/**
    * @license
    * Copyright 2021 Google LLC. All Rights Reserved.
    * Licensed under the Apache License, Version 2.0 (the "License");
    * you may not use this file except in compliance with the License.
    * You may obtain a copy of the License at
    *
    * http://www.apache.org/licenses/LICENSE-2.0
    *
    * Unless required by applicable law or agreed to in writing, software
    * distributed under the License is distributed on an "AS IS" BASIS,
    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    * See the License for the specific language governing permissions and
    * limitations under the License.
    * =============================================================================
    */
import{promisify as t}from"util";import e from"buffer";import"fs";function n(t){throw new Error(`'${t}' not yet implemented or not found in the registry. This kernel may not be supported by the tfjs backend you have chosen`)}function s(t){let e=t.length,n=0,s=0;for(;e>0;)s=Math.random()*e|0,e--,n=t[e],t[e]=t[s],t[s]=n}function r(t,e){if(!t)throw new Error("string"==typeof e?e:e())}function i(t,e,n=""){r(u(t,e),()=>n+` Shapes ${t} and ${e} must match`)}function a(t){r(null!=t,()=>"The input to the tensor constructor must be a non-null value.")}function o(t,e=[],n=!1){if(null==e&&(e=[]),Array.isArray(t)||d(t)&&!n)for(let s=0;s<t.length;++s)o(t[s],e,n);else e.push(t);return e}function l(t){if(0===t.length)return 1;let e=t[0];for(let n=1;n<t.length;n++)e*=t[n];return e}function u(t,e){if(t===e)return!0;if(null==t||null==e)return!1;if(t.length!==e.length)return!1;for(let n=0;n<t.length;n++)if(t[n]!==e[n])return!1;return!0}function h(t){return t%1==0}function c(t,e){return e<=t.length?t:t+" ".repeat(e-t.length)}function p(t,e){const n=e.length;return r((t=null==t?e.map((t,e)=>e):[].concat(t)).every(t=>t>=-n&&t<n),()=>`All values in axis param must be in range [-${n}, ${n}) but got axis `+t),r(t.every(t=>h(t)),()=>"All values in axis param must be integers but got axis "+t),t.map(t=>t<0?n+t:t)}function d(t){return t instanceof Float32Array||t instanceof Int32Array||t instanceof Uint8Array}function f(t){return"string"==typeof t||t instanceof String}function m(t){return"number"==typeof t}function g(t){return Array.isArray(t)?g(t[0]):t instanceof Float32Array?"float32":t instanceof Int32Array||t instanceof Uint8Array?"int32":m(t)?"float32":f(t)?"string":"boolean"==typeof t?"bool":"float32"}function y(t){return!!(t&&t.constructor&&t.call&&t.apply)}function b(t){const e=t.length;if(e<2)return[];const n=new Array(e-1);n[e-2]=t[e-1];for(let s=e-3;s>=0;--s)n[s]=n[s+1]*t[s+1];return n}function w(t,e){if(0===t.length)return e[0];const n=t.reduce((t,e)=>t*e);if(0===n)return[];if(n!==e.length)throw new Error(`[${t}] does not match the input size ${e.length}.`);return function t(e,n,s){const r=new Array;if(1===n.length){const t=n[0];for(let n=0;n<t;n++)r[n]=s[e+n]}else{const i=n[0],a=n.slice(1),o=a.reduce((t,e)=>t*e);for(let n=0;n<i;n++)r[n]=t(e+n*o,a,s)}return r}(0,t,e)}function v(t,e){const n=k(t,e);for(let t=0;t<n.length;t++)n[t]=1;return n}function k(t,e){if(null==e||"float32"===e||"complex64"===e)return new Float32Array(t);if("int32"===e)return new Int32Array(t);if("bool"===e)return new Uint8Array(t);throw new Error("Unknown data type "+e)}function x(t){t.forEach(e=>{r(Number.isInteger(e)&&e>=0,()=>`Tensor must have a shape comprised of positive integers but got shape [${t}].`)})}function S(t){return t&&t.then&&"function"==typeof t.then}class I{constructor(t){this.global=t,this.flags={},this.flagRegistry={},this.urlFlags={},this.populateURLFlags()}setPlatform(t,e){null!=this.platform&&console.warn(`Platform ${this.platformName} has already been set. Overwriting the platform with ${e}.`),this.platformName=t,this.platform=e}registerFlag(t,e,n){if(this.flagRegistry[t]={evaluationFn:e,setHook:n},null!=this.urlFlags[t]){const e=this.urlFlags[t];console.warn(`Setting feature override from URL ${t}: ${e}.`),this.set(t,e)}}async getAsync(t){return t in this.flags||(this.flags[t]=await this.evaluateFlag(t)),this.flags[t]}get(t){if(t in this.flags)return this.flags[t];const e=this.evaluateFlag(t);if(S(e))throw new Error(`Flag ${t} cannot be synchronously evaluated. Please use getAsync() instead.`);return this.flags[t]=e,this.flags[t]}getNumber(t){return this.get(t)}getBool(t){return this.get(t)}getFlags(){return this.flags}get features(){return this.flags}set(t,e){if(null==this.flagRegistry[t])throw new Error(`Cannot set flag ${t} as it has not been registered.`);this.flags[t]=e,null!=this.flagRegistry[t].setHook&&this.flagRegistry[t].setHook(e)}evaluateFlag(t){if(null==this.flagRegistry[t])throw new Error(`Cannot evaluate flag '${t}': no evaluation function found.`);return this.flagRegistry[t].evaluationFn()}setFlags(t){this.flags=Object.assign({},t)}reset(){this.flags={},this.urlFlags={},this.populateURLFlags()}populateURLFlags(){if(void 0===this.global||void 0===this.global.location||void 0===this.global.location.search)return;const t=function(t){const e={};return t.replace(/[?&]([^=?&]+)(?:=([^&]*))?/g,(t,...n)=>(function(t,e,n){t[decodeURIComponent(e)]=decodeURIComponent(n||"")}(e,n[0],n[1]),n.join("="))),e}(this.global.location.search);if("tfjsflags"in t){t.tfjsflags.split(",").forEach(t=>{const[e,n]=t.split(":");this.urlFlags[e]=function(t,e){if("true"===(e=e.toLowerCase())||"false"===e)return"true"===e;if(""+ +e===e)return+e;throw new Error(`Could not parse value flag value ${e} for flag ${t}.`)}(e,n)})}}}function N(){return A}let E,A=null;function T(){if(null==E){let t;if("undefined"!=typeof window)t=window;else if("undefined"!=typeof global)t=global;else if("undefined"!=typeof process)t=process;else{if("undefined"==typeof self)throw new Error("Could not find a global object");t=self}E=t}return E}function D(t,e){const n=function(){const t=T();return null==t._tfGlobals&&(t._tfGlobals=new Map),t._tfGlobals}();if(n.has(t))return n.get(t);{const s=e();return n.set(t,s),n.get(t)}}const z=D("kernelRegistry",()=>new Map),C=D("gradRegistry",()=>new Map);function F(t,e){const n=function(t,e){return`${e}_${t}`}(t,e);return z.get(n)}function R(t){return C.get(t)}function L(t){const e=z.entries(),n=[];for(;;){const{done:s,value:r}=e.next();if(s)break;const[i,a]=r,[o]=i.split("_");o===t&&n.push(a)}return n}function M(t){const{kernelName:e}=t;C.has(e)&&N().getBool("DEBUG")&&console.warn(`Overriding the gradient for '${e}'`),C.set(e,t)}function _(t,e){if("string"===e)throw new Error("Cannot convert a string[] to a TypedArray");if(Array.isArray(t)&&(t=o(t)),N().getBool("DEBUG")&&function(t,e){for(let n=0;n<t.length;n++){const s=t[n];if(isNaN(s)||!isFinite(s))throw Error(`A tensor of type ${e} being uploaded contains ${s}.`)}}(t,e),function(t,e){return t instanceof Float32Array&&"float32"===e||t instanceof Int32Array&&"int32"===e||t instanceof Uint8Array&&"bool"===e}(t,e))return t;if(null==e||"float32"===e||"complex64"===e)return new Float32Array(t);if("int32"===e)return new Int32Array(t);if("bool"===e){const e=new Uint8Array(t.length);for(let n=0;n<e.length;++n)0!==Math.round(t[n])&&(e[n]=1);return e}throw new Error("Unknown data type "+e)}function $(){return N().platform.now()}function O(t,e="utf-8"){return e=e||"utf-8",N().platform.decode(t,e)}class B{constructor(t,e){this.backendTimer=t,this.logger=e,null==e&&(this.logger=new U)}profileKernel(t,e,n){let s;const r=this.backendTimer.time(()=>{s=n()});if(N().getBool("CHECK_COMPUTATION_FOR_ERRORS"))for(let e=0;e<s.length;e++){const n=s[e];n.data().then(e=>{P(e,n.dtype,t)})}return{kernelName:t,outputs:s,inputs:e,timeMs:r.then(t=>t.kernelMs),extraInfo:r.then(t=>null!=t.getExtraProfileInfo?t.getExtraProfileInfo():"")}}logKernelProfile(t){const{kernelName:e,outputs:n,timeMs:s,inputs:r,extraInfo:i}=t;n.forEach(t=>{Promise.all([t.data(),s,i]).then(n=>{this.logger.logKernelProfile(e,t,n[0],n[1],r,n[2])})})}}function P(t,e,n){if("float32"!==e)return!1;for(let e=0;e<t.length;e++){const s=t[e];if(isNaN(s)||!isFinite(s))return console.warn(`Found ${s} in the result of '${n}'`),!0}return!1}class U{logKernelProfile(t,e,n,s,r,i){const a="number"==typeof s?c(s+"ms",9):s.error,o=c(t,25),l=e.rank,u=e.size,h=c(e.shape.toString(),14);let p="";for(const t in r){const n=r[t];if(null!=n){const s=n.shape||e.shape,r=s.length;p+=`${t}: ${r}D ${r>0?s:""} `}}console.log(`%c${o}\t%c${a}\t%c${l}D ${h}\t%c${u}\t%c${p}\t%c${i}`,"font-weight:bold","color:red","color:blue","color: orange","color: green","color: steelblue")}}function W(t,e,n,s){const r=b(e),i=function(t,e,n,s){const r=l(e),i=s[s.length-1],a=new Array(i).fill(0),o=e.length,u="complex64"===n?K(t):t;if(o>1)for(let t=0;t<r/i;t++){const e=t*i;for(let t=0;t<i;t++)a[t]=Math.max(a[t],j(u[e+t],0,n).length)}return a}(t,e,n,r),a=e.length,o=function t(e,n,s,r,i,a=!0){const o="complex64"===s?2:1,l=n[0],u=n.length;if(0===u){if("complex64"===s){return[j(K(e)[0],0,s)]}return"bool"===s?[q(e[0])]:[e[0].toString()]}if(1===u){if(l>20){const t=3*o;let n=Array.from(e.slice(0,t)),r=Array.from(e.slice((l-3)*o,l*o));return"complex64"===s&&(n=K(n),r=K(r)),["["+n.map((t,e)=>j(t,i[e],s)).join(", ")+", ..., "+r.map((t,e)=>j(t,i[l-3+e],s)).join(", ")+"]"]}return["["+("complex64"===s?K(e):Array.from(e)).map((t,e)=>j(t,i[e],s)).join(", ")+"]"]}const h=n.slice(1),c=r.slice(1),p=r[0]*o,d=[];if(l>20){for(let n=0;n<3;n++){const r=n*p,a=r+p;d.push(...t(e.slice(r,a),h,s,c,i,!1))}d.push("...");for(let n=l-3;n<l;n++){const r=n*p,a=r+p;d.push(...t(e.slice(r,a),h,s,c,i,n===l-1))}}else for(let n=0;n<l;n++){const r=n*p,a=r+p;d.push(...t(e.slice(r,a),h,s,c,i,n===l-1))}const f=2===u?",":"";d[0]="["+d[0]+f;for(let t=1;t<d.length-1;t++)d[t]=" "+d[t]+f;let m=",\n";for(let t=2;t<u;t++)m+="\n";return d[d.length-1]=" "+d[d.length-1]+"]"+(a?"":m),d}(t,e,n,r,i),u=["Tensor"];return s&&(u.push("  dtype: "+n),u.push("  rank: "+a),u.push(`  shape: [${e}]`),u.push("  values:")),u.push(o.map(t=>"    "+t).join("\n")),u.join("\n")}function j(t,e,n){let s;return s=Array.isArray(t)?parseFloat(t[0].toFixed(7))+" + "+parseFloat(t[1].toFixed(7))+"j":f(t)?`'${t}'`:"bool"===n?q(t):parseFloat(t.toFixed(7)).toString(),c(s,e)}function q(t){return 0===t?"false":"true"}function K(t){const e=[];for(let n=0;n<t.length;n+=2)e.push([t[n],t[n+1]]);return e}class V{constructor(t,e,n){if(this.dtype=e,this.shape=t.slice(),this.size=l(t),null!=n){const t=n.length;r(t===this.size,()=>`Length of values '${t}' does not match the size inferred by the shape '${this.size}'.`)}if("complex64"===e)throw new Error("complex64 dtype TensorBuffers are not supported. Please create a TensorBuffer for the real and imaginary parts separately and call tf.complex(real, imag).");this.values=n||function(t,e){let n=null;if(null==t||"float32"===t)n=new Float32Array(e);else if("int32"===t)n=new Int32Array(e);else if("bool"===t)n=new Uint8Array(e);else{if("string"!==t)throw new Error("Unknown data type "+t);n=new Array(e)}return n}(e,this.size),this.strides=b(t)}set(t,...e){0===e.length&&(e=[0]),r(e.length===this.rank,()=>`The number of provided coordinates (${e.length}) must match the rank (${this.rank})`);const n=this.locToIndex(e);this.values[n]=t}get(...t){0===t.length&&(t=[0]);let e=0;for(const n of t){if(n<0||n>=this.shape[e]){const e=`Requested out of range element at ${t}.   Buffer shape=`+this.shape;throw new Error(e)}e++}let n=t[t.length-1];for(let e=0;e<t.length-1;++e)n+=this.strides[e]*t[e];return this.values[n]}locToIndex(t){if(0===this.rank)return 0;if(1===this.rank)return t[0];let e=t[t.length-1];for(let n=0;n<t.length-1;++n)e+=this.strides[n]*t[n];return e}indexToLoc(t){if(0===this.rank)return[];if(1===this.rank)return[t];const e=new Array(this.shape.length);for(let n=0;n<e.length-1;++n)e[n]=Math.floor(t/this.strides[n]),t-=e[n]*this.strides[n];return e[e.length-1]=t,e}get rank(){return this.shape.length}toTensor(){return H().makeTensor(this.values,this.shape,this.dtype)}}let H=null,G=null;class J{constructor(t,e,n,s){this.kept=!1,this.isDisposedInternal=!1,this.shape=t.slice(),this.dtype=e||"float32",this.size=l(t),this.strides=b(t),this.dataId=n,this.id=s,this.rankType=this.rank<5?this.rank.toString():"higher"}get rank(){return this.shape.length}async buffer(){const t=await this.data();return G.buffer(this.shape,this.dtype,t)}bufferSync(){return G.buffer(this.shape,this.dtype,this.dataSync())}async array(){const t=await this.data();return w(this.shape,t)}arraySync(){return w(this.shape,this.dataSync())}async data(){this.throwIfDisposed();const t=H().read(this.dataId);if("string"===this.dtype){const e=await t;try{return e.map(t=>O(t))}catch(t){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}}return t}dataSync(){this.throwIfDisposed();const t=H().readSync(this.dataId);if("string"===this.dtype)try{return t.map(t=>O(t))}catch(t){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}return t}async bytes(){this.throwIfDisposed();const t=await H().read(this.dataId);return"string"===this.dtype?t:new Uint8Array(t.buffer)}dispose(){this.isDisposed||(H().disposeTensor(this),this.isDisposedInternal=!0)}get isDisposed(){return this.isDisposedInternal}throwIfDisposed(){if(this.isDisposed)throw new Error("Tensor is disposed.")}print(t=!1){return G.print(this,t)}clone(){return this.throwIfDisposed(),G.clone(this)}toString(t=!1){return W(this.dataSync(),this.shape,this.dtype,t)}cast(t){return this.throwIfDisposed(),G.cast(this,t)}variable(t=!0,e,n){return this.throwIfDisposed(),H().makeVariable(this,t,e,n)}}function Z(){return D("Tensor",()=>J)}Object.defineProperty(J,Symbol.hasInstance,{value:t=>!!t&&null!=t.data&&null!=t.dataSync&&null!=t.throwIfDisposed}),Z();class X extends J{constructor(t,e,n,s){super(t.shape,t.dtype,t.dataId,s),this.trainable=e,this.name=n}assign(t){if(t.dtype!==this.dtype)throw new Error(`dtype of the new value (${t.dtype}) and previous value (${this.dtype}) must match`);if(!u(t.shape,this.shape))throw new Error(`shape of the new value (${t.shape}) and previous value (${this.shape}) must match`);H().disposeTensor(this),this.dataId=t.dataId,H().incRef(this,null)}dispose(){H().disposeVariable(this),this.isDisposedInternal=!0}}var Y,Q,tt,et,nt;Object.defineProperty(X,Symbol.hasInstance,{value:t=>t instanceof J&&null!=t.assign&&t.assign instanceof Function}),function(t){t.R0="R0",t.R1="R1",t.R2="R2",t.R3="R3",t.R4="R4",t.R5="R5",t.R6="R6"}(Y||(Y={})),function(t){t.float32="float32",t.int32="int32",t.bool="int32",t.complex64="complex64"}(Q||(Q={})),function(t){t.float32="float32",t.int32="int32",t.bool="bool",t.complex64="complex64"}(tt||(tt={})),function(t){t.float32="float32",t.int32="float32",t.bool="float32",t.complex64="complex64"}(et||(et={})),function(t){t.float32="complex64",t.int32="complex64",t.bool="complex64",t.complex64="complex64"}(nt||(nt={}));const st={float32:et,int32:Q,bool:tt,complex64:nt};function rt(t,e){if(t.dtype===e.dtype)return[t,e];const n=function(t,e){if("string"===t||"string"===e){if("string"===t&&"string"===e)return"string";throw new Error(`Can not upcast ${t} with ${e}`)}return st[t][e]}(t.dtype,e.dtype);return[t.cast(n),e.cast(n)]}function it(t,e){return e.some(e=>e.id===t.id)}function at(t){const e=[];return function t(e,n,s){if(null==e)return;if(e instanceof J)return void n.push(e);if(r=e,!Array.isArray(r)&&"object"!=typeof r)return;var r;const i=e;for(const e in i){const r=i[e];s.has(r)||(s.add(r),t(r,n,s))}}(t,e,new Set),e}function ot(t){return null!=t.kernelName}class lt{constructor(){this.registeredVariables={},this.nextTapeNodeId=0,this.numBytes=0,this.numTensors=0,this.numStringTensors=0,this.numDataBuffers=0,this.gradientDepth=0,this.kernelDepth=0,this.scopeStack=[],this.numDataMovesStack=[],this.nextScopeId=0,this.tensorInfo=new WeakMap,this.profiling=!1,this.activeProfile={newBytes:0,newTensors:0,peakBytes:0,kernels:[],result:null,get kernelNames(){return Array.from(new Set(this.kernels.map(t=>t.name)))}}}dispose(){for(const t in this.registeredVariables)this.registeredVariables[t].dispose()}}class ut{constructor(t){this.ENV=t,this.registry={},this.registryFactory={},this.pendingBackendInitId=0,this.state=new lt}async ready(){if(null!=this.pendingBackendInit)return this.pendingBackendInit.then(()=>{});if(null!=this.backendInstance)return;const t=this.getSortedBackends();for(let e=0;e<t.length;e++){const n=t[e];if(await this.initializeBackend(n).success)return void await this.setBackend(n)}throw new Error("Could not initialize any backends, all backend initializations failed.")}get backend(){if(null!=this.pendingBackendInit)throw new Error(`Backend '${this.backendName}' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods`);if(null==this.backendInstance){const{name:t,asyncInit:e}=this.initializeBackendsAndReturnBest();if(e)throw new Error(`The highest priority backend '${t}' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods`);this.setBackend(t)}return this.backendInstance}backendNames(){return Object.keys(this.registryFactory)}findBackend(t){if(!(t in this.registry)){if(!(t in this.registryFactory))return null;{const{asyncInit:e}=this.initializeBackend(t);if(e)return null}}return this.registry[t]}findBackendFactory(t){return t in this.registryFactory?this.registryFactory[t].factory:null}registerBackend(t,e,n=1){return t in this.registryFactory?(console.warn(t+" backend was already registered. Reusing existing backend factory."),!1):(this.registryFactory[t]={factory:e,priority:n},!0)}async setBackend(t){if(null==this.registryFactory[t])throw new Error(`Backend name '${t}' not found in registry`);if(this.backendName=t,null==this.registry[t]){this.backendInstance=null;const{success:e,asyncInit:n}=this.initializeBackend(t);if(!(n?await e:e))return!1}return this.backendInstance=this.registry[t],this.setupRegisteredKernels(),this.profiler=new B(this.backendInstance),!0}setupRegisteredKernels(){L(this.backendName).forEach(t=>{null!=t.setupFunc&&t.setupFunc(this.backendInstance)})}disposeRegisteredKernels(t){L(t).forEach(e=>{null!=e.disposeFunc&&e.disposeFunc(this.registry[t])})}initializeBackend(t){const e=this.registryFactory[t];if(null==e)throw new Error(`Cannot initialize backend ${t}, no registration found.`);try{const s=e.factory();if(!s||s instanceof class{decComplexRef(t){}time(t){return n("time")}read(t){return n("read")}readSync(t){return n("readSync")}numDataIds(){return n("numDataIds")}disposeData(t){return n("disposeData")}write(t,e,s){return n("write")}move(t,e,s,r){return n("move")}memory(){return n("memory")}floatPrecision(){return n("floatPrecision")}epsilon(){return 32===this.floatPrecision()?1e-7:1e-4}dispose(){return n("dispose")}}||"function"!=typeof s.then)return this.registry[t]=s,{success:!0,asyncInit:!1};{const e=++this.pendingBackendInitId,n=s.then(n=>!(e<this.pendingBackendInitId)&&(this.registry[t]=n,this.pendingBackendInit=null,!0)).catch(n=>(e<this.pendingBackendInitId||(this.pendingBackendInit=null,console.warn(`Initialization of backend ${t} failed`),console.warn(n.stack||n.message)),!1));return this.pendingBackendInit=n,{success:n,asyncInit:!0}}}catch(e){return console.warn(`Initialization of backend ${t} failed`),console.warn(e.stack||e.message),{success:!1,asyncInit:!1}}}removeBackend(t){if(!(t in this.registryFactory))throw new Error(t+" backend not found in registry");this.backendName===t&&null!=this.pendingBackendInit&&this.pendingBackendInitId++,t in this.registry&&(this.disposeRegisteredKernels(t),this.registry[t].dispose(),delete this.registry[t]),delete this.registryFactory[t],this.backendName===t&&(this.pendingBackendInit=null,this.backendName=null,this.backendInstance=null)}getSortedBackends(){if(0===Object.keys(this.registryFactory).length)throw new Error("No backend found in registry.");return Object.keys(this.registryFactory).sort((t,e)=>this.registryFactory[e].priority-this.registryFactory[t].priority)}initializeBackendsAndReturnBest(){const t=this.getSortedBackends();for(let e=0;e<t.length;e++){const n=t[e],{success:s,asyncInit:r}=this.initializeBackend(n);if(r||s)return{name:n,asyncInit:r}}throw new Error("Could not initialize any backends, all backend initializations failed.")}moveData(t,e){const n=this.state.tensorInfo.get(e),s=n.backend,r=this.readSync(e);s.disposeData(e),n.backend=t,t.move(e,r,n.shape,n.dtype),this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack[this.state.numDataMovesStack.length-1]++}tidy(t,e){let n,s=null;if(null==e){if("function"!=typeof t)throw new Error("Please provide a function to tidy()");e=t}else{if("string"!=typeof t&&!(t instanceof String))throw new Error("When calling with two arguments, the first argument to tidy() must be a string");if("function"!=typeof e)throw new Error("When calling with two arguments, the 2nd argument to tidy() must be a function");s=t}return this.scopedRun(()=>this.startScope(s),()=>this.endScope(n),()=>(n=e(),n instanceof Promise&&console.error("Cannot return a Promise inside of tidy."),n))}scopedRun(t,e,n){t();try{const t=n();return e(),t}catch(t){throw e(),t}}nextTensorId(){return ut.nextTensorId++}nextVariableId(){return ut.nextVariableId++}clone(t){const e=this.makeTensorFromDataId(t.dataId,t.shape,t.dtype),n={x:t};return this.addTapeNode(this.state.activeScope.name,n,[e],t=>({x:()=>{const e={x:t},n={dtype:"float32"};return ct.runKernel("Cast",e,n)}}),[],{}),e}runKernel(t,e,n){if(!(null!=F(t,this.backendName)))throw new Error(`Kernel '${t}' not registered for backend '${this.backendName}'`);return this.runKernelFunc({kernelName:t,inputs:e,attrs:n})}shouldCheckForMemLeaks(){return this.ENV.getBool("IS_TEST")}checkKernelForMemLeak(t,e,n){const s=this.backend.numDataIds();let r=0;n.forEach(t=>{r+="complex64"===t.dtype?3:1});const i=this.state.numDataMovesStack[this.state.numDataMovesStack.length-1],a=s-e-r-i;if(a>0)throw new Error(`Backend '${this.backendName}' has an internal memory leak (${a} data ids) after running '${t}'`)}runKernelFunc(t){let e,n=[];const s=this.isTapeOn(),i=this.state.numBytes,a=this.state.numTensors;let o,l;this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack.push(0),null==this.backendName&&this.backend;const u=ot(t)?t.kernelName:null!=this.state.activeScope?this.state.activeScope.name:"";if(ot(t)){const{kernelName:e,inputs:i,attrs:a}=t;null==this.backendName&&this.backend;const u=F(e,this.backendName);r(null!=u,()=>`Cannot find registered kernel '${e}' for backend '${this.backendName}'`),o=()=>{const t=this.backend.numDataIds();l=u.kernelFunc({inputs:i,attrs:a,backend:this.backend});const r=Array.isArray(l)?l:[l];this.shouldCheckForMemLeaks()&&this.checkKernelForMemLeak(e,t,r);const o=r.map(t=>{if(null!=t.rank)return t;const{dataId:e,shape:n,dtype:s}=t;return this.makeTensorFromDataId(e,n,s)});if(s){const t=this.getTensorsForGradient(e,i,o);n=this.saveTensorsForBackwardMode(t)}return o}}else{const{forwardFunc:e}=t,r=t=>{s&&(n=t.map(t=>this.keep(this.clone(t))))};o=()=>{const t=this.backend.numDataIds();l=this.tidy(()=>e(this.backend,r));const n=Array.isArray(l)?l:[l];return this.shouldCheckForMemLeaks()&&this.checkKernelForMemLeak(u,t,n),n}}const{inputs:h,attrs:c}=t,p=ot(t)?null:t.backwardsFunc;let d;return this.scopedRun(()=>this.state.kernelDepth++,()=>this.state.kernelDepth--,()=>{this.ENV.getBool("DEBUG")||this.state.profiling?(d=this.profiler.profileKernel(u,h,()=>o()),this.ENV.getBool("DEBUG")&&this.profiler.logKernelProfile(d),e=d.outputs):e=o()}),s&&this.addTapeNode(u,h,e,p,n,c),this.state.profiling&&this.state.activeProfile.kernels.push({name:u,bytesAdded:this.state.numBytes-i,totalBytesSnapshot:this.state.numBytes,tensorsAdded:this.state.numTensors-a,totalTensorsSnapshot:this.state.numTensors,inputShapes:Object.keys(h).map(t=>null!=h[t]?h[t].shape:null),outputShapes:e.map(t=>t.shape),kernelTimeMs:d.timeMs,extraInfo:d.extraInfo}),Array.isArray(l)?e:e[0]}saveTensorsForBackwardMode(t){return t.map(t=>this.keep(this.clone(t)))}getTensorsForGradient(t,e,n){const s=R(t);if(null!=s){const t=s.inputsToSave||[],i=s.outputsToSave||[];let a;s.saveAllInputs?(r(Array.isArray(e),()=>"saveAllInputs is true, expected inputs to be an array."),a=Object.keys(e).map(t=>e[t])):a=t.map(t=>e[t]);const o=n.filter((t,e)=>i[e]);return a.concat(o)}return[]}makeTensor(t,e,n,s){if(null==t)throw new Error("Values passed to engine.makeTensor() are null");n=n||"float32",s=s||this.backend;let r=t;"string"===n&&f(t[0])&&(r=t.map(t=>function(t,e="utf-8"){return e=e||"utf-8",N().platform.encode(t,e)}(t)));const i=s.write(r,e,n),a=new J(e,n,i,this.nextTensorId());if(this.incRef(a,s),"string"===n){const t=this.state.tensorInfo.get(i),e=function(t){if(null==t)return 0;let e=0;return t.forEach(t=>e+=t.length),e}(r);this.state.numBytes+=e-t.bytes,t.bytes=e}return a}makeTensorFromDataId(t,e,n,s){const r=new J(e,n=n||"float32",t,this.nextTensorId());return this.incRef(r,s),r}makeVariable(t,e=!0,n,s){n=n||this.nextVariableId().toString(),null!=s&&s!==t.dtype&&(t=t.cast(s));const r=new X(t,e,n,this.nextTensorId());if(null!=this.state.registeredVariables[r.name])throw new Error(`Variable with name ${r.name} was already registered`);return this.state.registeredVariables[r.name]=r,this.incRef(r,this.backend),r}incRef(t,e){const n=this.state.tensorInfo.has(t.dataId)?this.state.tensorInfo.get(t.dataId).refCount:0;if(this.state.numTensors++,"string"===t.dtype&&this.state.numStringTensors++,0===n){this.state.numDataBuffers++;let n=0;"complex64"!==t.dtype&&"string"!==t.dtype&&(n=t.size*function(t){if("float32"===t||"int32"===t)return 4;if("complex64"===t)return 8;if("bool"===t)return 1;throw new Error("Unknown dtype "+t)}(t.dtype)),this.state.tensorInfo.set(t.dataId,{backend:e||this.backend,dtype:t.dtype,shape:t.shape,bytes:n,refCount:0}),this.state.numBytes+=n}this.state.tensorInfo.get(t.dataId).refCount++,t instanceof X||this.track(t)}disposeTensor(t){if(!this.state.tensorInfo.has(t.dataId))return;this.state.numTensors--,"string"===t.dtype&&this.state.numStringTensors--;const e=this.state.tensorInfo.get(t.dataId);e.refCount<=1?("complex64"!==t.dtype&&(this.state.numBytes-=e.bytes),this.state.numDataBuffers--,e.backend.disposeData(t.dataId),this.state.tensorInfo.delete(t.dataId)):(e.backend.decComplexRef(t.dataId),this.state.tensorInfo.get(t.dataId).refCount--)}disposeVariables(){for(const t in this.state.registeredVariables){const e=this.state.registeredVariables[t];this.disposeVariable(e)}}disposeVariable(t){this.disposeTensor(t),null!=this.state.registeredVariables[t.name]&&delete this.state.registeredVariables[t.name]}memory(){const t=this.backend.memory();return t.numTensors=this.state.numTensors,t.numDataBuffers=this.state.numDataBuffers,t.numBytes=this.state.numBytes,this.state.numStringTensors>0&&(t.unreliable=!0,null==t.reasons&&(t.reasons=[]),t.reasons.push("Memory usage by string tensors is approximate (2 bytes per character)")),t}async profile(t){this.state.profiling=!0;const e=this.state.numBytes,n=this.state.numTensors;this.state.activeProfile.kernels=[],this.state.activeProfile.result=await t(),this.state.profiling=!1,this.state.activeProfile.peakBytes=Math.max(...this.state.activeProfile.kernels.map(t=>t.totalBytesSnapshot)),this.state.activeProfile.newBytes=this.state.numBytes-e,this.state.activeProfile.newTensors=this.state.numTensors-n;for(const t of this.state.activeProfile.kernels)t.kernelTimeMs=await t.kernelTimeMs,t.extraInfo=await t.extraInfo;return this.state.activeProfile}isTapeOn(){return this.state.gradientDepth>0&&0===this.state.kernelDepth}addTapeNode(t,e,n,s,r,i){const a={id:this.state.nextTapeNodeId++,kernelName:t,inputs:e,outputs:n,saved:r},o=R(t);null!=o&&(s=o.gradFunc),null!=s&&(a.gradient=t=>(t=t.map((t,e)=>{if(null==t){const t=n[e],s=k(t.size,t.dtype);return this.makeTensor(s,t.shape,t.dtype)}return t}),s(t.length>1?t:t[0],r,i))),this.state.activeTape.push(a)}keep(t){return t.kept=!0,t}startTape(){0===this.state.gradientDepth&&(this.state.activeTape=[]),this.state.gradientDepth++}endTape(){this.state.gradientDepth--}startScope(t){const e={track:[],name:"unnamed scope",id:this.state.nextScopeId++};t&&(e.name=t),this.state.scopeStack.push(e),this.state.activeScope=e}endScope(t){const e=at(t),n=new Set(e.map(t=>t.id));for(let t=0;t<this.state.activeScope.track.length;t++){const e=this.state.activeScope.track[t];e.kept||n.has(e.id)||e.dispose()}const s=this.state.scopeStack.pop();this.state.activeScope=0===this.state.scopeStack.length?null:this.state.scopeStack[this.state.scopeStack.length-1],e.forEach(t=>{t.kept||t.scopeId!==s.id||this.track(t)})}gradients(t,e,n,s=!1){if(r(e.length>0,()=>"gradients() received an empty list of xs."),null!=n&&"float32"!==n.dtype)throw new Error(`dy must have 'float32' dtype, but has '${n.dtype}'`);const i=this.scopedRun(()=>this.startTape(),()=>this.endTape(),()=>this.tidy("forward",t));r(i instanceof J,()=>"The result y returned by f() must be a tensor.");const a=function(t,e,n){const s={},r={};for(let t=0;t<e.length;t++)s[e[t].id]=!0;for(let n=0;n<t.length;n++){const i=t[n],a=i.inputs;for(const t in a){const n=a[t];let o=!1;for(let t=0;t<e.length;t++)if(s[n.id]){i.outputs.forEach(t=>s[t.id]=!0),o=!0,r[i.id]=!0;break}if(o)break}}const i={};i[n.id]=!0;const a={};for(let e=t.length-1;e>=0;e--){const n=t[e],s=n.inputs;for(let t=0;t<n.outputs.length;t++)if(i[n.outputs[t].id]){for(const t in s)i[s[t].id]=!0,a[n.id]=!0;break}}const o=[];for(let e=0;e<t.length;e++){const n=t[e];if(r[n.id]&&a[n.id]){const t={};for(const e in n.inputs){const r=n.inputs[e];s[r.id]&&(t[e]=r)}const e=Object.assign({},n);e.inputs=t,e.outputs=n.outputs,o.push(e)}}return o}(this.state.activeTape,e,i);if(!s&&0===a.length&&e.length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that the f you passed encloses all operations that lead from x to y.");return this.tidy("backward",()=>{const t={};t[i.id]=null==n?function(t){const e=v(l(t),"float32");return ct.makeTensor(e,t,"float32")}(i.shape):n,function(t,e,n,s){for(let r=e.length-1;r>=0;r--){const i=e[r],a=[];if(i.outputs.forEach(e=>{const n=t[e.id];null!=n?a.push(n):a.push(null)}),null==i.gradient)throw new Error(`Cannot compute gradient: gradient function not found for ${i.kernelName}.`);const o=i.gradient(a);for(const e in i.inputs){if(!(e in o))throw new Error(`Cannot backprop through input ${e}. Available gradients found: ${Object.keys(o)}.`);const r=n(()=>o[e]());if("float32"!==r.dtype)throw new Error(`Error in gradient for op ${i.kernelName}. The gradient of input ${e} must have 'float32' dtype, but has '${r.dtype}'`);const a=i.inputs[e];if(!u(r.shape,a.shape))throw new Error(`Error in gradient for op ${i.kernelName}. The gradient of input '${e}' has shape '${r.shape}', which does not match the shape of the input '${a.shape}'`);if(null==t[a.id])t[a.id]=r;else{const e=t[a.id];t[a.id]=s(e,r),e.dispose()}}}}(t,a,t=>this.tidy(t),pt);const s=e.map(e=>t[e.id]);return 0===this.state.gradientDepth&&(this.state.activeTape.forEach(t=>{for(const e of t.saved)e.dispose()}),this.state.activeTape=null),{value:i,grads:s}})}customGrad(t){return r(y(t),()=>"The f passed in customGrad(f) must be a function."),(...e)=>{let n;r(e.every(t=>t instanceof J),()=>"The args passed in customGrad(f)(x1, x2,...) must all be tensors");const s={};e.forEach((t,e)=>{s[e]=t});return this.runKernelFunc({forwardFunc:(s,i)=>(n=t(...e,i),r(n.value instanceof J,()=>"The function f passed in customGrad(f) must return an object where `obj.value` is a tensor"),r(y(n.gradFunc),()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function."),n.value),backwardsFunc:(t,s)=>{const i=n.gradFunc(t,s),a=Array.isArray(i)?i:[i];r(a.length===e.length,()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns the same number of tensors as inputs passed to f(...)."),r(a.every(t=>t instanceof J),()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns a list of only tensors.");const o={};return a.forEach((t,e)=>{o[e]=()=>t}),o},inputs:s})}}readSync(t){return this.state.tensorInfo.get(t).backend.readSync(t)}read(t){return this.state.tensorInfo.get(t).backend.read(t)}async time(t){const e=$(),n=await this.backend.time(t);return n.wallMs=$()-e,n}track(t){return null!=this.state.activeScope&&(t.scopeId=this.state.activeScope.id,this.state.activeScope.track.push(t)),t}get registeredVariables(){return this.state.registeredVariables}reset(){this.pendingBackendInitId++,this.state.dispose(),this.ENV.reset(),this.state=new lt;for(const t in this.registry)this.disposeRegisteredKernels(t),this.registry[t].dispose(),delete this.registry[t];this.backendName=null,this.backendInstance=null,this.pendingBackendInit=null}}function ht(){const t=T();if(null==t._tfengine){const e=new I(t);t._tfengine=new ut(e)}var e;return e=t._tfengine.ENV,A=e,H=()=>t._tfengine,t._tfengine}ut.nextTensorId=0,ut.nextVariableId=0;const ct=ht();function pt(t,e){const n={a:t,b:e};return ct.runKernel("Add",n)}const dt=N();function ft(t,e){let n=t;if(d(t))return"string"===e?[]:[t.length];if(!Array.isArray(t))return[];const s=[];for(;Array.isArray(n)||d(n)&&"string"!==e;)s.push(n.length),n=n[0];return Array.isArray(t)&&N().getBool("TENSORLIKE_CHECK_SHAPE_CONSISTENCY")&&function t(e,n,s){if(s=s||[],!Array.isArray(e)&&!d(e))return void r(0===n.length,()=>`Element arr[${s.join("][")}] is a primitive, but should be an array/TypedArray of ${n[0]} elements`);r(n.length>0,()=>`Element arr[${s.join("][")}] should be a primitive, but is an array of ${e.length} elements`),r(e.length===n[0],()=>`Element arr[${s.join("][")}] should have ${n[0]} elements, but has ${e.length} elements`);const i=n.slice(1);for(let n=0;n<e.length;++n)t(e[n],i,s.concat(n))}(t,s,[]),s}function mt(t,e,n,s){if("string_or_numeric"!==t){if(null==t)throw new Error("Expected dtype cannot be null.");if("numeric"!==t&&t!==e||"numeric"===t&&"string"===e)throw new Error(`Argument '${n}' passed to '${s}' must be ${t} tensor, but got ${e} tensor`)}}function gt(t,e,n,s="numeric"){if(t instanceof J)return mt(s,t.dtype,e,n),t;let r=g(t);if("string"!==r&&["bool","int32","float32"].indexOf(s)>=0&&(r=s),mt(s,r,e,n),null==t||!d(t)&&!Array.isArray(t)&&"number"!=typeof t&&"boolean"!=typeof t&&"string"!=typeof t){const s=null==t?"null":t.constructor.name;throw new Error(`Argument '${e}' passed to '${n}' must be a Tensor or TensorLike, but got '${s}'`)}const i=ft(t,r);d(t)||Array.isArray(t)||(t=[t]);const a="string"!==r?_(t,r):o(t,[],!0);return ct.makeTensor(a,i,r)}function yt(t,e,n,s="numeric"){if(!Array.isArray(t))throw new Error(`Argument ${e} passed to ${n} must be a \`Tensor[]\` or \`TensorLike[]\``);return t.map((t,r)=>gt(t,`${e}[${r}]`,n,s))}dt.registerFlag("DEBUG",()=>!1,t=>{t&&console.warn("Debugging mode is ON. The output of every math call will be downloaded to CPU and checked for NaNs. This significantly impacts performance.")}),dt.registerFlag("IS_BROWSER",()=>"undefined"!=typeof window&&null!=window.document||"undefined"!=typeof WorkerGlobalScope),dt.registerFlag("IS_NODE",()=>"undefined"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.node),dt.registerFlag("IS_CHROME",()=>"undefined"!=typeof navigator&&null!=navigator&&null!=navigator.userAgent&&/Chrome/.test(navigator.userAgent)&&/Google Inc/.test(navigator.vendor)),dt.registerFlag("PROD",()=>!1),dt.registerFlag("TENSORLIKE_CHECK_SHAPE_CONSISTENCY",()=>dt.getBool("DEBUG")),dt.registerFlag("DEPRECATION_WARNINGS_ENABLED",()=>!0),dt.registerFlag("IS_TEST",()=>!1),dt.registerFlag("CHECK_COMPUTATION_FOR_ERRORS",()=>!0);function bt(t){const e=Object.keys(t);if(1!==e.length)throw new Error("Please provide an object with a single key (operation name) mapping to a function. Got an object with "+e.length+" keys.");let n=e[0];const s=t[n];n.endsWith("_")&&(n=n.substring(0,n.length-1)),n+="__op";const r=(...t)=>{ct.startScope(n);try{const e=s(...t);return S(e)&&console.error("Cannot return a Promise inside of tidy."),ct.endScope(e),e}catch(t){throw ct.endScope(null),t}};return Object.defineProperty(r,"name",{value:n,configurable:!0}),r}const wt=bt({complex_:function(t,e){const n=gt(t,"real","complex"),s=gt(e,"imag","complex");i(n.shape,s.shape,`real and imag shapes, ${n.shape} and ${s.shape}, must match in call to tf.complex().`);const r={real:n,imag:s};return ct.runKernel("Complex",r)}});function vt(t,e,n,s){if(null==s&&(s=g(t)),"complex64"===s)throw new Error("Cannot construct a complex64 tensor directly. Please use tf.complex(real, imag).");if(!d(t)&&!Array.isArray(t)&&"number"!=typeof t&&"boolean"!=typeof t&&"string"!=typeof t)throw new Error("values passed to tensor(values) must be a number/boolean/string or an array of numbers/booleans/strings, or a TypedArray");if(null!=e){x(e);const t=l(e),s=l(n);r(t===s,()=>`Based on the provided shape, [${e}], the tensor should have ${t} values but has ${s}`);for(let t=0;t<n.length;++t){const s=n[t],i=t!==n.length-1||s!==l(e.slice(t));r(n[t]===e[t]||!i,()=>`Error creating a new Tensor. Inferred shape (${n}) does not match the provided shape (${e}). `)}}return d(t)||Array.isArray(t)||(t=[t]),e=e||n,t="string"!==s?_(t,s):o(t,[],!0),ct.makeTensor(t,e,s)}function kt(t,e,n){return vt(t,e,ft(t,n),n)}const xt={float32:4,float16:2,int32:4,uint16:2,uint8:1,bool:1,complex64:8};async function St(t,e){const n=[],s=[],r=Array.isArray(t)?t.map(t=>t.name):Object.keys(t);for(let i=0;i<r.length;++i){const a=r[i],o=Array.isArray(t)?t[i].tensor:t[a];if("float32"!==o.dtype&&"int32"!==o.dtype&&"bool"!==o.dtype&&"string"!==o.dtype&&"complex64"!==o.dtype)throw new Error(`Unsupported dtype in weight '${a}': ${o.dtype}`);const l={name:a,shape:o.shape,dtype:o.dtype};if("string"===o.dtype){const t=new Promise(async t=>{const e=await o.bytes(),n=e.reduce((t,e)=>t+e.length,0)+4*e.length,s=new Uint8Array(n);let r=0;for(let t=0;t<e.length;t++){const n=e[t],i=new Uint8Array(new Uint32Array([n.length]).buffer);s.set(i,r),r+=4,s.set(n,r),r+=n.length}t(s)});s.push(t)}else s.push(o.data());null!=e&&(l.group=e),n.push(l)}return{data:It(await Promise.all(s)),specs:n}}function It(t){if(null===t)throw new Error("Invalid input value: "+JSON.stringify(t));let e=0;const n=[];t.forEach(t=>{if(e+=t.byteLength,n.push(t.byteLength===t.buffer.byteLength?t:new t.constructor(t)),!(t instanceof Float32Array||t instanceof Int32Array||t instanceof Uint8Array))throw new Error("Unsupported TypedArray subtype: "+t.constructor.name)});const s=new Uint8Array(e);let r=0;return n.forEach(t=>{s.set(new Uint8Array(t.buffer),r),r+=t.byteLength}),s.buffer}const Nt="undefined"!=typeof Buffer&&("undefined"==typeof Blob||"undefined"==typeof atob||"undefined"==typeof btoa);function Et(t){return Nt?Buffer.byteLength(t):new Blob([t]).size}function At(t){if(1===t.length)return t[0];let e=0;t.forEach(t=>{e+=t.byteLength});const n=new Uint8Array(e);let s=0;return t.forEach(t=>{n.set(new Uint8Array(t),s),s+=t.byteLength}),n.buffer}function Tt(t){if(t.modelTopology instanceof ArrayBuffer)throw new Error("Expected JSON model topology, received ArrayBuffer.");return{dateSaved:new Date,modelTopologyType:"JSON",modelTopologyBytes:null==t.modelTopology?0:Et(JSON.stringify(t.modelTopology)),weightSpecsBytes:null==t.weightSpecs?0:Et(JSON.stringify(t.weightSpecs)),weightDataBytes:null==t.weightData?0:t.weightData.byteLength}}function Dt(){const t=function(){const t=t=>{let e=t<<13,n=0;for(;0==(8388608&e);)n-=8388608,e<<=1;return e&=-8388609,n+=947912704,e|n},e=new Uint32Array(2048);e[0]=0;for(let n=1;n<1024;n++)e[n]=t(n);for(let t=1024;t<2048;t++)e[t]=939524096+(t-1024<<13);return e}(),e=function(){const t=new Uint32Array(64);t[0]=0,t[31]=1199570944,t[32]=2147483648,t[63]=3347054592;for(let e=1;e<31;e++)t[e]=e<<23;for(let e=33;e<63;e++)t[e]=2147483648+(e-32<<23);return t}(),n=function(){const t=new Uint32Array(64);for(let e=0;e<64;e++)t[e]=1024;return t[0]=t[32]=0,t}();return s=>{const r=new ArrayBuffer(4*s.length),i=new Uint32Array(r);for(let r=0;r<s.length;r++){const a=s[r],o=t[n[a>>10]+(1023&a)]+e[a>>10];i[r]=o}return new Float32Array(r)}}class zt{constructor(){this.saveRouters=[],this.loadRouters=[]}static getInstance(){return null==zt.instance&&(zt.instance=new zt),zt.instance}static registerSaveRouter(t){zt.getInstance().saveRouters.push(t)}static registerLoadRouter(t){zt.getInstance().loadRouters.push(t)}static getSaveHandlers(t){return zt.getHandlers(t,"save")}static getLoadHandlers(t,e){return zt.getHandlers(t,"load",e)}static getHandlers(t,e,n){const s=[];return("load"===e?zt.getInstance().loadRouters:zt.getInstance().saveRouters).forEach(e=>{const r=e(t,n);null!==r&&s.push(r)}),s}}function Ct(){if(!N().getBool("IS_BROWSER"))throw new Error("Failed to obtain IndexedDB factory because the current environmentis not a web browser.");const t="undefined"==typeof window?self:window,e=t.indexedDB||t.mozIndexedDB||t.webkitIndexedDB||t.msIndexedDB||t.shimIndexedDB;if(null==e)throw new Error("The current browser does not appear to support IndexedDB.");return e}function Ft(t){const e=t.result;e.createObjectStore("models_store",{keyPath:"modelPath"}),e.createObjectStore("model_info_store",{keyPath:"modelPath"})}class Rt{constructor(t){if(this.indexedDB=Ct(),null==t||!t)throw new Error("For IndexedDB, modelPath must not be null, undefined or empty.");this.modelPath=t}async save(t){if(t.modelTopology instanceof ArrayBuffer)throw new Error("BrowserLocalStorage.save() does not support saving model topology in binary formats yet.");return this.databaseAction(this.modelPath,t)}async load(){return this.databaseAction(this.modelPath)}databaseAction(t,e){return new Promise((t,n)=>{const s=this.indexedDB.open("tensorflowjs",1);s.onupgradeneeded=()=>Ft(s),s.onsuccess=()=>{const r=s.result;if(null==e){const e=r.transaction("models_store","readonly"),s=e.objectStore("models_store").get(this.modelPath);s.onsuccess=()=>{if(null==s.result)return r.close(),n(new Error(`Cannot find model with path '${this.modelPath}' in IndexedDB.`));t(s.result.modelArtifacts)},s.onerror=t=>(r.close(),n(s.error)),e.oncomplete=()=>r.close()}else{const s=Tt(e),i=r.transaction("model_info_store","readwrite");let a=i.objectStore("model_info_store");const o=a.put({modelPath:this.modelPath,modelArtifactsInfo:s});let l;o.onsuccess=()=>{l=r.transaction("models_store","readwrite");const o=l.objectStore("models_store").put({modelPath:this.modelPath,modelArtifacts:e,modelArtifactsInfo:s});o.onsuccess=()=>t({modelArtifactsInfo:s}),o.onerror=t=>{a=i.objectStore("model_info_store");const e=a.delete(this.modelPath);e.onsuccess=()=>(r.close(),n(o.error)),e.onerror=t=>(r.close(),n(o.error))}},o.onerror=t=>(r.close(),n(o.error)),i.oncomplete=()=>{null==l?r.close():l.oncomplete=()=>r.close()}}},s.onerror=t=>n(s.error)})}}Rt.URL_SCHEME="indexeddb://";const Lt=t=>{return N().getBool("IS_BROWSER")&&!Array.isArray(t)&&t.startsWith(Rt.URL_SCHEME)?(e=t.slice(Rt.URL_SCHEME.length),new Rt(e)):null;var e};zt.registerSaveRouter(Lt),zt.registerLoadRouter(Lt);class Mt{constructor(){this.indexedDB=Ct()}async listModels(){return new Promise((t,e)=>{const n=this.indexedDB.open("tensorflowjs",1);n.onupgradeneeded=()=>Ft(n),n.onsuccess=()=>{const s=n.result,r=s.transaction("model_info_store","readonly"),i=r.objectStore("model_info_store").getAll();i.onsuccess=()=>{const e={};for(const t of i.result)e[t.modelPath]=t.modelArtifactsInfo;t(e)},i.onerror=t=>(s.close(),e(i.error)),r.oncomplete=()=>s.close()},n.onerror=t=>e(n.error)})}async removeModel(t){var e;return t=(e=t).startsWith(Rt.URL_SCHEME)?e.slice(Rt.URL_SCHEME.length):e,new Promise((e,n)=>{const s=this.indexedDB.open("tensorflowjs",1);s.onupgradeneeded=()=>Ft(s),s.onsuccess=()=>{const r=s.result,i=r.transaction("model_info_store","readwrite"),a=i.objectStore("model_info_store"),o=a.get(t);let l;o.onsuccess=()=>{if(null==o.result)return r.close(),n(new Error(`Cannot find model with path '${t}' in IndexedDB.`));{const s=a.delete(t),i=()=>{l=r.transaction("models_store","readwrite");const s=l.objectStore("models_store").delete(t);s.onsuccess=()=>e(o.result.modelArtifactsInfo),s.onerror=t=>n(o.error)};s.onsuccess=i,s.onerror=t=>(i(),r.close(),n(o.error))}},o.onerror=t=>(r.close(),n(o.error)),i.oncomplete=()=>{null==l?r.close():l.oncomplete=()=>r.close()}},s.onerror=t=>n(s.error)})}}const _t="tensorflowjs_models",$t="info",Ot="model_topology",Bt="weight_specs",Pt="weight_data",Ut="model_metadata";function Wt(t){return{info:[_t,t,$t].join("/"),topology:[_t,t,Ot].join("/"),weightSpecs:[_t,t,Bt].join("/"),weightData:[_t,t,Pt].join("/"),modelMetadata:[_t,t,Ut].join("/")}}function jt(t){const e=t.split("/");if(e.length<3)throw new Error("Invalid key format: "+t);return e.slice(1,e.length-1).join("/")}class qt{constructor(t){if(!N().getBool("IS_BROWSER")||"undefined"==typeof window||void 0===window.localStorage)throw new Error("The current environment does not support local storage.");if(this.LS=window.localStorage,null==t||!t)throw new Error("For local storage, modelPath must not be null, undefined or empty.");this.modelPath=t,this.keys=Wt(this.modelPath)}async save(t){if(t.modelTopology instanceof ArrayBuffer)throw new Error("BrowserLocalStorage.save() does not support saving model topology in binary formats yet.");{const e=JSON.stringify(t.modelTopology),n=JSON.stringify(t.weightSpecs),s=Tt(t);try{this.LS.setItem(this.keys.info,JSON.stringify(s)),this.LS.setItem(this.keys.topology,e),this.LS.setItem(this.keys.weightSpecs,n),this.LS.setItem(this.keys.weightData,function(t){if(Nt)return Buffer.from(t).toString("base64");const e=new Uint8Array(t);let n="";for(let t=0,s=e.length;t<s;t++)n+=String.fromCharCode(e[t]);return btoa(n)}(t.weightData));const r={format:t.format,generatedBy:t.generatedBy,convertedBy:t.convertedBy};return null!=t.signature&&(r.signature=t.signature),null!=t.userDefinedMetadata&&(r.userDefinedMetadata=t.userDefinedMetadata),null!=t.modelInitializer&&(r.modelInitializer=t.modelInitializer),this.LS.setItem(this.keys.modelMetadata,JSON.stringify(r)),{modelArtifactsInfo:s}}catch(t){throw this.LS.removeItem(this.keys.info),this.LS.removeItem(this.keys.topology),this.LS.removeItem(this.keys.weightSpecs),this.LS.removeItem(this.keys.weightData),this.LS.removeItem(this.keys.modelMetadata),new Error(`Failed to save model '${this.modelPath}' to local storage: size quota being exceeded is a possible cause of this failure: modelTopologyBytes=${s.modelTopologyBytes}, weightSpecsBytes=${s.weightSpecsBytes}, weightDataBytes=${s.weightDataBytes}.`)}}}async load(){const t=JSON.parse(this.LS.getItem(this.keys.info));if(null==t)throw new Error(`In local storage, there is no model with name '${this.modelPath}'`);if("JSON"!==t.modelTopologyType)throw new Error("BrowserLocalStorage does not support loading non-JSON model topology yet.");const e={},n=JSON.parse(this.LS.getItem(this.keys.topology));if(null==n)throw new Error(`In local storage, the topology of model '${this.modelPath}' is missing.`);e.modelTopology=n;const s=JSON.parse(this.LS.getItem(this.keys.weightSpecs));if(null==s)throw new Error(`In local storage, the weight specs of model '${this.modelPath}' are missing.`);e.weightSpecs=s;const r=this.LS.getItem(this.keys.modelMetadata);if(null!=r){const t=JSON.parse(r);e.format=t.format,e.generatedBy=t.generatedBy,e.convertedBy=t.convertedBy,null!=t.signature&&(e.signature=t.signature),null!=t.userDefinedMetadata&&(e.userDefinedMetadata=t.userDefinedMetadata),null!=t.modelInitializer&&(e.modelInitializer=t.modelInitializer)}const i=this.LS.getItem(this.keys.weightData);if(null==i)throw new Error(`In local storage, the binary weight values of model '${this.modelPath}' are missing.`);return e.weightData=function(t){if(Nt){const e=Buffer.from(t,"base64");return e.buffer.slice(e.byteOffset,e.byteOffset+e.byteLength)}const e=atob(t),n=new Uint8Array(e.length);for(let t=0;t<e.length;++t)n.set([e.charCodeAt(t)],t);return n.buffer}(i),e}}qt.URL_SCHEME="localstorage://";const Kt=t=>{return N().getBool("IS_BROWSER")&&!Array.isArray(t)&&t.startsWith(qt.URL_SCHEME)?(e=t.slice(qt.URL_SCHEME.length),new qt(e)):null;var e};zt.registerSaveRouter(Kt),zt.registerLoadRouter(Kt);class Vt{constructor(){r(N().getBool("IS_BROWSER"),()=>"Current environment is not a web browser"),r("undefined"==typeof window||void 0!==window.localStorage,()=>"Current browser does not appear to support localStorage"),this.LS=window.localStorage}async listModels(){const t={},e=_t+"/",n="/"+$t;for(let s=0;s<this.LS.length;++s){const r=this.LS.key(s);if(r.startsWith(e)&&r.endsWith(n)){t[jt(r)]=JSON.parse(this.LS.getItem(r))}}return t}async removeModel(t){var e;const n=Wt(t=(e=t).startsWith(qt.URL_SCHEME)?e.slice(qt.URL_SCHEME.length):e);if(null==this.LS.getItem(n.info))throw new Error(`Cannot find model at path '${t}'`);const s=JSON.parse(this.LS.getItem(n.info));return this.LS.removeItem(n.info),this.LS.removeItem(n.topology),this.LS.removeItem(n.weightSpecs),this.LS.removeItem(n.weightData),s}}class Ht{constructor(){this.managers={}}static getInstance(){return null==Ht.instance&&(Ht.instance=new Ht),Ht.instance}static registerManager(t,e){r(null!=t,()=>"scheme must not be undefined or null."),t.endsWith("://")&&(t=t.slice(0,t.indexOf("://"))),r(t.length>0,()=>"scheme must not be an empty string.");const n=Ht.getInstance();r(null==n.managers[t],()=>`A model store manager is already registered for scheme '${t}'.`),n.managers[t]=e}static getManager(t){const e=this.getInstance().managers[t];if(null==e)throw new Error(`Cannot find model manager for scheme '${t}'`);return e}static getSchemes(){return Object.keys(this.getInstance().managers)}}async function Gt(){const t=Ht.getSchemes(),e={};for(const n of t){const t=await Ht.getManager(n).listModels();for(const s in t){e[n+"://"+s]=t[s]}}return e}async function Jt(t){const e=function(t){if(-1===t.indexOf("://"))throw new Error("The url string provided does not contain a scheme. Supported schemes are: "+Ht.getSchemes().join(","));return{scheme:t.split("://")[0],path:t.split("://")[1]}}(t);return Ht.getManager(e.scheme).removeModel(e.path)}class Zt{fetch(t,e){return fetch(t,e)}now(){return performance.now()}encode(t,e){if("utf-8"!==e&&"utf8"!==e)throw new Error("Browser's encoder only supports utf-8, but got "+e);return null==this.textEncoder&&(this.textEncoder=new TextEncoder),this.textEncoder.encode(t)}decode(t,e){return new TextDecoder(e).decode(t)}}if(N().get("IS_BROWSER")){N().setPlatform("browser",new Zt);try{Ht.registerManager(qt.URL_SCHEME,new Vt)}catch(t){}try{Ht.registerManager(Rt.URL_SCHEME,new Mt)}catch(t){}}const Xt=()=>require("node-fetch");let Yt;class Qt{constructor(){this.util=require("util"),this.textEncoder=new this.util.TextEncoder}fetch(t,e){return null!=N().global.fetch?N().global.fetch(t,e):(null==Yt&&(Yt=Xt()),Yt(t,e))}now(){const t=process.hrtime();return 1e3*t[0]+t[1]/1e6}encode(t,e){if("utf-8"!==e&&"utf8"!==e)throw new Error("Node built-in encoder only supports utf-8, but got "+e);return this.textEncoder.encode(t)}decode(t,e){return 0===t.length?"":new this.util.TextDecoder(e).decode(t)}}function te(t,e="float32",n){return e=e||"float32",x(t),new V(t,e,n)}N().get("IS_NODE")&&N().setPlatform("node",new Qt);const ee=bt({cast_:function(t,e){const n=gt(t,"x","cast");if(!function(t){return"bool"===t||"complex64"===t||"float32"===t||"int32"===t||"string"===t}(e))throw new Error("Failed to cast to unknown dtype "+e);if("string"===e&&"string"!==n.dtype||"string"!==e&&"string"===n.dtype)throw new Error("Only strings can be casted to strings");const s={x:n},r={dtype:e};return ct.runKernel("Cast",s,r)}});const ne=bt({clone_:function(t){const e={x:gt(t,"x","clone","string_or_numeric")};return ct.runKernel("Identity",e)}});ht();function se(t,e,n,s){!function(t){r(null!=t&&Array.isArray(t)&&t.length>0,()=>"promises must be a none empty array")}(t),function(t,e){r(t>=0&&t<=1,()=>"Progress fraction must be in range [0, 1], but got startFraction "+t),r(e>=0&&e<=1,()=>"Progress fraction must be in range [0, 1], but got endFraction "+e),r(e>=t,()=>`startFraction must be no more than endFraction, but got startFraction ${t} and endFraction `+e)}(n=null==n?0:n,s=null==s?1:s);let i=0;return Promise.all(t.map(r=>(r.then(r=>{const a=n+ ++i/t.length*(s-n);return e(a),r}),r)))}G={buffer:te,cast:ee,clone:ne,print:function(t,e=!1){console.log(t.toString(e))}};class re{constructor(t,e){if(this.DEFAULT_METHOD="POST",null==e&&(e={}),this.weightPathPrefix=e.weightPathPrefix,this.onProgress=e.onProgress,this.weightUrlConverter=e.weightUrlConverter,null!=e.fetchFunc?(r("function"==typeof e.fetchFunc,()=>"Must pass a function that matches the signature of `fetch` (see https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API)"),this.fetch=e.fetchFunc):this.fetch=N().platform.fetch,r(null!=t&&t.length>0,()=>"URL path for http must not be null, undefined or empty."),Array.isArray(t)&&r(2===t.length,()=>`URL paths for http must have a length of 2, (actual length is ${t.length}).`),this.path=t,null!=e.requestInit&&null!=e.requestInit.body)throw new Error("requestInit is expected to have no pre-existing body, but has one.");this.requestInit=e.requestInit||{}}async save(t){if(t.modelTopology instanceof ArrayBuffer)throw new Error("BrowserHTTPRequest.save() does not support saving model topology in binary formats yet.");const e=Object.assign({method:this.DEFAULT_METHOD},this.requestInit);e.body=new FormData;const n=[{paths:["./model.weights.bin"],weights:t.weightSpecs}],s={modelTopology:t.modelTopology,format:t.format,generatedBy:t.generatedBy,convertedBy:t.convertedBy,weightsManifest:n};null!=t.signature&&(s.signature=t.signature),null!=t.userDefinedMetadata&&(s.userDefinedMetadata=t.userDefinedMetadata),null!=t.modelInitializer&&(s.modelInitializer=t.modelInitializer),e.body.append("model.json",new Blob([JSON.stringify(s)],{type:"application/json"}),"model.json"),null!=t.weightData&&e.body.append("model.weights.bin",new Blob([t.weightData],{type:"application/octet-stream"}),"model.weights.bin");const r=await this.fetch(this.path,e);if(r.ok)return{modelArtifactsInfo:Tt(t),responses:[r]};throw new Error("BrowserHTTPRequest.save() failed due to HTTP response status "+r.status+".")}async load(){const t=await this.fetch(this.path,this.requestInit);if(!t.ok)throw new Error(`Request to ${this.path} failed with status code `+t.status+". Please verify this URL points to the model JSON of the model to load.");let e;try{e=await t.json()}catch(t){let e=`Failed to parse model JSON of response from ${this.path}.`;throw this.path.endsWith(".pb")?e+=" Your path contains a .pb file extension. Support for .pb models have been removed in TensorFlow.js 1.0 in favor of .json models. You can re-convert your Python TensorFlow model using the TensorFlow.js 1.0 conversion scripts or you can convert your.pb models with the 'pb2json'NPM script in the tensorflow/tfjs-converter repository.":e+=" Please make sure the server is serving valid JSON for this request.",new Error(e)}const n=e.modelTopology,s=e.weightsManifest,r=e.generatedBy,i=e.convertedBy,a=e.format,o=e.signature,l=e.userDefinedMetadata;if(null==n&&null==s)throw new Error(`The JSON from HTTP path ${this.path} contains neither model topology or manifest for weights.`);let u,h;if(null!=s){const t=await this.loadWeights(s);[u,h]=t}const c={modelTopology:n,weightSpecs:u,weightData:h,generatedBy:r,convertedBy:i,format:a};null!=o&&(c.signature=o),null!=l&&(c.userDefinedMetadata=l);const p=e.modelInitializer;return p&&(c.modelInitializer=p),c}async loadWeights(t){const e=Array.isArray(this.path)?this.path[1]:this.path,[n,s]=function(t){const e=t.lastIndexOf("/"),n=t.lastIndexOf("?"),s=t.substring(0,e),r=n>e?t.substring(n):"";return[s+"/",r]}(e),r=this.weightPathPrefix||n,i=[];for(const e of t)i.push(...e.weights);const a=[],o=[];for(const e of t)for(const t of e.paths)null!=this.weightUrlConverter?o.push(this.weightUrlConverter(t)):a.push(r+t+s);this.weightUrlConverter&&a.push(...await Promise.all(o));return[i,At(await async function(t,e){null==e&&(e={});const n=null==e.fetchFunc?N().platform.fetch:e.fetchFunc,s=t.map(t=>n(t,e.requestInit,{isBinary:!0})),r=(null==e.onProgress?await Promise.all(s):await se(s,e.onProgress,0,.5)).map(t=>t.arrayBuffer());return null==e.onProgress?await Promise.all(r):await se(r,e.onProgress,.5,1)}(a,{requestInit:this.requestInit,fetchFunc:this.fetch,onProgress:this.onProgress}))]}}function ie(t){return null!=t.match(re.URL_SCHEME_REGEX)}re.URL_SCHEME_REGEX=/^https?:\/\//;const ae=(t,e)=>{if("undefined"==typeof fetch&&(null==e||null==e.fetchFunc))return null;{let n=!0;if(n=Array.isArray(t)?t.every(t=>ie(t)):ie(t),n)return oe(t,e)}return null};function oe(t,e){return new re(t,e)}zt.registerSaveRouter(ae),zt.registerLoadRouter(ae);class le{constructor(t){this.modelArtifacts=t}async load(){return this.modelArtifacts}}function ue(t,e,n,s){if(1===arguments.length){return null!=t.modelTopology||null!=t.weightSpecs?new le(t):(console.warn("Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release."),new le({modelTopology:t}))}return console.warn("Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release."),new le({modelTopology:t,weightSpecs:e,weightData:n,trainingConfig:s})}const he=bt({matMul_:function(t,e,n=!1,s=!1){let r=gt(t,"a","matMul"),i=gt(e,"b","matMul");[r,i]=rt(r,i);const a={a:r,b:i},o={transposeA:n,transposeB:s};return ct.runKernel("BatchMatMul",a,o)}});const ce=bt({oneHot_:function(t,e,n=1,s=0){if(e<2)throw new Error("Error in oneHot: depth must be >=2, but it is "+e);const r={indices:gt(t,"indices","oneHot","int32")},i={depth:e,onValue:n,offValue:s};return ct.runKernel("OneHot",r,i)}});const pe=bt({transpose_:function(t,e){const n=gt(t,"x","transpose");if(null==e&&(e=n.shape.map((t,e)=>e).reverse()),r(n.rank===e.length,()=>`Error in transpose: rank of input ${n.rank} must match length of perm ${e}.`),e.forEach(t=>{r(t>=0&&t<n.rank,()=>"All entries in 'perm' must be between 0 and "+(n.rank-1)+" but got "+e)}),n.rank<=1)return n.clone();const s={x:n},i={perm:e};return ct.runKernel("Transpose",s,i)}});function de(t,e,n){if(a(t),null!=e&&3!==e.length)throw new Error("tensor3d() requires shape to have three numbers");const s=ft(t,n);if(3!==s.length&&1!==s.length)throw new Error("tensor3d() requires values to be number[][][] or flat/TypedArray");if(1===s.length&&null==e)throw new Error("tensor3d() requires shape to be provided when `values` are a flat array");return vt(t,e,s,n)}class fe{getClassName(){return this.constructor.className}static fromConfig(t,e){return new t(e)}}class me{constructor(){this.classNameMap={}}static getMap(){return null==me.instance&&(me.instance=new me),me.instance}static register(t){me.getMap().classNameMap[t.className]=[t,t.fromConfig]}}function ge(t){r(null!=t.className,()=>"Class being registered does not have the static className property defined."),r("string"==typeof t.className,()=>"className is required to be a string, but got type "+typeof t.className),r(t.className.length>0,()=>"Class being registered has an empty-string as its className, which is disallowed."),me.register(t)}function ye(){return ct.memory()}function be(t,e){return ct.tidy(t,e)}function we(t){at(t).forEach(t=>t.dispose())}function ve(t){return ct.keep(t)}function ke(){return ct.backend}const xe=bt({add_:function(t,e){let n=gt(t,"a","add"),s=gt(e,"b","add");[n,s]=rt(n,s);const r={a:n,b:s};return ct.runKernel("Add",r)}});const Se=bt({floorDiv_:function(t,e){let n=gt(t,"a","floorDiv"),s=gt(e,"b","floorDiv");[n,s]=rt(n,s);const r={a:n,b:s};return ct.runKernel("FloorDiv",r)}});const Ie=bt({div_:function(t,e){let n=gt(t,"a","div"),s=gt(e,"b","div");if([n,s]=rt(n,s),"int32"===n.dtype&&"int32"===s.dtype)return Se(n,s);const r={a:n,b:s};return ct.runKernel("RealDiv",r,{})}});const Ne=bt({mul_:function(t,e){let n=gt(t,"a","mul"),s=gt(e,"b","mul");[n,s]=rt(n,s);const r={a:n,b:s};return ct.runKernel("Multiply",r)}});const Ee=bt({abs_:function(t){const e=gt(t,"x","abs");if("complex64"===e.dtype){const t={x:e};return ct.runKernel("ComplexAbs",t)}{const t={x:e};return ct.runKernel("Abs",t)}}});const Ae=bt({acos_:function(t){const e={x:gt(t,"x","acos")};return ct.runKernel("Acos",e)}});const Te=bt({acosh_:function(t){const e={x:gt(t,"x","acosh")};return ct.runKernel("Acosh",e)}});const De=bt({all_:function(t,e=null,n=!1){const s={x:gt(t,"x","all","bool")},r={axis:e,keepDims:n};return ct.runKernel("All",s,r)}});const ze=bt({any_:function(t,e=null,n=!1){const s={x:gt(t,"x","any","bool")},r={axis:e,keepDims:n};return ct.runKernel("Any",s,r)}});const Ce=bt({argMax_:function(t,e=0){const n={x:gt(t,"x","argMax")},s={axis:e};return ct.runKernel("ArgMax",n,s)}});const Fe=bt({argMin_:function(t,e=0){const n={x:gt(t,"x","argMin")},s={axis:e};return ct.runKernel("ArgMin",n,s)}});const Re=bt({asin_:function(t){const e={x:gt(t,"x","asin")};return ct.runKernel("Asin",e)}});const Le=bt({asinh_:function(t){const e={x:gt(t,"x","asinh")};return ct.runKernel("Asinh",e)}});const Me=bt({atan_:function(t){const e={x:gt(t,"x","atan")};return ct.runKernel("Atan",e)}});const _e=bt({atan2_:function(t,e){let n=gt(t,"a","atan2"),s=gt(e,"b","atan2");[n,s]=rt(n,s);const r={a:n,b:s};return ct.runKernel("Atan2",r)}});const $e=bt({atanh_:function(t){const e={x:gt(t,"x","atanh")};return ct.runKernel("Atanh",e)}});function Oe(t,e,n,s,r,i,a=!1,o="channelsLast"){let[l,u,h,c]=[-1,-1,-1,-1];if("channelsLast"===o)[l,u,h,c]=t;else{if("channelsFirst"!==o)throw new Error("Unknown dataFormat "+o);[l,c,u,h]=t}const[p,d,,f]=e,[m,g]=Be(n),[y,b]=Be(s),w=Pe(p,y),v=Pe(d,b),{padInfo:k,outHeight:x,outWidth:S}=function(t,e,n,s,r,i,a,o,l){let u,h,c;if("number"==typeof t){u={top:t,bottom:t,left:t,right:t,type:0===t?"VALID":"NUMBER"};const r=function(t,e,n,s,r){null==s&&(s=function(t,e,n,s=1){const r=Pe(e,s);return Math.floor((t[0]*(n-1)-n+r)/2)}(t,e,n));const i=t[0],a=t[1],o=Ue((i-e+2*s)/n+1,r),l=Ue((a-e+2*s)/n+1,r);return[o,l]}([e,n],i,s,t,o);h=r[0],c=r[1]}else if("same"===t){h=Math.ceil(e/s),c=Math.ceil(n/r);const t=Math.max(0,(h-1)*s+i-e),o=Math.max(0,(c-1)*r+a-n),l=Math.floor(t/2),p=t-l,d=Math.floor(o/2);u={top:l,bottom:p,left:d,right:o-d,type:"SAME"}}else if("valid"===t)u={top:0,bottom:0,left:0,right:0,type:"VALID"},h=Math.ceil((e-i+1)/s),c=Math.ceil((n-a+1)/r);else{if("object"!=typeof t)throw Error("Unknown padding parameter: "+t);{const p="channelsLast"===l?t[1][0]:t[2][0],d="channelsLast"===l?t[1][1]:t[2][1],f="channelsLast"===l?t[2][0]:t[3][0],m="channelsLast"===l?t[2][1]:t[3][1];u={top:p,bottom:d,left:f,right:m,type:0===p&&0===d&&0===f&&0===m?"VALID":"EXPLICIT"},h=Ue((e-i+p+d)/s+1,o),c=Ue((n-a+f+m)/r+1,o)}}return{padInfo:u,outHeight:h,outWidth:c}}(r,u,h,m,g,w,v,i,o),I=a?f*c:f;let N;return"channelsFirst"===o?N=[l,I,x,S]:"channelsLast"===o&&(N=[l,x,S,I]),{batchSize:l,dataFormat:o,inHeight:u,inWidth:h,inChannels:c,outHeight:x,outWidth:S,outChannels:I,padInfo:k,strideHeight:m,strideWidth:g,filterHeight:p,filterWidth:d,effectiveFilterHeight:w,effectiveFilterWidth:v,dilationHeight:y,dilationWidth:b,inShape:t,outShape:N,filterShape:e}}function Be(t){return"number"==typeof t?[t,t,t]:2===t.length?[t[0],t[1],1]:t}function Pe(t,e){return e<=1?t:t+(t-1)*(e-1)}function Ue(t,e){if(!e)return Math.trunc(t);switch(e){case"round":return Math.round(t);case"ceil":return Math.ceil(t);case"floor":return Math.floor(t);default:throw new Error("Unknown roundingMode "+e)}}function We(t){const[e,n,s]=Be(t);return 1===e&&1===n&&1===s}function je(t,e){return We(t)||We(e)}const qe=bt({reshape_:function(t,e){const n={x:gt(t,"x","reshape","string_or_numeric")},s={shape:e};return ct.runKernel("Reshape",n,s)}});const Ke=bt({avgPool_:function(t,e,n,s,i){const a=gt(t,"x","avgPool","float32");r(je(n,1),()=>`Error in avgPool: Either strides or dilations must be 1. Got strides ${n} and dilations '1'`);let o=a,l=!1;3===a.rank&&(l=!0,o=qe(a,[1,a.shape[0],a.shape[1],a.shape[2]])),r(4===o.rank,()=>`Error in avgPool: x must be rank 4 but got rank ${o.rank}.`),null!=i&&r(h(s),()=>`Error in avgPool: pad must be an integer when using, dimRoundingMode ${i} but got pad ${s}.`);const u={x:o},c={filterSize:e,strides:n,pad:s,dimRoundingMode:i};let p=ct.runKernel("AvgPool",u,c);return p=ee(p,a.dtype),l?qe(p,[p.shape[1],p.shape[2],p.shape[3]]):p}});const Ve=bt({avgPool3d_:function(t,e,n,s,i,a="NDHWC"){const o=gt(t,"x","avgPool3d","float32");let l=o,u=!1;4===o.rank&&(u=!0,l=qe(o,[1,o.shape[0],o.shape[1],o.shape[2],o.shape[3]])),r(5===l.rank,()=>`Error in avgPool3d: x must be rank 5 but got rank ${l.rank}.`),r("NDHWC"===a,()=>"Error in avgPool3d: Only NDHWC is currently supported, but got dataFormat of "+a),null!=i&&r(h(s),()=>`Error in avgPool3d: pad must be an integer when using, dimRoundingMode ${i} but got pad ${s}.`);const c={x:l},p={filterSize:e,strides:n,pad:s,dimRoundingMode:i,dataFormat:a};let d=ct.runKernel("AvgPool3D",c,p);return d=ee(d,l.dtype),u?qe(d,[d.shape[1],d.shape[2],d.shape[3],d.shape[4]]):d}});const He=bt({concat_:function(t,e=0){r(t.length>=1,()=>"Pass at least one tensor to concat");const n=yt(t,"tensors","concat","string_or_numeric");if("complex64"===n[0].dtype&&n.forEach(t=>{if("complex64"!==t.dtype)throw new Error(`Cannot concatenate complex64 tensors with a tensor\n          with dtype ${t.dtype}. `)}),1===n.length)return ne(n[0]);const s=n,i={axis:e};return ct.runKernel("Concat",s,i)}});const Ge=bt({sigmoid_:function(t){const e={x:gt(t,"x","sigmoid")};return ct.runKernel("Sigmoid",e)}});const Je=bt({slice_:function(t,e,n){const s=gt(t,"x","slice","string_or_numeric");if(0===s.rank)throw new Error("Slicing scalar is not possible");const r={x:s},i={begin:e,size:n};return ct.runKernel("Slice",r,i)}});const Ze=bt({tanh_:function(t){const e={x:gt(t,"x","tanh")};return ct.runKernel("Tanh",e)}});const Xe=bt({batchToSpaceND_:function(t,e,n){const s=gt(t,"x","batchToSpaceND"),i=e.reduce((t,e)=>t*e);r(s.rank>=1+e.length,()=>`input rank is ${s.rank} but should be > than blockShape.length ${e.length}`),r(n.length===e.length,()=>`crops.length is ${n.length} but should be equal to blockShape.length  ${e.length}`),r(s.shape[0]%i==0,()=>`input tensor batch is ${s.shape[0]} but is not divisible by the product of the elements of blockShape ${e.join(" * ")} === ${i}`);const a={x:s},o={blockShape:e,crops:n};return ct.runKernel("BatchToSpaceND",a,o)}});const Ye=bt({batchNorm_:function(t,e,n,s,i,a){null==a&&(a=.001);const o=gt(t,"x","batchNorm"),l=gt(e,"mean","batchNorm"),u=gt(n,"variance","batchNorm");let h,c;null!=i&&(h=gt(i,"scale","batchNorm")),null!=s&&(c=gt(s,"offset","batchNorm")),r(l.rank===u.rank,()=>"Batch normalization gradient requires mean and variance to have equal ranks."),r(null==c||l.rank===c.rank,()=>"Batch normalization gradient requires mean and offset to have equal ranks."),r(null==h||l.rank===h.rank,()=>"Batch normalization gradient requires mean and scale to have equal ranks.");const p={x:function(t){let e;return e=0===t.rank||1===t.rank?qe(t,[1,1,1,t.size]):2===t.rank?qe(t,[1,1,t.shape[0],t.shape[1]]):3===t.rank?qe(t,[1,t.shape[0],t.shape[1],t.shape[2]]):t,e}(o),scale:h,offset:c,mean:l,variance:u},d={varianceEpsilon:a},f=ct.runKernel("FusedBatchNorm",p,d);return qe(f,o.shape)}});const Qe=bt({batchNorm2d_:function(t,e,n,s,i,a){const o=gt(t,"x","batchNorm"),l=gt(e,"mean","batchNorm"),u=gt(n,"variance","batchNorm");let h,c;return null!=i&&(h=gt(i,"scale","batchNorm")),null!=s&&(c=gt(s,"offset","batchNorm")),r(2===o.rank,()=>"Error in batchNorm2D: x must be rank 2 but got rank "+o.rank+"."),r(2===l.rank||1===l.rank,()=>`Error in batchNorm2D: mean must be rank 2 or rank 1 but got rank ${l.rank}.`),r(2===u.rank||1===u.rank,()=>`Error in batchNorm2D: variance must be rank 2 or rank 1 but got rank ${u.rank}.`),null!=h&&r(2===h.rank||1===h.rank,()=>`Error in batchNorm2D: scale must be rank 2 or rank 1 but got rank ${h.rank}.`),null!=c&&r(2===c.rank||1===c.rank,()=>`Error in batchNorm2D: offset must be rank 2 or rank 1 but got rank ${c.rank}.`),Ye(o,l,u,c,h,a)}});const tn=bt({batchNorm3d_:function(t,e,n,s,i,a){const o=gt(t,"x","batchNorm"),l=gt(e,"mean","batchNorm"),u=gt(n,"variance","batchNorm");let h,c;return null!=i&&(h=gt(i,"scale","batchNorm")),null!=s&&(c=gt(s,"offset","batchNorm")),r(3===o.rank,()=>"Error in batchNorm3D: x must be rank 3 but got rank "+o.rank+"."),r(3===l.rank||1===l.rank,()=>`Error in batchNorm3D: mean must be rank 3 or rank 1 but got rank ${l.rank}.`),r(3===u.rank||1===u.rank,()=>`Error in batchNorm3D: variance must be rank 3 or rank 1 but got rank ${u.rank}.`),null!=h&&r(3===h.rank||1===h.rank,()=>`Error in batchNorm3D: scale must be rank 3 or rank 1 but got rank ${h.rank}.`),null!=c&&r(3===c.rank||1===c.rank,()=>`Error in batchNorm3D: offset must be rank 3 or rank 1 but got rank ${c.rank}.`),Ye(o,l,u,c,h,a)}});const en=bt({batchNorm4d_:function(t,e,n,s,i,a){const o=gt(t,"x","batchNorm"),l=gt(e,"mean","batchNorm"),u=gt(n,"variance","batchNorm");let h,c;return null!=i&&(h=gt(i,"scale","batchNorm")),null!=s&&(c=gt(s,"offset","batchNorm")),r(4===o.rank,()=>"Error in batchNorm4D: x must be rank 4 but got rank "+o.rank+"."),r(4===l.rank||1===l.rank,()=>`Error in batchNorm4D: mean must be rank 4 or rank 1 but got rank ${l.rank}.`),r(4===u.rank||1===u.rank,()=>`Error in batchNorm4D: variance must be rank 4 or rank 1 but got rank ${u.rank}.`),null!=h&&r(4===h.rank||1===h.rank,()=>`Error in batchNorm4D: scale must be rank 4 or rank 1 but got rank ${h.rank}.`),null!=c&&r(4===c.rank||1===c.rank,()=>`Error in batchNorm4D: offset must be rank 4 or rank 1 but got rank ${c.rank}.`),Ye(o,l,u,c,h,a)}});const nn=bt({broadcastTo_:function(t,e){let n=gt(t,"broadcastTo","x");const s=n.shape;if(e.some(t=>!(t>0)||t%1!=0))throw new Error(`broadcastTo(): Invalid broadcast shape [${e}].`);if(e.length<n.rank)throw new Error(`broadcastTo(): shape.length=${e.length} < input.rank=${n.rank}.`);if(e.length>n.rank){const t=n.shape.slice();for(;t.length<e.length;)t.unshift(1);n=qe(n,t)}const r=n.shape,i=Array.from(e);for(let t=e.length-1;t>=0;t--)if(r[t]===e[t])i[t]=1;else if(1!==n.shape[t])throw new Error(`broadcastTo(): [${s}] cannot be broadcast to [${e}].`);if(0===i.map((t,e)=>t>1?e:-1).filter(t=>t>=0).length)return ne(n);const a={x:n},o={reps:i};return ct.runKernel("Tile",a,o)}});const sn=bt({ceil_:function(t){const e={x:gt(t,"x","ceil")};return ct.runKernel("Ceil",e)}});const rn=bt({clipByValue_:function(t,e,n){const s=gt(t,"x","clipByValue");r(e<=n,()=>`Error in clip: min (${e}) must be less than or equal to max (${n}).`);const i={x:s},a={clipValueMin:e,clipValueMax:n};return ct.runKernel("ClipByValue",i,a)}});const an=bt({concat1d_:function(t){return He(t,0)}});const on=bt({concat2d_:function(t,e){return He(t,e)}});const ln=bt({concat3d_:function(t,e){return He(t,e)}});const un=bt({concat4d_:function(t,e){return He(t,e)}});const hn=bt({conv2d_:function(t,e,n,s,i="NHWC",a=[1,1],o){const l=gt(t,"x","conv2d"),u=gt(e,"filter","conv2d");let c=l,p=!1;3===l.rank&&(p=!0,c=qe(l,[1,l.shape[0],l.shape[1],l.shape[2]])),r(4===c.rank,()=>`Error in conv2d: input must be rank 4, but got rank ${c.rank}.`),r(4===u.rank,()=>"Error in conv2d: filter must be rank 4, but got rank "+u.rank+"."),null!=o&&r(h(s),()=>`Error in conv2d: pad must be an integer when using, dimRoundingMode ${o} but got pad ${s}.`);const d="NHWC"===i?c.shape[3]:c.shape[1];r(d===u.shape[2],()=>`Error in conv2d: depth of input (${d}) must match input depth for filter ${u.shape[2]}.`),r(je(n,a),()=>`Error in conv2D: Either strides or dilations must be 1. Got strides ${n} and dilations '${a}'`);const f={x:c,filter:u},m={strides:n,pad:s,dataFormat:i,dilations:a,dimRoundingMode:o},g=ct.runKernel("Conv2D",f,m);return p?qe(g,[g.shape[1],g.shape[2],g.shape[3]]):g}});const cn=bt({conv1d_:function(t,e,n,s,i="NWC",a=1,o){const l=gt(t,"x","conv1d"),u=gt(e,"filter","conv1d");let c=l,p=!1;2===l.rank&&(p=!0,c=qe(l,[1,l.shape[0],l.shape[1]])),r(3===c.rank,()=>`Error in conv1d: input must be rank 3, but got rank ${c.rank}.`),r(3===u.rank,()=>"Error in conv1d: filter must be rank 3, but got rank "+u.rank+"."),null!=o&&r(h(s),()=>`Error in conv1d: pad must be an integer when using, dimRoundingMode ${o} but got pad ${s}.`),r(c.shape[2]===u.shape[1],()=>`Error in conv1d: depth of input (${c.shape[2]}) must match input depth for filter ${u.shape[1]}.`),r(je(n,a),()=>`Error in conv1D: Either stride or dilation must be 1. Got stride ${n} and dilation '${a}'`),r("NWC"===i,()=>`Error in conv1d: got dataFormat of ${i} but only NWC is currently supported.`);const d=qe(u,[1,u.shape[0],u.shape[1],u.shape[2]]),f=qe(c,[c.shape[0],1,c.shape[1],c.shape[2]]),m=hn(f,d,[1,n],s,"NHWC",[1,a],o);return qe(m,p?[m.shape[2],m.shape[3]]:[m.shape[0],m.shape[2],m.shape[3]])}});const pn=bt({conv2DBackpropInput_:function(t,e,n,s,i,a="NHWC",o){r(t.length===e.rank,()=>`Length of inShape (${t.length}) and rank of dy (${e.rank}) must match`);let l=t,u=e,c=!1;3===e.rank&&(c=!0,u=qe(e,[1,e.shape[0],e.shape[1],e.shape[2]]),l=[1,t[0],t[1],t[2]]),r(4===l.length,()=>"Error in conv2dDerInput: inShape must be length 4, but got length "+l.length+"."),r(4===u.rank,()=>"Error in conv2dDerInput: dy must be rank 4, but got rank "+u.rank),r(4===n.rank,()=>"Error in conv2dDerInput: filter must be rank 4, but got rank "+n.rank);const p="NHWC"===a?l[3]:l[1],d="NHWC"===a?u.shape[3]:u.shape[1];r(p===n.shape[2],()=>`Error in conv2dDerInput: depth of input (${p}) must match input depth for filter ${n.shape[2]}.`),r(d===n.shape[3],()=>`Error in conv2dDerInput: depth of output (${d}) must match output depth for filter ${n.shape[3]}.`),null!=o&&r(h(i),()=>`Error in conv2dDerInput: pad must be an integer when using, dimRoundingMode ${o} but got pad ${i}.`);const f={dy:u,filter:n},m={strides:s,pad:i,dataFormat:a,dimRoundingMode:o,inputShape:l},g=ct.runKernel("Conv2DBackpropInput",f,m);return c?qe(g,[g.shape[1],g.shape[2],g.shape[3]]):g}});const dn=bt({conv2dTranspose_:function(t,e,n,s,r,i){const a=gt(t,"x","conv2dTranspose"),o=gt(e,"filter","conv2dTranspose");return pn(n,a,o,s,r,"NHWC",i)}});const fn=bt({conv3d_:function(t,e,n,s,i="NDHWC",a=[1,1,1]){const o=gt(t,"x","conv3d"),l=gt(e,"filter","conv3d");let u=o,h=!1;4===o.rank&&(h=!0,u=qe(o,[1,o.shape[0],o.shape[1],o.shape[2],o.shape[3]])),r(5===u.rank,()=>`Error in conv3d: input must be rank 5, but got rank ${u.rank}.`),r(5===l.rank,()=>"Error in conv3d: filter must be rank 5, but got rank "+l.rank+"."),r(u.shape[4]===l.shape[3],()=>`Error in conv3d: depth of input (${u.shape[4]}) must match input depth for filter ${l.shape[3]}.`),r(je(n,a),()=>`Error in conv3D: Either strides or dilations must be 1. Got strides ${n} and dilations '${a}'`),r("NDHWC"===i,()=>`Error in conv3d: got dataFormat of ${i} but only NDHWC is currently supported.`);const c={x:u,filter:l},p={strides:n,pad:s,dataFormat:i,dilations:a},d=ct.runKernel("Conv3D",c,p);return h?qe(d,[d.shape[1],d.shape[2],d.shape[3],d.shape[4]]):d}});const mn=bt({conv3DBackpropInput_:function(t,e,n,s,i){r(t.length===e.rank,()=>`Length of inShape (${t.length}) and rank of dy (${e.rank}) must match`);let a=t,o=e,l=!1;4===e.rank&&(l=!0,o=qe(e,[1,e.shape[0],e.shape[1],e.shape[2],e.shape[3]]),a=[1,t[0],t[1],t[2],t[3]]);const u=a[4],h=o.shape[4];r(5===a.length,()=>"Error in conv3dDerInput: inShape must be length 5, but got length "+a.length+"."),r(5===o.rank,()=>"Error in conv3dDerInput: dy must be rank 5, but got rank "+o.rank),r(5===n.rank,()=>"Error in conv3dDerInput: filter must be rank 5, but got rank "+n.rank),r(u===n.shape[3],()=>`Error in conv3dDerInput: depth of input (${u}) must match input depth for filter ${n.shape[3]}.`),r(h===n.shape[4],()=>`Error in conv3dDerInput: depth of output (${h}) must match output depth for filter ${n.shape[4]}.`);const c={dy:o,filter:n},p={pad:i,strides:s,inputShape:a},d=ct.runKernel("Conv3DBackpropInputV2",c,p);return l?qe(d,[d.shape[1],d.shape[2],d.shape[3],d.shape[4]]):d}});const gn=bt({cos_:function(t){const e={x:gt(t,"x","cos")};return ct.runKernel("Cos",e)}});const yn=bt({cosh_:function(t){const e={x:gt(t,"x","cosh")};return ct.runKernel("Cosh",e)}});const bn=bt({cumsum_:function(t,e=0,n=!1,s=!1){const r={x:gt(t,"x","cumsum")},i={axis:e,exclusive:n,reverse:s};return ct.runKernel("Cumsum",r,i)}});const wn=bt({depthToSpace_:function(t,e,n="NHWC"){const s=gt(t,"x","depthToSpace"),i="NHWC"===n?s.shape[1]:s.shape[2],a="NHWC"===n?s.shape[2]:s.shape[3],o="NHWC"===n?s.shape[3]:s.shape[1];r(i*e>=0,()=>`Negative dimension size caused by overflow when multiplying\n    ${i} and ${e}  for depthToSpace with input shape\n    ${s.shape}`),r(a*e>=0,()=>`Negative dimension size caused by overflow when multiplying\n    ${a} and ${e} for depthToSpace with input shape\n        ${s.shape}`),r(o%(e*e)==0,()=>`Dimension size must be evenly divisible by ${e*e} but is ${o} for depthToSpace with input shape ${s.shape}`);const l={x:s},u={blockSize:e,dataFormat:n};return ct.runKernel("DepthToSpace",l,u)}});const vn=bt({depthwiseConv2d_:function(t,e,n,s,i="NHWC",a=[1,1],o){const l=gt(t,"x","depthwiseConv2d"),u=gt(e,"filter","depthwiseConv2d");let c=l,p=!1;3===l.rank&&(p=!0,c=qe(l,[1,l.shape[0],l.shape[1],l.shape[2]])),r(4===c.rank,()=>`Error in depthwiseConv2d: input must be rank 4, but got rank ${c.rank}.`),r(4===u.rank,()=>"Error in depthwiseConv2d: filter must be rank 4, but got rank "+u.rank+"."),r(c.shape[3]===u.shape[2],()=>`Error in depthwiseConv2d: number of input channels (${c.shape[3]}) must match the inChannels dimension in filter ${u.shape[2]}.`),null!=o&&r(h(s),()=>`Error in depthwiseConv2d: pad must be an integer when using, dimRoundingMode ${o} but got pad ${s}.`);const d={x:c,filter:u},f={strides:n,pad:s,dataFormat:i,dilations:a,dimRoundingMode:o},m=ct.runKernel("DepthwiseConv2dNative",d,f);return p?qe(m,[m.shape[1],m.shape[2],m.shape[3]]):m}});const kn=bt({dilation2d_:function(t,e,n,s,i=[1,1],a="NHWC"){const o=gt(t,"x","dilation2d"),l=gt(e,"filter","dilation2d");r(3===o.rank||4===o.rank,()=>"Error in dilation2d: input must be rank 3 or 4, but got rank "+o.rank+"."),r(3===l.rank,()=>"Error in dilation2d: filter must be rank 3, but got rank "+l.rank+"."),r("NHWC"===a,()=>"Error in dilation2d: Only NHWC is currently supported, but got dataFormat of "+a);let u=o,h=!1;3===o.rank&&(u=qe(o,[1,o.shape[0],o.shape[1],o.shape[2]]),h=!0);const c={x:u,filter:l},p={strides:n,pad:s,dilations:i},d=ct.runKernel("Dilation2D",c,p);return h?qe(d,[d.shape[1],d.shape[2],d.shape[3]]):d}});function xn(t,e){const n=[];for(let s=0;s<e.length;s++){const r=t[t.length-s-1],i=e.length-s-1,a=e[i];(null==r||1===r&&a>1)&&n.unshift(i)}return n}function Sn(t,e){const n=[],s=Math.max(t.length,e.length);for(let r=0;r<s;r++){let s=t[t.length-r-1];null==s&&(s=1);let i=e[e.length-r-1];if(null==i&&(i=1),1===s)n.unshift(i);else if(1===i)n.unshift(s);else{if(s!==i){throw Error(`Operands could not be broadcast together with shapes ${t} and ${e}.`)}n.unshift(s)}}return n}const In=bt({equal_:function(t,e){let n=gt(t,"a","equal"),s=gt(e,"b","equal");[n,s]=rt(n,s),Sn(n.shape,s.shape);const r={a:n,b:s};return ct.runKernel("Equal",r)}});const Nn=bt({where_:function(t,e,n){const s=gt(e,"a","where"),a=gt(n,"b","where"),o=gt(t,"condition","where","bool"),l=Sn(s.shape,a.shape),u=nn(s,l),h=nn(a,l);1===o.rank&&r(o.shape[0]===s.shape[0],()=>"The first dimension of `a` must match the size of `condition`."),1!==o.rank&&i(o.shape,h.shape,"Error in where: ");const c={condition:o,t:u,e:h};return ct.runKernel("Select",c)}});const En=bt({zerosLike_:function(t){const e={x:gt(t,"x","zerosLike")};return ct.runKernel("ZerosLike",e)}});const An=bt({divNoNan_:function(t,e){let n=gt(t,"a","div"),s=gt(e,"b","div");[n,s]=rt(n,s);const r=Ie(n,s),i=En(r),a=In(s,i);return Nn(a,i,r)}});const Tn=bt({dot_:function(t,e){const n=gt(t,"t1","dot"),s=gt(e,"t2","dot");r(!(1!==n.rank&&2!==n.rank||1!==s.rank&&2!==s.rank),()=>`Error in dot: inputs must all be rank 1 or 2, but got ranks ${n.rank} and ${s.rank}.`);const i=1===n.rank?n.size:n.shape[1],a=1===s.rank?s.size:s.shape[0];if(r(i===a,()=>`Error in dot: inner dimensions of inputs must match, but got ${i} and ${a}.`),1===n.rank&&1===s.rank){const t=qe(n,[1,-1]),e=qe(s,[-1,1]),r=he(t,e);return qe(r,[])}if(1===n.rank&&2===s.rank){const t=qe(n,[1,-1]),e=qe(s,[s.shape[0],s.shape[1]]),r=he(t,e);return qe(r,[r.size])}if(2===n.rank&&1===s.rank){const t=qe(s,[-1,1]),e=he(n,t);return qe(e,[e.size])}{const t=qe(s,[s.shape[0],s.shape[1]]);return he(n,t)}}});const Dn=bt({elu_:function(t){const e={x:gt(t,"x","elu")};return ct.runKernel("Elu",e)}});const zn=bt({erf_:function(t){let e=gt(t,"x","erf");r("int32"===e.dtype||"float32"===e.dtype,()=>"Input dtype must be `int32` or `float32`."),"int32"===e.dtype&&(e=ee(e,"float32"));const n={x:e};return ct.runKernel("Erf",n)}});const Cn=bt({exp_:function(t){const e={x:gt(t,"x","exp")};return ct.runKernel("Exp",e)}});const Fn=bt({expandDims_:function(t,e=0){const n=gt(t,"x","expandDims","string_or_numeric");r(e<=n.rank,()=>"Axis must be <= rank of the tensor");const s={input:n},i={dim:e};return ct.runKernel("ExpandDims",s,i)}});const Rn=bt({expm1_:function(t){const e={x:gt(t,"x","expm1")};return ct.runKernel("Expm1",e)}});const Ln=bt({tile_:function(t,e){const n=gt(t,"x","tile","string_or_numeric");r(n.rank===e.length,()=>`Error in transpose: rank of input ${n.rank} must match length of reps ${e}.`);const s={x:n},i={reps:e};return ct.runKernel("Tile",s,i)}});const Mn=bt({eye_:function(t,e,n,s="float32"){null==e&&(e=t);const r=te([t,e],s),i=t<=e?t:e;for(let t=0;t<i;++t)r.set(1,t,t);const a=qe(r.toTensor(),[t,e]);if(null==n)return a;if(1===n.length)return Ln(Fn(a,0),[n[0],1,1]);if(2===n.length)return Ln(Fn(Fn(a,0),0),[n[0],n[1],1,1]);if(3===n.length)return Ln(Fn(Fn(Fn(a,0),0),0),[n[0],n[1],n[2],1,1]);throw new Error(`eye() currently supports only 1D and 2D batchShapes, but received ${n.length}D.`)}});function _n(t,e,n){const s={shape:t,value:e,dtype:n};return ct.runKernel("Fill",{},s)}const $n=bt({floor_:function(t){const e={x:gt(t,"x","floor")};return ct.runKernel("Floor",e)}});const On=bt({gather_:function(t,e,n=0,s=0){const r={x:gt(t,"x","gather"),indices:gt(e,"indices","gather","int32")},i={axis:n,batchDims:s};return ct.runKernel("GatherV2",r,i)}});const Bn=bt({greater_:function(t,e){let n=gt(t,"a","greater"),s=gt(e,"b","greater");[n,s]=rt(n,s),Sn(n.shape,s.shape);const r={a:n,b:s};return ct.runKernel("Greater",r)}});const Pn=bt({greaterEqual_:function(t,e){let n=gt(t,"a","greaterEqual"),s=gt(e,"b","greaterEqual");[n,s]=rt(n,s),Sn(n.shape,s.shape);const r={a:n,b:s};return ct.runKernel("GreaterEqual",r)}});const Un=bt({imag_:function(t){const e={input:gt(t,"input","imag")};return ct.runKernel("Imag",e)}});const Wn=bt({isFinite_:function(t){const e={x:gt(t,"x","isFinite")};return ct.runKernel("IsFinite",e)}});const jn=bt({isInf_:function(t){const e={x:gt(t,"x","isInf")};return ct.runKernel("IsInf",e)}});const qn=bt({isNaN_:function(t){const e={x:gt(t,"x","isNaN")};return ct.runKernel("IsNan",e)}});const Kn=bt({leakyRelu_:function(t,e=.2){const n={x:gt(t,"x","leakyRelu")},s={alpha:e};return ct.runKernel("LeakyRelu",n,s)}});const Vn=bt({less_:function(t,e){let n=gt(t,"a","less"),s=gt(e,"b","less");[n,s]=rt(n,s),Sn(n.shape,s.shape);const r={a:n,b:s};return ct.runKernel("Less",r)}});const Hn=bt({lessEqual_:function(t,e){let n=gt(t,"a","lessEqual"),s=gt(e,"b","lessEqual");[n,s]=rt(n,s),Sn(n.shape,s.shape);const r={a:n,b:s};return ct.runKernel("LessEqual",r)}});const Gn=bt({localResponseNormalization_:function(t,e=5,n=1,s=1,i=.5){const a=gt(t,"x","localResponseNormalization");r(4===a.rank||3===a.rank,()=>`Error in localResponseNormalization: x must be rank 3 or 4 but got\n               rank ${a.rank}.`),r(h(e),()=>`Error in localResponseNormalization: depthRadius must be an integer but got depthRadius ${e}.`);let o=a,l=!1;3===a.rank&&(l=!0,o=qe(a,[1,a.shape[0],a.shape[1],a.shape[2]]));const u={x:o},c={depthRadius:e,bias:n,alpha:s,beta:i},p=ct.runKernel("LRN",u,c);return l?qe(p,[p.shape[1],p.shape[2],p.shape[3]]):p}});const Jn=bt({log_:function(t){const e={x:gt(t,"x","log")};return ct.runKernel("Log",e)}});const Zn=bt({log1p_:function(t){const e={x:gt(t,"x","log1p")};return ct.runKernel("Log1p",e)}});function Xn(t){return ct.customGrad(t)}const Yn=bt({neg_:function(t){const e={x:gt(t,"x","neg")};return ct.runKernel("Neg",e)}});const Qn=bt({softplus_:function(t){const e={x:gt(t,"x","softplus")};return ct.runKernel("Softplus",e)}});const ts=bt({logSigmoid_:function(t){const e=gt(t,"x","logSigmoid");return Xn(t=>({value:Yn(Qn(Yn(t))),gradFunc:e=>Ne(e,Ge(Yn(t)))}))(e)}});const es=bt({max_:function(t,e=null,n=!1){const s={x:gt(t,"x","max")},r={reductionIndices:e,keepDims:n};return ct.runKernel("Max",s,r)}});const ns=bt({sub_:function(t,e){let n=gt(t,"a","sub"),s=gt(e,"b","sub");[n,s]=rt(n,s);const r={a:n,b:s};return ct.runKernel("Sub",r)}});const ss=bt({sum_:function(t,e=null,n=!1){let s=gt(t,"x","sum");"bool"===s.dtype&&(s=ee(s,"int32"));const r={x:s},i={axis:e,keepDims:n};return ct.runKernel("Sum",r,i)}});const rs=bt({logSoftmax_:function(t,e=-1){const n=gt(t,"logits","logSoftmax");if(-1===e&&(e=n.rank-1),e!==n.rank-1)throw Error(`Log Softmax along a non-last dimension is not yet supported. Logits was rank ${n.rank} and axis was ${e}`);return Xn((t,n)=>{const s=es(t,e,!0),r=ns(t,s),i=ns(ee(r,"float32"),Jn(ss(Cn(r),e,!0)));n([i]);return{value:i,gradFunc:(t,n)=>{const[s]=n,r=Cn(s);return ns(t,Ne(ss(t,e,!0),r))}}})(n)}});function is(t,e){return function(t,e,n){const s=t.length+e.length,r=[];let i=0,a=0;for(let o=0;o<s;o++)-1===n.indexOf(o)?r.push(t[i++]):r.push(e[a++]);return r}(t,e.map(t=>1),e)}function as(t){return t.map((t,e)=>[e,t]).sort((t,e)=>t[1]-e[1]).map(t=>t[0])}const os=bt({logSumExp_:function(t,e=null,n=!1){const s=gt(t,"x","logSumExp"),r=p(e,s.shape),i=es(s,r,!0),a=ns(s,i),o=Cn(a),l=ss(o,r),u=Jn(l),h=xe(qe(i,u.shape),u);if(n){const t=is(h.shape,r);return qe(h,t)}return h}});const ls=bt({logicalAnd_:function(t,e){const n=gt(t,"a","logicalAnd","bool"),s=gt(e,"b","logicalAnd","bool");Sn(n.shape,s.shape);const r={a:n,b:s};return ct.runKernel("LogicalAnd",r)}});const us=bt({logicalNot_:function(t){const e={x:gt(t,"x","logicalNot","bool")};return ct.runKernel("LogicalNot",e)}});const hs=bt({logicalOr_:function(t,e){const n=gt(t,"a","logicalOr","bool"),s=gt(e,"b","logicalOr","bool");Sn(n.shape,s.shape);const r={a:n,b:s};return ct.runKernel("LogicalOr",r)}});const cs=bt({logicalXor_:function(t,e){const n=gt(t,"a","logicalXor","bool"),s=gt(e,"b","logicalXor","bool");return Sn(n.shape,s.shape),ls(hs(t,e),us(ls(t,e)))}});const ps=bt({maxPool_:function(t,e,n,s,i){const a=gt(t,"x","maxPool");let o=a,l=!1;3===a.rank&&(l=!0,o=qe(a,[1,a.shape[0],a.shape[1],a.shape[2]])),r(4===o.rank,()=>`Error in maxPool: input must be rank 4 but got rank ${o.rank}.`),r(je(n,1),()=>`Error in maxPool: Either strides or dilations must be 1. Got strides ${n} and dilations '1'`),null!=i&&r(h(s),()=>`Error in maxPool: pad must be an integer when using, dimRoundingMode ${i} but got pad ${s}.`);const u={x:o},c={filterSize:e,strides:n,pad:s,dimRoundingMode:i},p=ct.runKernel("MaxPool",u,c);return l?qe(p,[p.shape[1],p.shape[2],p.shape[3]]):p}});const ds=bt({maxPool3d_:function(t,e=[1,1,1],n,s,i,a="NDHWC"){const o=gt(t,"x","maxPool3d");let l=o,u=!1;4===o.rank&&(u=!0,l=qe(o,[1,o.shape[0],o.shape[1],o.shape[2],o.shape[3]])),r(5===l.rank,()=>`Error in maxPool3d: x must be rank 5 but got rank ${l.rank}.`),r("NDHWC"===a,()=>"Error in maxPool3d: Only NDHWC is currently supported, but got dataFormat of "+a),null!=i&&r(h(s),()=>`Error in maxPool3d: pad must be an integer when using, dimRoundingMode ${i} but got pad ${s}.`);const c={x:l},p={filterSize:e,strides:n,pad:s,dimRoundingMode:i,dataFormat:a},d=ct.runKernel("MaxPool3D",c,p);return u?qe(d,[d.shape[1],d.shape[2],d.shape[3],d.shape[4]]):d}});const fs=bt({maximum_:function(t,e){let n=gt(t,"a","maximum"),s=gt(e,"b","maximum");[n,s]=rt(n,s),"bool"===n.dtype&&(n=ee(n,"int32"),s=ee(s,"int32")),Sn(n.shape,s.shape);const r={a:n,b:s};return ct.runKernel("Maximum",r)}});const ms=bt({mean_:function(t,e=null,n=!1){const s={x:gt(t,"x","mean")},r={axis:e,keepDims:n};return ct.runKernel("Mean",s,r)}});const gs=bt({min_:function(t,e=null,n=!1){const s={x:gt(t,"x","min")},r={axis:e,keepDims:n};return ct.runKernel("Min",s,r)}});const ys=bt({minimum_:function(t,e){let n=gt(t,"a","minimum"),s=gt(e,"b","minimum");[n,s]=rt(n,s),"bool"===n.dtype&&(n=ee(n,"int32"),s=ee(s,"int32")),Sn(n.shape,s.shape);const r={a:n,b:s};return ct.runKernel("Minimum",r)}});const bs=bt({mirrorPad_:function(t,e,n){r("reflect"===n||"symmetric"===n,()=>`Invalid mode. Mode must be either reflect or symmetric. Got ${n}.`);const s=gt(t,"x","mirrorPad");if(0===s.rank)throw new Error("mirrorPad(scalar) is not defined. Pass non-scalar to mirrorPad");r(e.length===s.rank,()=>`Padding doesn't match input. Must be ${s.rank}. Got ${e.length}.`);const i="reflect"===n?1:0;for(let t=0;t<s.rank;t++)r(2===e[t].length,()=>"Invalid number of paddings. Must be length of 2 each."),r(e[t][0]>=0&&e[t][0]<=s.shape[t]-i&&e[t][1]>=0&&e[t][1]<=s.shape[t]-i,()=>`Padding in dimension ${t} cannot be greater than or equal to ${s.shape[t]-i} or less than 0 for input of shape `+s.shape);const a={paddings:e,mode:n},o={x:s};return ct.runKernel("MirrorPad",o,a)}});const ws=bt({mod_:function(t,e){let n=gt(t,"a","mod"),s=gt(e,"b","mod");[n,s]=rt(n,s);const r={a:n,b:s};return ct.runKernel("Mod",r)}});const vs=bt({square_:function(t){const e=gt(t,"x","square");return ct.runKernel("Square",{x:e},{})}});const ks=bt({moments_:function(t,e=null,n=!1){const s=p(e,(t=gt(t,"x","moments")).shape),r=ms(t,s,n);let i=r.shape;n||(i=is(r.shape,s));const a=vs(ns(ee(t,"float32"),qe(r,i)));return{mean:r,variance:ms(a,s,n)}}});const xs=bt({notEqual_:function(t,e){let n=gt(t,"a","notEqual"),s=gt(e,"b","notEqual");[n,s]=rt(n,s),Sn(n.shape,s.shape);const r={a:n,b:s};return ct.runKernel("NotEqual",r)}});function Ss(t,e="float32"){if("complex64"===e){const e=Ss(t,"float32"),n=Ss(t,"float32");return wt(e,n)}const n=k(l(t),e);return ct.makeTensor(n,t,e)}function Is(t,e="float32"){if("complex64"===e){const e=Is(t,"float32"),n=Ss(t,"float32");return wt(e,n)}const n=v(l(t),e);return ct.makeTensor(n,t,e)}const Ns=bt({onesLike_:function(t){const e={x:gt(t,"x","onesLike")};return ct.runKernel("OnesLike",e)}});const Es=bt({pad_:function(t,e,n=0){const s=gt(t,"x","pad");if(0===s.rank)throw new Error("pad(scalar) is not defined. Pass non-scalar to pad");const r={paddings:e,constantValue:n},i={x:s};return ct.runKernel("PadV2",i,r)}});const As=bt({spaceToBatchND_:function(t,e,n){const s=gt(t,"x","spaceToBatchND");r(s.rank>=1+e.length,()=>`input rank ${s.rank} should be > than [blockShape] ${e.length}`),r(n.length===e.length,()=>`paddings.shape[0] ${n.length} must be equal to [blockShape] ${e.length}`),r(s.shape.reduce((t,s,r)=>r>0&&r<=e.length?t&&(s+n[r-1][0]+n[r-1][1])%e[r-1]==0:t,!0),()=>`input spatial dimensions ${s.shape.slice(1)} with paddings ${n.toString()} must be divisible by blockShapes ${e.toString()}`);const i={x:s},a={blockShape:e,paddings:n};return ct.runKernel("SpaceToBatchND",i,a)}});const Ts=bt({pool_:function(t,e,n,s,i,a){null==i&&(i=[1,1]),null==a&&(a=1),0===s&&(s="valid");const o=gt(t,"x","maxPool");let l=o,u=!1;3===o.rank&&(u=!0,l=qe(o,[1,o.shape[0],o.shape[1],o.shape[2]])),r(je(a,i),()=>`Error in pool: Either strides or dilations must be 1. Got strides ${a} and dilations '${i}'`);const h=function(t,e,n,s,r,i,a="channelsLast"){const[o,l]=Be(e);let u;if("channelsLast"===a)u=[o,l,t[3],t[3]];else{if("channelsFirst"!==a)throw new Error("Unknown dataFormat "+a);u=[o,l,t[1],t[1]]}return Oe(t,u,n,s,r,i,!1,a)}(l.shape,e,a,i,s),c=[h.dilationHeight,h.dilationWidth];let p;p="same"===s?function(t,e){const n=t.map((t,n)=>t+(t-1)*(e[n]-1)).map(t=>t-1),s=n.map(t=>Math.floor(t/2)),r=n.map((t,e)=>t-s[e]);return n.map((t,e)=>[s[e],r[e]])}([h.filterHeight,h.filterWidth],c):[[0,0],[0,0]];const d=1===c[0]&&1===c[1],[f,m]=function(t,e,n){const s=n.map(t=>t[0]),r=n.map(t=>t[1]),i=t.concat(s,r),a=e.map((t,e)=>(t-i[e]%t)%t),o=r.map((t,e)=>t+a[e]),l=e.map((t,e)=>[s[e],o[e]]),u=e.map((t,e)=>[0,a[e]]);return[l,u]}([h.inHeight,h.inWidth],c,p),g=d?s:"valid",y=d?l:As(l,c,f),b=("avg"===n?()=>Ke(y,e,a,g):()=>ps(y,e,a,g))(),w=d?b:Xe(b,c,m);return u?qe(w,[w.shape[1],w.shape[2],w.shape[3]]):w}});const Ds=bt({pow_:function(t,e){let n=gt(t,"base","pow"),s=gt(e,"exp","pow");[n,s]=rt(n,s);const r={a:n,b:s};return ct.runKernel("Pow",r)}});const zs=bt({prelu_:function(t,e){const n={x:gt(t,"x","prelu"),alpha:gt(e,"alpha","prelu")};return ct.runKernel("Prelu",n)}});const Cs=bt({prod_:function(t,e=null,n=!1){let s=gt(t,"x","prod");"bool"===s.dtype&&(s=ee(s,"int32"));const r={x:s},i={axis:e,keepDims:n};return ct.runKernel("Prod",r,i)}});"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self&&self;function Fs(t,e){return t(e={exports:{}},e.exports),e.exports}var Rs=Fs((function(t){!function(t,e,n){function s(t){var e,n=this,s=(e=4022871197,function(t){t=t.toString();for(var n=0;n<t.length;n++){var s=.02519603282416938*(e+=t.charCodeAt(n));s-=e=s>>>0,e=(s*=e)>>>0,e+=4294967296*(s-=e)}return 2.3283064365386963e-10*(e>>>0)});n.next=function(){var t=2091639*n.s0+2.3283064365386963e-10*n.c;return n.s0=n.s1,n.s1=n.s2,n.s2=t-(n.c=0|t)},n.c=1,n.s0=s(" "),n.s1=s(" "),n.s2=s(" "),n.s0-=s(t),n.s0<0&&(n.s0+=1),n.s1-=s(t),n.s1<0&&(n.s1+=1),n.s2-=s(t),n.s2<0&&(n.s2+=1),s=null}function r(t,e){return e.c=t.c,e.s0=t.s0,e.s1=t.s1,e.s2=t.s2,e}function i(t,e){var n=new s(t),i=e&&e.state,a=n.next;return a.int32=function(){return 4294967296*n.next()|0},a.double=function(){return a()+11102230246251565e-32*(2097152*a()|0)},a.quick=a,i&&("object"==typeof i&&r(i,n),a.state=function(){return r(n,{})}),a}e&&e.exports?e.exports=i:n&&n.amd?n((function(){return i})):this.alea=i}(0,t,!1)})),Ls=Fs((function(t){!function(t,e,n){function s(t){var e=this,n="";e.x=0,e.y=0,e.z=0,e.w=0,e.next=function(){var t=e.x^e.x<<11;return e.x=e.y,e.y=e.z,e.z=e.w,e.w^=e.w>>>19^t^t>>>8},t===(0|t)?e.x=t:n+=t;for(var s=0;s<n.length+64;s++)e.x^=0|n.charCodeAt(s),e.next()}function r(t,e){return e.x=t.x,e.y=t.y,e.z=t.z,e.w=t.w,e}function i(t,e){var n=new s(t),i=e&&e.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},a.int32=n.next,a.quick=a,i&&("object"==typeof i&&r(i,n),a.state=function(){return r(n,{})}),a}e&&e.exports?e.exports=i:n&&n.amd?n((function(){return i})):this.xor128=i}(0,t,!1)})),Ms=Fs((function(t){!function(t,e,n){function s(t){var e=this,n="";e.next=function(){var t=e.x^e.x>>>2;return e.x=e.y,e.y=e.z,e.z=e.w,e.w=e.v,(e.d=e.d+362437|0)+(e.v=e.v^e.v<<4^t^t<<1)|0},e.x=0,e.y=0,e.z=0,e.w=0,e.v=0,t===(0|t)?e.x=t:n+=t;for(var s=0;s<n.length+64;s++)e.x^=0|n.charCodeAt(s),s==n.length&&(e.d=e.x<<10^e.x>>>4),e.next()}function r(t,e){return e.x=t.x,e.y=t.y,e.z=t.z,e.w=t.w,e.v=t.v,e.d=t.d,e}function i(t,e){var n=new s(t),i=e&&e.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},a.int32=n.next,a.quick=a,i&&("object"==typeof i&&r(i,n),a.state=function(){return r(n,{})}),a}e&&e.exports?e.exports=i:n&&n.amd?n((function(){return i})):this.xorwow=i}(0,t,!1)})),_s=Fs((function(t){!function(t,e,n){function s(t){var e=this;e.next=function(){var t,n,s=e.x,r=e.i;return t=s[r],n=(t^=t>>>7)^t<<24,n^=(t=s[r+1&7])^t>>>10,n^=(t=s[r+3&7])^t>>>3,n^=(t=s[r+4&7])^t<<7,t=s[r+7&7],n^=(t^=t<<13)^t<<9,s[r]=n,e.i=r+1&7,n},function(t,e){var n,s=[];if(e===(0|e))s[0]=e;else for(e=""+e,n=0;n<e.length;++n)s[7&n]=s[7&n]<<15^e.charCodeAt(n)+s[n+1&7]<<13;for(;s.length<8;)s.push(0);for(n=0;n<8&&0===s[n];++n);for(8==n?s[7]=-1:s[n],t.x=s,t.i=0,n=256;n>0;--n)t.next()}(e,t)}function r(t,e){return e.x=t.x.slice(),e.i=t.i,e}function i(t,e){null==t&&(t=+new Date);var n=new s(t),i=e&&e.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},a.int32=n.next,a.quick=a,i&&(i.x&&r(i,n),a.state=function(){return r(n,{})}),a}e&&e.exports?e.exports=i:n&&n.amd?n((function(){return i})):this.xorshift7=i}(0,t,!1)})),$s=Fs((function(t){!function(t,e,n){function s(t){var e=this;e.next=function(){var t,n,s=e.w,r=e.X,i=e.i;return e.w=s=s+1640531527|0,n=r[i+34&127],t=r[i=i+1&127],n^=n<<13,t^=t<<17,n^=n>>>15,t^=t>>>12,n=r[i]=n^t,e.i=i,n+(s^s>>>16)|0},function(t,e){var n,s,r,i,a,o=[],l=128;for(e===(0|e)?(s=e,e=null):(e+="\0",s=0,l=Math.max(l,e.length)),r=0,i=-32;i<l;++i)e&&(s^=e.charCodeAt((i+32)%e.length)),0===i&&(a=s),s^=s<<10,s^=s>>>15,s^=s<<4,s^=s>>>13,i>=0&&(a=a+1640531527|0,r=0==(n=o[127&i]^=s+a)?r+1:0);for(r>=128&&(o[127&(e&&e.length||0)]=-1),r=127,i=512;i>0;--i)s=o[r+34&127],n=o[r=r+1&127],s^=s<<13,n^=n<<17,s^=s>>>15,n^=n>>>12,o[r]=s^n;t.w=a,t.X=o,t.i=r}(e,t)}function r(t,e){return e.i=t.i,e.w=t.w,e.X=t.X.slice(),e}function i(t,e){null==t&&(t=+new Date);var n=new s(t),i=e&&e.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},a.int32=n.next,a.quick=a,i&&(i.X&&r(i,n),a.state=function(){return r(n,{})}),a}e&&e.exports?e.exports=i:n&&n.amd?n((function(){return i})):this.xor4096=i}(0,t,!1)})),Os=Fs((function(t){!function(t,e,n){function s(t){var e=this,n="";e.next=function(){var t=e.b,n=e.c,s=e.d,r=e.a;return t=t<<25^t>>>7^n,n=n-s|0,s=s<<24^s>>>8^r,r=r-t|0,e.b=t=t<<20^t>>>12^n,e.c=n=n-s|0,e.d=s<<16^n>>>16^r,e.a=r-t|0},e.a=0,e.b=0,e.c=-1640531527,e.d=1367130551,t===Math.floor(t)?(e.a=t/4294967296|0,e.b=0|t):n+=t;for(var s=0;s<n.length+20;s++)e.b^=0|n.charCodeAt(s),e.next()}function r(t,e){return e.a=t.a,e.b=t.b,e.c=t.c,e.d=t.d,e}function i(t,e){var n=new s(t),i=e&&e.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},a.int32=n.next,a.quick=a,i&&("object"==typeof i&&r(i,n),a.state=function(){return r(n,{})}),a}e&&e.exports?e.exports=i:n&&n.amd?n((function(){return i})):this.tychei=i}(0,t,!1)})),Bs=Fs((function(t){!function(e,n){var s,r=this,i=n.pow(256,6),a=n.pow(2,52),o=2*a;function l(t,l,d){var f=[],m=c(function t(e,n){var s,r=[],i=typeof e;if(n&&"object"==i)for(s in e)try{r.push(t(e[s],n-1))}catch(t){}return r.length?r:"string"==i?e:e+"\0"}((l=1==l?{entropy:!0}:l||{}).entropy?[t,p(e)]:null==t?function(){try{var t;return s&&(t=s.randomBytes)?t=t(256):(t=new Uint8Array(256),(r.crypto||r.msCrypto).getRandomValues(t)),p(t)}catch(t){var n=r.navigator,i=n&&n.plugins;return[+new Date,r,i,r.screen,p(e)]}}():t,3),f),g=new u(f),y=function(){for(var t=g.g(6),e=i,n=0;t<a;)t=256*(t+n),e*=256,n=g.g(1);for(;t>=o;)t/=2,e/=2,n>>>=1;return(t+n)/e};return y.int32=function(){return 0|g.g(4)},y.quick=function(){return g.g(4)/4294967296},y.double=y,c(p(g.S),e),(l.pass||d||function(t,e,s,r){return r&&(r.S&&h(r,g),t.state=function(){return h(g,{})}),s?(n.random=t,e):t})(y,m,"global"in l?l.global:this==n,l.state)}function u(t){var e,n=t.length,s=this,r=0,i=s.i=s.j=0,a=s.S=[];for(n||(t=[n++]);r<256;)a[r]=r++;for(r=0;r<256;r++)a[r]=a[i=255&i+t[r%n]+(e=a[r])],a[i]=e;(s.g=function(t){for(var e,n=0,r=s.i,i=s.j,a=s.S;t--;)e=a[r=255&r+1],n=256*n+a[255&(a[r]=a[i=255&i+e])+(a[i]=e)];return s.i=r,s.j=i,n})(256)}function h(t,e){return e.i=t.i,e.j=t.j,e.S=t.S.slice(),e}function c(t,e){for(var n,s=t+"",r=0;r<s.length;)e[255&r]=255&(n^=19*e[255&r])+s.charCodeAt(r++);return p(e)}function p(t){return String.fromCharCode.apply(0,t)}if(n.seedrandom=l,c(n.random(),e),t.exports){t.exports=l;try{s=require("crypto")}catch(t){}}}([],Math)}));Bs.alea=Rs,Bs.xor128=Ls,Bs.xorwow=Ms,Bs.xorshift7=_s,Bs.xor4096=$s,Bs.tychei=Os;var Ps=Bs.alea;class Us{constructor(t,e,n,s,r){this.mean=t,this.stdDev=e,this.dtype=n,this.nextVal=NaN,this.truncated=s,this.truncated&&(this.upper=this.mean+2*this.stdDev,this.lower=this.mean-2*this.stdDev);const i=r||Math.random();this.random=Ps(i.toString())}nextValue(){if(!isNaN(this.nextVal)){const t=this.nextVal;return this.nextVal=NaN,t}let t,e,n=!1;for(;!n;){let s,r,i;do{s=2*this.random()-1,r=2*this.random()-1,i=s*s+r*r}while(i>=1||0===i);const a=Math.sqrt(-2*Math.log(i)/i);t=this.mean+this.stdDev*s*a,e=this.mean+this.stdDev*r*a,this.truncated&&!this.isValidTruncated(t)||(n=!0)}return this.truncated&&!this.isValidTruncated(e)||(this.nextVal=this.convertValue(e)),this.convertValue(t)}convertValue(t){return null==this.dtype||"float32"===this.dtype?t:Math.round(t)}isValidTruncated(t){return t<=this.upper&&t>=this.lower}}class Ws{constructor(t=0,e=1,n,s){if(this.canReturnFloat=()=>null==this.dtype||"float32"===this.dtype,this.min=t,this.range=e-t,this.dtype=n,null==s&&(s=Math.random()),"number"==typeof s&&(s=s.toString()),!this.canReturnFloat()&&this.range<=1)throw new Error(`The difference between ${t} - ${e} <= 1 and dtype is not float`);this.random=Ps(s)}convertValue(t){return this.canReturnFloat()?t:Math.round(t)}nextValue(){return this.convertValue(this.min+this.range*this.random())}}const js=bt({randomNormal_:function(t,e=0,n=1,s,r){if(null!=s&&"bool"===s)throw new Error("Unsupported data type "+s);const i=new Us(e,n,s,!1,r),a=te(t,s);for(let t=0;t<a.values.length;t++)a.values[t]=i.nextValue();return a.toTensor()}});const qs=bt({randomUniform_:function(t,e=0,n=1,s="float32",r){const i=te(t,s),a=new Ws(e,n,null,r);for(let t=0;t<i.values.length;t++)i.values[t]=a.nextValue();return i.toTensor()}});function Ks(t,e,n=1,s="float32"){if(0===n)throw new Error("Cannot have a step of zero");const r={start:t,stop:e,step:n,dtype:s};return ct.runKernel("Range",{},r)}const Vs=bt({real_:function(t){const e={input:gt(t,"input","real")};return ct.runKernel("Real",e)}});const Hs=bt({reciprocal_:function(t){const e={x:gt(t,"x","reciprocal")};return ct.runKernel("Reciprocal",e)}});const Gs=bt({relu_:function(t){const e={x:gt(t,"x","relu")};return ct.runKernel("Relu",e)}});const Js=bt({relu6_:function(t){const e={x:gt(t,"x","relu6")};return ct.runKernel("Relu6",e)}});const Zs=bt({reverse_:function(t,e){const n={x:gt(t,"x","reverse")},s={dims:e};return ct.runKernel("Reverse",n,s)}});const Xs=bt({round_:function(t){const e={x:gt(t,"x","round")};return ct.runKernel("Round",e)}});const Ys=bt({rsqrt_:function(t){const e={x:gt(t,"x","rsqrt")};return ct.runKernel("Rsqrt",e)}});function Qs(t,e){if((d(t)&&"string"!==e||Array.isArray(t))&&"complex64"!==e)throw new Error("Error creating a new Scalar: value must be a primitive (number|boolean|string)");if("string"===e&&d(t)&&!(t instanceof Uint8Array))throw new Error("When making a scalar from encoded string, the value must be `Uint8Array`.");return vt(t,[],[],e)}const tr=bt({selu_:function(t){const e={x:gt(t,"x","selu")};return ct.runKernel("Selu",e)}});const er=bt({separableConv2d_:function(t,e,n,s,i,a=[1,1],o="NHWC"){const l=gt(t,"x","separableConv2d"),u=gt(e,"depthwiseFilter","separableConv2d"),h=gt(n,"pointwiseFilter","separableConv2d");let c=l,p=!1;if(3===l.rank&&(p=!0,c=qe(l,[1,l.shape[0],l.shape[1],l.shape[2]])),"NCHW"===o)throw new Error("separableConv2d currently does not support dataFormat NCHW; only NHWC is supported");r(4===c.rank,()=>`Error in separableConv2d: input must be rank 4, but got rank ${c.rank}.`),r(4===u.rank,()=>`Error in separableConv2d: depthwise filter must be rank 4, but got rank ${u.rank}.`),r(4===h.rank,()=>`Error in separableConv2d: pointwise filter must be rank 4, but got rank ${u.rank}.`),r(1===h.shape[0],()=>`Error in separableConv2d: the first dimension of pointwise filter  must be 1, but got ${h.shape[0]}.`),r(1===h.shape[1],()=>`Error in separableConv2d: the second dimension of pointwise filter must be 1, but got ${h.shape[1]}.`);const d=u.shape[2],f=u.shape[3];r(h.shape[2]===d*f,()=>`Error in separableConv2d: the third dimension of pointwise filter must be ${d*f}, but got ${h.shape[2]}.`);const m=vn(c,u,s,i,o,a),g=hn(m,h,1,"valid",o);return p?qe(g,[g.shape[1],g.shape[2],g.shape[3]]):g}});const nr=bt({sign_:function(t){const e={x:gt(t,"x","sign")};return ct.runKernel("Sign",e)}});const sr=bt({sin_:function(t){const e={x:gt(t,"x","sin")};return ct.runKernel("Sin",e)}});const rr=bt({sinh_:function(t){const e={x:gt(t,"x","sinh")};return ct.runKernel("Sinh",e)}});const ir=bt({slice1d_:function(t,e,n){const s=gt(t,"x","slice1d");return r(1===s.rank,()=>`slice1d expects a rank-1 tensor, but got a rank-${s.rank} tensor`),Je(s,[e],[n])}});const ar=bt({slice2d_:function(t,e,n){const s=gt(t,"x","slice2d");return r(2===s.rank,()=>`slice2d expects a rank-2 tensor, but got a rank-${s.rank} tensor`),Je(s,e,n)}});const or=bt({slice3d_:function(t,e,n){const s=gt(t,"x","slice3d");return r(3===s.rank,()=>`slice3d expects a rank-3 tensor, but got a rank-${s.rank} tensor`),Je(s,e,n)}});const lr=bt({slice4d_:function(t,e,n){const s=gt(t,"x","slice4d");return r(4===s.rank,()=>`slice4d expects a rank-4 tensor, but got a rank-${s.rank} tensor`),Je(s,e,n)}});const ur=bt({softmax_:function(t,e=-1){const n=gt(t,"logits","softmax","float32");if(-1===e&&(e=n.rank-1),e!==n.rank-1)throw Error(`Softmax along a non-last dimension is not yet supported. Logits was rank ${n.rank} and dim was ${e}`);const s={logits:n},r={dim:e};return ct.runKernel("Softmax",s,r)}});const hr=bt({fft_:function(t){r("complex64"===t.dtype,()=>`The dtype for tf.spectral.fft() must be complex64 but got ${t.dtype}.`);const e={input:t};return ct.runKernel("FFT",e)}});const cr=bt({ifft_:function(t){r("complex64"===t.dtype,()=>`The dtype for tf.spectral.ifft() must be complex64 but got ${t.dtype}.`);const e={input:t};return ct.runKernel("IFFT",e)}});const pr=bt({irfft_:function(t){const e=t.shape[t.shape.length-1],n=t.size/e;let s;if(e<=2){const r=qe(t,[n,e]);s=cr(r)}else{const r=[n,2*(e-1)],i=qe(Vs(t),[n,e]),a=qe(Un(t),[n,e]),o=Zs(Je(i,[0,1],[n,e-2]),1),l=Ne(Zs(Je(a,[0,1],[n,e-2]),1),Qs(-1)),u=He([i,o],1),h=He([a,l],1),c=qe(wt(u,h),[r[0],r[1]]);s=cr(c)}if(s=Vs(s),3===t.rank&&0!==t.shape[0]){const e=s,n=t.shape[0];s=qe(s,[n,s.shape[0]/n,s.shape[1]]),e.dispose()}return s}});const dr=bt({split_:function(t,e,n=0){const s={x:gt(t,"x","split")},r={numOrSizeSplits:e,axis:n};return ct.runKernel("SplitV",s,r)}});const fr=bt({rfft_:function(t,e){r("float32"===t.dtype,()=>"The dtype for rfft() must be real value but got "+t.dtype);let n=t.shape[t.shape.length-1];const s=t.size/n;let i;if(null!=e&&e<n){const s=t.shape.map(t=>0),r=t.shape.map(t=>t);r[t.shape.length-1]=e,i=Je(t,s,r),n=e}else if(null!=e&&e>n){const s=t.shape.map(t=>t);s[t.shape.length-1]=e-n,i=He([t,Ss(s)],t.shape.length-1),n=e}else i=t;const a=En(i),o=qe(wt(i,a),[s,n]),l=hr(o),u=Math.floor(n/2)+1,h=Vs(l),c=Un(l),p=dr(h,[u,n-u],h.shape.length-1),d=dr(c,[u,n-u],c.shape.length-1),f=i.shape.slice();return f[i.shape.length-1]=u,qe(wt(p[0],d[0]),f)}});const mr=bt({sqrt_:function(t){const e={x:gt(t,"x","sqrt")};return ct.runKernel("Sqrt",e)}});const gr=bt({squaredDifference_:function(t,e){let n=gt(t,"a","squaredDifference"),s=gt(e,"b","squaredDifference");[n,s]=rt(n,s),Sn(n.shape,s.shape);const r={a:n,b:s};return ct.runKernel("SquaredDifference",r,{})}});const yr=bt({squeeze_:function(t,e){const n=gt(t,"x","squeeze");return qe(n,function(t,e){const n=[],s=[],r=null!=e&&Array.isArray(e)&&0===e.length,i=null==e||r?null:p(e,t).sort();let a=0;for(let e=0;e<t.length;++e){if(null!=i){if(i[a]===e&&1!==t[e])throw new Error(`Can't squeeze axis ${e} since its dim '${t[e]}' is not 1`);(null==i[a]||i[a]>e)&&1===t[e]&&(n.push(t[e]),s.push(e)),i[a]<=e&&a++}1!==t[e]&&(n.push(t[e]),s.push(e))}return{newShape:n,keptDims:s}}(n.shape,e).newShape)}});const br=bt({stack_:function(t,e=0){const n=yt(t,"tensors","stack","string_or_numeric");r(n.length>=1,()=>"Pass at least one tensor to tf.stack"),n.length>0&&r(e<=n[0].rank,()=>"Axis must be <= rank of the tensor");const s=n,i={axis:e};return ct.runKernel("Pack",s,i)}});const wr=bt({step_:function(t,e=0){const n={x:gt(t,"x","step")},s={alpha:e};return ct.runKernel("Step",n,s)}});const vr=bt({stridedSlice_:function(t,e,n,s,r=0,i=0,a=0,o=0,l=0){const u={x:gt(t,"x","stridedSlice")},h={begin:e,end:n,strides:s,beginMask:r,endMask:i,ellipsisMask:a,newAxisMask:o,shrinkAxisMask:l};return ct.runKernel("StridedSlice",u,h)}});const kr=bt({tan_:function(t){const e={x:gt(t,"x","tan")};return ct.runKernel("Tan",e)}});function xr(t,e){a(t);const n=ft(t,e);if(1!==n.length)throw new Error("tensor1d() requires values to be a flat/TypedArray");return vt(t,null,n,e)}function Sr(t,e,n){if(a(t),null!=e&&2!==e.length)throw new Error("tensor2d() requires shape to have two numbers");const s=ft(t,n);if(2!==s.length&&1!==s.length)throw new Error("tensor2d() requires values to be number[][] or flat/TypedArray");if(1===s.length&&null==e)throw new Error("tensor2d() requires shape to be provided when `values` are a flat/TypedArray");return vt(t,e,s,n)}const Ir=bt({topk_:function(t,e=1,n=!0){const s=gt(t,"x","topk");if(0===s.rank)throw new Error("topk() expects the input to be of rank 1 or higher");const r=s.shape[s.shape.length-1];if(e>r)throw new Error(`'k' passed to topk() must be <= the last dimension (${r}) but got `+e);const i={x:s},a={k:e,sorted:n},[o,l]=ct.runKernel("TopK",i,a);return{values:o,indices:l}}});const Nr=bt({truncatedNormal_:function(t,e=0,n=1,s,r){if(null!=s&&"bool"===s)throw new Error("Unsupported data type $ { dtype }");const i=new Us(e,n,s,!0,r),a=te(t,s);for(let t=0;t<a.values.length;t++)a.values[t]=i.nextValue();return a.toTensor()}});const Er=bt({unique_:function(t,e=0){const n=gt(t,"x","unique","string_or_numeric");r(n.rank>0,()=>"The input tensor must be at least 1D");const s={x:n},i={axis:e},[a,o]=ct.runKernel("Unique",s,i);return{values:a,indices:o}}});const Ar=bt({unsortedSegmentSum_:function(t,e,n){const s=gt(t,"x","unsortedSegmentSum"),i=gt(e,"segmentIds","unsortedSegmentSum","int32");r(h(n),()=>"numSegments must be of dtype int");const a={x:s,segmentIds:i},o={numSegments:n};return ct.runKernel("UnsortedSegmentSum",a,o)}});const Tr=bt({unstack_:function(t,e=0){const n=gt(t,"x","unstack","string_or_numeric");r(e>=-n.shape.length&&e<n.shape.length,()=>`Axis = ${e} is not in [-${n.shape.length}, ${n.shape.length})`);const s={value:n},i={axis:e};return ct.runKernel("Unpack",s,i)}});const Dr=bt({norm_:function(t,e="euclidean",n=null,s=!1){const r=function t(e,n,s=null){if(0===e.rank)return Ee(e);if(1!==e.rank&&null===s)return t(qe(e,[-1]),n,s);if(1===e.rank||"number"==typeof s||Array.isArray(s)&&1===s.length){if(1===n)return ss(Ee(e),s);if(n===1/0)return es(Ee(e),s);if(n===-1/0)return gs(Ee(e),s);if("euclidean"===n||2===n)return mr(ss(Ds(Ee(e),Qs(2,"int32")),s));throw new Error("Error in norm: invalid ord value: "+n)}if(Array.isArray(s)&&2===s.length){if(1===n)return es(ss(Ee(e),s[0]),s[1]-1);if(n===1/0)return es(ss(Ee(e),s[1]),s[0]);if(n===-1/0)return gs(ss(Ee(e),s[1]),s[0]);if("fro"===n||"euclidean"===n)return mr(ss(vs(e),s));throw new Error("Error in norm: invalid ord value: "+n)}throw new Error("Error in norm: invalid axis: "+s)}(t=gt(t,"x","norm"),e,n);let i=r.shape;if(s){const e=p(n,t.shape);i=is(r.shape,e)}return qe(r,i)}});const zr=bt({dropout_:function(t,e,n,s){const i=gt(t,"x","dropout");if(r("float32"===i.dtype,()=>`x has to be a floating point tensor since it's going to be scaled, but got a ${i.dtype} tensor instead.`),r(e>=0&&e<1,()=>`rate must be a float in the range [0, 1), but got ${e}.`),0===e)return t instanceof J?i.clone():i;const a=function(t,e){if(null==e)return t.shape.slice();if(u(t.shape,e))return e;if(t.shape.length===e.length){const n=[];for(let s=0;s<t.shape.length;s++)null==e[s]&&null!=t.shape[s]?n.push(t.shape[s]):n.push(e[s]);return n}return e}(i,n),o=1-e,l=Ie($n(xe(qs(a,0,1,"float32",s),o)),o);return Ne(i,l)}});const Cr=bt({conv2DBackpropFilter_:function(t,e,n,s,i,a="NHWC",o){let l=t;3===t.rank&&(l=qe(t,[1,t.shape[0],t.shape[1],t.shape[2]]));let u=e;3===u.rank&&(u=qe(e,[1,e.shape[0],e.shape[1],e.shape[2]])),r(4===l.rank,()=>"Error in conv2dDerFilter: input must be rank 4, but got shape "+l.shape+"."),r(4===u.rank,()=>"Error in conv2dDerFilter: dy must be rank 4, but got shape "+u.shape+"."),r(4===n.length,()=>"Error in conv2dDerFilter: filterShape must be length 4, but got "+n+".");const c="NHWC"===a?l.shape[3]:l.shape[1],p="NHWC"===a?u.shape[3]:u.shape[1];r(c===n[2],()=>`Error in conv2dDerFilter: depth of input ${c}) must match input depth in filter (${n[2]}.`),r(p===n[3],()=>`Error in conv2dDerFilter: depth of dy (${p}) must match output depth for filter (${n[3]}).`),null!=o&&r(h(i),()=>`Error in conv2dDerFilter: pad must be an integer when using, dimRoundingMode ${o} but got pad ${i}.`);const d={x:l,dy:u},f={strides:s,pad:i,dataFormat:a,dimRoundingMode:o,filterShape:n};return ct.runKernel("Conv2DBackpropFilter",d,f)}});function Fr(t,e,n){if(null==n||"linear"===n)return t;if("relu"===n)return Ne(t,wr(e));throw new Error(`Cannot compute gradient for fused activation ${n}.`)}function Rr(t,e){let n=e;const s=xn(t.shape,e.shape);return s.length>0&&(n=ss(n,s)),qe(n,t.shape)}function Lr(t,e,n,s){if("linear"===e)return t;if("relu"===e)return Gs(t);if("elu"===e)return Dn(t);if("relu6"===e)return Js(t);if("prelu"===e)return zs(t,n);if("leakyrelu"===e)return Kn(t,s);throw new Error(`Unknown fused activation ${e}.`)}const Mr=(t,e)=>!(t>0)||"linear"===e;const _r=bt({fusedConv2d_:function({x:t,filter:e,strides:n,pad:s,dataFormat:i="NHWC",dilations:a=[1,1],dimRoundingMode:o,bias:l,activation:u="linear",preluActivationWeights:c,leakyreluAlpha:p}){if(u=u||"linear",!1===Mr(ct.state.gradientDepth,u)){let r=hn(t,e,n,s,i,a,o);return null!=l&&(r=xe(r,l)),Lr(r,u,c,p)}const d=gt(t,"x","conv2d"),f=gt(e,"filter","conv2d");let m=d,g=!1;3===d.rank&&(g=!0,m=qe(d,[1,d.shape[0],d.shape[1],d.shape[2]])),r(4===m.rank,()=>"Error in fused conv2d: input must be rank 4, but got rank "+m.rank+"."),r(4===f.rank,()=>"Error in fused conv2d: filter must be rank 4, but got rank "+f.rank+"."),null!=o&&r(h(s),()=>`Error in fused conv2d: pad must be an integer when using, dimRoundingMode ${o} but got pad ${s}.`),r(m.shape[3]===f.shape[2],()=>`Error in conv2d: depth of input (${m.shape[3]}) must match input depth for filter ${f.shape[2]}.`),r(je(n,a),()=>`Error in conv2D: Either strides or dilations must be 1. Got strides ${n} and dilations '${a}'`),r("NHWC"===i,()=>`Error in conv2d: got dataFormat of ${i} but only NHWC is currently supported.`);const y=Oe(m.shape,f.shape,n,a,s,o);let b,w;null!=l&&(b=gt(l,"bias","fused conv2d"),[b]=rt(b,d),Sn(y.outShape,b.shape)),null!=c&&(w=gt(c,"prelu weights","fused conv2d"));const v=(t,e)=>{const[i,o,l,h]=e,c=Fr(t,l,u);r(We(a),()=>`Error in gradient of fused conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '${a}'`);const p=[pn(o.shape,c,i,n,s),Cr(o,c,i.shape,n,s)];if(null!=h){const t=Rr(h,c);p.push(t)}return p},k={x:m,filter:f,bias:b,preluActivationWeights:w},x={strides:n,pad:s,dataFormat:i,dilations:a,dimRoundingMode:o,activation:u,leakyreluAlpha:p};if(null==l){return Xn((t,e,n)=>{let s=ct.runKernel("FusedConv2D",k,x);return n([e,t,s]),g&&(s=qe(s,[s.shape[1],s.shape[2],s.shape[3]])),{value:s,gradFunc:v}})(m,f)}return Xn((t,e,n,s)=>{let r=ct.runKernel("FusedConv2D",k,x);return s([e,t,r,n]),g&&(r=qe(r,[r.shape[1],r.shape[2],r.shape[3]])),{value:r,gradFunc:v}})(m,f,b)}});const $r=bt({depthwiseConv2dNativeBackpropFilter_:function(t,e,n,s,r,i=[1,1],a){let o=t;3===t.rank&&(o=qe(t,[1,t.shape[0],t.shape[1],t.shape[2]]));let l=e;3===l.rank&&(l=qe(e,[1,e.shape[0],e.shape[1],e.shape[2]]));const u={x:o,dy:l},h={strides:s,pad:r,dimRoundingMode:a,dilations:i,filterShape:n};return ct.runKernel("DepthwiseConv2dNativeBackpropFilter",u,h)}});const Or=bt({depthwiseConv2dNativeBackpropInput_:function(t,e,n,s,r,i=[1,1],a){let o=e,l=!1;3===e.rank&&(l=!0,o=qe(e,[1,e.shape[0],e.shape[1],e.shape[2]]));const u={dy:o,filter:n},h={strides:s,pad:r,dimRoundingMode:a,dilations:i,inputShape:t},c=ct.runKernel("DepthwiseConv2dNativeBackpropInput",u,h);return l?qe(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});const Br=bt({fusedMatMul_:function({a:t,b:e,transposeA:n=!1,transposeB:s=!1,bias:i,activation:a="linear",preluActivationWeights:o,leakyreluAlpha:h}){if(!1===Mr(ct.state.gradientDepth,a)){let r=he(t,e,n,s);return null!=i&&(r=xe(r,i)),Lr(r,a,o,h)}let c=gt(t,"a","fused matMul"),p=gt(e,"b","fused matMul");[c,p]=rt(c,p);const d=n?c.shape[c.rank-2]:c.shape[c.rank-1],f=s?p.shape[p.rank-1]:p.shape[p.rank-2],m=n?c.shape[c.rank-1]:c.shape[c.rank-2],g=s?p.shape[p.rank-2]:p.shape[p.rank-1],y=c.shape.slice(0,-2),b=p.shape.slice(0,-2),w=l(y),v=l(b);r(c.rank>=2&&p.rank>=2&&c.rank===p.rank,()=>`Error in fused matMul: inputs must have the same rank of at least 2, got ranks ${c.rank} and ${p.rank}.`),r(u(y,b),()=>`Error in fused matMul: outer dimensions (${y}) and (${b}) of Tensors with shapes ${c.shape} and `+p.shape+" must match."),r(d===f,()=>`Error in fused matMul: inner shapes (${d}) and (${f}) of Tensors with shapes ${c.shape} and ${p.shape} and transposeA=${n} and transposeB=${s} must match.`);const k=c.shape.slice(0,-2).concat([m,g]),x=qe(c,n?[w,d,m]:[w,m,d]),S=qe(p,s?[v,g,f]:[v,f,g]);let I,N;null!=i&&(I=gt(i,"bias","fused matMul"),[I]=rt(I,c),Sn(k,I.shape)),null!=o&&(N=gt(o,"prelu weights","fused matMul"));const E=(t,e)=>{const[r,o,l,u]=e,h=Fr(qe(t,l.shape),l,a);let c,p;if(n||s?!n&&s?(c=he(h,o,!1,!1),p=he(h,r,!0,!1)):n&&!s?(c=he(o,h,!1,!0),p=he(r,h,!1,!1)):(c=he(o,h,!0,!0),p=he(h,r,!0,!0)):(c=he(h,o,!1,!0),p=he(r,h,!0,!1)),null!=i){return[c,p,Rr(u,h)]}return[c,p]},A={a:x,b:S,bias:I,preluActivationWeights:N},T={transposeA:n,transposeB:s,activation:a,leakyreluAlpha:h};if(null==i){return Xn((t,e,n)=>{const s=ct.runKernel("_FusedMatMul",A,T);return n([t,e,s]),{value:qe(s,k),gradFunc:E}})(x,S)}return Xn((t,e,n,s)=>{const r=ct.runKernel("_FusedMatMul",A,T);return s([t,e,r,n]),{value:qe(r,k),gradFunc:E}})(x,S,I)}});const Pr=bt({resizeBilinear_:function(t,e,n=!1,s=!1){const i=gt(t,"images","resizeBilinear");r(3===i.rank||4===i.rank,()=>`Error in resizeBilinear: x must be rank 3 or 4, but got rank ${i.rank}.`),r(2===e.length,()=>"Error in resizeBilinear: new shape must 2D, but got shape "+e+"."),r(!1===s||!1===n,()=>"Error in resizeBilinear: If halfPixelCenters is true, alignCorners must be false.");let a=i,o=!1;3===i.rank&&(o=!0,a=qe(i,[1,i.shape[0],i.shape[1],i.shape[2]]));const l={images:a},u={alignCorners:n,halfPixelCenters:s,size:e},h=ct.runKernel("ResizeBilinear",l,u);return o?qe(h,[h.shape[1],h.shape[2],h.shape[3]]):h}});const Ur=bt({resizeNearestNeighbor_:function(t,e,n=!1,s=!1){const i=gt(t,"images","resizeNearestNeighbor");r(3===i.rank||4===i.rank,()=>`Error in resizeNearestNeighbor: x must be rank 3 or 4, but got rank ${i.rank}.`),r(2===e.length,()=>"Error in resizeNearestNeighbor: new shape must 2D, but got shape "+e+"."),r("float32"===i.dtype||"int32"===i.dtype,()=>"`images` must have `int32` or `float32` as dtype"),r(!1===s||!1===n,()=>"Error in resizeNearestNeighbor: If halfPixelCenters is true, alignCorners must be false.");let a=i,o=!1;3===i.rank&&(o=!0,a=qe(i,[1,i.shape[0],i.shape[1],i.shape[2]]));const l={images:a},u={alignCorners:n,halfPixelCenters:s,size:e},h=ct.runKernel("ResizeNearestNeighbor",l,u);return o?qe(h,[h.shape[1],h.shape[2],h.shape[3]]):h}});function Wr(t,e=!1){return ct.tidy(()=>{r(2===t.shape.length,()=>`qr2d() requires a 2D Tensor, but got a ${t.shape.length}D Tensor.`);const n=t.shape[0],s=t.shape[1];let i=Mn(n),a=ne(t);const o=Sr([[1]],[1,1]);let l=ne(o);const u=n>=s?s:n;for(let t=0;t<u;++t){const e=a,r=l,u=i;[l,a,i]=ct.tidy(()=>{const e=Je(a,[t,t],[n-t,1]),r=Dr(e),u=Je(a,[t,t],[1,1]),h=Nn(Bn(u,0),Sr([[-1]]),Sr([[1]])),c=ns(u,Ne(h,r)),p=Ie(e,c);l=1===p.shape[0]?ne(o):He([o,Je(p,[1,0],[p.shape[0]-1,p.shape[1]])],0);const d=Yn(Ie(he(h,c),r)),f=Je(a,[t,0],[n-t,s]),m=Ne(d,l),g=pe(l);if(0===t)a=ns(f,he(m,he(g,f)));else{const e=ns(f,he(m,he(g,f)));a=He([Je(a,[0,0],[t,s]),e],0)}const y=pe(m),b=Je(i,[0,t],[n,i.shape[1]-t]);if(0===t)i=ns(b,he(he(b,l),y));else{const e=ns(b,he(he(b,l),y));i=He([Je(i,[0,0],[n,t]),e],1)}return[l,a,i]}),we([e,r,u])}return!e&&n>s&&(i=Je(i,[0,0],[n,s]),a=Je(a,[0,0],[s,s])),[i,a]})}const jr={bandPart:bt({bandPart_:function(t,e,n){r(e%1==0,()=>`bandPart(): numLower must be an integer, got ${e}.`),r(n%1==0,()=>`bandPart(): numUpper must be an integer, got ${n}.`);const s=gt(t,"a","bandPart");r(s.rank>=2,()=>`bandPart(): Rank must be at least 2, got ${s.rank}.`);const i=s.shape,[a,o]=s.shape.slice(-2);if(!(e<=a))throw new Error(`bandPart(): numLower (${e}) must not be greater than the number of rows (${a}).`);if(!(n<=o))throw new Error(`bandPart(): numUpper (${n}) must not be greater than the number of columns (${o}).`);e<0&&(e=a),n<0&&(n=o);const l=qe(Ks(0,a,1,"int32"),[-1,1]),u=Ks(0,o,1,"int32"),h=ns(l,u),c=ls(Hn(h,Qs(+e,"int32")),Pn(h,Qs(-n,"int32"))),p=Ss([a,o],s.dtype);return qe(br(Tr(qe(s,[-1,a,o])).map(t=>Nn(c,t,p))),i)}}),gramSchmidt:bt({gramSchmidt_:function(t){let e;if(Array.isArray(t)){e=!1,r(null!=t&&t.length>0,()=>"Gram-Schmidt process: input must not be null, undefined, or empty");const n=t[0].shape[0];for(let e=1;e<t.length;++e)r(t[e].shape[0]===n,()=>`Gram-Schmidt: Non-unique lengths found in the input vectors: (${t[e].shape[0]} vs. ${n})`)}else e=!0,t=dr(t,t.shape[0],0).map(t=>yr(t,[0]));r(t.length<=t[0].shape[0],()=>`Gram-Schmidt: Number of vectors (${t.length}) exceeds number of dimensions (${t[0].shape[0]}).`);const n=[],s=t;for(let e=0;e<t.length;++e)n.push(ct.tidy(()=>{let t=s[e];if(e>0)for(let s=0;s<e;++s){const e=Ne(ss(Ne(n[s],t)),n[s]);t=ns(t,e)}return Ie(t,Dr(t,"euclidean"))}));return e?br(n,0):n}}),qr:bt({qr_:function(t,e=!1){if(r(t.rank>=2,()=>"qr() requires input tensor to have a rank >= 2, but got rank "+t.rank),2===t.rank)return Wr(t,e);{const n=t.shape.slice(0,t.shape.length-2).reduce((t,e)=>t*e),s=Tr(qe(t,[n,t.shape[t.shape.length-2],t.shape[t.shape.length-1]]),0),r=[],i=[];s.forEach(t=>{const[n,s]=Wr(t,e);r.push(n),i.push(s)});return[qe(br(r,0),t.shape),qe(br(i,0),t.shape)]}}})};class qr extends fe{minimize(t,e=!1,n){const{value:s,grads:r}=this.computeGradients(t,n);if(null!=n){const t=n.map(t=>({name:t.name,tensor:r[t.name]}));this.applyGradients(t)}else this.applyGradients(r);return we(r),e?s:(s.dispose(),null)}get iterations(){return null==this.iterations_&&(this.iterations_=0),this.iterations_}incrementIterations(){this.iterations_=this.iterations+1}computeGradients(t,e){return function(t,e){r(y(t),()=>"The f passed in variableGrads(f) must be a function"),r(null==e||Array.isArray(e)&&e.every(t=>t instanceof X),()=>"The varList passed in variableGrads(f, varList) must be an array of variables");const n=null!=e;if(!n){e=[];for(const t in ct.registeredVariables)e.push(ct.registeredVariables[t])}const s=n?e.filter(t=>!t.trainable):null,i=e.length;r((e=e.filter(t=>t.trainable)).length>0,()=>`variableGrads() expects at least one of the input variables to be trainable, but none of the ${i} variables is trainable.`);const{value:a,grads:o}=ct.gradients(t,e,null,!0);r(o.some(t=>null!=t),()=>"Cannot find a connection between any variable and the result of the loss function y=f(x). Please make sure the operations that use variables are inside the function f passed to minimize()."),r(0===a.rank,()=>`The f passed in variableGrads(f) must return a scalar, but it returned a rank-${a.rank} tensor`);const l={};return e.forEach((t,e)=>{null!=o[e]&&(l[t.name]=o[e])}),null!=s&&s.forEach(t=>l[t.name]=null),{value:a,grads:l}}(t,e)}dispose(){null!=this.iterations_&&we(this.iterations_)}async saveIterations(){return null==this.iterations_&&(this.iterations_=0),{name:"iter",tensor:Qs(this.iterations_,"int32")}}async getWeights(){throw new Error("getWeights() is not implemented for this optimizer yet.")}async setWeights(t){throw new Error("setWeights() is not implemented for this optimizer class "+this.getClassName())}async extractIterations(t){return this.iterations_=(await t[0].tensor.data())[0],t.slice(1)}}Object.defineProperty(qr,Symbol.hasInstance,{value:t=>null!=t.minimize&&null!=t.computeGradients&&null!=t.applyGradients});class Kr extends qr{constructor(t,e,n=null){super(),this.learningRate=t,this.rho=e,this.epsilon=n,this.accumulatedGrads=[],this.accumulatedUpdates=[],null==n&&(this.epsilon=ct.backend.epsilon())}applyGradients(t){(Array.isArray(t)?t.map(t=>t.name):Object.keys(t)).forEach((e,n)=>{const s=ct.registeredVariables[e];null==this.accumulatedGrads[n]&&(this.accumulatedGrads[n]={originalName:e+"/accum_grad",variable:be(()=>En(s).variable(!1))}),null==this.accumulatedUpdates[n]&&(this.accumulatedUpdates[n]={originalName:e+"/accum_var",variable:be(()=>En(s).variable(!1))});const r=Array.isArray(t)?t[n].tensor:t[e];if(null==r)return;const i=this.accumulatedGrads[n].variable,a=this.accumulatedUpdates[n].variable;be(()=>{const t=xe(Ne(i,this.rho),Ne(vs(r),1-this.rho)),e=Ne(Ie(mr(xe(a,this.epsilon)),mr(xe(i,this.epsilon))),r),n=xe(Ne(a,this.rho),Ne(vs(e),1-this.rho));i.assign(t),a.assign(n);const o=xe(Ne(e,-this.learningRate),s);s.assign(o)})}),this.incrementIterations()}dispose(){null!=this.accumulatedUpdates&&(we(this.accumulatedGrads.map(t=>t.variable)),we(this.accumulatedUpdates.map(t=>t.variable)))}async getWeights(){const t=[...this.accumulatedGrads,...this.accumulatedUpdates];return[await this.saveIterations()].concat(t.map(t=>({name:t.originalName,tensor:t.variable})))}async setWeights(t){const e=(t=await this.extractIterations(t)).length/2;this.accumulatedGrads=t.slice(0,e).map(t=>({originalName:t.name,variable:t.tensor.variable(!1)})),this.accumulatedUpdates=t.slice(e,2*e).map(t=>({originalName:t.name,variable:t.tensor.variable(!1)}))}getConfig(){return{learningRate:this.learningRate,rho:this.rho,epsilon:this.epsilon}}static fromConfig(t,e){return new t(e.learningRate,e.rho,e.epsilon)}}Kr.className="Adadelta",ge(Kr);class Vr extends qr{constructor(t,e=.1){super(),this.learningRate=t,this.initialAccumulatorValue=e,this.accumulatedGrads=[]}applyGradients(t){(Array.isArray(t)?t.map(t=>t.name):Object.keys(t)).forEach((e,n)=>{const s=ct.registeredVariables[e];if(null==this.accumulatedGrads[n]){const t=!1;this.accumulatedGrads[n]={originalName:e+"/accumulator",variable:be(()=>_n(s.shape,this.initialAccumulatorValue).variable(t))}}const r=Array.isArray(t)?t[n].tensor:t[e];if(null==r)return;const i=this.accumulatedGrads[n].variable;be(()=>{const t=xe(i,vs(r));i.assign(t);const e=xe(Ne(Ie(r,mr(xe(t,ct.backend.epsilon()))),-this.learningRate),s);s.assign(e)})}),this.incrementIterations()}dispose(){null!=this.accumulatedGrads&&we(this.accumulatedGrads.map(t=>t.variable))}async getWeights(){return[await this.saveIterations()].concat(this.accumulatedGrads.map(t=>({name:t.originalName,tensor:t.variable})))}async setWeights(t){t=await this.extractIterations(t);this.accumulatedGrads=t.map(t=>({originalName:t.name,variable:t.tensor.variable(!1)}))}getConfig(){return{learningRate:this.learningRate,initialAccumulatorValue:this.initialAccumulatorValue}}static fromConfig(t,e){return new t(e.learningRate,e.initialAccumulatorValue)}}Vr.className="Adagrad",ge(Vr);class Hr extends qr{constructor(t,e,n,s=null){super(),this.learningRate=t,this.beta1=e,this.beta2=n,this.epsilon=s,this.accumulatedFirstMoment=[],this.accumulatedSecondMoment=[],be(()=>{this.accBeta1=Qs(e).variable(),this.accBeta2=Qs(n).variable()}),null==s&&(this.epsilon=ct.backend.epsilon())}applyGradients(t){const e=Array.isArray(t)?t.map(t=>t.name):Object.keys(t);be(()=>{const n=ns(1,this.accBeta1),s=ns(1,this.accBeta2);e.forEach((e,r)=>{const i=ct.registeredVariables[e];null==this.accumulatedFirstMoment[r]&&(this.accumulatedFirstMoment[r]={originalName:e+"/m",variable:be(()=>En(i).variable(!1))}),null==this.accumulatedSecondMoment[r]&&(this.accumulatedSecondMoment[r]={originalName:e+"/v",variable:be(()=>En(i).variable(!1))});const a=Array.isArray(t)?t[r].tensor:t[e];if(null==a)return;const o=this.accumulatedFirstMoment[r].variable,l=this.accumulatedSecondMoment[r].variable,u=xe(Ne(o,this.beta1),Ne(a,1-this.beta1)),h=xe(Ne(l,this.beta2),Ne(vs(a),1-this.beta2)),c=Ie(u,n),p=Ie(h,s);o.assign(u),l.assign(h);const d=xe(Ne(Ie(c,xe(mr(p),this.epsilon)),-this.learningRate),i);i.assign(d)}),this.accBeta1.assign(Ne(this.accBeta1,this.beta1)),this.accBeta2.assign(Ne(this.accBeta2,this.beta2))}),this.incrementIterations()}dispose(){this.accBeta1.dispose(),this.accBeta2.dispose(),null!=this.accumulatedFirstMoment&&we(this.accumulatedFirstMoment.map(t=>t.variable)),null!=this.accumulatedSecondMoment&&we(this.accumulatedSecondMoment.map(t=>t.variable))}async getWeights(){const t=[...this.accumulatedFirstMoment,...this.accumulatedSecondMoment];return[await this.saveIterations()].concat(t.map(t=>({name:t.originalName,tensor:t.variable})))}async setWeights(t){t=await this.extractIterations(t),be(()=>{this.accBeta1.assign(Ds(this.beta1,this.iterations_+1)),this.accBeta2.assign(Ds(this.beta2,this.iterations_+1))});const e=t.length/2;this.accumulatedFirstMoment=t.slice(0,e).map(t=>({originalName:t.name,variable:t.tensor.variable(!1)})),this.accumulatedSecondMoment=t.slice(e,2*e).map(t=>({originalName:t.name,variable:t.tensor.variable(!1)}))}getConfig(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon}}static fromConfig(t,e){return new t(e.learningRate,e.beta1,e.beta2,e.epsilon)}}Hr.className="Adam",ge(Hr);class Gr extends qr{constructor(t,e,n,s=null,r=0){super(),this.learningRate=t,this.beta1=e,this.beta2=n,this.epsilon=s,this.decay=r,this.accumulatedFirstMoment=[],this.accumulatedWeightedInfNorm=[],be(()=>{this.iteration=Qs(0).variable(),this.accBeta1=Qs(e).variable()}),null==s&&(this.epsilon=ct.backend.epsilon())}applyGradients(t){const e=Array.isArray(t)?t.map(t=>t.name):Object.keys(t);be(()=>{const n=ns(1,this.accBeta1),s=Ie(-this.learningRate,xe(Ne(this.iteration,this.decay),1));e.forEach((e,r)=>{const i=ct.registeredVariables[e];null==this.accumulatedFirstMoment[r]&&(this.accumulatedFirstMoment[r]={originalName:e+"/m",variable:En(i).variable(!1)}),null==this.accumulatedWeightedInfNorm[r]&&(this.accumulatedWeightedInfNorm[r]={originalName:e+"/v",variable:En(i).variable(!1)});const a=Array.isArray(t)?t[r].tensor:t[e];if(null==a)return;const o=this.accumulatedFirstMoment[r].variable,l=this.accumulatedWeightedInfNorm[r].variable,u=xe(Ne(o,this.beta1),Ne(a,1-this.beta1)),h=Ne(l,this.beta2),c=Ee(a),p=fs(h,c);o.assign(u),l.assign(p);const d=xe(Ne(Ie(s,n),Ie(u,xe(p,this.epsilon))),i);i.assign(d)}),this.iteration.assign(xe(this.iteration,1)),this.accBeta1.assign(Ne(this.accBeta1,this.beta1))}),this.incrementIterations()}dispose(){this.accBeta1.dispose(),this.iteration.dispose(),null!=this.accumulatedFirstMoment&&we(this.accumulatedFirstMoment.map(t=>t.variable)),null!=this.accumulatedWeightedInfNorm&&we(this.accumulatedWeightedInfNorm.map(t=>t.variable))}async getWeights(){throw new Error("getWeights() is not implemented for Adamax yet.")}async setWeights(t){throw new Error("setWeights() is not implemented for Adamax yet.")}getConfig(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon,decay:this.decay}}static fromConfig(t,e){return new t(e.learningRate,e.beta1,e.beta2,e.epsilon,e.decay)}}Gr.className="Adamax",ge(Gr);class Jr extends qr{constructor(t){super(),this.learningRate=t,this.setLearningRate(t)}applyGradients(t){(Array.isArray(t)?t.map(t=>t.name):Object.keys(t)).forEach((e,n)=>{const s=Array.isArray(t)?t[n].tensor:t[e];if(null==s)return;const r=ct.registeredVariables[e];be(()=>{const t=xe(Ne(this.c,s),r);r.assign(t)})}),this.incrementIterations()}setLearningRate(t){this.learningRate=t,null!=this.c&&this.c.dispose(),this.c=ve(Qs(-t))}dispose(){this.c.dispose()}async getWeights(){return[await this.saveIterations()]}async setWeights(t){if(0!==(t=await this.extractIterations(t)).length)throw new Error("SGD optimizer does not have settable weights.")}getConfig(){return{learningRate:this.learningRate}}static fromConfig(t,e){return new t(e.learningRate)}}Jr.className="SGD",ge(Jr);class Zr extends Jr{constructor(t,e,n=!1){super(t),this.learningRate=t,this.momentum=e,this.useNesterov=n,this.accumulations=[],this.m=Qs(this.momentum)}applyGradients(t){(Array.isArray(t)?t.map(t=>t.name):Object.keys(t)).forEach((e,n)=>{const s=ct.registeredVariables[e];if(null==this.accumulations[n]){const t=!1;this.accumulations[n]={originalName:e+"/momentum",variable:be(()=>En(s).variable(t))}}const r=this.accumulations[n].variable,i=Array.isArray(t)?t[n].tensor:t[e];null!=i&&be(()=>{let t;const e=xe(Ne(this.m,r),i);t=this.useNesterov?xe(Ne(this.c,xe(i,Ne(e,this.m))),s):xe(Ne(this.c,e),s),r.assign(e),s.assign(t)})}),this.incrementIterations()}dispose(){this.m.dispose(),null!=this.accumulations&&we(this.accumulations.map(t=>t.variable))}setMomentum(t){this.momentum=t}async getWeights(){return[await this.saveIterations()].concat(this.accumulations.map(t=>({name:t.originalName,tensor:t.variable})))}async setWeights(t){t=await this.extractIterations(t);this.accumulations=t.map(t=>({originalName:t.name,variable:t.tensor.variable(!1)}))}getConfig(){return{learningRate:this.learningRate,momentum:this.momentum,useNesterov:this.useNesterov}}static fromConfig(t,e){return new t(e.learningRate,e.momentum,e.useNesterov)}}Zr.className="Momentum",ge(Zr);class Xr extends qr{constructor(t,e=.9,n=0,s=null,r=!1){if(super(),this.learningRate=t,this.decay=e,this.momentum=n,this.epsilon=s,this.accumulatedMeanSquares=[],this.accumulatedMoments=[],this.accumulatedMeanGrads=[],this.centered=r,null==s&&(this.epsilon=ct.backend.epsilon()),null==t)throw new Error("learningRate for RMSPropOptimizer must be defined.")}applyGradients(t){(Array.isArray(t)?t.map(t=>t.name):Object.keys(t)).forEach((e,n)=>{const s=ct.registeredVariables[e];null==this.accumulatedMeanSquares[n]&&(this.accumulatedMeanSquares[n]={originalName:e+"/rms",variable:be(()=>En(s).variable(!1))}),null==this.accumulatedMoments[n]&&(this.accumulatedMoments[n]={originalName:e+"/momentum",variable:be(()=>En(s).variable(!1))}),null==this.accumulatedMeanGrads[n]&&this.centered&&(this.accumulatedMeanGrads[n]={originalName:e+"/mg",variable:be(()=>En(s).variable(!1))});const r=Array.isArray(t)?t[n].tensor:t[e];if(null==r)return;const i=this.accumulatedMeanSquares[n].variable,a=this.accumulatedMoments[n].variable;be(()=>{const t=xe(Ne(i,this.decay),Ne(vs(r),1-this.decay));if(this.centered){const e=this.accumulatedMeanGrads[n].variable,o=xe(Ne(e,this.decay),Ne(r,1-this.decay)),l=Ie(Ne(r,this.learningRate),mr(ns(t,xe(vs(o),this.epsilon)))),u=xe(Ne(a,this.momentum),l);i.assign(t),e.assign(o),a.assign(u);const h=ns(s,u);s.assign(h)}else{const t=xe(Ne(i,this.decay),Ne(vs(r),1-this.decay)),e=xe(Ne(a,this.momentum),Ie(Ne(r,this.learningRate),mr(xe(t,this.epsilon))));i.assign(t),a.assign(e);const n=ns(s,e);s.assign(n)}})}),this.incrementIterations()}dispose(){null!=this.accumulatedMeanSquares&&we(this.accumulatedMeanSquares.map(t=>t.variable)),null!=this.accumulatedMeanGrads&&this.centered&&we(this.accumulatedMeanGrads.map(t=>t.variable)),null!=this.accumulatedMoments&&we(this.accumulatedMoments.map(t=>t.variable))}async getWeights(){const t=[...this.accumulatedMeanSquares,...this.accumulatedMoments];return this.centered&&t.push(...this.accumulatedMeanGrads),[await this.saveIterations()].concat(t.map(t=>({name:t.originalName,tensor:t.variable})))}async setWeights(t){t=await this.extractIterations(t);const e=this.centered?t.length/3:t.length/2;this.accumulatedMeanSquares=t.slice(0,e).map(t=>({originalName:t.name,variable:t.tensor.variable(!1)})),this.accumulatedMoments=t.slice(e,2*e).map(t=>({originalName:t.name,variable:t.tensor.variable(!1)})),this.centered&&(this.accumulatedMeanGrads=t.slice(2*e,3*e).map(t=>({originalName:t.name,variable:t.tensor.variable(!1)})))}getConfig(){return{learningRate:this.learningRate,decay:this.decay,momentum:this.momentum,epsilon:this.epsilon,centered:this.centered}}static fromConfig(t,e){return new t(e.learningRate,e.decay,e.momentum,e.epsilon,e.centered)}}Xr.className="RMSProp",ge(Xr);class Yr{static sgd(t){return new Jr(t)}static momentum(t,e,n=!1){return new Zr(t,e,n)}static rmsprop(t,e=.9,n=0,s=null,r=!1){return new Xr(t,e,n,s,r)}static adam(t=.001,e=.9,n=.999,s=null){return new Hr(t,e,n,s)}static adadelta(t=.001,e=.95,n=null){return new Kr(t,e,n)}static adamax(t=.002,e=.9,n=.999,s=null,r=0){return new Gr(t,e,n,s,r)}static adagrad(t,e=.1){return new Vr(t,e)}}const Qr={sgd:Yr.sgd,momentum:Yr.momentum,adadelta:Yr.adadelta,adagrad:Yr.adagrad,rmsprop:Yr.rmsprop,adamax:Yr.adamax,adam:Yr.adam},ti="undefined"!=typeof requestAnimationFrame?requestAnimationFrame:"undefined"!=typeof setImmediate?setImmediate:t=>t();function ei(){return new Promise(t=>ti(()=>t()))}var ni=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])};var si=Object.assign||function(t){for(var e,n=1,s=arguments.length;n<s;n++)for(var r in e=arguments[n])Object.prototype.hasOwnProperty.call(e,r)&&(t[r]=e[r]);return t};function ri(t,e,n,s){return new(n||(n=Promise))((function(r,i){function a(t){try{l(s.next(t))}catch(t){i(t)}}function o(t){try{l(s.throw(t))}catch(t){i(t)}}function l(t){t.done?r(t.value):new n((function(e){e(t.value)})).then(a,o)}l((s=s.apply(t,e||[])).next())}))}function ii(t,e){var n,s,r,i,a={label:0,sent:function(){if(1&r[0])throw r[1];return r[1]},trys:[],ops:[]};return i={next:o(0),throw:o(1),return:o(2)},"function"==typeof Symbol&&(i[Symbol.iterator]=function(){return this}),i;function o(i){return function(o){return function(i){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,s&&(r=s[2&i[0]?"return":i[0]?"throw":"next"])&&!(r=r.call(s,i[1])).done)return r;switch(s=0,r&&(i=[0,r.value]),i[0]){case 0:case 1:r=i;break;case 4:return a.label++,{value:i[1],done:!1};case 5:a.label++,s=i[1],i=[0];continue;case 7:i=a.ops.pop(),a.trys.pop();continue;default:if(!(r=a.trys,(r=r.length>0&&r[r.length-1])||6!==i[0]&&2!==i[0])){a=0;continue}if(3===i[0]&&(!r||i[1]>r[0]&&i[1]<r[3])){a.label=i[1];break}if(6===i[0]&&a.label<r[1]){a.label=r[1],r=i;break}if(r&&a.label<r[2]){a.label=r[2],a.ops.push(i);break}r[2]&&a.ops.pop(),a.trys.pop();continue}i=e.call(t,a)}catch(t){i=[6,t],s=0}finally{n=r=0}if(5&i[0])throw i[1];return{value:i[0]?i[1]:void 0,done:!0}}([i,o])}}}function ai(t){var e="function"==typeof Symbol&&t[Symbol.iterator],n=0;return e?e.call(t):{next:function(){return t&&n>=t.length&&(t=void 0),{value:t&&t[n++],done:!t}}}}function oi(t,e){var n="function"==typeof Symbol&&t[Symbol.iterator];if(!n)return t;var s,r,i=n.call(t),a=[];try{for(;(void 0===e||e-- >0)&&!(s=i.next()).done;)a.push(s.value)}catch(t){r={error:t}}finally{try{s&&!s.done&&(n=i.return)&&n.call(i)}finally{if(r)throw r.error}}return a}function li(){for(var t=[],e=0;e<arguments.length;e++)t=t.concat(oi(arguments[e]));return t}Z().prototype.abs=function(){return this.throwIfDisposed(),Ee(this)},Z().prototype.acos=function(){return this.throwIfDisposed(),Ae(this)},Z().prototype.acosh=function(){return this.throwIfDisposed(),Te(this)},Z().prototype.add=function(t){return this.throwIfDisposed(),xe(this,t)},Z().prototype.all=function(t,e){return this.throwIfDisposed(),De(this,t,e)},Z().prototype.any=function(t,e){return this.throwIfDisposed(),ze(this,t,e)},Z().prototype.argMax=function(t){return this.throwIfDisposed(),Ce(this,t)},Z().prototype.argMin=function(t){return this.throwIfDisposed(),Fe(this,t)},Z().prototype.asScalar=function(){return this.throwIfDisposed(),r(1===this.size,()=>"The array must have only 1 element."),qe(this,[])},Z().prototype.asType=function(t){return this.throwIfDisposed(),ee(this,t)},Z().prototype.as1D=function(){return this.throwIfDisposed(),qe(this,[this.size])},Z().prototype.as2D=function(t,e){return this.throwIfDisposed(),qe(this,[t,e])},Z().prototype.as3D=function(t,e,n){return this.throwIfDisposed(),qe(this,[t,e,n])},Z().prototype.as4D=function(t,e,n,s){return this.throwIfDisposed(),qe(this,[t,e,n,s])},Z().prototype.as5D=function(t,e,n,s,r){return this.throwIfDisposed(),qe(this,[t,e,n,s,r])},Z().prototype.asin=function(){return this.throwIfDisposed(),Re(this)},Z().prototype.asinh=function(){return this.throwIfDisposed(),Le(this)},Z().prototype.atan=function(){return this.throwIfDisposed(),Me(this)},Z().prototype.atan2=function(t){return this.throwIfDisposed(),_e(this,t)},Z().prototype.atanh=function(){return this.throwIfDisposed(),$e(this)},Z().prototype.avgPool=function(t,e,n,s){return this.throwIfDisposed(),Ke(this,t,e,n,s)},Z().prototype.batchToSpaceND=function(t,e){return this.throwIfDisposed(),Xe(this,t,e)},Z().prototype.batchNorm=function(t,e,n,s,r){return this.throwIfDisposed(),Ye(this,t,e,n,s,r)},Z().prototype.broadcastTo=function(t){return this.throwIfDisposed(),nn(this,t)},Z().prototype.cast=function(t){return this.throwIfDisposed(),ee(this,t)},Z().prototype.ceil=function(){return this.throwIfDisposed(),sn(this)},Z().prototype.clipByValue=function(t,e){return this.throwIfDisposed(),rn(this,t,e)},Z().prototype.concat=function(t,e){return this.throwIfDisposed(),t instanceof J&&(t=[t]),He([this,...t],e)},Z().prototype.conv1d=function(t,e,n,s,r,i){return this.throwIfDisposed(),cn(this,t,e,n,s,r,i)},Z().prototype.conv2dTranspose=function(t,e,n,s,r){return this.throwIfDisposed(),dn(this,t,e,n,s,r)},Z().prototype.conv2d=function(t,e,n,s,r,i){return this.throwIfDisposed(),hn(this,t,e,n,s,r,i)},Z().prototype.cos=function(){return this.throwIfDisposed(),gn(this)},Z().prototype.cosh=function(){return this.throwIfDisposed(),yn(this)},Z().prototype.cumsum=function(t,e,n){return this.throwIfDisposed(),bn(this,t,e,n)},Z().prototype.depthToSpace=function(t,e){return this.throwIfDisposed(),wn(this,t,e)},Z().prototype.depthwiseConv2d=function(t,e,n,s,r,i){return this.throwIfDisposed(),vn(this,t,e,n,s,r,i)},Z().prototype.dilation2d=function(t,e,n,s,r){return this.throwIfDisposed(),kn(this,t,e,n,s,r)},Z().prototype.divNoNan=function(t){return this.throwIfDisposed(),An(this,t)},Z().prototype.div=function(t){return this.throwIfDisposed(),Ie(this,t)},Z().prototype.dot=function(t){return this.throwIfDisposed(),Tn(this,t)},Z().prototype.elu=function(){return this.throwIfDisposed(),Dn(this)},Z().prototype.equal=function(t){return this.throwIfDisposed(),In(this,t)},Z().prototype.erf=function(){return this.throwIfDisposed(),zn(this)},Z().prototype.exp=function(){return this.throwIfDisposed(),Cn(this)},Z().prototype.expandDims=function(t){return this.throwIfDisposed(),Fn(this,t)},Z().prototype.expm1=function(){return this.throwIfDisposed(),Rn(this)},Z().prototype.fft=function(){return this.throwIfDisposed(),hr(this)},Z().prototype.flatten=function(){return this.throwIfDisposed(),qe(this,[this.size])},Z().prototype.floor=function(){return this.throwIfDisposed(),$n(this)},Z().prototype.floorDiv=function(t){return this.throwIfDisposed(),Se(this,t)},Z().prototype.gather=function(t,e){return this.throwIfDisposed(),On(this,t,e)},Z().prototype.greaterEqual=function(t){return this.throwIfDisposed(),Pn(this,t)},Z().prototype.greater=function(t){return this.throwIfDisposed(),Bn(this,t)},Z().prototype.ifft=function(){return this.throwIfDisposed(),cr(this)},Z().prototype.irfft=function(){return this.throwIfDisposed(),pr(this)},Z().prototype.isFinite=function(){return this.throwIfDisposed(),Wn(this)},Z().prototype.isInf=function(){return this.throwIfDisposed(),jn(this)},Z().prototype.isNaN=function(){return this.throwIfDisposed(),qn(this)},Z().prototype.leakyRelu=function(t){return this.throwIfDisposed(),Kn(this,t)},Z().prototype.lessEqual=function(t){return this.throwIfDisposed(),Hn(this,t)},Z().prototype.less=function(t){return this.throwIfDisposed(),Vn(this,t)},Z().prototype.localResponseNormalization=function(t,e,n,s){return this.throwIfDisposed(),Gn(this,t,e,n,s)},Z().prototype.logSigmoid=function(){return this.throwIfDisposed(),ts(this)},Z().prototype.logSoftmax=function(t){return this.throwIfDisposed(),rs(this,t)},Z().prototype.logSumExp=function(t,e){return this.throwIfDisposed(),os(this,t,e)},Z().prototype.log=function(){return this.throwIfDisposed(),Jn(this)},Z().prototype.log1p=function(){return this.throwIfDisposed(),Zn(this)},Z().prototype.logicalAnd=function(t){return this.throwIfDisposed(),ls(this,t)},Z().prototype.logicalNot=function(){return this.throwIfDisposed(),us(this)},Z().prototype.logicalOr=function(t){return this.throwIfDisposed(),hs(this,t)},Z().prototype.logicalXor=function(t){return this.throwIfDisposed(),cs(this,t)},Z().prototype.matMul=function(t,e,n){return this.throwIfDisposed(),he(this,t,e,n)},Z().prototype.maxPool=function(t,e,n,s){return this.throwIfDisposed(),ps(this,t,e,n,s)},Z().prototype.max=function(t,e){return this.throwIfDisposed(),es(this,t,e)},Z().prototype.maximum=function(t){return this.throwIfDisposed(),fs(this,t)},Z().prototype.mean=function(t,e){return this.throwIfDisposed(),ms(this,t,e)},Z().prototype.min=function(t,e){return this.throwIfDisposed(),gs(this,t,e)},Z().prototype.minimum=function(t){return this.throwIfDisposed(),ys(this,t)},Z().prototype.mirrorPad=function(t,e){return this.throwIfDisposed(),bs(this,t,e)},Z().prototype.mod=function(t){return this.throwIfDisposed(),ws(this,t)},Z().prototype.mul=function(t){return this.throwIfDisposed(),Ne(this,t)},Z().prototype.neg=function(){return this.throwIfDisposed(),Yn(this)},Z().prototype.norm=function(t,e,n){return this.throwIfDisposed(),Dr(this,t,e,n)},Z().prototype.notEqual=function(t){return this.throwIfDisposed(),xs(this,t)},Z().prototype.oneHot=function(t,e=1,n=0){return this.throwIfDisposed(),ce(this,t,e,n)},Z().prototype.onesLike=function(){return this.throwIfDisposed(),Ns(this)},Z().prototype.pad=function(t,e){return this.throwIfDisposed(),Es(this,t,e)},Z().prototype.pool=function(t,e,n,s,r){return this.throwIfDisposed(),Ts(this,t,e,n,s,r)},Z().prototype.pow=function(t){return this.throwIfDisposed(),Ds(this,t)},Z().prototype.prelu=function(t){return this.throwIfDisposed(),zs(this,t)},Z().prototype.prod=function(t,e){return this.throwIfDisposed(),Cs(this,t,e)},Z().prototype.reciprocal=function(){return this.throwIfDisposed(),Hs(this)},Z().prototype.relu=function(){return this.throwIfDisposed(),Gs(this)},Z().prototype.relu6=function(){return this.throwIfDisposed(),Js(this)},Z().prototype.reshapeAs=function(t){return this.throwIfDisposed(),qe(this,t.shape)},Z().prototype.reshape=function(t){return this.throwIfDisposed(),qe(this,t)},Z().prototype.resizeBilinear=function(t,e,n){return this.throwIfDisposed(),Pr(this,t,e,n)},Z().prototype.resizeNearestNeighbor=function(t,e,n){return this.throwIfDisposed(),Ur(this,t,e,n)},Z().prototype.reverse=function(t){return this.throwIfDisposed(),Zs(this,t)},Z().prototype.rfft=function(){return this.throwIfDisposed(),fr(this)},Z().prototype.round=function(){return this.throwIfDisposed(),Xs(this)},Z().prototype.rsqrt=function(){return this.throwIfDisposed(),Ys(this)},Z().prototype.selu=function(){return this.throwIfDisposed(),tr(this)},Z().prototype.separableConv2d=function(t,e,n,s,r,i){return this.throwIfDisposed(),er(this,t,e,n,s,r,i)},Z().prototype.sigmoid=function(){return this.throwIfDisposed(),Ge(this)},Z().prototype.sign=function(){return this.throwIfDisposed(),nr(this)},Z().prototype.sin=function(){return this.throwIfDisposed(),sr(this)},Z().prototype.sinh=function(){return this.throwIfDisposed(),rr(this)},Z().prototype.slice=function(t,e){return this.throwIfDisposed(),Je(this,t,e)},Z().prototype.softmax=function(t){return this.throwIfDisposed(),ur(this,t)},Z().prototype.softplus=function(){return this.throwIfDisposed(),Qn(this)},Z().prototype.spaceToBatchND=function(t,e){return this.throwIfDisposed(),As(this,t,e)},Z().prototype.split=function(t,e){return this.throwIfDisposed(),dr(this,t,e)},Z().prototype.sqrt=function(){return this.throwIfDisposed(),mr(this)},Z().prototype.square=function(){return this.throwIfDisposed(),vs(this)},Z().prototype.squaredDifference=function(t){return this.throwIfDisposed(),gr(this,t)},Z().prototype.squeeze=function(t){return this.throwIfDisposed(),yr(this,t)},Z().prototype.stack=function(t,e){this.throwIfDisposed();const n=t instanceof J?[this,t]:[this,...t];return br(n,e)},Z().prototype.step=function(t){return this.throwIfDisposed(),wr(this,t)},Z().prototype.stridedSlice=function(t,e,n,s,r,i,a,o){return this.throwIfDisposed(),vr(this,t,e,n,s,r,i,a,o)},Z().prototype.sub=function(t){return this.throwIfDisposed(),ns(this,t)},Z().prototype.sum=function(t,e){return this.throwIfDisposed(),ss(this,t,e)},Z().prototype.tan=function(){return this.throwIfDisposed(),kr(this)},Z().prototype.tanh=function(){return this.throwIfDisposed(),Ze(this)},Z().prototype.tile=function(t){return this.throwIfDisposed(),Ln(this,t)},Z().prototype.toBool=function(){return this.throwIfDisposed(),ee(this,"bool")},Z().prototype.toFloat=function(){return this.throwIfDisposed(),ee(this,"float32")},Z().prototype.toInt=function(){return this.throwIfDisposed(),ee(this,"int32")},Z().prototype.topk=function(t,e){return this.throwIfDisposed(),Ir(this,t,e)},Z().prototype.transpose=function(t){return this.throwIfDisposed(),pe(this,t)},Z().prototype.unique=function(t){return this.throwIfDisposed(),Er(this,t)},Z().prototype.unsortedSegmentSum=function(t,e){return this.throwIfDisposed(),Ar(this,t,e)},Z().prototype.unstack=function(t){return this.throwIfDisposed(),Tr(this,t)},Z().prototype.where=function(t,e){return this.throwIfDisposed(),Nn(t,this,e)},Z().prototype.zerosLike=function(){return this.throwIfDisposed(),En(this)};const ui={kernelName:"Abs",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ne(t,wr(ee(n,"float32"),-1))}}},hi={kernelName:"Acos",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>{const e=vs(ee(n,"float32")),s=mr(ns(Qs(1),e));return Yn(Ie(t,s))}}}},ci={kernelName:"Acosh",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>{const e=mr(ns(vs(ee(n,"float32")),1));return Ie(t,e)}}}},pi={kernelName:"Add",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e,r=Sn(n.shape,s.shape);return{a:()=>{let e=t;const s=xn(n.shape,r);return s.length>0&&(e=ss(e,s)),qe(e,n.shape)},b:()=>{let e=t;const n=xn(s.shape,r);return n.length>0&&(e=ss(e,n)),qe(e,s.shape)}}}},di={kernelName:"AddN",saveAllInputs:!0,gradFunc:(t,e)=>{const n={};return e.forEach((e,s)=>{n[s]=()=>t.clone()}),n}},fi={kernelName:"ArgMax",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>En(n)}}},mi={kernelName:"ArgMin",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>En(n)}}},gi={kernelName:"Asin",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ie(t,mr(ns(Qs(1),vs(ee(n,"float32")))))}}},yi={kernelName:"Asinh",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>{const e=mr(xe(Qs(1),vs(ee(n,"float32"))));return Ie(t,e)}}}},bi={kernelName:"Atan2",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e,r=Sn(n.shape,s.shape);return{a:()=>{const e=xe(vs(n),vs(s));let i=Ne(t,Ie(s,e));const a=xn(n.shape,r);return a.length>0&&(i=ss(i,a)),qe(i,n.shape)},b:()=>{const e=xe(vs(n),vs(s));let i=Yn(Ne(t,Ie(n,e)));const a=xn(s.shape,r);return a.length>0&&(i=ss(i,a)),qe(i,s.shape)}}}},wi={kernelName:"Atan",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ie(t,xe(vs(ee(n,"float32")),1))}}},vi={kernelName:"Atanh",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ie(t,ns(Qs(1),vs(ee(n,"float32"))))}}};const ki=bt({avgPool3dGrad_:function(t,e,n,s,i,a){const o=gt(t,"dy","avgPool3dGrad"),l=gt(e,"input","avgPool3dGrad");let u=o,c=l,p=!1;4===l.rank&&(p=!0,u=qe(o,[1,o.shape[0],o.shape[1],o.shape[2],o.shape[3]]),c=qe(l,[1,l.shape[0],l.shape[1],l.shape[2],l.shape[3]])),r(5===u.rank,()=>"Error in avgPool3dGrad: dy must be rank 5 but got rank "+u.rank+"."),r(5===c.rank,()=>"Error in avgPool3dGrad: input must be rank 5 but got rank "+c.rank+"."),null!=a&&r(h(i),()=>`Error in avgPool3dGrad: pad must be an integer when using, dimRoundingMode ${a} but got pad ${i}.`);const d={dy:u,input:c},f={filterSize:n,strides:s,pad:i,dimRoundingMode:a},m=ct.runKernel("AvgPool3DGrad",d,f);return p?qe(m,[m.shape[1],m.shape[2],m.shape[3],m.shape[4]]):m}}),xi={kernelName:"AvgPool3D",inputsToSave:["x"],gradFunc:(t,e,n)=>{const[s]=e,{filterSize:r,strides:i,pad:a,dimRoundingMode:o}=n;return{x:()=>ki(t,s,r,i,a,o)}}};const Si=bt({avgPoolGrad_:function(t,e,n,s,i){const a=gt(t,"dy","avgPoolGrad"),o=gt(e,"input","avgPoolGrad");r(o.rank===a.rank,()=>`Rank of input (${o.rank}) does not match rank of dy (${a.rank})`);let l=o,u=a,h=!1;3===o.rank&&(h=!0,l=qe(o,[1,o.shape[0],o.shape[1],o.shape[2]]),u=qe(a,[1,a.shape[0],a.shape[1],a.shape[2]])),r(4===u.rank,()=>"Error in avgPoolGrad: dy must be rank 4 but got rank "+u.rank+"."),r(4===l.rank,()=>"Error in avgPoolGrad: input must be rank 4 but got rank "+l.rank+".");const c={dy:u,input:l},p={filterSize:n,strides:s,pad:i},d=ct.runKernel("AvgPoolGrad",c,p);return h?qe(d,[d.shape[1],d.shape[2],d.shape[3]]):d}}),Ii={kernelName:"AvgPool",inputsToSave:["x"],gradFunc:(t,e,n)=>{const[s]=e,{filterSize:r,strides:i,pad:a}=n;return{x:()=>Si(t,s,r,i,a)}}},Ni={kernelName:"BatchMatMul",inputsToSave:["a","b"],gradFunc:(t,e,n)=>{const[s,r]=e,{transposeA:i,transposeB:a}=n;return i||a?!i&&a?{a:()=>he(t,r,!1,!1),b:()=>he(t,s,!0,!1)}:i&&!a?{a:()=>he(r,t,!1,!0),b:()=>he(s,t,!1,!1)}:{a:()=>he(r,t,!0,!0),b:()=>he(t,s,!0,!0)}:{a:()=>he(t,r,!1,!0),b:()=>he(s,t,!0,!1)}}},Ei={kernelName:"BatchToSpaceND",gradFunc:(t,e,n)=>{const{blockShape:s,crops:r}=n;return{x:()=>As(t,s,r)}}},Ai={kernelName:"BroadcastTo",gradFunc:(t,e,n)=>{const s=n,r=s.inputShape,i=s.shape,a=Array.from(i);for(let t=r.length-1;t>=0;t--)if(r[t]===i[t])a[t]=1;else if(1!==r[t])throw new Error(`broadcastTo(): [${r}] cannot be broadcast to [${i}].`);const o=[];for(let t=0;t<a.length;t++)a[t]>1&&o.push(t);return{x:()=>ss(t,o,!0)}}},Ti={kernelName:"Cast",gradFunc:t=>({x:()=>t.clone()})},Di={kernelName:"Ceil",gradFunc:t=>({x:()=>En(t)})},zi={kernelName:"ClipByValue",inputsToSave:["x"],gradFunc:(t,e,n)=>{const[s]=e,{clipValueMin:r,clipValueMax:i}=n;return{x:()=>Nn(ls(Pn(s,r),Hn(s,i)),t,En(t))}}},Ci={kernelName:"ComplexAbs",inputsToSave:["x"],gradFunc:ui.gradFunc},Fi={kernelName:"Concat",saveAllInputs:!0,gradFunc:(t,e,n)=>{const s=e.map(t=>t.shape),{axis:r}=n,i=p(r,e[0].shape)[0],a=s.map(t=>t[i]);return dr(t,a,i).map(t=>()=>t)}},Ri={kernelName:"Conv2D",inputsToSave:["x","filter"],gradFunc:(t,e,n)=>{const[s,i]=e,{dilations:a,strides:o,pad:l,dataFormat:u}=n;return r(We(a),()=>`Error in gradient of conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '${a}'`),{x:()=>pn(s.shape,t,i,o,l,u),filter:()=>Cr(s,t,i.shape,o,l,u)}}},Li={kernelName:"Conv2DBackpropInput",inputsToSave:["dy","filter"],gradFunc:(t,e,n)=>{const[s,r]=e,{strides:i,pad:a,dataFormat:o,dimRoundingMode:l}=n;return{dy:()=>hn(t,r,i,a,o,1,l),filter:()=>Cr(t,s,r.shape,i,a,o,l)}}};const Mi=bt({conv3DBackpropFilter_:function(t,e,n,s,i){let a=t;4===t.rank&&(a=qe(t,[1,t.shape[0],t.shape[1],t.shape[2],t.shape[3]]));let o=e;4===o.rank&&(o=qe(e,[1,e.shape[0],e.shape[1],e.shape[2],e.shape[3]])),r(5===a.rank,()=>"Error in conv3dDerFilter: input must be rank 5, but got shape "+a.shape+"."),r(5===o.rank,()=>"Error in conv3dDerFilter: dy must be rank 5, but got shape "+o.shape+"."),r(5===n.length,()=>"Error in conv3dDerFilter: filterShape must be length 5, but got "+n+"."),r(a.shape[4]===n[3],()=>`Error in conv3dDerFilter: depth of input ${a.shape[4]}) must match input depth in filter (${n[3]}.`),r(o.shape[4]===n[4],()=>`Error in conv3dDerFilter: depth of dy (${o.shape[4]}) must match output depth for filter (${n[4]}).`);const l={x:a,dy:o},u={strides:s,pad:i,filterShape:n};return ct.runKernel("Conv3DBackpropFilterV2",l,u)}}),_i={kernelName:"Conv3D",inputsToSave:["x","filter"],gradFunc:(t,e,n)=>{const{dilations:s,strides:i,pad:a}=n;r(We(s),()=>`Error in gradient of conv3D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '${s}'`);const[o,l]=e;return{x:()=>mn(o.shape,t,l,i,a),filter:()=>Mi(o,t,l.shape,i,a)}}},$i={kernelName:"Cos",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ne(Yn(sr(ee(n,"float32"))),t)}}},Oi={kernelName:"Cosh",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ne(rr(ee(n,"float32")),t)}}},Bi={kernelName:"Cumsum",inputsToSave:["x"],gradFunc:(t,e,n)=>{const[s]=e,{axis:r,exclusive:i,reverse:a}=n;return{x:()=>{const e=function(t,e){if(function(t,e){for(let n=0;n<t.length;++n)if(t[t.length-n-1]!==e-1-n)return!1;return!0}(t,e))return null;const n=[];for(let s=0;s<e;++s)-1===t.indexOf(s)&&n.push(s);return t.forEach(t=>n.push(t)),n}([r],s.rank);let n=bn(t,r,i,!a);return null!=e&&(n=pe(n,e)),n}}}},Pi={kernelName:"DepthwiseConv2dNative",inputsToSave:["x","filter"],gradFunc:(t,e,n)=>{const{dilations:s,strides:i,pad:a,dimRoundingMode:o}=n,l=null==s?[1,1]:s;r(We(l),()=>`Error in gradient of depthwiseConv2dNative: dilation rates greater than 1 are not yet supported. Got dilations '${l}'`);const[u,c]=e;return r(4===u.rank,()=>`Error in gradient of depthwiseConv2dNative: input must be rank 4, but got rank ${u.rank}.`),r(4===c.rank,()=>`Error in gradient of depthwiseConv2dNative: filter must be rank 4, but got rank ${c.rank}.`),r(u.shape[3]===c.shape[2],()=>`Error in gradient of depthwiseConv2d: number of input channels (${u.shape[3]}) must match the inChannels dimension in filter ${c.shape[2]}.`),r(je(i,l),()=>`Error in gradient of depthwiseConv2d: Either strides or dilations must be  1. Got strides ${i} and dilations '${l}'.`),null!=o&&r(h(a),()=>`Error in depthwiseConv2d: pad must be an integer when using, dimRoundingMode ${o} but got pad ${a}.`),{x:()=>Or(u.shape,t,c,i,a,s,o),filter:()=>$r(u,t,c.shape,i,a,s,o)}}},Ui={kernelName:"Dilation2D",inputsToSave:["x","filter"],gradFunc:(t,e,n)=>{const[s,r]=e,i={x:s,filter:r,dy:t},a={x:s,filter:r,dy:t};return{x:()=>ct.runKernel("Dilation2DBackpropInput",i,n),filter:()=>ct.runKernel("Dilation2DBackpropFilter",a,n)}}},Wi={kernelName:"Elu",outputsToSave:[!0],gradFunc:(t,e)=>{const[n]=e,s={dy:t,y:n};return{x:()=>ct.runKernel("EluGrad",s)}}},ji={kernelName:"Erf",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e,s=Ne(Cn(Yn(vs(n))),2/Math.sqrt(Math.PI));return{x:()=>Ne(t,s)}}},qi={kernelName:"Exp",outputsToSave:[!0],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ne(t,n)}}},Ki={kernelName:"ExpandDims",inputsToSave:["input"],gradFunc:(t,e)=>{const[n]=e;return{input:()=>qe(t,n.shape)}}},Vi={kernelName:"Expm1",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ne(t,Cn(n))}}},Hi={kernelName:"Floor",gradFunc:t=>({x:()=>En(t)})},Gi={kernelName:"FloorDiv",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e,r=Sn(n.shape,s.shape);return{a:()=>{const e=Ie(t,ee(s,"float32")),i=xn(n.shape,r);return i.length>0?qe(ss(e,i),n.shape):e},b:()=>{let e=Ne(t,ee(n,"float32"));const i=xn(s.shape,r);i.length>0&&(e=qe(ss(e,i),s.shape));const a=vs(s);return Yn(Ie(e,ee(a,"float32")))}}}},Ji={kernelName:"FusedBatchNorm",inputsToSave:["x","mean","variance","scale"],gradFunc:(t,e,n)=>{const{varianceEpsilon:s}=n,[r,i,a,o]=e,l=null==o?Qs(1):o,u=xn(i.shape,r.shape),h=[];if(1===i.rank){for(let t=0;t<r.shape.length-1;++t)h.push(r.shape[t]);h.push(1)}const c=ns(r,i),p=Ne(t,l),d=Ys(xe(a,Qs(s))),f=Ne(Ne(Ne(d,d),d),Qs(-.5));return{x:()=>1===i.rank?qe(Ne(Ne(t,Ln(qe(d,[1,1,1,i.shape[0]]),h)),l),r.shape):qe(Ne(Ne(t,d),l),r.shape),mean:()=>{let t=Ne(Ne(d,Qs(-1)),p);return 1===i.rank&&(t=ss(t,u)),qe(t,i.shape)},variance:()=>{let t=Ne(Ne(f,c),p);return 1===i.rank&&(t=ss(t,u)),qe(t,i.shape)},scale:()=>{const e=Ne(c,d);let n=Ne(t,e);return 1===i.rank&&(n=ss(n,u)),qe(n,i.shape)},offset:()=>{let e=t;return 1===i.rank&&(e=ss(e,u)),qe(e,i.shape)}}}},Zi={kernelName:"GatherV2",inputsToSave:["x","indices"],gradFunc:(t,e,n)=>{const[s,r]=e,{axis:i}=n,a=p(i,s.shape)[0];return{x:()=>{const e=s.shape,n=r.size,o=e.slice(0,a),l=o.length,u=e.slice(i,e.length).slice(1),h=u.length,c=Xi(0,l),p=Xi(l+1,l+1+h),d=Yi([o,[n],u]),f=qe(t,d),m=qe(r,[n]),g=Yi([[l],c,p]),y=pe(f,g);let b=Ar(y,m,s.shape[a]);const w=as(g);return b=pe(b,w),b},indices:()=>r}}};function Xi(t,e){const n=[];for(let s=t;s<e;++s)n.push(s);return n}function Yi(t){const e=[];for(let n=0;n<t.length;++n)for(let s=0;s<t[n].length;++s)e.push(t[n][s]);return e}const Qi={kernelName:"GreaterEqual",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e;return{a:()=>En(n),b:()=>En(s)}}},ta={kernelName:"Identity",gradFunc:t=>({x:()=>ee(t,"float32")})},ea={kernelName:"IsFinite",gradFunc:t=>({x:()=>En(t)})},na={kernelName:"IsInf",gradFunc:t=>({x:()=>En(t)})},sa={kernelName:"IsNan",gradFunc:t=>({x:()=>En(t)})},ra={kernelName:"LeakyRelu",inputsToSave:["x"],gradFunc:(t,e,n)=>{const[s]=e,{alpha:r}=n,i=Bn(s,0);return{x:()=>Nn(i,t,Ne(t,r))}}},ia={kernelName:"Log1p",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ie(t,xe(n,1))}}},aa={kernelName:"Log",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ie(t,ee(n,"float32"))}}},oa={kernelName:"LogSoftmax",inputsToSave:[],outputsToSave:[!0],gradFunc:(t,e,n)=>{const[s]=e,{axis:r}=n;return{logits:()=>{const e=Cn(s);return ns(t,Ne(ss(t,r,!0),e))}}}};const la=bt({localResponseNormalizationBackprop_:function(t,e,n,s=5,r=1,i=1,a=.5){const o={x:t,y:e,dy:n},l={depthRadius:s,bias:r,alpha:i,beta:a};return ct.runKernel("LRNGrad",o,l)}}),ua={kernelName:"LRN",inputsToSave:["x"],outputsToSave:[!0],gradFunc:(t,e,n)=>{const[s,r]=e,{depthRadius:i,bias:a,alpha:o,beta:l}=n;return{x:()=>la(s,r,t,i,a,o,l)}}};function ha(t,e,n,s){return e.rank<n.rank&&(e=qe(e,is(e.shape,s))),t.rank<n.rank&&(t=qe(t,is(t.shape,s))),{x:()=>Ne(t,ee(In(n,e),t.dtype))}}const ca={kernelName:"Max",inputsToSave:["x"],outputsToSave:[!0],gradFunc:(t,e,n)=>{const s=n,{reductionIndices:r}=s,i=e[0],a=ha(t,e[1],i,p(r,i.shape));return{x:()=>a.x()}}},pa={kernelName:"Maximum",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e;return{a:()=>Ne(t,ee(Pn(n,s),"float32")),b:()=>Ne(t,ee(Vn(n,s),"float32"))}}};const da=bt({maxPool3dGrad_:function(t,e,n,s,i,a,o){const l=gt(t,"dy","maxPool3dGrad"),u=gt(e,"input","maxPool3dGrad"),c=gt(n,"output","maxPool3dGrad");let p=l,d=u,f=c,m=!1;4===u.rank&&(m=!0,p=qe(l,[1,l.shape[0],l.shape[1],l.shape[2],l.shape[3]]),d=qe(u,[1,u.shape[0],u.shape[1],u.shape[2],u.shape[3]]),f=qe(c,[1,c.shape[0],c.shape[1],c.shape[2],c.shape[3]])),r(5===p.rank,()=>"Error in maxPool3dGrad: dy must be rank 5 but got rank "+p.rank+"."),r(5===d.rank,()=>"Error in maxPool3dGrad: input must be rank 5 but got rank "+d.rank+"."),r(5===f.rank,()=>"Error in maxPool3dGrad: output must be rank 5 but got rank "+f.rank+"."),null!=o&&r(h(a),()=>`Error in maxPool3dGrad: pad must be an integer when using, dimRoundingMode ${o} but got pad ${a}.`);const g={dy:p,input:d,output:f},y={filterSize:s,strides:i,pad:a,dimRoundingMode:o},b=ct.runKernel("MaxPool3DGrad",g,y);return m?qe(b,[b.shape[1],b.shape[2],b.shape[3],b.shape[4]]):b}}),fa={kernelName:"MaxPool3D",inputsToSave:["x"],outputsToSave:[!0],gradFunc:(t,e,n)=>{const[s,r]=e,{filterSize:i,strides:a,pad:o,dimRoundingMode:l}=n;return{x:()=>da(t,s,r,i,a,o,l)}}};const ma=bt({maxPoolGrad_:function(t,e,n,s,i,a,o){const l=gt(t,"dy","maxPoolGrad"),u=gt(e,"input","maxPoolGrad"),c=gt(n,"output","maxPoolGrad");r(u.rank===l.rank,()=>`Rank of input (${u.rank}) does not match rank of dy (${l.rank})`),r(4===l.rank,()=>"Error in maxPoolGrad: dy must be rank 4 but got rank "+l.rank+"."),r(4===u.rank,()=>"Error in maxPoolGrad: input must be rank 4 but got rank "+u.rank+"."),null!=o&&r(h(a),()=>`Error in maxPoolGrad: pad must be an integer when using, dimRoundingMode ${o} but got pad ${a}.`);const p={dy:l,input:u,output:c},d={filterSize:s,strides:i,pad:a,dimRoundingMode:o};return ct.runKernel("MaxPoolGrad",p,d)}}),ga={kernelName:"PadV2",inputsToSave:["x"],gradFunc:(t,e,n)=>{const s=e[0],{paddings:r}=n,i=r.map(t=>t[0]);return{x:()=>Je(t,i,s.shape)}}},ya={kernelName:"SpaceToBatchND",gradFunc:(t,e,n)=>{const{blockShape:s,paddings:r}=n;return{x:()=>Xe(t,s,r)}}},ba={kernelName:"SplitV",gradFunc:(t,e,n)=>{const{axis:s}=n;return{x:()=>He(t,s)}}};const wa=[ui,hi,ci,pi,di,fi,mi,gi,yi,bi,wi,vi,xi,Ii,Ni,Ei,Ai,Ti,Di,zi,Ci,Fi,Li,Ri,_i,$i,Oi,Bi,Pi,Ui,{kernelName:"RealDiv",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e,r=Sn(n.shape,s.shape);return{a:()=>{const e=Ie(t,ee(s,"float32")),i=xn(n.shape,r);return i.length>0?qe(ss(e,i),n.shape):e},b:()=>{let e=Ne(t,ee(n,"float32"));const i=xn(s.shape,r);i.length>0&&(e=qe(ss(e,i),s.shape));const a=vs(s);return Yn(Ie(e,ee(a,"float32")))}}}},Wi,ji,qi,Ki,Vi,Gi,Hi,Ji,Zi,Qi,ta,ea,na,sa,ra,ia,aa,oa,ua,ca,ca,pa,fa,{kernelName:"MaxPool",inputsToSave:["x"],outputsToSave:[!0],gradFunc:(t,e,n)=>{const[s,r]=e,{filterSize:i,strides:a,pad:o}=n;return{x:()=>ma(t,s,r,i,a,o)}}},{kernelName:"Mean",inputsToSave:["x"],gradFunc:(t,e,n)=>{const[s]=e,{axis:r}=n,i=p(r,s.shape),a=l(function(t,e){const n=[],s=t.length;for(let r=0;r<s;r++)-1===e.indexOf(r)&&n.push(t[r]);return[n,e.map(e=>t[e])]}(s.shape,i)[1]);return{x:()=>{const e=s.shape.slice();i.forEach(t=>{e[t]=1});const n=qe(t,e);return Ie(Ne(n,Is(s.shape,"float32")),a)}}}},{kernelName:"Min",inputsToSave:["x"],outputsToSave:[!0],gradFunc:(t,e,n)=>{const s=n,{axis:r}=s,[i,a]=e,o=ha(t,a,i,p(r,i.shape));return{x:()=>o.x()}}},{kernelName:"Minimum",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e;return{a:()=>Ne(t,ee(Hn(n,s),"float32")),b:()=>Ne(t,ee(Bn(n,s),"float32"))}}},{kernelName:"MirrorPad",inputsToSave:["x"],gradFunc:(t,e,n)=>{const s=e[0],{paddings:r}=n,i=r.map(t=>t[0]);return{x:()=>Je(t,i,s.shape)}}},{kernelName:"Mod",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e,r=Sn(n.shape,s.shape);return{a:()=>{const e=xn(n.shape,r);return e.length>0?qe(ss(t,e),n.shape):t},b:()=>{const e=Ne(t,Yn($n(Ie(n,s)))),i=xn(s.shape,r);return i.length>0?qe(ss(e,i),s.shape):e}}}},{kernelName:"Multiply",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e,r=Sn(n.shape,s.shape);return{a:()=>{const e=Ne(t,ee(s,"float32")),i=xn(n.shape,r);return i.length>0?qe(ss(e,i),n.shape):e},b:()=>{const e=Ne(t,ee(n,"float32")),i=xn(s.shape,r);return i.length>0?qe(ss(e,i),s.shape):e}}}},{kernelName:"Neg",gradFunc:t=>({x:()=>Yn(t)})},{kernelName:"OneHot",inputsToSave:["indices"],gradFunc:(t,e)=>{const n=e[0];return{indices:()=>Ss(n.shape,"float32")}}},{kernelName:"OnesLike",gradFunc:t=>({x:()=>En(t)})},{kernelName:"Pack",saveAllInputs:!0,gradFunc:(t,e,n)=>{const{axis:s}=n;return Tr(t,s).map(t=>()=>t)}},ga,ga,{kernelName:"Pow",inputsToSave:["a","b"],outputsToSave:[!0],gradFunc:(t,e)=>{const[n,s,r]=e,i=n,a=s,o=Sn(i.shape,a.shape);return{a:()=>{const e=ee(a,"float32");let n=Ne(t,Ne(e,Ds(i,ns(e,Qs(1)))));const s=xn(i.shape,o);return s.length>0&&(n=ss(n,s)),qe(n,i.shape)},b:()=>{const e=Bn(i,0),n=Nn(e,Jn(i),En(i));let s=Ne(t,Ne(r,n));const l=xn(a.shape,o);return l.length>0&&(s=ss(s,l)),qe(s,a.shape)}}}},{kernelName:"Prelu",inputsToSave:["x","alpha"],gradFunc:(t,e)=>{const[n,s]=e,r=Bn(n,0);return{x:()=>Nn(r,t,Ne(t,s)),alpha:()=>{let e=Nn(r,En(t),Ne(t,n));const i=xn(s.shape,t.shape);return i.length>0&&(e=ss(e,i)),qe(e,s.shape)}}}},{kernelName:"Reciprocal",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ie(t,Yn(vs(n)))}}},{kernelName:"Relu6",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e,s=Ne(Hn(n,6),wr(n));return{x:()=>Ne(t,ee(s,"float32"))}}},{kernelName:"Relu",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ne(t,ee(wr(n),"float32"))}}},{kernelName:"Reshape",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>qe(t,n.shape)}}},{kernelName:"ResizeBilinear",inputsToSave:["images"],gradFunc:(t,e,n)=>{const[s]=e,r={dy:t,images:s};return{images:()=>ct.runKernel("ResizeBilinearGrad",r,n)}}},{kernelName:"ResizeNearestNeighbor",inputsToSave:["images"],gradFunc:(t,e,n)=>{const[s]=e,r={dy:t,images:s};return{images:()=>ct.runKernel("ResizeNearestNeighborGrad",r,n)}}},{kernelName:"Reverse",gradFunc:(t,e,n)=>{const{dims:s}=n,r=p(s,t.shape);return{x:()=>Zs(t,r)}}},{kernelName:"Round",gradFunc:t=>({x:()=>En(t)})},{kernelName:"Rsqrt",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Yn(Ie(t,Ne(Ds(n,1.5),2)))}}},{kernelName:"Select",inputsToSave:["condition"],gradFunc:(t,e)=>{const[n]=e;return{condition:()=>ee(En(n),"float32"),t:()=>Ne(t,ee(n,t.dtype)),e:()=>Ne(t,ee(us(n),t.dtype))}}},{kernelName:"Selu",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>{const e=Bn(n,Qs(0)),s=Qs(1.7580993408473768),r=Qs(1.0507009873554805),i=Ne(t,r),a=Ne(Ne(t,s),Cn(ee(n,"float32")));return Nn(e,i,a)}}}},{kernelName:"Sigmoid",outputsToSave:[!0],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ne(t,Ne(n,ns(Qs(1),n)))}}},{kernelName:"Sign",gradFunc:t=>({x:()=>En(t)})},{kernelName:"Sin",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ne(gn(ee(n,"float32")),t)}}},{kernelName:"Sinh",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ne(yn(ee(n,"float32")),t)}}},{kernelName:"Slice",inputsToSave:["x"],gradFunc:(t,e,n)=>{const[s]=e,{begin:i,size:a}=n,o=s.shape,[l,u]=function(t,e,n){let s;const i=t.shape.length;let a;return s="number"==typeof e?[e,...new Array(i-1).fill(0)]:e.length<i?e.concat(new Array(i-e.length).fill(0)):e.slice(),s.forEach(t=>{r(-1!==t,()=>"slice() does not support negative begin indexing.")}),a=null==n?new Array(i).fill(-1):"number"==typeof n?[n,...new Array(i-1).fill(-1)]:n.length<i?n.concat(new Array(i-n.length).fill(-1)):n,a=a.map((e,n)=>e>=0?e:(r(-1===e,()=>`Negative size values should be exactly -1 but got ${e} for the slice() size at index ${n}.`),t.shape[n]-s[n])),[s,a]}(s,i,a),h=[];for(let e=0;e<t.rank;e++)h.push([l[e],o[e]-l[e]-u[e]]);return{x:()=>Es(t,h)}}},{kernelName:"Softmax",outputsToSave:[!0],gradFunc:(t,e,n)=>{const[s]=e,{dim:r}=n,i=Ne(t,s);return{logits:()=>ns(i,Ne(ss(i,[r],!0),s))}}},{kernelName:"Softplus",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ne(t,Ge(n))}}},ya,ya,ba,ba,{kernelName:"Sqrt",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ie(t,Ne(mr(ee(n,"float32")),2))}}},{kernelName:"SquaredDifference",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e,r=Qs(2);return{a:()=>Ne(t,Ne(r,ns(n,s))),b:()=>Ne(t,Ne(r,ns(s,n)))}}},{kernelName:"Square",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ne(t,Ne(ee(n,"float32"),2))}}},{kernelName:"Step",gradFunc:t=>({x:()=>En(t)})},{kernelName:"Sub",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e,r=Sn(n.shape,s.shape);return{a:()=>{let e=t;const s=xn(n.shape,r);return s.length>0&&(e=ss(e,s)),qe(e,n.shape)},b:()=>{let e=t;const n=xn(s.shape,r);return n.length>0&&(e=ss(e,n)),qe(Yn(e),s.shape)}}}},{kernelName:"Sum",inputsToSave:["x"],gradFunc:(t,e,n)=>{const[s]=e,r=s.shape.slice(),{axis:i}=n;p(i,s.shape).forEach(t=>{r[t]=1});const a=qe(t,r),o=Ne(a,Is(s.shape,"float32"));return{x:()=>o}}},{kernelName:"Tan",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ie(t,vs(gn(n)))}}},{kernelName:"Tanh",outputsToSave:[!0],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ne(ns(Qs(1),vs(n)),t)}}},{kernelName:"Tile",inputsToSave:["x"],gradFunc:(t,e,n)=>{const[s]=e,{reps:r}=n;return{x:()=>{let e=En(s);if(1===s.rank)for(let n=0;n<r[0];++n)e=xe(e,Je(t,[n*s.shape[0]],[s.shape[0]]));else if(2===s.rank)for(let n=0;n<r[0];++n)for(let i=0;i<r[1];++i)e=xe(e,Je(t,[n*s.shape[0],i*s.shape[1]],[s.shape[0],s.shape[1]]));else if(3===s.rank)for(let n=0;n<r[0];++n)for(let i=0;i<r[1];++i)for(let a=0;a<r[2];++a)e=xe(e,Je(t,[n*s.shape[0],i*s.shape[1],a*s.shape[2]],[s.shape[0],s.shape[1],s.shape[2]]));else{if(4!==s.rank)throw new Error("Gradient for tile operation is not implemented for rank-"+s.rank+" tensors yet.");for(let n=0;n<r[0];++n)for(let i=0;i<r[1];++i)for(let a=0;a<r[2];++a)for(let o=0;o<r[3];++o)e=xe(e,Je(t,[n*s.shape[0],i*s.shape[1],a*s.shape[2],o*s.shape[3]],[s.shape[0],s.shape[1],s.shape[2],s.shape[3]]))}return e}}}},{kernelName:"Transpose",gradFunc:(t,e,n)=>{const s=n,{perm:r}=s,i=as(r);return{x:()=>pe(t,i)}}},{kernelName:"Unpack",gradFunc:(t,e,n)=>{const s=n,{axis:r}=s;return{value:()=>br(t,r)}}},{kernelName:"UnsortedSegmentSum",inputsToSave:["segmentIds"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>function(t,e){const n=fs(e,En(e)),s=On(t,n);let r=Pn(e,Qs(0,"int32"));const i=s.rank-r.rank;for(let t=0;t<i;++t)r=Fn(r,t+1);r=ls(r,Is(s.shape,"bool"));const a=En(s);return Nn(r,s,a)}(t,n)}}},{kernelName:"ZerosLike",gradFunc:t=>({x:()=>En(t)})}];for(const t of wa)M(t);let va;function ka(){return null==va&&(va=ke().epsilon()),va}class xa extends Error{constructor(t){super(t),Object.setPrototypeOf(this,xa.prototype)}}class Sa extends Error{constructor(t){super(t),Object.setPrototypeOf(this,Sa.prototype)}}class Ia extends Error{constructor(t){super(t),Object.setPrototypeOf(this,Ia.prototype)}}class Na extends Error{constructor(t){super(t),Object.setPrototypeOf(this,Na.prototype)}}class Ea extends Error{constructor(t){super(t),Object.setPrototypeOf(this,Ea.prototype)}}function Aa(t,e){if(Array.isArray(t)){let n=[];for(let s=0;s<e;s++)n=n.concat(t);return n}{const n=new Array(e);return n.fill(t),n}}function Ta(t,e){if(!t)throw new Ea(e)}function Da(t,e){let n=0;for(const s of t)s===e&&n++;return n}function za(t){return 1===t.length?t[0]:t}function Ca(t){return Array.isArray(t)?t:[t]}function Fa(t){const e=t.replace(/(.)([A-Z][a-z0-9]+)/g,"$1_$2").replace(/([a-z])([A-Z])/g,"$1_$2").toLowerCase();return"_"!==e[0]?e:"private"+e}function Ra(t){return t.length<=1||-1===t.indexOf("_")?t:t.replace(/[_]+(\w|$)/g,(t,e)=>e.toUpperCase())}let La={};function Ma(t){if(null==t)return null;const e={};return e.className=t.getClassName(),e.config=t.getConfig(),e}function _a(t,e={},n={},s="object",r=!1){if("string"==typeof t){const r=t;let i;if(r in n)i=n[r];else if(r in La)i=La[r];else if(i=e[r],null==i)throw new Ia(`Unknown ${s}: ${t}. This may be due to one of the following reasons:\n1. The ${s} is defined in Python, in which case it needs to be ported to TensorFlow.js or your JavaScript code.\n2. The custom ${s} is defined in JavaScript, but is not registered properly with tf.serialization.registerClass().`);return i}{const i=t;if(null==i.className||null==i.config)throw new Ia(s+": Improper config format: "+JSON.stringify(i)+".\n'className' and 'config' must set.");const a=i.className;let o,l;if(a in n?[o,l]=n[a]:a in La?[o,l]=La.className:a in e&&([o,l]=e[a]),null==o)throw new Ia(`Unknown ${s}: ${a}. This may be due to one of the following reasons:\n1. The ${s} is defined in Python, in which case it needs to be ported to TensorFlow.js or your JavaScript code.\n2. The custom ${s} is defined in JavaScript, but is not registered properly with tf.serialization.registerClass().`);if(null!=l){const t={};for(const e of Object.keys(La))t[e]=La[e];for(const e of Object.keys(n))t[e]=n[e];i.config.customObjects=t;const e=Object.assign({},La);for(const t of Object.keys(n))La[t]=n[t];!function t(e){if(null!=e&&"object"==typeof e)if(Array.isArray(e))e.forEach(e=>t(e));else{const n=Object.keys(e);for(const s of n){const n=e[s];null!=n&&"object"==typeof n&&(Array.isArray(n)||"ndarray"!==n.type||"number"!=typeof n.value?t(n):e[s]=n.value)}}}(i.config);const s=l(o,i.config,n,r);return La=Object.assign({},e),s}{const t=Object.assign({},La);for(const t of Object.keys(n))La[t]=n[t];const e=new o(i.config);return La=Object.assign({},t),e}}}function $a(t,e){return-1*function(t,e){return t<e?-1:t>e?1:0}(t,e)}function Oa(t){if(null==t)return t;const e=[];for(const n of t)-1===e.indexOf(n)&&e.push(n);return e}function Ba(t){if(null==t)throw new Ia("Invalid value in obj: "+JSON.stringify(t));for(const e in t)if(t.hasOwnProperty(e))return!1;return!0}function Pa(t,e,n){if(null!=n&&t.indexOf(n)<0)throw new Ia(`${n} is not a valid ${e}.  Valid values are ${t} or null/undefined.`)}function Ua(t,e,n=0,s=1/0){return Ta(n>=0),Ta(s>=n),Array.isArray(t)&&t.length>=n&&t.length<=s&&t.every(t=>typeof t===e)}function Wa(t,e){Array.isArray(t)?(r(t.length>0,()=>e+" is unexpectedly an empty array."),t.forEach((t,n)=>Wa(t,`element ${n+1} of ${e}`))):r(Number.isInteger(t)&&t>0,()=>`Expected ${e} to be a positive integer, but got `+function t(e){return null===e?"null":Array.isArray(e)?"["+e.map(e=>t(e)).join(",")+"]":"string"==typeof e?`"${e}"`:""+e}(t)+".")}function ja(t){return"relu"===t?"relu":"linear"===t?"linear":"elu"===t?"elu":null}function qa(t,e){return be(()=>mr(ss(Ne(t,t),e,!0)))}class Ka extends fe{getConfig(){return{}}}class Va extends Ka{constructor(t){super(),this.defaultMaxValue=2,this.defaultAxis=0,this.maxValue=null!=t.maxValue?t.maxValue:this.defaultMaxValue,this.axis=null!=t.axis?t.axis:this.defaultAxis}apply(t){return be(()=>{const e=qa(t,this.axis),n=rn(e,0,this.maxValue);return Ne(t,Ie(n,xe(ka(),e)))})}getConfig(){return{maxValue:this.maxValue,axis:this.axis}}}Va.className="MaxNorm",ge(Va);class Ha extends Ka{constructor(t){super(),this.defaultAxis=0,this.axis=null!=t.axis?t.axis:this.defaultAxis}apply(t){return be(()=>Ie(t,xe(ka(),qa(t,this.axis))))}getConfig(){return{axis:this.axis}}}Ha.className="UnitNorm",ge(Ha);class Ga extends Ka{apply(t){return Gs(t)}}Ga.className="NonNeg",ge(Ga);class Ja extends Ka{constructor(t){super(),this.defaultMinValue=0,this.defaultMaxValue=1,this.defaultRate=1,this.defaultAxis=0,this.minValue=null!=t.minValue?t.minValue:this.defaultMinValue,this.maxValue=null!=t.maxValue?t.maxValue:this.defaultMaxValue,this.rate=null!=t.rate?t.rate:this.defaultRate,this.axis=null!=t.axis?t.axis:this.defaultAxis}apply(t){return be(()=>{const e=qa(t,this.axis),n=xe(Ne(this.rate,rn(e,this.minValue,this.maxValue)),Ne(1-this.rate,e));return Ne(t,Ie(n,xe(ka(),e)))})}getConfig(){return{minValue:this.minValue,maxValue:this.maxValue,rate:this.rate,axis:this.axis}}}Ja.className="MinMaxNorm",ge(Ja);const Za={maxNorm:"MaxNorm",minMaxNorm:"MinMaxNorm",nonNeg:"NonNeg",unitNorm:"UnitNorm"};function Xa(t){return Ma(t)}function Ya(t,e={}){return _a(t,me.getMap().classNameMap,e,"constraint")}function Qa(t){if(null==t)return null;if("string"==typeof t){return Ya({className:t in Za?Za[t]:t,config:{}})}return t instanceof Ka?t:Ya(t)}const to=["channelsFirst","channelsLast"],eo=["nearest","bilinear"],no=["valid","same","causal"],so=["max","avg"],ro=["sum","mul","concat","ave"],io=new Map;function ao(t){Pa(to,"DataFormat",t)}function oo(t){Pa(no,"PaddingMode",t)}function lo(t){Pa(so,"PoolMode",t)}const uo=[];function ho(t,e){uo.push(t);try{const t=e();return uo.pop(),t}catch(t){throw uo.pop(),t}}function co(t){if(!mo(t))throw new Error("Not a valid tensor name: '"+t+"'");return(0===uo.length?"":uo.join("/")+"/")+t}function po(t){if(!mo(t))throw new Error("Not a valid tensor name: '"+t+"'");io.has(t)||io.set(t,0);const e=io.get(t);if(io.set(t,io.get(t)+1),e>0){const n=`${t}_${e}`;return io.set(n,1),n}return t}const fo=new RegExp(/^[A-Za-z0-9][-A-Za-z0-9\._\/]*$/);function mo(t){return!!t.match(fo)}function go(t,e,n){null==e&&(e=0),null==n&&(n=t.length);let s=1;for(let r=e;r<n;++r)s*=t[r];return s}function yo(t){return xr(t=Array.isArray(t)?new Float32Array(t):t)}function bo(t){return gs(yo(t)).dataSync()[0]}function wo(t){return es(yo(t)).dataSync()[0]}function vo(t,e){if(e<t)throw new Ia(`end (${e}) < begin (${t}) is forbidden.`);const n=[];for(let s=t;s<e;++s)n.push(s);return n}function ko(t,e){return t.asType(e)}function xo(t,e=-1){const n=t.shape.slice();return e<0&&(e=n.length+e+1),n.splice(e,0,1),t.reshape(n)}function So(t,e,n){return be(()=>{switch(t.rank){case 1:return ir(t,e,n);case 2:return ar(t,[e,0],[n,t.shape[1]]);case 3:return or(t,[e,0,0],[n,t.shape[1],t.shape[2]]);case 4:return lr(t,[e,0,0,0],[n,t.shape[1],t.shape[2],t.shape[3]]);case 5:return Je(t,[e,0,0,0,0],[n,t.shape[1],t.shape[2],t.shape[3],t.shape[4]]);case 6:return Je(t,[e,0,0,0,0,0],[n,t.shape[1],t.shape[2],t.shape[3],t.shape[4],t.shape[5]]);default:throw new Ia("sliceAlongFirstAxis() received an unsupported tensor rank: "+t.rank)}})}function Io(t,e,n){return be(()=>{switch(t.rank){case 1:return ir(t,e,n);case 2:return ar(t,[0,e],[t.shape[0],n]);case 3:return or(t,[0,0,e],[t.shape[0],t.shape[1],n]);case 4:return lr(t,[0,0,0,e],[t.shape[0],t.shape[1],t.shape[2],n]);default:throw new Ia("sliceAlongLastAxis() received an unsupported tensor rank: "+t.rank)}})}function No(t,e,n,s){return be(()=>{switch(t.rank){case 1:return ir(t,e,n);case 2:switch(s){case 1:return So(t,e,n);case 2:return Io(t,e,n);default:throw new Ia("The axis is not within the rank of the tensor "+s)}case 3:switch(s){case 1:return So(t,e,n);case 2:return or(t,[0,e,0],[t.shape[0],n,t.shape[2]]);case 3:return Io(t,e,n);default:throw new Ia("The axis is not within the rank of the tensor "+s)}case 4:switch(s){case 1:return So(t,e,n);case 2:return lr(t,[0,e,0,0],[t.shape[0],n,t.shape[2],t.shape[3]]);case 3:return lr(t,[0,0,e,0],[t.shape[0],t.shape[1],n,t.shape[3]]);case 4:return Io(t,e,n);default:throw new Ia("The axis is not within the rank of the tensor "+s)}default:throw new Ia("sliceAlongLastAxis() received an unsupported tensor rank: "+t.rank)}})}function Eo(t,e=-1){let n;return e<0&&(n=t[0].rank,e=0!==n?n:0),e===t[0].rank&&(e=-1),He(t,e)}function Ao(t,e){switch(t.rank){case 1:return an([t,e]);case 2:return on([t,e],0);case 3:return ln([t,e],0);case 4:return un([t,e],0);default:throw new Ia("concatAlongFirstAxis() received an unsupported tensor rank: "+t.rank)}}function To(t,e){if(Array.isArray(e)||(e=[e]),t.rank!==e.length)throw new Ia(`The length of input n (${e.length}) does not match the number of dimensions in input x (${t.rank})`);return Ln(t,e)}function Do(t,e=0,n=1,s,r){return js(t,e,n,s,r)}function zo(t,e,n,s){if(t.rank<2||e.rank<2)throw new Na(`dot requires both inputs to be rank >= 2 but got x shape = ${t.shape} and y shape = ${e.shape}`);if(e.rank>=3){if(t.shape.slice(-1)[0]!==e.shape.slice(-2)[0])throw new Na(`If rank y >= 3, then the second last dim of y must equal the last dim of x but got x shape = ${t.shape} and  y shape = `+e.shape)}if(2===t.rank&&2===e.rank){return Br({a:t,b:e,transposeA:!1,transposeB:!1,bias:s?Ro(t.rank,s,"channelsLast"):null,activation:n})}{const r=t.shape.slice(),i=r.pop();t=t.reshape([-1,i]);const a=e.shape.slice(),o=a.pop(),l=a.pop(),u=[...a,o],h=Array.from({length:e.rank},(t,n)=>0===n?e.rank-2:n<=e.rank-2?n-1:n);e=e.transpose(h).reshape([l,-1]);const c=[...r,...u];return Br({a:t,b:e,transposeA:!1,transposeB:!1,bias:s?Ro(t.rank,s,"channelsLast"):null,activation:n}).reshape(c)}}function Co(t,e,n){return be(()=>(e=Array.isArray(e)?xr(e,"int32"):e.toInt(),On(t,e,n)))}function Fo(t){return Ne(t,t)}function Ro(t,e,n){const s=e.shape;if(1!==e.rank&&e.rank!==t)throw new Ia("Unexpected bias dimensions: "+e.rank+"; expected it to be 1 or "+t);if(5===t){if("channelsFirst"===n)return 1===s.length?e.reshape([1,s[0],1,1,1]):e.reshape([1,s[3],s[0],s[1],s[2]]);if("channelsLast"===n)return 1===s.length?e.reshape([1,1,1,1,s[0]]):e.reshape([1].concat(s))}else if(4===t){if("channelsFirst"===n)return 1===s.length?e.reshape([1,s[0],1,1]):e.reshape([1,s[2],s[0],s[1]]);if("channelsLast"===n)return 1===s.length?e.reshape([1,1,1,s[0]]):e.reshape([1].concat(s))}else if(3===t){if("channelsFirst"===n)return 1===s.length?e.reshape([1,s[0],1]):e.reshape([1,s[1],s[0]]);if("channelsLast"===n)return 1===s.length?e.reshape([1,1,s[0]]):e.reshape([1].concat(s))}else if(t<3)return e;throw new Ia("Unsupported input rank by biasAdd: "+e.rank)}function Lo(t,e,n){return be(()=>(null==n&&(n="channelsLast"),ao(n),t.add(Ro(t.rank,e,n))))}function Mo(t,e,n,s){return be(()=>zr(t,e,n,s))}function _o(t,e,n=!1){return n?t():e()}const $o=["fanIn","fanOut","fanAvg"],Oo=["normal","uniform","truncatedNormal"];class Bo extends fe{fromConfigUsesCustomObjects(){return!1}getConfig(){return{}}}class Po extends Bo{apply(t,e){return Ss(t,e)}}Po.className="Zeros",ge(Po);class Uo extends Bo{apply(t,e){return Is(t,e)}}Uo.className="Ones",ge(Uo);class Wo extends Bo{constructor(t){if(super(),"object"!=typeof t)throw new Ia("Expected argument of type ConstantConfig but got "+t);if(void 0===t.value)throw new Ia("config must have value set but got "+t);this.value=t.value}apply(t,e){return be(()=>Ne(Qs(this.value),Is(t,e)))}getConfig(){return{value:this.value}}}Wo.className="Constant",ge(Wo);class jo extends Bo{constructor(t){super(),this.DEFAULT_MINVAL=-.05,this.DEFAULT_MAXVAL=.05,this.minval=t.minval||this.DEFAULT_MINVAL,this.maxval=t.maxval||this.DEFAULT_MAXVAL,this.seed=t.seed}apply(t,e){return qs(t,this.minval,this.maxval,e)}getConfig(){return{minval:this.minval,maxval:this.maxval,seed:this.seed}}}jo.className="RandomUniform",ge(jo);class qo extends Bo{constructor(t){super(),this.DEFAULT_MEAN=0,this.DEFAULT_STDDEV=.05,this.mean=t.mean||this.DEFAULT_MEAN,this.stddev=t.stddev||this.DEFAULT_STDDEV,this.seed=t.seed}apply(t,e){if("float32"!==(e=e||"float32")&&"int32"!==e)throw new Na(`randomNormal does not support dType ${e}.`);return Do(t,this.mean,this.stddev,e,this.seed)}getConfig(){return{mean:this.mean,stddev:this.stddev,seed:this.seed}}}qo.className="RandomNormal",ge(qo);class Ko extends Bo{constructor(t){super(),this.DEFAULT_MEAN=0,this.DEFAULT_STDDEV=.05,this.mean=t.mean||this.DEFAULT_MEAN,this.stddev=t.stddev||this.DEFAULT_STDDEV,this.seed=t.seed}apply(t,e){if("float32"!==(e=e||"float32")&&"int32"!==e)throw new Na(`truncatedNormal does not support dType ${e}.`);return Nr(t,this.mean,this.stddev,e,this.seed)}getConfig(){return{mean:this.mean,stddev:this.stddev,seed:this.seed}}}Ko.className="TruncatedNormal",ge(Ko);class Vo extends Bo{constructor(t){super(),this.gain=null!=t.gain?t.gain:1}apply(t,e){return be(()=>{if(2!==t.length||t[0]!==t[1])throw new Ia("Identity matrix initializer can only be used for 2D square matrices.");return Ne(this.gain,Mn(t[0]))})}getConfig(){return{gain:this.gain}}}Vo.className="Identity",ge(Vo);class Ho extends Bo{constructor(t){if(super(),t.scale<0)throw new Ia("scale must be a positive float. Got: "+t.scale);var e;this.scale=null==t.scale?1:t.scale,this.mode=null==t.mode?"fanIn":t.mode,e=this.mode,Pa($o,"FanMode",e),this.distribution=null==t.distribution?"normal":t.distribution,function(t){Pa(Oo,"Distribution",t)}(this.distribution),this.seed=t.seed}apply(t,e){const n=function(t,e="channelsLast"){let n,s;if(ao(e),2===t.length)n=t[0],s=t[1];else if(-1!==[3,4,5].indexOf(t.length)){if("channelsFirst"===e){const e=go(t,2);n=t[1]*e,s=t[0]*e}else if("channelsLast"===e){const e=go(t,0,t.length-2);n=t[t.length-2]*e,s=t[t.length-1]*e}}else{const e=go(t);n=Math.sqrt(e),s=Math.sqrt(e)}return[n,s]}(t),s=n[0],r=n[1];let i=this.scale;if("fanIn"===this.mode?i/=Math.max(1,s):"fanOut"===this.mode?i/=Math.max(1,r):i/=Math.max(1,(s+r)/2),"normal"===this.distribution){const n=Math.sqrt(i);if("float32"!==(e=e||"float32")&&"int32"!==e)throw new Na(`${this.getClassName()} does not support dType ${e}.`);return Nr(t,0,n,e,this.seed)}{const n=Math.sqrt(3*i);return qs(t,-n,n,e)}}getConfig(){return{scale:this.scale,mode:this.mode,distribution:this.distribution,seed:this.seed}}}Ho.className="VarianceScaling",ge(Ho);class Go extends Ho{constructor(t){super({scale:1,mode:"fanAvg",distribution:"uniform",seed:null==t?null:t.seed})}getClassName(){return Ho.className}}Go.className="GlorotUniform",ge(Go);class Jo extends Ho{constructor(t){super({scale:1,mode:"fanAvg",distribution:"normal",seed:null==t?null:t.seed})}getClassName(){return Ho.className}}Jo.className="GlorotNormal",ge(Jo);class Zo extends Ho{constructor(t){super({scale:2,mode:"fanIn",distribution:"normal",seed:null==t?null:t.seed})}getClassName(){return Ho.className}}Zo.className="HeNormal",ge(Zo);class Xo extends Ho{constructor(t){super({scale:2,mode:"fanIn",distribution:"uniform",seed:null==t?null:t.seed})}getClassName(){return Ho.className}}Xo.className="HeUniform",ge(Xo);class Yo extends Ho{constructor(t){super({scale:1,mode:"fanIn",distribution:"normal",seed:null==t?null:t.seed})}getClassName(){return Ho.className}}Yo.className="LeCunNormal",ge(Yo);class Qo extends Ho{constructor(t){super({scale:1,mode:"fanIn",distribution:"uniform",seed:null==t?null:t.seed})}getClassName(){return Ho.className}}Qo.className="LeCunNormal",ge(Qo);class tl extends Bo{constructor(t){if(super(),this.DEFAULT_GAIN=1,this.gain=null==t.gain?this.DEFAULT_GAIN:t.gain,this.seed=t.seed,null!=this.seed)throw new Na("Random seed is not implemented for Orthogonal Initializer yet.")}apply(t,e){return be(()=>{if(t.length<2)throw new Na("Shape must be at least 2D.");t[0]*t[1]>2e3&&console.warn(`Orthogonal initializer is being called on a matrix with more than 2000 (${t[0]*t[1]}) elements: Slowness may result.`);const e=Do(t[0]>t[1]?[t[1],t[0]]:t,0,1,"float32");let n=jr.gramSchmidt(e);return t[0]>t[1]&&(n=n.transpose()),Ne(this.gain,n)})}getConfig(){return{gain:this.gain,seed:this.seed}}}tl.className="Orthogonal",ge(tl);const el={constant:"Constant",glorotNormal:"GlorotNormal",glorotUniform:"GlorotUniform",heNormal:"HeNormal",heUniform:"HeUniform",identity:"Identity",leCunNormal:"LeCunNormal",leCunUniform:"LeCunUniform",ones:"Ones",orthogonal:"Orthogonal",randomNormal:"RandomNormal",randomUniform:"RandomUniform",truncatedNormal:"TruncatedNormal",varianceScaling:"VarianceScaling",zeros:"Zeros"};function nl(t,e={}){return _a(t,me.getMap().classNameMap,e,"initializer")}function sl(t){return Ma(t)}function rl(t){if("string"==typeof t){const e=t in el?el[t]:t;if("GlorotNormal"===e)return new Jo;if("GlorotUniform"===e)return new Go;if("HeNormal"===e)return new Zo;if("HeUniform"===e)return new Xo;if("LeCunNormal"===e)return new Yo;if("LeCunUniform"===e)return new Qo;{const t={};return t.className=e,t.config={},nl(t)}}return t instanceof Bo?t:nl(t)}let il=0;function al(){return il++}const ol={};function ll(t=""){return t in ol||(ol[t]=0),ol[t]+=1,t+ol[t].toString()}function ul(t){return Array.isArray(t)&&Array.isArray(t[0])}function hl(t){return 0===t.length?[]:Array.isArray(t[0])?t:[t]}function cl(t){let e;if(Array.isArray(t)){if(1!==t.length)throw new Ia("Expected Tensor length to be 1; got "+t.length);e=t[0]}else e=t;return e}function pl(t){if(Array.isArray(t)&&Array.isArray(t[0])){if(1===t.length)return(t=t)[0];throw new Ia("Expected exactly 1 Shape; got "+t.length)}return t}function dl(t){let e=0;for(const n of t)0===n.shape.length?e+=1:e+=n.shape.reduce((t,e)=>t*e);return e}class fl{constructor(t,e="float32",n="Variable",s=!0,r=null){this.dtype=null==e?"float32":e,this.shape=t.shape,this.id=al(),n=null==n?"Variable":n,this.originalName=co(n),this.name=po(this.originalName),this.trainable_=s,this.constraint=r,this.val=function(t,e=!0,n,s){return ct.makeVariable(t,e,n,s)}(t,this.trainable_,this.name,this.dtype)}read(){return this.assertNotDisposed(),this.val}write(t){return this.assertNotDisposed(),function(t,e){if(t.shape.toString()!==e.shape.toString())throw new Error("Shape mismatch: "+JSON.stringify(t.shape)+" vs. "+JSON.stringify(e.shape))}(this.val,t),this.val.id!==t.id&&(this.val.assign(t),null!=this.constraint&&this.val.assign(this.constraint.apply(this.val))),this}dispose(){this.assertNotDisposed(),this.val.dispose()}assertNotDisposed(){if(this.val.isDisposed)throw new Error(`LayersVariable ${this.name} is already disposed.`)}get trainable(){return this.trainable_}set trainable(t){this.trainable_=t,this.val.trainable=t}}function ml(t){return t.map(t=>t.read())}function gl(t){t.forEach(t=>{t[0].write(t[1])})}class yl{constructor(t){this.dtype=t.dtype,this.shape=t.shape,null!=t.shape?this.ndim=t.shape.length:this.ndim=t.ndim,this.maxNDim=t.maxNDim,this.minNDim=t.minNDim,this.axes=t.axes||{}}}class bl{constructor(t,e,n,s,r,i,a){this.dtype=t,this.shape=e,this.sourceLayer=n,this.inputs=s,this.callArgs=r,this.outputTensorIndex=a,this.id=al(),null!=i&&(this.originalName=co(i),this.name=po(this.originalName)),this.rank=e.length}}let wl=0;class vl{constructor(t,e){this.callArgs=e,this.id=wl++,this.outboundLayer=t.outboundLayer,this.inboundLayers=t.inboundLayers,this.nodeIndices=t.nodeIndices,this.tensorIndices=t.tensorIndices,this.inputTensors=t.inputTensors,this.outputTensors=t.outputTensors,this.inputMasks=t.inputMasks,this.outputMasks=t.outputMasks,this.inputShapes=t.inputShapes,this.outputShapes=t.outputShapes;for(const e of t.inboundLayers)null!=e&&e.outboundNodes.push(this);t.outboundLayer.inboundNodes.push(this)}getConfig(){const t=[];for(const e of this.inboundLayers)null!=e?t.push(e.name):t.push(null);return{outboundLayer:this.outboundLayer?this.outboundLayer.name:null,inboundLayers:t,nodeIndices:this.nodeIndices,tensorIndices:this.tensorIndices}}}let kl=0;class xl extends fe{constructor(t={}){super(),this._callHook=null,this._addedWeightNames=[],this._stateful=!1,this.id=kl++,this.activityRegularizer=null,this.inputSpec=null,this.supportsMasking=!1,this._trainableWeights=[],this._nonTrainableWeights=[],this._losses=[],this._updates=[],this._built=!1,this.inboundNodes=[],this.outboundNodes=[];let e=t.name;if(!e){const t=this.getClassName();e=Fa(t)+"_"+ll(t)}if(this.name=e,this.trainable_=null==t.trainable||t.trainable,null!=t.inputShape||null!=t.batchInputShape){let e;if(null!=t.batchInputShape)e=t.batchInputShape;else if(null!=t.inputShape){let n=null;null!=t.batchSize&&(n=t.batchSize),e=[n].concat(t.inputShape)}this.batchInputShape=e;let n=t.dtype;null==n&&(n=t.inputDType),null==n&&(n="float32"),this.dtype=n}null!=t.weights?this.initialWeights=t.weights:this.initialWeights=null,this._refCount=null,this.fastWeightInitDuringBuild=!1}static nodeKey(t,e){return t.name+"_ib-"+e.toString()}getNodeAtIndex(t,e){if(0===this.inboundNodes.length)throw new Sa(`The layer has never been called and thus has no defined ${e}.`);if(this.inboundNodes.length<=t)throw new Ia(`Asked to get ${e} at node ${t}, but the layer has only ${this.inboundNodes.length} inbound nodes.`);return this.inboundNodes[t]}getInputAt(t){return za(this.getNodeAtIndex(t,"input").inputTensors)}getOutputAt(t){return za(this.getNodeAtIndex(t,"output").outputTensors)}get input(){if(this.inboundNodes.length>1)throw new xa("Layer "+this.name+' has multiple inbound nodes, hence the notion of "layer input" is ill-defined. Use `getInputAt(nodeIndex)` instead.');if(0===this.inboundNodes.length)throw new xa("Layer "+this.name+" is not connected, no input to return.");return za(this.getNodeAtIndex(0,"input").inputTensors)}get output(){if(0===this.inboundNodes.length)throw new xa("Layer "+this.name+" has no inbound nodes.");if(this.inboundNodes.length>1)throw new xa("Layer "+this.name+' has multiple inbound nodes, hence the notion of "layer output" is ill-defined. Use `getOutputAt(nodeIndex)` instead.');return za(this.getNodeAtIndex(0,"output").outputTensors)}get losses(){return this._losses}calculateLosses(){return this.losses.map(t=>t())}get updates(){return this._updates}get built(){return this._built}set built(t){this._built=t}get trainable(){return this.trainable_}set trainable(t){this._trainableWeights.forEach(e=>e.trainable=t),this.trainable_=t}get trainableWeights(){return this.trainable_?this._trainableWeights.filter(t=>t.trainable):[]}set trainableWeights(t){this._trainableWeights=t}get nonTrainableWeights(){return this.trainable?this._trainableWeights.filter(t=>!t.trainable).concat(this._nonTrainableWeights):this._trainableWeights.concat(this._nonTrainableWeights)}set nonTrainableWeights(t){this._nonTrainableWeights=t}get weights(){return this.trainableWeights.concat(this.nonTrainableWeights)}get stateful(){return this._stateful}resetStates(){if(!this.stateful)throw new Error("Cannot call the resetStates() method of a non-stateful Layer object.")}assertInputCompatibility(t){if(t=Ca(t),null==this.inputSpec||0===this.inputSpec.length)return;const e=Ca(this.inputSpec);if(t.length!==e.length)throw new Ia(`Layer ${this.name} expects ${e.length} inputs, but it received ${t.length} input tensors. Input received: `+t);for(let n=0;n<t.length;n++){const s=t[n],r=e[n];if(null==r)continue;const i=s.rank;if(null!=r.ndim&&i!==r.ndim)throw new Ia(`Input ${n} is incompatible with layer ${this.name}: expected ndim=${r.ndim}, found ndim=${i}`);if(null!=r.maxNDim&&i>r.maxNDim)throw new Ia(`Input ${n} is incompatible with layer ${this.name}: expected max_ndim=${r.maxNDim}, found ndim=${i}`);if(null!=r.minNDim&&i<r.minNDim)throw new Ia(`Input ${n} is incompatible with layer ${this.name}: expected min_ndim=${r.minNDim}, found ndim=${i}.`);if(null!=r.dtype&&s.dtype!==r.dtype)throw new Ia(`Input ${n} is incompatible with layer ${this.name} : expected dtype=${r.dtype}, found dtype=${s.dtype}.`);if(r.axes){const t=s.shape;for(const e in r.axes){const s=Number(e),i=r.axes[e],a=s>=0?t[s]:t[t.length+s];if(null!=i&&-1===[i,null].indexOf(a))throw new Ia(`Input ${n} is incompatible with layer ${this.name}: expected axis ${s} of input shape to have value ${i} but got shape ${t}.`)}}if(null!=r.shape)for(let t=0;t<r.shape.length;++t){const e=r.shape[t],i=s.shape[t];if(null!=e&&null!=i&&e!==i)throw new Ia(`Input ${n} is incompatible with layer ${this.name}: expected shape=${r.shape}, found shape=${s.shape}.`)}}}call(t,e){return t}invokeCallHook(t,e){null!=this._callHook&&this._callHook(t,e)}setCallHook(t){this._callHook=t}clearCallHook(){this._callHook=null}apply(t,e){e=e||{},this.assertNotDisposed();const n=Ca(t);let s=!0;for(const t of n)if(!(t instanceof bl)){s=!1;break}let r=!0;for(const t of n)if(t instanceof bl){r=!1;break}if(s===r)throw new Ia("Arguments to apply() must be all SymbolicTensors or all Tensors");return ho(this.name,()=>{if(!this.built){this.assertInputCompatibility(t);const e=[];for(const n of Ca(t))e.push(n.shape);this.build(za(e)),this.built=!0,this.initialWeights&&this.setWeights(this.initialWeights),null===this._refCount&&r&&(this._refCount=1)}if(this.assertInputCompatibility(t),r){let s=this.call(t,e);const r=Ca(s),i=[];for(let t of r)-1!==n.indexOf(t)&&(t=t.clone()),i.push(t);if(s=za(i),null!=this.activityRegularizer)throw new Na("Layer invocation in the presence of activity regularizer(s) is not supported yet.");return s}{const n=function(t){t=Ca(t);const e=[];for(const n of t)e.push(n.shape);return za(e)}(t),s=this.computeOutputShape(n);let r;const i="float32";if(this.warnOnIncompatibleInputShape(Array.isArray(t)?n[0]:n),r=null!=s&&s.length>0&&Array.isArray(s[0])?s.map((n,s)=>new bl(i,n,this,Ca(t),e,this.name,s)):new bl(i,s,this,Ca(t),e,this.name),this.addInboundNode(t,r,null,null,n,s,e),this._refCount++,null!=this.activityRegularizer)throw new Na("Layer invocation in the presence of activity regularizer(s) is not supported yet.");return r}})}warnOnIncompatibleInputShape(t){if(null!=this.batchInputShape)if(t.length!==this.batchInputShape.length)console.warn("The rank of the input tensor provided (shape: "+JSON.stringify(t)+") does not match that of the "+`batchInputShape (${JSON.stringify(this.batchInputShape)}) of the layer `+this.name);else{let e=!1;this.batchInputShape.forEach((n,s)=>{null!=n&&null!=t[s]&&t[s]!==n&&(e=!0)}),e&&console.warn(`The shape of the input tensor (${JSON.stringify(t)}) does not match the expectation of layer ${this.name}: `+JSON.stringify(this.batchInputShape))}}get outputShape(){if(null==this.inboundNodes||0===this.inboundNodes.length)throw new xa(`The layer ${this.name} has never been called and thus has no defined output shape.`);const t=[];for(const e of this.inboundNodes){const n=JSON.stringify(e.outputShapes);-1===t.indexOf(n)&&t.push(n)}if(1===t.length){const t=this.inboundNodes[0].outputShapes;return Array.isArray(t)&&Array.isArray(t[0])&&1===t.length?t[0]:t}throw new xa(`The layer ${this.name} has multiple inbound nodes with different output shapes. Hence the notion of "output shape" is ill-defined for the layer.`)}countParams(){if(!this.built)throw new Sa(`You tried to call countParams() on ${this.name}, but the layer is not built yet. Build it first by calling build(batchInputShape).`);return dl(this.weights)}build(t){this.built=!0}getWeights(t=!1){return ml(t?this.trainableWeights:this.weights)}setWeights(t){be(()=>{const e=this.weights;if(e.length!==t.length)throw new Ia(`You called setWeights(weights) on layer "${this.name}" with a weight list of length ${t.length}, but the layer was expecting ${e.length} weights. Provided weights: ${t}...`);if(0===e.length)return;const n=[],s=ml(e);for(let r=0;r<s.length;++r){const i=s[r],a=e[r],o=t[r];if(!u(i.shape,o.shape))throw new Ia(`Layer weight shape ${i.shape} not compatible with provided weight shape `+o.shape);n.push([a,o])}gl(n)})}addWeight(t,e,n,s,r,i,a){if(-1!==this._addedWeightNames.indexOf(t))throw new Ia(`Duplicate weight name ${t} for layer ${this.name}`);this._addedWeightNames.push(t),null==n&&(n="float32"),this.fastWeightInitDuringBuild&&(s=rl("zeros"));const o=s.apply(e,n),l=new fl(o,n,t,i,a);return o.dispose(),null!=r&&this.addLoss(()=>r.apply(l.read())),null==i&&(i=!0),i?this._trainableWeights.push(l):this._nonTrainableWeights.push(l),l}setFastWeightInitDuringBuild(t){this.fastWeightInitDuringBuild=t}addLoss(t){null==t||Array.isArray(t)&&0===t.length||(t=Ca(t),void 0!==this._losses&&null!==this._losses&&this.losses.push(...t))}computeOutputShape(t){return t}computeMask(t,e){if(!this.supportsMasking){if(null!=e){if(!Array.isArray(e))throw new TypeError(`Layer ${this.name} does not support masking, but was passed an inputMask.`);e.forEach(t=>{if(null!=t)throw new TypeError(`Layer ${this.name} does not support masking, but was passed an inputMask.`)})}return null}return e}addInboundNode(t,e,n,s,r,i,a=null){const o=Ca(t);e=Ca(e),n=Ca(n),s=Ca(s),r=hl(r),i=hl(i);const l=[],u=[],h=[];for(const t of o)l.push(t.sourceLayer),u.push(t.nodeIndex),h.push(t.tensorIndex);new vl({outboundLayer:this,inboundLayers:l,nodeIndices:u,tensorIndices:h,inputTensors:o,outputTensors:e,inputMasks:n,outputMasks:s,inputShapes:r,outputShapes:i},a);for(let t=0;t<e.length;t++)e[t].sourceLayer=this,e[t].nodeIndex=this.inboundNodes.length-1,e[t].tensorIndex=t}getConfig(){const t={name:this.name,trainable:this.trainable};return null!=this.batchInputShape&&(t.batchInputShape=this.batchInputShape),null!=this.dtype&&(t.dtype=this.dtype),t}disposeWeights(){return this.weights.forEach(t=>t.dispose()),this.weights.length}assertNotDisposed(){if(0===this._refCount)throw new Error(`Layer '${this.name}' is already disposed.`)}dispose(){if(!this.built)throw new Error(`Cannot dispose Layer ${this.name} because it has not been built yet.`);if(null===this._refCount)throw new Error(`Cannot dispose Layer ${this.name} because it has not been used yet.`);this.assertNotDisposed();let t=0;return 0==--this._refCount&&(t=this.disposeWeights()),{refCountAfterDispose:this._refCount,numDisposedVariables:t}}}class Sl extends xl{constructor(t){if(super({dtype:t.dtype,name:null!=t.name?t.name:ll("input").toString()}),null==t.batchSize&&(t.batchSize=null),null==t.sparse&&(t.sparse=!1),this.trainable=!1,this.built=!0,this.sparse=t.sparse,null!=t.inputShape&&null!=t.batchInputShape)throw new Ia("Only provide the inputShape OR batchInputShape argument to inputLayer, not both at the same time.");let e=t.batchInputShape;if(null==e){if(null==t.inputShape)throw new Ia("An InputLayer should be passed either a `batchInputShape` or an `inputShape`.");e=[t.batchSize].concat(t.inputShape)}else if(null!=t.batchSize)throw new Ia("Cannot specify batchSize if batchInputShape is specified when creating an InputLayer.");const n=t.dtype||"float32";this.batchInputShape=e,this.dtype=n,this.inputSpec=[{shape:e}];const s=new bl(this.dtype,this.batchInputShape,this,[],{},this.name);s.nodeIndex=0,s.tensorIndex=0,new vl({outboundLayer:this,inboundLayers:[],nodeIndices:[],tensorIndices:[],inputTensors:[s],outputTensors:[s],inputMasks:[null],outputMasks:[null],inputShapes:[e],outputShapes:[e]})}apply(t,e){throw new Ia("Cannot pass any input to an InputLayer's apply() method. InputLayer name: "+this.name)}dispose(){return{refCountAfterDispose:this._refCount,numDisposedVariables:0}}getConfig(){return{batchInputShape:this.batchInputShape,dtype:this.dtype,sparse:this.sparse,name:this.name}}}async function Il(t){if(null==t)return;const e=[],n=[],s=[];for(const r in t){const i=t[r];if("number"!=typeof i){const t=i;e.push(t.data()),n.push(r),s.push(t)}}if(e.length>0){const r=await Promise.all(e);for(let e=0;e<r.length;++e)t[n[e]]=r[e][0];we(s)}}function Nl(t){if(null!=t)for(const e in t){const n=t[e];"number"!=typeof n&&n.dispose()}}var El;Sl.className="InputLayer",ge(Sl),function(t){t[t.SILENT=0]="SILENT",t[t.VERBOSE=1]="VERBOSE"}(El||(El={}));class Al{constructor(){this.validationData=null}setParams(t){this.params=t}async onEpochBegin(t,e){}async onEpochEnd(t,e){}async onBatchBegin(t,e){}async onBatchEnd(t,e){}async onTrainBegin(t){}async onTrainEnd(t){}setModel(t){}}class Tl{constructor(t,e=10){null==t&&(t=[]),this.callbacks=t,this.queueLength=e}append(t){this.callbacks.push(t)}setParams(t){for(const e of this.callbacks)e.setParams(t)}setModel(t){for(const e of this.callbacks)e.setModel(t)}async onEpochBegin(t,e){null==e&&(e={});for(const n of this.callbacks)await n.onEpochBegin(t,e)}async onEpochEnd(t,e){null==e&&(e={});for(const n of this.callbacks)await n.onEpochEnd(t,e)}async onBatchBegin(t,e){null==e&&(e={});for(const n of this.callbacks)await n.onBatchBegin(t,e)}async onBatchEnd(t,e){null==e&&(e={});for(const n of this.callbacks)await n.onBatchEnd(t,e)}async onTrainBegin(t){null==t&&(t={});for(const e of this.callbacks)await e.onTrainBegin(t)}async onTrainEnd(t){null==t&&(t={});for(const e of this.callbacks)await e.onTrainEnd(t)}}class Dl extends Al{constructor(){super()}async onEpochBegin(t){this.seen=0,this.totals={}}async onBatchEnd(t,e){null==e&&(e={});const n=null==e.size?0:e.size;this.seen+=n;for(const t in e){const s=e[t];if("number"==typeof s)this.totals.hasOwnProperty(t)||(this.totals[t]=0),this.totals[t]=this.totals[t]+s*n;else{let e;t in this.totals?e=this.totals[t]:this.totals[t]=0;const r=be(()=>xe(this.totals[t],Ne(s,n)));this.totals[t]=r,null!=e&&e.dispose()}}}async onEpochEnd(t,e){if(null!=e)for(const t of this.params.metrics)null!=this.totals[t]&&("number"==typeof this.totals[t]?e[t]=this.totals[t]/this.seen:be(()=>{const n=Ne(Ie(1,this.seen),this.totals[t]);e[t]=n,this.totals[t].dispose(),ve(e[t])}))}}class zl extends Al{async onTrainBegin(t){this.epoch=[],this.history={}}async onEpochEnd(t,e){null==e&&(e={}),this.epoch.push(t);for(const t in e)null==this.history[t]&&(this.history[t]=[]),this.history[t].push(e[t])}async syncData(){const t=[],e=[],n=[];for(const s in this.history){const r=this.history[s];for(let i=0;i<r.length;++i)if("number"!=typeof r[i]){const a=r[i];t.push(a.data()),e.push(s),n.push(i)}}const s=await Promise.all(t);for(let t=0;t<s.length;++t){this.history[e[t]][n[t]].dispose(),this.history[e[t]][n[t]]=s[t][0]}}}class Cl extends Al{constructor(t,e){if(super(),this.currentEpoch=0,this.yieldEvery=e||"auto","auto"===this.yieldEvery&&(this.yieldEvery=125),"never"===this.yieldEvery&&null!=t.onYield)throw new Error("yieldEvery is `never` but you provided an `onYield` callback. Either change `yieldEvery` or remove the callback");m(this.yieldEvery)&&(this.maybeWait=function(t,e){let n,s=$();return(...r)=>{const i=$();return i-s<e||(s=i,n=t(...r)),n}}(this.maybeWait.bind(this),this.yieldEvery)),this.trainBegin=t.onTrainBegin,this.trainEnd=t.onTrainEnd,this.epochBegin=t.onEpochBegin,this.epochEnd=t.onEpochEnd,this.batchBegin=t.onBatchBegin,this.batchEnd=t.onBatchEnd,this.yield=t.onYield}async maybeWait(t,e,n){const s=[];null!=this.yield&&(await Il(n),s.push(this.yield(t,e,n))),s.push(ei()),await Promise.all(s)}async onEpochBegin(t,e){this.currentEpoch=t,null!=this.epochBegin&&(await Il(e),await this.epochBegin(t,e))}async onEpochEnd(t,e){const n=[];null!=this.epochEnd&&(await Il(e),n.push(this.epochEnd(t,e))),"epoch"===this.yieldEvery&&n.push(ei()),await Promise.all(n)}async onBatchBegin(t,e){null!=this.batchBegin&&(await Il(e),await this.batchBegin(t,e))}async onBatchEnd(t,e){const n=[];null!=this.batchEnd&&(await Il(e),n.push(this.batchEnd(t,e))),"batch"===this.yieldEvery?n.push(ei()):m(this.yieldEvery)&&n.push(this.maybeWait(this.currentEpoch,t,e)),await Promise.all(n)}async onTrainBegin(t){null!=this.trainBegin&&(await Il(t),await this.trainBegin(t))}async onTrainEnd(t){null!=this.trainEnd&&(await Il(t),await this.trainEnd(t))}}function Fl(t,e){if(null==t&&(t={}),t instanceof Al)return[t];if(Array.isArray(t)&&t[0]instanceof Al)return t;return Ca(t).map(t=>new Cl(t,e))}class Rl{constructor(){}static registerCallbackConstructor(t,e){r(t>=0&&Number.isInteger(t),()=>"Verbosity level is expected to be an integer >= 0, but got "+t),Rl.checkForDuplicate(e),null==Rl.constructors[t]&&(Rl.constructors[t]=[]),Rl.constructors[t].push(e)}static checkForDuplicate(t){for(const e in Rl.constructors){Rl.constructors[+e].forEach(e=>{if(e===t)throw new Ia("Duplicate callback constructor.")})}}static clear(){Rl.constructors={}}static createCallbacks(t){const e=[];for(const n in Rl.constructors){const s=+n;t>=s&&e.push(...Rl.constructors[s])}return e.map(t=>new t)}}function Ll(t,e,n,s,r,i,a,o,l){const u=new zl,h=[new Dl,...Rl.createCallbacks(e)];null!=t&&h.push(...t),h.push(u);const c=new Tl(h);return c.setParams({epochs:n,initialEpoch:s,samples:r,steps:i,batchSize:a,verbose:e,doValidation:o,metrics:l}),{callbackList:c,history:u}}function Ml(t,e={},n=!1){return _a(t,me.getMap().classNameMap,e,"layer",n)}function _l(t,e){return be(()=>{"float32"!==t.dtype&&(t=t.asType("float32"));const n=ss(Fo(t),e,!0),s=_n(n.shape,ka()),r=mr(fs(n,s));return Ie(t,r)})}function $l(t,e){return be(()=>ms(Fo(ns(e,t)),-1))}function Ol(t,e){return be(()=>ms(Ee(ns(e,t)),-1))}function Bl(t,e){return be(()=>{const n=ns(t,e),s=rn(Ee(t),ka(),Number.MAX_VALUE),r=Ee(Ie(n,s));return Ne(100,ms(r,-1))})}function Pl(t,e,n=!1){return be(()=>{if(n)e=ur(e);else{const t=ss(e,e.shape.length-1,!0);e=Ie(e,t)}return e=rn(e,ka(),1-ka()),Yn(ss(Ne(t.toFloat(),Jn(e)),e.shape.length-1))})}function Ul(t,e,n=!1){return be(()=>{const s=$n(function(t){const e=[go(t.shape)];return t.reshape(e)}(t)).toInt(),r=(e=rn(e,ka(),1-ka())).shape;return Pl(ce(s,r[r.length-1]).reshape(r),e,n)})}function Wl(t,e){return be(()=>{let n;return n=rn(e,ka(),1-ka()),n=Jn(Ie(n,ns(1,n))),ms(function(t,e){if(!u(t.shape,e.shape))throw new Ia(`logits and labels must have the same shape, but got shapes ${JSON.stringify(t.shape)} and ${JSON.stringify(e.shape)}`);return be(()=>{const n=e.relu(),s=e.abs().neg();return n.sub(e.mul(t)).add(s.exp().log1p())})}(t,n),-1)})}function jl(t,e){return be(()=>{const n=_l(t,-1),s=_l(e,-1),r=Ne(n,s);return Yn(ss(r,-1))})}Rl.constructors={};const ql={meanSquaredError:$l,meanAbsoluteError:Ol,meanAbsolutePercentageError:Bl,meanSquaredLogarithmicError:function(t,e){return be(()=>{const n=rn(e,ka(),Number.MAX_VALUE),s=Jn(xe(1,n)),r=rn(t,ka(),Number.MAX_VALUE),i=Jn(xe(1,r));return ms(Fo(ns(s,i)),-1)})},squaredHinge:function(t,e){return be(()=>{const n=fs(0,ns(1,Ne(t,e)));return ms(Fo(n),-1)})},hinge:function(t,e){return be(()=>{const n=fs(0,ns(1,Ne(t,e)));return ms(n,-1)})},categoricalHinge:function(t,e){return be(()=>{const n=ss(Ne(t,e),-1),s=es(Ne(ns(1,t),e),-1);return fs(0,xe(1,ns(s,n)))})},logcosh:function(t,e){return be(()=>{const n=Math.log(2),s=ns(e,t),r=ns(xe(s,Qn(Ne(-2,s))),n);return ms(r,-1)})},categoricalCrossentropy:Pl,sparseCategoricalCrossentropy:Ul,binaryCrossentropy:Wl,kullbackLeiblerDivergence:function(t,e){return be(()=>{const n=rn(t,ka(),1),s=rn(e,ka(),1);return ss(Ne(t,Jn(Ie(n,s))),-1)})},poisson:function(t,e){return be(()=>{const n=Jn(xe(ka(),e));return ms(ns(e,Ne(t,n)),-1)})},cosineProximity:jl};function Kl(t){if("string"==typeof t){if(t in ql)return ql[t];let e="Unknown loss "+t;throw t.toLowerCase().includes("softmaxcrossentropy")&&(e=`Unknown loss ${t}. Use "categoricalCrossentropy" as the string name for tf.losses.softmaxCrossEntropy`),new Ia(e)}return t}function Vl(t,e){return be(()=>{const n=Ne(.5,Ns(e)),s=ko(Bn(e,n),t.dtype);return ms(In(t,s),-1)})}function Hl(t,e){return be(()=>ko(In(Ce(t,-1),Ce(e,-1)),"float32"))}function Gl(t,e){return Wl(t,e)}function Jl(t,e){return t.rank===e.rank&&(t=t.squeeze([t.rank-1])),(e=e.argMax(-1)).dtype!==t.dtype&&(e=e.asType(t.dtype)),In(t,e).asType("float32")}const Zl=Pl,Xl=Ul,Yl={binaryAccuracy:Vl,categoricalAccuracy:Hl,precision:function(t,e){return be(()=>{const n=function(t,e){return be(()=>ls(t.equal(1),e.equal(1)).sum().cast("float32"))}(t,e),s=function(t,e){return be(()=>ls(t.equal(0),e.equal(1)).sum().cast("float32"))}(t,e),r=n.add(s);return Nn(Bn(r,0),n.div(r),0).cast("float32")})},categoricalCrossentropy:Zl,sparseCategoricalCrossentropy:Xl,mse:$l,MSE:$l,mae:Ol,MAE:Ol,mape:Bl,MAPE:Bl,cosine:jl};function Ql(t){if("string"==typeof t&&t in Yl)return Yl[t];if("string"!=typeof t&&null!=t)return t;throw new Ia("Unknown metric "+t)}function tu(t){if(Ta(null!==t,"Unknown LossOrMetricFn "+t),"string"==typeof t)return t;{let e;for(const n of Object.keys(ql))if(ql[n]===t){e=n;break}if(void 0!==e)return e;for(const n of Object.keys(Yl))if(Yl[n]===t){e=n;break}return void 0!==e?e:t.name}}function eu(t,e,n=!1){if(null==t||"object"!=typeof t||Object.getPrototypeOf(t)!==Object.prototype||!function t(e){if(null===e)return!0;if("object"==typeof e){if(Object.getPrototypeOf(e)===Object.prototype){const n=Object.keys(e);for(const s of n){if("string"!=typeof s)return!1;if(!t(e[s]))return!1}return!0}if(Array.isArray(e)){for(const n of e)if(!t(n))return!1;return!0}return!1}{const t=typeof e;return"string"===t||"number"===t||"boolean"===t}}(t))throw new Error("User-defined metadata is expected to be a JSON object, but is not.");if(n){const n=JSON.stringify(t);n.length>1048576&&console.warn(`User-defined metadata of model "${e}" is too large in size (length=${n.length} when serialized). It is not recommended to store such large objects in user-defined metadata. Please make sure its serialized length is <= 1048576.`)}}function nu(t,e,n,s=console.log){const r=function(t){let e=!0;const n=[],s=[];for(const e in t.nodesByDepth)n.push(t.nodesByDepth[e]);for(const t of n){if(t.length>1||1===t.length&&t[0].inboundLayers.length>1){e=!1;break}s.push(...t)}if(e)for(const n of t.layers){let t=!1;for(const r of n.inboundNodes)if(-1!==s.indexOf(r)){if(t){e=!1;break}t=!0}if(!e)break}return e}(t),i=["Layer (type)","Output shape","Param #"];let a;if(r?(e=e||65,n=n||[.45,.85,1]):(e=e||98,n=n||[.33,.55,.67,1]),n[n.length-1]<=1&&(n=n.map(t=>Math.floor(e*t))),!r){i.push("Receives inputs"),a=[];for(const e in t.nodesByDepth)a.push(...t.nodesByDepth[e])}s("_".repeat(e)),su(i,n,s),s("=".repeat(e));const o=t.layers;for(let t=0;t<o.length;++t)r?ru(o[t],n,s):iu(o[t],n,a,s),s((t===o.length-1?"=":"_").repeat(e));t.checkTrainableWeightsConsistency();const l=function(t){let e;e=null!=t.collectedTrainableWeights?dl(t.collectedTrainableWeights):dl(t.trainableWeights);return e}(t),u=dl(t.nonTrainableWeights);s("Total params: "+(l+u)),s("Trainable params: "+l),s("Non-trainable params: "+u),s("_".repeat(e))}function su(t,e,n=console.log){let s="";for(let n=0;n<t.length;++n)n>0&&(s=s.slice(0,s.length-1)+" "),s+=t[n],s=s.slice(0,e[n]),s+=" ".repeat(e[n]-s.length);n(s)}function ru(t,e,n){let s;try{s=JSON.stringify(t.outputShape)}catch(t){s="multiple"}su([`${t.name} (${t.getClassName()})`,s,t.countParams().toString()],e,n)}function iu(t,e,n,s){let r;try{r=JSON.stringify(t.outputShape)}catch(t){r="multiple"}const i=[];for(const e of t.inboundNodes)if(!(null!=n&&n.length>0&&-1===n.indexOf(e)))for(let t=0;t<e.inboundLayers.length;++t){const n=e.inboundLayers[t].name,s=e.nodeIndices[t],r=e.tensorIndices[t];i.push(`${n}[${s}][${r}]`)}const a=t.name,o=t.getClassName(),l=0===i.length?"":i[0];su([`${a} (${o})`,r,t.countParams().toString(),l],e,s);for(let t=1;t<i.length;++t)su(["","","",i[t]],e,s)}function au(t,e,n){return("inboundNodes"===t||"outputLayers"===t||"inputLayers"===t)&&0===e&&"string"==typeof n}function ou(t,e){if(null===t)return null;if("string"==typeof t)return Ra(t);if("number"==typeof t||"boolean"==typeof t)return t;if(t instanceof Array){const n=[],s=t.length;for(let r=0;r<s;++r){const s=t[r];au(e,r,s)?n.push(s):n.push(ou(s,e))}return n}{const e={};for(const n of Object.keys(t)){const s=t[n];if("name"===n&&"string"==typeof s)e[n]=s;else{const t=Ra(n);e[t]=ou(s,t)}}return e}}class lu{constructor(t){if(this.id2Value={},this.id2Mask={},this.name2Id={},t instanceof lu)for(const e in t.id2Value)this.id2Value[e]=t.id2Value[e],e in t.id2Mask&&(this.id2Mask[e]=t.id2Mask[e]);else{if(null==t)return;for(const e of t)this.add(e.key,e.value)}}add(t,e,n){if(null!=this.id2Value[t.id])throw new Ia(`Duplicate key: name=${t.name}, id=${t.id}`);return this.id2Value[t.id]=function(t,e){if(null==t.dtype||t.dtype===e.dtype)return e;try{return ee(e,t.dtype)}catch(n){throw new Ia(`The dtype of the feed (${e.dtype}) can not be cast to the dtype of the key '${t.name}' (${t.dtype}).`)}}(t,e),this.name2Id[t.name]=t.id,null!=n&&(this.id2Mask[t.id]=n),this}addFeed(t){this.add(t.key,t.value)}hasKey(t){return null!=this.id2Value[t.id]}names(){return Object.keys(this.name2Id)}getValue(t){if(t instanceof bl){if(null==this.id2Value[t.id])throw new Ia("Nonexistent key: "+t.name);return this.id2Value[t.id]}{const e=this.name2Id[t];if(null==e)throw new Ia("Feed dict has no SymbolicTensor name: "+t);return this.id2Value[e]}}getMask(t){if(t instanceof bl){if(null==this.id2Value[t.id])throw new Ia("Nonexistent key: "+t.name);return this.id2Mask[t.id]}{const e=this.name2Id[t];if(null==e)throw new Ia("Feed dict has no SymbolicTensor name: "+t);return this.id2Mask[e]}}disposeMasks(){null!=this.id2Mask&&we(this.id2Mask)}}const uu={},hu={};function cu(t,e,n,s){const i=null!=n&&n.training,a=Array.isArray(t),o=a?t:[t],l=o.map(t=>t.name),u=[],h=e.names();for(const t of l)-1!==h.indexOf(t)?u.push(e.getValue(t)):u.push(null);null!=s&&(s.maxNumTensors=-1/0,s.minNumTensors=1/0);const c=l.join(",")+"|"+e.names().join(",");let p,d;if(null==uu[c]){const t=function(t,e){r(null!=t&&t.length>0,()=>"Expected at least one fetch, got none");let n=[],s={};if(1===t.length){const r=du(t[0],e);n=r.sorted,s=r.recipientMap}else{const r=new Set;for(const i of t){const{sorted:t,recipientMap:a}=du(i,e);for(const e of t)r.has(e.name)||(n.push(e),r.add(e.name));for(const t in a)null==s[t]&&(s[t]=new Set),a[t].forEach(e=>s[t].add(e))}}return{sorted:n,recipientCounts:pu(s)}}(o,e);p=t.sorted,d=t.recipientCounts,uu[c]=p,hu[c]=d}p=uu[c],d={},i||Object.assign(d,hu[c]);const f=new lu(e);for(let t=0;t<p.length;++t){if(null!=s){const t=ye().numTensors;t>s.maxNumTensors&&(s.maxNumTensors=t),t<s.minNumTensors&&(s.minNumTensors=t)}const r=p[t],a=r.sourceLayer;if(a instanceof Sl)continue;const o=[],h=[],c=[];let m=!1;for(const t of r.inputs){const n=f.getValue(t),s=f.getMask(t);o.push(n),h.push(s),null!=s&&(m=!0),i||(d[t.name]--,0!==d[t.name]||e.hasKey(t)||-1!==l.indexOf(t.name)||n.isDisposed||!0===t.sourceLayer.stateful||c.push(n))}m&&((n=n||{}).mask=h[0]);const g=Ca(a.apply(o,n));let y=null;a.supportsMasking&&(y=a.computeMask(o,h));const b=fu(r),w=Array.isArray(b)?b:[b];for(let t=0;t<w.length;++t){f.hasKey(w[t])||f.add(w[t],g[t],Array.isArray(y)?y[0]:y);const e=l.indexOf(w[t].name);-1!==e&&(u[e]=g[t])}i||we(c)}return f.disposeMasks(),a?u:u[0]}function pu(t){const e={};for(const n in t)e[n]=t[n].size;return e}function du(t,e){const n=new Set,s=[],r={};for(const t of e.names())n.add(t);const i=[],a=[];for(i.push(t);i.length>0;){const t=i[i.length-1];if(n.has(t.name)){i.pop();continue}const e=a[a.length-1]===i.length-1;if(0===t.inputs.length||e)i.pop(),s.push(t),n.add(t.name),e&&a.pop();else{a.push(i.length-1);for(const e of t.inputs)null==r[e.name]&&(r[e.name]=new Set),r[e.name].add(t.name),n.has(e.name)||i.push(e)}}return{sorted:s,recipientMap:r}}function fu(t){let e;if(1===t.sourceLayer.inboundNodes.length)e=t.sourceLayer.output;else{let n=null;for(let e=0;e<t.sourceLayer.inboundNodes.length;++e)for(const s of t.sourceLayer.inboundNodes[e].outputTensors)if(s.id===t.id){n=e;break}e=t.sourceLayer.getOutputAt(n)}return e}class mu extends xl{constructor(t){if(super({}),this.containerNodes=new Set,this.name=t.name,null==this.name){const t=this.getClassName().toLowerCase();this.name=ll(t)}if(this.supportsMasking=!1,this.trainable_=!0,Array.isArray(t.inputs)?this.inputs=t.inputs.slice():this.inputs=[t.inputs],Array.isArray(t.outputs)?this.outputs=t.outputs.slice():this.outputs=[t.outputs],Oa(this.inputs).length!==this.inputs.length)throw new Ia("The list of inputs passed to the model is redundant. All inputs should only appear once. Found: "+this.inputs.map(t=>t.name));Oa(this.outputs).length!==this.outputs.length&&console.warn("The list of outputs passed to the model is redundant. All outputs should only appear once. Found: "+this.outputs.map(t=>t.name)),this.inputLayers=[],this.inputLayersNodeIndices=[],this.inputLayersTensorIndices=[],this.outputLayers=[],this.outputLayersNodeIndices=[],this.outputLayersTensorIndices=[],this.layers=[],this.internalContainerRefs=[];for(const t of this.outputs){const e=t.sourceLayer,n=t.nodeIndex,s=t.tensorIndex;this.outputLayers.push(e),this.outputLayersNodeIndices.push(n),this.outputLayersTensorIndices.push(s)}for(const t of this.inputs){const e=t.sourceLayer,n=t.nodeIndex,s=t.tensorIndex;Ta(0===n,"input layer has >1 nodes"),Ta(0===s,"input layer has >1 tensors"),this.inputLayers.push(e),this.inputLayersNodeIndices.push(n),this.inputLayersTensorIndices.push(s)}this.inputNames=[],this.outputNames=[],this.feedInputShapes=[],this.feedInputNames=[],this.feedOutputNames=[];for(let e=0;e<this.inputLayers.length;e++){const n=this.inputLayers[e];if(!(n instanceof Sl))throw new TypeError(`Input layers to a LayersModel must be InputLayer objects. Received inputs: ${t.inputs}. Input ${e} (0-based) originates from layer type ${n.getClassName()}.`);this.inputNames.push(n.name),this.feedInputShapes.push(n.batchInputShape),this.feedInputNames.push(n.name)}for(const t of this.outputLayers)this.outputNames.push(t.name);this.internalInputShapes=this.inputs.map(t=>t.shape),this.internalOutputShapes=this.outputs.map(t=>t.shape);const e={},n={},s={},r={},i={},a=[],o=(t,e,n,s,r,l)=>{null!=s&&null!=r&&null!=l||(s=t.sourceLayer,r=t.nodeIndex,l=t.tensorIndex);const u=s.inboundNodes[r];if(-1!==n.indexOf(u))throw new Sa(`The tensor ${t.name} at layer "${s.name}" is part of a cycle.`);if(-1!==e.indexOf(u))return;this.containerNodes.add(mu.nodeKey(s,r)),s.id in i||(i[s.id]=Object.keys(i).length),-1===n.indexOf(u)&&n.push(u);const h=u.inboundLayers.length;for(let t=0;t<h;t++){const s=u.inputTensors[t],r=u.inboundLayers[t],i=u.nodeIndices[t],a=u.tensorIndices[t];o(s,e,n,r,i,a)}for(e.push(u);n.indexOf(u)>=0;)n.splice(n.indexOf(u),1);a.push(u)},l=[],u=[];for(const t of this.outputs)o(t,l,u);const h=a.slice().reverse();for(const t of h){n[t.id]=t,t.id in e||(e[t.id]=0);let i=e[t.id];const a=null==s[t.outboundLayer.id]?0:s[t.outboundLayer.id];i=Math.max(i,a),s[t.outboundLayer.id]=i,r[t.outboundLayer.id]=t.outboundLayer,e[t.id]=i;for(let s=0;s<t.inboundLayers.length;s++){const r=t.inboundLayers[s],a=t.nodeIndices[s],o=r.inboundNodes[a],l=null==e[o.id]?0:e[o.id];e[o.id]=Math.max(i+1,l),n[o.id]=o}}const c={};for(const t in e){const s=e[t];s in c||(c[s]=[]),c[s].push(n[t])}const p={};for(const t in s){const e=s[t];e in p||(p[e]=[]),p[e].push(r[t])}let d=Object.keys(p).map(t=>parseInt(t,10)).sort($a);this.layers=[];for(const t of d){const e=p[t];e.sort((t,e)=>{const n=i[t.id],s=i[e.id];return n<s?-1:n>s?1:0});for(const t of e)t instanceof mu&&this.internalContainerRefs.push(t),this.layers.push(t)}this.layersByDepth=p,d=Object.keys(c).map(t=>parseInt(t,10)).sort($a);const f=this.inputs.slice(),m=[];for(const t of d)for(const e of c[t]){const t=e.outboundLayer;if(null!=t){for(const n of e.inputTensors)if(-1===f.indexOf(n))throw new Sa("Graph disconnected: cannot obtain value for tensor "+n+` at layer "${t.name}". The following previous layers were accessed without issue: `+m);for(const t of e.outputTensors)f.push(t);m.push(t.name)}}this.nodesByDepth=c;const g=this.layers.map(t=>t.name);for(const t of g){const e=g.filter(e=>e===t).length;if(1!==e)throw new Sa(`The name "${t}" is used ${e} times in the model. All layer names should be unique. Layer names: `+JSON.stringify(g))}this.outboundNodes=[],this.inboundNodes=[],new vl({outboundLayer:this,inboundLayers:[],nodeIndices:[],tensorIndices:[],inputTensors:this.inputs,outputTensors:this.outputs,inputMasks:this.inputs.map(t=>null),outputMasks:this.outputs.map(t=>null),inputShapes:this.inputs.map(t=>t.shape),outputShapes:this.outputs.map(t=>t.shape)}),this.built=!0,this._refCount=1}assertNotDisposed(){if(0===this._refCount)throw new Error(`Container '${this.name}' is already disposed.`)}dispose(){this.assertNotDisposed();const t={refCountAfterDispose:null,numDisposedVariables:0};if(0==--this._refCount){for(const e of this.layers)t.numDisposedVariables+=e.dispose().numDisposedVariables;for(const e of this.internalContainerRefs)t.numDisposedVariables+=e.dispose().numDisposedVariables}return t.refCountAfterDispose=this._refCount,t}get trainable(){return this.trainable_}set trainable(t){this.layers.forEach(e=>{e._trainableWeights.forEach(e=>e.trainable=t)}),this.trainable_=t}get trainableWeights(){if(this._trainableWeights.length>0)throw new Ia("Container instance unexpectedly contains _trainableWeights.The trainable weights of a Container are a union of the trainable weights of its consituent Layers. Its own _trainableWeights must remain an empty Array.");if(!this.trainable)return[];let t=[];for(const e of this.layers)t=t.concat(e.trainableWeights);return t}get nonTrainableWeights(){const t=[];for(const e of this.layers)t.push(...e.nonTrainableWeights);if(!this.trainable){const e=[];for(const t of this.layers)e.push(...t.trainableWeights);return e.concat(t)}return t}get weights(){return this.trainableWeights.concat(this.nonTrainableWeights)}loadWeights(t,e=!0){const n={};let s=0;for(const t of this.layers)for(const e of t.weights){if(null!=n[e.originalName])throw new Ia("Duplicate weight name: "+e.originalName);n[e.originalName]=e,s++}const r=[];for(const s in t){let i=s;if(null==n[s]){const t=s.split("/");i=t.slice(0,-2).concat([t[t.length-1]]).join("/")}if(null!=n[i])r.push([n[i],t[s]]);else if(e)throw new Ia("Provided weight data has no target variable: "+s);delete n[i]}if(e){const t=[];for(const e in n)t.push(e);if(t.length>0)throw new Ia(`${t.length} of ${s} weights are not set: `+t)}gl(r)}updatedConfig(){const t=this.getConfig(),e={};return e.className=this.getClassName(),e.config=t,e.kerasVersion="tfjs-layers 3.0.0",e.backend="TensorFlow.js",e}toJSON(t,e=!0){const n=function t(e,n){if(null==e)return null;if("string"==typeof e)return Fa(e);if("number"==typeof e||"boolean"==typeof e)return e;if(e instanceof Array){const s=[],r=e.length;for(let i=0;i<r;++i){const r=e[i];au(n,i,r)?s.push(r):s.push(t(r,n))}return s}{const n={};for(const s of Object.keys(e)){const r=e[s],i=Fa(s);n[i]="name"!==s&&"className"!==s||"string"!=typeof r?t(r,s):r}return n}}(this.updatedConfig());return e?JSON.stringify(n):n}call(t,e){return be(()=>{t=Ca(t);const n=new lu;for(let e=0;e<this.inputs.length;++e)n.add(this.inputs[e],t[e]);return cu(this.outputs,n,e)})}computeMask(t,e){return be(()=>{let n;return t=Ca(t),n=null==e?Aa(null,t.length):Ca(e),this.runInternalGraph(t,n)[1]})}computeOutputShape(t){const e=hl(t);if(e.length!==this.inputLayers.length)throw new Ia(`Invalid inputShape argument ${t}: model has ${this.inputLayers.length} tensor inputs.`);const n={};for(let t=0;t<e.length;t++){const s=this.inputLayers[t],r=e[t];n[s.name+"_0_0"]=r}const s=Object.keys(this.nodesByDepth).map(t=>parseInt(t,10)).sort($a);if(s.length>1)for(const t of s){const e=this.nodesByDepth[t];for(const t of e){const e=t.outboundLayer;if(-1!==this.inputLayers.map(t=>t.id).indexOf(e.id))continue;const s=[];for(let e=0;e<t.inboundLayers.length;e++){const r=t.inboundLayers[e],i=t.nodeIndices[e],a=t.tensorIndices[e],o=n[`${r.name}_${i}_${a}`];s.push(o)}const r=hl(e.computeOutputShape(za(s))),i=e.inboundNodes.indexOf(t);for(let t=0;t<r.length;t++){n[`${e.name}_${i}_${t}`]=r[t]}}}const r=[],i=[];for(let t=0;t<this.outputLayers.length;t++){const e=this.outputLayers[t],n=this.outputLayersNodeIndices[t],s=this.outputLayersTensorIndices[t],r=`${e.name}_${n}_${s}`;i.push(r)}for(let t=0;t<i.length;t++){const e=i[t];Ta(e in n),r.push(n[e])}return za(r)}runInternalGraph(t,e){null==e&&(e=Aa(null,t.length));const n={};for(let s=0;s<this.inputs.length;++s){const r=this.inputs[s],i=t[s],a=e[s];n[r.id]=[i,a]}const s=Object.keys(this.nodesByDepth).map(t=>parseInt(t,10)).sort($a);for(const t of s){const e=this.nodesByDepth[t];for(const t of e){const e=t.outboundLayer,s=t.inputTensors,r=t.outputTensors,i=new Array;for(const t of s)t.id in n&&i.push(n[t.id]);if(i.length===s.length){let s,a,o,l,u={};if(null!=t.callArgs&&(u=t.callArgs),1===i.length){const[t,n]=i[0];null==u.mask&&(u.mask=n),o=Ca(e.call(t,u)),l=Ca(e.computeMask(t,n)),s=[t],a=[n]}else s=i.map(t=>t[0]),a=i.map(t=>t[1]),null==u.mask&&(u.mask=a),o=Ca(e.call(s,u)),l=Ca(e.computeMask(s,a));if(e.activityRegularizer)throw new Na("LayersModel invocation with concrete Tensor value(s) in the presence of activity regularizer(s) is not supported yet.");for(let t=0;t<r.length;++t){const e=r[t],s=o[t],i=l[t];n[e.id]=[s,i]}}}}const r=[],i=[],a=[];for(const t of this.outputs){Ta(t.id in n,`Could not compute output ${t.name} : ${t.id}`);const[e,s]=n[t.id];a.push(e.shape),r.push(e),i.push(s)}return[r,i,a]}buildNodeConversionMap(t){const e={};let n;for(const t of this.layers){n=t instanceof mu?1:0;for(let s=0;s<t.inboundNodes.length;s++){const r=mu.nodeKey(t,s);this.containerNodes.has(r)&&(e[r]=n,n+=1)}}return e}getLayer(t,e){if(null!=e){if(this.layers.length<=e)throw new Ia(`Was asked to retrieve layer at index ${e}, but model only has ${this.layers.length} layer(s).`);return this.layers[e]}if(null==t)throw new Ia("Provide either a layer name or layer index");for(const e of this.layers)if(e.name===t)return e;throw new Ia("No such layer: "+t)}calculateLosses(){return be(()=>{const t=[];for(const e of this.layers)for(let n=0;n<e.inboundNodes.length;++n){const s=mu.nodeKey(e,n);this.containerNodes.has(s)&&t.push(...e.calculateLosses())}return t})}getConfig(){const t={name:this.name},e=this.buildNodeConversionMap(this.layers),n=[];for(const t of this.layers){const s=t.getClassName(),r=t.getConfig(),i=[];for(let n=0;n<t.inboundNodes.length;n++){const s=t.inboundNodes[n],r=mu.nodeKey(t,n);let a={};if(this.containerNodes.has(r)){if(s.callArgs)try{JSON.stringify(s.callArgs),a=s.callArgs}catch(e){console.warn(`Layer ${t.name} was passed non-serializable keyword arguments: `+s.callArgs+". They will not be included in the serialized model (and thus will be missing at deserialization time)."),a={}}if(s.inboundLayers.length>0){const t=[];for(let n=0;n<s.inboundLayers.length;n++){const r=s.inboundLayers[n],i=s.nodeIndices[n],o=s.tensorIndices[n];let l=e[mu.nodeKey(r,i)];null==l&&(l=0),t.push([r.name,l,o,a])}i.push(t)}}}const a={};a.name=t.name,a.className=s,a.config=r,a.inboundNodes=i,n.push(a)}t.layers=n;const s=[];for(let t=0;t<this.inputLayers.length;t++){const n=this.inputLayers[t],r=this.inputLayersNodeIndices[t],i=mu.nodeKey(n,r);if(!this.containerNodes.has(i))continue;let a=e[i];null==a&&(a=0);const o=this.inputLayersTensorIndices[t];s.push([n.name,a,o])}t.inputLayers=s;const r=[];for(let t=0;t<this.outputLayers.length;t++){const n=this.outputLayers[t],s=this.outputLayersNodeIndices[t],i=mu.nodeKey(n,s);if(!this.containerNodes.has(i))continue;let a=e[i];null==a&&(a=0);const o=this.outputLayersTensorIndices[t];r.push([n.name,a,o])}return t.outputLayers=r,t}static fromConfig(t,e,n={},s=!1){const r={},i={};function a(t,e){t.name in i?i[t.name].push(e):i[t.name]=[e]}function o(t,e){const n=[];let s;for(const i of e){const o=i[0],l=i[1],u=i[2];if(s=null==i[3]?{}:i[3],!(o in r))return void a(t,e);const h=r[o];if(h.inboundNodes.length<=l)return void a(t,e);const c=h.inboundNodes[l];n.push(c.outputTensors[u])}n.length>0&&t.apply(za(n),s)}function l(t){const n=t.name,i=Ml(t,null!=e.customObjects?e.customObjects:{});i.setFastWeightInitDuringBuild(s),r[n]=i;t.inboundNodes.forEach(t=>{if(!(t instanceof Array))throw new Ia("Corrupted configuration, expected array for nodeData: "+t);a(i,t)})}const u=e.name,h=e.layers;for(const t of h)l(t);for(;!Ba(i);)for(const t of h){const e=r[t.name];if(e.name in i){const t=i[e.name];delete i[e.name];for(const n of t)o(e,n)}}const c=[],p=[],d=e.inputLayers;for(const t of d){const e=t[0],n=t[1],s=t[2];Ta(e in r);const i=r[e].inboundNodes[n].outputTensors;c.push(i[s])}const f=e.outputLayers;for(const t of f){const e=t[0],n=t[1],s=t[2];Ta(e in r);const i=r[e].inboundNodes[n].outputTensors;p.push(i[s])}return new t({inputs:c,outputs:p,name:u})}get stateful(){if(this._stateful)throw new Ia("Container instance unexpectedly has _stateful = true. The statefulness of a Container is determined by the Layers it contains. Its _stateful property must remain the default false.");for(const t of this.layers)if(t.stateful)return!0;return!1}resetStates(){be(()=>{this.layers.forEach(t=>{t.stateful&&t.resetStates()})})}}function gu(t,e){return function(t,e,n){const s=e.length;if(null==t||Array.isArray(t)&&0===t.length)return e.map(t=>null);if(1===s)return Array.isArray(t)&&1===t.length?t:"object"==typeof t&&e[0]in t?[t[e[0]]]:[t];if(Array.isArray(t)){if(t.length!==s)throw new Error(`Provided ${n} is an array of ${t.length} element(s), but the model has ${s} outputs. Make sure a set of weights is provided for each model output.`);return t}if("object"==typeof t&&Object.keys(t).length>0&&"object"==typeof t[Object.keys(t)[0]]){const n=[];return e.forEach(e=>{e in t?n.push(t[e]):n.push(null)}),n}throw new Error(`The model has multiple (${s}) outputs, so ${n} must be either an array with ${s} elements or an object with ${e} keys. Provided ${n} not understood: ${JSON.stringify(t)}`)}(t,e,"classWeight")}async function yu(t,e,n,s){if(null!=e||null!=s)throw new Error("Support sampleWeight is not implemented yet");if(null!=n){const e=be(()=>{if(1===t.shape.length)return t.clone();if(2===t.shape.length){if(t.shape[1]>1){const e=1;return t.argMax(e)}if(1===t.shape[1])return t.reshape([t.shape[0]]);throw new Error(`Encountered unexpected last-dimension size (${t.shape[1]}) during handling of class weights. The size is expected to be >= 1.`)}throw new Error(`Unexpected rank of target (y) tensor (${t.rank}) during handling of class weights. The rank is expected to be 1 or 2.`)}),s=Array.from(await e.data());we(e);const r=[];return s.forEach(t=>{if(null==n[t])throw new Error(`classWeight must contain all classes in the training data. The class ${t} exists in the data but not in classWeight`);r.push(n[t])}),xr(r,"float32")}return null}function bu(t,e){return Ne(t,e)}function wu(t,e){let n,s;const i=e;n=i.xs,s=i.ys,r(null!=n&&null!=s,()=>"A Dataset iterator for fitDataset() is expected to generate objects of the form `{xs: xVal, ys: yVal}`, where the two values may be `tf.Tensor`, an array of Tensors, or a map of string to Tensor.  The provided Dataset instead generates "+e);const a=vu("input",t.inputNames,n),o=vu("output",t.outputNames,s),l=a[0].shape[0];r(a.length===t.inputs.length,()=>`LayersModel has ${t.inputs.length} inputs, but the dataset provides ${a.length} inputs.  (Expected input keys: `+JSON.stringify(t.inputNames)+")"),r(o.length===t.outputs.length,()=>`LayersModel has ${t.outputs.length} outputs, but the dataset provides ${o.length} outputs.  (Expected output keys: `+JSON.stringify(t.outputNames)+")");for(let e=0;e<a.length;e++)r(a[e].shape[0]===l,()=>`Batch size mismatch: input ${t.inputNames[e]} has ${a[e].shape[0]}; expected  ${l} based on input ${t.inputNames[0]}.`);for(let e=0;e<o.length;e++)r(o[e].shape[0]===l,()=>`Batch size mismatch: output ${t.outputNames[e]} has ${o[e].shape[0]}; expected  ${l} based on input ${t.inputNames[0]}.`);return{xs:a,ys:o}}function vu(t,e,n){if(n instanceof J)return[n];if(Array.isArray(n))return r(n.length===e.length,()=>`Received an array of ${n.length} Tensors, but expected ${e.length} to match the ${t} keys ${e}.`),n;{const s=[];for(const r of e){if(null==n[r])throw new Ia(`The feature data generated by the dataset lacks the required ${t} key '${r}'.`);s.push(n[r])}return s}}async function ku(t,e,n){const s=null!=n.batchesPerEpoch;if(r(null!=t.optimizer,()=>"You must compile a model before training/testing. Use LayersModel.compile(modelCompileConfig)."),r(null!=n,()=>"For fitDataset(), the 2nd argument (config) is required, but it is not provided in this call."),r(null!=n.epochs&&n.epochs>0&&Number.isInteger(n.epochs),()=>"For fitDataset(), config.epochs is expected to be a positive integer, but got "+n.epochs),r(!s||n.batchesPerEpoch>0&&Number.isInteger(n.batchesPerEpoch),()=>"For fitDataset(), config.batchesPerEpoch is expected to be a positive integer if specified, but got "+n.batchesPerEpoch),r(null==n.validationSplit,()=>"`validationSplit` is not supported by `fitDataset()`. Use validationData instead."),t.isTraining)throw new Error("Cannot start training because another fit() call is ongoing.");t.isTraining=!0;try{const i=null!=n.validationData;let a,o;if(i)if(xu(n.validationData))r(null==n.validationBatches||n.validationBatches>0&&Number.isInteger(n.validationBatches),()=>"For fitDataset() with dataset-based validation, config.validationBatches is expected not to be provided, or to be a positive integer, but got "+n.validationBatches);else{const t=function(t){if(3===t.length)throw new Na("Validation with sample weights is not implemented yet.");return{xs:t[0],ys:t[1]}}(n.validationData);a=t.xs,o=t.ys}const l=t.makeTrainFunction(),u=t.getDedupedMetricsNames();let h;h=i?u.slice().concat(u.map(t=>"val_"+t)):u.slice();const c=Fl(n.callbacks,n.yieldEvery),p=null==n.verbose?1:n.verbose,{callbackList:d,history:f}=Ll(c,p,n.epochs,null,null,function(t,e){let n=null;null!=e.batchesPerEpoch?n=e.batchesPerEpoch:Number.isFinite(t.size)&&(n=t.size);return n}(e,n),null,i,h);d.setModel(t),t.history=f,await d.onTrainBegin(),t.stopTraining_=!1;let m=null==n.initialEpoch?0:n.initialEpoch,g=await e.iterator();for(;m<n.epochs;){const r={};await d.onEpochBegin(m);let h=0,c=0;for(s||(g=await e.iterator());!s||h<n.batchesPerEpoch;){const e=await g.next();if(s&&e.done){console.warn("You provided `batchesPerEpoch` as "+n.batchesPerEpoch+", but your dataset iterator ran out of data after "+h+" batches; interrupting training. Make sure that your dataset can generate at least `batchesPerEpoch * epochs` batches (in this case, "+n.batchesPerEpoch*n.epochs+" batches). You may need to use the repeat() function when building your dataset.");break}if(null!=e.value){const{xs:s,ys:r}=wu(t,e.value),i={};i.batch=c,i.size=s[0].shape[0],await d.onBatchBegin(c,i);const a=[];if(null!=n.classWeight){const e=gu(n.classWeight,t.outputNames);for(let t=0;t<e.length;++t)a.push(await yu(r[t],null,e[t]))}const o=s.concat(r).concat(a),p=l(o);we(o);for(let t=0;t<u.length;++t){const e=u[t],n=p[t];i[e]=n,ve(n)}await d.onBatchEnd(c,i),Nl(i),c++,h++}if(s?h>=n.batchesPerEpoch:e.done){if(i){let e;e=xu(n.validationData)?Ca(await t.evaluateDataset(n.validationData,{batches:n.validationBatches})):Ca(t.evaluate(a,o,{batchSize:null==n.validationBatchSize?32:n.validationBatchSize,verbose:0}));for(let n=0;n<t.metricsNames.length;++n)r["val_"+t.metricsNames[n]]=e[n]}break}if(t.stopTraining_)break}if(await d.onEpochEnd(m,r),m++,t.stopTraining_)break}return await d.onTrainEnd(),await t.history.syncData(),t.history}finally{t.isTraining=!1}}function xu(t){return"function"==typeof t.iterator}function Su(t){r(t>0&&Number.isInteger(t),()=>"batchSize is required to be a positive integer, but got "+t)}function Iu(t,e,n){return null==t?[null]:Array.isArray(t)?t.map(t=>So(t,e,n-e)):So(t,e,n-e)}function Nu(t,e){return be(()=>null==t?null:Array.isArray(t)?t.map(t=>Nu(t,e)):Co(t,"int32"===e.dtype?e:e.toInt()))}function Eu(t,e){const n=[];let s=0,r=null;for(;s<t;)r=s+e,r>=t&&(r=t),n.push([s,r]),s=r;return n}async function Au(t,e,n,r={}){if(t.isTraining)throw new Error("Cannot start training because another fit() call is ongoing.");let i,a,o,l,u,h,c;t.isTraining=!0;try{const p=null==r.batchSize?32:r.batchSize;Su(p);const d=!1,f=await t.standardizeUserData(e,n,r.sampleWeight,r.classWeight,d,p);i=f[0],a=f[1],c=f[2];let m,g=!1;if(null!=r.validationData&&r.validationData.length>0){if(g=!0,2!==r.validationData.length)throw 3===r.validationData.length?new Na("validationData including sample weights is not supported yet."):new Ia("When passing validation data, it must contain 2 (valX, valY) or 3 (valX, valY, valSampleWeight) items; "+r.validationData+" is invalid.");o=r.validationData[0],l=r.validationData[1];const e=!0,n=await t.standardizeUserData(o,l,null,null,e,p);u=n[0],h=n[1],m=u.concat(h)}else if(null!=r.validationSplit&&r.validationSplit>0&&r.validationSplit<1){g=!0;const t=Math.floor(i[0].shape[0]*(1-r.validationSplit)),e=i[0].shape[0];u=Iu(i,t,e),i=Iu(i,0,t),h=Iu(a,t,e),a=Iu(a,0,t),m=u.concat(h)}else null!=r.validationSteps&&(g=!0);const y=i.concat(a).concat(c);t.checkTrainableWeightsConsistency();const b=t.makeTrainFunction(),w=t.getDedupedMetricsNames();let v,k;g?(t.makeTestFunction(),v=t.testFunction,k=w.slice().concat(w.map(t=>"val_"+t))):(v=null,m=[],k=w.slice());const x=Fl(r.callbacks,r.yieldEvery);return await async function(t,e,n,r,i,a,o,l,u,h,c,p,d,f,m){null==i&&(i=32),null==a&&(a=1),null==c&&(c=!0),null==d&&(d=0);let g=!1;if(null!=u&&null!=h&&(g=!0),null!=m&&(g=!0,null==f))throw new Ia("Can only use `validationSteps` when doing step-wise training, i.e., `stepsPerEpoch` must be set.");const y=t.checkNumSamples(n,i,f,"steps_per_epoch");let b;null!=y&&(b=vo(0,y)),null==o&&(o=1);const{callbackList:w,history:v}=Ll(l,o,a,d,y,f,i,g,p);w.setModel(t),t.history=v,await w.onTrainBegin(),t.stopTraining_=!1;for(let o=d;o<a;++o){await w.onEpochBegin(o);const a={};if(null!=f)throw new Na("stepsPerEpoch mode is not implemented yet.");{if("batch"===c)throw new Na("batch shuffling is not implemneted yet");c&&s(b);const o=xr(b),l=Eu(y,i);for(let s=0;s<l.length;++s){const c={};if(await w.onBatchBegin(s,c),be(()=>{const p=l[s][0],d=l[s][1],f=So(o,p,d-p);c.batch=s,c.size=d-p;const m=Nu(n,f),y=e(m);for(let t=0;t<r.length;++t){const e=r[t],n=y[t];c[e]=n,ve(n)}if(s===l.length-1&&g){const e=t.testLoop(u,h,i);for(let t=0;t<r.length;++t){const n=r[t],s=e[t];ve(s),a["val_"+n]=s}}}),await w.onBatchEnd(s,c),Nl(c),t.stopTraining_)break}o.dispose()}if(await w.onEpochEnd(o,a),t.stopTraining_)break}return await w.onTrainEnd(),await t.history.syncData(),t.history}(t,b,y,w,p,r.epochs,r.verbose,x,v,m,r.shuffle,k,r.initialEpoch,null,null)}finally{t.isTraining=!1,Du(i,e),Du(a,n),Du(u,o),Du(h,l),null!=c&&we(c)}}function Tu(t){const e=[];t instanceof J&&(t=[t]);for(let n=0;n<t.length;++n){const s=t[n];if(1===s.rank)e.push(xo(s,1));else{if(0===s.rank)throw new Error("Expected tensor to be at least 1D, but received a 0D tensor (scalar).");e.push(s)}}return e}function Du(t,e){if(null==t)return;const n=[];if(e instanceof J)n.push(e.id);else if(Array.isArray(e))e.forEach(t=>n.push(t.id));else if(null!=e)for(const t in e){const s=e[t];n.push(s.id)}const s=[];if(t instanceof J)-1===n.indexOf(t.id)&&s.push(t);else if(Array.isArray(t))t.forEach(t=>{-1===n.indexOf(t.id)&&s.push(t)});else if(null!=t)for(const e in t){const r=t[e];-1===n.indexOf(r.id)&&s.push(r)}s.forEach(t=>{t.isDisposed||t.dispose()})}function zu(t){return Array.isArray(t)}function Cu(t){return!function(t){return t instanceof J}(t)&&!zu(t)}function Fu(t,e,n,s=!0,r=""){if(null==e||0===e.length){if(null!=t){let e=!1;if(zu(t)&&t.length>0)e=!0;else if(Cu(t)){for(const n in t)if(t.hasOwnProperty(n)){e=!0;break}}else e=!0;if(e)throw new Ia(`Error when checking model ${r} expected no data, but got `+t)}return[]}if(null==t)return e.map(t=>null);let i;if(Cu(t)){t=t,i=[];for(const n of e){if(null==t[n])throw new Ia(`No data provided for "${n}". Need data for each key in: `+e);i.push(t[n])}}else if(zu(t)){if((t=t).length!==e.length)throw new Ia(`Error when checking model ${r}: the Array of Tensors that you are passing to your model is not the size the model expected. Expected to see ${e.length} Tensor(s), but instead got the following list of Tensor(s): `+t);i=t}else{if(t=t,e.length>1)throw new Ia(`The model ${r} expects ${e.length} Tensor(s), but only received one Tensor. Found: Tensor with shape `+t.shape);i=[t]}if(i=Tu(i),null!=n)for(let t=0;t<e.length;++t){if(null==n[t])continue;const a=i[t];if(a.shape.length!==n[t].length)throw new Ia(`Error when checking ${r}: expected ${e[t]} to have ${n[t].length} dimension(s). but got array with shape `+a.shape);for(let i=0;i<n[t].length;++i){if(0===i&&!s)continue;const o=a.shape[i],l=n[t][i];if(null!=l&&l>=0&&o!==l)throw new Ia(`Error when checking ${r}: expected ${e[t]} to have shape [${n[t]}], but got array with shape [${a.shape}].`)}}return i}function Ru(t,e,n,s=!0,r=""){let i;if(Array.isArray(t)){if(t.length!==e.length)throw new Ia(`Error when checking model ${r}: the Array of Tensors that you are passing to your model is not the size the the model expected. Expected to see ${e.length} Tensor(s), but instead got ${t.length} Tensors(s).`);i=t}else{if(e.length>1)throw new Ia(`The model expects ${e.length} ${r} Tensors, but only received one Tensor. Found: array with shape `+JSON.stringify(t.shape)+".");i=[t]}if(null!=n)for(let t=0;t<e.length;++t){if(null==n[t])continue;const a=i[t];if(a.shape.length!==n[t].length)throw new Ia(`Error when checking ${r}: expected ${e[t]} to have ${n[t].length} dimension(s), but got array with shape `+JSON.stringify(a.shape));for(let i=0;i<n[t].length;++i){if(0===i&&!s)continue;const o=a.shape[i],l=n[t][i];if(null!=l&&l!==o)throw new Ia(`Error when checking ${r}: expected ${e[t]} to have shape ${JSON.stringify(n[t])} but got array with shape ${JSON.stringify(a.shape)}.`)}}}class Lu extends mu{constructor(t){super(t),this.isTraining=!1}summary(t,e,n=console.log){if(!this.built)throw new Ia("This model has never been called, thus its weights have not been created yet. So no summary can be displayed. Build the model first (e.g., by calling it on some test data).");nu(this,t,e,n)}compile(t){if(null==t.loss&&(t.loss=[]),this.loss=t.loss,"string"==typeof t.optimizer)this.optimizer_=function(t){const e={Adagrad:()=>Qr.adagrad(.01),Adadelta:()=>Qr.adadelta(1,.95,ka()),Adam:()=>Qr.adam(.001,.9,.999,ka()),Adamax:()=>Qr.adamax(.002,.9,.999,ka(),0),RMSProp:()=>Qr.rmsprop(.001,.9,0,ka()),SGD:()=>Qr.sgd(.01)};if(e.adagrad=e.Adagrad,e.adadelta=e.Adadelta,e.adam=e.Adam,e.adamax=e.Adamax,e.rmsprop=e.RMSProp,e.sgd=e.SGD,t in e)return e[t]();throw new Ia("Unknown Optimizer "+t)}(t.optimizer),this.isOptimizerOwned=!0;else{if(!(t.optimizer instanceof qr))throw new Ia("User-defined optimizer must be an instance of tf.Optimizer.");this.optimizer_=t.optimizer,this.isOptimizerOwned=!1}let e=[];if(Array.isArray(t.loss)||"string"==typeof t.loss||"function"==typeof t.loss)if(Array.isArray(t.loss)){if(t.loss.length!==this.outputs.length)throw new Ia(`When passing an Array as loss, it should have one entry per model output. The model has ${this.outputs.length} output(s), but you passed loss=${t.loss}.`);const n=t.loss;e=n.map(t=>Kl(t))}else{const n=Kl(t.loss);this.outputs.forEach(t=>{e.push(n)})}else{t.loss=t.loss;for(const e in t.loss)if(-1===this.outputNames.indexOf(e))throw new Ia(`Unknown entry in loss dictionary: "${e}". Only expected the following keys: `+this.outputNames);for(const n of this.outputNames)null==t.loss[n]&&console.warn(`Output "${n}" is missing from loss dictionary. We assume this was done on purpose, and we will not be expecting data to be passed to ${n} during training`),e.push(Kl(t.loss[n]))}this.lossFunctions=e,this.feedOutputNames=[],this.feedOutputShapes=[],this.feedLossFns=[];for(let t=0;t<this.outputs.length;++t){const e=this.internalOutputShapes[t],n=this.outputNames[t];this.feedOutputNames.push(n),this.feedOutputShapes.push(e),this.feedLossFns.push(this.lossFunctions[t])}const n=[];this.metrics=t.metrics,this.metricsNames=["loss"],this.metricsTensors=[],ho("loss",()=>{for(let t=0;t<this.outputs.length;++t){if(-1!==n.indexOf(t))continue;const e=this.lossFunctions[t];this.outputs.length>1&&(this.metricsTensors.push([e,t]),this.metricsNames.push(this.outputNames[t]+"_loss"))}});const s=function(t,e){if(null==t||Array.isArray(t)&&0===t.length)return e.map(t=>[]);let n;if("string"==typeof t||"function"==typeof t)n=[t];else{if(!Array.isArray(t)&&"object"!=typeof t)throw new TypeError("Type of metrics argument not understood. Expected an string,function, Array, or Object, found: "+t);n=t}if(Array.isArray(n))return e.map(t=>n);{const t=[];for(const s of e){let e=n.hasOwnProperty(s)?n[s]:[];Array.isArray(e)||(e=[e]),t.push(e)}return t}}(t.metrics,this.outputNames),r=(t,e,n)=>{this.outputNames.length>1&&(e=this.outputNames[t]+"_"+e),this.metricsNames.push(e),this.metricsTensors.push([n,t])};ho("metric",()=>{for(let t=0;t<this.outputs.length;++t){if(-1!==n.indexOf(t))continue;(e=>{let n,s,i;for(const a of e){if("string"==typeof a&&-1!==["accuracy","acc","crossentropy","ce"].indexOf(a)){const e=this.internalOutputShapes[t];let r;1===e[e.length-1]||this.lossFunctions[t]===Wl?-1!==["accuracy","acc"].indexOf(a)?s=Vl:-1!==["crossentropy","ce"].indexOf(a)&&(s=Gl):this.lossFunctions[t]===Ul?-1!==["accuracy","acc"].indexOf(a)?s=Jl:-1!==["crossentropy","ce"].indexOf(a)&&(s=Xl):-1!==["accuracy","acc"].indexOf(a)?s=Hl:-1!==["crossentropy","ce"].indexOf(a)&&(s=Zl),-1!==["accuracy","acc"].indexOf(a)?r="acc":-1!==["crossentropy","ce"].indexOf(a)&&(r="ce"),i=s,n=""+r}else{const t=Ql(a);i=t,n=""+tu(a)}let e;ho(n,()=>{e=i}),r(t,n,e)}})(s[t])}}),this.collectedTrainableWeights=this.trainableWeights}checkTrainableWeightsConsistency(){null!=this.collectedTrainableWeights&&this.trainableWeights.length!==this.collectedTrainableWeights.length&&console.warn("Discrepancy between trainableweights and collected trainable weights. Did you set `model.trainable` without calling `model.compile()` afterwards?")}evaluate(t,e,n={}){const s=null==n.batchSize?32:n.batchSize;Su(s);const r=this.standardizeUserDataXY(t,e,!0,s);try{const i=r[0].concat(r[1]);this.makeTestFunction();const a=this.testFunction;return za(this.testLoop(a,i,s,n.verbose,n.steps))}finally{Du(r[0],t),Du(r[1],e)}}async evaluateDataset(t,e){return this.makeTestFunction(),async function(t,e,n){const s=null!=(n=n||{}).batches,i=t.testFunction;let a=[];if(n.verbose>0)throw new Na("Verbose mode is not implemented yet.");r(!s||n.batches>0&&Number.isInteger(n.batches),()=>"Test loop expects `batches` to be a positive integer, but received "+JSON.stringify(n.batches));const o="function"==typeof e.next?e:await e.iterator();let l=0,u=0;for(;!s||u<n.batches;){const e=await o.next();if(a=be(()=>{if(e.value){const{xs:n,ys:s}=wu(t,e.value),r=n.concat(s),o=be(()=>i(r));if(we(r),0===u)for(let t=0;t<o.length;++t)a.push(Qs(0));const h=r[0].shape[0];for(let t=0;t<o.length;++t){const e=o[t],n=a[t];a[t]=be(()=>xe(a[t],Ne(h,e))),u>0&&we(n)}we(o),l+=h,++u}return a}),e.done){s&&console.warn(`Your dataset iterator ran out of data during evaluateDataset(). Interrupting evalution. Make sure that your dataset can generate at least \`batches\` batches (in this case, ${n.batches} batches). You may need to use the repeat() function when building your dataset.`);break}}for(let t=0;t<a.length;++t){const e=a[t];a[t]=Ie(a[t],l),we(e)}return za(a)}(this,t,e)}checkNumSamples(t,e,n,s="steps"){let r;if(null!=n){if(r=null,null!=e)throw new Ia(`If ${s} is set, batchSize must be null or undefined.Got batchSize = `+e)}else{if(null==t)throw new Ia("Either the input data should have a defined shape, or "+s+" shoud be specified.");r=Array.isArray(t)?t[0].shape[0]:t.shape[0]}return r}execute(t,e){if(Array.isArray(e)&&0===e.length)throw new Ia("`outputs` is an empty Array, which is not allowed.");const n=Array.isArray(e),s=n?e:[e],r=this.retrieveSymbolicTensors(s),i=new lu;if(t instanceof J&&(t=[t]),Array.isArray(t)){if(t.length!==this.inputs.length)throw new Ia(`The number of inputs provided (${t.length}) does not match the number of inputs of this model (${this.inputs.length}).`);for(let e=0;e<this.inputs.length;++e)i.add(this.inputs[e],t[e])}else for(const e of this.inputs){const n=t[e.name];if(null==n)throw new Ia("No value is provided for the model's input "+e.name);i.add(e,n)}const a=cu(r,i);return n?a:a[0]}retrieveSymbolicTensors(t){const e=Aa(null,t.length);let n=t.length;for(const s of this.layers){const r=Array.isArray(s.output)?s.output:[s.output],i=r.map(t=>t.name);for(let s=0;s<t.length;++s){const a=i.indexOf(t[s]);if(-1!==a&&(e[s]=r[a],n--),0===n)break}if(0===n)break}if(n>0){const n=[];throw e.forEach((e,s)=>{null==e&&n.push(t[s])}),new Ia("Cannot find SymbolicTensors for output name(s): "+JSON.stringify(n))}return e}predictLoop(t,e=32,n=!1){return be(()=>{const s=this.checkNumSamples(t);if(n)throw new Na("Verbose predictLoop() is not implemented yet.");const r=Eu(s,e),i=this.outputs.map(t=>[]);for(let e=0;e<r.length;++e){be(()=>{const n=r[e][0],s=r[e][1],i=Iu(t,n,s),a=[];if(Array.isArray(i))for(let t=0;t<i.length;++t)a.push({key:this.inputs[t],value:i[t]});else a.push({key:this.inputs[0],value:i});const o=new lu(a);return cu(this.outputs,o)}).forEach((t,e)=>i[e].push(t))}return za(i.map(t=>He(t,0)))})}predict(t,e={}){const n=Tu(t);Ru(n,this.inputNames,this.feedInputShapes,!1);try{const s=null==e.batchSize?32:e.batchSize;return Su(s),this.predictLoop(n,s)}finally{Du(n,t)}}predictOnBatch(t){Ru(t,this.inputNames,this.feedInputShapes,!0);const e=(Array.isArray(t)?t[0]:t).shape[0];return this.predictLoop(t,e)}standardizeUserDataXY(t,e,n=!0,s){if(null==this.optimizer_)throw new Sa("You must compile a model before training/testing. Use LayersModel.compile(modelCompileArgs).");const r=[];for(let t=0;t<this.feedOutputShapes.length;++t){const e=this.feedOutputShapes[t];this.feedLossFns[t]===Ul?r.push(e.slice(0,e.length-1).concat([1])):r.push(e)}if(function(t,e,n){const s=Oa(t.map(t=>t.shape[0]));s.sort();const r=Oa(e.map(t=>t.shape[0]));if(r.sort(),s.length>1)throw new Ia("All input Tensors (x) should have the same number of samples. Got array shapes: "+JSON.stringify(t.map(t=>t.shape)));if(r.length>1)throw new Ia("All target Tensors (y) should have the same number of samples. Got array shapes: "+JSON.stringify(e.map(t=>t.shape)));if(s.length>0&&r.length>0&&!u(s,r))throw new Ia(`Input Tensors should have the same number of samples as target Tensors. Found ${s[0]} input sample(s) and ${r[0]} target sample(s).`)}(t=Fu(t,this.feedInputNames,this.feedInputShapes,!1,"input"),e=Fu(e,this.feedOutputNames,r,!1,"target")),function(t,e,n){const s=[$l,Wl,Pl];for(let r=0;r<t.length;++r){const i=t[r],a=e[r],o=n[r];if(null!=a){if(a===Pl&&1===i.shape[i.shape.length-1])throw new Ia(`You are passing a target array of shape ${i.shape} while using a loss 'categorical_crossentropy'. 'categorical_crossentropy'expects targets to be binary matrices (1s and 0s) of shape [samples, classes].`);if(-1!==s.indexOf(a)){const t=i.shape.slice(1),e=o.slice(1);for(let n=0;n<t.length;++n){const s=t[n],r=e[n];if(null!=r&&s!==r)throw new Ia(`A target Tensor with shape ${i.shape} was passed for an output of shape ${o}, while using a loss function that expects targets to have the same shape as the output.`)}}}}}(e,this.feedLossFns,this.feedOutputShapes),this.stateful&&null!=s&&s>0&&t[0].shape[0]%s!=0)throw new Ia(`In a stateful network, you should only pass inputs with a number of samples that is divisible by the batch size ${s}. Found: ${t[0].shape[0]} sample(s).`);return[t,e]}async standardizeUserData(t,e,n,s,r=!0,i){const[a,o]=this.standardizeUserDataXY(t,e,r,i);if(null!=n)throw new Error("sample weight is not supported yet.");let l=null;if(null!=s){const t=gu(s,this.outputNames);l=[];for(let e=0;e<t.length;++e)l.push(await yu(o[e],null,t[e]))}return[a,o,l]}testLoop(t,e,n,s=0,r){return be(()=>{const i=this.checkNumSamples(e,n,r,"steps"),a=[];if(s>0)throw new Na("Verbose mode is not implemented yet.");if(null!=r)throw new Na("steps mode in testLoop() is not implemented yet");{const s=Eu(i,n),r=xr(vo(0,i));for(let n=0;n<s.length;++n){const i=s[n][0],o=s[n][1],l=So(r,i,o-i),u=Nu(e,l),h=t(u);if(0===n)for(let t=0;t<h.length;++t)a.push(Qs(0));for(let t=0;t<h.length;++t){const e=h[t];a[t]=xe(a[t],Ne(o-i,e))}}for(let t=0;t<a.length;++t)a[t]=Ie(a[t],i)}return a})}getDedupedMetricsNames(){const t=this.metricsNames,e=[];for(let n=0;n<t.length;++n){const s=t[n];let r=s;if(Da(t,s)>1){r+="_"+Da(t.slice(0,n),s)}e.push(r)}return e}makeTrainFunction(){return t=>{const e=[],n=t.slice(0,this.inputs.length),s=t.slice(this.inputs.length,this.inputs.length+this.outputs.length),r=t.slice(this.inputs.length+this.outputs.length,this.inputs.length+2*this.outputs.length),i=[],a=this.collectedTrainableWeights.map(t=>t.read());return[this.optimizer_.minimize(()=>{const t=[];for(let e=0;e<this.inputs.length;++e)t.push({key:this.inputs[e],value:n[e]});const a=new lu(t),o=cu(this.outputs,a,{training:!0});let l;for(let t=0;t<this.lossFunctions.length;++t){let n=(0,this.lossFunctions[t])(s[t],o[t]);null!=r[t]&&(n=bu(n,r[t]));const i=ms(n);e.push(i),l=0===t?n:xe(l,n)}for(let t=0;t<this.metricsTensors.length;++t){let n;if(this.outputs.length>1&&t<this.outputs.length)n=e[t];else{const e=this.metricsTensors[t][0],r=this.metricsTensors[t][1];n=ms(e(s[r],o[r]))}ve(n),i.push(n)}return l=ms(l),this.calculateLosses().forEach(t=>{l=xe(l,t)}),l},!0,a)].concat(i)}}makeTestFunction(){this.testFunction=t=>be(()=>{const e=[];let n;const s=t.slice(0,this.inputs.length),r=t.slice(this.inputs.length,this.inputs.length+this.outputs.length),i=[];for(let t=0;t<this.inputs.length;++t)i.push({key:this.inputs[t],value:s[t]});const a=new lu(i),o=cu(this.outputs,a);for(let t=0;t<this.lossFunctions.length;++t){const s=this.lossFunctions[t],i=ms(s(r[t],o[t]));n=0===t?i:xe(n,i),e.push(n)}for(let t=0;t<this.metricsTensors.length;++t){const n=this.metricsTensors[t][0],s=this.metricsTensors[t][1],i=ms(n(r[s],o[s]));e.push(i)}return e})}async fit(t,e,n={}){return Au(this,t,e,n)}async fitDataset(t,e){return ku(this,t,e)}async trainOnBatch(t,e){const n=await this.standardizeUserData(t,e),s=n[0],r=n[1],i=this.makeTrainFunction()(s.concat(r)),a=[];for(const t of i){const e=await t.data();a.push(e[0])}return we(i),za(a)}getNamedWeights(t){const e=[],n=null!=t&&t.trainableOnly,s=n?this.trainableWeights:this.weights,r=this.getWeights(n);for(let t=0;t<s.length;++t)n&&!s[t].trainable||e.push({name:s[t].originalName,tensor:r[t]});return e}set stopTraining(t){this.stopTraining_=t}get stopTraining(){return this.stopTraining_}get optimizer(){return this.optimizer_}set optimizer(t){this.optimizer_!==t&&(this.optimizer_=t,this.isOptimizerOwned=!1)}dispose(){const t=super.dispose();if(0===t.refCountAfterDispose&&null!=this.optimizer&&this.isOptimizerOwned){const e=ye().numTensors;this.optimizer_.dispose(),t.numDisposedVariables+=e-ye().numTensors}return t}getLossIdentifiers(){let t;if("string"==typeof this.loss)t=Fa(this.loss);else if(Array.isArray(this.loss)){for(const t of this.loss)if("string"!=typeof t)throw new Error("Serialization of non-string loss is not supported.");t=this.loss.map(t=>Fa(t))}else{const e=Object.keys(this.loss);t={};const n=this.loss;for(const s of e){if("string"!=typeof n[s])throw new Error("Serialization of non-string loss is not supported.");t[s]=Fa(n[s])}}return t}getMetricIdentifiers(){if("string"==typeof this.metrics||"function"==typeof this.metrics)return[Fa(tu(this.metrics))];if(Array.isArray(this.metrics))return this.metrics.map(t=>Fa(tu(t)));{const t={};for(const e in this.metrics)t[e]=Fa(tu(this.metrics[e]));return t}}getTrainingConfig(){return{loss:this.getLossIdentifiers(),metrics:this.getMetricIdentifiers(),optimizer_config:{class_name:this.optimizer.getClassName(),config:this.optimizer.getConfig()}}}loadTrainingConfig(t){if(null!=t.weighted_metrics)throw new Error("Loading weight_metrics is not supported yet.");if(null!=t.loss_weights)throw new Error("Loading loss_weights is not supported yet.");if(null!=t.sample_weight_mode)throw new Error("Loading sample_weight_mode is not supported yet.");const e=Ml(ou(t.optimizer_config));let n,s;if("string"==typeof t.loss)n=Ra(t.loss);else if(Array.isArray(t.loss))n=t.loss.map(t=>Ra(t));else if(null!=t.loss){n={};for(const e in t.loss)n[e]=Ra(t.loss[e])}if(Array.isArray(t.metrics))s=t.metrics.map(t=>Ra(t));else if(null!=t.metrics){s={};for(const e in t.metrics)s[e]=Ra(t.metrics[e])}this.compile({loss:n,metrics:s,optimizer:e})}async save(t,e){if("string"==typeof t){const e=(n=t,zt.getSaveHandlers(n));if(0===e.length)throw new Ia(`Cannot find any save handlers for URL '${t}'`);if(e.length>1)throw new Ia(`Found more than one (${e.length}) save handlers for URL '${t}'`);t=e[0]}var n;if(null==t.save)throw new Ia("LayersModel.save() cannot proceed because the IOHandler provided does not have the `save` attribute defined.");const s=await St(this.getNamedWeights(e)),r={modelTopology:this.toJSON(null,!1),format:"layers-model",generatedBy:"TensorFlow.js tfjs-layers v3.0.0",convertedBy:null};if(null!=e&&e.includeOptimizer&&null!=this.optimizer){r.trainingConfig=this.getTrainingConfig();const t="optimizer",{data:e,specs:n}=await St(await this.optimizer.getWeights(),t);s.specs.push(...n),s.data=At([s.data,e])}if(null!=this.userDefinedMetadata){const t=!0;eu(this.userDefinedMetadata,this.name,t),r.userDefinedMetadata=this.userDefinedMetadata}return r.weightData=s.data,r.weightSpecs=s.specs,t.save(r)}setUserDefinedMetadata(t){eu(t,this.name),this.userDefinedMetadata=t}getUserDefinedMetadata(){return this.userDefinedMetadata}}Lu.className="Model",ge(Lu);class Mu extends Lu{}async function _u(t,e){if(null==e&&(e={}),"string"==typeof t){const r=(n=t,s=e,zt.getLoadHandlers(n,s));if(0===r.length)r.push(function(t,e){return oe(t,e)}(t,e));else if(r.length>1)throw new Ia(`Found more than one (${r.length}) load handlers for URL '${t}'`);t=r[0]}var n,s;return async function(t,e,n){null==n&&(n={});if(null==t.load)throw new Ia("Cannot proceed with model loading because the IOHandler provided does not have the `load` method implemented.");const s=await t.load();let r=s.modelTopology;null!=r.model_config&&(r=r.model_config);const i=null==n.strict||n.strict,a=null!=s.weightData&&null!=s.weightSpecs&&i,o=Ml(ou(r),e,a),u=s.trainingConfig;null!=u&&o.loadTrainingConfig(u);null!=s.userDefinedMetadata&&o.setUserDefinedMetadata(s.userDefinedMetadata);if(null!=s.weightData){if(null==s.weightSpecs)throw new Ia("LayersModel artifacts contains weight data, but not weight specs. Therefore loading of weights cannot proceed.");const{modelWeights:t,optimizerWeights:e}=function(t,e){const n=function(t,e){const n={};let s,r=0;for(const i of e){const e=i.name,a=i.dtype,o=i.shape,u=l(o);let h;if("quantization"in i){const n=i.quantization;if("uint8"===n.dtype||"uint16"===n.dtype){if(!("min"in n)||!("scale"in n))throw new Error(`Weight ${i.name} with quantization ${n.dtype} doesn't have corresponding metadata min and scale.`)}else{if("float16"!==n.dtype)throw new Error(`Weight ${i.name} has unknown quantization dtype ${n.dtype}. Supported quantization dtypes are: 'uint8', 'uint16', and 'float16'.`);if("float32"!==a)throw new Error(`Weight ${i.name} is quantized with ${n.dtype} which only supports weights of type float32 not ${a}.`)}const o=xt[n.dtype],l=t.slice(r,r+u*o),c="uint8"===n.dtype?new Uint8Array(l):new Uint16Array(l);if("float32"===a)if("uint8"===n.dtype||"uint16"===n.dtype){h=new Float32Array(c.length);for(let t=0;t<c.length;t++){const e=c[t];h[t]=e*n.scale+n.min}}else{if("float16"!==n.dtype)throw new Error(`Unsupported quantization type ${n.dtype} for weight type float32.`);void 0===s&&(s=Dt()),h=s(c)}else{if("int32"!==a)throw new Error(`Unsupported dtype in weight '${e}': ${a}`);if("uint8"!==n.dtype&&"uint16"!==n.dtype)throw new Error(`Unsupported quantization type ${n.dtype} for weight type int32.`);h=new Int32Array(c.length);for(let t=0;t<c.length;t++){const e=c[t];h[t]=Math.round(e*n.scale+n.min)}}r+=u*o}else if("string"===a){const e=l(i.shape);h=[];for(let n=0;n<e;n++){const e=new Uint32Array(t.slice(r,r+4))[0];r+=4;const n=new Uint8Array(t.slice(r,r+e));h.push(n),r+=e}}else{const s=xt[a],i=t.slice(r,r+u*s);if("float32"===a)h=new Float32Array(i);else if("int32"===a)h=new Int32Array(i);else if("bool"===a)h=new Uint8Array(i);else{if("complex64"!==a)throw new Error(`Unsupported dtype in weight '${e}': ${a}`);{h=new Float32Array(i);const t=new Float32Array(h.length/2),s=new Float32Array(h.length/2);for(let e=0;e<t.length;e++)t[e]=h[2*e],s[e]=h[2*e+1];const r=kt(t,o,"float32"),a=kt(s,o,"float32");n[e]=wt(r,a),r.dispose(),a.dispose()}}r+=u*s}"complex64"!==a&&(n[e]=kt(h,o,a))}return n}(t,e),s={},r=[];return e.forEach(t=>{"optimizer"===t.group?r.push({name:t.name,tensor:n[t.name]}):s[t.name]=n[t.name]}),{modelWeights:s,optimizerWeights:r}}(s.weightData,s.weightSpecs);o.loadWeights(t,i),null!=o.optimizer&&e.length>0&&await o.optimizer.setWeights(e),we(t),we(e.map(t=>t.tensor))}return o}(t,void 0,e)}Mu.className="Functional",ge(Mu);class $u extends Lu{constructor(t){if(super({inputs:[],outputs:[]}),t=t||{},this.trainable=!0,this.built=!1,this.name=null!=t.name?t.name:ll("sequential_"),null!=t.layers)for(const e of t.layers)this.add(e)}checkShape(t){if(t.inboundNodes[0].outputTensors[0].shape.some(t=>t<0))throw new Ia("Negative dimension size caused by adding layer "+t.name+" with input shape ["+t.inboundNodes[0].inputTensors[0].shape+"]")}add(t){const e=t instanceof $u||t instanceof Lu;let n;if(e){if(n=t,1!==n.outputs.length)throw new Ia("All layers in a Sequential model should have a single output tensor. For multi-output layers, use the functional API.");if(1!==n.inputs.length)throw new Ia("All layers in a Sequential model should have a single input tensor. For multi-input layers, use the functional API.")}if(0===this.outputs.length){if(0===t.inboundNodes.length){if(null==t.batchInputShape)throw new Ia("The first layer in a Sequential model must get an `inputShape` or `batchInputShape` argument.");const e=function(t){if(null==t.batchShape&&null==t.shape)throw new Error("Please provide to Input either a `shape` or a `batchShape` argument. Note that `shape` does not include the batch dimension.");if(null!=t.batchShape&&null!=t.shape)throw new Ia("Please provide either a `shape` or `batchShape` argument to Input, but not both.");let e=t.batchShape;null!=t.shape&&null==e&&(e=[null].concat(t.shape));let n=t.dtype;return null==n&&(n="float32"),new Sl({batchInputShape:e,name:t.name,dtype:n,sparse:t.sparse}).inboundNodes[0].outputTensors[0]}({batchShape:t.batchInputShape,dtype:t.dtype,name:t.name+"_input"});t.apply(e)}if(e)this.outputs=n.outputs,this.inputs=n.inputs;else{if(1!==t.inboundNodes.length)throw new Ia(`A layer added to a Sequential model must not already be connected somewhere else. LayersModel received layer ${t.name} which has ${t.inboundNodes.length} pre-existing inbound connections.`);if(1!==t.inboundNodes[0].outputTensors.length)throw new Ia("All layers in a Sequential model should have a single output tensor. For multi-output layers, use the functional API.");this.checkShape(t),this.outputs=[t.inboundNodes[0].outputTensors[0]],this.inputs=function t(e,n,s){if((null==n||null!=s&&s>0)&&(n=e.sourceLayer,s=e.nodeIndex),0===n.inboundNodes.length)return[e];{const e=n.inboundNodes[s];if(0===e.inboundLayers.length)return e.inputTensors;{const n=[];for(let s=0;s<e.inboundLayers.length;s++){const r=t(e.inputTensors[s],e.inboundLayers[s],e.nodeIndices[s]);for(const t of r)-1===n.indexOf(t)&&n.push(t)}return n}}}(this.outputs[0])}this.inboundNodes=[],new vl({outboundLayer:this,inboundLayers:[],nodeIndices:[],tensorIndices:[],inputTensors:this.inputs,outputTensors:this.outputs,inputMasks:Aa(null,this.inputs.length),outputMasks:[null],inputShapes:this.inputs.map(t=>t.shape),outputShapes:this.outputs[0].shape})}else{const e=t.apply(this.outputs[0]);if(Array.isArray(e))throw new TypeError("All layers in a Sequential model should have a single output tensor. For multi-output layers, use the functional API.");this.checkShape(t),this.outputs=[e],this.inboundNodes[0].outputTensors=this.outputs,this.inboundNodes[0].outputShapes=[this.outputs[0].shape]}this.layers.push(t),this.built=!1}pop(){if(0===this.layers.length)throw new TypeError("There are no layers in the model.");if(this.layers.pop(),0===this.layers.length)this.outputs=[],this.inboundNodes=[],this.outboundNodes=[];else{const t=this.layers.length-1;this.layers[t].outboundNodes=[],this.outputs=[this.layers[t].output],this.inboundNodes[0].outputTensors=this.outputs,this.inboundNodes[0].outputShapes=[this.outputs[0].shape]}}call(t,e){return null==this.model&&this.build(),this.model.call(t,e)}build(t){if(pl(t),0===this.inputs.length||0===this.outputs.length)throw new TypeError("Sequential model cannot be built: model is empty. Add some layers first.");this.model=new Lu({inputs:this.inputs,outputs:this.outputs[0],name:this.name+"_model"}),this.model.trainable=this.trainable,this.supportsMasking=this.model.supportsMasking,this.inputLayers=this.model.inputLayers,this.inputLayersNodeIndices=this.model.inputLayersNodeIndices,this.inputLayersTensorIndices=this.model.inputLayersTensorIndices,this.outputLayers=this.model.outputLayers,this.outputLayersNodeIndices=this.model.outputLayersNodeIndices,this.outputLayersTensorIndices=this.model.outputLayersTensorIndices,this.nodesByDepth=this.model.nodesByDepth,this.containerNodes=this.model.containerNodes,this.outputNames=this.model.outputNames,this.inputNames=this.model.inputNames,this.built=!0}countParams(){return this.built||this.build(),super.countParams()}summary(t,e,n=console.log){this.built||this.build(),super.summary(t,e,n)}setWeights(t){null==this.model&&this.build(),this.model.setWeights(t)}evaluate(t,e,n={}){if(!this.built)throw new Sa("The model needs to be compiled before being used.");return this.model.evaluate(t,e,n)}async evaluateDataset(t,e){if(!this.built)throw new Sa("The model needs to be compiled before being used.");return this.model.evaluateDataset(t,e)}predict(t,e={}){return null==this.model&&this.build(),this.model.predict(t,e)}predictOnBatch(t){return null==this.model&&this.build(),this.model.predictOnBatch(t)}compile(t){this.build(),this.model.compile(t),this.optimizer_=this.model.optimizer,this.isOptimizerOwned=this.model.isOptimizerOwned,this.loss=this.model.loss,this.metrics=this.model.metrics,this.metricsTensors=this.model.metricsTensors,this.metricsNames=this.model.metricsNames}get optimizer(){return null==this.model?void 0:this.model.optimizer}set optimizer(t){this.model.optimizer=t}async fit(t,e,n={}){if(!this.built)throw new Sa("The model needs to be compiled before being used.");return this.model.fit(t,e,n)}async fitDataset(t,e){if(!this.built)throw new Sa("The model needs to be compiled before being used.");return this.model.fitDataset(t,e)}async trainOnBatch(t,e){return this.model.trainOnBatch(t,e)}static fromConfig(t,e,n={},s=!1){let i,a={};if(e instanceof Array){if(null==e[0].className||"Merge"===e[0].className)throw new Ia("Legacy serialization format not supported yet.");i=e}else r(null!=e.layers,()=>"When the config data for a Sequential model is not an Array, it must be an Object that contains the 'layers' field."),i=e.layers,delete e.layers,a=e;const o=new t(a);if(!(o instanceof $u))throw new Na("Sequential.fromConfig called on non-Sequential input: "+o);for(const t of i){const e=Ml(t,void 0,s);s&&e.setFastWeightInitDuringBuild(!0),o.add(e)}return o}set stopTraining(t){if(null==this.model)throw new Ia("Cannot set the stopTraining property of a sequential model before it is compiled.");this.model.stopTraining=t}get stopTraining(){if(null==this.model)throw new Ia("Cannot get the stopTraining property of a sequential model before it is compiled.");return this.model.stopTraining}getConfig(){const t=[];for(const e of this.layers){const n={};n.className=e.getClassName(),n.config=e.getConfig(),t.push(n)}return{name:this.name,layers:t}}}function Ou(t){return new Lu(t)}function Bu(t,e){return null==e&&(e={}),_u(t,e)}$u.className="Sequential",ge($u);class Pu extends fe{getConfig(){return{}}}class Uu extends Pu{apply(t,e=1){return function(t,e=1){if(1!==e)throw new Na(`Support for alpha values other than 1 (${e}) is not implemented yet.`);return Dn(t)}(t,e)}}Uu.className="elu",ge(Uu);class Wu extends Pu{apply(t){return tr(t)}}Wu.className="selu",ge(Wu);class ju extends Pu{apply(t){return Gs(t)}}ju.className="relu",ge(ju);class qu extends Pu{apply(t){return be(()=>ys(6,Gs(t)))}}qu.className="relu6",ge(qu);class Ku extends Pu{apply(t){return t}}Ku.className="linear",ge(Ku);class Vu extends Pu{apply(t){return Ge(t)}}Vu.className="sigmoid",ge(Vu);class Hu extends Pu{apply(t){return function(t){return be(()=>{const e=xe(.5,Ne(.2,t));return rn(e,0,1)})}(t)}}Hu.className="hardSigmoid",ge(Hu);class Gu extends Pu{apply(t){return Qn(t)}}Gu.className="softplus",ge(Gu);class Ju extends Pu{apply(t){return function(t){return be(()=>Ie(t,Ee(t).add(1)))}(t)}}Ju.className="softsign",ge(Ju);class Zu extends Pu{apply(t){return Ze(t)}}Zu.className="tanh",ge(Zu);class Xu extends Pu{apply(t,e=-1){return ur(t,e)}}Xu.className="softmax",ge(Xu);class Yu extends Pu{apply(t,e=-1){return rs(t,e)}}Yu.className="logSoftmax",ge(Yu);class Qu extends Pu{apply(t,e=1){return be(()=>Ge(t.mul(e)).mul(t))}}function th(t){return t.getClassName()}function eh(t,e={}){return _a(t,me.getMap().classNameMap,e,"activation")}function nh(t){if(null==t){const t={className:"linear",config:{}};return eh(t)}if("string"==typeof t){const e={};return e.className=t,e.config={},eh(e)}return t instanceof Pu?t:eh(t)}Qu.className="swish",ge(Qu);class sh extends fe{}class rh extends sh{constructor(t){super(),function(t){if(null!=t&&"object"!=typeof t)throw new Error("Argument to L1L2 regularizer's constructor is expected to be an object, but received: "+t)}(t),this.l1=null==t||null==t.l1?.01:t.l1,this.l2=null==t||null==t.l2?.01:t.l2,this.hasL1=0!==this.l1,this.hasL2=0!==this.l2}apply(t){return be(()=>{let e=Ss([1]);return this.hasL1&&(e=xe(e,ss(Ne(this.l1,Ee(t))))),this.hasL2&&(e=xe(e,ss(Ne(this.l2,Fo(t))))),e.asScalar()})}getConfig(){return{l1:this.l1,l2:this.l2}}static fromConfig(t,e){return new t({l1:e.l1,l2:e.l2})}}rh.className="L1L2",ge(rh);const ih={l1l2:"L1L2"};function ah(t){return Ma(t)}function oh(t,e={}){return _a(t,me.getMap().classNameMap,e,"regularizer")}function lh(t){if(null==t)return null;if("string"==typeof t){return oh({className:t in ih?ih[t]:t,config:{}})}return t instanceof sh?t:oh(t)}class uh extends xl{constructor(t){super(null==t?{}:t),this.supportsMasking=!0,null!=t&&(this.maxValue=t.maxValue)}call(t,e){t=cl(t);let n=Gs(t);return null!=this.maxValue&&(n=rn(n,0,this.maxValue)),n}computeOutputShape(t){return t}getConfig(){const t={maxValue:this.maxValue},e=super.getConfig();return Object.assign(t,e),t}}uh.className="ReLU",ge(uh);class hh extends xl{constructor(t){super(null==t?{}:t),this.DEFAULT_ALPHA=.3,null==t&&(t={}),this.alpha=null==t.alpha?this.DEFAULT_ALPHA:t.alpha}call(t,e){const n=cl(t);return Kn(n,this.alpha)}computeOutputShape(t){return t}getConfig(){const t={alpha:this.alpha},e=super.getConfig();return Object.assign(t,e),t}}hh.className="LeakyReLU",ge(hh);class ch extends xl{constructor(t){if(super(null==t?{}:t),this.DEFAULT_ALPHA_INITIALIZER="zeros",null==t&&(t={}),this.supportsMasking=!0,this.alphaInitializer=rl(t.alphaInitializer||this.DEFAULT_ALPHA_INITIALIZER),this.alphaRegularizer=lh(t.alphaRegularizer),this.alphaConstraint=Qa(t.alphaConstraint),null==t.sharedAxes)this.sharedAxes=null;else if(Array.isArray(t.sharedAxes))this.sharedAxes=t.sharedAxes;else{if("number"!=typeof t.sharedAxes)throw new Ia("Expected sharedAxes to be a number or an array of numbers, but got "+t.sharedAxes);this.sharedAxes=[t.sharedAxes]}}build(t){const e=(t=pl(t)).slice(1);if(null!=this.sharedAxes)for(const t of this.sharedAxes)e[t-1]=1;this.alpha=this.addWeight("alpha",e,"float32",this.alphaInitializer,this.alphaRegularizer,!0,this.alphaConstraint);const n={};if(null!=this.sharedAxes)for(let e=1;e<t.length;++e)n[e]=t[e];this.inputSpec=[new yl({ndim:t.length,axes:n})],this.built=!0}call(t,e){return t=cl(t),zs(t,this.alpha.read())}getConfig(){const t={alphaInitializer:sl(this.alphaInitializer),alphaRegularizer:ah(this.alphaRegularizer),alphaConstraint:Xa(this.alphaConstraint),sharedAxes:this.sharedAxes},e=super.getConfig();return Object.assign(t,e),t}}ch.className="PReLU",ge(ch);class ph extends xl{constructor(t){if(super(null==t?{}:t),this.DEFAULT_ALPHA=1,null==t&&(t={}),null!=t.alpha&&t.alpha!==this.DEFAULT_ALPHA)throw new Na(`Non-default alpha value (${t.alpha}) is not supported by the ELU layer yet.`);this.alpha=null==t.alpha?this.DEFAULT_ALPHA:t.alpha}call(t,e){const n=cl(t);return Dn(n)}computeOutputShape(t){return t}getConfig(){const t={alpha:this.alpha},e=super.getConfig();return Object.assign(t,e),t}}ph.className="ELU",ge(ph);class dh extends xl{constructor(t){super(null==t?{}:t),this.DEFAULT_THETA=1,null==t&&(t={}),this.theta=null==t.theta?this.DEFAULT_THETA:t.theta}call(t,e){const n=cl(t);return n.mul(ko(n.greater(this.theta),"float32"))}computeOutputShape(t){return t}getConfig(){const t={theta:this.theta},e=super.getConfig();return Object.assign(t,e),t}}dh.className="ThresholdedReLU",ge(dh);class fh extends xl{constructor(t){super(null==t?{}:t),this.DEFAULT_AXIS=1,null==t&&(t={}),this.softmax=(new Xu).apply,this.axis=null==t.axis?this.DEFAULT_AXIS:t.axis}call(t,e){const n=cl(t);return this.softmax(n,this.axis)}computeOutputShape(t){return t}getConfig(){const t={axis:this.axis},e=super.getConfig();return Object.assign(t,e),t}}function mh(t,e,n){if("number"==typeof t)return Aa(t,e);if(t.length!==e)throw new Ia(`The ${n} argument must be an integer or tuple of ${e} integers. Received: ${t.length} elements.`);for(let r=0;r<e;++r){const i=t[r];if((s=i)!==parseInt(s.toString(),10))throw new Ia(`The ${n} argument must be an integer or tuple of ${e} integers. Received: ${JSON.stringify(t)} including a non-integer number `+i)}return t;var s}function gh(t,e,n,s,r=1){if(null==t)return t;let i;return i="same"===n?t:t-(e+(e-1)*(r-1))+1,Math.floor((i+s-1)/s)}function yh(t,e,n,s){if(null==t)return null;if("valid"===s)t=t*e+wo([n-e,0]);else{if("same"!==s)throw new Ia(`Unsupport padding mode: ${s}.`);t*=e}return t}function bh(t,e){return be(()=>(ao(e),"channelsFirst"===e?pe(t,[0,2,3,1]):t))}function wh(t,e){return be(()=>(ao(e),"channelsFirst"===e?pe(t,[0,2,3,4,1]):t))}function vh(t,e,n,s=[1,1],r="valid",i,a,o=null){return be(()=>{if(null==i&&(i="channelsLast"),ao(i),3!==t.rank&&4!==t.rank)throw new Ia(`conv2dWithBiasActivation expects input to be of rank 3 or 4, but received ${t.rank}.`);if(3!==e.rank&&4!==e.rank)throw new Ia(`conv2dWithBiasActivation expects kernel to be of rank 3 or 4, but received ${t.rank}.`);let l=bh(t,i);if("causal"===r)throw new Na("The support for CAUSAL padding mode in conv1dWithBias is not implemented yet.");return l=_r({x:l,filter:e,strides:s,pad:"same"===r?"same":"valid",dilations:a,dataFormat:"NHWC",bias:n,activation:o}),"channelsFirst"===i&&(l=pe(l,[0,3,1,2])),l})}fh.className="Softmax",ge(fh);class kh extends xl{constructor(t,e){if(super(e),this.bias=null,this.DEFAULT_KERNEL_INITIALIZER="glorotNormal",this.DEFAULT_BIAS_INITIALIZER="zeros",kh.verifyArgs(e),this.rank=t,Wa(this.rank,"rank"),1!==this.rank&&2!==this.rank&&3!==this.rank)throw new Na(`Convolution layer for rank other than 1, 2, or 3 (${this.rank}) is not implemented yet.`);if(this.kernelSize=mh(e.kernelSize,t,"kernelSize"),this.strides=mh(null==e.strides?1:e.strides,t,"strides"),this.padding=null==e.padding?"valid":e.padding,oo(this.padding),this.dataFormat=null==e.dataFormat?"channelsLast":e.dataFormat,ao(this.dataFormat),this.activation=nh(e.activation),this.useBias=null==e.useBias||e.useBias,this.biasInitializer=rl(e.biasInitializer||this.DEFAULT_BIAS_INITIALIZER),this.biasConstraint=Qa(e.biasConstraint),this.biasRegularizer=lh(e.biasRegularizer),this.activityRegularizer=lh(e.activityRegularizer),this.dilationRate=mh(null==e.dilationRate?1:e.dilationRate,t,"dilationRate"),1===this.rank&&Array.isArray(this.dilationRate)&&1!==this.dilationRate.length)throw new Ia("dilationRate must be a number or an array of a single number for 1D convolution, but received "+JSON.stringify(this.dilationRate));if(2===this.rank){if("number"==typeof this.dilationRate)this.dilationRate=[this.dilationRate,this.dilationRate];else if(2!==this.dilationRate.length)throw new Ia("dilationRate must be a number or array of two numbers for 2D convolution, but received "+JSON.stringify(this.dilationRate))}else if(3===this.rank)if("number"==typeof this.dilationRate)this.dilationRate=[this.dilationRate,this.dilationRate,this.dilationRate];else if(3!==this.dilationRate.length)throw new Ia("dilationRate must be a number or array of three numbers for 3D convolution, but received "+JSON.stringify(this.dilationRate))}static verifyArgs(t){if(Ta("kernelSize"in t,"required key 'kernelSize' not in config"),"number"!=typeof t.kernelSize&&!Ua(t.kernelSize,"number",1,3))throw new Ia(`BaseConv expects config.kernelSize to be number or number[] with length 1, 2, or 3, but received ${JSON.stringify(t.kernelSize)}.`)}getConfig(){const t={kernelSize:this.kernelSize,strides:this.strides,padding:this.padding,dataFormat:this.dataFormat,dilationRate:this.dilationRate,activation:th(this.activation),useBias:this.useBias,biasInitializer:sl(this.biasInitializer),biasRegularizer:ah(this.biasRegularizer),activityRegularizer:ah(this.activityRegularizer),biasConstraint:Xa(this.biasConstraint)},e=super.getConfig();return Object.assign(t,e),t}}class xh extends kh{constructor(t,e){super(t,e),this.kernel=null,xh.verifyArgs(e),this.filters=e.filters,Wa(this.filters,"filters"),this.kernelInitializer=rl(e.kernelInitializer||this.DEFAULT_KERNEL_INITIALIZER),this.kernelConstraint=Qa(e.kernelConstraint),this.kernelRegularizer=lh(e.kernelRegularizer)}build(t){t=pl(t);const e="channelsFirst"===this.dataFormat?1:t.length-1;if(null==t[e])throw new Ia("The channel dimension of the input should be defined. Found "+t[e]);const n=t[e],s=this.kernelSize.concat([n,this.filters]);this.kernel=this.addWeight("kernel",s,null,this.kernelInitializer,this.kernelRegularizer,!0,this.kernelConstraint),this.useBias&&(this.bias=this.addWeight("bias",[this.filters],null,this.biasInitializer,this.biasRegularizer,!0,this.biasConstraint)),this.inputSpec=[{ndim:this.rank+2,axes:{[e]:n}}],this.built=!0}call(t,e){return be(()=>{let e;t=cl(t);const n=null==this.bias?null:this.bias.read(),s=ja(this.activation.getClassName());if(null!=s&&2===this.rank)e=vh(t,this.kernel.read(),n,this.strides,this.padding,this.dataFormat,this.dilationRate,s);else{if(1===this.rank)e=function(t,e,n,s=1,r="valid",i,a=1){return be(()=>{if(null==i&&(i="channelsLast"),ao(i),3!==t.shape.length)throw new Ia("The input of a conv1dWithBias operation should be 3, but is "+t.shape.length+" instead.");if(3!==e.shape.length)throw new Ia("The kernel for a conv1dWithBias operation should be 3, but is "+e.shape.length+" instead");if(null!=n&&1!==n.shape.length)throw new Ia("The bias for a conv1dWithBias operation should be 1, but is "+e.shape.length+" instead");if("channelsFirst"===i&&(t=pe(t,[0,2,1])),"causal"===r)throw new Na("The support for CAUSAL padding mode in conv1dWithBias is not implemented yet.");let o=cn(t,e,s,"same"===r?"same":"valid","NWC",a);return null!=n&&(o=Lo(o,n)),o})}(t,this.kernel.read(),n,this.strides[0],this.padding,this.dataFormat,this.dilationRate[0]);else if(2===this.rank)e=vh(t,this.kernel.read(),n,this.strides,this.padding,this.dataFormat,this.dilationRate);else{if(3!==this.rank)throw new Na("convolutions greater than 3D are not implemented yet.");e=function(t,e,n,s=[1,1,1],r="valid",i,a){return be(()=>{if(null==i&&(i="channelsLast"),ao(i),4!==t.rank&&5!==t.rank)throw new Ia("conv3dWithBias expects input to be of rank 4 or 5, but received "+t.rank+".");if(4!==e.rank&&5!==e.rank)throw new Ia("conv3dWithBias expects kernel to be of rank 4 or 5, but received "+t.rank+".");let o=wh(t,i);if("causal"===r)throw new Na("The support for CAUSAL padding mode in conv3dWithBias is not implemented yet.");return o=fn(o,e,s,"same"===r?"same":"valid","NDHWC",a),null!=n&&(o=Lo(o,n)),"channelsFirst"===i&&(o=pe(o,[0,4,1,2,3])),o})}(t,this.kernel.read(),n,this.strides,this.padding,this.dataFormat,this.dilationRate)}null!=this.activation&&(e=this.activation.apply(e))}return e})}computeOutputShape(t){t=pl(t);const e=[],n="channelsLast"===this.dataFormat?t.slice(1,t.length-1):t.slice(2);for(let t=0;t<n.length;++t){const s=gh(n[t],this.kernelSize[t],this.padding,this.strides[t],"number"==typeof this.dilationRate?this.dilationRate:this.dilationRate[t]);e.push(s)}let s=[t[0]];return"channelsLast"===this.dataFormat?(s=s.concat(e),s.push(this.filters)):(s.push(this.filters),s=s.concat(e)),s}getConfig(){const t={filters:this.filters,kernelInitializer:sl(this.kernelInitializer),kernelRegularizer:ah(this.kernelRegularizer),kernelConstraint:Xa(this.kernelConstraint)},e=super.getConfig();return Object.assign(t,e),t}static verifyArgs(t){if(!("filters"in t)||"number"!=typeof t.filters||t.filters<1)throw new Ia("Convolution layer expected config.filters to be a 'number' > 0 but got "+JSON.stringify(t.filters))}}class Sh extends xh{constructor(t){super(2,t),Sh.verifyArgs(t)}getConfig(){const t=super.getConfig();return delete t.rank,t}static verifyArgs(t){if("number"!=typeof t.kernelSize&&!Ua(t.kernelSize,"number",1,2))throw new Ia(`Conv2D expects config.kernelSize to be number or number[] with length 1 or 2, but received ${JSON.stringify(t.kernelSize)}.`)}}Sh.className="Conv2D",ge(Sh);class Ih extends xh{constructor(t){super(3,t),Ih.verifyArgs(t)}getConfig(){const t=super.getConfig();return delete t.rank,t}static verifyArgs(t){if("number"!=typeof t.kernelSize&&(!Array.isArray(t.kernelSize)||1!==t.kernelSize.length&&3!==t.kernelSize.length))throw new Ia(`Conv3D expects config.kernelSize to be number or [number, number, number], but received ${JSON.stringify(t.kernelSize)}.`)}}Ih.className="Conv3D",ge(Ih);class Nh extends Sh{constructor(t){if(super(t),this.inputSpec=[new yl({ndim:4})],"same"!==this.padding&&"valid"!==this.padding)throw new Ia("Conv2DTranspose currently supports only padding modes 'same' and 'valid', but received padding mode "+this.padding)}build(t){if(4!==(t=pl(t)).length)throw new Ia("Input should have rank 4; Received input shape: "+JSON.stringify(t));const e="channelsFirst"===this.dataFormat?1:t.length-1;if(null==t[e])throw new Ia("The channel dimension of the inputs should be defined. Found `None`.");const n=t[e],s=this.kernelSize.concat([this.filters,n]);this.kernel=this.addWeight("kernel",s,"float32",this.kernelInitializer,this.kernelRegularizer,!0,this.kernelConstraint),this.useBias&&(this.bias=this.addWeight("bias",[this.filters],"float32",this.biasInitializer,this.biasRegularizer,!0,this.biasConstraint)),this.inputSpec=[new yl({ndim:4,axes:{[e]:n}})],this.built=!0}call(t,e){return be(()=>{let e=cl(t);if(4!==e.shape.length)throw new Ia("Conv2DTranspose.call() expects input tensor to be rank-4, but received a tensor of rank-"+e.shape.length);const n=e.shape,s=n[0];let r,i;"channelsFirst"===this.dataFormat?(r=2,i=3):(r=1,i=2);const a=n[r],o=n[i],l=this.kernelSize[0],u=this.kernelSize[1],h=this.strides[0],c=this.strides[1],p=[s,yh(a,h,l,this.padding),yh(o,c,u,this.padding),this.filters];"channelsLast"!==this.dataFormat&&(e=pe(e,[0,2,3,1]));let d=dn(e,this.kernel.read(),p,this.strides,this.padding);return"channelsLast"!==this.dataFormat&&(d=pe(d,[0,3,1,2])),null!=this.bias&&(d=Lo(d,this.bias.read(),this.dataFormat)),null!=this.activation&&(d=this.activation.apply(d)),d})}computeOutputShape(t){const e=(t=pl(t)).slice();let n,s,r;"channelsFirst"===this.dataFormat?(n=1,s=2,r=3):(n=3,s=1,r=2);const i=this.kernelSize[0],a=this.kernelSize[1],o=this.strides[0],l=this.strides[1];return e[n]=this.filters,e[s]=yh(e[s],o,i,this.padding),e[r]=yh(e[r],l,a,this.padding),e}getConfig(){const t=super.getConfig();return delete t.dilationRate,t}}Nh.className="Conv2DTranspose",ge(Nh);class Eh extends xh{constructor(t,e){if(super(t,e),this.DEFAULT_DEPTHWISE_INITIALIZER="glorotUniform",this.DEFAULT_POINTWISE_INITIALIZER="glorotUniform",this.depthwiseKernel=null,this.pointwiseKernel=null,null==e.filters)throw new Ia("The `filters` configuration field is required by SeparableConv, but is unspecified.");if(null!=e.kernelInitializer||null!=e.kernelRegularizer||null!=e.kernelConstraint)throw new Ia("Fields kernelInitializer, kernelRegularizer and kernelConstraint are invalid for SeparableConv2D. Use depthwiseInitializer, depthwiseRegularizer, depthwiseConstraint, pointwiseInitializer, pointwiseRegularizer and pointwiseConstraint instead.");if(null!=e.padding&&"same"!==e.padding&&"valid"!==e.padding)throw new Ia(`SeparableConv${this.rank}D supports only padding modes: 'same' and 'valid', but received `+JSON.stringify(e.padding));this.depthMultiplier=null==e.depthMultiplier?1:e.depthMultiplier,this.depthwiseInitializer=rl(e.depthwiseInitializer||this.DEFAULT_DEPTHWISE_INITIALIZER),this.depthwiseRegularizer=lh(e.depthwiseRegularizer),this.depthwiseConstraint=Qa(e.depthwiseConstraint),this.pointwiseInitializer=rl(e.depthwiseInitializer||this.DEFAULT_POINTWISE_INITIALIZER),this.pointwiseRegularizer=lh(e.pointwiseRegularizer),this.pointwiseConstraint=Qa(e.pointwiseConstraint)}build(t){if((t=pl(t)).length<this.rank+2)throw new Ia(`Inputs to SeparableConv${this.rank}D should have rank `+(this.rank+2)+", but received input shape: "+JSON.stringify(t));const e="channelsFirst"===this.dataFormat?1:t.length-1;if(null==t[e]||t[e]<0)throw new Ia("The channel dimension of the inputs should be defined, but found "+JSON.stringify(t[e]));const n=t[e],s=this.kernelSize.concat([n,this.depthMultiplier]),r=[];for(let t=0;t<this.rank;++t)r.push(1);r.push(n*this.depthMultiplier,this.filters);this.depthwiseKernel=this.addWeight("depthwise_kernel",s,"float32",this.depthwiseInitializer,this.depthwiseRegularizer,!0,this.depthwiseConstraint),this.pointwiseKernel=this.addWeight("pointwise_kernel",r,"float32",this.pointwiseInitializer,this.pointwiseRegularizer,!0,this.pointwiseConstraint),this.useBias?this.bias=this.addWeight("bias",[this.filters],"float32",this.biasInitializer,this.biasRegularizer,!0,this.biasConstraint):this.bias=null,this.inputSpec=[new yl({ndim:this.rank+2,axes:{[e]:n}})],this.built=!0}call(t,e){return be(()=>{let e;if(t=cl(t),1===this.rank)throw new Na("1D separable convolution is not implemented yet.");return 2===this.rank&&("channelsFirst"===this.dataFormat&&(t=pe(t,[0,2,3,1])),e=er(t,this.depthwiseKernel.read(),this.pointwiseKernel.read(),this.strides,this.padding,this.dilationRate,"NHWC")),this.useBias&&(e=Lo(e,this.bias.read(),this.dataFormat)),null!=this.activation&&(e=this.activation.apply(e)),"channelsFirst"===this.dataFormat&&(e=pe(e,[0,3,1,2])),e})}getConfig(){const t=super.getConfig();return delete t.rank,delete t.kernelInitializer,delete t.kernelRegularizer,delete t.kernelConstraint,t.depthwiseInitializer=sl(this.depthwiseInitializer),t.pointwiseInitializer=sl(this.pointwiseInitializer),t.depthwiseRegularizer=ah(this.depthwiseRegularizer),t.pointwiseRegularizer=ah(this.pointwiseRegularizer),t.depthwiseConstraint=Xa(this.depthwiseConstraint),t.pointwiseConstraint=Xa(this.pointwiseConstraint),t}}Eh.className="SeparableConv";class Ah extends Eh{constructor(t){super(2,t)}}Ah.className="SeparableConv2D",ge(Ah);class Th extends xh{constructor(t){super(1,t),Th.verifyArgs(t),this.inputSpec=[{ndim:3}]}getConfig(){const t=super.getConfig();return delete t.rank,delete t.dataFormat,t}static verifyArgs(t){if("number"!=typeof t.kernelSize&&!Ua(t.kernelSize,"number",1,1))throw new Ia(`Conv1D expects config.kernelSize to be number or number[] with length 1, but received ${JSON.stringify(t.kernelSize)}.`)}}Th.className="Conv1D",ge(Th);class Dh extends xl{constructor(t){super(t),"number"==typeof t.cropping?this.cropping=[[t.cropping,t.cropping],[t.cropping,t.cropping]]:"number"==typeof t.cropping[0]?this.cropping=[[t.cropping[0],t.cropping[0]],[t.cropping[1],t.cropping[1]]]:this.cropping=t.cropping,this.dataFormat=void 0===t.dataFormat?"channelsLast":t.dataFormat,this.inputSpec=[{ndim:4}]}computeOutputShape(t){return"channelsFirst"===this.dataFormat?[t[0],t[1],t[2]-this.cropping[0][0]-this.cropping[0][1],t[3]-this.cropping[1][0]-this.cropping[1][1]]:[t[0],t[1]-this.cropping[0][0]-this.cropping[0][1],t[2]-this.cropping[1][0]-this.cropping[1][1],t[3]]}call(t,e){return be(()=>{if(t=cl(t),"channelsLast"===this.dataFormat){const e=No(t,this.cropping[0][0],t.shape[1]-this.cropping[0][0]-this.cropping[0][1],2);return No(e,this.cropping[1][0],t.shape[2]-this.cropping[1][1]-this.cropping[1][0],3)}{const e=No(t,this.cropping[0][0],t.shape[2]-this.cropping[0][0]-this.cropping[0][1],3);return No(e,this.cropping[1][0],t.shape[3]-this.cropping[1][1]-this.cropping[1][0],4)}})}getConfig(){const t={cropping:this.cropping,dataFormat:this.dataFormat},e=super.getConfig();return Object.assign(t,e),t}}Dh.className="Cropping2D",ge(Dh);class zh extends xl{constructor(t){var e;super(t),this.DEFAULT_SIZE=[2,2],this.inputSpec=[{ndim:4}],this.size=null==t.size?this.DEFAULT_SIZE:t.size,this.dataFormat=null==t.dataFormat?"channelsLast":t.dataFormat,ao(this.dataFormat),this.interpolation=null==t.interpolation?"nearest":t.interpolation,e=this.interpolation,Pa(eo,"InterpolationFormat",e)}computeOutputShape(t){if("channelsFirst"===this.dataFormat){const e=null==t[2]?null:this.size[0]*t[2],n=null==t[3]?null:this.size[1]*t[3];return[t[0],t[1],e,n]}{const e=null==t[1]?null:this.size[0]*t[1],n=null==t[2]?null:this.size[1]*t[2];return[t[0],e,n,t[3]]}}call(t,e){return be(()=>{let e=cl(t);const n=e.shape;if("channelsFirst"===this.dataFormat){e=pe(e,[0,2,3,1]);const t=this.size[0]*n[2],s=this.size[1]*n[3],r="nearest"===this.interpolation?e.resizeNearestNeighbor([t,s]):e.resizeBilinear([t,s]);return pe(r,[0,3,1,2])}{const t=this.size[0]*n[1],s=this.size[1]*n[2];return"nearest"===this.interpolation?e.resizeNearestNeighbor([t,s]):e.resizeBilinear([t,s])}})}getConfig(){const t={size:this.size,dataFormat:this.dataFormat},e=super.getConfig();return Object.assign(t,e),t}}zh.className="UpSampling2D",ge(zh);class Ch extends kh{constructor(t){super(2,t),this.depthwiseKernel=null,this.depthMultiplier=null==t.depthMultiplier?1:t.depthMultiplier,this.depthwiseInitializer=rl(t.depthwiseInitializer||this.DEFAULT_KERNEL_INITIALIZER),this.depthwiseConstraint=Qa(t.depthwiseConstraint),this.depthwiseRegularizer=lh(t.depthwiseRegularizer)}build(t){if((t=pl(t)).length<4)throw new Ia(`Inputs to DepthwiseConv2D should have rank 4. Received input shape: ${JSON.stringify(t)}.`);const e="channelsFirst"===this.dataFormat?1:3;if(null==t[e]||t[e]<0)throw new Ia(`The channel dimension of the inputs to DepthwiseConv2D should be defined, but is not (${t[e]}).`);const n=t[e],s=[this.kernelSize[0],this.kernelSize[1],n,this.depthMultiplier];this.depthwiseKernel=this.addWeight("depthwise_kernel",s,null,this.depthwiseInitializer,this.depthwiseRegularizer,!0,this.depthwiseConstraint),this.useBias?this.bias=this.addWeight("bias",[n*this.depthMultiplier],null,this.biasInitializer,this.biasRegularizer,!0,this.biasConstraint):this.bias=null,this.built=!0}call(t,e){return be(()=>{let e=function(t,e,n=[1,1],s="valid",r,i){return be(()=>{null==r&&(r="channelsLast"),ao(r);let a=bh(t,r);if(4!==t.rank)throw new Ia("Input for depthwiseConv2d is required to be 4-D, but is instead "+t.rank+"-D");if(4!==e.rank)throw new Ia("depthwiseKernel is required to be 4-D, but is instead "+e.rank+"-D");return a=vn(a,e,n,"same"===s?"same":"valid","NHWC",i),"channelsFirst"===r&&(a=pe(a,[0,3,1,2])),a})}(t=cl(t),this.depthwiseKernel.read(),this.strides,this.padding,this.dataFormat,null);return this.useBias&&(e=Lo(e,this.bias.read(),this.dataFormat)),null!=this.activation&&(e=this.activation.apply(e)),e})}computeOutputShape(t){t=pl(t);const e="channelsFirst"===this.dataFormat?t[2]:t[1],n="channelsFirst"===this.dataFormat?t[3]:t[2],s="channelsFirst"===this.dataFormat?t[1]*this.depthMultiplier:t[3]*this.depthMultiplier,r=gh(e,this.kernelSize[0],this.padding,this.strides[0]),i=gh(n,this.kernelSize[1],this.padding,this.strides[1]);return"channelsFirst"===this.dataFormat?[t[0],s,r,i]:[t[0],r,i,s]}getConfig(){const t=super.getConfig();return t.depthMultiplier=this.depthMultiplier,t.depthwiseInitializer=sl(this.depthwiseInitializer),t.depthwiseRegularizer=ah(this.depthwiseRegularizer),t.depthwiseConstraint=Xa(this.depthwiseRegularizer),t}}function Fh(t,e,n,s){if(Array.isArray(t)){if(null!=e||null!=n)throw new Ia("When inputs is an array, neither initialState or constants should be provided");null!=s&&(n=t.slice(t.length-s,t.length),t=t.slice(0,t.length-s)),t.length>1&&(e=t.slice(1,t.length)),t=t[0]}function r(t){return null==t||Array.isArray(t)?t:[t]}return{inputs:t,initialState:e=r(e),constants:n=r(n)}}function Rh(t,e,n,s=!1,r,i,a=!1,o=!1){return be(()=>{const l=e.shape.length;if(l<3)throw new Ia(`Input should be at least 3D, but is ${l}D.`);const u=[1,0].concat(vo(2,l));if(e=pe(e,u),null!=i)throw new Na("The rnn() functoin of the deeplearn.js backend does not support constants yet.");a&&console.warn("Backend rnn(): the unroll = true option is not applicable to the imperative deeplearn.js backend."),null!=r&&((r=r.asType("bool").asType("float32")).rank===l-1&&(r=Fn(r,-1)),r=pe(r,u)),s&&(e=Zs(e,0),null!=r&&(r=Zs(r,0)));const h=[];let c,p=n;const d=e.shape[0],f=Tr(e);let m,g;null!=r&&(m=Tr(r));for(let e=0;e<d;++e){const n=f[e],s=be(()=>t(n,p));if(null==r)c=s[0],p=s[1];else{const t=be(()=>{const t=m[e],n=Ns(t).sub(t);return{output:s[0].mul(t).add(p[0].mul(n)),newStates:p.map((e,r)=>s[1][r].mul(t).add(e.mul(n)))}});c=t.output,p=t.newStates}o&&h.push(c)}if(o){g=br(h,1)}return[c,g,p]})}Ch.className="DepthwiseConv2D",ge(Ch);class Lh extends xl{constructor(t){let e;if(super(t),null==t.cell)throw new Ia("cell property is missing for the constructor of RNN.");if(e=Array.isArray(t.cell)?new Wh({cells:t.cell}):t.cell,null==e.stateSize)throw new Ia("The RNN cell should have an attribute `stateSize` (tuple of integers, one integer per RNN state).");this.cell=e,this.returnSequences=null!=t.returnSequences&&t.returnSequences,this.returnState=null!=t.returnState&&t.returnState,this.goBackwards=null!=t.goBackwards&&t.goBackwards,this._stateful=null!=t.stateful&&t.stateful,this.unroll=null!=t.unroll&&t.unroll,this.supportsMasking=!0,this.inputSpec=[new yl({ndim:3})],this.stateSpec=null,this.states_=null,this.numConstants=null,this.keptStates=[]}getStates(){if(null==this.states_){return vo(0,Array.isArray(this.cell.stateSize)?this.cell.stateSize.length:1).map(t=>null)}return this.states_}setStates(t){this.states_=t}computeOutputShape(t){ul(t)&&(t=t[0]),t=t;let e=this.cell.stateSize;Array.isArray(e)||(e=[e]);const n=e[0];let s;if(s=this.returnSequences?[t[0],t[1],n]:[t[0],n],this.returnState){const n=[];for(const s of e)n.push([t[0],s]);return[s].concat(n)}return s}computeMask(t,e){return be(()=>{Array.isArray(e)&&(e=e[0]);const t=this.returnSequences?e:null;if(this.returnState){const e=this.states.map(t=>null);return[t].concat(e)}return t})}get states(){if(null==this.states_){const t=Array.isArray(this.cell.stateSize)?this.cell.stateSize.length:1,e=[];for(let n=0;n<t;++n)e.push(null);return e}return this.states_}set states(t){this.states_=t}build(t){if(null!=this.numConstants)throw new Na("Constants support is not implemented in RNN yet.");ul(t)&&(t=t[0]),t=t;const e=this.stateful?t[0]:null,n=t.slice(2);this.inputSpec[0]=new yl({shape:[e,null,...n]});const s=[t[0]].concat(t.slice(2));let r;if(this.cell.build(s),r=Array.isArray(this.cell.stateSize)?this.cell.stateSize:[this.cell.stateSize],null!=this.stateSpec){if(!u(this.stateSpec.map(t=>t.shape[t.shape.length-1]),r))throw new Ia(`An initialState was passed that is not compatible with cell.stateSize. Received stateSpec=${this.stateSpec}; However cell.stateSize is `+this.cell.stateSize)}else this.stateSpec=r.map(t=>new yl({shape:[null,t]}));this.stateful&&this.resetStates()}resetStates(t,e=!1){be(()=>{if(!this.stateful)throw new xa("Cannot call resetStates() on an RNN Layer that is not stateful.");const n=this.inputSpec[0].shape[0];if(null==n)throw new Ia("If an RNN is stateful, it needs to know its batch size. Specify the batch size of your input tensors: \n- If using a Sequential model, specify the batch size by passing a `batchInputShape` option to your first layer.\n- If using the functional API, specify the batch size by passing a `batchShape` option to your Input layer.");if(null==this.states_)Array.isArray(this.cell.stateSize)?this.states_=this.cell.stateSize.map(t=>Ss([n,t])):this.states_=[Ss([n,this.cell.stateSize])];else if(null==t)we(this.states_),null!=this.keptStates&&(we(this.keptStates),this.keptStates=[]),Array.isArray(this.cell.stateSize)?this.states_=this.cell.stateSize.map(t=>Ss([n,t])):this.states_[0]=Ss([n,this.cell.stateSize]);else{if(Array.isArray(t)||(t=[t]),t.length!==this.states_.length)throw new Ia(`Layer ${this.name} expects ${this.states_.length} state(s), but it received ${t.length} state value(s). Input received: `+t);!0===e?this.keptStates.push(this.states_.slice()):we(this.states_);for(let e=0;e<this.states_.length;++e){const s=t[e],r=Array.isArray(this.cell.stateSize)?this.cell.stateSize[e]:this.cell.stateSize,i=[n,r];if(!u(s.shape,i))throw new Ia(`State ${e} is incompatible with layer ${this.name}: expected shape=${i}, received shape=${s.shape}`);this.states_[e]=s}}this.states_=this.states_.map(t=>ve(t.clone()))})}apply(t,e){let n=null==e?null:e.initialState,s=null==e?null:e.constants;null==e&&(e={});const r=Fh(t,n,s,this.numConstants);t=r.inputs,n=r.initialState,s=r.constants;let i=[],a=[];if(null!=n){e.initialState=n,i=i.concat(n),this.stateSpec=[];for(const t of n)this.stateSpec.push(new yl({shape:t.shape}));a=a.concat(this.stateSpec)}null!=s&&(e.constants=s,i=i.concat(s),this.numConstants=s.length);if(i[0]instanceof bl){const n=[t].concat(i),s=this.inputSpec.concat(a),r=this.inputSpec;this.inputSpec=s;const o=super.apply(n,e);return this.inputSpec=r,o}return super.apply(t,e)}call(t,e){return be(()=>{const n=null==e?null:e.mask,s=null==e?null:e.training;let r=null==e?null:e.initialState;t=cl(t),null==r&&(r=this.stateful?this.states_:this.getInitialState(t));const i=Array.isArray(this.cell.stateSize)?this.cell.stateSize.length:1;if(r.length!==i)throw new Ia(`RNN Layer has ${i} state(s) but was passed `+r.length+" initial state(s).");this.unroll&&console.warn("Ignoring unroll = true for RNN layer, due to imperative backend.");const a={training:s},o=Rh((t,e)=>{const n=this.cell.call([t].concat(e),a);return[n[0],n.slice(1)]},t,r,this.goBackwards,n,null,this.unroll,this.returnSequences),l=o[0],u=o[1],h=o[2];this.stateful&&this.resetStates(h,s);const c=this.returnSequences?u:l;return this.returnState?[c].concat(h):c})}getInitialState(t){return be(()=>{let e=Ss(t.shape);return e=ss(e,[1,2]),e=xo(e),Array.isArray(this.cell.stateSize)?this.cell.stateSize.map(t=>t>1?To(e,[1,t]):e):this.cell.stateSize>1?[To(e,[1,this.cell.stateSize])]:[e]})}get trainableWeights(){return this.trainable?this.cell.trainableWeights:[]}get nonTrainableWeights(){return this.trainable?this.cell.nonTrainableWeights:this.cell.weights}setFastWeightInitDuringBuild(t){super.setFastWeightInitDuringBuild(t),null!=this.cell&&this.cell.setFastWeightInitDuringBuild(t)}getConfig(){const t=super.getConfig(),e={returnSequences:this.returnSequences,returnState:this.returnState,goBackwards:this.goBackwards,stateful:this.stateful,unroll:this.unroll};null!=this.numConstants&&(e.numConstants=this.numConstants);const n=this.cell.getConfig();return this.getClassName()===Lh.className&&(e.cell={className:this.cell.getClassName(),config:n}),Object.assign({},n,t,e)}static fromConfig(t,e,n={}){const s=Ml(e.cell,n);return new t(Object.assign(e,{cell:s}))}}Lh.className="RNN",ge(Lh);class Mh extends xl{}class _h extends Mh{constructor(t){super(t),this.DEFAULT_ACTIVATION="tanh",this.DEFAULT_KERNEL_INITIALIZER="glorotNormal",this.DEFAULT_RECURRENT_INITIALIZER="orthogonal",this.DEFAULT_BIAS_INITIALIZER="zeros",this.units=t.units,Wa(this.units,"units"),this.activation=nh(null==t.activation?this.DEFAULT_ACTIVATION:t.activation),this.useBias=null==t.useBias||t.useBias,this.kernelInitializer=rl(t.kernelInitializer||this.DEFAULT_KERNEL_INITIALIZER),this.recurrentInitializer=rl(t.recurrentInitializer||this.DEFAULT_RECURRENT_INITIALIZER),this.biasInitializer=rl(t.biasInitializer||this.DEFAULT_BIAS_INITIALIZER),this.kernelRegularizer=lh(t.kernelRegularizer),this.recurrentRegularizer=lh(t.recurrentRegularizer),this.biasRegularizer=lh(t.biasRegularizer),this.kernelConstraint=Qa(t.kernelConstraint),this.recurrentConstraint=Qa(t.recurrentConstraint),this.biasConstraint=Qa(t.biasConstraint),this.dropout=bo([1,wo([0,null==t.dropout?0:t.dropout])]),this.recurrentDropout=bo([1,wo([0,null==t.recurrentDropout?0:t.recurrentDropout])]),this.stateSize=this.units,this.dropoutMask=null,this.recurrentDropoutMask=null}build(t){t=pl(t),this.kernel=this.addWeight("kernel",[t[t.length-1],this.units],null,this.kernelInitializer,this.kernelRegularizer,!0,this.kernelConstraint),this.recurrentKernel=this.addWeight("recurrent_kernel",[this.units,this.units],null,this.recurrentInitializer,this.recurrentRegularizer,!0,this.recurrentConstraint),this.useBias?this.bias=this.addWeight("bias",[this.units],null,this.biasInitializer,this.biasRegularizer,!0,this.biasConstraint):this.bias=null,this.built=!0}call(t,e){return be(()=>{if(2!==(t=t).length)throw new Ia(`SimpleRNNCell expects 2 input Tensors, got ${t.length}.`);let n=t[1];t=t[0];const s=null!=e.training&&e.training;let r;0<this.dropout&&this.dropout<1&&null==this.dropoutMask&&(this.dropoutMask=jh({ones:()=>Ns(t),rate:this.dropout,training:s})),0<this.recurrentDropout&&this.recurrentDropout<1&&null==this.recurrentDropoutMask&&(this.recurrentDropoutMask=jh({ones:()=>Ns(n),rate:this.recurrentDropout,training:s}));const i=this.dropoutMask,a=this.recurrentDropoutMask;r=zo(null!=i?Ne(t,i):t,this.kernel.read()),null!=this.bias&&(r=Lo(r,this.bias.read())),null!=a&&(n=Ne(n,a));let o=xe(r,zo(n,this.recurrentKernel.read()));return null!=this.activation&&(o=this.activation.apply(o)),[o,o]})}getConfig(){const t=super.getConfig(),e={units:this.units,activation:th(this.activation),useBias:this.useBias,kernelInitializer:sl(this.kernelInitializer),recurrentInitializer:sl(this.recurrentInitializer),biasInitializer:sl(this.biasInitializer),kernelRegularizer:ah(this.kernelRegularizer),recurrentRegularizer:ah(this.recurrentRegularizer),biasRegularizer:ah(this.biasRegularizer),activityRegularizer:ah(this.activityRegularizer),kernelConstraint:Xa(this.kernelConstraint),recurrentConstraint:Xa(this.recurrentConstraint),biasConstraint:Xa(this.biasConstraint),dropout:this.dropout,recurrentDropout:this.recurrentDropout};return Object.assign({},t,e)}}_h.className="SimpleRNNCell",ge(_h);class $h extends Lh{constructor(t){t.cell=new _h(t),super(t)}call(t,e){return be(()=>{null!=this.cell.dropoutMask&&(we(this.cell.dropoutMask),this.cell.dropoutMask=null),null!=this.cell.recurrentDropoutMask&&(we(this.cell.recurrentDropoutMask),this.cell.recurrentDropoutMask=null);const n=null==e?null:e.mask,s=null==e?null:e.training,r=null==e?null:e.initialState;return super.call(t,{mask:n,training:s,initialState:r})})}static fromConfig(t,e){return new t(e)}}$h.className="SimpleRNN",ge($h);class Oh extends Mh{constructor(t){if(super(t),this.DEFAULT_ACTIVATION="tanh",this.DEFAULT_RECURRENT_ACTIVATION="hardSigmoid",this.DEFAULT_KERNEL_INITIALIZER="glorotNormal",this.DEFAULT_RECURRENT_INITIALIZER="orthogonal",this.DEFAULT_BIAS_INITIALIZER="zeros",t.resetAfter)throw new Ia("GRUCell does not support reset_after parameter set to true.");this.units=t.units,Wa(this.units,"units"),this.activation=nh(void 0===t.activation?this.DEFAULT_ACTIVATION:t.activation),this.recurrentActivation=nh(void 0===t.recurrentActivation?this.DEFAULT_RECURRENT_ACTIVATION:t.recurrentActivation),this.useBias=null==t.useBias||t.useBias,this.kernelInitializer=rl(t.kernelInitializer||this.DEFAULT_KERNEL_INITIALIZER),this.recurrentInitializer=rl(t.recurrentInitializer||this.DEFAULT_RECURRENT_INITIALIZER),this.biasInitializer=rl(t.biasInitializer||this.DEFAULT_BIAS_INITIALIZER),this.kernelRegularizer=lh(t.kernelRegularizer),this.recurrentRegularizer=lh(t.recurrentRegularizer),this.biasRegularizer=lh(t.biasRegularizer),this.kernelConstraint=Qa(t.kernelConstraint),this.recurrentConstraint=Qa(t.recurrentConstraint),this.biasConstraint=Qa(t.biasConstraint),this.dropout=bo([1,wo([0,null==t.dropout?0:t.dropout])]),this.recurrentDropout=bo([1,wo([0,null==t.recurrentDropout?0:t.recurrentDropout])]),this.implementation=t.implementation,this.stateSize=this.units,this.dropoutMask=null,this.recurrentDropoutMask=null}build(t){const e=(t=pl(t))[t.length-1];this.kernel=this.addWeight("kernel",[e,3*this.units],null,this.kernelInitializer,this.kernelRegularizer,!0,this.kernelConstraint),this.recurrentKernel=this.addWeight("recurrent_kernel",[this.units,3*this.units],null,this.recurrentInitializer,this.recurrentRegularizer,!0,this.recurrentConstraint),this.useBias?this.bias=this.addWeight("bias",[3*this.units],null,this.biasInitializer,this.biasRegularizer,!0,this.biasConstraint):this.bias=null,this.built=!0}call(t,e){return be(()=>{if(2!==(t=t).length)throw new Ia("GRUCell expects 2 input Tensors (inputs, h, c), got "+t.length+".");const n=null!=e.training&&e.training;let s=t[1];t=t[0],0<this.dropout&&this.dropout<1&&null==this.dropoutMask&&(this.dropoutMask=jh({ones:()=>Ns(t),rate:this.dropout,training:n,count:3})),0<this.recurrentDropout&&this.recurrentDropout<1&&null==this.recurrentDropoutMask&&(this.recurrentDropoutMask=jh({ones:()=>Ns(s),rate:this.recurrentDropout,training:n,count:3}));const r=this.dropoutMask,i=this.recurrentDropoutMask;let a,o,l;0<this.dropout&&this.dropout<1&&(t=Ne(t,r[0]));let u=zo(t,this.kernel.read());this.useBias&&(u=Lo(u,this.bias.read())),0<this.recurrentDropout&&this.recurrentDropout<1&&(s=Ne(s,i[0]));const h=this.recurrentKernel.read(),[c,p]=dr(h,[2*this.units,this.units],h.rank-1),d=zo(s,c),[f,m,g]=dr(u,3,u.rank-1),[y,b]=dr(d,2,d.rank-1);a=this.recurrentActivation.apply(xe(f,y)),o=this.recurrentActivation.apply(xe(m,b));const w=zo(Ne(o,s),p);l=this.activation.apply(xe(g,w));const v=xe(Ne(a,s),Ne(xe(1,Yn(a)),l));return[v,v]})}getConfig(){const t=super.getConfig(),e={units:this.units,activation:th(this.activation),recurrentActivation:th(this.recurrentActivation),useBias:this.useBias,kernelInitializer:sl(this.kernelInitializer),recurrentInitializer:sl(this.recurrentInitializer),biasInitializer:sl(this.biasInitializer),kernelRegularizer:ah(this.kernelRegularizer),recurrentRegularizer:ah(this.recurrentRegularizer),biasRegularizer:ah(this.biasRegularizer),activityRegularizer:ah(this.activityRegularizer),kernelConstraint:Xa(this.kernelConstraint),recurrentConstraint:Xa(this.recurrentConstraint),biasConstraint:Xa(this.biasConstraint),dropout:this.dropout,recurrentDropout:this.recurrentDropout,implementation:this.implementation,resetAfter:!1};return Object.assign({},t,e)}}Oh.className="GRUCell",ge(Oh);class Bh extends Lh{constructor(t){0===t.implementation&&console.warn("`implementation=0` has been deprecated, and now defaults to `implementation=1`. Please update your layer call."),t.cell=new Oh(t),super(t)}call(t,e){return be(()=>{null!=this.cell.dropoutMask&&(we(this.cell.dropoutMask),this.cell.dropoutMask=null),null!=this.cell.recurrentDropoutMask&&(we(this.cell.recurrentDropoutMask),this.cell.recurrentDropoutMask=null);const n=null==e?null:e.mask,s=null==e?null:e.training,r=null==e?null:e.initialState;return super.call(t,{mask:n,training:s,initialState:r})})}static fromConfig(t,e){return 0===e.implmentation&&(e.implementation=1),new t(e)}}Bh.className="GRU",ge(Bh);class Ph extends Mh{constructor(t){super(t),this.DEFAULT_ACTIVATION="tanh",this.DEFAULT_RECURRENT_ACTIVATION="hardSigmoid",this.DEFAULT_KERNEL_INITIALIZER="glorotNormal",this.DEFAULT_RECURRENT_INITIALIZER="orthogonal",this.DEFAULT_BIAS_INITIALIZER="zeros",this.units=t.units,Wa(this.units,"units"),this.activation=nh(void 0===t.activation?this.DEFAULT_ACTIVATION:t.activation),this.recurrentActivation=nh(void 0===t.recurrentActivation?this.DEFAULT_RECURRENT_ACTIVATION:t.recurrentActivation),this.useBias=null==t.useBias||t.useBias,this.kernelInitializer=rl(t.kernelInitializer||this.DEFAULT_KERNEL_INITIALIZER),this.recurrentInitializer=rl(t.recurrentInitializer||this.DEFAULT_RECURRENT_INITIALIZER),this.biasInitializer=rl(t.biasInitializer||this.DEFAULT_BIAS_INITIALIZER),this.unitForgetBias=t.unitForgetBias,this.kernelRegularizer=lh(t.kernelRegularizer),this.recurrentRegularizer=lh(t.recurrentRegularizer),this.biasRegularizer=lh(t.biasRegularizer),this.kernelConstraint=Qa(t.kernelConstraint),this.recurrentConstraint=Qa(t.recurrentConstraint),this.biasConstraint=Qa(t.biasConstraint),this.dropout=bo([1,wo([0,null==t.dropout?0:t.dropout])]),this.recurrentDropout=bo([1,wo([0,null==t.recurrentDropout?0:t.recurrentDropout])]),this.implementation=t.implementation,this.stateSize=[this.units,this.units],this.dropoutMask=null,this.recurrentDropoutMask=null}build(t){var e;const n=(t=pl(t))[t.length-1];let s;if(this.kernel=this.addWeight("kernel",[n,4*this.units],null,this.kernelInitializer,this.kernelRegularizer,!0,this.kernelConstraint),this.recurrentKernel=this.addWeight("recurrent_kernel",[this.units,4*this.units],null,this.recurrentInitializer,this.recurrentRegularizer,!0,this.recurrentConstraint),this.useBias){if(this.unitForgetBias){const t=this.biasInitializer,n=this.units;s=new((e=class extends Bo{apply(e,s){const r=t.apply([n]),i=(new Uo).apply([n]),a=t.apply([2*n]);return Ao(Ao(r,i),a)}}).className="CustomInit",e)}else s=this.biasInitializer;this.bias=this.addWeight("bias",[4*this.units],null,s,this.biasRegularizer,!0,this.biasConstraint)}else this.bias=null;this.built=!0}call(t,e){return be(()=>{const n=null!=e.training&&e.training;if(3!==(t=t).length)throw new Ia("LSTMCell expects 3 input Tensors (inputs, h, c), got "+t.length+".");let s=t[1];const r=t[2];t=t[0],0<this.dropout&&this.dropout<1&&null==this.dropoutMask&&(this.dropoutMask=jh({ones:()=>Ns(t),rate:this.dropout,training:n,count:4})),0<this.recurrentDropout&&this.recurrentDropout<1&&null==this.recurrentDropoutMask&&(this.recurrentDropoutMask=jh({ones:()=>Ns(s),rate:this.recurrentDropout,training:n,count:4}));const i=this.dropoutMask,a=this.recurrentDropoutMask;let o,l,u,h;0<this.dropout&&this.dropout<1&&(t=Ne(t,i[0]));let c=zo(t,this.kernel.read());0<this.recurrentDropout&&this.recurrentDropout<1&&(s=Ne(s,a[0])),c=xe(c,zo(s,this.recurrentKernel.read())),this.useBias&&(c=Lo(c,this.bias.read()));const[p,d,f,m]=dr(c,4,c.rank-1);o=this.recurrentActivation.apply(p),l=this.recurrentActivation.apply(d),u=xe(Ne(l,r),Ne(o,this.activation.apply(f))),h=this.recurrentActivation.apply(m);const g=Ne(h,this.activation.apply(u));return[g,g,u]})}getConfig(){const t=super.getConfig(),e={units:this.units,activation:th(this.activation),recurrentActivation:th(this.recurrentActivation),useBias:this.useBias,kernelInitializer:sl(this.kernelInitializer),recurrentInitializer:sl(this.recurrentInitializer),biasInitializer:sl(this.biasInitializer),unitForgetBias:this.unitForgetBias,kernelRegularizer:ah(this.kernelRegularizer),recurrentRegularizer:ah(this.recurrentRegularizer),biasRegularizer:ah(this.biasRegularizer),activityRegularizer:ah(this.activityRegularizer),kernelConstraint:Xa(this.kernelConstraint),recurrentConstraint:Xa(this.recurrentConstraint),biasConstraint:Xa(this.biasConstraint),dropout:this.dropout,recurrentDropout:this.recurrentDropout,implementation:this.implementation};return Object.assign({},t,e)}}Ph.className="LSTMCell",ge(Ph);class Uh extends Lh{constructor(t){0===t.implementation&&console.warn("`implementation=0` has been deprecated, and now defaults to `implementation=1`. Please update your layer call."),t.cell=new Ph(t),super(t)}call(t,e){return be(()=>{null!=this.cell.dropoutMask&&(we(this.cell.dropoutMask),this.cell.dropoutMask=null),null!=this.cell.recurrentDropoutMask&&(we(this.cell.recurrentDropoutMask),this.cell.recurrentDropoutMask=null);const n=null==e?null:e.mask,s=null==e?null:e.training,r=null==e?null:e.initialState;return super.call(t,{mask:n,training:s,initialState:r})})}static fromConfig(t,e){return 0===e.implmentation&&(e.implementation=1),new t(e)}}Uh.className="LSTM",ge(Uh);class Wh extends Mh{constructor(t){super(t),this.cells=t.cells}get stateSize(){const t=[];for(const e of this.cells.slice().reverse())Array.isArray(e.stateSize)?t.push(...e.stateSize):t.push(e.stateSize);return t}call(t,e){return be(()=>{let n=(t=t).slice(1);const s=[];for(const t of this.cells.slice().reverse())Array.isArray(t.stateSize)?s.push(n.splice(0,t.stateSize.length)):s.push(n.splice(0,1));s.reverse();const r=[];let i;for(let a=0;a<this.cells.length;++a){const o=this.cells[a];n=s[a],i=0===a?[t[0]].concat(n):[i[0]].concat(n),i=o.call(i,e),r.push(i.slice(1))}n=[];for(const t of r.slice().reverse())n.push(...t);return[i[0]].concat(n)})}build(t){let e;ul(t)&&(t=t[0]),t=t,this.cells.forEach((n,s)=>{ho("RNNCell_"+s,()=>{n.build(t),e=Array.isArray(n.stateSize)?n.stateSize[0]:n.stateSize,t=[t[0],e]})}),this.built=!0}getConfig(){const t=super.getConfig(),e={cells:this.cells.map(t=>({className:t.getClassName(),config:t.getConfig()}))};return Object.assign({},t,e)}static fromConfig(t,e,n={}){const s=[];for(const t of e.cells)s.push(Ml(t,n));return new t({cells:s})}get trainableWeights(){if(!this.trainable)return[];const t=[];for(const e of this.cells)t.push(...e.trainableWeights);return t}get nonTrainableWeights(){const t=[];for(const e of this.cells)t.push(...e.nonTrainableWeights);if(!this.trainable){const e=[];for(const t of this.cells)e.push(...t.trainableWeights);return e.concat(t)}return t}getWeights(){const t=[];for(const e of this.cells)t.push(...e.weights);return ml(t)}setWeights(t){const e=[];for(const n of this.cells){const s=n.weights.length,r=t.splice(s);for(let t=0;t<n.weights.length;++t)e.push([n.weights[t],r[t]])}gl(e)}}function jh(t){const{ones:e,rate:n,training:s=!1,count:r=1}=t,i=()=>Mo(e(),n),a=()=>_o(i,e,s);if(!r||r<=1)return ve(a().clone());return Array(r).fill(void 0).map(a).map(t=>ve(t.clone()))}Wh.className="StackedRNNCells",ge(Wh);var qh=function(t,e){var n={};for(var s in t)Object.prototype.hasOwnProperty.call(t,s)&&e.indexOf(s)<0&&(n[s]=t[s]);if(null!=t&&"function"==typeof Object.getOwnPropertySymbols){var r=0;for(s=Object.getOwnPropertySymbols(t);r<s.length;r++)e.indexOf(s[r])<0&&Object.prototype.propertyIsEnumerable.call(t,s[r])&&(n[s[r]]=t[s[r]])}return n};class Kh extends Lh{constructor(t){if(t.unroll)throw new Na("Unrolling is not possible with convolutional RNNs.");if(Array.isArray(t.cell))throw new Na("It is not possible at the moment to stack convolutional cells.");super(t),this.inputSpec=[new yl({ndim:5})]}call(t,e){return be(()=>{if(null!=this.cell.dropoutMask&&(we(this.cell.dropoutMask),this.cell.dropoutMask=null),null!=this.cell.recurrentDropoutMask&&(we(this.cell.recurrentDropoutMask),this.cell.recurrentDropoutMask=null),e&&e.constants)throw new Ia("ConvRNN2D cell does not support constants");const n=null==e?null:e.mask,s=null==e?null:e.training,r=null==e?null:e.initialState;return super.call(t,{mask:n,training:s,initialState:r})})}computeOutputShape(t){let e=this.computeSingleOutputShape(t);return this.returnSequences||(e=[e[0],...e.slice(2)]),this.returnState&&(e=[e,...Array(2).fill([t[0],...e.slice(-3)])]),e}getInitialState(t){return be(()=>{const{stateSize:e}=this.cell,n=t.shape,s=this.computeSingleOutputShape(n),r=Ss([s[0],...s.slice(2)]);return Array.isArray(e)?Array(e.length).fill(r):[r]})}resetStates(t,e=!1){be(()=>{if(!this.stateful)throw new xa("Cannot call resetStates() on an RNN Layer that is not stateful.");const n=this.inputSpec[0].shape,s=this.computeSingleOutputShape(n),r=[s[0],...s.slice(2)];if(null==n[0])throw new Ia("If an RNN is stateful, it needs to know its batch size. Specify the batch size of your input tensors: \n- If using a Sequential model, specify the batch size by passing a `batchInputShape` option to your first layer.\n- If using the functional API, specify the batch size by passing a `batchShape` option to your Input layer.");if(null==this.getStates())Array.isArray(this.cell.stateSize)?this.states_=this.cell.stateSize.map(()=>Ss(r)):this.states_=[Ss(r)];else if(null==t)we(this.states_),null!=this.keptStates&&(we(this.keptStates),this.keptStates=[]),Array.isArray(this.cell.stateSize)?this.states_=this.cell.stateSize.map(()=>Ss(r)):this.states_[0]=Ss(r);else{if(Array.isArray(t)||(t=[t]),t.length!==this.states_.length)throw new Ia(`Layer ${this.name} expects ${this.states_.length} state(s), but it received ${t.length} state value(s). Input received: `+t);e?this.keptStates.push(this.states_.slice()):we(this.states_);for(let e=0;e<this.states_.length;++e){const n=t[e],s=r;if(!u(n.shape,s))throw new Ia(`State ${e} is incompatible with layer ${this.name}: expected shape=${s}, received shape=${n.shape}`);this.states_[e]=n}}this.states_=this.states_.map(t=>ve(t.clone()))})}computeSingleOutputShape(t){const{dataFormat:e,filters:n,kernelSize:s,padding:r,strides:i,dilationRate:a}=this.cell,o="channelsFirst"===e,l=t[o?3:2],u=t[o?4:3],h=gh(l,s[0],r,i[0],a[0]),c=gh(u,s[1],r,i[1],a[1]);return[...t.slice(0,2),...o?[n,h,c]:[h,c,n]]}}Kh.className="ConvRNN2D";class Vh extends Ph{constructor(t){const{filters:e,kernelSize:n,strides:s,padding:r,dataFormat:i,dilationRate:a}=t;super(Object.assign({},t,{units:e})),this.filters=e,Wa(this.filters,"filters"),this.kernelSize=mh(n,2,"kernelSize"),this.kernelSize.forEach(t=>Wa(t,"kernelSize")),this.strides=mh(s||1,2,"strides"),this.strides.forEach(t=>Wa(t,"strides")),this.padding=r||"valid",oo(this.padding),this.dataFormat=i||"channelsLast",ao(this.dataFormat),this.dilationRate=mh(a||1,2,"dilationRate"),this.dilationRate.forEach(t=>Wa(t,"dilationRate"))}build(t){var e;t=pl(t);const n="channelsFirst"===this.dataFormat?1:t.length-1;if(null==t[n])throw new Ia("The channel dimension of the input should be defined. Found "+t[n]);const s=t[n],r=this.kernelSize.concat([s,4*this.filters]);this.kernel=this.addWeight("kernel",r,null,this.kernelInitializer,this.kernelRegularizer,!0,this.kernelConstraint);const i=this.kernelSize.concat([this.filters,4*this.filters]);if(this.recurrentKernel=this.addWeight("recurrent_kernel",i,null,this.recurrentInitializer,this.recurrentRegularizer,!0,this.recurrentConstraint),this.useBias){let t;if(this.unitForgetBias){const n=this.biasInitializer,s=this.filters;t=new((e=class extends Bo{apply(t,e){return Eo([n.apply([s]),Is([s]),n.apply([2*s])])}}).className="CustomInit",e)}else t=this.biasInitializer;this.bias=this.addWeight("bias",[4*this.filters],null,t,this.biasRegularizer,!0,this.biasConstraint)}this.built=!0}call(t,e){return be(()=>{if(3!==t.length)throw new Ia("ConvLSTM2DCell expects 3 input Tensors (inputs, h, c), got "+t.length+".");const n=e.training||!1,s=t[0],r=t[1],i=t[2];0<this.dropout&&this.dropout<1&&null==this.dropoutMask&&(this.dropoutMask=jh({ones:()=>Ns(s),rate:this.dropout,training:n,count:4}));const a=this.dropoutMask,o=(t,e,n)=>e&&e[n]?Ne(e[n],t):t;let l=o(s,a,0),u=o(s,a,1),h=o(s,a,2),c=o(s,a,3);0<this.recurrentDropout&&this.recurrentDropout<1&&null==this.recurrentDropoutMask&&(this.recurrentDropoutMask=jh({ones:()=>Ns(r),rate:this.recurrentDropout,training:n,count:4}));const p=this.recurrentDropoutMask;let d=o(r,p,0),f=o(r,p,1),m=o(r,p,2),g=o(r,p,3);const[y,b,w,v]=dr(this.kernel.read(),4,3),[k,x,S,I]=this.useBias?dr(this.bias.read(),4):[null,null,null,null];l=this.inputConv(l,y,k,this.padding),u=this.inputConv(u,b,x,this.padding),h=this.inputConv(h,w,S,this.padding),c=this.inputConv(c,v,I,this.padding);const[N,E,A,T]=dr(this.recurrentKernel.read(),4,3);d=this.recurrentConv(d,N),f=this.recurrentConv(f,E),m=this.recurrentConv(m,A),g=this.recurrentConv(g,T);const D=this.recurrentActivation.apply(xe(l,d)),z=this.recurrentActivation.apply(xe(u,f)),C=xe(Ne(z,i),Ne(D,this.activation.apply(xe(h,m)))),F=Ne(this.recurrentActivation.apply(xe(c,g)),this.activation.apply(C));return[F,F,C]})}getConfig(){const t=super.getConfig(),e=qh(t,["units"]),n={filters:this.filters,kernelSize:this.kernelSize,padding:this.padding,dataFormat:this.dataFormat,dilationRate:this.dilationRate,strides:this.strides};return Object.assign({},e,n)}inputConv(t,e,n,s){const r=hn(t,e,this.strides,s||"valid","channelsFirst"===this.dataFormat?"NCHW":"NHWC",this.dilationRate);return n?Lo(r,n,this.dataFormat):r}recurrentConv(t,e){return hn(t,e,1,"same","channelsFirst"===this.dataFormat?"NCHW":"NHWC")}}Vh.className="ConvLSTM2DCell",ge(Vh);class Hh extends Kh{constructor(t){const e=new Vh(t);super(Object.assign({},t,{cell:e}))}static fromConfig(t,e){return new t(e)}}Hh.className="ConvLSTM2D",ge(Hh);class Gh extends xl{constructor(t){super(t),this.rate=Math.max(Math.min(t.rate,1),0),this.noiseShape=t.noiseShape,this.seed=t.seed,this.supportsMasking=!0}getNoiseShape(t){if(null==this.noiseShape)return this.noiseShape;const e=t.shape,n=[];for(let t=0;t<this.noiseShape.length;++t)n.push(null==this.noiseShape[t]?e[t]:this.noiseShape[t]);return n}call(t,e){return be(()=>{this.invokeCallHook(t,e);const n=cl(t);if(0<this.rate&&this.rate<1){const t=null!=e.training&&e.training,s=this.getNoiseShape(n);return _o(()=>Mo(n,this.rate,s,this.seed),()=>n,t)}return t})}getConfig(){const t={rate:this.rate,noiseShape:this.noiseShape,seed:this.seed},e=super.getConfig();return Object.assign(t,e),t}dispose(){return super.dispose()}}Gh.className="Dropout",ge(Gh);class Jh extends Gh{constructor(t){super(t),this.inputSpec=[{ndim:3}]}getNoiseShape(t){const e=t.shape;return[e[0],1,e[2]]}}Jh.className="SpatialDropout1D",ge(Jh);class Zh extends xl{constructor(t){if(super(t),this.activation=null,this.useBias=!0,this.kernel=null,this.bias=null,this.DEFAULT_KERNEL_INITIALIZER="glorotNormal",this.DEFAULT_BIAS_INITIALIZER="zeros",null==t.batchInputShape&&null==t.inputShape&&null!=t.inputDim){let e=null;null!=t.batchSize&&(e=t.batchSize),this.batchInputShape=[e,t.inputDim]}this.units=t.units,Wa(this.units,"units"),this.activation=nh(t.activation),null!=t.useBias&&(this.useBias=t.useBias),this.kernelInitializer=rl(t.kernelInitializer||this.DEFAULT_KERNEL_INITIALIZER),this.biasInitializer=rl(t.biasInitializer||this.DEFAULT_BIAS_INITIALIZER),this.kernelConstraint=Qa(t.kernelConstraint),this.biasConstraint=Qa(t.biasConstraint),this.kernelRegularizer=lh(t.kernelRegularizer),this.biasRegularizer=lh(t.biasRegularizer),this.activityRegularizer=lh(t.activityRegularizer),this.supportsMasking=!0,this.inputSpec=[{minNDim:2}]}build(t){const e=(t=pl(t))[t.length-1];null==this.kernel&&(this.kernel=this.addWeight("kernel",[e,this.units],null,this.kernelInitializer,this.kernelRegularizer,!0,this.kernelConstraint),this.useBias&&(this.bias=this.addWeight("bias",[this.units],null,this.biasInitializer,this.biasRegularizer,!0,this.biasConstraint))),this.inputSpec=[{minNDim:2,axes:{[-1]:e}}],this.built=!0}computeOutputShape(t){const e=(t=pl(t)).slice();return e[e.length-1]=this.units,e}call(t,e){return be(()=>{this.invokeCallHook(t,e);const n=cl(t),s=ja(this.activation.getClassName());let r;return null!=s?r=zo(n,this.kernel.read(),s,this.bias?this.bias.read():null):(r=zo(n,this.kernel.read()),null!=this.bias&&(r=Lo(r,this.bias.read())),null!=this.activation&&(r=this.activation.apply(r))),r})}getConfig(){const t={units:this.units,activation:th(this.activation),useBias:this.useBias,kernelInitializer:sl(this.kernelInitializer),biasInitializer:sl(this.biasInitializer),kernelRegularizer:ah(this.kernelRegularizer),biasRegularizer:ah(this.biasRegularizer),activityRegularizer:ah(this.activityRegularizer),kernelConstraint:Xa(this.kernelConstraint),biasConstraint:Xa(this.biasConstraint)},e=super.getConfig();return Object.assign(t,e),t}}Zh.className="Dense",ge(Zh);class Xh extends xl{constructor(t){super(t=t||{}),this.inputSpec=[{minNDim:3}],this.dataFormat=t.dataFormat}computeOutputShape(t){t=pl(t);for(const e of t.slice(1))if(null==e)throw new Ia(`The shape of the input to "Flatten" is not fully defined (got ${t.slice(1)}). Make sure to pass a complete "input_shape" or "batch_input_shape" argument to the first layer in your model.`);return[t[0],go(t,1)]}call(t,e){return be(()=>{this.invokeCallHook(t,e);let n=cl(t);if("channelsFirst"===this.dataFormat&&n.rank>1){const t=[0];for(let e=2;e<n.rank;++e)t.push(e);t.push(1),n=n.transpose(t)}return function(t){if(t.rank<=1)throw new Ia(`batchFlatten requires a minimum rank of 2. Got rank: ${t.rank}.`);const e=[t.shape[0],go(t.shape,1)];return t.reshape(e)}(n)})}getConfig(){const t={};null!=this.dataFormat&&(t.dataFormat=this.dataFormat);const e=super.getConfig();return Object.assign(t,e),t}}Xh.className="Flatten",ge(Xh);class Yh extends xl{constructor(t){super(t),this.supportsMasking=!0,this.activation=nh(t.activation)}call(t,e){return be(()=>{this.invokeCallHook(t,e);const n=cl(t);return this.activation.apply(n)})}getConfig(){const t={activation:th(this.activation)},e=super.getConfig();return Object.assign(t,e),t}}Yh.className="Activation",ge(Yh);class Qh extends xl{constructor(t){super(t),this.n=t.n,this.inputSpec=[{ndim:2}]}computeOutputShape(t){return[t[0],this.n,t[1]]}call(t,e){return be(()=>{return t=cl(t),e=t,n=this.n,be(()=>{if(2!==e.shape.length)throw new Ia(`repeat() expects a rank-2 tensor, but received a rank-${e.shape.length} tensor.`);return To(xo(e,1),[1,n,1])});var e,n})}getConfig(){const t={n:this.n},e=super.getConfig();return Object.assign(t,e),t}}Qh.className="RepeatVector",ge(Qh);class tc extends xl{constructor(t){super(t),this.targetShape=t.targetShape;for(let t=0;t<this.targetShape.length;++t)this.isUnknown(this.targetShape[t])&&(this.targetShape[t]=null)}isUnknown(t){return t<0||null==t}fixUnknownDimension(t,e){const n="Total size of new array must be unchanged.",s=e.slice();let r=1,i=null;for(let t=0;t<s.length;++t){const e=s[t];if(this.isUnknown(e)){if(null!==i)throw new Ia("Can only specifiy one unknown dimension.");i=t}else r*=e}const a=go(t);if(null!==i){if(0===r||a%r!=0)throw new Ia(n);s[i]=a/r}else if(a!==r)throw new Ia(n);return s}computeOutputShape(t){let e=!1;for(let n=0;n<t.length;++n)if(this.isUnknown(t[n])){e=!0;break}return e?t.slice(0,1).concat(this.targetShape):t.slice(0,1).concat(this.fixUnknownDimension(t.slice(1),this.targetShape))}call(t,e){return be(()=>{this.invokeCallHook(t,e);const n=cl(t),s=n.shape,r=s.slice(0,1).concat(this.fixUnknownDimension(s.slice(1),this.targetShape));return n.reshape(r)})}getConfig(){const t={targetShape:this.targetShape},e=super.getConfig();return Object.assign(t,e),t}}tc.className="Reshape",ge(tc);class ec extends xl{constructor(t){if(super(t),null==t.dims)throw new Error("Required configuration field `dims` is missing during Permute constructor call.");if(!Array.isArray(t.dims))throw new Error("Permute constructor requires `dims` to be an Array, but received "+t.dims+" instead.");const e=vo(1,t.dims.length+1);if(!u(t.dims.slice().sort(),e))throw new Error("Invalid permutation `dims`: "+JSON.stringify(t.dims)+" `dims` must contain consecutive integers starting from 1.");this.dims=t.dims,this.dimsIncludingBatch=[0].concat(this.dims),this.inputSpec=[new yl({ndim:this.dims.length+1})]}computeOutputShape(t){const e=(t=pl(t)).slice();return this.dims.forEach((n,s)=>{e[s+1]=t[n]}),e}call(t,e){return pe(cl(t),this.dimsIncludingBatch)}getConfig(){const t={dims:this.dims},e=super.getConfig();return Object.assign(t,e),t}}ec.className="Permute",ge(ec);class nc extends xl{constructor(t){super(null==t?{}:t),this.supportsMasking=!0,this.maskValue=null!=t?null==t.maskValue?0:t.maskValue:0}computeOutputShape(t){return t}getConfig(){const t=super.getConfig(),e={maskValue:this.maskValue};return Object.assign(e,t),e}computeMask(t,e){const n=cl(t);return ze(xs(n,this.maskValue),-1)}call(t,e){return be(()=>{this.invokeCallHook(t,e);const n=cl(t),s=ze(xs(n,this.maskValue),-1,!0);return n.mul(s.asType(n.dtype))})}}nc.className="Masking",ge(nc);class sc extends xl{constructor(t){if(super(t),this.embeddings=null,this.DEFAULT_EMBEDDINGS_INITIALIZER="randomUniform",null==t.batchInputShape&&null==t.inputShape){let e=null;null!=t.batchSize&&(e=t.batchSize),null==t.inputLength?this.batchInputShape=[e,null]:this.batchInputShape=[e].concat(Ca(t.inputLength))}this.inputDim=t.inputDim,Wa(this.inputDim,"inputDim"),this.outputDim=t.outputDim,Wa(this.outputDim,"outputDim"),this.embeddingsInitializer=rl(t.embeddingsInitializer||this.DEFAULT_EMBEDDINGS_INITIALIZER),this.embeddingsRegularizer=lh(t.embeddingsRegularizer),this.activityRegularizer=lh(t.activityRegularizer),this.embeddingsConstraint=Qa(t.embeddingsConstraint),this.maskZero=t.maskZero,this.supportsMasking=t.maskZero,this.inputLength=t.inputLength}build(t){this.embeddings=this.addWeight("embeddings",[this.inputDim,this.outputDim],this.dtype,this.embeddingsInitializer,this.embeddingsRegularizer,!0,this.embeddingsConstraint),this.built=!0}warnOnIncompatibleInputShape(t){}computeMask(t,e){return be(()=>this.maskZero?(t=cl(t),xs(t,En(t))):null)}computeOutputShape(t){if(t=pl(t),null==this.inputLength)return[...t,this.outputDim];const e=Ca(this.inputLength);if(e.length!==t.length-1)throw new Ia(`"inputLength" is ${this.inputLength}, but received input shape has shape `+t);{let n=0;for(let s=0;s<e.length;++s){const r=e[s],i=t[s+1];if(null!=r&&null!=i&&r!==i)throw new Ia(`"inputLength" is ${this.inputLength}, but received input shape has shape `+t);null==r&&(e[n]=i),n++}}return[t[0],...e,this.outputDim]}call(t,e){return be(()=>{this.invokeCallHook(t,e);let n=cl(t);"int32"!==n.dtype&&(n=ko(n,"int32"));return Co(this.embeddings.read(),n.as1D()).reshape(pl(this.computeOutputShape(n.shape)))})}getConfig(){const t={inputDim:this.inputDim,outputDim:this.outputDim,embeddingsInitializer:sl(this.embeddingsInitializer),embeddingsRegularizer:ah(this.embeddingsRegularizer),activityRegularizer:ah(this.activityRegularizer),embeddingsConstraint:Xa(this.embeddingsConstraint),maskZero:this.maskZero,inputLength:this.inputLength},e=super.getConfig();return Object.assign(t,e),t}}sc.className="Embedding",ge(sc);class rc extends xl{constructor(t){super(t||{}),this.supportsMasking=!0}mergeFunction(t){throw new Na}computeElementwiseOpOutputShape(t,e){if(null==t||null==e)return null;if(t.length<e.length)return this.computeElementwiseOpOutputShape(e,t);if(0===e.length)return t;const n=t.slice(0,t.length-e.length);for(let s=0;s<e.length;++s){const r=t[t.length-e.length+s],i=e[s];if(null==r||null==i||r<0||i<0)n.push(null);else if(1===r)n.push(i);else if(1===i)n.push(r);else{if(r!==i)throw new Ia("Operands could not be broadcast together with shapes "+JSON.stringify(t)+" "+JSON.stringify(e));n.push(r)}}return n}build(t){if(Array.isArray(t)&&!Array.isArray(t[0])&&(t=[pl(t)]),(t=t).length<2)throw new Ia(`A merge layer should be called on an Array of at least 2 inputs. Got ${t.length} input(s).`);let e=[];for(const n of t)null!=n&&null!==n[0]&&e.push(n[0]);if(e=Oa(e),e.length>1)throw new Ia(`Can not merge tensors with different batch sizes. Got tensors with shapes: ${JSON.stringify(t)}.`);let n=null==t[0]?null:t[0].slice(1);for(let e=1;e<t.length;++e){const s=null==t[e]?null:t[e].slice(1);n=this.computeElementwiseOpOutputShape(n,s)}const s=t.map(t=>t.length);-1===t.indexOf(null)&&1===Oa(s).length?this.reshapeRequired=!1:this.reshapeRequired=!0}call(t,e){return be(()=>{if(t=t,this.reshapeRequired){const e=[],n=t.map(t=>t.rank);if(-1===n.indexOf(null)){const s=wo(n);for(let n of t){const t=n.rank;for(let e=0;e<s-t;++e)n=xo(n,1);e.push(n)}return this.mergeFunction(e)}{let n=!1;for(const s of t){const t=s.rank;if(null==t){const t=s.shape,r=t[0],i=t.slice(1).concat([r]);let a=s.reshape([r].concat(go(t.slice(1))));a=pe(a,[1,0]),a=a.reshape(i),e.push(a),n=!0}else if(t>1){const r=vo(1,t).concat([0]);e.push(pe(s,r)),n=!0}else e.push(s)}let s=this.mergeFunction(e);const r=s.rank;if(n)if(null==r){const t=s.shape,e=t[t.length-1],n=[e].concat(t.slice(0,t.length-1));s=pe(s.reshape([-1,e]),[1,0]).reshape(n)}else if(r>1){const t=[r-1].concat(vo(0,r-1));s=pe(s,t)}return s}}return this.mergeFunction(t)})}computeOutputShape(t){let e;e=null==(t=t)[0]?null:t[0].slice(1);for(let n=1;n<t.length;++n){const s=null==t[n]?null:t[n].slice(1);e=this.computeElementwiseOpOutputShape(e,s)}let n=[];for(const e of t)null!=e&&null!==e[0]&&n.push(e[0]);return n=Oa(n),e=1===n.length?n.concat(e):[null].concat(e),e}computeMask(t,e){return be(()=>{if(null==e)return null;if(!Array.isArray(e))throw new Ia("`mask` should be an Array");if(!Array.isArray(t))throw new Ia("`inputs` should be an Array");if(e.length!==t.length)throw new Ia(`The Array 'inputs' and 'mask' are expected to have the same length, but have different lengths (${t.length} vs ${e.length})`);if(e.every(t=>null==t))return null;let n=(e=e.map(t=>null==t?t:Fn(t,0)))[0];for(let t=1;t<e.length-1;++t)n=ls(n,e[t]);return n})}}class ic extends rc{constructor(t){super(t)}mergeFunction(t){return be(()=>{let e=t[0].clone();for(let n=1;n<t.length;++n)e=xe(e,t[n]);return e})}}ic.className="Add",ge(ic);class ac extends rc{constructor(t){super(t)}mergeFunction(t){return be(()=>{let e=t[0].clone();for(let n=1;n<t.length;++n)e=Ne(e,t[n]);return e})}}ac.className="Multiply",ge(ac);class oc extends rc{constructor(t){super(t)}mergeFunction(t){return be(()=>{let e=t[0].clone();for(let n=1;n<t.length;++n)e=xe(e,t[n]);return Ne(1/t.length,e)})}}oc.className="Average",ge(oc);class lc extends rc{constructor(t){super(t)}mergeFunction(t){return be(()=>{let e=t[0];for(let n=1;n<t.length;++n)e=fs(e,t[n]);return e})}}lc.className="Maximum",ge(lc);class uc extends rc{constructor(t){super(t)}mergeFunction(t){return be(()=>{let e=t[0];for(let n=1;n<t.length;++n)e=ys(e,t[n]);return e})}}uc.className="Minimum",ge(uc);class hc extends rc{constructor(t){super(t),this.DEFAULT_AXIS=-1,null==t&&(t={}),this.axis=null==t.axis?this.DEFAULT_AXIS:t.axis,this.supportsMasking=!0,this.reshapeRequired=!1}build(t){if(!Array.isArray(t)||!Array.isArray(t[0])||1===t.length)throw new Ia("A `Concatenate` layer should be called on a list of at least 2 inputs");t=t;let e=!0;for(const n of t)if(null!=n){e=!1;break}if(e)return;const n=[];for(let e=0;e<t.length;++e){const s=t[e].slice();s.splice(this.axis,1);let r=!1;for(const t of n)if(u(t,s)){r=!0;break}r||n.push(s)}if(n.length>1)throw new Ia("A `Concatenate` layer requires inputs with matching shapes except for the concat axis. Got input shapes: "+JSON.stringify(t))}mergeFunction(t){return be(()=>Eo(t,this.axis))}computeOutputShape(t){if(!Array.isArray(t)||!Array.isArray(t[0]))throw new Ia("A `Concatenate` layer should be called on a list of inputs.");const e=t,n=e[0].slice(),s=this.axis<0?n.length+this.axis:this.axis;for(const t of e.slice(1)){if(null==n[s]||null==t[s]){n[s]=null;break}n[s]+=t[s]}return n}computeMask(t,e){if(null==e)return null;if(!Array.isArray(e))throw new Ia("`mask` should be an array for Concatenate");if(!Array.isArray(t))throw new Ia("`inputs` should be an array for Concatenate");if(e.length!==t.length)throw new Ia(`Mismatch in the length of mask (${e.length}) and the legnth of inputs (${t.length})`);return be(()=>{let n=!0;if(e.forEach(t=>{null==t||(n=!1)}),n)return null;const s=[];for(let n=0;n<t.length;++n)null==e[n]?s.push(Ns(t[n]).asType("bool")):e[n].rank<t[n].rank?s.push(Fn(e[n],-1)):s.push(e[n]);const r=He(s,this.axis);return De(r,-1,!1)})}getConfig(){const t={axis:this.axis},e=super.getConfig();return Object.assign(t,e),t}}function cc(t,e){for(;t<0;)t+=e;return t}hc.className="Concatenate",ge(hc);class pc extends rc{constructor(t){super(t),this.axes=t.axes,this.normalize=null!=t.normalize&&t.normalize,this.supportsMasking=!0,this.reshapeRequired=!1}build(t){r(Array.isArray(t)&&2===t.length&&Array.isArray(t[0])&&Array.isArray(t[1]),()=>"A `Dot` layer should be called on a list of exactly 2 inputs.");const e=t[0],n=t[1];if(e.length>3||n.length>3)throw new Na("Dot layer does not support tensors of 4D or higher rank yet.");const s=this.interpretAxes(e,n);if(e[s[0]]!==n[s[1]])throw new Ia(`Dimension incompatibility: ${e[s[0]]} !== ${n[s[1]]}`)}mergeFunction(t){if(2!==t.length)throw new Ia(`A \`Dot\` layer must be called on exactly 2 inputs, but received ${t.length} input(s).`);let e,n=t[0],s=t[1];return e=Array.isArray(this.axes)?this.axes.map((e,n)=>cc(e,t[n].shape.length)):[cc(this.axes,n.shape.length),cc(this.axes,s.shape.length)],this.normalize&&(n=_l(n,e[0]),s=_l(s,e[1])),function(t,e,n){if(t.shape.length>3||e.shape.length>3)throw new Na("batchDot is not implemented for tensors of 4D or higher rank yet");if(r(t.shape.length>=2,()=>"batchDot requires the rank of x to be >= 2, but got "+t.shape.length),r(t.shape.length>=2,()=>"batchDot requires the rank of y to be >= 2, but got "+e.shape.length),"number"==typeof n&&(n=[n,n]),"complex64"===t.dtype||"complex64"===e.dtype)throw new Na("batchDot is not implemented for complex64-type Tensors yet.");const s=t.shape.length,i=e.shape.length;null==n&&(n=[s-1,i-2]);const a=n;return be(()=>{let n,r;if(s>i){n=s-i;const t=[];for(let e=0;e<n;++e)t.push(1);e=e.reshape(e.shape.concat(t))}else if(i>s){n=i-s;const e=[];for(let t=0;t<n;++t)e.push(1);t=t.reshape(t.shape.concat(e))}else n=0;if(2===t.shape.length&&2===e.shape.length)r=a[0]===a[1]?t.mul(e).sum(a[0]):t.transpose([1,0]).mul(e).sum(a[1]);else{const n=a[0]!==t.shape.length-1,s=a[1]===e.shape.length-1;r=t.matMul(e,n,s)}if(n>0){let t;t=s>i?s+i-3:s-1;const e=[];for(let s=t;s<t+n;++s)e.push(s);r=r.squeeze(e)}return 1===r.shape.length&&(r=r.expandDims(1)),r})}(n,s,e)}interpretAxes(t,e){let n;return n=Array.isArray(this.axes)?this.axes:[cc(this.axes,t.length),cc(this.axes,e.length)],n}computeOutputShape(t){r(Array.isArray(t)&&2===t.length&&Array.isArray(t[0])&&Array.isArray(t[1]),()=>"A `Dot` layer should be called on a list of exactly 2 inputs.");const e=t[0].slice(),n=t[1].slice();if(e.length>3||n.length>3)throw new Na("Dot layer does not support tensors of 4D or higher rank yet.");const s=this.interpretAxes(e,n);e.splice(s[0],1),n.splice(s[1],1),n.splice(0,1);const i=e.concat(n);return 1===i.length&&i.push(1),i}computeMask(t,e){return null}getConfig(){const t={axes:this.axes,normalize:this.normalize},e=super.getConfig();return Object.assign(t,e),t}}pc.className="Dot",ge(pc);class dc extends xl{constructor(t){super(t),this.supportsMasking=!0,this.stddev=t.stddev}computeOutputShape(t){return t}getConfig(){const t=super.getConfig(),e={stddev:this.stddev};return Object.assign(e,t),e}call(t,e){return be(()=>{this.invokeCallHook(t,e);const n=cl(t);return _o(()=>Do(n.shape,0,this.stddev).add(n),()=>n,e.training||!1)})}}dc.className="GaussianNoise",ge(dc);class fc extends xl{constructor(t){super(t),this.supportsMasking=!0,this.rate=t.rate}computeOutputShape(t){return t}getConfig(){const t=super.getConfig(),e={rate:this.rate};return Object.assign(e,t),e}call(t,e){return be(()=>{this.invokeCallHook(t,e);const n=cl(t);if(this.rate>0&&this.rate<1){return _o(()=>{const t=Math.sqrt(this.rate/(1-this.rate));return n.mul(Do(n.shape,1,t))},()=>n,e.training||!1)}return n})}}fc.className="GaussianDropout",ge(fc);class mc extends xl{constructor(t){super(t),this.supportsMasking=!0,this.rate=t.rate,this.noiseShape=t.noiseShape}_getNoiseShape(t){return this.noiseShape||cl(t).shape}computeOutputShape(t){return t}getConfig(){const t=super.getConfig(),e={rate:this.rate};return Object.assign(e,t),e}call(t,e){return be(()=>{if(this.rate<1&&this.rate>0){const n=this._getNoiseShape(t);return _o(()=>{const e=cl(t),s=-1.7580993408473766;let r=Pn(qs(n),this.rate);r=ko(r,"float32");const i=((1-this.rate)*(1+this.rate*s**2))**-.5,a=-i*s*this.rate;return e.mul(r).add(r.add(-1).mul(s)).mul(i).add(a)},()=>cl(t),e.training||!1)}return t})}}function gc(t,e,n,s,r,i=.001){let a;if(2===t.rank)a=Qe(t,e,n,s,r,i);else if(3===t.rank)a=tn(t,e,n,s,r,i);else{if(4!==t.rank)throw new Na(`batchNormalization is not implemented for array of rank ${t.rank} yet`);a=en(t,e,n,s,r,i)}return a}function yc(t,e,n,s,r=.001){return u(s.slice().sort(),vo(0,t.rank-1))?function(t,e,n,s,r=.001){return be(()=>{const i=ks(t,s),a=i.mean,o=i.variance;return[gc(t,a,o,n,e,r),a,o]})}(t,e,n,s,r):function(t,e,n,s,r=.001){return be(()=>{const i=ks(t,s),a=i.mean,o=i.variance,l=[];for(const e of vo(0,t.rank))-1!==s.indexOf(e)?l.push(1):l.push(t.shape[e]);const u=a.reshape(l),h=o.reshape(l),c=null==e?null:e.reshape(l),p=null==n?null:n.reshape(l);return[gc(t,u,h,p,c,r),a,o]})}(t,e,n,s,r)}mc.className="AlphaDropout",ge(mc);class bc extends xl{constructor(t){null==t&&(t={}),super(t),this.supportsMasking=!0,this.axis=null==t.axis?-1:t.axis,this.momentum=null==t.momentum?.99:t.momentum,this.epsilon=null==t.epsilon?.001:t.epsilon,this.center=null==t.center||t.center,this.scale=null==t.scale||t.scale,this.betaInitializer=rl(t.betaInitializer||"zeros"),this.gammaInitializer=rl(t.gammaInitializer||"ones"),this.movingMeanInitializer=rl(t.movingMeanInitializer||"zeros"),this.movingVarianceInitializer=rl(t.movingVarianceInitializer||"ones"),this.betaConstraint=Qa(t.betaConstraint),this.gammaConstraint=Qa(t.gammaConstraint),this.betaRegularizer=lh(t.betaRegularizer),this.gammaRegularizer=lh(t.gammaRegularizer)}build(t){t=pl(t);const e=this.axis>=0?this.axis:this.axis+t.length,n=t[e];if(null==n)throw new Ia(`Axis ${e} of input tensor should have a defined dimension but the layer received an input with shape `+JSON.stringify(t)+".");this.inputSpec=[new yl({ndim:t.length,axes:{[e]:n}})];const s=[n];this.scale&&(this.gamma=this.addWeight("gamma",s,null,this.gammaInitializer,this.gammaRegularizer,!0,this.gammaConstraint)),this.center&&(this.beta=this.addWeight("beta",s,null,this.betaInitializer,this.betaRegularizer,!0,this.betaConstraint)),this.movingMean=this.addWeight("moving_mean",s,null,this.movingMeanInitializer,null,!1),this.movingVariance=this.addWeight("moving_variance",s,null,this.movingVarianceInitializer,null,!1),this.built=!0}call(t,e){return be(()=>{const n=null!=e.training&&e.training,s=cl(t),r=s.shape,i=r.length,a=vo(0,i),o=this.axis>=0?this.axis:this.axis+i;a.splice(o,1);const l=Aa(1,i);l[o]=r[o];const h=a.slice();h.sort();const c=!u(h,vo(0,i).slice(0,i-1));if(!n)return(()=>{if(c){const t=this.movingMean.read().reshape(l),e=this.movingVariance.read().reshape(l),n=this.center?this.beta.read().reshape(l):null,r=this.scale?this.gamma.read().reshape(l):null;return gc(s,t,e,n,r,this.epsilon)}return gc(s,this.movingMean.read(),this.movingVariance.read(),null==this.beta?null:this.beta.read(),null==this.gamma?null:this.gamma.read(),this.epsilon)})();const[p,d,f]=yc(s,this.gamma.read(),this.beta.read(),a,this.epsilon),m=(t,e,n)=>{be(()=>{const s=1-n,r=t.read(),i=r.sub(e).mul(s);t.write(r.sub(i))})};return(()=>{m(this.movingMean,d,this.momentum),m(this.movingVariance,f,this.momentum)})(),p})}getConfig(){const t={axis:this.axis,momentum:this.momentum,epsilon:this.epsilon,center:this.center,scale:this.scale,betaInitializer:sl(this.betaInitializer),gammaInitializer:sl(this.gammaInitializer),movingMeanInitializer:sl(this.movingMeanInitializer),movingVarianceInitializer:sl(this.movingVarianceInitializer),betaRegularizer:ah(this.betaRegularizer),gammaRegularizer:ah(this.gammaRegularizer),betaConstraint:Xa(this.betaConstraint),gammaConstraint:Xa(this.gammaConstraint)},e=super.getConfig();return Object.assign(t,e),t}}bc.className="BatchNormalization",ge(bc);class wc extends xl{constructor(t){if(null==t&&(t={}),super(t),this.axis=null==t.axis?-1:t.axis,"number"==typeof this.axis){if(!Number.isInteger(this.axis))throw new Error("Expected axis to be an integer, but received "+this.axis)}else{if(!Array.isArray(this.axis))throw new Error("Expected axis to be an integer or an array of integers, but received "+JSON.stringify(this.axis));for(const t of this.axis)if(!Number.isInteger(t))throw new Error("Expected axis to be an array of integers, but received "+JSON.stringify(this.axis))}this.epsilon=null==t.epsilon?.001:t.epsilon,this.center=null==t.center||t.center,this.scale=null==t.scale||t.scale,this.betaInitializer=rl(t.betaInitializer||"zeros"),this.gammaInitializer=rl(t.gammaInitializer||"ones"),this.betaRegularizer=lh(t.betaRegularizer),this.gammaRegularizer=lh(t.gammaRegularizer),this.supportsMasking=!0}build(t){const e=(t=pl(t)).length;"number"==typeof this.axis&&(this.axis=[this.axis]);for(let t=0;t<this.axis.length;++t)this.axis[t]<0&&(this.axis[t]+=e);for(const t of this.axis)if(t<0||t>=e)throw new Error("Invalid axis: "+t);if(this.axis.length!==Oa(this.axis).length)throw new Error("Found duplicate axes in: "+this.axis);const n=this.axis.map(e=>t[e]);this.scale?this.gamma=this.addWeight("gamma",n,"float32",this.gammaInitializer,this.gammaRegularizer,!0):this.gamma=null,this.center?this.beta=this.addWeight("beta",n,"float32",this.betaInitializer,this.betaRegularizer,!0):this.beta=null,this.built=!0}call(t,e){const n=cl(t),s=n.shape,r=s.length;return be(()=>{let{mean:t,variance:e}=ks(n,this.axis,!0);const i=Aa(1,r);for(const t of this.axis)i[t]=s[t];const a=t=>null!=t&&t.shape.length!==r&&this.axis!==[r-1]?t.reshape(i):t;let o=a(this.gamma.read()),l=a(this.beta.read());const u=[],h=[];for(let t=0;t<r;++t)-1!==this.axis.indexOf(t)?(u.push(s[t]),h.push(1)):(u.push(1),h.push(s[t]));return t=t.tile(u),e=e.tile(u),o=o.tile(h),l=l.tile(h),gc(n,t,e,l,o,this.epsilon)})}getConfig(){const t={axis:this.axis,epsilon:this.epsilon,center:this.center,scale:this.scale,betaInitializer:sl(this.betaInitializer),gammaInitializer:sl(this.gammaInitializer),betaRegularizer:ah(this.betaRegularizer),gammaRegularizer:ah(this.gammaRegularizer)},e=super.getConfig();return Object.assign(t,e),t}}wc.className="LayerNormalization",ge(wc);class vc extends xl{constructor(t){if(null==t&&(t={}),super(t),this.dataFormat=null==t.dataFormat?"channelsLast":t.dataFormat,null==t.padding)this.padding=[[1,1],[1,1]];else if("number"==typeof t.padding)this.padding=[[t.padding,t.padding],[t.padding,t.padding]];else{if(t.padding=t.padding,2!==t.padding.length)throw new Ia(`ZeroPadding2D expects padding to be a length-2 array, but received a length-${t.padding.length} array.`);let e,n;if("number"==typeof t.padding[0])e=[t.padding[0],t.padding[0]],n=[t.padding[1],t.padding[1]];else{if(t.padding=t.padding,2!==t.padding[0].length)throw new Ia(`ZeroPadding2D expects height padding to be a length-2 array, but received a length-${t.padding[0].length} array.`);if(e=t.padding[0],2!==t.padding[1].length)throw new Ia(`ZeroPadding2D expects width padding to be a length-2 array, but received a length-${t.padding[1].length} array.`);n=t.padding[1]}this.padding=[e,n]}this.inputSpec=[new yl({ndim:4})]}computeOutputShape(t){let e,n;return t=pl(t),"channelsFirst"===this.dataFormat?(e=null!=t[2]&&t[2]>=0?t[2]+this.padding[0][0]+this.padding[0][1]:null,n=null!=t[3]&&t[3]>=0?t[3]+this.padding[1][0]+this.padding[1][1]:null,[t[0],t[1],e,n]):(e=null!=t[1]&&t[1]>=0?t[1]+this.padding[0][0]+this.padding[0][1]:null,n=null!=t[2]&&t[2]>=0?t[2]+this.padding[1][0]+this.padding[1][1]:null,[t[0],e,n,t[3]])}call(t,e){return be(()=>{return e=cl(t),n=this.padding,s=this.dataFormat,be(()=>{if(4!==e.rank)throw new Ia("temporalPadding expects input tensor to be 4-D, but received a "+e.rank+"-D tensor.");if(null==n&&(n=[[1,1],[1,1]]),2!==n.length||2!==n[0].length||2!==n[1].length)throw new Ia("spatial2dPadding expects `padding` to be an Array of two Arrays, each of which is an Array of two integers.");if(null==s&&(s="channelsLast"),"channelsLast"!==s&&"channelsFirst"!==s)throw new Ia(`Unknown data format: ${s}. Supported data formats are 'channelsLast' and 'channelsFirst.`);let t;return t="channelsFirst"===s?[[0,0],[0,0],n[0],n[1]]:[[0,0],n[0],n[1],[0,0]],Es(e,t)});var e,n,s})}getConfig(){const t={padding:this.padding,dataFormat:this.dataFormat},e=super.getConfig();return Object.assign(t,e),t}}function kc(t,e,n,s,r,i){return be(()=>{let a;ao(r),lo(i),oo(s),null==n&&(n=[1,1]),null==s&&(s="valid"),null==r&&(r="channelsLast"),null==i&&(i="max"),t=bh(t,r);const o="same"===s?"same":"valid";return a="max"===i?ps(t,e,n,o):Ke(t,e,n,o),"channelsFirst"===r&&(a=pe(a,[0,3,1,2])),a})}function xc(t,e,n,s,r,i){return be(()=>{let a;ao(r),lo(i),oo(s),null==n&&(n=[1,1,1]),null==s&&(s="valid"),null==r&&(r="channelsLast"),null==i&&(i="max"),t=wh(t,r);const o="same"===s?"same":"valid";return a="max"===i?ds(t,e,n,o):Ve(t,e,n,o),"channelsFirst"===r&&(a=pe(a,[0,4,1,2,3])),a})}vc.className="ZeroPadding2D",ge(vc);class Sc extends xl{constructor(t){if(null==t.poolSize&&(t.poolSize=2),super(t),"number"==typeof t.poolSize)this.poolSize=[t.poolSize];else{if(!Array.isArray(t.poolSize)||1!==t.poolSize.length||"number"!=typeof t.poolSize[0])throw new Ia("poolSize for 1D convolutional layer must be a number or an Array of a single number, but received "+JSON.stringify(t.poolSize));this.poolSize=t.poolSize}if(Wa(this.poolSize,"poolSize"),null==t.strides)this.strides=this.poolSize;else if("number"==typeof t.strides)this.strides=[t.strides];else{if(!Array.isArray(t.strides)||1!==t.strides.length||"number"!=typeof t.strides[0])throw new Ia("strides for 1D convolutional layer must be a number or an Array of a single number, but received "+JSON.stringify(t.strides));this.strides=t.strides}Wa(this.strides,"strides"),this.padding=null==t.padding?"valid":t.padding,oo(this.padding),this.inputSpec=[new yl({ndim:3})]}computeOutputShape(t){const e=gh((t=pl(t))[1],this.poolSize[0],this.padding,this.strides[0]);return[t[0],e,t[2]]}call(t,e){return be(()=>{this.invokeCallHook(t,e),t=xo(cl(t),2);const n=this.poolingFunction(cl(t),[this.poolSize[0],1],[this.strides[0],1],this.padding,"channelsLast");return yr(n,[2])})}getConfig(){const t={poolSize:this.poolSize,padding:this.padding,strides:this.strides},e=super.getConfig();return Object.assign(t,e),t}}class Ic extends Sc{constructor(t){super(t)}poolingFunction(t,e,n,s,r){return ao(r),oo(s),kc(t,e,n,s,r,"max")}}Ic.className="MaxPooling1D",ge(Ic);class Nc extends Sc{constructor(t){super(t)}poolingFunction(t,e,n,s,r){return ao(r),oo(s),kc(t,e,n,s,r,"avg")}}Nc.className="AveragePooling1D",ge(Nc);class Ec extends xl{constructor(t){if(null==t.poolSize&&(t.poolSize=[2,2]),super(t),this.poolSize=Array.isArray(t.poolSize)?t.poolSize:[t.poolSize,t.poolSize],null==t.strides)this.strides=this.poolSize;else if(Array.isArray(t.strides)){if(2!==t.strides.length)throw new Ia("If the strides property of a 2D pooling layer is an Array, it is expected to have a length of 2, but received length "+t.strides.length+".");this.strides=t.strides}else this.strides=[t.strides,t.strides];Wa(this.poolSize,"poolSize"),Wa(this.strides,"strides"),this.padding=null==t.padding?"valid":t.padding,this.dataFormat=null==t.dataFormat?"channelsLast":t.dataFormat,ao(this.dataFormat),oo(this.padding),this.inputSpec=[new yl({ndim:4})]}computeOutputShape(t){t=pl(t);let e="channelsFirst"===this.dataFormat?t[2]:t[1],n="channelsFirst"===this.dataFormat?t[3]:t[2];return e=gh(e,this.poolSize[0],this.padding,this.strides[0]),n=gh(n,this.poolSize[1],this.padding,this.strides[1]),"channelsFirst"===this.dataFormat?[t[0],t[1],e,n]:[t[0],e,n,t[3]]}call(t,e){return be(()=>(this.invokeCallHook(t,e),this.poolingFunction(cl(t),this.poolSize,this.strides,this.padding,this.dataFormat)))}getConfig(){const t={poolSize:this.poolSize,padding:this.padding,strides:this.strides,dataFormat:this.dataFormat},e=super.getConfig();return Object.assign(t,e),t}}class Ac extends Ec{constructor(t){super(t)}poolingFunction(t,e,n,s,r){return ao(r),oo(s),kc(t,e,n,s,r,"max")}}Ac.className="MaxPooling2D",ge(Ac);class Tc extends Ec{constructor(t){super(t)}poolingFunction(t,e,n,s,r){return ao(r),oo(s),kc(t,e,n,s,r,"avg")}}Tc.className="AveragePooling2D",ge(Tc);class Dc extends xl{constructor(t){if(null==t.poolSize&&(t.poolSize=[2,2,2]),super(t),this.poolSize=Array.isArray(t.poolSize)?t.poolSize:[t.poolSize,t.poolSize,t.poolSize],null==t.strides)this.strides=this.poolSize;else if(Array.isArray(t.strides)){if(3!==t.strides.length)throw new Ia("If the strides property of a 3D pooling layer is an Array, it is expected to have a length of 3, but received length "+t.strides.length+".");this.strides=t.strides}else this.strides=[t.strides,t.strides,t.strides];Wa(this.poolSize,"poolSize"),Wa(this.strides,"strides"),this.padding=null==t.padding?"valid":t.padding,this.dataFormat=null==t.dataFormat?"channelsLast":t.dataFormat,ao(this.dataFormat),oo(this.padding),this.inputSpec=[new yl({ndim:5})]}computeOutputShape(t){t=pl(t);let e="channelsFirst"===this.dataFormat?t[2]:t[1],n="channelsFirst"===this.dataFormat?t[3]:t[2],s="channelsFirst"===this.dataFormat?t[4]:t[3];return e=gh(e,this.poolSize[0],this.padding,this.strides[0]),n=gh(n,this.poolSize[1],this.padding,this.strides[1]),s=gh(s,this.poolSize[2],this.padding,this.strides[2]),"channelsFirst"===this.dataFormat?[t[0],t[1],e,n,s]:[t[0],e,n,s,t[4]]}call(t,e){return be(()=>(this.invokeCallHook(t,e),this.poolingFunction(cl(t),this.poolSize,this.strides,this.padding,this.dataFormat)))}getConfig(){const t={poolSize:this.poolSize,padding:this.padding,strides:this.strides,dataFormat:this.dataFormat},e=super.getConfig();return Object.assign(t,e),t}}class zc extends Dc{constructor(t){super(t)}poolingFunction(t,e,n,s,r){return ao(r),oo(s),xc(t,e,n,s,r,"max")}}zc.className="MaxPooling3D",ge(zc);class Cc extends Dc{constructor(t){super(t)}poolingFunction(t,e,n,s,r){return ao(r),oo(s),xc(t,e,n,s,r,"avg")}}Cc.className="AveragePooling3D",ge(Cc);class Fc extends xl{constructor(t){super(t),this.inputSpec=[new yl({ndim:3})]}computeOutputShape(t){return[t[0],t[2]]}call(t,e){throw new Na}}class Rc extends Fc{constructor(t){super(t||{})}call(t,e){return be(()=>{const e=cl(t);return ms(e,1)})}}Rc.className="GlobalAveragePooling1D",ge(Rc);class Lc extends Fc{constructor(t){super(t||{})}call(t,e){return be(()=>{const e=cl(t);return es(e,1)})}}Lc.className="GlobalMaxPooling1D",ge(Lc);class Mc extends xl{constructor(t){super(t),this.dataFormat=null==t.dataFormat?"channelsLast":t.dataFormat,ao(this.dataFormat),this.inputSpec=[new yl({ndim:4})]}computeOutputShape(t){return t=t,"channelsLast"===this.dataFormat?[t[0],t[3]]:[t[0],t[1]]}call(t,e){throw new Na}getConfig(){const t={dataFormat:this.dataFormat},e=super.getConfig();return Object.assign(t,e),t}}class _c extends Mc{call(t,e){return be(()=>{const e=cl(t);return"channelsLast"===this.dataFormat?ms(e,[1,2]):ms(e,[2,3])})}}_c.className="GlobalAveragePooling2D",ge(_c);class $c extends Mc{call(t,e){return be(()=>{const e=cl(t);return"channelsLast"===this.dataFormat?es(e,[1,2]):es(e,[2,3])})}}$c.className="GlobalMaxPooling2D",ge($c);class Oc extends xl{constructor(t){super(t),this.layer=t.layer}build(t){this.built=!0}get trainable(){return null!=this.layer&&this.layer.trainable}set trainable(t){null!=this.layer&&(this.layer.trainable=t)}get trainableWeights(){return this.layer.trainableWeights}get nonTrainableWeights(){return this.layer.nonTrainableWeights}get updates(){return this.layer._updates}get losses(){return this.layer.losses}getWeights(){return this.layer.getWeights()}setWeights(t){this.layer.setWeights(t)}getConfig(){const t={layer:{className:this.layer.getClassName(),config:this.layer.getConfig()}},e=super.getConfig();return Object.assign(t,e),t}setFastWeightInitDuringBuild(t){super.setFastWeightInitDuringBuild(t),null!=this.layer&&this.layer.setFastWeightInitDuringBuild(t)}static fromConfig(t,e,n={}){const s=Ml(e.layer,n);delete e.layer;const r={layer:s};return Object.assign(r,e),new t(r)}}class Bc extends Oc{constructor(t){super(t),this.supportsMasking=!0}build(t){if((t=pl(t)).length<3)throw new Ia("TimeDistributed layer expects an input shape >= 3D, but received input shape "+JSON.stringify(t));this.inputSpec=[{shape:t}];const e=[t[0]].concat(t.slice(2));this.layer.built||(this.layer.build(e),this.layer.built=!0),super.build(t)}computeOutputShape(t){const e=[(t=pl(t))[0]].concat(t.slice(2)),n=this.layer.computeOutputShape(e),s=t[1];return[n[0],s].concat(n.slice(1))}call(t,e){return be(()=>Rh((t,n)=>[cl(this.layer.call(t,e)),[]],t=cl(t),[],!1,null,null,!1,!0)[1])}}Bc.className="TimeDistributed",ge(Bc);class Pc extends Oc{constructor(t){super(t);const e=t.layer.getConfig(),n={};n.className=t.layer.getClassName(),n.config=e,this.forwardLayer=Ml(n),e.goBackwards=!0!==e.goBackwards;const s={};var r;if(s.className=t.layer.getClassName(),s.config=e,this.backwardLayer=Ml(s),this.forwardLayer.name="forward_"+this.forwardLayer.name,this.backwardLayer.name="backward_"+this.backwardLayer.name,this.mergeMode=void 0===t.mergeMode?"concat":t.mergeMode,r=this.mergeMode,Pa(ro,"BidirectionalMergeMode",r),t.weights)throw new Na("weights support is not implemented for Bidirectional layer yet.");this._stateful=t.layer.stateful,this.returnSequences=t.layer.returnSequences,this.returnState=t.layer.returnState,this.supportsMasking=!0,this._trainable=!0,this.inputSpec=t.layer.inputSpec,this.numConstants=null}get trainable(){return this._trainable}set trainable(t){this._trainable=t,null!=this.forwardLayer&&(this.forwardLayer.trainable=t),null!=this.backwardLayer&&(this.backwardLayer.trainable=t)}getWeights(){return this.forwardLayer.getWeights().concat(this.backwardLayer.getWeights())}setWeights(t){const e=t.length,n=Math.floor(e/2);this.forwardLayer.setWeights(t.slice(0,n)),this.backwardLayer.setWeights(t.slice(n))}computeOutputShape(t){let e,n,s,r=this.forwardLayer.computeOutputShape(t);return Array.isArray(r)&&Array.isArray(r[0])||(r=[r]),r=r,this.returnState?(s=r.slice(1),e=r[0]):e=r[0],e=e,"concat"===this.mergeMode?(e[e.length-1]*=2,n=[e]):n=null==this.mergeMode?[e,e.slice()]:[e],this.returnState?null==this.mergeMode?n.concat(s).concat(s.slice()):[e].concat(s).concat(s.slice()):za(n)}apply(t,e){let n=null==e?null:e.initialState,s=null==e?null:e.constants;null==e&&(e={});const r=Fh(t,n,s,this.numConstants);if(t=r.inputs,n=r.initialState,s=r.constants,Array.isArray(t)&&(n=t.slice(1),t=t[0]),(null==n||0===n.length)&&null==s)return super.apply(t,e);const i=[],a=[];if(null!=n){const t=n.length;if(t%2>0)throw new Ia("When passing `initialState` to a Bidrectional RNN, the state should be an Array containing the states of the underlying RNNs.");e.initialState=n,i.push(...n);const s=n.map(t=>new yl({shape:t.shape}));this.forwardLayer.stateSpec=s.slice(0,t/2),this.backwardLayer.stateSpec=s.slice(t/2),a.push(...s)}if(null!=s)throw new Na("Support for constants in Bidirectional layers is not implemented yet.");const o=i[0]instanceof bl;for(const t of i)if(t instanceof bl!==o)throw new Ia("The initial state of a Bidirectional layer cannot be specified as a mix of symbolic and non-symbolic tensors");if(o){const n=[t].concat(i),s=this.inputSpec.concat(a),r=this.inputSpec;this.inputSpec=s;const o=super.apply(n,e);return this.inputSpec=r,o}return super.apply(t,e)}call(t,e){return be(()=>{const n=e.initialState;let s,r,i,a;if(null==n)s=this.forwardLayer.call(t,e),r=this.backwardLayer.call(t,e);else{const i=n.slice(0,n.length/2),a=n.slice(n.length/2);s=this.forwardLayer.call(t,Object.assign(e,{initialState:i})),r=this.backwardLayer.call(t,Object.assign(e,{initialState:a}))}return this.returnState&&(Array.isArray(s)&&(i=s.slice(1).concat(r.slice(1))),s=s[0],r=r[0]),this.returnSequences&&(r=Zs(r,1)),"concat"===this.mergeMode?a=Eo([s,r]):"sum"===this.mergeMode?a=xe(s,r):"ave"===this.mergeMode?a=Ne(.5,xe(s,r)):"mul"===this.mergeMode?a=Ne(s,r):null==this.mergeMode&&(a=[s,r]),this.returnState?null==this.mergeMode?a.concat(i):[a].concat(i):a})}resetStates(t){this.forwardLayer.resetStates(),this.backwardLayer.resetStates()}build(t){ho(this.forwardLayer.name,()=>{this.forwardLayer.build(t)}),ho(this.backwardLayer.name,()=>{this.backwardLayer.build(t)}),this.built=!0}computeMask(t,e){let n;if(Array.isArray(e)&&(e=e[0]),n=this.returnSequences?null==this.mergeMode?[e,e]:e:null==this.mergeMode?[null,null]:null,this.returnState){const t=this.forwardLayer.states.map(t=>null);return Array.isArray(n)?n.concat(t).concat(t):[n].concat(t).concat(t)}return n}get trainableWeights(){return this.forwardLayer.trainableWeights.concat(this.backwardLayer.trainableWeights)}get nonTrainableWeights(){return this.forwardLayer.nonTrainableWeights.concat(this.backwardLayer.nonTrainableWeights)}setFastWeightInitDuringBuild(t){super.setFastWeightInitDuringBuild(t),null!=this.forwardLayer&&this.forwardLayer.setFastWeightInitDuringBuild(t),null!=this.backwardLayer&&this.backwardLayer.setFastWeightInitDuringBuild(t)}getConfig(){const t={mergeMode:this.mergeMode},e=super.getConfig();return Object.assign(t,e),t}static fromConfig(t,e){const n=Ml(e.layer);if(delete e.layer,null!=e.numConstants)throw new Na("Deserialization of a Bidirectional layer with numConstants present is not supported yet.");const s=e;return s.layer=n,new t(s)}}function Uc(e){return ri(this,void 0,void 0,(function(){var n,s,r,i,a;return ii(this,(function(o){switch(o.label){case 0:return"http://","https://",n="file://",0!==e.indexOf("http://")&&0!==e.indexOf("https://")?[3,3]:[4,fetch(e)];case 1:return[4,o.sent().json()];case 2:return[2,o.sent()];case 3:return 0!==e.indexOf(n)?[3,5]:(s=require("fs"),r=t(s.readFile),a=(i=JSON).parse,[4,r(e.slice(n.length),{encoding:"utf-8"})]);case 4:return[2,a.apply(i,[o.sent()])];case 5:throw new Error("Unsupported URL scheme in metadata URL: "+e+". Supported schemes are: http://, https://, and (node.js-only) file://")}}))}))}Pc.className="Bidirectional",ge(Pc);var Wc=null;function jc(t){return null==Wc&&(Wc=ke().epsilon()),be((function(){var e=ks(t),n=e.mean,s=e.variance;return Ie(ns(t,n),xe(mr(s),Wc))}))}function qc(t){if(t.length<2)throw new Error("Cannot normalize a Float32Array with fewer than 2 elements.");return null==Wc&&(Wc=ke().epsilon()),be((function(){var e=ks(xr(t)),n=e.mean,s=e.variance,r=n.arraySync(),i=Math.sqrt(s.arraySync()),a=Array.from(t).map((function(t){return(t-r)/(i+Wc)}));return new Float32Array(a)}))}function Kc(t){return ri(this,void 0,void 0,(function(){return ii(this,(function(e){return[2,navigator.mediaDevices.getUserMedia({audio:null==t||t,video:!1})]}))}))}var Vc=function(){function t(t){var e=this;if(null==t)throw new Error("Required configuration object is missing for BrowserFftFeatureExtractor constructor");if(null==t.spectrogramCallback)throw new Error("spectrogramCallback cannot be null or undefined");if(!(t.numFramesPerSpectrogram>0))throw new Error("Invalid value in numFramesPerSpectrogram: "+t.numFramesPerSpectrogram);if(t.suppressionTimeMillis<0)throw new Error("Expected suppressionTimeMillis to be >= 0, but got "+t.suppressionTimeMillis);if(this.suppressionTimeMillis=t.suppressionTimeMillis,this.spectrogramCallback=t.spectrogramCallback,this.numFrames=t.numFramesPerSpectrogram,this.sampleRateHz=t.sampleRateHz||44100,this.fftSize=t.fftSize||1024,this.frameDurationMillis=this.fftSize/this.sampleRateHz*1e3,this.columnTruncateLength=t.columnTruncateLength||this.fftSize,this.overlapFactor=t.overlapFactor,this.includeRawAudio=t.includeRawAudio,r(this.overlapFactor>=0&&this.overlapFactor<1,(function(){return"Expected overlapFactor to be >= 0 and < 1, but got "+e.overlapFactor})),this.columnTruncateLength>this.fftSize)throw new Error("columnTruncateLength "+this.columnTruncateLength+" exceeds fftSize ("+this.fftSize+").");this.audioContextConstructor=window.AudioContext||window.webkitAudioContext}return t.prototype.start=function(t){return ri(this,void 0,void 0,(function(){var e,n,s;return ii(this,(function(r){switch(r.label){case 0:if(null!=this.frameIntervalTask)throw new Error("Cannot start already-started BrowserFftFeatureExtractor");return e=this,[4,Kc(t)];case 1:return e.stream=r.sent(),this.audioContext=new this.audioContextConstructor,this.audioContext.sampleRate!==this.sampleRateHz&&console.warn("Mismatch in sampling rate: Expected: "+this.sampleRateHz+"; Actual: "+this.audioContext.sampleRate),n=this.audioContext.createMediaStreamSource(this.stream),this.analyser=this.audioContext.createAnalyser(),this.analyser.fftSize=2*this.fftSize,this.analyser.smoothingTimeConstant=0,n.connect(this.analyser),this.freqDataQueue=[],this.freqData=new Float32Array(this.fftSize),this.includeRawAudio&&(this.timeDataQueue=[],this.timeData=new Float32Array(this.fftSize)),s=Math.max(1,Math.round(this.numFrames*(1-this.overlapFactor))),this.tracker=new Zc(s,Math.round(this.suppressionTimeMillis/this.frameDurationMillis)),this.frameIntervalTask=setInterval(this.onAudioFrame.bind(this),this.fftSize/this.sampleRateHz*1e3),[2]}}))}))},t.prototype.onAudioFrame=function(){return ri(this,void 0,void 0,(function(){var t,e,n,s;return ii(this,(function(r){switch(r.label){case 0:return this.analyser.getFloatFrequencyData(this.freqData),this.freqData[0]===-1/0?[2]:(this.freqDataQueue.push(this.freqData.slice(0,this.columnTruncateLength)),this.includeRawAudio&&(this.analyser.getFloatTimeDomainData(this.timeData),this.timeDataQueue.push(this.timeData.slice())),this.freqDataQueue.length>this.numFrames&&this.freqDataQueue.shift(),this.tracker.tick()?(t=Hc(this.freqDataQueue),e=Gc(t,[1,this.numFrames,this.columnTruncateLength,1]),n=void 0,this.includeRawAudio&&(s=Hc(this.timeDataQueue),n=Gc(s,[1,this.numFrames*this.fftSize])),[4,this.spectrogramCallback(e,n)]):[3,2]);case 1:r.sent()&&this.tracker.suppress(),we([e,n]),r.label=2;case 2:return[2]}}))}))},t.prototype.stop=function(){return ri(this,void 0,void 0,(function(){return ii(this,(function(t){if(null==this.frameIntervalTask)throw new Error("Cannot stop because there is no ongoing streaming activity.");return clearInterval(this.frameIntervalTask),this.frameIntervalTask=null,this.analyser.disconnect(),this.audioContext.close(),null!=this.stream&&this.stream.getTracks().length>0&&this.stream.getTracks()[0].stop(),[2]}))}))},t.prototype.setConfig=function(t){throw new Error("setConfig() is not implemented for BrowserFftFeatureExtractor.")},t.prototype.getFeatures=function(){throw new Error("getFeatures() is not implemented for BrowserFftFeatureExtractor. Use the spectrogramCallback field of the constructor config instead.")},t}();function Hc(t){var e=t[0].length,n=new Float32Array(t.length*e);return t.forEach((function(t,s){return n.set(t,s*e)})),n}function Gc(t,e){var n=new Float32Array(l(e));return n.set(t,n.length-t.length),kt(n,e)}var Jc,Zc=function(){function t(t,e){var n=this;this.period=t,this.suppressionTime=null==e?0:e,this.counter=0,r(this.period>0,(function(){return"Expected period to be positive, but got "+n.period}))}return t.prototype.tick=function(){return this.counter++,this.counter%this.period==0&&(null==this.suppressionOnset||this.counter-this.suppressionOnset>this.suppressionTime)},t.prototype.suppress=function(){this.suppressionOnset=this.counter},t}();function Xc(t,e,n=new Map,s=new Set){if(null==t)return null;if(s.has(t))throw new Error("Circular references are not supported.");if(n.has(t))return n.get(t);const r=e(t);if(r.recurse&&null!==r.value)throw new Error("A deep map function may not return both a value and recurse=true.");if(r.recurse){if(ep(t)){const r=Array.isArray(t)?[]:{};s.add(t);for(const i in t){const a=Xc(t[i],e,n,s);r[i]=a}return s.delete(t),r}throw new Error("Can't recurse into non-iterable type: "+t)}return n.set(t,r.value),r.value}function Yc(t,e=Qc){return function t(e,n,s=new Set){const r=e[0];if(s.has(r))throw new Error("Circular references are not supported.");const i=n(e);if(i.recurse&&null!==i.value)throw new Error("A deep zip function may not return both a value and recurse=true.");if(i.recurse){if(ep(r)){const i=Array.isArray(r)?[]:{};s.add(r);for(const a in r){const r=e.map(t=>t[a]),o=t(r,n,s);i[a]=o}return s.delete(r),i}throw new Error("Can't recurse into non-iterable type: "+r)}return i.value}(t,e)}function Qc(t){return null===t?null:ep(t[0])?{value:null,recurse:!0}:{value:t,recurse:!1}}async function tp(t,e){const n=new Map;Xc(t,e,n);for(const t of Array.from(n.keys())){const e=n.get(t);if(S(e)){const s=await e;n.set(t,s)}}return Xc(t,e,n)}function ep(t){return null!=t&&!ArrayBuffer.isView(t)&&(Array.isArray(t)||"object"==typeof t&&!(t instanceof J))}function np(t){return Xc(t,sp)}function sp(t){return t instanceof J?{value:t.clone(),recurse:!1}:ep(t)?{value:null,recurse:!0}:{value:t,recurse:!1}}class rp{constructor(t){if(this.capacity=t,this.begin=0,this.end=0,null==t)throw new RangeError("Can't create a ring buffer of unknown capacity.");if(t<1)throw new RangeError("Can't create ring buffer of capacity < 1.");this.data=new Array(t),this.doubledCapacity=2*t}wrap(t){for(;t<0;)t+=this.doubledCapacity;return t%this.doubledCapacity}get(t){if(t<0)throw new RangeError("Can't get item at a negative index.");return this.data[t%this.capacity]}set(t,e){if(t<0)throw new RangeError("Can't set item at a negative index.");this.data[t%this.capacity]=e}length(){let t=this.end-this.begin;return t<0&&(t=this.doubledCapacity+t),t}isFull(){return this.length()===this.capacity}isEmpty(){return 0===this.length()}push(t){if(this.isFull())throw new RangeError("Ring buffer is full.");this.set(this.end,t),this.end=this.wrap(this.end+1)}pushAll(t){for(const e of t)this.push(e)}pop(){if(this.isEmpty())throw new RangeError("Ring buffer is empty.");this.end=this.wrap(this.end-1);const t=this.get(this.end);return this.set(this.end,void 0),t}unshift(t){if(this.isFull())throw new RangeError("Ring buffer is full.");this.begin=this.wrap(this.begin-1),this.set(this.begin,t)}shift(){if(this.isEmpty())throw new RangeError("Ring buffer is empty.");const t=this.get(this.begin);return this.set(this.begin,void 0),this.begin=this.wrap(this.begin+1),t}shuffleExcise(t){if(this.isEmpty())throw new RangeError("Ring buffer is empty.");const e=this.wrap(this.begin+t),n=this.get(e);return this.set(e,this.pop()),n}}class ip extends rp{constructor(){super(ip.INITIAL_CAPACITY)}isFull(){return!1}push(t){super.isFull()&&this.expand(),super.push(t)}unshift(t){super.isFull()&&this.expand(),super.unshift(t)}expand(){const t=2*this.capacity,e=new Array(t),n=this.length();for(let t=0;t<n;t++)e[t]=this.get(this.wrap(this.begin+t));this.data=e,this.capacity=t,this.doubledCapacity=2*this.capacity,this.begin=0,this.end=n}}function ap(t){return new lp(t)}ip.INITIAL_CAPACITY=32;class op{async toArray(){const t=[];let e=await this.next();for(;!e.done;)t.push(e.value),e=await this.next();return t}async toArrayForTest(){const t=this.prefetch(100),e=[];let n=await t.next();for(;!n.done;)e.push(n.value),n=await t.next();return e}async resolveFully(){let t=await this.next();for(;!t.done;)t=await this.next()}async resolveWhile(t){let e=await this.next(),n=t(e.value);for(;!e.done&&n;)e=await this.next(),n=t(e.value)}handleErrors(t){return new gp(this,t)}filter(t){return new fp(this,t)}map(t){return new mp(this,t)}mapAsync(t){return new yp(this,t)}serialMapAsync(t){return new yp(this,t).serial()}flatmap(t){return new wp(this,t)}async forEachAsync(t){return this.map(t).resolveFully()}async serialForEach(t){return this.serialMapAsync(t).resolveWhile(t=>!0===t)}rowMajorBatch(t,e=!0){return new dp(this,t,e)}columnMajorBatch(t,e=!0,n=Qc){return this.rowMajorBatch(t,e).map(t=>Yc(t,n))}concatenate(t,e){return new vp(ap([this,t]),e)}take(t){return t<0||null==t?this:new pp(this,t)}skip(t){return t<0||null==t?this:new cp(this,t)}prefetch(t){return new xp(this,t)}shuffle(t,e){return new Sp(this,t,e)}serial(){return new hp(this)}}class lp extends op{constructor(t){super(),this.items=t,this.trav=0}summary(){return`Array of ${this.items.length} items`}async next(){if(this.trav>=this.items.length)return{value:null,done:!0};const t=this.items[this.trav];return this.trav++,{value:np(t),done:!1}}}class up extends op{constructor(t){super(),this.nextFn=t}summary(){return"Function call"}async next(){try{return this.nextFn()}catch(t){throw t.message="Error thrown while iterating through a dataset: "+t.message,t}}}class hp extends op{constructor(t){super(),this.upstream=t,this.lastRead=Promise.resolve({value:null,done:!1})}summary(){return this.upstream.summary()+" -> Serial"}async next(){return this.lastRead=this.lastRead.then(()=>this.serialNext()),this.lastRead}async serialNext(){return this.upstream.next()}}class cp extends op{constructor(t,e){super(),this.upstream=t,this.maxCount=e,this.count=0,this.lastRead=Promise.resolve({value:null,done:!1})}summary(){return this.upstream.summary()+" -> Skip"}async next(){return this.lastRead=this.lastRead.then(()=>this.serialNext()),this.lastRead}async serialNext(){for(;this.count++<this.maxCount;){const t=await this.upstream.next();if(t.done)return t;we(t.value)}return this.upstream.next()}}class pp extends op{constructor(t,e){super(),this.upstream=t,this.maxCount=e,this.count=0}summary(){return this.upstream.summary()+" -> Take"}async next(){return this.count++>=this.maxCount?{value:null,done:!0}:this.upstream.next()}}class dp extends op{constructor(t,e,n=!0){super(),this.upstream=t,this.batchSize=e,this.enableSmallLastBatch=n,this.lastRead=Promise.resolve({value:null,done:!1})}summary(){return this.upstream.summary()+" -> RowMajorBatch"}async next(){return this.lastRead=this.lastRead.then(()=>this.serialNext()),this.lastRead}async serialNext(){const t=[];for(;t.length<this.batchSize;){const e=await this.upstream.next();if(e.done)return this.enableSmallLastBatch&&t.length>0?{value:t,done:!1}:{value:null,done:!0};t.push(e.value)}return{value:t,done:!1}}}class fp extends op{constructor(t,e){super(),this.upstream=t,this.predicate=e,this.lastRead=Promise.resolve({value:null,done:!1})}summary(){return this.upstream.summary()+" -> Filter"}async next(){return this.lastRead=this.lastRead.then(()=>this.serialNext()),this.lastRead}async serialNext(){for(;;){const t=await this.upstream.next();if(t.done||this.predicate(t.value))return t;we(t.value)}}}class mp extends op{constructor(t,e){super(),this.upstream=t,this.transform=e}summary(){return this.upstream.summary()+" -> Map"}async next(){const t=await this.upstream.next();if(t.done)return{value:null,done:!0};const e=at(t.value),n=this.transform(t.value),s=at(n);for(const t of e)it(t,s)||t.dispose();return{value:n,done:!1}}}class gp extends op{constructor(t,e){super(),this.upstream=t,this.handler=e,this.count=0,this.lastRead=Promise.resolve({value:null,done:!1})}summary(){return this.upstream.summary()+" -> handleErrors"}async next(){return this.lastRead=this.lastRead.then(()=>this.serialNext()),this.lastRead}async serialNext(){for(;;)try{return await this.upstream.next()}catch(t){if(!this.handler(t))return{value:null,done:!0}}}}class yp extends op{constructor(t,e){super(),this.upstream=t,this.transform=e}summary(){return this.upstream.summary()+" -> AsyncMap"}async next(){const t=await this.upstream.next();if(t.done)return{value:null,done:!0};const e=at(t.value),n=await this.transform(t.value),s=at(n);for(const t of e)it(t,s)||t.dispose();return{value:n,done:!1}}}class bp extends op{constructor(){super(),this.outputQueue=new ip,this.lastRead=Promise.resolve({value:null,done:!1})}async next(){return this.lastRead=this.lastRead.then(()=>this.serialNext()),this.lastRead}async serialNext(){for(;0===this.outputQueue.length();)if(!await this.pump())return{value:null,done:!0};return{value:this.outputQueue.shift(),done:!1}}}class wp extends bp{constructor(t,e){super(),this.upstream=t,this.transform=e}summary(){return this.upstream.summary()+" -> Flatmap"}async pump(){const t=await this.upstream.next();if(t.done)return!1;const e=at(t.value),n=this.transform(t.value),s=at(n);this.outputQueue.pushAll(n);for(const t of e)it(t,s)||t.dispose();return!0}}class vp extends op{constructor(t,e){super(),this.baseErrorHandler=e,this.lastRead=null,this.iterator=null,this.moreIterators=t}summary(){return"TODO: fill in upstream of chained summaries -> Chained"}async next(){return this.lastRead=this.readFromChain(this.lastRead),this.lastRead}async readFromChain(t){if(await t,null==this.iterator){const t=await this.moreIterators.next();if(t.done)return{value:null,done:!0};this.iterator=t.value,null!=this.baseErrorHandler&&(this.iterator=this.iterator.handleErrors(this.baseErrorHandler))}const e=await this.iterator.next();return e.done?(this.iterator=null,this.readFromChain(t)):e}}!function(t){t[t.FAIL=0]="FAIL",t[t.SHORTEST=1]="SHORTEST",t[t.LONGEST=2]="LONGEST"}(Jc||(Jc={}));class kp extends op{constructor(t,e=Jc.FAIL){super(),this.iterators=t,this.mismatchMode=e,this.count=0,this.currentPromise=null}summary(){return"{TODO: fill in upstream of zip summaries} -> Zip"}async nextState(t){await t;let e=0,n=0;const s=await tp(this.iterators,(function(t){if(t instanceof op){return{value:t.next().then(t=>(e++,t.done&&n++,t.value)),recurse:!1}}return{value:null,recurse:!0}}));if(e===n)return{value:null,done:!0};if(n>0)switch(this.mismatchMode){case Jc.FAIL:throw new Error(`Zipped streams should have the same length. Mismatched at element ${this.count}.`);case Jc.SHORTEST:return{value:null,done:!0};case Jc.LONGEST:}return this.count++,{value:s,done:!1}}async next(){return this.currentPromise=this.nextState(this.currentPromise),this.currentPromise}}class xp extends op{constructor(t,e){super(),this.upstream=t,this.bufferSize=e,this.buffer=new rp(e)}summary(){return this.upstream.summary()+" -> Prefetch"}refill(){for(;!this.buffer.isFull();){const t=this.upstream.next();this.buffer.push(t)}}next(){return this.refill(),this.buffer.shift()}}class Sp extends xp{constructor(t,e,n){super(t,e),this.upstream=t,this.windowSize=e,this.upstreamExhausted=!1,this.random=Ps(n||$().toString()),this.lastRead=Promise.resolve({value:null,done:!1})}async next(){return this.lastRead=this.lastRead.then(()=>this.serialNext()),this.lastRead}randomInt(t){return Math.floor(this.random()*t)}chooseIndex(){return this.randomInt(this.buffer.length())}async serialNext(){for(this.upstreamExhausted||this.refill();!this.buffer.isEmpty();){const t=this.chooseIndex(),e=await this.buffer.shuffleExcise(t);if(!e.done)return this.refill(),e;this.upstreamExhausted=!0}return{value:null,done:!0}}}class Ip{constructor(){this.size=null}batch(t,e=!0){const n=this;let s;return r(t>0,()=>"batchSize needs to be positive, but it is\n      "+t),s=this.size===1/0||null==this.size?this.size:e?Math.ceil(this.size/t):Math.floor(this.size/t),Np(async()=>(await n.iterator()).columnMajorBatch(t,e,Tp),s)}concatenate(t){const e=this;let n;return n=this.size===1/0||t.size===1/0?1/0:null!=this.size&&null!=t.size?this.size+t.size:null,Np(async()=>(await e.iterator()).concatenate(await t.iterator()),n)}filter(t){const e=this;let n;return n=this.size===1/0?1/0:null,Np(async()=>(await e.iterator()).filter(e=>be(()=>t(e))),n)}async forEachAsync(t){return(await this.iterator()).forEachAsync(t)}map(t){const e=this;return Np(async()=>(await e.iterator()).map(e=>be(()=>t(e))),this.size)}mapAsync(t){const e=this;return Np(async()=>(await e.iterator()).mapAsync(t),this.size)}prefetch(t){if(null==t)throw new RangeError("`Dataset.prefetch()` requires bufferSize to be specified.");const e=this;return Np(async()=>(await e.iterator()).prefetch(t),this.size)}repeat(t){const e=this;let n;return n=null!=this.size&&t>0?this.size*t:0===t?0:null!=this.size&&(void 0===t||t<0)?1/0:null,Np(async()=>{const n=new up(async()=>({value:await e.iterator(),done:!1}));var s,r;return s=n.take(t),new vp(s,r)},n)}skip(t){const e=this;let n;return n=null!=this.size&&t>=0&&this.size>=t?this.size-t:null!=this.size&&(this.size<t||void 0===t||t<0)?0:null,Np(async()=>(await e.iterator()).skip(t),n)}shuffle(t,e,n=!0){if(null==t||t<0)throw null==this.size?new RangeError("`Dataset.shuffle()` requires bufferSize to be specified."):new RangeError(`\`Dataset.shuffle()\` requires bufferSize to be specified.  If your data fits in main memory (for regular JS objects), and/or GPU memory (for \`tf.Tensor\`s), consider setting bufferSize to the dataset size (${this.size} elements)`);const s=this,r=Ps(e||$().toString());return Np(async()=>{let e=r.int32();return n&&(e+=r.int32()),(await s.iterator()).shuffle(t,e.toString())},this.size)}take(t){const e=this;let n;return n=null!=this.size&&this.size>t?t:null!=this.size&&this.size<=t?this.size:null,Np(async()=>(await e.iterator()).take(t),n)}async toArray(){if(this.size===1/0)throw new Error("Can not convert infinite data stream to array.");return(await this.iterator()).toArray()}async toArrayForTest(){if(this.size===1/0)throw new Error("Can not convert infinite data stream to array.");return(await this.iterator()).toArrayForTest()}}function Np(t,e=null){return new class extends Ip{constructor(){super(...arguments),this.size=e}async iterator(){return t()}}}function Ep(t){return Np(async()=>ap(t),t.length)}function Ap(t){if(!ep(t))throw new Error("The argument to zip() must be an object or array.");let e;if(Array.isArray(t))for(let n=0;n<t.length;n++)e=null==e?t[n].size:Math.min(e,t[n].size);else if(t instanceof Object)for(const n in t)e=null==e?t[n].size:Math.min(e,t[n].size);return Np(async()=>function(t,e=Jc.FAIL){return new kp(t,e)}(await tp(t,t=>{if(t instanceof Ip)return{value:t.iterator(),recurse:!1};if(ep(t))return{value:null,recurse:!0};throw new Error("Leaves of the structure passed to zip() must be Datasets, not primitives.")}),Jc.SHORTEST),e)}function Tp(t){if(null===t)return null;const e=t[0];if(null==(n=e)||null===(s=n)||"object"!=typeof s&&"function"!=typeof s||Array.isArray(n)||"object"==typeof n&&n instanceof J||d(n)){return{value:function(t){if(0===t.length)throw new Error("Can't make a batch of zero elements.");return t[0]instanceof J?br(t):kt(t)}(t),recurse:!1}}var n,s;return{value:null,recurse:!0}}Ip.MAX_BUFFER_SIZE=1e4;var Dp=Fs((function(t,n){var s=e.Buffer;function r(t,e){for(var n in t)e[n]=t[n]}function i(t,e,n){return s(t,e,n)}s.from&&s.alloc&&s.allocUnsafe&&s.allocUnsafeSlow?t.exports=e:(r(e,n),n.Buffer=i),r(s,i),i.from=function(t,e,n){if("number"==typeof t)throw new TypeError("Argument must not be a number");return s(t,e,n)},i.alloc=function(t,e,n){if("number"!=typeof t)throw new TypeError("Argument must be a number");var r=s(t);return void 0!==e?"string"==typeof n?r.fill(e,n):r.fill(e):r.fill(0),r},i.allocUnsafe=function(t){if("number"!=typeof t)throw new TypeError("Argument must be a number");return s(t)},i.allocUnsafeSlow=function(t){if("number"!=typeof t)throw new TypeError("Argument must be a number");return e.SlowBuffer(t)}})),zp=(Dp.Buffer,Dp.Buffer),Cp=zp.isEncoding||function(t){switch((t=""+t)&&t.toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":case"raw":return!0;default:return!1}};function Fp(t){var e;switch(this.encoding=function(t){var e=function(t){if(!t)return"utf8";for(var e;;)switch(t){case"utf8":case"utf-8":return"utf8";case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return"utf16le";case"latin1":case"binary":return"latin1";case"base64":case"ascii":case"hex":return t;default:if(e)return;t=(""+t).toLowerCase(),e=!0}}(t);if("string"!=typeof e&&(zp.isEncoding===Cp||!Cp(t)))throw new Error("Unknown encoding: "+t);return e||t}(t),this.encoding){case"utf16le":this.text=Mp,this.end=_p,e=4;break;case"utf8":this.fillLast=Lp,e=4;break;case"base64":this.text=$p,this.end=Op,e=3;break;default:return this.write=Bp,void(this.end=Pp)}this.lastNeed=0,this.lastTotal=0,this.lastChar=zp.allocUnsafe(e)}function Rp(t){return t<=127?0:t>>5==6?2:t>>4==14?3:t>>3==30?4:t>>6==2?-1:-2}function Lp(t){var e=this.lastTotal-this.lastNeed,n=function(t,e,n){if(128!=(192&e[0]))return t.lastNeed=0,"�";if(t.lastNeed>1&&e.length>1){if(128!=(192&e[1]))return t.lastNeed=1,"�";if(t.lastNeed>2&&e.length>2&&128!=(192&e[2]))return t.lastNeed=2,"�"}}(this,t);return void 0!==n?n:this.lastNeed<=t.length?(t.copy(this.lastChar,e,0,this.lastNeed),this.lastChar.toString(this.encoding,0,this.lastTotal)):(t.copy(this.lastChar,e,0,t.length),void(this.lastNeed-=t.length))}function Mp(t,e){if((t.length-e)%2==0){var n=t.toString("utf16le",e);if(n){var s=n.charCodeAt(n.length-1);if(s>=55296&&s<=56319)return this.lastNeed=2,this.lastTotal=4,this.lastChar[0]=t[t.length-2],this.lastChar[1]=t[t.length-1],n.slice(0,-1)}return n}return this.lastNeed=1,this.lastTotal=2,this.lastChar[0]=t[t.length-1],t.toString("utf16le",e,t.length-1)}function _p(t){var e=t&&t.length?this.write(t):"";if(this.lastNeed){var n=this.lastTotal-this.lastNeed;return e+this.lastChar.toString("utf16le",0,n)}return e}function $p(t,e){var n=(t.length-e)%3;return 0===n?t.toString("base64",e):(this.lastNeed=3-n,this.lastTotal=3,1===n?this.lastChar[0]=t[t.length-1]:(this.lastChar[0]=t[t.length-2],this.lastChar[1]=t[t.length-1]),t.toString("base64",e,t.length-n))}function Op(t){var e=t&&t.length?this.write(t):"";return this.lastNeed?e+this.lastChar.toString("base64",0,3-this.lastNeed):e}function Bp(t){return t.toString(this.encoding)}function Pp(t){return t&&t.length?this.write(t):""}function Up(t){var e=0;t.forEach((function(t){e+=t.byteLength}));var n=new Uint8Array(e),s=0;return t.forEach((function(t){n.set(new Uint8Array(t),s),s+=t.byteLength})),n.buffer}function Wp(t){var e=0;t.forEach((function(t){return e+=t.length}));var n=new Float32Array(e),s=0;return t.forEach((function(t){n.set(t,s),s+=t.length})),n}function jp(t){if(null==t)throw new Error("Received null or undefind string");for(var e=unescape(encodeURIComponent(t)),n=new Uint8Array(e.length),s=0;s<e.length;++s)n[s]=e.charCodeAt(s);return n.buffer}function qp(t){if(null==t)throw new Error("Received null or undefind buffer");var e=new Uint8Array(t);return decodeURIComponent(escape(String.fromCharCode.apply(String,li(e))))}Fp.prototype.write=function(t){if(0===t.length)return"";var e,n;if(this.lastNeed){if(void 0===(e=this.fillLast(t)))return"";n=this.lastNeed,this.lastNeed=0}else n=0;return n<t.length?e?e+this.text(t,n):this.text(t,n):e||""},Fp.prototype.end=function(t){var e=t&&t.length?this.write(t):"";return this.lastNeed?e+"�":e},Fp.prototype.text=function(t,e){var n=function(t,e,n){var s=e.length-1;if(s<n)return 0;var r=Rp(e[s]);if(r>=0)return r>0&&(t.lastNeed=r-1),r;if(--s<n||-2===r)return 0;if((r=Rp(e[s]))>=0)return r>0&&(t.lastNeed=r-2),r;if(--s<n||-2===r)return 0;if((r=Rp(e[s]))>=0)return r>0&&(2===r?r=0:t.lastNeed=r-3),r;return 0}(this,t,e);if(!this.lastNeed)return t.toString("utf8",e);this.lastTotal=n;var s=t.length-(n-this.lastNeed);return t.copy(this.lastChar,0,s),t.toString("utf8",e,s)},Fp.prototype.fillLast=function(t){if(this.lastNeed<=t.length)return t.copy(this.lastChar,this.lastTotal-this.lastNeed,0,this.lastNeed),this.lastChar.toString(this.encoding,0,this.lastTotal);t.copy(this.lastChar,this.lastTotal-this.lastNeed,0,t.length),this.lastNeed-=t.length};var Kp="_background_noise_",Vp=function(){function t(t){if(this.examples={},this.label2Ids={},null!=t)for(var e=function(t){r(null!=t,(function(){return"Received null or undefined buffer"}));var e=0;r("TFJSSCDS"===qp(t.slice(e,"TFJSSCDS".length)),(function(){return"Deserialization error: Invalid descriptor"})),e+="TFJSSCDS".length,e+=4;var n=new Uint32Array(t,e,1),s=e+=4;e=s+n[0];var i=qp(t.slice(s,e)),a=JSON.parse(i),o=t.slice(e);return{manifest:a,data:o}}(t),n=0,s=0;s<e.manifest.length;++s){var i=e.manifest[s],a=i.spectrogramNumFrames*i.spectrogramFrameSize;null!=i.rawAudioNumSamples&&(a+=i.rawAudioNumSamples),a*=4,this.addExample(Gp({spec:i,data:e.data.slice(n,n+a)})),n+=a}}return t.prototype.addExample=function(t){r(null!=t,(function(){return"Got null or undefined example"})),r(null!=t.label&&t.label.length>0,(function(){return"Expected label to be a non-empty string, but got "+JSON.stringify(t.label)}));var e=function(){function t(){return Math.floor(65536*(1+Math.random())).toString(16).substring(1)}return t()+t()+"-"+t()+"-"+t()+"-"+t()+"-"+t()+t()+t()}();return this.examples[e]=t,t.label in this.label2Ids||(this.label2Ids[t.label]=[]),this.label2Ids[t.label].push(e),e},t.prototype.merge=function(t){var e,n,s,i;r(t!==this,(function(){return"Cannot merge a dataset into itself"}));var a=t.getVocabulary();try{for(var o=ai(a),l=o.next();!l.done;l=o.next()){var u=l.value,h=t.getExamples(u);try{for(var c=(s=void 0,ai(h)),p=c.next();!p.done;p=c.next()){var d=p.value;this.addExample(d.example)}}catch(t){s={error:t}}finally{try{p&&!p.done&&(i=c.return)&&i.call(c)}finally{if(s)throw s.error}}}}catch(t){e={error:t}}finally{try{l&&!l.done&&(n=o.return)&&n.call(o)}finally{if(e)throw e.error}}},t.prototype.getExampleCounts=function(){var t={};for(var e in this.examples){var n=this.examples[e];n.label in t||(t[n.label]=0),t[n.label]++}return t},t.prototype.getExamples=function(t){var e=this;r(null!=t,(function(){return"Expected label to be a string, but got "+JSON.stringify(t)})),r(t in this.label2Ids,(function(){return'No example of label "'+t+'" exists in dataset'}));var n=[];return this.label2Ids[t].forEach((function(t){n.push({uid:t,example:e.examples[t]})})),n},t.prototype.getData=function(t,e){var n=this;r(this.size()>0,(function(){return"Cannot get spectrograms as tensors because the dataset is empty"}));var i=this.getVocabulary();null!=t?r(-1!==i.indexOf(t),(function(){return"Label "+t+" is not in the vocabulary ("+JSON.stringify(i)+")"})):r(i.length>1,(function(){return"One-hot encoding of labels requires the vocabulary to have at least two words, but it has only "+i.length+" word."})),null==e&&(e={});var a,o,l=this.getSortedUniqueNumFrames();1===l.length?(a=null==e.numFrames?l[0]:e.numFrames,o=null==e.hopFrames?1:e.hopFrames):(r(null!=(a=e.numFrames)&&Number.isInteger(a)&&a>0,(function(){return"There are "+l.length+" unique lengths among the "+n.size()+" examples of this Dataset, hence numFrames is required. But it is not provided."})),r(a<=l[0],(function(){return"numFrames ("+a+") exceeds the minimum numFrames ("+l[0]+") among the examples of the Dataset."})),r(null!=(o=e.hopFrames)&&Number.isInteger(o)&&o>0,(function(){return"There are "+l.length+" unique lengths among the "+n.size()+" examples of this Dataset, hence hopFrames is required. But it is not provided."})));var u=null==e.normalize||e.normalize;return be((function(){for(var l,h,c,p=[],d=[],f=[],m=0;m<i.length;++m){var g=i[m];if(null==t||g===t){var y=n.label2Ids[g],b=function(s){var i,l,h=n.examples[s].spectrogram,y=h.frameSize;null==c?c=y:r(y===c,(function(){return"Mismatch in frameSize  ("+y+" vs "+c+")"}));var b=h.data.length/y,w=null;"_background_noise_"!==g&&(w=null==h.keyFrameIndex?Xp(h).dataSync()[0]:h.keyFrameIndex);var v=de(h.data,[b,y,1]),k=Jp(b,w,a,o),x=function(n){var s=be((function(){var t=Je(v,[n[0],0,0],[n[1]-n[0],-1,-1]);return u?jc(t):t}));e.getDataset?d.push(s.dataSync()):p.push(s),null==t&&f.push(m)};try{for(var S=(i=void 0,ai(k)),I=S.next();!I.done;I=S.next()){x(I.value)}}catch(t){i={error:t}}finally{try{I&&!I.done&&(l=S.return)&&l.call(S)}finally{if(i)throw i.error}}we(v)};try{for(var w=(l=void 0,ai(y)),v=w.next();!v.done;v=w.next()){b(v.value)}}catch(t){l={error:t}}finally{try{v&&!v.done&&(h=w.return)&&h.call(w)}finally{if(l)throw l.error}}}}null!=e.augmentByMixingNoiseRatio&&n.augmentByMixingNoise(e.getDataset?d:p,f,e.augmentByMixingNoiseRatio);var k=null==e.shuffle||e.shuffle;if(e.getDataset){var x=null==e.datasetBatchSize?32:e.datasetBatchSize,S=null==e.datasetValidationSplit?.15:e.datasetValidationSplit;r(S>0&&S<1,(function(){return"Invalid dataset validation split: "+S}));var I=d.map((function(t,e){return[t,f[e]]}));s(I),d=I.map((function(t){return t[0]}));var N=I.map((function(t){return t[1]})),E=function(t,e,n){var i,a,o,l,u,h,c,p;r(n>0&&n<1,(function(){return"validationSplit is expected to be >0 and <1, but got "+n}));for(var d=!Array.isArray(t[0]),f=e,m=[],g=0;g<f.length;++g){var y=f[g];null==m[y]&&(m[y]=[]),m[y].push(g)}var b=m.length,w=[],v=[];for(m.map((function(t){return s(t)})),g=0;g<b;++g)for(var k=m[g],x=Math.round(k.length*(1-n)),S=0;S<k.length;++S)S<x?w.push(k[S]):v.push(k[S]);if(d){var I=[],N=[],E=[],A=[];try{for(var T=ai(w),D=T.next();!D.done;D=T.next()){var z=D.value;I.push(t[z]),N.push(e[z])}}catch(t){i={error:t}}finally{try{D&&!D.done&&(a=T.return)&&a.call(T)}finally{if(i)throw i.error}}try{for(var C=ai(v),F=C.next();!F.done;F=C.next()){z=F.value;E.push(t[z]),A.push(e[z])}}catch(t){o={error:t}}finally{try{F&&!F.done&&(l=C.return)&&l.call(C)}finally{if(o)throw o.error}}return{trainXs:I,trainYs:N,valXs:E,valYs:A}}I=[],N=[],E=[],A=[];try{for(var R=ai(w),L=R.next();!L.done;L=R.next()){z=L.value;I.push(t[z]),N.push(e[z])}}catch(t){u={error:t}}finally{try{L&&!L.done&&(h=R.return)&&h.call(R)}finally{if(u)throw u.error}}try{for(var M=ai(v),_=M.next();!_.done;_=M.next()){z=_.value;E.push(t[z]),A.push(e[z])}}catch(t){c={error:t}}finally{try{_&&!_.done&&(p=M.return)&&p.call(M)}finally{if(c)throw c.error}}return{trainXs:I,trainYs:N,valXs:E,valYs:A}}(d,N,S),A=E.trainXs,T=E.trainYs,D=E.valXs,z=E.valYs,C=Ap({xs:Ep(A).map((function(t){return de(t,[a,c,1])})),ys:Ep(T).map((function(t){return yr(ce([t],i.length),[0])}))});k&&(C=C.shuffle(d.length)),C=C.batch(x).prefetch(4);var F=Ap({xs:Ep(D).map((function(t){return de(t,[a,c,1])})),ys:Ep(z).map((function(t){return yr(ce([t],i.length),[0])}))});return[C,F=F.batch(x).prefetch(4)]}if(k){var R=[];p.forEach((function(t,e){R.push({x:t,y:f[e]})})),s(R),p=R.map((function(t){return t.x})),f=R.map((function(t){return t.y}))}var L=null==t?ee(ce(xr(f,"int32"),i.length),"float32"):void 0;return{xs:br(p),ys:L}}))},t.prototype.augmentByMixingNoise=function(t,e,n){var s,r;if(null==t||0===t.length)throw new Error("Cannot perform augmentation because data is null or empty");for(var i=t[0]instanceof Float32Array,a=this.getVocabulary(),o=[],l=[],u=0;u<e.length;++u)"_background_noise_"===a[e[u]]?o.push(u):l.push(u);if(0===o.length)throw new Error("Cannot perform augmentation by mixing with noise when there is no example with label _background_noise_");var h=[],c=[],p=function(s){var r=o[function(t,e){return Math.floor((e-t)*Math.random())+t}(0,o.length)],a=i?xr(t[s]):t[s],l=i?xr(t[r]):t[r],u=be((function(){return jc(xe(a,Ne(l,n)))}));i?h.push(u.dataSync()):h.push(u),c.push(e[s])};try{for(var d=ai(l),f=d.next();!f.done;f=d.next()){p(f.value)}}catch(t){s={error:t}}finally{try{f&&!f.done&&(r=d.return)&&r.call(d)}finally{if(s)throw s.error}}console.log("Data augmentation: mixing noise: added "+h.length+" examples"),h.forEach((function(e){return t.push(e)})),e.push.apply(e,li(c))},t.prototype.getSortedUniqueNumFrames=function(){for(var t,e,n=new Set,s=this.getVocabulary(),r=0;r<s.length;++r){var i=s[r],a=this.label2Ids[i];try{for(var o=(t=void 0,ai(a)),l=o.next();!l.done;l=o.next()){var u=l.value,h=this.examples[u].spectrogram,c=h.data.length/h.frameSize;n.add(c)}}catch(e){t={error:e}}finally{try{l&&!l.done&&(e=o.return)&&e.call(o)}finally{if(t)throw t.error}}}var p=li(n);return p.sort(),p},t.prototype.removeExample=function(t){if(!(t in this.examples))throw new Error("Nonexistent example UID: "+t);var e=this.examples[t].label;delete this.examples[t];var n=this.label2Ids[e].indexOf(t);this.label2Ids[e].splice(n,1),0===this.label2Ids[e].length&&delete this.label2Ids[e]},t.prototype.setExampleKeyFrameIndex=function(t,e){if(!(t in this.examples))throw new Error("Nonexistent example UID: "+t);var n=this.examples[t].spectrogram,s=n.data.length/n.frameSize;r(e>=0&&e<s&&Number.isInteger(e),(function(){return"Invalid keyFrameIndex: "+e+". Must be >= 0, < "+s+", and an integer."})),n.keyFrameIndex=e},t.prototype.size=function(){return Object.keys(this.examples).length},t.prototype.durationMillis=function(){var t=0;for(var e in this.examples){var n=this.examples[e].spectrogram,s=23.22|n.frameDurationMillis;t+=n.data.length/n.frameSize*s}return t},t.prototype.empty=function(){return 0===this.size()},t.prototype.clear=function(){this.examples={}},t.prototype.getVocabulary=function(){var t=new Set;for(var e in this.examples){var n=this.examples[e];t.add(n.label)}var s=li(t);return s.sort(),s},t.prototype.serialize=function(t){var e,n,s,i,a=this.getVocabulary();r(!this.empty(),(function(){return"Cannot serialize empty Dataset"})),null!=t&&(Array.isArray(t)||(t=[t]),t.forEach((function(t){if(-1===a.indexOf(t))throw new Error('Word label "'+t+'" does not exist in the vocabulary of this dataset. The vocabulary is: '+JSON.stringify(a)+".")})));var o=[],l=[];try{for(var u=ai(a),h=u.next();!h.done;h=u.next()){var c=h.value;if(null==t||-1!==t.indexOf(c)){var p=this.label2Ids[c];try{for(var d=(s=void 0,ai(p)),f=d.next();!f.done;f=d.next()){var m=f.value,g=Hp(this.examples[m]);o.push(g.spec),l.push(g.data)}}catch(t){s={error:t}}finally{try{f&&!f.done&&(i=d.return)&&i.call(d)}finally{if(s)throw s.error}}}}}catch(t){e={error:t}}finally{try{h&&!h.done&&(n=u.return)&&n.call(u)}finally{if(e)throw e.error}}return function(t){var e=jp(JSON.stringify(t.manifest)),n=jp("TFJSSCDS"),s=new Uint32Array([1]),r=new Uint32Array([e.byteLength]),i=Up([n,s.buffer,r.buffer]);return Up([i,e,t.data])}({manifest:o,data:Up(l)})},t}();function Hp(t){var e=null!=t.rawAudio,n={label:t.label,spectrogramNumFrames:t.spectrogram.data.length/t.spectrogram.frameSize,spectrogramFrameSize:t.spectrogram.frameSize};null!=t.spectrogram.keyFrameIndex&&(n.spectrogramKeyFrameIndex=t.spectrogram.keyFrameIndex);var s=t.spectrogram.data.buffer.slice(0);return e&&(n.rawAudioNumSamples=t.rawAudio.data.length,n.rawAudioSampleRateHz=t.rawAudio.sampleRateHz,s=Up([s,t.rawAudio.data.buffer])),{spec:n,data:s}}function Gp(t){var e={frameSize:t.spec.spectrogramFrameSize,data:new Float32Array(t.data.slice(0,4*t.spec.spectrogramFrameSize*t.spec.spectrogramNumFrames))};null!=t.spec.spectrogramKeyFrameIndex&&(e.keyFrameIndex=t.spec.spectrogramKeyFrameIndex);var n={label:t.spec.label,spectrogram:e};return null!=t.spec.rawAudioNumSamples&&(n.rawAudio={sampleRateHz:t.spec.rawAudioSampleRateHz,data:new Float32Array(t.data.slice(4*t.spec.spectrogramFrameSize*t.spec.spectrogramNumFrames))}),n}function Jp(t,e,n,s){if(r(Number.isInteger(t)&&t>0,(function(){return"snippetLength must be a positive integer, but got "+t})),null!=e&&r(Number.isInteger(e)&&e>=0,(function(){return"focusIndex must be a non-negative integer, but got "+e})),r(Number.isInteger(n)&&n>0,(function(){return"windowLength must be a positive integer, but got "+n})),r(Number.isInteger(s)&&s>0,(function(){return"windowHop must be a positive integer, but got "+s})),r(n<=t,(function(){return"windowLength ("+n+") exceeds snippetLength ("+t+")"})),r(e<t,(function(){return"focusIndex ("+e+") equals or exceeds snippetLength ("+t+")"})),n===t)return[[0,t]];var i=[];if(null==e){for(var a=0;a+n<=t;)i.push([a,a+n]),a+=s;return i}var o=Math.floor(n/2),l=e-o;for(l<0?l=0:l+n>t&&(l=t-n);!(l-s<0||e>=l-s+n);)l-=s;for(;l+n<=t&&!(e<l);)i.push([l,l+n]),l+=s;return i}function Zp(t){return be((function(){var e=t.data.length/t.frameSize,n=Sr(t.data,[e,t.frameSize]);return ms(n,-1)}))}function Xp(t){return be((function(){return Ce(Zp(t))}))}var Yp="0.5.1",Qp="_unknown_",td="tfjs-speech-commands-saved-model-metadata",ed="indexeddb://tfjs-speech-commands-model/",nd={localStorage:"undefined"==typeof window?null:window.localStorage};var sd=function(){function t(e,n,s){this.MODEL_URL_PREFIX="https://storage.googleapis.com/tfjs-models/tfjs/speech-commands/v"+function(t){return t.split(".").slice(0,2).join(".")}("0.5.1")+"/browser_fft",this.SAMPLE_RATE_HZ=44100,this.FFT_SIZE=1024,this.DEFAULT_SUPPRESSION_TIME_MILLIS=0,this.streaming=!1,this.transferRecognizers={},r(null==n&&null==s||null!=n&&null!=s,(function(){return"modelURL and metadataURL must be both provided or both not provided."})),null==n?(null==e?e=t.DEFAULT_VOCABULARY_NAME:r(-1!==t.VALID_VOCABULARY_NAMES.indexOf(e),(function(){return"Invalid vocabulary name: '"+e+"'"})),this.vocabulary=e,this.modelArtifactsOrURL=this.MODEL_URL_PREFIX+"/"+this.vocabulary+"/model.json",this.metadataOrURL=this.MODEL_URL_PREFIX+"/"+this.vocabulary+"/metadata.json"):(r(null==e,(function(){return"vocabulary name must be null or undefined when modelURL is provided"})),this.modelArtifactsOrURL=n,this.metadataOrURL=s),this.parameters={sampleRateHz:this.SAMPLE_RATE_HZ,fftSize:this.FFT_SIZE}}return t.prototype.listen=function(t,e){return ri(this,void 0,void 0,(function(){var n,s,i,a,o,l=this;return ii(this,(function(u){switch(u.label){case 0:if(this.streaming)throw new Error("Cannot start streaming again when streaming is ongoing.");return[4,this.ensureModelLoaded()];case 1:if(u.sent(),null==e&&(e={}),n=null==e.probabilityThreshold?0:e.probabilityThreshold,e.includeEmbedding&&(n=0),r(n>=0&&n<=1,(function(){return"Invalid probabilityThreshold value: "+n})),s=null!=e.invokeCallbackOnNoiseAndUnknown&&e.invokeCallbackOnNoiseAndUnknown,e.includeEmbedding&&(s=!0),e.suppressionTimeMillis<0)throw new Error("suppressionTimeMillis is expected to be >= 0, but got "+e.suppressionTimeMillis);return r((i=null==e.overlapFactor?.5:e.overlapFactor)>=0&&i<1,(function(){return"Expected overlapFactor to be >= 0 and < 1, but got "+i})),a=function(r,i){return ri(l,void 0,void 0,(function(){var i,a,o,l,u,h,c,p,d,f,m;return ii(this,(function(g){switch(g.label){case 0:return i=jc(r),e.includeEmbedding?[4,this.ensureModelWithEmbeddingOutputCreated()]:[3,2];case 1:return g.sent(),m=oi(this.modelWithEmbeddingOutput.predict(i),2),a=m[0],o=m[1],[3,3];case 2:a=this.model.predict(i),g.label=3;case 3:return[4,a.data()];case 4:return l=g.sent(),[4,(u=a.argMax(-1)).data()];case 5:return h=g.sent()[0],c=Math.max.apply(Math,li(l)),we([a,u,i]),c<n?[2,!1]:[3,6];case 6:return p=void 0,e.includeSpectrogram?(d={},[4,r.data()]):[3,8];case 7:d.data=g.sent(),d.frameSize=this.nonBatchInputShape[1],p=d,g.label=8;case 8:return f=!0,s||"_background_noise_"!==this.words[h]&&"_unknown_"!==this.words[h]||(f=!1),f&&t({scores:l,spectrogram:p,embedding:o}),[2,f]}}))}))},o=null==e.suppressionTimeMillis?this.DEFAULT_SUPPRESSION_TIME_MILLIS:e.suppressionTimeMillis,this.audioDataExtractor=new Vc({sampleRateHz:this.parameters.sampleRateHz,numFramesPerSpectrogram:this.nonBatchInputShape[0],columnTruncateLength:this.nonBatchInputShape[1],suppressionTimeMillis:o,spectrogramCallback:a,overlapFactor:i}),[4,this.audioDataExtractor.start(e.audioTrackConstraints)];case 2:return u.sent(),this.streaming=!0,[2]}}))}))},t.prototype.ensureModelLoaded=function(){return ri(this,void 0,void 0,(function(){var t,e,n,s,r=this;return ii(this,(function(i){switch(i.label){case 0:return null!=this.model?[2]:[4,this.ensureMetadataLoaded()];case 1:return i.sent(),"string"!=typeof this.modelArtifactsOrURL?[3,3]:[4,Bu(this.modelArtifactsOrURL)];case 2:return t=i.sent(),[3,5];case 3:return[4,Bu(ue(this.modelArtifactsOrURL.modelTopology,this.modelArtifactsOrURL.weightSpecs,this.modelArtifactsOrURL.weightData))];case 4:t=i.sent(),i.label=5;case 5:if(1!==t.inputs.length)throw new Error("Expected model to have 1 input, but got a model with "+t.inputs.length+" inputs");if(4!==t.inputs[0].shape.length)throw new Error("Expected model to have an input shape of rank 4, but got an input shape of rank "+t.inputs[0].shape.length);if(1!==t.inputs[0].shape[3])throw new Error("Expected model to have an input shape with 1 as the last dimension, but got input shape"+JSON.stringify(t.inputs[0].shape[3])+"}");if(2!==(e=t.outputShape).length)throw new Error("Expected loaded model to have an output shape of rank 2,but received shape "+JSON.stringify(e));if(e[1]!==this.words.length)throw new Error("Mismatch between the last dimension of model's output shape ("+e[1]+") and number of words ("+this.words.length+").");return this.model=t,this.freezeModel(),this.nonBatchInputShape=t.inputs[0].shape.slice(1),this.elementsPerExample=1,t.inputs[0].shape.slice(1).forEach((function(t){return r.elementsPerExample*=t})),this.warmUpModel(),n=this.parameters.fftSize/this.parameters.sampleRateHz*1e3,s=t.inputs[0].shape[1],this.parameters.spectrogramDurationMillis=s*n,[2]}}))}))},t.prototype.ensureModelWithEmbeddingOutputCreated=function(){return ri(this,void 0,void 0,(function(){var t,e;return ii(this,(function(n){switch(n.label){case 0:return null!=this.modelWithEmbeddingOutput?[2]:[4,this.ensureModelLoaded()];case 1:for(n.sent(),e=this.model.layers.length-2;e>=0;--e)if("Dense"===this.model.layers[e].getClassName()){t=this.model.layers[e];break}if(null==t)throw new Error("Failed to find second last dense layer in the original model.");return this.modelWithEmbeddingOutput=Ou({inputs:this.model.inputs,outputs:[this.model.outputs[0],t.output]}),[2]}}))}))},t.prototype.warmUpModel=function(){var t=this;be((function(){for(var e=Ss([1].concat(t.nonBatchInputShape)),n=0;n<3;++n)t.model.predict(e)}))},t.prototype.ensureMetadataLoaded=function(){return ri(this,void 0,void 0,(function(){var t,e,n;return ii(this,(function(s){switch(s.label){case 0:return null!=this.words?[2]:"string"!=typeof this.metadataOrURL?[3,2]:[4,Uc(this.metadataOrURL)];case 1:return e=s.sent(),[3,3];case 2:e=this.metadataOrURL,s.label=3;case 3:if(null==(t=e).wordLabels){if(null==(n=t.words))throw new Error('Cannot find field "words" or "wordLabels" in metadata JSON file');this.words=n}else this.words=t.wordLabels;return[2]}}))}))},t.prototype.stopListening=function(){return ri(this,void 0,void 0,(function(){return ii(this,(function(t){switch(t.label){case 0:if(!this.streaming)throw new Error("Cannot stop streaming when streaming is not ongoing.");return[4,this.audioDataExtractor.stop()];case 1:return t.sent(),this.streaming=!1,[2]}}))}))},t.prototype.isListening=function(){return this.streaming},t.prototype.wordLabels=function(){return this.words},t.prototype.params=function(){return this.parameters},t.prototype.modelInputShape=function(){if(null==this.model)throw new Error("Model has not been loaded yet. Load model by calling ensureModelLoaded(), recognize(), or listen().");return this.model.inputs[0].shape},t.prototype.recognize=function(t,e){return ri(this,void 0,void 0,(function(){var n,s,r,i,o,l,u,h,c,p,d,f,m;return ii(this,(function(g){switch(g.label){case 0:return null==e&&(e={}),[4,this.ensureModelLoaded()];case 1:return g.sent(),null!=t?[3,3]:[4,this.recognizeOnline()];case 2:n=g.sent(),t=n.data,g.label=3;case 3:if(t instanceof J)this.checkInputTensorShape(t),r=t,s=t.shape[0];else{if(t.length%this.elementsPerExample)throw new Error("The length of the input Float32Array "+t.length+" is not divisible by the number of tensor elements per per example expected by the model "+this.elementsPerExample+".");s=t.length/this.elementsPerExample,r=function(t,e,n){if(a(t),null!=e&&4!==e.length)throw new Error("tensor4d() requires shape to have four numbers");const s=ft(t,n);if(4!==s.length&&1!==s.length)throw new Error("tensor4d() requires values to be number[][][][] or flat/TypedArray");if(1===s.length&&null==e)throw new Error("tensor4d() requires shape to be provided when `values` are a flat array");return vt(t,e,s,n)}(t,[s].concat(this.nonBatchInputShape))}return o={scores:null},e.includeEmbedding?[4,this.ensureModelWithEmbeddingOutputCreated()]:[3,5];case 4:return g.sent(),l=this.modelWithEmbeddingOutput.predict(r),i=l[0],o.embedding=l[1],[3,6];case 5:i=this.model.predict(r),g.label=6;case 6:return 1!==s?[3,8]:(u=o,[4,i.data()]);case 7:return u.scores=g.sent(),[3,10];case 8:return h=Tr(i),c=h.map((function(t){return t.data()})),p=o,[4,Promise.all(c)];case 9:p.scores=g.sent(),we(h),g.label=10;case 10:return e.includeSpectrogram?(d=o,f={},t instanceof J?[4,t.data()]:[3,12]):[3,14];case 11:return m=g.sent(),[3,13];case 12:m=t,g.label=13;case 13:d.spectrogram=(f.data=m,f.frameSize=this.nonBatchInputShape[1],f),g.label=14;case 14:return we(i),[2,o]}}))}))},t.prototype.recognizeOnline=function(){return ri(this,void 0,void 0,(function(){var t=this;return ii(this,(function(e){return[2,new Promise((function(e,n){t.audioDataExtractor=new Vc({sampleRateHz:t.parameters.sampleRateHz,numFramesPerSpectrogram:t.nonBatchInputShape[0],columnTruncateLength:t.nonBatchInputShape[1],suppressionTimeMillis:0,spectrogramCallback:function(n){return ri(t,void 0,void 0,(function(){var t,s,r;return ii(this,(function(i){switch(i.label){case 0:return t=jc(n),[4,this.audioDataExtractor.stop()];case 1:return i.sent(),s=e,r={},[4,t.data()];case 2:return s.apply(void 0,[(r.data=i.sent(),r.frameSize=this.nonBatchInputShape[1],r)]),t.dispose(),[2,!1]}}))}))},overlapFactor:0}),t.audioDataExtractor.start()}))]}))}))},t.prototype.createTransfer=function(t){if(null==this.model)throw new Error("Model has not been loaded yet. Load model by calling ensureModelLoaded(), recognizer(), or listen().");r(null!=t&&"string"==typeof t&&t.length>1,(function(){return"Expected the name for a transfer-learning recognized to be a non-empty string, but got "+JSON.stringify(t)})),r(null==this.transferRecognizers[t],(function(){return"There is already a transfer-learning model named '"+t+"'"}));var e=new rd(t,this.parameters,this.model);return this.transferRecognizers[t]=e,e},t.prototype.freezeModel=function(){var t,e;try{for(var n=ai(this.model.layers),s=n.next();!s.done;s=n.next()){s.value.trainable=!1}}catch(e){t={error:e}}finally{try{s&&!s.done&&(e=n.return)&&e.call(n)}finally{if(t)throw t.error}}},t.prototype.checkInputTensorShape=function(t){var e=this.model.inputs[0].shape.length;if(t.shape.length!==e)throw new Error("Expected input Tensor to have rank "+e+", but got rank "+t.shape.length+" that differs ");var n=t.shape.slice(1),s=this.model.inputs[0].shape.slice(1);if(!u(n,s))throw new Error("Expected input to have shape [null,"+s+"], but got shape [null,"+n+"]")},t.VALID_VOCABULARY_NAMES=["18w","directional4w"],t.DEFAULT_VOCABULARY_NAME="18w",t}(),rd=function(t){function e(e,n,s){var i=t.call(this)||this;return i.name=e,i.parameters=n,i.baseModel=s,r(null!=e&&"string"==typeof e&&e.length>0,(function(){return"The name of a transfer model must be a non-empty string, but got "+JSON.stringify(e)})),i.nonBatchInputShape=i.baseModel.inputs[0].shape.slice(1),i.words=null,i.dataset=new Vp,i}return function(t,e){function n(){this.constructor=t}ni(t,e),t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)}(e,t),e.prototype.collectExample=function(t,e){return ri(this,void 0,void 0,(function(){var n,s,i,a,o=this;return ii(this,(function(l){if(r(!this.streaming,(function(){return"Cannot start collection of transfer-learning example because a streaming recognition or transfer-learning example collection is ongoing"})),r(null!=t&&"string"==typeof t&&t.length>0,(function(){return"Must provide a non-empty string when collecting transfer-learning example"})),null==e&&(e={}),null!=e.durationMultiplier&&null!=e.durationSec)throw new Error("durationMultiplier and durationSec are mutually exclusive, but are both specified.");return null!=e.durationSec?(r(e.durationSec>0,(function(){return"Expected durationSec to be > 0, but got "+e.durationSec})),s=this.parameters.fftSize/this.parameters.sampleRateHz,n=Math.ceil(e.durationSec/s)):null!=e.durationMultiplier?(r(e.durationMultiplier>=1,(function(){return"Expected duration multiplier to be >= 1, but got "+e.durationMultiplier})),n=Math.round(this.nonBatchInputShape[0]*e.durationMultiplier)):n=this.nonBatchInputShape[0],null!=e.snippetDurationSec&&(r(e.snippetDurationSec>0,(function(){return"snippetDurationSec is expected to be > 0, but got "+e.snippetDurationSec})),r(null!=e.onSnippet,(function(){return"onSnippet must be provided if snippetDurationSec is provided."}))),null!=e.onSnippet&&r(null!=e.snippetDurationSec,(function(){return"snippetDurationSec must be provided if onSnippet is provided."})),i=this.parameters.fftSize/this.parameters.sampleRateHz,a=i*n,this.streaming=!0,[2,new Promise((function(s){var r=null==e.snippetDurationSec?1:e.snippetDurationSec/a,i=1-r,l=Math.round(1/r),u=0,h=-1,c=[];o.audioDataExtractor=new Vc({sampleRateHz:o.parameters.sampleRateHz,numFramesPerSpectrogram:n,columnTruncateLength:o.nonBatchInputShape[1],suppressionTimeMillis:0,spectrogramCallback:function(n,r){return ri(o,void 0,void 0,(function(){var i,a,o,p,d,f,m,g,y,b,w,v,k,x,S,I,N,E,A,T;return ii(this,(function(D){switch(D.label){case 0:return null!=e.onSnippet?[3,7]:(i=jc(n),o=(a=this.dataset).addExample,p={label:t},d={},[4,i.data()]);case 1:return p.spectrogram=(d.data=D.sent(),d.frameSize=this.nonBatchInputShape[1],d),e.includeRawAudio?(m={},[4,r.data()]):[3,3];case 2:return m.data=D.sent(),m.sampleRateHz=this.audioDataExtractor.sampleRateHz,f=m,[3,4];case 3:f=void 0,D.label=4;case 4:return o.apply(a,[(p.rawAudio=f,p)]),i.dispose(),[4,this.audioDataExtractor.stop()];case 5:return D.sent(),this.streaming=!1,this.collateTransferWords(),g=s,y={},[4,n.data()];case 6:return g.apply(void 0,[(y.data=D.sent(),y.frameSize=this.nonBatchInputShape[1],y)]),[3,13];case 7:return[4,n.data()];case 8:for(b=D.sent(),-1===h&&(h=b.length),w=h-1;0!==b[w]&&w>=0;)w--;return v=h-w-1,h=w+1,k=b.slice(b.length-v,b.length),c.push(k),null!=e.onSnippet&&e.onSnippet({data:k,frameSize:this.nonBatchInputShape[1]}),u++!==l?[3,13]:[4,this.audioDataExtractor.stop()];case 9:return D.sent(),this.streaming=!1,this.collateTransferWords(),x=qc(Wp(c)),S={data:x,frameSize:this.nonBatchInputShape[1]},N=(I=this.dataset).addExample,E={label:t,spectrogram:S},e.includeRawAudio?(T={},[4,r.data()]):[3,11];case 10:return T.data=D.sent(),T.sampleRateHz=this.audioDataExtractor.sampleRateHz,A=T,[3,12];case 11:A=void 0,D.label=12;case 12:N.apply(I,[(E.rawAudio=A,E)]),s(S),D.label=13;case 13:return[2,!1]}}))}))},overlapFactor:i,includeRawAudio:e.includeRawAudio}),o.audioDataExtractor.start(e.audioTrackConstraints)}))]}))}))},e.prototype.clearExamples=function(){var t=this;r(null!=this.words&&this.words.length>0&&!this.dataset.empty(),(function(){return"No transfer learning examples exist for model name "+t.name})),this.dataset.clear(),this.words=null},e.prototype.countExamples=function(){if(this.dataset.empty())throw new Error("No examples have been collected for transfer-learning model named '"+this.name+"' yet.");return this.dataset.getExampleCounts()},e.prototype.getExamples=function(t){return this.dataset.getExamples(t)},e.prototype.setExampleKeyFrameIndex=function(t,e){this.dataset.setExampleKeyFrameIndex(t,e)},e.prototype.removeExample=function(t){this.dataset.removeExample(t),this.collateTransferWords()},e.prototype.isDatasetEmpty=function(){return this.dataset.empty()},e.prototype.loadExamples=function(t,e){var n,s,r,i;void 0===e&&(e=!1);var a=new Vp(t);e&&this.clearExamples();var o=a.getVocabulary();try{for(var l=ai(o),u=l.next();!u.done;u=l.next()){var h=u.value,c=a.getExamples(h);try{for(var p=(r=void 0,ai(c)),d=p.next();!d.done;d=p.next()){var f=d.value;this.dataset.addExample(f.example)}}catch(t){r={error:t}}finally{try{d&&!d.done&&(i=p.return)&&i.call(p)}finally{if(r)throw r.error}}}}catch(t){n={error:t}}finally{try{u&&!u.done&&(s=l.return)&&s.call(l)}finally{if(n)throw n.error}}this.collateTransferWords()},e.prototype.serializeExamples=function(t){return this.dataset.serialize(t)},e.prototype.collateTransferWords=function(){this.words=this.dataset.getVocabulary()},e.prototype.collectTransferDataAsTensors=function(t,e){var n=this.nonBatchInputShape[0];t=t||.25;var s=Math.round(t*n),r=this.dataset.getData(null,si({numFrames:n,hopFrames:s},e));return{xs:r.xs,ys:r.ys}},e.prototype.collectTransferDataAsTfDataset=function(t,e,n,s){void 0===e&&(e=.15),void 0===n&&(n=32);var r=this.nonBatchInputShape[0];t=t||.25;var i=Math.round(t*r);return this.dataset.getData(null,si({numFrames:r,hopFrames:i,getDataset:!0,datasetBatchSize:n,datasetValidationSplit:e},s))},e.prototype.train=function(t){return ri(this,void 0,void 0,(function(){var e,n=this;return ii(this,(function(s){return r(null!=this.words&&this.words.length>0,(function(){return"Cannot train transfer-learning model '"+n.name+"' because no transfer learning example has been collected."})),r(this.words.length>1,(function(){return"Cannot train transfer-learning model '"+n.name+"' because only 1 word label ('"+JSON.stringify(n.words)+"') has been collected for transfer learning. Requires at least 2."})),null!=t.fineTuningEpochs&&r(t.fineTuningEpochs>=0&&Number.isInteger(t.fineTuningEpochs),(function(){return"If specified, fineTuningEpochs must be a non-negative integer, but received "+t.fineTuningEpochs})),null==t&&(t={}),null==this.model&&this.createTransferModelFromBaseModel(),this.secondLastBaseDenseLayer.trainable=!1,this.model.compile({loss:"categoricalCrossentropy",optimizer:t.optimizer||"sgd",metrics:["acc"]}),e=null==t.fitDatasetDurationMillisThreshold?6e4:t.fitDatasetDurationMillisThreshold,this.dataset.durationMillis()>e?(console.log("Detected large dataset: total duration = "+this.dataset.durationMillis()+" ms > "+e+" ms. Training transfer model using fitDataset() instead of fit()"),[2,this.trainOnDataset(t)]):[2,this.trainOnTensors(t)]}))}))},e.prototype.trainOnDataset=function(t){return ri(this,void 0,void 0,(function(){var e,n,s,i,a,o,l,u,h;return ii(this,(function(c){switch(c.label){case 0:return r(t.epochs>0,(function(){return"Invalid config.epochs"})),e=null==t.batchSize?32:t.batchSize,n=t.windowHopRatio||.25,s=oi(this.collectTransferDataAsTfDataset(n,t.validationSplit,e,{augmentByMixingNoiseRatio:t.augmentByMixingNoiseRatio}),2),i=s[0],a=s[1],o=$(),[4,this.model.fitDataset(i,{epochs:t.epochs,validationData:t.validationSplit>0?a:null,callbacks:null==t.callback?null:[t.callback]})];case 1:return l=c.sent(),console.log("fitDataset() took "+($()-o).toFixed(2)+" ms"),null!=t.fineTuningEpochs&&t.fineTuningEpochs>0?(u=$(),[4,this.fineTuningUsingTfDatasets(t,i,a)]):[3,3];case 2:return h=c.sent(),console.log("fitDataset() (fine-tuning) took "+($()-u).toFixed(2)+" ms"),[2,[l,h]];case 3:return[2,l]}}))}))},e.prototype.trainOnTensors=function(t){return ri(this,void 0,void 0,(function(){var e,n,i,a,o,l,u,h,c,p;return ii(this,(function(d){switch(d.label){case 0:e=t.windowHopRatio||.25,n=this.collectTransferDataAsTensors(e,{augmentByMixingNoiseRatio:t.augmentByMixingNoiseRatio}),i=n.xs,a=n.ys,console.log("Training data: xs.shape = "+i.shape+", ys.shape = "+a.shape),d.label=1;case 1:return d.trys.push([1,,6,7]),null!=t.validationSplit?(h=function(t,e,n){return r(n>0&&n<1,(function(){return"validationSplit is expected to be >0 and <1, but got "+n})),be((function(){for(var r=Ce(e,-1).dataSync(),i=[],a=0;a<r.length;++a){var o=r[a];null==i[o]&&(i[o]=[]),i[o].push(a)}var l=i.length,u=[],h=[];i.map((function(t){return s(t)}));for(a=0;a<l;++a)for(var c=i[a],p=Math.round(c.length*(1-n)),d=0;d<c.length;++d)d<p?u.push(c[d]):h.push(c[d]);return{trainXs:On(t,u),trainYs:On(e,u),valXs:On(t,h),valYs:On(e,h)}}))}(i,a,t.validationSplit),o=h.trainXs,l=h.trainYs,u=[h.valXs,h.valYs]):(o=i,l=a),[4,this.model.fit(o,l,{epochs:null==t.epochs?20:t.epochs,validationData:u,batchSize:t.batchSize,callbacks:null==t.callback?null:[t.callback]})];case 2:return c=d.sent(),null!=t.fineTuningEpochs&&t.fineTuningEpochs>0?[4,this.fineTuningUsingTensors(t,o,l,u)]:[3,4];case 3:return p=d.sent(),[2,[c,p]];case 4:return[2,c];case 5:return[3,7];case 6:return we([i,a,o,l,u]),[7];case 7:return[2]}}))}))},e.prototype.fineTuningUsingTfDatasets=function(t,e,n){return ri(this,void 0,void 0,(function(){var s,r,i;return ii(this,(function(a){switch(a.label){case 0:return s=this.secondLastBaseDenseLayer.trainable,this.secondLastBaseDenseLayer.trainable=!0,r=null==t.fineTuningOptimizer?"sgd":t.fineTuningOptimizer,this.model.compile({loss:"categoricalCrossentropy",optimizer:r,metrics:["acc"]}),[4,this.model.fitDataset(e,{epochs:t.fineTuningEpochs,validationData:n,callbacks:null==t.callback?null:[t.callback]})];case 1:return i=a.sent(),this.secondLastBaseDenseLayer.trainable=s,[2,i]}}))}))},e.prototype.fineTuningUsingTensors=function(t,e,n,s){return ri(this,void 0,void 0,(function(){var r,i,a;return ii(this,(function(o){switch(o.label){case 0:return r=this.secondLastBaseDenseLayer.trainable,this.secondLastBaseDenseLayer.trainable=!0,i=null==t.fineTuningOptimizer?"sgd":t.fineTuningOptimizer,this.model.compile({loss:"categoricalCrossentropy",optimizer:i,metrics:["acc"]}),[4,this.model.fit(e,n,{epochs:t.fineTuningEpochs,validationData:s,batchSize:t.batchSize,callbacks:null==t.fineTuningCallback?null:[t.fineTuningCallback]})];case 1:return a=o.sent(),this.secondLastBaseDenseLayer.trainable=r,[2,a]}}))}))},e.prototype.evaluate=function(t){return ri(this,void 0,void 0,(function(){var e=this;return ii(this,(function(n){return r(null!=t.wordProbThresholds&&t.wordProbThresholds.length>0,(function(){return"Received null or empty wordProbThresholds"})),0,r("_background_noise_"===this.words[0],(function(){return"Cannot perform evaluation when the first tag is not _background_noise_"})),[2,be((function(){for(var n=[],s=0,r=e.collectTransferDataAsTensors(t.windowHopRatio),i=r.xs,a=r.ys.argMax(-1).dataSync(),o=e.model.predict(i),l=es(Je(o,[0,1],[o.shape[0],o.shape[1]-1]),-1),u=o.shape[0],h=0;h<t.wordProbThresholds.length;++h){for(var c=t.wordProbThresholds[h],p=l.greater(Qs(c)).dataSync(),d=0,f=0,m=0,g=0,y=0;y<u;++y)0===a[y]?(d++,p[y]&&m++):(f++,p[y]&&g++);var b=m/d,w=g/f;n.push({probThreshold:c,fpr:b,tpr:w}),console.log("ROC thresh="+c+": fpr="+b.toFixed(4)+", tpr="+w.toFixed(4)),h>0&&(s+=Math.abs(n[h-1].fpr-n[h].fpr)*(n[h-1].tpr+n[h].tpr)/2)}return{rocCurve:n,auc:s}}))]}))}))},e.prototype.createTransferModelFromBaseModel=function(){var t=this;r(null!=this.words,(function(){return"No word example is available for tranfer-learning model of name "+t.name}));for(var e=this.baseModel.layers,n=e.length-2;n>=0&&"dense"!==e[n].getClassName().toLowerCase();)n--;if(n<0)throw new Error("Cannot find a hidden dense layer in the base model.");this.secondLastBaseDenseLayer=e[n];var s,i,a=this.secondLastBaseDenseLayer.output;this.transferHead=new $u(s),this.transferHead.add((i={units:this.words.length,activation:"softmax",inputShape:a.shape.slice(1),name:"NewHeadDense"},new Zh(i)));var o=this.transferHead.apply(a);this.model=Ou({inputs:this.baseModel.inputs,outputs:o})},e.prototype.modelInputShape=function(){return this.baseModel.inputs[0].shape},e.prototype.getMetadata=function(){return{tfjsSpeechCommandsVersion:"0.5.1",modelName:this.name,timeStamp:(new Date).toISOString(),wordLabels:this.wordLabels()}},e.prototype.save=function(t){return ri(this,void 0,void 0,(function(){var e,n,s;return ii(this,(function(r){return e=null!=t,t=t||id(this.name),e||(n=nd.localStorage.getItem(td),(s=null==n?{}:JSON.parse(n))[this.name]=this.getMetadata(),nd.localStorage.setItem(td,JSON.stringify(s))),console.log("Saving model to "+t),[2,this.model.save(t)]}))}))},e.prototype.load=function(t){return ri(this,void 0,void 0,(function(){var e,n,s;return ii(this,(function(r){switch(r.label){case 0:if(e=null!=t,t=t||id(this.name),!e){if(null==(n=JSON.parse(nd.localStorage.getItem(td)))||null==n[this.name])throw new Error("Cannot find metadata for transfer model named "+this.name+'"');this.words=n[this.name].wordLabels,console.log("Loaded word list for model named "+this.name+": "+this.words)}return s=this,[4,Bu(t)];case 1:return s.model=r.sent(),console.log("Loaded model from "+t+":"),this.model.summary(),[2]}}))}))},e.prototype.createTransfer=function(t){throw new Error("Creating transfer-learned recognizer from a transfer-learned recognizer is not supported.")},e}(sd);function id(t){return""+ed+t}function ad(){return ri(this,void 0,void 0,(function(){var t,e,n;return ii(this,(function(s){switch(s.label){case 0:return[4,Gt()];case 1:for(n in t=s.sent(),e=[],t)n.startsWith(ed)&&e.push(n.slice(ed.length));return[2,e]}}))}))}function od(t){return ri(this,void 0,void 0,(function(){var e;return ii(this,(function(n){switch(n.label){case 0:return null==(e=JSON.parse(nd.localStorage.getItem(td)))&&(e={}),null!=e[t]&&delete e[t],nd.localStorage.setItem(td,JSON.stringify(e)),[4,Jt(id(t))];case 1:return n.sent(),[2]}}))}))}function ld(t,e,n,s){if(r(null==n&&null==s||null!=n&&null!=s,(function(){return"customModelURL and customMetadataURL must be both provided or both not provided."})),null!=n&&r(null==e,(function(){return"vocabulary name must be null or undefined when modelURL is provided."})),"BROWSER_FFT"===t)return new sd(e,n,s);throw"SOFT_FFT"===t?new Error("SOFT_FFT SpeechCommandRecognizer has not been implemented yet."):new Error("Invalid fftType: '"+t+"'")}var ud={concatenateFloat32Arrays:Wp,normalizeFloat32Array:qc,normalize:jc,playRawAudio:function(t,e){var n=new(window.AudioContext||window.webkitAudioContext),s=n.createBuffer(1,t.data.length,t.sampleRateHz);s.getChannelData(0).set(t.data);var r=n.createBufferSource();r.buffer=s,r.connect(n.destination),r.start(),r.onended=function(){null!=e&&e()}}};export{Kp as BACKGROUND_NOISE_TAG,Vp as Dataset,Qp as UNKNOWN_TAG,ld as create,od as deleteSavedTransferModel,Xp as getMaxIntensityFrameIndex,ad as listSavedTransferModels,Zp as spectrogram2IntensityCurve,ud as utils,Yp as version};
//# sourceMappingURL=speech-commands.esm.js.map
