/**
    * @license
    * Copyright 2021 Google LLC. All Rights Reserved.
    * Licensed under the Apache License, Version 2.0 (the "License");
    * you may not use this file except in compliance with the License.
    * You may obtain a copy of the License at
    *
    * http://www.apache.org/licenses/LICENSE-2.0
    *
    * Unless required by applicable law or agreed to in writing, software
    * distributed under the License is distributed on an "AS IS" BASIS,
    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    * See the License for the specific language governing permissions and
    * limitations under the License.
    * =============================================================================
    */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports,require("util"),require("buffer"),require("fs")):"function"==typeof define&&define.amd?define(["exports","util","buffer","fs"],e):e((t=t||self).speechCommands={},t.util,t.buffer$1,t.fs)}(this,(function(t,e,n,s){"use strict";n=n&&Object.prototype.hasOwnProperty.call(n,"default")?n.default:n,s=s&&Object.prototype.hasOwnProperty.call(s,"default")?s.default:s;function r(t){throw new Error(`'${t}' not yet implemented or not found in the registry. This kernel may not be supported by the tfjs backend you have chosen`)}function i(t){let e=t.length,n=0,s=0;for(;e>0;)s=Math.random()*e|0,e--,n=t[e],t[e]=t[s],t[s]=n}function a(t,e){if(!t)throw new Error("string"==typeof e?e:e())}function o(t,e,n=""){a(c(t,e),()=>n+` Shapes ${t} and ${e} must match`)}function l(t){a(null!=t,()=>"The input to the tensor constructor must be a non-null value.")}function u(t,e=[],n=!1){if(null==e&&(e=[]),Array.isArray(t)||m(t)&&!n)for(let s=0;s<t.length;++s)u(t[s],e,n);else e.push(t);return e}function h(t){if(0===t.length)return 1;let e=t[0];for(let n=1;n<t.length;n++)e*=t[n];return e}function c(t,e){if(t===e)return!0;if(null==t||null==e)return!1;if(t.length!==e.length)return!1;for(let n=0;n<t.length;n++)if(t[n]!==e[n])return!1;return!0}function p(t){return t%1==0}function d(t,e){return e<=t.length?t:t+" ".repeat(e-t.length)}function f(t,e){const n=e.length;return a((t=null==t?e.map((t,e)=>e):[].concat(t)).every(t=>t>=-n&&t<n),()=>`All values in axis param must be in range [-${n}, ${n}) but got axis `+t),a(t.every(t=>p(t)),()=>"All values in axis param must be integers but got axis "+t),t.map(t=>t<0?n+t:t)}function m(t){return t instanceof Float32Array||t instanceof Int32Array||t instanceof Uint8Array}function g(t){return"string"==typeof t||t instanceof String}function y(t){return"number"==typeof t}function b(t){return Array.isArray(t)?b(t[0]):t instanceof Float32Array?"float32":t instanceof Int32Array||t instanceof Uint8Array?"int32":y(t)?"float32":g(t)?"string":"boolean"==typeof t?"bool":"float32"}function w(t){return!!(t&&t.constructor&&t.call&&t.apply)}function v(t){const e=t.length;if(e<2)return[];const n=new Array(e-1);n[e-2]=t[e-1];for(let s=e-3;s>=0;--s)n[s]=n[s+1]*t[s+1];return n}function k(t,e){if(0===t.length)return e[0];const n=t.reduce((t,e)=>t*e);if(0===n)return[];if(n!==e.length)throw new Error(`[${t}] does not match the input size ${e.length}.`);return function t(e,n,s){const r=new Array;if(1===n.length){const t=n[0];for(let n=0;n<t;n++)r[n]=s[e+n]}else{const i=n[0],a=n.slice(1),o=a.reduce((t,e)=>t*e);for(let n=0;n<i;n++)r[n]=t(e+n*o,a,s)}return r}(0,t,e)}function x(t,e){const n=S(t,e);for(let t=0;t<n.length;t++)n[t]=1;return n}function S(t,e){if(null==e||"float32"===e||"complex64"===e)return new Float32Array(t);if("int32"===e)return new Int32Array(t);if("bool"===e)return new Uint8Array(t);throw new Error("Unknown data type "+e)}function I(t){t.forEach(e=>{a(Number.isInteger(e)&&e>=0,()=>`Tensor must have a shape comprised of positive integers but got shape [${t}].`)})}function N(t){return t&&t.then&&"function"==typeof t.then}class A{constructor(t){this.global=t,this.flags={},this.flagRegistry={},this.urlFlags={},this.populateURLFlags()}setPlatform(t,e){null!=this.platform&&console.warn(`Platform ${this.platformName} has already been set. Overwriting the platform with ${e}.`),this.platformName=t,this.platform=e}registerFlag(t,e,n){if(this.flagRegistry[t]={evaluationFn:e,setHook:n},null!=this.urlFlags[t]){const e=this.urlFlags[t];console.warn(`Setting feature override from URL ${t}: ${e}.`),this.set(t,e)}}async getAsync(t){return t in this.flags||(this.flags[t]=await this.evaluateFlag(t)),this.flags[t]}get(t){if(t in this.flags)return this.flags[t];const e=this.evaluateFlag(t);if(N(e))throw new Error(`Flag ${t} cannot be synchronously evaluated. Please use getAsync() instead.`);return this.flags[t]=e,this.flags[t]}getNumber(t){return this.get(t)}getBool(t){return this.get(t)}getFlags(){return this.flags}get features(){return this.flags}set(t,e){if(null==this.flagRegistry[t])throw new Error(`Cannot set flag ${t} as it has not been registered.`);this.flags[t]=e,null!=this.flagRegistry[t].setHook&&this.flagRegistry[t].setHook(e)}evaluateFlag(t){if(null==this.flagRegistry[t])throw new Error(`Cannot evaluate flag '${t}': no evaluation function found.`);return this.flagRegistry[t].evaluationFn()}setFlags(t){this.flags=Object.assign({},t)}reset(){this.flags={},this.urlFlags={},this.populateURLFlags()}populateURLFlags(){if(void 0===this.global||void 0===this.global.location||void 0===this.global.location.search)return;const t=function(t){const e={};return t.replace(/[?&]([^=?&]+)(?:=([^&]*))?/g,(t,...n)=>(function(t,e,n){t[decodeURIComponent(e)]=decodeURIComponent(n||"")}(e,n[0],n[1]),n.join("="))),e}(this.global.location.search);if("tfjsflags"in t){t.tfjsflags.split(",").forEach(t=>{const[e,n]=t.split(":");this.urlFlags[e]=function(t,e){if("true"===(e=e.toLowerCase())||"false"===e)return"true"===e;if(""+ +e===e)return+e;throw new Error(`Could not parse value flag value ${e} for flag ${t}.`)}(e,n)})}}}function E(){return D}let T,D=null;function z(){if(null==T){let t;if("undefined"!=typeof window)t=window;else if("undefined"!=typeof global)t=global;else if("undefined"!=typeof process)t=process;else{if("undefined"==typeof self)throw new Error("Could not find a global object");t=self}T=t}return T}function C(t,e){const n=function(){const t=z();return null==t._tfGlobals&&(t._tfGlobals=new Map),t._tfGlobals}();if(n.has(t))return n.get(t);{const s=e();return n.set(t,s),n.get(t)}}const F=C("kernelRegistry",()=>new Map),R=C("gradRegistry",()=>new Map);function M(t,e){const n=function(t,e){return`${e}_${t}`}(t,e);return F.get(n)}function L(t){return R.get(t)}function _(t){const e=F.entries(),n=[];for(;;){const{done:s,value:r}=e.next();if(s)break;const[i,a]=r,[o]=i.split("_");o===t&&n.push(a)}return n}function $(t){const{kernelName:e}=t;R.has(e)&&E().getBool("DEBUG")&&console.warn(`Overriding the gradient for '${e}'`),R.set(e,t)}function O(t,e){if("string"===e)throw new Error("Cannot convert a string[] to a TypedArray");if(Array.isArray(t)&&(t=u(t)),E().getBool("DEBUG")&&function(t,e){for(let n=0;n<t.length;n++){const s=t[n];if(isNaN(s)||!isFinite(s))throw Error(`A tensor of type ${e} being uploaded contains ${s}.`)}}(t,e),function(t,e){return t instanceof Float32Array&&"float32"===e||t instanceof Int32Array&&"int32"===e||t instanceof Uint8Array&&"bool"===e}(t,e))return t;if(null==e||"float32"===e||"complex64"===e)return new Float32Array(t);if("int32"===e)return new Int32Array(t);if("bool"===e){const e=new Uint8Array(t.length);for(let n=0;n<e.length;++n)0!==Math.round(t[n])&&(e[n]=1);return e}throw new Error("Unknown data type "+e)}function B(){return E().platform.now()}function P(t,e="utf-8"){return e=e||"utf-8",E().platform.decode(t,e)}class U{constructor(t,e){this.backendTimer=t,this.logger=e,null==e&&(this.logger=new j)}profileKernel(t,e,n){let s;const r=this.backendTimer.time(()=>{s=n()});if(E().getBool("CHECK_COMPUTATION_FOR_ERRORS"))for(let e=0;e<s.length;e++){const n=s[e];n.data().then(e=>{W(e,n.dtype,t)})}return{kernelName:t,outputs:s,inputs:e,timeMs:r.then(t=>t.kernelMs),extraInfo:r.then(t=>null!=t.getExtraProfileInfo?t.getExtraProfileInfo():"")}}logKernelProfile(t){const{kernelName:e,outputs:n,timeMs:s,inputs:r,extraInfo:i}=t;n.forEach(t=>{Promise.all([t.data(),s,i]).then(n=>{this.logger.logKernelProfile(e,t,n[0],n[1],r,n[2])})})}}function W(t,e,n){if("float32"!==e)return!1;for(let e=0;e<t.length;e++){const s=t[e];if(isNaN(s)||!isFinite(s))return console.warn(`Found ${s} in the result of '${n}'`),!0}return!1}class j{logKernelProfile(t,e,n,s,r,i){const a="number"==typeof s?d(s+"ms",9):s.error,o=d(t,25),l=e.rank,u=e.size,h=d(e.shape.toString(),14);let c="";for(const t in r){const n=r[t];if(null!=n){const s=n.shape||e.shape,r=s.length;c+=`${t}: ${r}D ${r>0?s:""} `}}console.log(`%c${o}\t%c${a}\t%c${l}D ${h}\t%c${u}\t%c${c}\t%c${i}`,"font-weight:bold","color:red","color:blue","color: orange","color: green","color: steelblue")}}function q(t,e,n,s){const r=v(e),i=function(t,e,n,s){const r=h(e),i=s[s.length-1],a=new Array(i).fill(0),o=e.length,l="complex64"===n?H(t):t;if(o>1)for(let t=0;t<r/i;t++){const e=t*i;for(let t=0;t<i;t++)a[t]=Math.max(a[t],K(l[e+t],0,n).length)}return a}(t,e,n,r),a=e.length,o=function t(e,n,s,r,i,a=!0){const o="complex64"===s?2:1,l=n[0],u=n.length;if(0===u){if("complex64"===s){return[K(H(e)[0],0,s)]}return"bool"===s?[V(e[0])]:[e[0].toString()]}if(1===u){if(l>20){const t=3*o;let n=Array.from(e.slice(0,t)),r=Array.from(e.slice((l-3)*o,l*o));return"complex64"===s&&(n=H(n),r=H(r)),["["+n.map((t,e)=>K(t,i[e],s)).join(", ")+", ..., "+r.map((t,e)=>K(t,i[l-3+e],s)).join(", ")+"]"]}return["["+("complex64"===s?H(e):Array.from(e)).map((t,e)=>K(t,i[e],s)).join(", ")+"]"]}const h=n.slice(1),c=r.slice(1),p=r[0]*o,d=[];if(l>20){for(let n=0;n<3;n++){const r=n*p,a=r+p;d.push(...t(e.slice(r,a),h,s,c,i,!1))}d.push("...");for(let n=l-3;n<l;n++){const r=n*p,a=r+p;d.push(...t(e.slice(r,a),h,s,c,i,n===l-1))}}else for(let n=0;n<l;n++){const r=n*p,a=r+p;d.push(...t(e.slice(r,a),h,s,c,i,n===l-1))}const f=2===u?",":"";d[0]="["+d[0]+f;for(let t=1;t<d.length-1;t++)d[t]=" "+d[t]+f;let m=",\n";for(let t=2;t<u;t++)m+="\n";return d[d.length-1]=" "+d[d.length-1]+"]"+(a?"":m),d}(t,e,n,r,i),l=["Tensor"];return s&&(l.push("  dtype: "+n),l.push("  rank: "+a),l.push(`  shape: [${e}]`),l.push("  values:")),l.push(o.map(t=>"    "+t).join("\n")),l.join("\n")}function K(t,e,n){let s;return s=Array.isArray(t)?parseFloat(t[0].toFixed(7))+" + "+parseFloat(t[1].toFixed(7))+"j":g(t)?`'${t}'`:"bool"===n?V(t):parseFloat(t.toFixed(7)).toString(),d(s,e)}function V(t){return 0===t?"false":"true"}function H(t){const e=[];for(let n=0;n<t.length;n+=2)e.push([t[n],t[n+1]]);return e}class G{constructor(t,e,n){if(this.dtype=e,this.shape=t.slice(),this.size=h(t),null!=n){const t=n.length;a(t===this.size,()=>`Length of values '${t}' does not match the size inferred by the shape '${this.size}'.`)}if("complex64"===e)throw new Error("complex64 dtype TensorBuffers are not supported. Please create a TensorBuffer for the real and imaginary parts separately and call tf.complex(real, imag).");this.values=n||function(t,e){let n=null;if(null==t||"float32"===t)n=new Float32Array(e);else if("int32"===t)n=new Int32Array(e);else if("bool"===t)n=new Uint8Array(e);else{if("string"!==t)throw new Error("Unknown data type "+t);n=new Array(e)}return n}(e,this.size),this.strides=v(t)}set(t,...e){0===e.length&&(e=[0]),a(e.length===this.rank,()=>`The number of provided coordinates (${e.length}) must match the rank (${this.rank})`);const n=this.locToIndex(e);this.values[n]=t}get(...t){0===t.length&&(t=[0]);let e=0;for(const n of t){if(n<0||n>=this.shape[e]){const e=`Requested out of range element at ${t}.   Buffer shape=`+this.shape;throw new Error(e)}e++}let n=t[t.length-1];for(let e=0;e<t.length-1;++e)n+=this.strides[e]*t[e];return this.values[n]}locToIndex(t){if(0===this.rank)return 0;if(1===this.rank)return t[0];let e=t[t.length-1];for(let n=0;n<t.length-1;++n)e+=this.strides[n]*t[n];return e}indexToLoc(t){if(0===this.rank)return[];if(1===this.rank)return[t];const e=new Array(this.shape.length);for(let n=0;n<e.length-1;++n)e[n]=Math.floor(t/this.strides[n]),t-=e[n]*this.strides[n];return e[e.length-1]=t,e}get rank(){return this.shape.length}toTensor(){return J().makeTensor(this.values,this.shape,this.dtype)}}let J=null,Z=null;class X{constructor(t,e,n,s){this.kept=!1,this.isDisposedInternal=!1,this.shape=t.slice(),this.dtype=e||"float32",this.size=h(t),this.strides=v(t),this.dataId=n,this.id=s,this.rankType=this.rank<5?this.rank.toString():"higher"}get rank(){return this.shape.length}async buffer(){const t=await this.data();return Z.buffer(this.shape,this.dtype,t)}bufferSync(){return Z.buffer(this.shape,this.dtype,this.dataSync())}async array(){const t=await this.data();return k(this.shape,t)}arraySync(){return k(this.shape,this.dataSync())}async data(){this.throwIfDisposed();const t=J().read(this.dataId);if("string"===this.dtype){const e=await t;try{return e.map(t=>P(t))}catch(t){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}}return t}dataSync(){this.throwIfDisposed();const t=J().readSync(this.dataId);if("string"===this.dtype)try{return t.map(t=>P(t))}catch(t){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}return t}async bytes(){this.throwIfDisposed();const t=await J().read(this.dataId);return"string"===this.dtype?t:new Uint8Array(t.buffer)}dispose(){this.isDisposed||(J().disposeTensor(this),this.isDisposedInternal=!0)}get isDisposed(){return this.isDisposedInternal}throwIfDisposed(){if(this.isDisposed)throw new Error("Tensor is disposed.")}print(t=!1){return Z.print(this,t)}clone(){return this.throwIfDisposed(),Z.clone(this)}toString(t=!1){return q(this.dataSync(),this.shape,this.dtype,t)}cast(t){return this.throwIfDisposed(),Z.cast(this,t)}variable(t=!0,e,n){return this.throwIfDisposed(),J().makeVariable(this,t,e,n)}}function Y(){return C("Tensor",()=>X)}Object.defineProperty(X,Symbol.hasInstance,{value:t=>!!t&&null!=t.data&&null!=t.dataSync&&null!=t.throwIfDisposed}),Y();class Q extends X{constructor(t,e,n,s){super(t.shape,t.dtype,t.dataId,s),this.trainable=e,this.name=n}assign(t){if(t.dtype!==this.dtype)throw new Error(`dtype of the new value (${t.dtype}) and previous value (${this.dtype}) must match`);if(!c(t.shape,this.shape))throw new Error(`shape of the new value (${t.shape}) and previous value (${this.shape}) must match`);J().disposeTensor(this),this.dataId=t.dataId,J().incRef(this,null)}dispose(){J().disposeVariable(this),this.isDisposedInternal=!0}}var tt,et,nt,st,rt;Object.defineProperty(Q,Symbol.hasInstance,{value:t=>t instanceof X&&null!=t.assign&&t.assign instanceof Function}),function(t){t.R0="R0",t.R1="R1",t.R2="R2",t.R3="R3",t.R4="R4",t.R5="R5",t.R6="R6"}(tt||(tt={})),function(t){t.float32="float32",t.int32="int32",t.bool="int32",t.complex64="complex64"}(et||(et={})),function(t){t.float32="float32",t.int32="int32",t.bool="bool",t.complex64="complex64"}(nt||(nt={})),function(t){t.float32="float32",t.int32="float32",t.bool="float32",t.complex64="complex64"}(st||(st={})),function(t){t.float32="complex64",t.int32="complex64",t.bool="complex64",t.complex64="complex64"}(rt||(rt={}));const it={float32:st,int32:et,bool:nt,complex64:rt};function at(t,e){if(t.dtype===e.dtype)return[t,e];const n=function(t,e){if("string"===t||"string"===e){if("string"===t&&"string"===e)return"string";throw new Error(`Can not upcast ${t} with ${e}`)}return it[t][e]}(t.dtype,e.dtype);return[t.cast(n),e.cast(n)]}function ot(t,e){return e.some(e=>e.id===t.id)}function lt(t){const e=[];return function t(e,n,s){if(null==e)return;if(e instanceof X)return void n.push(e);if(r=e,!Array.isArray(r)&&"object"!=typeof r)return;var r;const i=e;for(const e in i){const r=i[e];s.has(r)||(s.add(r),t(r,n,s))}}(t,e,new Set),e}function ut(t){return null!=t.kernelName}class ht{constructor(){this.registeredVariables={},this.nextTapeNodeId=0,this.numBytes=0,this.numTensors=0,this.numStringTensors=0,this.numDataBuffers=0,this.gradientDepth=0,this.kernelDepth=0,this.scopeStack=[],this.numDataMovesStack=[],this.nextScopeId=0,this.tensorInfo=new WeakMap,this.profiling=!1,this.activeProfile={newBytes:0,newTensors:0,peakBytes:0,kernels:[],result:null,get kernelNames(){return Array.from(new Set(this.kernels.map(t=>t.name)))}}}dispose(){for(const t in this.registeredVariables)this.registeredVariables[t].dispose()}}class ct{constructor(t){this.ENV=t,this.registry={},this.registryFactory={},this.pendingBackendInitId=0,this.state=new ht}async ready(){if(null!=this.pendingBackendInit)return this.pendingBackendInit.then(()=>{});if(null!=this.backendInstance)return;const t=this.getSortedBackends();for(let e=0;e<t.length;e++){const n=t[e];if(await this.initializeBackend(n).success)return void await this.setBackend(n)}throw new Error("Could not initialize any backends, all backend initializations failed.")}get backend(){if(null!=this.pendingBackendInit)throw new Error(`Backend '${this.backendName}' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods`);if(null==this.backendInstance){const{name:t,asyncInit:e}=this.initializeBackendsAndReturnBest();if(e)throw new Error(`The highest priority backend '${t}' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods`);this.setBackend(t)}return this.backendInstance}backendNames(){return Object.keys(this.registryFactory)}findBackend(t){if(!(t in this.registry)){if(!(t in this.registryFactory))return null;{const{asyncInit:e}=this.initializeBackend(t);if(e)return null}}return this.registry[t]}findBackendFactory(t){return t in this.registryFactory?this.registryFactory[t].factory:null}registerBackend(t,e,n=1){return t in this.registryFactory?(console.warn(t+" backend was already registered. Reusing existing backend factory."),!1):(this.registryFactory[t]={factory:e,priority:n},!0)}async setBackend(t){if(null==this.registryFactory[t])throw new Error(`Backend name '${t}' not found in registry`);if(this.backendName=t,null==this.registry[t]){this.backendInstance=null;const{success:e,asyncInit:n}=this.initializeBackend(t);if(!(n?await e:e))return!1}return this.backendInstance=this.registry[t],this.setupRegisteredKernels(),this.profiler=new U(this.backendInstance),!0}setupRegisteredKernels(){_(this.backendName).forEach(t=>{null!=t.setupFunc&&t.setupFunc(this.backendInstance)})}disposeRegisteredKernels(t){_(t).forEach(e=>{null!=e.disposeFunc&&e.disposeFunc(this.registry[t])})}initializeBackend(t){const e=this.registryFactory[t];if(null==e)throw new Error(`Cannot initialize backend ${t}, no registration found.`);try{const n=e.factory();if(!n||n instanceof class{decComplexRef(t){}time(t){return r("time")}read(t){return r("read")}readSync(t){return r("readSync")}numDataIds(){return r("numDataIds")}disposeData(t){return r("disposeData")}write(t,e,n){return r("write")}move(t,e,n,s){return r("move")}memory(){return r("memory")}floatPrecision(){return r("floatPrecision")}epsilon(){return 32===this.floatPrecision()?1e-7:1e-4}dispose(){return r("dispose")}}||"function"!=typeof n.then)return this.registry[t]=n,{success:!0,asyncInit:!1};{const e=++this.pendingBackendInitId,s=n.then(n=>!(e<this.pendingBackendInitId)&&(this.registry[t]=n,this.pendingBackendInit=null,!0)).catch(n=>(e<this.pendingBackendInitId||(this.pendingBackendInit=null,console.warn(`Initialization of backend ${t} failed`),console.warn(n.stack||n.message)),!1));return this.pendingBackendInit=s,{success:s,asyncInit:!0}}}catch(e){return console.warn(`Initialization of backend ${t} failed`),console.warn(e.stack||e.message),{success:!1,asyncInit:!1}}}removeBackend(t){if(!(t in this.registryFactory))throw new Error(t+" backend not found in registry");this.backendName===t&&null!=this.pendingBackendInit&&this.pendingBackendInitId++,t in this.registry&&(this.disposeRegisteredKernels(t),this.registry[t].dispose(),delete this.registry[t]),delete this.registryFactory[t],this.backendName===t&&(this.pendingBackendInit=null,this.backendName=null,this.backendInstance=null)}getSortedBackends(){if(0===Object.keys(this.registryFactory).length)throw new Error("No backend found in registry.");return Object.keys(this.registryFactory).sort((t,e)=>this.registryFactory[e].priority-this.registryFactory[t].priority)}initializeBackendsAndReturnBest(){const t=this.getSortedBackends();for(let e=0;e<t.length;e++){const n=t[e],{success:s,asyncInit:r}=this.initializeBackend(n);if(r||s)return{name:n,asyncInit:r}}throw new Error("Could not initialize any backends, all backend initializations failed.")}moveData(t,e){const n=this.state.tensorInfo.get(e),s=n.backend,r=this.readSync(e);s.disposeData(e),n.backend=t,t.move(e,r,n.shape,n.dtype),this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack[this.state.numDataMovesStack.length-1]++}tidy(t,e){let n,s=null;if(null==e){if("function"!=typeof t)throw new Error("Please provide a function to tidy()");e=t}else{if("string"!=typeof t&&!(t instanceof String))throw new Error("When calling with two arguments, the first argument to tidy() must be a string");if("function"!=typeof e)throw new Error("When calling with two arguments, the 2nd argument to tidy() must be a function");s=t}return this.scopedRun(()=>this.startScope(s),()=>this.endScope(n),()=>(n=e(),n instanceof Promise&&console.error("Cannot return a Promise inside of tidy."),n))}scopedRun(t,e,n){t();try{const t=n();return e(),t}catch(t){throw e(),t}}nextTensorId(){return ct.nextTensorId++}nextVariableId(){return ct.nextVariableId++}clone(t){const e=this.makeTensorFromDataId(t.dataId,t.shape,t.dtype),n={x:t};return this.addTapeNode(this.state.activeScope.name,n,[e],t=>({x:()=>{const e={x:t},n={dtype:"float32"};return dt.runKernel("Cast",e,n)}}),[],{}),e}runKernel(t,e,n){if(!(null!=M(t,this.backendName)))throw new Error(`Kernel '${t}' not registered for backend '${this.backendName}'`);return this.runKernelFunc({kernelName:t,inputs:e,attrs:n})}shouldCheckForMemLeaks(){return this.ENV.getBool("IS_TEST")}checkKernelForMemLeak(t,e,n){const s=this.backend.numDataIds();let r=0;n.forEach(t=>{r+="complex64"===t.dtype?3:1});const i=this.state.numDataMovesStack[this.state.numDataMovesStack.length-1],a=s-e-r-i;if(a>0)throw new Error(`Backend '${this.backendName}' has an internal memory leak (${a} data ids) after running '${t}'`)}runKernelFunc(t){let e,n=[];const s=this.isTapeOn(),r=this.state.numBytes,i=this.state.numTensors;let o,l;this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack.push(0),null==this.backendName&&this.backend;const u=ut(t)?t.kernelName:null!=this.state.activeScope?this.state.activeScope.name:"";if(ut(t)){const{kernelName:e,inputs:r,attrs:i}=t;null==this.backendName&&this.backend;const u=M(e,this.backendName);a(null!=u,()=>`Cannot find registered kernel '${e}' for backend '${this.backendName}'`),o=()=>{const t=this.backend.numDataIds();l=u.kernelFunc({inputs:r,attrs:i,backend:this.backend});const a=Array.isArray(l)?l:[l];this.shouldCheckForMemLeaks()&&this.checkKernelForMemLeak(e,t,a);const o=a.map(t=>{if(null!=t.rank)return t;const{dataId:e,shape:n,dtype:s}=t;return this.makeTensorFromDataId(e,n,s)});if(s){const t=this.getTensorsForGradient(e,r,o);n=this.saveTensorsForBackwardMode(t)}return o}}else{const{forwardFunc:e}=t,r=t=>{s&&(n=t.map(t=>this.keep(this.clone(t))))};o=()=>{const t=this.backend.numDataIds();l=this.tidy(()=>e(this.backend,r));const n=Array.isArray(l)?l:[l];return this.shouldCheckForMemLeaks()&&this.checkKernelForMemLeak(u,t,n),n}}const{inputs:h,attrs:c}=t,p=ut(t)?null:t.backwardsFunc;let d;return this.scopedRun(()=>this.state.kernelDepth++,()=>this.state.kernelDepth--,()=>{this.ENV.getBool("DEBUG")||this.state.profiling?(d=this.profiler.profileKernel(u,h,()=>o()),this.ENV.getBool("DEBUG")&&this.profiler.logKernelProfile(d),e=d.outputs):e=o()}),s&&this.addTapeNode(u,h,e,p,n,c),this.state.profiling&&this.state.activeProfile.kernels.push({name:u,bytesAdded:this.state.numBytes-r,totalBytesSnapshot:this.state.numBytes,tensorsAdded:this.state.numTensors-i,totalTensorsSnapshot:this.state.numTensors,inputShapes:Object.keys(h).map(t=>null!=h[t]?h[t].shape:null),outputShapes:e.map(t=>t.shape),kernelTimeMs:d.timeMs,extraInfo:d.extraInfo}),Array.isArray(l)?e:e[0]}saveTensorsForBackwardMode(t){return t.map(t=>this.keep(this.clone(t)))}getTensorsForGradient(t,e,n){const s=L(t);if(null!=s){const t=s.inputsToSave||[],r=s.outputsToSave||[];let i;s.saveAllInputs?(a(Array.isArray(e),()=>"saveAllInputs is true, expected inputs to be an array."),i=Object.keys(e).map(t=>e[t])):i=t.map(t=>e[t]);const o=n.filter((t,e)=>r[e]);return i.concat(o)}return[]}makeTensor(t,e,n,s){if(null==t)throw new Error("Values passed to engine.makeTensor() are null");n=n||"float32",s=s||this.backend;let r=t;"string"===n&&g(t[0])&&(r=t.map(t=>function(t,e="utf-8"){return e=e||"utf-8",E().platform.encode(t,e)}(t)));const i=s.write(r,e,n),a=new X(e,n,i,this.nextTensorId());if(this.incRef(a,s),"string"===n){const t=this.state.tensorInfo.get(i),e=function(t){if(null==t)return 0;let e=0;return t.forEach(t=>e+=t.length),e}(r);this.state.numBytes+=e-t.bytes,t.bytes=e}return a}makeTensorFromDataId(t,e,n,s){const r=new X(e,n=n||"float32",t,this.nextTensorId());return this.incRef(r,s),r}makeVariable(t,e=!0,n,s){n=n||this.nextVariableId().toString(),null!=s&&s!==t.dtype&&(t=t.cast(s));const r=new Q(t,e,n,this.nextTensorId());if(null!=this.state.registeredVariables[r.name])throw new Error(`Variable with name ${r.name} was already registered`);return this.state.registeredVariables[r.name]=r,this.incRef(r,this.backend),r}incRef(t,e){const n=this.state.tensorInfo.has(t.dataId)?this.state.tensorInfo.get(t.dataId).refCount:0;if(this.state.numTensors++,"string"===t.dtype&&this.state.numStringTensors++,0===n){this.state.numDataBuffers++;let n=0;"complex64"!==t.dtype&&"string"!==t.dtype&&(n=t.size*function(t){if("float32"===t||"int32"===t)return 4;if("complex64"===t)return 8;if("bool"===t)return 1;throw new Error("Unknown dtype "+t)}(t.dtype)),this.state.tensorInfo.set(t.dataId,{backend:e||this.backend,dtype:t.dtype,shape:t.shape,bytes:n,refCount:0}),this.state.numBytes+=n}this.state.tensorInfo.get(t.dataId).refCount++,t instanceof Q||this.track(t)}disposeTensor(t){if(!this.state.tensorInfo.has(t.dataId))return;this.state.numTensors--,"string"===t.dtype&&this.state.numStringTensors--;const e=this.state.tensorInfo.get(t.dataId);e.refCount<=1?("complex64"!==t.dtype&&(this.state.numBytes-=e.bytes),this.state.numDataBuffers--,e.backend.disposeData(t.dataId),this.state.tensorInfo.delete(t.dataId)):(e.backend.decComplexRef(t.dataId),this.state.tensorInfo.get(t.dataId).refCount--)}disposeVariables(){for(const t in this.state.registeredVariables){const e=this.state.registeredVariables[t];this.disposeVariable(e)}}disposeVariable(t){this.disposeTensor(t),null!=this.state.registeredVariables[t.name]&&delete this.state.registeredVariables[t.name]}memory(){const t=this.backend.memory();return t.numTensors=this.state.numTensors,t.numDataBuffers=this.state.numDataBuffers,t.numBytes=this.state.numBytes,this.state.numStringTensors>0&&(t.unreliable=!0,null==t.reasons&&(t.reasons=[]),t.reasons.push("Memory usage by string tensors is approximate (2 bytes per character)")),t}async profile(t){this.state.profiling=!0;const e=this.state.numBytes,n=this.state.numTensors;this.state.activeProfile.kernels=[],this.state.activeProfile.result=await t(),this.state.profiling=!1,this.state.activeProfile.peakBytes=Math.max(...this.state.activeProfile.kernels.map(t=>t.totalBytesSnapshot)),this.state.activeProfile.newBytes=this.state.numBytes-e,this.state.activeProfile.newTensors=this.state.numTensors-n;for(const t of this.state.activeProfile.kernels)t.kernelTimeMs=await t.kernelTimeMs,t.extraInfo=await t.extraInfo;return this.state.activeProfile}isTapeOn(){return this.state.gradientDepth>0&&0===this.state.kernelDepth}addTapeNode(t,e,n,s,r,i){const a={id:this.state.nextTapeNodeId++,kernelName:t,inputs:e,outputs:n,saved:r},o=L(t);null!=o&&(s=o.gradFunc),null!=s&&(a.gradient=t=>(t=t.map((t,e)=>{if(null==t){const t=n[e],s=S(t.size,t.dtype);return this.makeTensor(s,t.shape,t.dtype)}return t}),s(t.length>1?t:t[0],r,i))),this.state.activeTape.push(a)}keep(t){return t.kept=!0,t}startTape(){0===this.state.gradientDepth&&(this.state.activeTape=[]),this.state.gradientDepth++}endTape(){this.state.gradientDepth--}startScope(t){const e={track:[],name:"unnamed scope",id:this.state.nextScopeId++};t&&(e.name=t),this.state.scopeStack.push(e),this.state.activeScope=e}endScope(t){const e=lt(t),n=new Set(e.map(t=>t.id));for(let t=0;t<this.state.activeScope.track.length;t++){const e=this.state.activeScope.track[t];e.kept||n.has(e.id)||e.dispose()}const s=this.state.scopeStack.pop();this.state.activeScope=0===this.state.scopeStack.length?null:this.state.scopeStack[this.state.scopeStack.length-1],e.forEach(t=>{t.kept||t.scopeId!==s.id||this.track(t)})}gradients(t,e,n,s=!1){if(a(e.length>0,()=>"gradients() received an empty list of xs."),null!=n&&"float32"!==n.dtype)throw new Error(`dy must have 'float32' dtype, but has '${n.dtype}'`);const r=this.scopedRun(()=>this.startTape(),()=>this.endTape(),()=>this.tidy("forward",t));a(r instanceof X,()=>"The result y returned by f() must be a tensor.");const i=function(t,e,n){const s={},r={};for(let t=0;t<e.length;t++)s[e[t].id]=!0;for(let n=0;n<t.length;n++){const i=t[n],a=i.inputs;for(const t in a){const n=a[t];let o=!1;for(let t=0;t<e.length;t++)if(s[n.id]){i.outputs.forEach(t=>s[t.id]=!0),o=!0,r[i.id]=!0;break}if(o)break}}const i={};i[n.id]=!0;const a={};for(let e=t.length-1;e>=0;e--){const n=t[e],s=n.inputs;for(let t=0;t<n.outputs.length;t++)if(i[n.outputs[t].id]){for(const t in s)i[s[t].id]=!0,a[n.id]=!0;break}}const o=[];for(let e=0;e<t.length;e++){const n=t[e];if(r[n.id]&&a[n.id]){const t={};for(const e in n.inputs){const r=n.inputs[e];s[r.id]&&(t[e]=r)}const e=Object.assign({},n);e.inputs=t,e.outputs=n.outputs,o.push(e)}}return o}(this.state.activeTape,e,r);if(!s&&0===i.length&&e.length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that the f you passed encloses all operations that lead from x to y.");return this.tidy("backward",()=>{const t={};t[r.id]=null==n?function(t){const e=x(h(t),"float32");return dt.makeTensor(e,t,"float32")}(r.shape):n,function(t,e,n,s){for(let r=e.length-1;r>=0;r--){const i=e[r],a=[];if(i.outputs.forEach(e=>{const n=t[e.id];null!=n?a.push(n):a.push(null)}),null==i.gradient)throw new Error(`Cannot compute gradient: gradient function not found for ${i.kernelName}.`);const o=i.gradient(a);for(const e in i.inputs){if(!(e in o))throw new Error(`Cannot backprop through input ${e}. Available gradients found: ${Object.keys(o)}.`);const r=n(()=>o[e]());if("float32"!==r.dtype)throw new Error(`Error in gradient for op ${i.kernelName}. The gradient of input ${e} must have 'float32' dtype, but has '${r.dtype}'`);const a=i.inputs[e];if(!c(r.shape,a.shape))throw new Error(`Error in gradient for op ${i.kernelName}. The gradient of input '${e}' has shape '${r.shape}', which does not match the shape of the input '${a.shape}'`);if(null==t[a.id])t[a.id]=r;else{const e=t[a.id];t[a.id]=s(e,r),e.dispose()}}}}(t,i,t=>this.tidy(t),ft);const s=e.map(e=>t[e.id]);return 0===this.state.gradientDepth&&(this.state.activeTape.forEach(t=>{for(const e of t.saved)e.dispose()}),this.state.activeTape=null),{value:r,grads:s}})}customGrad(t){return a(w(t),()=>"The f passed in customGrad(f) must be a function."),(...e)=>{let n;a(e.every(t=>t instanceof X),()=>"The args passed in customGrad(f)(x1, x2,...) must all be tensors");const s={};e.forEach((t,e)=>{s[e]=t});return this.runKernelFunc({forwardFunc:(s,r)=>(n=t(...e,r),a(n.value instanceof X,()=>"The function f passed in customGrad(f) must return an object where `obj.value` is a tensor"),a(w(n.gradFunc),()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function."),n.value),backwardsFunc:(t,s)=>{const r=n.gradFunc(t,s),i=Array.isArray(r)?r:[r];a(i.length===e.length,()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns the same number of tensors as inputs passed to f(...)."),a(i.every(t=>t instanceof X),()=>"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns a list of only tensors.");const o={};return i.forEach((t,e)=>{o[e]=()=>t}),o},inputs:s})}}readSync(t){return this.state.tensorInfo.get(t).backend.readSync(t)}read(t){return this.state.tensorInfo.get(t).backend.read(t)}async time(t){const e=B(),n=await this.backend.time(t);return n.wallMs=B()-e,n}track(t){return null!=this.state.activeScope&&(t.scopeId=this.state.activeScope.id,this.state.activeScope.track.push(t)),t}get registeredVariables(){return this.state.registeredVariables}reset(){this.pendingBackendInitId++,this.state.dispose(),this.ENV.reset(),this.state=new ht;for(const t in this.registry)this.disposeRegisteredKernels(t),this.registry[t].dispose(),delete this.registry[t];this.backendName=null,this.backendInstance=null,this.pendingBackendInit=null}}function pt(){const t=z();if(null==t._tfengine){const e=new A(t);t._tfengine=new ct(e)}var e;return e=t._tfengine.ENV,D=e,J=()=>t._tfengine,t._tfengine}ct.nextTensorId=0,ct.nextVariableId=0;const dt=pt();function ft(t,e){const n={a:t,b:e};return dt.runKernel("Add",n)}const mt=E();function gt(t,e){let n=t;if(m(t))return"string"===e?[]:[t.length];if(!Array.isArray(t))return[];const s=[];for(;Array.isArray(n)||m(n)&&"string"!==e;)s.push(n.length),n=n[0];return Array.isArray(t)&&E().getBool("TENSORLIKE_CHECK_SHAPE_CONSISTENCY")&&function t(e,n,s){if(s=s||[],!Array.isArray(e)&&!m(e))return void a(0===n.length,()=>`Element arr[${s.join("][")}] is a primitive, but should be an array/TypedArray of ${n[0]} elements`);a(n.length>0,()=>`Element arr[${s.join("][")}] should be a primitive, but is an array of ${e.length} elements`),a(e.length===n[0],()=>`Element arr[${s.join("][")}] should have ${n[0]} elements, but has ${e.length} elements`);const r=n.slice(1);for(let n=0;n<e.length;++n)t(e[n],r,s.concat(n))}(t,s,[]),s}function yt(t,e,n,s){if("string_or_numeric"!==t){if(null==t)throw new Error("Expected dtype cannot be null.");if("numeric"!==t&&t!==e||"numeric"===t&&"string"===e)throw new Error(`Argument '${n}' passed to '${s}' must be ${t} tensor, but got ${e} tensor`)}}function bt(t,e,n,s="numeric"){if(t instanceof X)return yt(s,t.dtype,e,n),t;let r=b(t);if("string"!==r&&["bool","int32","float32"].indexOf(s)>=0&&(r=s),yt(s,r,e,n),null==t||!m(t)&&!Array.isArray(t)&&"number"!=typeof t&&"boolean"!=typeof t&&"string"!=typeof t){const s=null==t?"null":t.constructor.name;throw new Error(`Argument '${e}' passed to '${n}' must be a Tensor or TensorLike, but got '${s}'`)}const i=gt(t,r);m(t)||Array.isArray(t)||(t=[t]);const a="string"!==r?O(t,r):u(t,[],!0);return dt.makeTensor(a,i,r)}function wt(t,e,n,s="numeric"){if(!Array.isArray(t))throw new Error(`Argument ${e} passed to ${n} must be a \`Tensor[]\` or \`TensorLike[]\``);return t.map((t,r)=>bt(t,`${e}[${r}]`,n,s))}mt.registerFlag("DEBUG",()=>!1,t=>{t&&console.warn("Debugging mode is ON. The output of every math call will be downloaded to CPU and checked for NaNs. This significantly impacts performance.")}),mt.registerFlag("IS_BROWSER",()=>"undefined"!=typeof window&&null!=window.document||"undefined"!=typeof WorkerGlobalScope),mt.registerFlag("IS_NODE",()=>"undefined"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.node),mt.registerFlag("IS_CHROME",()=>"undefined"!=typeof navigator&&null!=navigator&&null!=navigator.userAgent&&/Chrome/.test(navigator.userAgent)&&/Google Inc/.test(navigator.vendor)),mt.registerFlag("PROD",()=>!1),mt.registerFlag("TENSORLIKE_CHECK_SHAPE_CONSISTENCY",()=>mt.getBool("DEBUG")),mt.registerFlag("DEPRECATION_WARNINGS_ENABLED",()=>!0),mt.registerFlag("IS_TEST",()=>!1),mt.registerFlag("CHECK_COMPUTATION_FOR_ERRORS",()=>!0);function vt(t){const e=Object.keys(t);if(1!==e.length)throw new Error("Please provide an object with a single key (operation name) mapping to a function. Got an object with "+e.length+" keys.");let n=e[0];const s=t[n];n.endsWith("_")&&(n=n.substring(0,n.length-1)),n+="__op";const r=(...t)=>{dt.startScope(n);try{const e=s(...t);return N(e)&&console.error("Cannot return a Promise inside of tidy."),dt.endScope(e),e}catch(t){throw dt.endScope(null),t}};return Object.defineProperty(r,"name",{value:n,configurable:!0}),r}const kt=vt({complex_:function(t,e){const n=bt(t,"real","complex"),s=bt(e,"imag","complex");o(n.shape,s.shape,`real and imag shapes, ${n.shape} and ${s.shape}, must match in call to tf.complex().`);const r={real:n,imag:s};return dt.runKernel("Complex",r)}});function xt(t,e,n,s){if(null==s&&(s=b(t)),"complex64"===s)throw new Error("Cannot construct a complex64 tensor directly. Please use tf.complex(real, imag).");if(!m(t)&&!Array.isArray(t)&&"number"!=typeof t&&"boolean"!=typeof t&&"string"!=typeof t)throw new Error("values passed to tensor(values) must be a number/boolean/string or an array of numbers/booleans/strings, or a TypedArray");if(null!=e){I(e);const t=h(e),s=h(n);a(t===s,()=>`Based on the provided shape, [${e}], the tensor should have ${t} values but has ${s}`);for(let t=0;t<n.length;++t){const s=n[t],r=t!==n.length-1||s!==h(e.slice(t));a(n[t]===e[t]||!r,()=>`Error creating a new Tensor. Inferred shape (${n}) does not match the provided shape (${e}). `)}}return m(t)||Array.isArray(t)||(t=[t]),e=e||n,t="string"!==s?O(t,s):u(t,[],!0),dt.makeTensor(t,e,s)}function St(t,e,n){return xt(t,e,gt(t,n),n)}const It={float32:4,float16:2,int32:4,uint16:2,uint8:1,bool:1,complex64:8};async function Nt(t,e){const n=[],s=[],r=Array.isArray(t)?t.map(t=>t.name):Object.keys(t);for(let i=0;i<r.length;++i){const a=r[i],o=Array.isArray(t)?t[i].tensor:t[a];if("float32"!==o.dtype&&"int32"!==o.dtype&&"bool"!==o.dtype&&"string"!==o.dtype&&"complex64"!==o.dtype)throw new Error(`Unsupported dtype in weight '${a}': ${o.dtype}`);const l={name:a,shape:o.shape,dtype:o.dtype};if("string"===o.dtype){const t=new Promise(async t=>{const e=await o.bytes(),n=e.reduce((t,e)=>t+e.length,0)+4*e.length,s=new Uint8Array(n);let r=0;for(let t=0;t<e.length;t++){const n=e[t],i=new Uint8Array(new Uint32Array([n.length]).buffer);s.set(i,r),r+=4,s.set(n,r),r+=n.length}t(s)});s.push(t)}else s.push(o.data());null!=e&&(l.group=e),n.push(l)}return{data:At(await Promise.all(s)),specs:n}}function At(t){if(null===t)throw new Error("Invalid input value: "+JSON.stringify(t));let e=0;const n=[];t.forEach(t=>{if(e+=t.byteLength,n.push(t.byteLength===t.buffer.byteLength?t:new t.constructor(t)),!(t instanceof Float32Array||t instanceof Int32Array||t instanceof Uint8Array))throw new Error("Unsupported TypedArray subtype: "+t.constructor.name)});const s=new Uint8Array(e);let r=0;return n.forEach(t=>{s.set(new Uint8Array(t.buffer),r),r+=t.byteLength}),s.buffer}const Et="undefined"!=typeof Buffer&&("undefined"==typeof Blob||"undefined"==typeof atob||"undefined"==typeof btoa);function Tt(t){return Et?Buffer.byteLength(t):new Blob([t]).size}function Dt(t){if(1===t.length)return t[0];let e=0;t.forEach(t=>{e+=t.byteLength});const n=new Uint8Array(e);let s=0;return t.forEach(t=>{n.set(new Uint8Array(t),s),s+=t.byteLength}),n.buffer}function zt(t){if(t.modelTopology instanceof ArrayBuffer)throw new Error("Expected JSON model topology, received ArrayBuffer.");return{dateSaved:new Date,modelTopologyType:"JSON",modelTopologyBytes:null==t.modelTopology?0:Tt(JSON.stringify(t.modelTopology)),weightSpecsBytes:null==t.weightSpecs?0:Tt(JSON.stringify(t.weightSpecs)),weightDataBytes:null==t.weightData?0:t.weightData.byteLength}}function Ct(){const t=function(){const t=t=>{let e=t<<13,n=0;for(;0==(8388608&e);)n-=8388608,e<<=1;return e&=-8388609,n+=947912704,e|n},e=new Uint32Array(2048);e[0]=0;for(let n=1;n<1024;n++)e[n]=t(n);for(let t=1024;t<2048;t++)e[t]=939524096+(t-1024<<13);return e}(),e=function(){const t=new Uint32Array(64);t[0]=0,t[31]=1199570944,t[32]=2147483648,t[63]=3347054592;for(let e=1;e<31;e++)t[e]=e<<23;for(let e=33;e<63;e++)t[e]=2147483648+(e-32<<23);return t}(),n=function(){const t=new Uint32Array(64);for(let e=0;e<64;e++)t[e]=1024;return t[0]=t[32]=0,t}();return s=>{const r=new ArrayBuffer(4*s.length),i=new Uint32Array(r);for(let r=0;r<s.length;r++){const a=s[r],o=t[n[a>>10]+(1023&a)]+e[a>>10];i[r]=o}return new Float32Array(r)}}class Ft{constructor(){this.saveRouters=[],this.loadRouters=[]}static getInstance(){return null==Ft.instance&&(Ft.instance=new Ft),Ft.instance}static registerSaveRouter(t){Ft.getInstance().saveRouters.push(t)}static registerLoadRouter(t){Ft.getInstance().loadRouters.push(t)}static getSaveHandlers(t){return Ft.getHandlers(t,"save")}static getLoadHandlers(t,e){return Ft.getHandlers(t,"load",e)}static getHandlers(t,e,n){const s=[];return("load"===e?Ft.getInstance().loadRouters:Ft.getInstance().saveRouters).forEach(e=>{const r=e(t,n);null!==r&&s.push(r)}),s}}function Rt(){if(!E().getBool("IS_BROWSER"))throw new Error("Failed to obtain IndexedDB factory because the current environmentis not a web browser.");const t="undefined"==typeof window?self:window,e=t.indexedDB||t.mozIndexedDB||t.webkitIndexedDB||t.msIndexedDB||t.shimIndexedDB;if(null==e)throw new Error("The current browser does not appear to support IndexedDB.");return e}function Mt(t){const e=t.result;e.createObjectStore("models_store",{keyPath:"modelPath"}),e.createObjectStore("model_info_store",{keyPath:"modelPath"})}class Lt{constructor(t){if(this.indexedDB=Rt(),null==t||!t)throw new Error("For IndexedDB, modelPath must not be null, undefined or empty.");this.modelPath=t}async save(t){if(t.modelTopology instanceof ArrayBuffer)throw new Error("BrowserLocalStorage.save() does not support saving model topology in binary formats yet.");return this.databaseAction(this.modelPath,t)}async load(){return this.databaseAction(this.modelPath)}databaseAction(t,e){return new Promise((t,n)=>{const s=this.indexedDB.open("tensorflowjs",1);s.onupgradeneeded=()=>Mt(s),s.onsuccess=()=>{const r=s.result;if(null==e){const e=r.transaction("models_store","readonly"),s=e.objectStore("models_store").get(this.modelPath);s.onsuccess=()=>{if(null==s.result)return r.close(),n(new Error(`Cannot find model with path '${this.modelPath}' in IndexedDB.`));t(s.result.modelArtifacts)},s.onerror=t=>(r.close(),n(s.error)),e.oncomplete=()=>r.close()}else{const s=zt(e),i=r.transaction("model_info_store","readwrite");let a=i.objectStore("model_info_store");const o=a.put({modelPath:this.modelPath,modelArtifactsInfo:s});let l;o.onsuccess=()=>{l=r.transaction("models_store","readwrite");const o=l.objectStore("models_store").put({modelPath:this.modelPath,modelArtifacts:e,modelArtifactsInfo:s});o.onsuccess=()=>t({modelArtifactsInfo:s}),o.onerror=t=>{a=i.objectStore("model_info_store");const e=a.delete(this.modelPath);e.onsuccess=()=>(r.close(),n(o.error)),e.onerror=t=>(r.close(),n(o.error))}},o.onerror=t=>(r.close(),n(o.error)),i.oncomplete=()=>{null==l?r.close():l.oncomplete=()=>r.close()}}},s.onerror=t=>n(s.error)})}}Lt.URL_SCHEME="indexeddb://";const _t=t=>{return E().getBool("IS_BROWSER")&&!Array.isArray(t)&&t.startsWith(Lt.URL_SCHEME)?(e=t.slice(Lt.URL_SCHEME.length),new Lt(e)):null;var e};Ft.registerSaveRouter(_t),Ft.registerLoadRouter(_t);class $t{constructor(){this.indexedDB=Rt()}async listModels(){return new Promise((t,e)=>{const n=this.indexedDB.open("tensorflowjs",1);n.onupgradeneeded=()=>Mt(n),n.onsuccess=()=>{const s=n.result,r=s.transaction("model_info_store","readonly"),i=r.objectStore("model_info_store").getAll();i.onsuccess=()=>{const e={};for(const t of i.result)e[t.modelPath]=t.modelArtifactsInfo;t(e)},i.onerror=t=>(s.close(),e(i.error)),r.oncomplete=()=>s.close()},n.onerror=t=>e(n.error)})}async removeModel(t){var e;return t=(e=t).startsWith(Lt.URL_SCHEME)?e.slice(Lt.URL_SCHEME.length):e,new Promise((e,n)=>{const s=this.indexedDB.open("tensorflowjs",1);s.onupgradeneeded=()=>Mt(s),s.onsuccess=()=>{const r=s.result,i=r.transaction("model_info_store","readwrite"),a=i.objectStore("model_info_store"),o=a.get(t);let l;o.onsuccess=()=>{if(null==o.result)return r.close(),n(new Error(`Cannot find model with path '${t}' in IndexedDB.`));{const s=a.delete(t),i=()=>{l=r.transaction("models_store","readwrite");const s=l.objectStore("models_store").delete(t);s.onsuccess=()=>e(o.result.modelArtifactsInfo),s.onerror=t=>n(o.error)};s.onsuccess=i,s.onerror=t=>(i(),r.close(),n(o.error))}},o.onerror=t=>(r.close(),n(o.error)),i.oncomplete=()=>{null==l?r.close():l.oncomplete=()=>r.close()}},s.onerror=t=>n(s.error)})}}const Ot="tensorflowjs_models",Bt="info",Pt="model_topology",Ut="weight_specs",Wt="weight_data",jt="model_metadata";function qt(t){return{info:[Ot,t,Bt].join("/"),topology:[Ot,t,Pt].join("/"),weightSpecs:[Ot,t,Ut].join("/"),weightData:[Ot,t,Wt].join("/"),modelMetadata:[Ot,t,jt].join("/")}}function Kt(t){const e=t.split("/");if(e.length<3)throw new Error("Invalid key format: "+t);return e.slice(1,e.length-1).join("/")}class Vt{constructor(t){if(!E().getBool("IS_BROWSER")||"undefined"==typeof window||void 0===window.localStorage)throw new Error("The current environment does not support local storage.");if(this.LS=window.localStorage,null==t||!t)throw new Error("For local storage, modelPath must not be null, undefined or empty.");this.modelPath=t,this.keys=qt(this.modelPath)}async save(t){if(t.modelTopology instanceof ArrayBuffer)throw new Error("BrowserLocalStorage.save() does not support saving model topology in binary formats yet.");{const e=JSON.stringify(t.modelTopology),n=JSON.stringify(t.weightSpecs),s=zt(t);try{this.LS.setItem(this.keys.info,JSON.stringify(s)),this.LS.setItem(this.keys.topology,e),this.LS.setItem(this.keys.weightSpecs,n),this.LS.setItem(this.keys.weightData,function(t){if(Et)return Buffer.from(t).toString("base64");const e=new Uint8Array(t);let n="";for(let t=0,s=e.length;t<s;t++)n+=String.fromCharCode(e[t]);return btoa(n)}(t.weightData));const r={format:t.format,generatedBy:t.generatedBy,convertedBy:t.convertedBy};return null!=t.signature&&(r.signature=t.signature),null!=t.userDefinedMetadata&&(r.userDefinedMetadata=t.userDefinedMetadata),null!=t.modelInitializer&&(r.modelInitializer=t.modelInitializer),this.LS.setItem(this.keys.modelMetadata,JSON.stringify(r)),{modelArtifactsInfo:s}}catch(t){throw this.LS.removeItem(this.keys.info),this.LS.removeItem(this.keys.topology),this.LS.removeItem(this.keys.weightSpecs),this.LS.removeItem(this.keys.weightData),this.LS.removeItem(this.keys.modelMetadata),new Error(`Failed to save model '${this.modelPath}' to local storage: size quota being exceeded is a possible cause of this failure: modelTopologyBytes=${s.modelTopologyBytes}, weightSpecsBytes=${s.weightSpecsBytes}, weightDataBytes=${s.weightDataBytes}.`)}}}async load(){const t=JSON.parse(this.LS.getItem(this.keys.info));if(null==t)throw new Error(`In local storage, there is no model with name '${this.modelPath}'`);if("JSON"!==t.modelTopologyType)throw new Error("BrowserLocalStorage does not support loading non-JSON model topology yet.");const e={},n=JSON.parse(this.LS.getItem(this.keys.topology));if(null==n)throw new Error(`In local storage, the topology of model '${this.modelPath}' is missing.`);e.modelTopology=n;const s=JSON.parse(this.LS.getItem(this.keys.weightSpecs));if(null==s)throw new Error(`In local storage, the weight specs of model '${this.modelPath}' are missing.`);e.weightSpecs=s;const r=this.LS.getItem(this.keys.modelMetadata);if(null!=r){const t=JSON.parse(r);e.format=t.format,e.generatedBy=t.generatedBy,e.convertedBy=t.convertedBy,null!=t.signature&&(e.signature=t.signature),null!=t.userDefinedMetadata&&(e.userDefinedMetadata=t.userDefinedMetadata),null!=t.modelInitializer&&(e.modelInitializer=t.modelInitializer)}const i=this.LS.getItem(this.keys.weightData);if(null==i)throw new Error(`In local storage, the binary weight values of model '${this.modelPath}' are missing.`);return e.weightData=function(t){if(Et){const e=Buffer.from(t,"base64");return e.buffer.slice(e.byteOffset,e.byteOffset+e.byteLength)}const e=atob(t),n=new Uint8Array(e.length);for(let t=0;t<e.length;++t)n.set([e.charCodeAt(t)],t);return n.buffer}(i),e}}Vt.URL_SCHEME="localstorage://";const Ht=t=>{return E().getBool("IS_BROWSER")&&!Array.isArray(t)&&t.startsWith(Vt.URL_SCHEME)?(e=t.slice(Vt.URL_SCHEME.length),new Vt(e)):null;var e};Ft.registerSaveRouter(Ht),Ft.registerLoadRouter(Ht);class Gt{constructor(){a(E().getBool("IS_BROWSER"),()=>"Current environment is not a web browser"),a("undefined"==typeof window||void 0!==window.localStorage,()=>"Current browser does not appear to support localStorage"),this.LS=window.localStorage}async listModels(){const t={},e=Ot+"/",n="/"+Bt;for(let s=0;s<this.LS.length;++s){const r=this.LS.key(s);if(r.startsWith(e)&&r.endsWith(n)){t[Kt(r)]=JSON.parse(this.LS.getItem(r))}}return t}async removeModel(t){var e;const n=qt(t=(e=t).startsWith(Vt.URL_SCHEME)?e.slice(Vt.URL_SCHEME.length):e);if(null==this.LS.getItem(n.info))throw new Error(`Cannot find model at path '${t}'`);const s=JSON.parse(this.LS.getItem(n.info));return this.LS.removeItem(n.info),this.LS.removeItem(n.topology),this.LS.removeItem(n.weightSpecs),this.LS.removeItem(n.weightData),s}}class Jt{constructor(){this.managers={}}static getInstance(){return null==Jt.instance&&(Jt.instance=new Jt),Jt.instance}static registerManager(t,e){a(null!=t,()=>"scheme must not be undefined or null."),t.endsWith("://")&&(t=t.slice(0,t.indexOf("://"))),a(t.length>0,()=>"scheme must not be an empty string.");const n=Jt.getInstance();a(null==n.managers[t],()=>`A model store manager is already registered for scheme '${t}'.`),n.managers[t]=e}static getManager(t){const e=this.getInstance().managers[t];if(null==e)throw new Error(`Cannot find model manager for scheme '${t}'`);return e}static getSchemes(){return Object.keys(this.getInstance().managers)}}async function Zt(){const t=Jt.getSchemes(),e={};for(const n of t){const t=await Jt.getManager(n).listModels();for(const s in t){e[n+"://"+s]=t[s]}}return e}async function Xt(t){const e=function(t){if(-1===t.indexOf("://"))throw new Error("The url string provided does not contain a scheme. Supported schemes are: "+Jt.getSchemes().join(","));return{scheme:t.split("://")[0],path:t.split("://")[1]}}(t);return Jt.getManager(e.scheme).removeModel(e.path)}class Yt{fetch(t,e){return fetch(t,e)}now(){return performance.now()}encode(t,e){if("utf-8"!==e&&"utf8"!==e)throw new Error("Browser's encoder only supports utf-8, but got "+e);return null==this.textEncoder&&(this.textEncoder=new TextEncoder),this.textEncoder.encode(t)}decode(t,e){return new TextDecoder(e).decode(t)}}if(E().get("IS_BROWSER")){E().setPlatform("browser",new Yt);try{Jt.registerManager(Vt.URL_SCHEME,new Gt)}catch(t){}try{Jt.registerManager(Lt.URL_SCHEME,new $t)}catch(t){}}const Qt=()=>require("node-fetch");let te;class ee{constructor(){this.util=require("util"),this.textEncoder=new this.util.TextEncoder}fetch(t,e){return null!=E().global.fetch?E().global.fetch(t,e):(null==te&&(te=Qt()),te(t,e))}now(){const t=process.hrtime();return 1e3*t[0]+t[1]/1e6}encode(t,e){if("utf-8"!==e&&"utf8"!==e)throw new Error("Node built-in encoder only supports utf-8, but got "+e);return this.textEncoder.encode(t)}decode(t,e){return 0===t.length?"":new this.util.TextDecoder(e).decode(t)}}function ne(t,e="float32",n){return e=e||"float32",I(t),new G(t,e,n)}E().get("IS_NODE")&&E().setPlatform("node",new ee);const se=vt({cast_:function(t,e){const n=bt(t,"x","cast");if(!function(t){return"bool"===t||"complex64"===t||"float32"===t||"int32"===t||"string"===t}(e))throw new Error("Failed to cast to unknown dtype "+e);if("string"===e&&"string"!==n.dtype||"string"!==e&&"string"===n.dtype)throw new Error("Only strings can be casted to strings");const s={x:n},r={dtype:e};return dt.runKernel("Cast",s,r)}});const re=vt({clone_:function(t){const e={x:bt(t,"x","clone","string_or_numeric")};return dt.runKernel("Identity",e)}});pt();function ie(t,e,n,s){!function(t){a(null!=t&&Array.isArray(t)&&t.length>0,()=>"promises must be a none empty array")}(t),function(t,e){a(t>=0&&t<=1,()=>"Progress fraction must be in range [0, 1], but got startFraction "+t),a(e>=0&&e<=1,()=>"Progress fraction must be in range [0, 1], but got endFraction "+e),a(e>=t,()=>`startFraction must be no more than endFraction, but got startFraction ${t} and endFraction `+e)}(n=null==n?0:n,s=null==s?1:s);let r=0;return Promise.all(t.map(i=>(i.then(i=>{const a=n+ ++r/t.length*(s-n);return e(a),i}),i)))}Z={buffer:ne,cast:se,clone:re,print:function(t,e=!1){console.log(t.toString(e))}};class ae{constructor(t,e){if(this.DEFAULT_METHOD="POST",null==e&&(e={}),this.weightPathPrefix=e.weightPathPrefix,this.onProgress=e.onProgress,this.weightUrlConverter=e.weightUrlConverter,null!=e.fetchFunc?(a("function"==typeof e.fetchFunc,()=>"Must pass a function that matches the signature of `fetch` (see https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API)"),this.fetch=e.fetchFunc):this.fetch=E().platform.fetch,a(null!=t&&t.length>0,()=>"URL path for http must not be null, undefined or empty."),Array.isArray(t)&&a(2===t.length,()=>`URL paths for http must have a length of 2, (actual length is ${t.length}).`),this.path=t,null!=e.requestInit&&null!=e.requestInit.body)throw new Error("requestInit is expected to have no pre-existing body, but has one.");this.requestInit=e.requestInit||{}}async save(t){if(t.modelTopology instanceof ArrayBuffer)throw new Error("BrowserHTTPRequest.save() does not support saving model topology in binary formats yet.");const e=Object.assign({method:this.DEFAULT_METHOD},this.requestInit);e.body=new FormData;const n=[{paths:["./model.weights.bin"],weights:t.weightSpecs}],s={modelTopology:t.modelTopology,format:t.format,generatedBy:t.generatedBy,convertedBy:t.convertedBy,weightsManifest:n};null!=t.signature&&(s.signature=t.signature),null!=t.userDefinedMetadata&&(s.userDefinedMetadata=t.userDefinedMetadata),null!=t.modelInitializer&&(s.modelInitializer=t.modelInitializer),e.body.append("model.json",new Blob([JSON.stringify(s)],{type:"application/json"}),"model.json"),null!=t.weightData&&e.body.append("model.weights.bin",new Blob([t.weightData],{type:"application/octet-stream"}),"model.weights.bin");const r=await this.fetch(this.path,e);if(r.ok)return{modelArtifactsInfo:zt(t),responses:[r]};throw new Error("BrowserHTTPRequest.save() failed due to HTTP response status "+r.status+".")}async load(){const t=await this.fetch(this.path,this.requestInit);if(!t.ok)throw new Error(`Request to ${this.path} failed with status code `+t.status+". Please verify this URL points to the model JSON of the model to load.");let e;try{e=await t.json()}catch(t){let e=`Failed to parse model JSON of response from ${this.path}.`;throw this.path.endsWith(".pb")?e+=" Your path contains a .pb file extension. Support for .pb models have been removed in TensorFlow.js 1.0 in favor of .json models. You can re-convert your Python TensorFlow model using the TensorFlow.js 1.0 conversion scripts or you can convert your.pb models with the 'pb2json'NPM script in the tensorflow/tfjs-converter repository.":e+=" Please make sure the server is serving valid JSON for this request.",new Error(e)}const n=e.modelTopology,s=e.weightsManifest,r=e.generatedBy,i=e.convertedBy,a=e.format,o=e.signature,l=e.userDefinedMetadata;if(null==n&&null==s)throw new Error(`The JSON from HTTP path ${this.path} contains neither model topology or manifest for weights.`);let u,h;if(null!=s){const t=await this.loadWeights(s);[u,h]=t}const c={modelTopology:n,weightSpecs:u,weightData:h,generatedBy:r,convertedBy:i,format:a};null!=o&&(c.signature=o),null!=l&&(c.userDefinedMetadata=l);const p=e.modelInitializer;return p&&(c.modelInitializer=p),c}async loadWeights(t){const e=Array.isArray(this.path)?this.path[1]:this.path,[n,s]=function(t){const e=t.lastIndexOf("/"),n=t.lastIndexOf("?"),s=t.substring(0,e),r=n>e?t.substring(n):"";return[s+"/",r]}(e),r=this.weightPathPrefix||n,i=[];for(const e of t)i.push(...e.weights);const a=[],o=[];for(const e of t)for(const t of e.paths)null!=this.weightUrlConverter?o.push(this.weightUrlConverter(t)):a.push(r+t+s);this.weightUrlConverter&&a.push(...await Promise.all(o));return[i,Dt(await async function(t,e){null==e&&(e={});const n=null==e.fetchFunc?E().platform.fetch:e.fetchFunc,s=t.map(t=>n(t,e.requestInit,{isBinary:!0})),r=(null==e.onProgress?await Promise.all(s):await ie(s,e.onProgress,0,.5)).map(t=>t.arrayBuffer());return null==e.onProgress?await Promise.all(r):await ie(r,e.onProgress,.5,1)}(a,{requestInit:this.requestInit,fetchFunc:this.fetch,onProgress:this.onProgress}))]}}function oe(t){return null!=t.match(ae.URL_SCHEME_REGEX)}ae.URL_SCHEME_REGEX=/^https?:\/\//;const le=(t,e)=>{if("undefined"==typeof fetch&&(null==e||null==e.fetchFunc))return null;{let n=!0;if(n=Array.isArray(t)?t.every(t=>oe(t)):oe(t),n)return ue(t,e)}return null};function ue(t,e){return new ae(t,e)}Ft.registerSaveRouter(le),Ft.registerLoadRouter(le);class he{constructor(t){this.modelArtifacts=t}async load(){return this.modelArtifacts}}function ce(t,e,n,s){if(1===arguments.length){return null!=t.modelTopology||null!=t.weightSpecs?new he(t):(console.warn("Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release."),new he({modelTopology:t}))}return console.warn("Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release."),new he({modelTopology:t,weightSpecs:e,weightData:n,trainingConfig:s})}const pe=vt({matMul_:function(t,e,n=!1,s=!1){let r=bt(t,"a","matMul"),i=bt(e,"b","matMul");[r,i]=at(r,i);const a={a:r,b:i},o={transposeA:n,transposeB:s};return dt.runKernel("BatchMatMul",a,o)}});const de=vt({oneHot_:function(t,e,n=1,s=0){if(e<2)throw new Error("Error in oneHot: depth must be >=2, but it is "+e);const r={indices:bt(t,"indices","oneHot","int32")},i={depth:e,onValue:n,offValue:s};return dt.runKernel("OneHot",r,i)}});const fe=vt({transpose_:function(t,e){const n=bt(t,"x","transpose");if(null==e&&(e=n.shape.map((t,e)=>e).reverse()),a(n.rank===e.length,()=>`Error in transpose: rank of input ${n.rank} must match length of perm ${e}.`),e.forEach(t=>{a(t>=0&&t<n.rank,()=>"All entries in 'perm' must be between 0 and "+(n.rank-1)+" but got "+e)}),n.rank<=1)return n.clone();const s={x:n},r={perm:e};return dt.runKernel("Transpose",s,r)}});function me(t,e,n){if(l(t),null!=e&&3!==e.length)throw new Error("tensor3d() requires shape to have three numbers");const s=gt(t,n);if(3!==s.length&&1!==s.length)throw new Error("tensor3d() requires values to be number[][][] or flat/TypedArray");if(1===s.length&&null==e)throw new Error("tensor3d() requires shape to be provided when `values` are a flat array");return xt(t,e,s,n)}class ge{getClassName(){return this.constructor.className}static fromConfig(t,e){return new t(e)}}class ye{constructor(){this.classNameMap={}}static getMap(){return null==ye.instance&&(ye.instance=new ye),ye.instance}static register(t){ye.getMap().classNameMap[t.className]=[t,t.fromConfig]}}function be(t){a(null!=t.className,()=>"Class being registered does not have the static className property defined."),a("string"==typeof t.className,()=>"className is required to be a string, but got type "+typeof t.className),a(t.className.length>0,()=>"Class being registered has an empty-string as its className, which is disallowed."),ye.register(t)}function we(){return dt.memory()}function ve(t,e){return dt.tidy(t,e)}function ke(t){lt(t).forEach(t=>t.dispose())}function xe(t){return dt.keep(t)}function Se(){return dt.backend}const Ie=vt({add_:function(t,e){let n=bt(t,"a","add"),s=bt(e,"b","add");[n,s]=at(n,s);const r={a:n,b:s};return dt.runKernel("Add",r)}});const Ne=vt({floorDiv_:function(t,e){let n=bt(t,"a","floorDiv"),s=bt(e,"b","floorDiv");[n,s]=at(n,s);const r={a:n,b:s};return dt.runKernel("FloorDiv",r)}});const Ae=vt({div_:function(t,e){let n=bt(t,"a","div"),s=bt(e,"b","div");if([n,s]=at(n,s),"int32"===n.dtype&&"int32"===s.dtype)return Ne(n,s);const r={a:n,b:s};return dt.runKernel("RealDiv",r,{})}});const Ee=vt({mul_:function(t,e){let n=bt(t,"a","mul"),s=bt(e,"b","mul");[n,s]=at(n,s);const r={a:n,b:s};return dt.runKernel("Multiply",r)}});const Te=vt({abs_:function(t){const e=bt(t,"x","abs");if("complex64"===e.dtype){const t={x:e};return dt.runKernel("ComplexAbs",t)}{const t={x:e};return dt.runKernel("Abs",t)}}});const De=vt({acos_:function(t){const e={x:bt(t,"x","acos")};return dt.runKernel("Acos",e)}});const ze=vt({acosh_:function(t){const e={x:bt(t,"x","acosh")};return dt.runKernel("Acosh",e)}});const Ce=vt({all_:function(t,e=null,n=!1){const s={x:bt(t,"x","all","bool")},r={axis:e,keepDims:n};return dt.runKernel("All",s,r)}});const Fe=vt({any_:function(t,e=null,n=!1){const s={x:bt(t,"x","any","bool")},r={axis:e,keepDims:n};return dt.runKernel("Any",s,r)}});const Re=vt({argMax_:function(t,e=0){const n={x:bt(t,"x","argMax")},s={axis:e};return dt.runKernel("ArgMax",n,s)}});const Me=vt({argMin_:function(t,e=0){const n={x:bt(t,"x","argMin")},s={axis:e};return dt.runKernel("ArgMin",n,s)}});const Le=vt({asin_:function(t){const e={x:bt(t,"x","asin")};return dt.runKernel("Asin",e)}});const _e=vt({asinh_:function(t){const e={x:bt(t,"x","asinh")};return dt.runKernel("Asinh",e)}});const $e=vt({atan_:function(t){const e={x:bt(t,"x","atan")};return dt.runKernel("Atan",e)}});const Oe=vt({atan2_:function(t,e){let n=bt(t,"a","atan2"),s=bt(e,"b","atan2");[n,s]=at(n,s);const r={a:n,b:s};return dt.runKernel("Atan2",r)}});const Be=vt({atanh_:function(t){const e={x:bt(t,"x","atanh")};return dt.runKernel("Atanh",e)}});function Pe(t,e,n,s,r,i,a=!1,o="channelsLast"){let[l,u,h,c]=[-1,-1,-1,-1];if("channelsLast"===o)[l,u,h,c]=t;else{if("channelsFirst"!==o)throw new Error("Unknown dataFormat "+o);[l,c,u,h]=t}const[p,d,,f]=e,[m,g]=Ue(n),[y,b]=Ue(s),w=We(p,y),v=We(d,b),{padInfo:k,outHeight:x,outWidth:S}=function(t,e,n,s,r,i,a,o,l){let u,h,c;if("number"==typeof t){u={top:t,bottom:t,left:t,right:t,type:0===t?"VALID":"NUMBER"};const r=function(t,e,n,s,r){null==s&&(s=function(t,e,n,s=1){const r=We(e,s);return Math.floor((t[0]*(n-1)-n+r)/2)}(t,e,n));const i=t[0],a=t[1],o=je((i-e+2*s)/n+1,r),l=je((a-e+2*s)/n+1,r);return[o,l]}([e,n],i,s,t,o);h=r[0],c=r[1]}else if("same"===t){h=Math.ceil(e/s),c=Math.ceil(n/r);const t=Math.max(0,(h-1)*s+i-e),o=Math.max(0,(c-1)*r+a-n),l=Math.floor(t/2),p=t-l,d=Math.floor(o/2);u={top:l,bottom:p,left:d,right:o-d,type:"SAME"}}else if("valid"===t)u={top:0,bottom:0,left:0,right:0,type:"VALID"},h=Math.ceil((e-i+1)/s),c=Math.ceil((n-a+1)/r);else{if("object"!=typeof t)throw Error("Unknown padding parameter: "+t);{const p="channelsLast"===l?t[1][0]:t[2][0],d="channelsLast"===l?t[1][1]:t[2][1],f="channelsLast"===l?t[2][0]:t[3][0],m="channelsLast"===l?t[2][1]:t[3][1];u={top:p,bottom:d,left:f,right:m,type:0===p&&0===d&&0===f&&0===m?"VALID":"EXPLICIT"},h=je((e-i+p+d)/s+1,o),c=je((n-a+f+m)/r+1,o)}}return{padInfo:u,outHeight:h,outWidth:c}}(r,u,h,m,g,w,v,i,o),I=a?f*c:f;let N;return"channelsFirst"===o?N=[l,I,x,S]:"channelsLast"===o&&(N=[l,x,S,I]),{batchSize:l,dataFormat:o,inHeight:u,inWidth:h,inChannels:c,outHeight:x,outWidth:S,outChannels:I,padInfo:k,strideHeight:m,strideWidth:g,filterHeight:p,filterWidth:d,effectiveFilterHeight:w,effectiveFilterWidth:v,dilationHeight:y,dilationWidth:b,inShape:t,outShape:N,filterShape:e}}function Ue(t){return"number"==typeof t?[t,t,t]:2===t.length?[t[0],t[1],1]:t}function We(t,e){return e<=1?t:t+(t-1)*(e-1)}function je(t,e){if(!e)return Math.trunc(t);switch(e){case"round":return Math.round(t);case"ceil":return Math.ceil(t);case"floor":return Math.floor(t);default:throw new Error("Unknown roundingMode "+e)}}function qe(t){const[e,n,s]=Ue(t);return 1===e&&1===n&&1===s}function Ke(t,e){return qe(t)||qe(e)}const Ve=vt({reshape_:function(t,e){const n={x:bt(t,"x","reshape","string_or_numeric")},s={shape:e};return dt.runKernel("Reshape",n,s)}});const He=vt({avgPool_:function(t,e,n,s,r){const i=bt(t,"x","avgPool","float32");a(Ke(n,1),()=>`Error in avgPool: Either strides or dilations must be 1. Got strides ${n} and dilations '1'`);let o=i,l=!1;3===i.rank&&(l=!0,o=Ve(i,[1,i.shape[0],i.shape[1],i.shape[2]])),a(4===o.rank,()=>`Error in avgPool: x must be rank 4 but got rank ${o.rank}.`),null!=r&&a(p(s),()=>`Error in avgPool: pad must be an integer when using, dimRoundingMode ${r} but got pad ${s}.`);const u={x:o},h={filterSize:e,strides:n,pad:s,dimRoundingMode:r};let c=dt.runKernel("AvgPool",u,h);return c=se(c,i.dtype),l?Ve(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});const Ge=vt({avgPool3d_:function(t,e,n,s,r,i="NDHWC"){const o=bt(t,"x","avgPool3d","float32");let l=o,u=!1;4===o.rank&&(u=!0,l=Ve(o,[1,o.shape[0],o.shape[1],o.shape[2],o.shape[3]])),a(5===l.rank,()=>`Error in avgPool3d: x must be rank 5 but got rank ${l.rank}.`),a("NDHWC"===i,()=>"Error in avgPool3d: Only NDHWC is currently supported, but got dataFormat of "+i),null!=r&&a(p(s),()=>`Error in avgPool3d: pad must be an integer when using, dimRoundingMode ${r} but got pad ${s}.`);const h={x:l},c={filterSize:e,strides:n,pad:s,dimRoundingMode:r,dataFormat:i};let d=dt.runKernel("AvgPool3D",h,c);return d=se(d,l.dtype),u?Ve(d,[d.shape[1],d.shape[2],d.shape[3],d.shape[4]]):d}});const Je=vt({concat_:function(t,e=0){a(t.length>=1,()=>"Pass at least one tensor to concat");const n=wt(t,"tensors","concat","string_or_numeric");if("complex64"===n[0].dtype&&n.forEach(t=>{if("complex64"!==t.dtype)throw new Error(`Cannot concatenate complex64 tensors with a tensor\n          with dtype ${t.dtype}. `)}),1===n.length)return re(n[0]);const s=n,r={axis:e};return dt.runKernel("Concat",s,r)}});const Ze=vt({sigmoid_:function(t){const e={x:bt(t,"x","sigmoid")};return dt.runKernel("Sigmoid",e)}});const Xe=vt({slice_:function(t,e,n){const s=bt(t,"x","slice","string_or_numeric");if(0===s.rank)throw new Error("Slicing scalar is not possible");const r={x:s},i={begin:e,size:n};return dt.runKernel("Slice",r,i)}});const Ye=vt({tanh_:function(t){const e={x:bt(t,"x","tanh")};return dt.runKernel("Tanh",e)}});const Qe=vt({batchToSpaceND_:function(t,e,n){const s=bt(t,"x","batchToSpaceND"),r=e.reduce((t,e)=>t*e);a(s.rank>=1+e.length,()=>`input rank is ${s.rank} but should be > than blockShape.length ${e.length}`),a(n.length===e.length,()=>`crops.length is ${n.length} but should be equal to blockShape.length  ${e.length}`),a(s.shape[0]%r==0,()=>`input tensor batch is ${s.shape[0]} but is not divisible by the product of the elements of blockShape ${e.join(" * ")} === ${r}`);const i={x:s},o={blockShape:e,crops:n};return dt.runKernel("BatchToSpaceND",i,o)}});const tn=vt({batchNorm_:function(t,e,n,s,r,i){null==i&&(i=.001);const o=bt(t,"x","batchNorm"),l=bt(e,"mean","batchNorm"),u=bt(n,"variance","batchNorm");let h,c;null!=r&&(h=bt(r,"scale","batchNorm")),null!=s&&(c=bt(s,"offset","batchNorm")),a(l.rank===u.rank,()=>"Batch normalization gradient requires mean and variance to have equal ranks."),a(null==c||l.rank===c.rank,()=>"Batch normalization gradient requires mean and offset to have equal ranks."),a(null==h||l.rank===h.rank,()=>"Batch normalization gradient requires mean and scale to have equal ranks.");const p={x:function(t){let e;return e=0===t.rank||1===t.rank?Ve(t,[1,1,1,t.size]):2===t.rank?Ve(t,[1,1,t.shape[0],t.shape[1]]):3===t.rank?Ve(t,[1,t.shape[0],t.shape[1],t.shape[2]]):t,e}(o),scale:h,offset:c,mean:l,variance:u},d={varianceEpsilon:i},f=dt.runKernel("FusedBatchNorm",p,d);return Ve(f,o.shape)}});const en=vt({batchNorm2d_:function(t,e,n,s,r,i){const o=bt(t,"x","batchNorm"),l=bt(e,"mean","batchNorm"),u=bt(n,"variance","batchNorm");let h,c;return null!=r&&(h=bt(r,"scale","batchNorm")),null!=s&&(c=bt(s,"offset","batchNorm")),a(2===o.rank,()=>"Error in batchNorm2D: x must be rank 2 but got rank "+o.rank+"."),a(2===l.rank||1===l.rank,()=>`Error in batchNorm2D: mean must be rank 2 or rank 1 but got rank ${l.rank}.`),a(2===u.rank||1===u.rank,()=>`Error in batchNorm2D: variance must be rank 2 or rank 1 but got rank ${u.rank}.`),null!=h&&a(2===h.rank||1===h.rank,()=>`Error in batchNorm2D: scale must be rank 2 or rank 1 but got rank ${h.rank}.`),null!=c&&a(2===c.rank||1===c.rank,()=>`Error in batchNorm2D: offset must be rank 2 or rank 1 but got rank ${c.rank}.`),tn(o,l,u,c,h,i)}});const nn=vt({batchNorm3d_:function(t,e,n,s,r,i){const o=bt(t,"x","batchNorm"),l=bt(e,"mean","batchNorm"),u=bt(n,"variance","batchNorm");let h,c;return null!=r&&(h=bt(r,"scale","batchNorm")),null!=s&&(c=bt(s,"offset","batchNorm")),a(3===o.rank,()=>"Error in batchNorm3D: x must be rank 3 but got rank "+o.rank+"."),a(3===l.rank||1===l.rank,()=>`Error in batchNorm3D: mean must be rank 3 or rank 1 but got rank ${l.rank}.`),a(3===u.rank||1===u.rank,()=>`Error in batchNorm3D: variance must be rank 3 or rank 1 but got rank ${u.rank}.`),null!=h&&a(3===h.rank||1===h.rank,()=>`Error in batchNorm3D: scale must be rank 3 or rank 1 but got rank ${h.rank}.`),null!=c&&a(3===c.rank||1===c.rank,()=>`Error in batchNorm3D: offset must be rank 3 or rank 1 but got rank ${c.rank}.`),tn(o,l,u,c,h,i)}});const sn=vt({batchNorm4d_:function(t,e,n,s,r,i){const o=bt(t,"x","batchNorm"),l=bt(e,"mean","batchNorm"),u=bt(n,"variance","batchNorm");let h,c;return null!=r&&(h=bt(r,"scale","batchNorm")),null!=s&&(c=bt(s,"offset","batchNorm")),a(4===o.rank,()=>"Error in batchNorm4D: x must be rank 4 but got rank "+o.rank+"."),a(4===l.rank||1===l.rank,()=>`Error in batchNorm4D: mean must be rank 4 or rank 1 but got rank ${l.rank}.`),a(4===u.rank||1===u.rank,()=>`Error in batchNorm4D: variance must be rank 4 or rank 1 but got rank ${u.rank}.`),null!=h&&a(4===h.rank||1===h.rank,()=>`Error in batchNorm4D: scale must be rank 4 or rank 1 but got rank ${h.rank}.`),null!=c&&a(4===c.rank||1===c.rank,()=>`Error in batchNorm4D: offset must be rank 4 or rank 1 but got rank ${c.rank}.`),tn(o,l,u,c,h,i)}});const rn=vt({broadcastTo_:function(t,e){let n=bt(t,"broadcastTo","x");const s=n.shape;if(e.some(t=>!(t>0)||t%1!=0))throw new Error(`broadcastTo(): Invalid broadcast shape [${e}].`);if(e.length<n.rank)throw new Error(`broadcastTo(): shape.length=${e.length} < input.rank=${n.rank}.`);if(e.length>n.rank){const t=n.shape.slice();for(;t.length<e.length;)t.unshift(1);n=Ve(n,t)}const r=n.shape,i=Array.from(e);for(let t=e.length-1;t>=0;t--)if(r[t]===e[t])i[t]=1;else if(1!==n.shape[t])throw new Error(`broadcastTo(): [${s}] cannot be broadcast to [${e}].`);if(0===i.map((t,e)=>t>1?e:-1).filter(t=>t>=0).length)return re(n);const a={x:n},o={reps:i};return dt.runKernel("Tile",a,o)}});const an=vt({ceil_:function(t){const e={x:bt(t,"x","ceil")};return dt.runKernel("Ceil",e)}});const on=vt({clipByValue_:function(t,e,n){const s=bt(t,"x","clipByValue");a(e<=n,()=>`Error in clip: min (${e}) must be less than or equal to max (${n}).`);const r={x:s},i={clipValueMin:e,clipValueMax:n};return dt.runKernel("ClipByValue",r,i)}});const ln=vt({concat1d_:function(t){return Je(t,0)}});const un=vt({concat2d_:function(t,e){return Je(t,e)}});const hn=vt({concat3d_:function(t,e){return Je(t,e)}});const cn=vt({concat4d_:function(t,e){return Je(t,e)}});const pn=vt({conv2d_:function(t,e,n,s,r="NHWC",i=[1,1],o){const l=bt(t,"x","conv2d"),u=bt(e,"filter","conv2d");let h=l,c=!1;3===l.rank&&(c=!0,h=Ve(l,[1,l.shape[0],l.shape[1],l.shape[2]])),a(4===h.rank,()=>`Error in conv2d: input must be rank 4, but got rank ${h.rank}.`),a(4===u.rank,()=>"Error in conv2d: filter must be rank 4, but got rank "+u.rank+"."),null!=o&&a(p(s),()=>`Error in conv2d: pad must be an integer when using, dimRoundingMode ${o} but got pad ${s}.`);const d="NHWC"===r?h.shape[3]:h.shape[1];a(d===u.shape[2],()=>`Error in conv2d: depth of input (${d}) must match input depth for filter ${u.shape[2]}.`),a(Ke(n,i),()=>`Error in conv2D: Either strides or dilations must be 1. Got strides ${n} and dilations '${i}'`);const f={x:h,filter:u},m={strides:n,pad:s,dataFormat:r,dilations:i,dimRoundingMode:o},g=dt.runKernel("Conv2D",f,m);return c?Ve(g,[g.shape[1],g.shape[2],g.shape[3]]):g}});const dn=vt({conv1d_:function(t,e,n,s,r="NWC",i=1,o){const l=bt(t,"x","conv1d"),u=bt(e,"filter","conv1d");let h=l,c=!1;2===l.rank&&(c=!0,h=Ve(l,[1,l.shape[0],l.shape[1]])),a(3===h.rank,()=>`Error in conv1d: input must be rank 3, but got rank ${h.rank}.`),a(3===u.rank,()=>"Error in conv1d: filter must be rank 3, but got rank "+u.rank+"."),null!=o&&a(p(s),()=>`Error in conv1d: pad must be an integer when using, dimRoundingMode ${o} but got pad ${s}.`),a(h.shape[2]===u.shape[1],()=>`Error in conv1d: depth of input (${h.shape[2]}) must match input depth for filter ${u.shape[1]}.`),a(Ke(n,i),()=>`Error in conv1D: Either stride or dilation must be 1. Got stride ${n} and dilation '${i}'`),a("NWC"===r,()=>`Error in conv1d: got dataFormat of ${r} but only NWC is currently supported.`);const d=Ve(u,[1,u.shape[0],u.shape[1],u.shape[2]]),f=Ve(h,[h.shape[0],1,h.shape[1],h.shape[2]]),m=pn(f,d,[1,n],s,"NHWC",[1,i],o);return Ve(m,c?[m.shape[2],m.shape[3]]:[m.shape[0],m.shape[2],m.shape[3]])}});const fn=vt({conv2DBackpropInput_:function(t,e,n,s,r,i="NHWC",o){a(t.length===e.rank,()=>`Length of inShape (${t.length}) and rank of dy (${e.rank}) must match`);let l=t,u=e,h=!1;3===e.rank&&(h=!0,u=Ve(e,[1,e.shape[0],e.shape[1],e.shape[2]]),l=[1,t[0],t[1],t[2]]),a(4===l.length,()=>"Error in conv2dDerInput: inShape must be length 4, but got length "+l.length+"."),a(4===u.rank,()=>"Error in conv2dDerInput: dy must be rank 4, but got rank "+u.rank),a(4===n.rank,()=>"Error in conv2dDerInput: filter must be rank 4, but got rank "+n.rank);const c="NHWC"===i?l[3]:l[1],d="NHWC"===i?u.shape[3]:u.shape[1];a(c===n.shape[2],()=>`Error in conv2dDerInput: depth of input (${c}) must match input depth for filter ${n.shape[2]}.`),a(d===n.shape[3],()=>`Error in conv2dDerInput: depth of output (${d}) must match output depth for filter ${n.shape[3]}.`),null!=o&&a(p(r),()=>`Error in conv2dDerInput: pad must be an integer when using, dimRoundingMode ${o} but got pad ${r}.`);const f={dy:u,filter:n},m={strides:s,pad:r,dataFormat:i,dimRoundingMode:o,inputShape:l},g=dt.runKernel("Conv2DBackpropInput",f,m);return h?Ve(g,[g.shape[1],g.shape[2],g.shape[3]]):g}});const mn=vt({conv2dTranspose_:function(t,e,n,s,r,i){const a=bt(t,"x","conv2dTranspose"),o=bt(e,"filter","conv2dTranspose");return fn(n,a,o,s,r,"NHWC",i)}});const gn=vt({conv3d_:function(t,e,n,s,r="NDHWC",i=[1,1,1]){const o=bt(t,"x","conv3d"),l=bt(e,"filter","conv3d");let u=o,h=!1;4===o.rank&&(h=!0,u=Ve(o,[1,o.shape[0],o.shape[1],o.shape[2],o.shape[3]])),a(5===u.rank,()=>`Error in conv3d: input must be rank 5, but got rank ${u.rank}.`),a(5===l.rank,()=>"Error in conv3d: filter must be rank 5, but got rank "+l.rank+"."),a(u.shape[4]===l.shape[3],()=>`Error in conv3d: depth of input (${u.shape[4]}) must match input depth for filter ${l.shape[3]}.`),a(Ke(n,i),()=>`Error in conv3D: Either strides or dilations must be 1. Got strides ${n} and dilations '${i}'`),a("NDHWC"===r,()=>`Error in conv3d: got dataFormat of ${r} but only NDHWC is currently supported.`);const c={x:u,filter:l},p={strides:n,pad:s,dataFormat:r,dilations:i},d=dt.runKernel("Conv3D",c,p);return h?Ve(d,[d.shape[1],d.shape[2],d.shape[3],d.shape[4]]):d}});const yn=vt({conv3DBackpropInput_:function(t,e,n,s,r){a(t.length===e.rank,()=>`Length of inShape (${t.length}) and rank of dy (${e.rank}) must match`);let i=t,o=e,l=!1;4===e.rank&&(l=!0,o=Ve(e,[1,e.shape[0],e.shape[1],e.shape[2],e.shape[3]]),i=[1,t[0],t[1],t[2],t[3]]);const u=i[4],h=o.shape[4];a(5===i.length,()=>"Error in conv3dDerInput: inShape must be length 5, but got length "+i.length+"."),a(5===o.rank,()=>"Error in conv3dDerInput: dy must be rank 5, but got rank "+o.rank),a(5===n.rank,()=>"Error in conv3dDerInput: filter must be rank 5, but got rank "+n.rank),a(u===n.shape[3],()=>`Error in conv3dDerInput: depth of input (${u}) must match input depth for filter ${n.shape[3]}.`),a(h===n.shape[4],()=>`Error in conv3dDerInput: depth of output (${h}) must match output depth for filter ${n.shape[4]}.`);const c={dy:o,filter:n},p={pad:r,strides:s,inputShape:i},d=dt.runKernel("Conv3DBackpropInputV2",c,p);return l?Ve(d,[d.shape[1],d.shape[2],d.shape[3],d.shape[4]]):d}});const bn=vt({cos_:function(t){const e={x:bt(t,"x","cos")};return dt.runKernel("Cos",e)}});const wn=vt({cosh_:function(t){const e={x:bt(t,"x","cosh")};return dt.runKernel("Cosh",e)}});const vn=vt({cumsum_:function(t,e=0,n=!1,s=!1){const r={x:bt(t,"x","cumsum")},i={axis:e,exclusive:n,reverse:s};return dt.runKernel("Cumsum",r,i)}});const kn=vt({depthToSpace_:function(t,e,n="NHWC"){const s=bt(t,"x","depthToSpace"),r="NHWC"===n?s.shape[1]:s.shape[2],i="NHWC"===n?s.shape[2]:s.shape[3],o="NHWC"===n?s.shape[3]:s.shape[1];a(r*e>=0,()=>`Negative dimension size caused by overflow when multiplying\n    ${r} and ${e}  for depthToSpace with input shape\n    ${s.shape}`),a(i*e>=0,()=>`Negative dimension size caused by overflow when multiplying\n    ${i} and ${e} for depthToSpace with input shape\n        ${s.shape}`),a(o%(e*e)==0,()=>`Dimension size must be evenly divisible by ${e*e} but is ${o} for depthToSpace with input shape ${s.shape}`);const l={x:s},u={blockSize:e,dataFormat:n};return dt.runKernel("DepthToSpace",l,u)}});const xn=vt({depthwiseConv2d_:function(t,e,n,s,r="NHWC",i=[1,1],o){const l=bt(t,"x","depthwiseConv2d"),u=bt(e,"filter","depthwiseConv2d");let h=l,c=!1;3===l.rank&&(c=!0,h=Ve(l,[1,l.shape[0],l.shape[1],l.shape[2]])),a(4===h.rank,()=>`Error in depthwiseConv2d: input must be rank 4, but got rank ${h.rank}.`),a(4===u.rank,()=>"Error in depthwiseConv2d: filter must be rank 4, but got rank "+u.rank+"."),a(h.shape[3]===u.shape[2],()=>`Error in depthwiseConv2d: number of input channels (${h.shape[3]}) must match the inChannels dimension in filter ${u.shape[2]}.`),null!=o&&a(p(s),()=>`Error in depthwiseConv2d: pad must be an integer when using, dimRoundingMode ${o} but got pad ${s}.`);const d={x:h,filter:u},f={strides:n,pad:s,dataFormat:r,dilations:i,dimRoundingMode:o},m=dt.runKernel("DepthwiseConv2dNative",d,f);return c?Ve(m,[m.shape[1],m.shape[2],m.shape[3]]):m}});const Sn=vt({dilation2d_:function(t,e,n,s,r=[1,1],i="NHWC"){const o=bt(t,"x","dilation2d"),l=bt(e,"filter","dilation2d");a(3===o.rank||4===o.rank,()=>"Error in dilation2d: input must be rank 3 or 4, but got rank "+o.rank+"."),a(3===l.rank,()=>"Error in dilation2d: filter must be rank 3, but got rank "+l.rank+"."),a("NHWC"===i,()=>"Error in dilation2d: Only NHWC is currently supported, but got dataFormat of "+i);let u=o,h=!1;3===o.rank&&(u=Ve(o,[1,o.shape[0],o.shape[1],o.shape[2]]),h=!0);const c={x:u,filter:l},p={strides:n,pad:s,dilations:r},d=dt.runKernel("Dilation2D",c,p);return h?Ve(d,[d.shape[1],d.shape[2],d.shape[3]]):d}});function In(t,e){const n=[];for(let s=0;s<e.length;s++){const r=t[t.length-s-1],i=e.length-s-1,a=e[i];(null==r||1===r&&a>1)&&n.unshift(i)}return n}function Nn(t,e){const n=[],s=Math.max(t.length,e.length);for(let r=0;r<s;r++){let s=t[t.length-r-1];null==s&&(s=1);let i=e[e.length-r-1];if(null==i&&(i=1),1===s)n.unshift(i);else if(1===i)n.unshift(s);else{if(s!==i){throw Error(`Operands could not be broadcast together with shapes ${t} and ${e}.`)}n.unshift(s)}}return n}const An=vt({equal_:function(t,e){let n=bt(t,"a","equal"),s=bt(e,"b","equal");[n,s]=at(n,s),Nn(n.shape,s.shape);const r={a:n,b:s};return dt.runKernel("Equal",r)}});const En=vt({where_:function(t,e,n){const s=bt(e,"a","where"),r=bt(n,"b","where"),i=bt(t,"condition","where","bool"),l=Nn(s.shape,r.shape),u=rn(s,l),h=rn(r,l);1===i.rank&&a(i.shape[0]===s.shape[0],()=>"The first dimension of `a` must match the size of `condition`."),1!==i.rank&&o(i.shape,h.shape,"Error in where: ");const c={condition:i,t:u,e:h};return dt.runKernel("Select",c)}});const Tn=vt({zerosLike_:function(t){const e={x:bt(t,"x","zerosLike")};return dt.runKernel("ZerosLike",e)}});const Dn=vt({divNoNan_:function(t,e){let n=bt(t,"a","div"),s=bt(e,"b","div");[n,s]=at(n,s);const r=Ae(n,s),i=Tn(r),a=An(s,i);return En(a,i,r)}});const zn=vt({dot_:function(t,e){const n=bt(t,"t1","dot"),s=bt(e,"t2","dot");a(!(1!==n.rank&&2!==n.rank||1!==s.rank&&2!==s.rank),()=>`Error in dot: inputs must all be rank 1 or 2, but got ranks ${n.rank} and ${s.rank}.`);const r=1===n.rank?n.size:n.shape[1],i=1===s.rank?s.size:s.shape[0];if(a(r===i,()=>`Error in dot: inner dimensions of inputs must match, but got ${r} and ${i}.`),1===n.rank&&1===s.rank){const t=Ve(n,[1,-1]),e=Ve(s,[-1,1]),r=pe(t,e);return Ve(r,[])}if(1===n.rank&&2===s.rank){const t=Ve(n,[1,-1]),e=Ve(s,[s.shape[0],s.shape[1]]),r=pe(t,e);return Ve(r,[r.size])}if(2===n.rank&&1===s.rank){const t=Ve(s,[-1,1]),e=pe(n,t);return Ve(e,[e.size])}{const t=Ve(s,[s.shape[0],s.shape[1]]);return pe(n,t)}}});const Cn=vt({elu_:function(t){const e={x:bt(t,"x","elu")};return dt.runKernel("Elu",e)}});const Fn=vt({erf_:function(t){let e=bt(t,"x","erf");a("int32"===e.dtype||"float32"===e.dtype,()=>"Input dtype must be `int32` or `float32`."),"int32"===e.dtype&&(e=se(e,"float32"));const n={x:e};return dt.runKernel("Erf",n)}});const Rn=vt({exp_:function(t){const e={x:bt(t,"x","exp")};return dt.runKernel("Exp",e)}});const Mn=vt({expandDims_:function(t,e=0){const n=bt(t,"x","expandDims","string_or_numeric");a(e<=n.rank,()=>"Axis must be <= rank of the tensor");const s={input:n},r={dim:e};return dt.runKernel("ExpandDims",s,r)}});const Ln=vt({expm1_:function(t){const e={x:bt(t,"x","expm1")};return dt.runKernel("Expm1",e)}});const _n=vt({tile_:function(t,e){const n=bt(t,"x","tile","string_or_numeric");a(n.rank===e.length,()=>`Error in transpose: rank of input ${n.rank} must match length of reps ${e}.`);const s={x:n},r={reps:e};return dt.runKernel("Tile",s,r)}});const $n=vt({eye_:function(t,e,n,s="float32"){null==e&&(e=t);const r=ne([t,e],s),i=t<=e?t:e;for(let t=0;t<i;++t)r.set(1,t,t);const a=Ve(r.toTensor(),[t,e]);if(null==n)return a;if(1===n.length)return _n(Mn(a,0),[n[0],1,1]);if(2===n.length)return _n(Mn(Mn(a,0),0),[n[0],n[1],1,1]);if(3===n.length)return _n(Mn(Mn(Mn(a,0),0),0),[n[0],n[1],n[2],1,1]);throw new Error(`eye() currently supports only 1D and 2D batchShapes, but received ${n.length}D.`)}});function On(t,e,n){const s={shape:t,value:e,dtype:n};return dt.runKernel("Fill",{},s)}const Bn=vt({floor_:function(t){const e={x:bt(t,"x","floor")};return dt.runKernel("Floor",e)}});const Pn=vt({gather_:function(t,e,n=0,s=0){const r={x:bt(t,"x","gather"),indices:bt(e,"indices","gather","int32")},i={axis:n,batchDims:s};return dt.runKernel("GatherV2",r,i)}});const Un=vt({greater_:function(t,e){let n=bt(t,"a","greater"),s=bt(e,"b","greater");[n,s]=at(n,s),Nn(n.shape,s.shape);const r={a:n,b:s};return dt.runKernel("Greater",r)}});const Wn=vt({greaterEqual_:function(t,e){let n=bt(t,"a","greaterEqual"),s=bt(e,"b","greaterEqual");[n,s]=at(n,s),Nn(n.shape,s.shape);const r={a:n,b:s};return dt.runKernel("GreaterEqual",r)}});const jn=vt({imag_:function(t){const e={input:bt(t,"input","imag")};return dt.runKernel("Imag",e)}});const qn=vt({isFinite_:function(t){const e={x:bt(t,"x","isFinite")};return dt.runKernel("IsFinite",e)}});const Kn=vt({isInf_:function(t){const e={x:bt(t,"x","isInf")};return dt.runKernel("IsInf",e)}});const Vn=vt({isNaN_:function(t){const e={x:bt(t,"x","isNaN")};return dt.runKernel("IsNan",e)}});const Hn=vt({leakyRelu_:function(t,e=.2){const n={x:bt(t,"x","leakyRelu")},s={alpha:e};return dt.runKernel("LeakyRelu",n,s)}});const Gn=vt({less_:function(t,e){let n=bt(t,"a","less"),s=bt(e,"b","less");[n,s]=at(n,s),Nn(n.shape,s.shape);const r={a:n,b:s};return dt.runKernel("Less",r)}});const Jn=vt({lessEqual_:function(t,e){let n=bt(t,"a","lessEqual"),s=bt(e,"b","lessEqual");[n,s]=at(n,s),Nn(n.shape,s.shape);const r={a:n,b:s};return dt.runKernel("LessEqual",r)}});const Zn=vt({localResponseNormalization_:function(t,e=5,n=1,s=1,r=.5){const i=bt(t,"x","localResponseNormalization");a(4===i.rank||3===i.rank,()=>`Error in localResponseNormalization: x must be rank 3 or 4 but got\n               rank ${i.rank}.`),a(p(e),()=>`Error in localResponseNormalization: depthRadius must be an integer but got depthRadius ${e}.`);let o=i,l=!1;3===i.rank&&(l=!0,o=Ve(i,[1,i.shape[0],i.shape[1],i.shape[2]]));const u={x:o},h={depthRadius:e,bias:n,alpha:s,beta:r},c=dt.runKernel("LRN",u,h);return l?Ve(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});const Xn=vt({log_:function(t){const e={x:bt(t,"x","log")};return dt.runKernel("Log",e)}});const Yn=vt({log1p_:function(t){const e={x:bt(t,"x","log1p")};return dt.runKernel("Log1p",e)}});function Qn(t){return dt.customGrad(t)}const ts=vt({neg_:function(t){const e={x:bt(t,"x","neg")};return dt.runKernel("Neg",e)}});const es=vt({softplus_:function(t){const e={x:bt(t,"x","softplus")};return dt.runKernel("Softplus",e)}});const ns=vt({logSigmoid_:function(t){const e=bt(t,"x","logSigmoid");return Qn(t=>({value:ts(es(ts(t))),gradFunc:e=>Ee(e,Ze(ts(t)))}))(e)}});const ss=vt({max_:function(t,e=null,n=!1){const s={x:bt(t,"x","max")},r={reductionIndices:e,keepDims:n};return dt.runKernel("Max",s,r)}});const rs=vt({sub_:function(t,e){let n=bt(t,"a","sub"),s=bt(e,"b","sub");[n,s]=at(n,s);const r={a:n,b:s};return dt.runKernel("Sub",r)}});const is=vt({sum_:function(t,e=null,n=!1){let s=bt(t,"x","sum");"bool"===s.dtype&&(s=se(s,"int32"));const r={x:s},i={axis:e,keepDims:n};return dt.runKernel("Sum",r,i)}});const as=vt({logSoftmax_:function(t,e=-1){const n=bt(t,"logits","logSoftmax");if(-1===e&&(e=n.rank-1),e!==n.rank-1)throw Error(`Log Softmax along a non-last dimension is not yet supported. Logits was rank ${n.rank} and axis was ${e}`);return Qn((t,n)=>{const s=ss(t,e,!0),r=rs(t,s),i=rs(se(r,"float32"),Xn(is(Rn(r),e,!0)));n([i]);return{value:i,gradFunc:(t,n)=>{const[s]=n,r=Rn(s);return rs(t,Ee(is(t,e,!0),r))}}})(n)}});function os(t,e){return function(t,e,n){const s=t.length+e.length,r=[];let i=0,a=0;for(let o=0;o<s;o++)-1===n.indexOf(o)?r.push(t[i++]):r.push(e[a++]);return r}(t,e.map(t=>1),e)}function ls(t){return t.map((t,e)=>[e,t]).sort((t,e)=>t[1]-e[1]).map(t=>t[0])}const us=vt({logSumExp_:function(t,e=null,n=!1){const s=bt(t,"x","logSumExp"),r=f(e,s.shape),i=ss(s,r,!0),a=rs(s,i),o=Rn(a),l=is(o,r),u=Xn(l),h=Ie(Ve(i,u.shape),u);if(n){const t=os(h.shape,r);return Ve(h,t)}return h}});const hs=vt({logicalAnd_:function(t,e){const n=bt(t,"a","logicalAnd","bool"),s=bt(e,"b","logicalAnd","bool");Nn(n.shape,s.shape);const r={a:n,b:s};return dt.runKernel("LogicalAnd",r)}});const cs=vt({logicalNot_:function(t){const e={x:bt(t,"x","logicalNot","bool")};return dt.runKernel("LogicalNot",e)}});const ps=vt({logicalOr_:function(t,e){const n=bt(t,"a","logicalOr","bool"),s=bt(e,"b","logicalOr","bool");Nn(n.shape,s.shape);const r={a:n,b:s};return dt.runKernel("LogicalOr",r)}});const ds=vt({logicalXor_:function(t,e){const n=bt(t,"a","logicalXor","bool"),s=bt(e,"b","logicalXor","bool");return Nn(n.shape,s.shape),hs(ps(t,e),cs(hs(t,e)))}});const fs=vt({maxPool_:function(t,e,n,s,r){const i=bt(t,"x","maxPool");let o=i,l=!1;3===i.rank&&(l=!0,o=Ve(i,[1,i.shape[0],i.shape[1],i.shape[2]])),a(4===o.rank,()=>`Error in maxPool: input must be rank 4 but got rank ${o.rank}.`),a(Ke(n,1),()=>`Error in maxPool: Either strides or dilations must be 1. Got strides ${n} and dilations '1'`),null!=r&&a(p(s),()=>`Error in maxPool: pad must be an integer when using, dimRoundingMode ${r} but got pad ${s}.`);const u={x:o},h={filterSize:e,strides:n,pad:s,dimRoundingMode:r},c=dt.runKernel("MaxPool",u,h);return l?Ve(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});const ms=vt({maxPool3d_:function(t,e=[1,1,1],n,s,r,i="NDHWC"){const o=bt(t,"x","maxPool3d");let l=o,u=!1;4===o.rank&&(u=!0,l=Ve(o,[1,o.shape[0],o.shape[1],o.shape[2],o.shape[3]])),a(5===l.rank,()=>`Error in maxPool3d: x must be rank 5 but got rank ${l.rank}.`),a("NDHWC"===i,()=>"Error in maxPool3d: Only NDHWC is currently supported, but got dataFormat of "+i),null!=r&&a(p(s),()=>`Error in maxPool3d: pad must be an integer when using, dimRoundingMode ${r} but got pad ${s}.`);const h={x:l},c={filterSize:e,strides:n,pad:s,dimRoundingMode:r,dataFormat:i},d=dt.runKernel("MaxPool3D",h,c);return u?Ve(d,[d.shape[1],d.shape[2],d.shape[3],d.shape[4]]):d}});const gs=vt({maximum_:function(t,e){let n=bt(t,"a","maximum"),s=bt(e,"b","maximum");[n,s]=at(n,s),"bool"===n.dtype&&(n=se(n,"int32"),s=se(s,"int32")),Nn(n.shape,s.shape);const r={a:n,b:s};return dt.runKernel("Maximum",r)}});const ys=vt({mean_:function(t,e=null,n=!1){const s={x:bt(t,"x","mean")},r={axis:e,keepDims:n};return dt.runKernel("Mean",s,r)}});const bs=vt({min_:function(t,e=null,n=!1){const s={x:bt(t,"x","min")},r={axis:e,keepDims:n};return dt.runKernel("Min",s,r)}});const ws=vt({minimum_:function(t,e){let n=bt(t,"a","minimum"),s=bt(e,"b","minimum");[n,s]=at(n,s),"bool"===n.dtype&&(n=se(n,"int32"),s=se(s,"int32")),Nn(n.shape,s.shape);const r={a:n,b:s};return dt.runKernel("Minimum",r)}});const vs=vt({mirrorPad_:function(t,e,n){a("reflect"===n||"symmetric"===n,()=>`Invalid mode. Mode must be either reflect or symmetric. Got ${n}.`);const s=bt(t,"x","mirrorPad");if(0===s.rank)throw new Error("mirrorPad(scalar) is not defined. Pass non-scalar to mirrorPad");a(e.length===s.rank,()=>`Padding doesn't match input. Must be ${s.rank}. Got ${e.length}.`);const r="reflect"===n?1:0;for(let t=0;t<s.rank;t++)a(2===e[t].length,()=>"Invalid number of paddings. Must be length of 2 each."),a(e[t][0]>=0&&e[t][0]<=s.shape[t]-r&&e[t][1]>=0&&e[t][1]<=s.shape[t]-r,()=>`Padding in dimension ${t} cannot be greater than or equal to ${s.shape[t]-r} or less than 0 for input of shape `+s.shape);const i={paddings:e,mode:n},o={x:s};return dt.runKernel("MirrorPad",o,i)}});const ks=vt({mod_:function(t,e){let n=bt(t,"a","mod"),s=bt(e,"b","mod");[n,s]=at(n,s);const r={a:n,b:s};return dt.runKernel("Mod",r)}});const xs=vt({square_:function(t){const e=bt(t,"x","square");return dt.runKernel("Square",{x:e},{})}});const Ss=vt({moments_:function(t,e=null,n=!1){const s=f(e,(t=bt(t,"x","moments")).shape),r=ys(t,s,n);let i=r.shape;n||(i=os(r.shape,s));const a=xs(rs(se(t,"float32"),Ve(r,i)));return{mean:r,variance:ys(a,s,n)}}});const Is=vt({notEqual_:function(t,e){let n=bt(t,"a","notEqual"),s=bt(e,"b","notEqual");[n,s]=at(n,s),Nn(n.shape,s.shape);const r={a:n,b:s};return dt.runKernel("NotEqual",r)}});function Ns(t,e="float32"){if("complex64"===e){const e=Ns(t,"float32"),n=Ns(t,"float32");return kt(e,n)}const n=S(h(t),e);return dt.makeTensor(n,t,e)}function As(t,e="float32"){if("complex64"===e){const e=As(t,"float32"),n=Ns(t,"float32");return kt(e,n)}const n=x(h(t),e);return dt.makeTensor(n,t,e)}const Es=vt({onesLike_:function(t){const e={x:bt(t,"x","onesLike")};return dt.runKernel("OnesLike",e)}});const Ts=vt({pad_:function(t,e,n=0){const s=bt(t,"x","pad");if(0===s.rank)throw new Error("pad(scalar) is not defined. Pass non-scalar to pad");const r={paddings:e,constantValue:n},i={x:s};return dt.runKernel("PadV2",i,r)}});const Ds=vt({spaceToBatchND_:function(t,e,n){const s=bt(t,"x","spaceToBatchND");a(s.rank>=1+e.length,()=>`input rank ${s.rank} should be > than [blockShape] ${e.length}`),a(n.length===e.length,()=>`paddings.shape[0] ${n.length} must be equal to [blockShape] ${e.length}`),a(s.shape.reduce((t,s,r)=>r>0&&r<=e.length?t&&(s+n[r-1][0]+n[r-1][1])%e[r-1]==0:t,!0),()=>`input spatial dimensions ${s.shape.slice(1)} with paddings ${n.toString()} must be divisible by blockShapes ${e.toString()}`);const r={x:s},i={blockShape:e,paddings:n};return dt.runKernel("SpaceToBatchND",r,i)}});const zs=vt({pool_:function(t,e,n,s,r,i){null==r&&(r=[1,1]),null==i&&(i=1),0===s&&(s="valid");const o=bt(t,"x","maxPool");let l=o,u=!1;3===o.rank&&(u=!0,l=Ve(o,[1,o.shape[0],o.shape[1],o.shape[2]])),a(Ke(i,r),()=>`Error in pool: Either strides or dilations must be 1. Got strides ${i} and dilations '${r}'`);const h=function(t,e,n,s,r,i,a="channelsLast"){const[o,l]=Ue(e);let u;if("channelsLast"===a)u=[o,l,t[3],t[3]];else{if("channelsFirst"!==a)throw new Error("Unknown dataFormat "+a);u=[o,l,t[1],t[1]]}return Pe(t,u,n,s,r,i,!1,a)}(l.shape,e,i,r,s),c=[h.dilationHeight,h.dilationWidth];let p;p="same"===s?function(t,e){const n=t.map((t,n)=>t+(t-1)*(e[n]-1)).map(t=>t-1),s=n.map(t=>Math.floor(t/2)),r=n.map((t,e)=>t-s[e]);return n.map((t,e)=>[s[e],r[e]])}([h.filterHeight,h.filterWidth],c):[[0,0],[0,0]];const d=1===c[0]&&1===c[1],[f,m]=function(t,e,n){const s=n.map(t=>t[0]),r=n.map(t=>t[1]),i=t.concat(s,r),a=e.map((t,e)=>(t-i[e]%t)%t),o=r.map((t,e)=>t+a[e]),l=e.map((t,e)=>[s[e],o[e]]),u=e.map((t,e)=>[0,a[e]]);return[l,u]}([h.inHeight,h.inWidth],c,p),g=d?s:"valid",y=d?l:Ds(l,c,f),b=("avg"===n?()=>He(y,e,i,g):()=>fs(y,e,i,g))(),w=d?b:Qe(b,c,m);return u?Ve(w,[w.shape[1],w.shape[2],w.shape[3]]):w}});const Cs=vt({pow_:function(t,e){let n=bt(t,"base","pow"),s=bt(e,"exp","pow");[n,s]=at(n,s);const r={a:n,b:s};return dt.runKernel("Pow",r)}});const Fs=vt({prelu_:function(t,e){const n={x:bt(t,"x","prelu"),alpha:bt(e,"alpha","prelu")};return dt.runKernel("Prelu",n)}});const Rs=vt({prod_:function(t,e=null,n=!1){let s=bt(t,"x","prod");"bool"===s.dtype&&(s=se(s,"int32"));const r={x:s},i={axis:e,keepDims:n};return dt.runKernel("Prod",r,i)}});"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self&&self;function Ms(t,e){return t(e={exports:{}},e.exports),e.exports}var Ls=Ms((function(t){!function(t,e,n){function s(t){var e,n=this,s=(e=4022871197,function(t){t=t.toString();for(var n=0;n<t.length;n++){var s=.02519603282416938*(e+=t.charCodeAt(n));s-=e=s>>>0,e=(s*=e)>>>0,e+=4294967296*(s-=e)}return 2.3283064365386963e-10*(e>>>0)});n.next=function(){var t=2091639*n.s0+2.3283064365386963e-10*n.c;return n.s0=n.s1,n.s1=n.s2,n.s2=t-(n.c=0|t)},n.c=1,n.s0=s(" "),n.s1=s(" "),n.s2=s(" "),n.s0-=s(t),n.s0<0&&(n.s0+=1),n.s1-=s(t),n.s1<0&&(n.s1+=1),n.s2-=s(t),n.s2<0&&(n.s2+=1),s=null}function r(t,e){return e.c=t.c,e.s0=t.s0,e.s1=t.s1,e.s2=t.s2,e}function i(t,e){var n=new s(t),i=e&&e.state,a=n.next;return a.int32=function(){return 4294967296*n.next()|0},a.double=function(){return a()+11102230246251565e-32*(2097152*a()|0)},a.quick=a,i&&("object"==typeof i&&r(i,n),a.state=function(){return r(n,{})}),a}e&&e.exports?e.exports=i:n&&n.amd?n((function(){return i})):this.alea=i}(0,t,!1)})),_s=Ms((function(t){!function(t,e,n){function s(t){var e=this,n="";e.x=0,e.y=0,e.z=0,e.w=0,e.next=function(){var t=e.x^e.x<<11;return e.x=e.y,e.y=e.z,e.z=e.w,e.w^=e.w>>>19^t^t>>>8},t===(0|t)?e.x=t:n+=t;for(var s=0;s<n.length+64;s++)e.x^=0|n.charCodeAt(s),e.next()}function r(t,e){return e.x=t.x,e.y=t.y,e.z=t.z,e.w=t.w,e}function i(t,e){var n=new s(t),i=e&&e.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},a.int32=n.next,a.quick=a,i&&("object"==typeof i&&r(i,n),a.state=function(){return r(n,{})}),a}e&&e.exports?e.exports=i:n&&n.amd?n((function(){return i})):this.xor128=i}(0,t,!1)})),$s=Ms((function(t){!function(t,e,n){function s(t){var e=this,n="";e.next=function(){var t=e.x^e.x>>>2;return e.x=e.y,e.y=e.z,e.z=e.w,e.w=e.v,(e.d=e.d+362437|0)+(e.v=e.v^e.v<<4^t^t<<1)|0},e.x=0,e.y=0,e.z=0,e.w=0,e.v=0,t===(0|t)?e.x=t:n+=t;for(var s=0;s<n.length+64;s++)e.x^=0|n.charCodeAt(s),s==n.length&&(e.d=e.x<<10^e.x>>>4),e.next()}function r(t,e){return e.x=t.x,e.y=t.y,e.z=t.z,e.w=t.w,e.v=t.v,e.d=t.d,e}function i(t,e){var n=new s(t),i=e&&e.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},a.int32=n.next,a.quick=a,i&&("object"==typeof i&&r(i,n),a.state=function(){return r(n,{})}),a}e&&e.exports?e.exports=i:n&&n.amd?n((function(){return i})):this.xorwow=i}(0,t,!1)})),Os=Ms((function(t){!function(t,e,n){function s(t){var e=this;e.next=function(){var t,n,s=e.x,r=e.i;return t=s[r],n=(t^=t>>>7)^t<<24,n^=(t=s[r+1&7])^t>>>10,n^=(t=s[r+3&7])^t>>>3,n^=(t=s[r+4&7])^t<<7,t=s[r+7&7],n^=(t^=t<<13)^t<<9,s[r]=n,e.i=r+1&7,n},function(t,e){var n,s=[];if(e===(0|e))s[0]=e;else for(e=""+e,n=0;n<e.length;++n)s[7&n]=s[7&n]<<15^e.charCodeAt(n)+s[n+1&7]<<13;for(;s.length<8;)s.push(0);for(n=0;n<8&&0===s[n];++n);for(8==n?s[7]=-1:s[n],t.x=s,t.i=0,n=256;n>0;--n)t.next()}(e,t)}function r(t,e){return e.x=t.x.slice(),e.i=t.i,e}function i(t,e){null==t&&(t=+new Date);var n=new s(t),i=e&&e.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},a.int32=n.next,a.quick=a,i&&(i.x&&r(i,n),a.state=function(){return r(n,{})}),a}e&&e.exports?e.exports=i:n&&n.amd?n((function(){return i})):this.xorshift7=i}(0,t,!1)})),Bs=Ms((function(t){!function(t,e,n){function s(t){var e=this;e.next=function(){var t,n,s=e.w,r=e.X,i=e.i;return e.w=s=s+1640531527|0,n=r[i+34&127],t=r[i=i+1&127],n^=n<<13,t^=t<<17,n^=n>>>15,t^=t>>>12,n=r[i]=n^t,e.i=i,n+(s^s>>>16)|0},function(t,e){var n,s,r,i,a,o=[],l=128;for(e===(0|e)?(s=e,e=null):(e+="\0",s=0,l=Math.max(l,e.length)),r=0,i=-32;i<l;++i)e&&(s^=e.charCodeAt((i+32)%e.length)),0===i&&(a=s),s^=s<<10,s^=s>>>15,s^=s<<4,s^=s>>>13,i>=0&&(a=a+1640531527|0,r=0==(n=o[127&i]^=s+a)?r+1:0);for(r>=128&&(o[127&(e&&e.length||0)]=-1),r=127,i=512;i>0;--i)s=o[r+34&127],n=o[r=r+1&127],s^=s<<13,n^=n<<17,s^=s>>>15,n^=n>>>12,o[r]=s^n;t.w=a,t.X=o,t.i=r}(e,t)}function r(t,e){return e.i=t.i,e.w=t.w,e.X=t.X.slice(),e}function i(t,e){null==t&&(t=+new Date);var n=new s(t),i=e&&e.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},a.int32=n.next,a.quick=a,i&&(i.X&&r(i,n),a.state=function(){return r(n,{})}),a}e&&e.exports?e.exports=i:n&&n.amd?n((function(){return i})):this.xor4096=i}(0,t,!1)})),Ps=Ms((function(t){!function(t,e,n){function s(t){var e=this,n="";e.next=function(){var t=e.b,n=e.c,s=e.d,r=e.a;return t=t<<25^t>>>7^n,n=n-s|0,s=s<<24^s>>>8^r,r=r-t|0,e.b=t=t<<20^t>>>12^n,e.c=n=n-s|0,e.d=s<<16^n>>>16^r,e.a=r-t|0},e.a=0,e.b=0,e.c=-1640531527,e.d=1367130551,t===Math.floor(t)?(e.a=t/4294967296|0,e.b=0|t):n+=t;for(var s=0;s<n.length+20;s++)e.b^=0|n.charCodeAt(s),e.next()}function r(t,e){return e.a=t.a,e.b=t.b,e.c=t.c,e.d=t.d,e}function i(t,e){var n=new s(t),i=e&&e.state,a=function(){return(n.next()>>>0)/4294967296};return a.double=function(){do{var t=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===t);return t},a.int32=n.next,a.quick=a,i&&("object"==typeof i&&r(i,n),a.state=function(){return r(n,{})}),a}e&&e.exports?e.exports=i:n&&n.amd?n((function(){return i})):this.tychei=i}(0,t,!1)})),Us=Ms((function(t){!function(e,n){var s,r=this,i=n.pow(256,6),a=n.pow(2,52),o=2*a;function l(t,l,d){var f=[],m=c(function t(e,n){var s,r=[],i=typeof e;if(n&&"object"==i)for(s in e)try{r.push(t(e[s],n-1))}catch(t){}return r.length?r:"string"==i?e:e+"\0"}((l=1==l?{entropy:!0}:l||{}).entropy?[t,p(e)]:null==t?function(){try{var t;return s&&(t=s.randomBytes)?t=t(256):(t=new Uint8Array(256),(r.crypto||r.msCrypto).getRandomValues(t)),p(t)}catch(t){var n=r.navigator,i=n&&n.plugins;return[+new Date,r,i,r.screen,p(e)]}}():t,3),f),g=new u(f),y=function(){for(var t=g.g(6),e=i,n=0;t<a;)t=256*(t+n),e*=256,n=g.g(1);for(;t>=o;)t/=2,e/=2,n>>>=1;return(t+n)/e};return y.int32=function(){return 0|g.g(4)},y.quick=function(){return g.g(4)/4294967296},y.double=y,c(p(g.S),e),(l.pass||d||function(t,e,s,r){return r&&(r.S&&h(r,g),t.state=function(){return h(g,{})}),s?(n.random=t,e):t})(y,m,"global"in l?l.global:this==n,l.state)}function u(t){var e,n=t.length,s=this,r=0,i=s.i=s.j=0,a=s.S=[];for(n||(t=[n++]);r<256;)a[r]=r++;for(r=0;r<256;r++)a[r]=a[i=255&i+t[r%n]+(e=a[r])],a[i]=e;(s.g=function(t){for(var e,n=0,r=s.i,i=s.j,a=s.S;t--;)e=a[r=255&r+1],n=256*n+a[255&(a[r]=a[i=255&i+e])+(a[i]=e)];return s.i=r,s.j=i,n})(256)}function h(t,e){return e.i=t.i,e.j=t.j,e.S=t.S.slice(),e}function c(t,e){for(var n,s=t+"",r=0;r<s.length;)e[255&r]=255&(n^=19*e[255&r])+s.charCodeAt(r++);return p(e)}function p(t){return String.fromCharCode.apply(0,t)}if(n.seedrandom=l,c(n.random(),e),t.exports){t.exports=l;try{s=require("crypto")}catch(t){}}}([],Math)}));Us.alea=Ls,Us.xor128=_s,Us.xorwow=$s,Us.xorshift7=Os,Us.xor4096=Bs,Us.tychei=Ps;var Ws=Us.alea;class js{constructor(t,e,n,s,r){this.mean=t,this.stdDev=e,this.dtype=n,this.nextVal=NaN,this.truncated=s,this.truncated&&(this.upper=this.mean+2*this.stdDev,this.lower=this.mean-2*this.stdDev);const i=r||Math.random();this.random=Ws(i.toString())}nextValue(){if(!isNaN(this.nextVal)){const t=this.nextVal;return this.nextVal=NaN,t}let t,e,n=!1;for(;!n;){let s,r,i;do{s=2*this.random()-1,r=2*this.random()-1,i=s*s+r*r}while(i>=1||0===i);const a=Math.sqrt(-2*Math.log(i)/i);t=this.mean+this.stdDev*s*a,e=this.mean+this.stdDev*r*a,this.truncated&&!this.isValidTruncated(t)||(n=!0)}return this.truncated&&!this.isValidTruncated(e)||(this.nextVal=this.convertValue(e)),this.convertValue(t)}convertValue(t){return null==this.dtype||"float32"===this.dtype?t:Math.round(t)}isValidTruncated(t){return t<=this.upper&&t>=this.lower}}class qs{constructor(t=0,e=1,n,s){if(this.canReturnFloat=()=>null==this.dtype||"float32"===this.dtype,this.min=t,this.range=e-t,this.dtype=n,null==s&&(s=Math.random()),"number"==typeof s&&(s=s.toString()),!this.canReturnFloat()&&this.range<=1)throw new Error(`The difference between ${t} - ${e} <= 1 and dtype is not float`);this.random=Ws(s)}convertValue(t){return this.canReturnFloat()?t:Math.round(t)}nextValue(){return this.convertValue(this.min+this.range*this.random())}}const Ks=vt({randomNormal_:function(t,e=0,n=1,s,r){if(null!=s&&"bool"===s)throw new Error("Unsupported data type "+s);const i=new js(e,n,s,!1,r),a=ne(t,s);for(let t=0;t<a.values.length;t++)a.values[t]=i.nextValue();return a.toTensor()}});const Vs=vt({randomUniform_:function(t,e=0,n=1,s="float32",r){const i=ne(t,s),a=new qs(e,n,null,r);for(let t=0;t<i.values.length;t++)i.values[t]=a.nextValue();return i.toTensor()}});function Hs(t,e,n=1,s="float32"){if(0===n)throw new Error("Cannot have a step of zero");const r={start:t,stop:e,step:n,dtype:s};return dt.runKernel("Range",{},r)}const Gs=vt({real_:function(t){const e={input:bt(t,"input","real")};return dt.runKernel("Real",e)}});const Js=vt({reciprocal_:function(t){const e={x:bt(t,"x","reciprocal")};return dt.runKernel("Reciprocal",e)}});const Zs=vt({relu_:function(t){const e={x:bt(t,"x","relu")};return dt.runKernel("Relu",e)}});const Xs=vt({relu6_:function(t){const e={x:bt(t,"x","relu6")};return dt.runKernel("Relu6",e)}});const Ys=vt({reverse_:function(t,e){const n={x:bt(t,"x","reverse")},s={dims:e};return dt.runKernel("Reverse",n,s)}});const Qs=vt({round_:function(t){const e={x:bt(t,"x","round")};return dt.runKernel("Round",e)}});const tr=vt({rsqrt_:function(t){const e={x:bt(t,"x","rsqrt")};return dt.runKernel("Rsqrt",e)}});function er(t,e){if((m(t)&&"string"!==e||Array.isArray(t))&&"complex64"!==e)throw new Error("Error creating a new Scalar: value must be a primitive (number|boolean|string)");if("string"===e&&m(t)&&!(t instanceof Uint8Array))throw new Error("When making a scalar from encoded string, the value must be `Uint8Array`.");return xt(t,[],[],e)}const nr=vt({selu_:function(t){const e={x:bt(t,"x","selu")};return dt.runKernel("Selu",e)}});const sr=vt({separableConv2d_:function(t,e,n,s,r,i=[1,1],o="NHWC"){const l=bt(t,"x","separableConv2d"),u=bt(e,"depthwiseFilter","separableConv2d"),h=bt(n,"pointwiseFilter","separableConv2d");let c=l,p=!1;if(3===l.rank&&(p=!0,c=Ve(l,[1,l.shape[0],l.shape[1],l.shape[2]])),"NCHW"===o)throw new Error("separableConv2d currently does not support dataFormat NCHW; only NHWC is supported");a(4===c.rank,()=>`Error in separableConv2d: input must be rank 4, but got rank ${c.rank}.`),a(4===u.rank,()=>`Error in separableConv2d: depthwise filter must be rank 4, but got rank ${u.rank}.`),a(4===h.rank,()=>`Error in separableConv2d: pointwise filter must be rank 4, but got rank ${u.rank}.`),a(1===h.shape[0],()=>`Error in separableConv2d: the first dimension of pointwise filter  must be 1, but got ${h.shape[0]}.`),a(1===h.shape[1],()=>`Error in separableConv2d: the second dimension of pointwise filter must be 1, but got ${h.shape[1]}.`);const d=u.shape[2],f=u.shape[3];a(h.shape[2]===d*f,()=>`Error in separableConv2d: the third dimension of pointwise filter must be ${d*f}, but got ${h.shape[2]}.`);const m=xn(c,u,s,r,o,i),g=pn(m,h,1,"valid",o);return p?Ve(g,[g.shape[1],g.shape[2],g.shape[3]]):g}});const rr=vt({sign_:function(t){const e={x:bt(t,"x","sign")};return dt.runKernel("Sign",e)}});const ir=vt({sin_:function(t){const e={x:bt(t,"x","sin")};return dt.runKernel("Sin",e)}});const ar=vt({sinh_:function(t){const e={x:bt(t,"x","sinh")};return dt.runKernel("Sinh",e)}});const or=vt({slice1d_:function(t,e,n){const s=bt(t,"x","slice1d");return a(1===s.rank,()=>`slice1d expects a rank-1 tensor, but got a rank-${s.rank} tensor`),Xe(s,[e],[n])}});const lr=vt({slice2d_:function(t,e,n){const s=bt(t,"x","slice2d");return a(2===s.rank,()=>`slice2d expects a rank-2 tensor, but got a rank-${s.rank} tensor`),Xe(s,e,n)}});const ur=vt({slice3d_:function(t,e,n){const s=bt(t,"x","slice3d");return a(3===s.rank,()=>`slice3d expects a rank-3 tensor, but got a rank-${s.rank} tensor`),Xe(s,e,n)}});const hr=vt({slice4d_:function(t,e,n){const s=bt(t,"x","slice4d");return a(4===s.rank,()=>`slice4d expects a rank-4 tensor, but got a rank-${s.rank} tensor`),Xe(s,e,n)}});const cr=vt({softmax_:function(t,e=-1){const n=bt(t,"logits","softmax","float32");if(-1===e&&(e=n.rank-1),e!==n.rank-1)throw Error(`Softmax along a non-last dimension is not yet supported. Logits was rank ${n.rank} and dim was ${e}`);const s={logits:n},r={dim:e};return dt.runKernel("Softmax",s,r)}});const pr=vt({fft_:function(t){a("complex64"===t.dtype,()=>`The dtype for tf.spectral.fft() must be complex64 but got ${t.dtype}.`);const e={input:t};return dt.runKernel("FFT",e)}});const dr=vt({ifft_:function(t){a("complex64"===t.dtype,()=>`The dtype for tf.spectral.ifft() must be complex64 but got ${t.dtype}.`);const e={input:t};return dt.runKernel("IFFT",e)}});const fr=vt({irfft_:function(t){const e=t.shape[t.shape.length-1],n=t.size/e;let s;if(e<=2){const r=Ve(t,[n,e]);s=dr(r)}else{const r=[n,2*(e-1)],i=Ve(Gs(t),[n,e]),a=Ve(jn(t),[n,e]),o=Ys(Xe(i,[0,1],[n,e-2]),1),l=Ee(Ys(Xe(a,[0,1],[n,e-2]),1),er(-1)),u=Je([i,o],1),h=Je([a,l],1),c=Ve(kt(u,h),[r[0],r[1]]);s=dr(c)}if(s=Gs(s),3===t.rank&&0!==t.shape[0]){const e=s,n=t.shape[0];s=Ve(s,[n,s.shape[0]/n,s.shape[1]]),e.dispose()}return s}});const mr=vt({split_:function(t,e,n=0){const s={x:bt(t,"x","split")},r={numOrSizeSplits:e,axis:n};return dt.runKernel("SplitV",s,r)}});const gr=vt({rfft_:function(t,e){a("float32"===t.dtype,()=>"The dtype for rfft() must be real value but got "+t.dtype);let n=t.shape[t.shape.length-1];const s=t.size/n;let r;if(null!=e&&e<n){const s=t.shape.map(t=>0),i=t.shape.map(t=>t);i[t.shape.length-1]=e,r=Xe(t,s,i),n=e}else if(null!=e&&e>n){const s=t.shape.map(t=>t);s[t.shape.length-1]=e-n,r=Je([t,Ns(s)],t.shape.length-1),n=e}else r=t;const i=Tn(r),o=Ve(kt(r,i),[s,n]),l=pr(o),u=Math.floor(n/2)+1,h=Gs(l),c=jn(l),p=mr(h,[u,n-u],h.shape.length-1),d=mr(c,[u,n-u],c.shape.length-1),f=r.shape.slice();return f[r.shape.length-1]=u,Ve(kt(p[0],d[0]),f)}});const yr=vt({sqrt_:function(t){const e={x:bt(t,"x","sqrt")};return dt.runKernel("Sqrt",e)}});const br=vt({squaredDifference_:function(t,e){let n=bt(t,"a","squaredDifference"),s=bt(e,"b","squaredDifference");[n,s]=at(n,s),Nn(n.shape,s.shape);const r={a:n,b:s};return dt.runKernel("SquaredDifference",r,{})}});const wr=vt({squeeze_:function(t,e){const n=bt(t,"x","squeeze");return Ve(n,function(t,e){const n=[],s=[],r=null!=e&&Array.isArray(e)&&0===e.length,i=null==e||r?null:f(e,t).sort();let a=0;for(let e=0;e<t.length;++e){if(null!=i){if(i[a]===e&&1!==t[e])throw new Error(`Can't squeeze axis ${e} since its dim '${t[e]}' is not 1`);(null==i[a]||i[a]>e)&&1===t[e]&&(n.push(t[e]),s.push(e)),i[a]<=e&&a++}1!==t[e]&&(n.push(t[e]),s.push(e))}return{newShape:n,keptDims:s}}(n.shape,e).newShape)}});const vr=vt({stack_:function(t,e=0){const n=wt(t,"tensors","stack","string_or_numeric");a(n.length>=1,()=>"Pass at least one tensor to tf.stack"),n.length>0&&a(e<=n[0].rank,()=>"Axis must be <= rank of the tensor");const s=n,r={axis:e};return dt.runKernel("Pack",s,r)}});const kr=vt({step_:function(t,e=0){const n={x:bt(t,"x","step")},s={alpha:e};return dt.runKernel("Step",n,s)}});const xr=vt({stridedSlice_:function(t,e,n,s,r=0,i=0,a=0,o=0,l=0){const u={x:bt(t,"x","stridedSlice")},h={begin:e,end:n,strides:s,beginMask:r,endMask:i,ellipsisMask:a,newAxisMask:o,shrinkAxisMask:l};return dt.runKernel("StridedSlice",u,h)}});const Sr=vt({tan_:function(t){const e={x:bt(t,"x","tan")};return dt.runKernel("Tan",e)}});function Ir(t,e){l(t);const n=gt(t,e);if(1!==n.length)throw new Error("tensor1d() requires values to be a flat/TypedArray");return xt(t,null,n,e)}function Nr(t,e,n){if(l(t),null!=e&&2!==e.length)throw new Error("tensor2d() requires shape to have two numbers");const s=gt(t,n);if(2!==s.length&&1!==s.length)throw new Error("tensor2d() requires values to be number[][] or flat/TypedArray");if(1===s.length&&null==e)throw new Error("tensor2d() requires shape to be provided when `values` are a flat/TypedArray");return xt(t,e,s,n)}const Ar=vt({topk_:function(t,e=1,n=!0){const s=bt(t,"x","topk");if(0===s.rank)throw new Error("topk() expects the input to be of rank 1 or higher");const r=s.shape[s.shape.length-1];if(e>r)throw new Error(`'k' passed to topk() must be <= the last dimension (${r}) but got `+e);const i={x:s},a={k:e,sorted:n},[o,l]=dt.runKernel("TopK",i,a);return{values:o,indices:l}}});const Er=vt({truncatedNormal_:function(t,e=0,n=1,s,r){if(null!=s&&"bool"===s)throw new Error("Unsupported data type $ { dtype }");const i=new js(e,n,s,!0,r),a=ne(t,s);for(let t=0;t<a.values.length;t++)a.values[t]=i.nextValue();return a.toTensor()}});const Tr=vt({unique_:function(t,e=0){const n=bt(t,"x","unique","string_or_numeric");a(n.rank>0,()=>"The input tensor must be at least 1D");const s={x:n},r={axis:e},[i,o]=dt.runKernel("Unique",s,r);return{values:i,indices:o}}});const Dr=vt({unsortedSegmentSum_:function(t,e,n){const s=bt(t,"x","unsortedSegmentSum"),r=bt(e,"segmentIds","unsortedSegmentSum","int32");a(p(n),()=>"numSegments must be of dtype int");const i={x:s,segmentIds:r},o={numSegments:n};return dt.runKernel("UnsortedSegmentSum",i,o)}});const zr=vt({unstack_:function(t,e=0){const n=bt(t,"x","unstack","string_or_numeric");a(e>=-n.shape.length&&e<n.shape.length,()=>`Axis = ${e} is not in [-${n.shape.length}, ${n.shape.length})`);const s={value:n},r={axis:e};return dt.runKernel("Unpack",s,r)}});const Cr=vt({norm_:function(t,e="euclidean",n=null,s=!1){const r=function t(e,n,s=null){if(0===e.rank)return Te(e);if(1!==e.rank&&null===s)return t(Ve(e,[-1]),n,s);if(1===e.rank||"number"==typeof s||Array.isArray(s)&&1===s.length){if(1===n)return is(Te(e),s);if(n===1/0)return ss(Te(e),s);if(n===-1/0)return bs(Te(e),s);if("euclidean"===n||2===n)return yr(is(Cs(Te(e),er(2,"int32")),s));throw new Error("Error in norm: invalid ord value: "+n)}if(Array.isArray(s)&&2===s.length){if(1===n)return ss(is(Te(e),s[0]),s[1]-1);if(n===1/0)return ss(is(Te(e),s[1]),s[0]);if(n===-1/0)return bs(is(Te(e),s[1]),s[0]);if("fro"===n||"euclidean"===n)return yr(is(xs(e),s));throw new Error("Error in norm: invalid ord value: "+n)}throw new Error("Error in norm: invalid axis: "+s)}(t=bt(t,"x","norm"),e,n);let i=r.shape;if(s){const e=f(n,t.shape);i=os(r.shape,e)}return Ve(r,i)}});const Fr=vt({dropout_:function(t,e,n,s){const r=bt(t,"x","dropout");if(a("float32"===r.dtype,()=>`x has to be a floating point tensor since it's going to be scaled, but got a ${r.dtype} tensor instead.`),a(e>=0&&e<1,()=>`rate must be a float in the range [0, 1), but got ${e}.`),0===e)return t instanceof X?r.clone():r;const i=function(t,e){if(null==e)return t.shape.slice();if(c(t.shape,e))return e;if(t.shape.length===e.length){const n=[];for(let s=0;s<t.shape.length;s++)null==e[s]&&null!=t.shape[s]?n.push(t.shape[s]):n.push(e[s]);return n}return e}(r,n),o=1-e,l=Ae(Bn(Ie(Vs(i,0,1,"float32",s),o)),o);return Ee(r,l)}});const Rr=vt({conv2DBackpropFilter_:function(t,e,n,s,r,i="NHWC",o){let l=t;3===t.rank&&(l=Ve(t,[1,t.shape[0],t.shape[1],t.shape[2]]));let u=e;3===u.rank&&(u=Ve(e,[1,e.shape[0],e.shape[1],e.shape[2]])),a(4===l.rank,()=>"Error in conv2dDerFilter: input must be rank 4, but got shape "+l.shape+"."),a(4===u.rank,()=>"Error in conv2dDerFilter: dy must be rank 4, but got shape "+u.shape+"."),a(4===n.length,()=>"Error in conv2dDerFilter: filterShape must be length 4, but got "+n+".");const h="NHWC"===i?l.shape[3]:l.shape[1],c="NHWC"===i?u.shape[3]:u.shape[1];a(h===n[2],()=>`Error in conv2dDerFilter: depth of input ${h}) must match input depth in filter (${n[2]}.`),a(c===n[3],()=>`Error in conv2dDerFilter: depth of dy (${c}) must match output depth for filter (${n[3]}).`),null!=o&&a(p(r),()=>`Error in conv2dDerFilter: pad must be an integer when using, dimRoundingMode ${o} but got pad ${r}.`);const d={x:l,dy:u},f={strides:s,pad:r,dataFormat:i,dimRoundingMode:o,filterShape:n};return dt.runKernel("Conv2DBackpropFilter",d,f)}});function Mr(t,e,n){if(null==n||"linear"===n)return t;if("relu"===n)return Ee(t,kr(e));throw new Error(`Cannot compute gradient for fused activation ${n}.`)}function Lr(t,e){let n=e;const s=In(t.shape,e.shape);return s.length>0&&(n=is(n,s)),Ve(n,t.shape)}function _r(t,e,n,s){if("linear"===e)return t;if("relu"===e)return Zs(t);if("elu"===e)return Cn(t);if("relu6"===e)return Xs(t);if("prelu"===e)return Fs(t,n);if("leakyrelu"===e)return Hn(t,s);throw new Error(`Unknown fused activation ${e}.`)}const $r=(t,e)=>!(t>0)||"linear"===e;const Or=vt({fusedConv2d_:function({x:t,filter:e,strides:n,pad:s,dataFormat:r="NHWC",dilations:i=[1,1],dimRoundingMode:o,bias:l,activation:u="linear",preluActivationWeights:h,leakyreluAlpha:c}){if(u=u||"linear",!1===$r(dt.state.gradientDepth,u)){let a=pn(t,e,n,s,r,i,o);return null!=l&&(a=Ie(a,l)),_r(a,u,h,c)}const d=bt(t,"x","conv2d"),f=bt(e,"filter","conv2d");let m=d,g=!1;3===d.rank&&(g=!0,m=Ve(d,[1,d.shape[0],d.shape[1],d.shape[2]])),a(4===m.rank,()=>"Error in fused conv2d: input must be rank 4, but got rank "+m.rank+"."),a(4===f.rank,()=>"Error in fused conv2d: filter must be rank 4, but got rank "+f.rank+"."),null!=o&&a(p(s),()=>`Error in fused conv2d: pad must be an integer when using, dimRoundingMode ${o} but got pad ${s}.`),a(m.shape[3]===f.shape[2],()=>`Error in conv2d: depth of input (${m.shape[3]}) must match input depth for filter ${f.shape[2]}.`),a(Ke(n,i),()=>`Error in conv2D: Either strides or dilations must be 1. Got strides ${n} and dilations '${i}'`),a("NHWC"===r,()=>`Error in conv2d: got dataFormat of ${r} but only NHWC is currently supported.`);const y=Pe(m.shape,f.shape,n,i,s,o);let b,w;null!=l&&(b=bt(l,"bias","fused conv2d"),[b]=at(b,d),Nn(y.outShape,b.shape)),null!=h&&(w=bt(h,"prelu weights","fused conv2d"));const v=(t,e)=>{const[r,o,l,h]=e,c=Mr(t,l,u);a(qe(i),()=>`Error in gradient of fused conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '${i}'`);const p=[fn(o.shape,c,r,n,s),Rr(o,c,r.shape,n,s)];if(null!=h){const t=Lr(h,c);p.push(t)}return p},k={x:m,filter:f,bias:b,preluActivationWeights:w},x={strides:n,pad:s,dataFormat:r,dilations:i,dimRoundingMode:o,activation:u,leakyreluAlpha:c};if(null==l){return Qn((t,e,n)=>{let s=dt.runKernel("FusedConv2D",k,x);return n([e,t,s]),g&&(s=Ve(s,[s.shape[1],s.shape[2],s.shape[3]])),{value:s,gradFunc:v}})(m,f)}return Qn((t,e,n,s)=>{let r=dt.runKernel("FusedConv2D",k,x);return s([e,t,r,n]),g&&(r=Ve(r,[r.shape[1],r.shape[2],r.shape[3]])),{value:r,gradFunc:v}})(m,f,b)}});const Br=vt({depthwiseConv2dNativeBackpropFilter_:function(t,e,n,s,r,i=[1,1],a){let o=t;3===t.rank&&(o=Ve(t,[1,t.shape[0],t.shape[1],t.shape[2]]));let l=e;3===l.rank&&(l=Ve(e,[1,e.shape[0],e.shape[1],e.shape[2]]));const u={x:o,dy:l},h={strides:s,pad:r,dimRoundingMode:a,dilations:i,filterShape:n};return dt.runKernel("DepthwiseConv2dNativeBackpropFilter",u,h)}});const Pr=vt({depthwiseConv2dNativeBackpropInput_:function(t,e,n,s,r,i=[1,1],a){let o=e,l=!1;3===e.rank&&(l=!0,o=Ve(e,[1,e.shape[0],e.shape[1],e.shape[2]]));const u={dy:o,filter:n},h={strides:s,pad:r,dimRoundingMode:a,dilations:i,inputShape:t},c=dt.runKernel("DepthwiseConv2dNativeBackpropInput",u,h);return l?Ve(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});const Ur=vt({fusedMatMul_:function({a:t,b:e,transposeA:n=!1,transposeB:s=!1,bias:r,activation:i="linear",preluActivationWeights:o,leakyreluAlpha:l}){if(!1===$r(dt.state.gradientDepth,i)){let a=pe(t,e,n,s);return null!=r&&(a=Ie(a,r)),_r(a,i,o,l)}let u=bt(t,"a","fused matMul"),p=bt(e,"b","fused matMul");[u,p]=at(u,p);const d=n?u.shape[u.rank-2]:u.shape[u.rank-1],f=s?p.shape[p.rank-1]:p.shape[p.rank-2],m=n?u.shape[u.rank-1]:u.shape[u.rank-2],g=s?p.shape[p.rank-2]:p.shape[p.rank-1],y=u.shape.slice(0,-2),b=p.shape.slice(0,-2),w=h(y),v=h(b);a(u.rank>=2&&p.rank>=2&&u.rank===p.rank,()=>`Error in fused matMul: inputs must have the same rank of at least 2, got ranks ${u.rank} and ${p.rank}.`),a(c(y,b),()=>`Error in fused matMul: outer dimensions (${y}) and (${b}) of Tensors with shapes ${u.shape} and `+p.shape+" must match."),a(d===f,()=>`Error in fused matMul: inner shapes (${d}) and (${f}) of Tensors with shapes ${u.shape} and ${p.shape} and transposeA=${n} and transposeB=${s} must match.`);const k=u.shape.slice(0,-2).concat([m,g]),x=Ve(u,n?[w,d,m]:[w,m,d]),S=Ve(p,s?[v,g,f]:[v,f,g]);let I,N;null!=r&&(I=bt(r,"bias","fused matMul"),[I]=at(I,u),Nn(k,I.shape)),null!=o&&(N=bt(o,"prelu weights","fused matMul"));const A=(t,e)=>{const[a,o,l,u]=e,h=Mr(Ve(t,l.shape),l,i);let c,p;if(n||s?!n&&s?(c=pe(h,o,!1,!1),p=pe(h,a,!0,!1)):n&&!s?(c=pe(o,h,!1,!0),p=pe(a,h,!1,!1)):(c=pe(o,h,!0,!0),p=pe(h,a,!0,!0)):(c=pe(h,o,!1,!0),p=pe(a,h,!0,!1)),null!=r){return[c,p,Lr(u,h)]}return[c,p]},E={a:x,b:S,bias:I,preluActivationWeights:N},T={transposeA:n,transposeB:s,activation:i,leakyreluAlpha:l};if(null==r){return Qn((t,e,n)=>{const s=dt.runKernel("_FusedMatMul",E,T);return n([t,e,s]),{value:Ve(s,k),gradFunc:A}})(x,S)}return Qn((t,e,n,s)=>{const r=dt.runKernel("_FusedMatMul",E,T);return s([t,e,r,n]),{value:Ve(r,k),gradFunc:A}})(x,S,I)}});const Wr=vt({resizeBilinear_:function(t,e,n=!1,s=!1){const r=bt(t,"images","resizeBilinear");a(3===r.rank||4===r.rank,()=>`Error in resizeBilinear: x must be rank 3 or 4, but got rank ${r.rank}.`),a(2===e.length,()=>"Error in resizeBilinear: new shape must 2D, but got shape "+e+"."),a(!1===s||!1===n,()=>"Error in resizeBilinear: If halfPixelCenters is true, alignCorners must be false.");let i=r,o=!1;3===r.rank&&(o=!0,i=Ve(r,[1,r.shape[0],r.shape[1],r.shape[2]]));const l={images:i},u={alignCorners:n,halfPixelCenters:s,size:e},h=dt.runKernel("ResizeBilinear",l,u);return o?Ve(h,[h.shape[1],h.shape[2],h.shape[3]]):h}});const jr=vt({resizeNearestNeighbor_:function(t,e,n=!1,s=!1){const r=bt(t,"images","resizeNearestNeighbor");a(3===r.rank||4===r.rank,()=>`Error in resizeNearestNeighbor: x must be rank 3 or 4, but got rank ${r.rank}.`),a(2===e.length,()=>"Error in resizeNearestNeighbor: new shape must 2D, but got shape "+e+"."),a("float32"===r.dtype||"int32"===r.dtype,()=>"`images` must have `int32` or `float32` as dtype"),a(!1===s||!1===n,()=>"Error in resizeNearestNeighbor: If halfPixelCenters is true, alignCorners must be false.");let i=r,o=!1;3===r.rank&&(o=!0,i=Ve(r,[1,r.shape[0],r.shape[1],r.shape[2]]));const l={images:i},u={alignCorners:n,halfPixelCenters:s,size:e},h=dt.runKernel("ResizeNearestNeighbor",l,u);return o?Ve(h,[h.shape[1],h.shape[2],h.shape[3]]):h}});function qr(t,e=!1){return dt.tidy(()=>{a(2===t.shape.length,()=>`qr2d() requires a 2D Tensor, but got a ${t.shape.length}D Tensor.`);const n=t.shape[0],s=t.shape[1];let r=$n(n),i=re(t);const o=Nr([[1]],[1,1]);let l=re(o);const u=n>=s?s:n;for(let t=0;t<u;++t){const e=i,a=l,u=r;[l,i,r]=dt.tidy(()=>{const e=Xe(i,[t,t],[n-t,1]),a=Cr(e),u=Xe(i,[t,t],[1,1]),h=En(Un(u,0),Nr([[-1]]),Nr([[1]])),c=rs(u,Ee(h,a)),p=Ae(e,c);l=1===p.shape[0]?re(o):Je([o,Xe(p,[1,0],[p.shape[0]-1,p.shape[1]])],0);const d=ts(Ae(pe(h,c),a)),f=Xe(i,[t,0],[n-t,s]),m=Ee(d,l),g=fe(l);if(0===t)i=rs(f,pe(m,pe(g,f)));else{const e=rs(f,pe(m,pe(g,f)));i=Je([Xe(i,[0,0],[t,s]),e],0)}const y=fe(m),b=Xe(r,[0,t],[n,r.shape[1]-t]);if(0===t)r=rs(b,pe(pe(b,l),y));else{const e=rs(b,pe(pe(b,l),y));r=Je([Xe(r,[0,0],[n,t]),e],1)}return[l,i,r]}),ke([e,a,u])}return!e&&n>s&&(r=Xe(r,[0,0],[n,s]),i=Xe(i,[0,0],[s,s])),[r,i]})}const Kr={bandPart:vt({bandPart_:function(t,e,n){a(e%1==0,()=>`bandPart(): numLower must be an integer, got ${e}.`),a(n%1==0,()=>`bandPart(): numUpper must be an integer, got ${n}.`);const s=bt(t,"a","bandPart");a(s.rank>=2,()=>`bandPart(): Rank must be at least 2, got ${s.rank}.`);const r=s.shape,[i,o]=s.shape.slice(-2);if(!(e<=i))throw new Error(`bandPart(): numLower (${e}) must not be greater than the number of rows (${i}).`);if(!(n<=o))throw new Error(`bandPart(): numUpper (${n}) must not be greater than the number of columns (${o}).`);e<0&&(e=i),n<0&&(n=o);const l=Ve(Hs(0,i,1,"int32"),[-1,1]),u=Hs(0,o,1,"int32"),h=rs(l,u),c=hs(Jn(h,er(+e,"int32")),Wn(h,er(-n,"int32"))),p=Ns([i,o],s.dtype);return Ve(vr(zr(Ve(s,[-1,i,o])).map(t=>En(c,t,p))),r)}}),gramSchmidt:vt({gramSchmidt_:function(t){let e;if(Array.isArray(t)){e=!1,a(null!=t&&t.length>0,()=>"Gram-Schmidt process: input must not be null, undefined, or empty");const n=t[0].shape[0];for(let e=1;e<t.length;++e)a(t[e].shape[0]===n,()=>`Gram-Schmidt: Non-unique lengths found in the input vectors: (${t[e].shape[0]} vs. ${n})`)}else e=!0,t=mr(t,t.shape[0],0).map(t=>wr(t,[0]));a(t.length<=t[0].shape[0],()=>`Gram-Schmidt: Number of vectors (${t.length}) exceeds number of dimensions (${t[0].shape[0]}).`);const n=[],s=t;for(let e=0;e<t.length;++e)n.push(dt.tidy(()=>{let t=s[e];if(e>0)for(let s=0;s<e;++s){const e=Ee(is(Ee(n[s],t)),n[s]);t=rs(t,e)}return Ae(t,Cr(t,"euclidean"))}));return e?vr(n,0):n}}),qr:vt({qr_:function(t,e=!1){if(a(t.rank>=2,()=>"qr() requires input tensor to have a rank >= 2, but got rank "+t.rank),2===t.rank)return qr(t,e);{const n=t.shape.slice(0,t.shape.length-2).reduce((t,e)=>t*e),s=zr(Ve(t,[n,t.shape[t.shape.length-2],t.shape[t.shape.length-1]]),0),r=[],i=[];s.forEach(t=>{const[n,s]=qr(t,e);r.push(n),i.push(s)});return[Ve(vr(r,0),t.shape),Ve(vr(i,0),t.shape)]}}})};class Vr extends ge{minimize(t,e=!1,n){const{value:s,grads:r}=this.computeGradients(t,n);if(null!=n){const t=n.map(t=>({name:t.name,tensor:r[t.name]}));this.applyGradients(t)}else this.applyGradients(r);return ke(r),e?s:(s.dispose(),null)}get iterations(){return null==this.iterations_&&(this.iterations_=0),this.iterations_}incrementIterations(){this.iterations_=this.iterations+1}computeGradients(t,e){return function(t,e){a(w(t),()=>"The f passed in variableGrads(f) must be a function"),a(null==e||Array.isArray(e)&&e.every(t=>t instanceof Q),()=>"The varList passed in variableGrads(f, varList) must be an array of variables");const n=null!=e;if(!n){e=[];for(const t in dt.registeredVariables)e.push(dt.registeredVariables[t])}const s=n?e.filter(t=>!t.trainable):null,r=e.length;a((e=e.filter(t=>t.trainable)).length>0,()=>`variableGrads() expects at least one of the input variables to be trainable, but none of the ${r} variables is trainable.`);const{value:i,grads:o}=dt.gradients(t,e,null,!0);a(o.some(t=>null!=t),()=>"Cannot find a connection between any variable and the result of the loss function y=f(x). Please make sure the operations that use variables are inside the function f passed to minimize()."),a(0===i.rank,()=>`The f passed in variableGrads(f) must return a scalar, but it returned a rank-${i.rank} tensor`);const l={};return e.forEach((t,e)=>{null!=o[e]&&(l[t.name]=o[e])}),null!=s&&s.forEach(t=>l[t.name]=null),{value:i,grads:l}}(t,e)}dispose(){null!=this.iterations_&&ke(this.iterations_)}async saveIterations(){return null==this.iterations_&&(this.iterations_=0),{name:"iter",tensor:er(this.iterations_,"int32")}}async getWeights(){throw new Error("getWeights() is not implemented for this optimizer yet.")}async setWeights(t){throw new Error("setWeights() is not implemented for this optimizer class "+this.getClassName())}async extractIterations(t){return this.iterations_=(await t[0].tensor.data())[0],t.slice(1)}}Object.defineProperty(Vr,Symbol.hasInstance,{value:t=>null!=t.minimize&&null!=t.computeGradients&&null!=t.applyGradients});class Hr extends Vr{constructor(t,e,n=null){super(),this.learningRate=t,this.rho=e,this.epsilon=n,this.accumulatedGrads=[],this.accumulatedUpdates=[],null==n&&(this.epsilon=dt.backend.epsilon())}applyGradients(t){(Array.isArray(t)?t.map(t=>t.name):Object.keys(t)).forEach((e,n)=>{const s=dt.registeredVariables[e];null==this.accumulatedGrads[n]&&(this.accumulatedGrads[n]={originalName:e+"/accum_grad",variable:ve(()=>Tn(s).variable(!1))}),null==this.accumulatedUpdates[n]&&(this.accumulatedUpdates[n]={originalName:e+"/accum_var",variable:ve(()=>Tn(s).variable(!1))});const r=Array.isArray(t)?t[n].tensor:t[e];if(null==r)return;const i=this.accumulatedGrads[n].variable,a=this.accumulatedUpdates[n].variable;ve(()=>{const t=Ie(Ee(i,this.rho),Ee(xs(r),1-this.rho)),e=Ee(Ae(yr(Ie(a,this.epsilon)),yr(Ie(i,this.epsilon))),r),n=Ie(Ee(a,this.rho),Ee(xs(e),1-this.rho));i.assign(t),a.assign(n);const o=Ie(Ee(e,-this.learningRate),s);s.assign(o)})}),this.incrementIterations()}dispose(){null!=this.accumulatedUpdates&&(ke(this.accumulatedGrads.map(t=>t.variable)),ke(this.accumulatedUpdates.map(t=>t.variable)))}async getWeights(){const t=[...this.accumulatedGrads,...this.accumulatedUpdates];return[await this.saveIterations()].concat(t.map(t=>({name:t.originalName,tensor:t.variable})))}async setWeights(t){const e=(t=await this.extractIterations(t)).length/2;this.accumulatedGrads=t.slice(0,e).map(t=>({originalName:t.name,variable:t.tensor.variable(!1)})),this.accumulatedUpdates=t.slice(e,2*e).map(t=>({originalName:t.name,variable:t.tensor.variable(!1)}))}getConfig(){return{learningRate:this.learningRate,rho:this.rho,epsilon:this.epsilon}}static fromConfig(t,e){return new t(e.learningRate,e.rho,e.epsilon)}}Hr.className="Adadelta",be(Hr);class Gr extends Vr{constructor(t,e=.1){super(),this.learningRate=t,this.initialAccumulatorValue=e,this.accumulatedGrads=[]}applyGradients(t){(Array.isArray(t)?t.map(t=>t.name):Object.keys(t)).forEach((e,n)=>{const s=dt.registeredVariables[e];if(null==this.accumulatedGrads[n]){const t=!1;this.accumulatedGrads[n]={originalName:e+"/accumulator",variable:ve(()=>On(s.shape,this.initialAccumulatorValue).variable(t))}}const r=Array.isArray(t)?t[n].tensor:t[e];if(null==r)return;const i=this.accumulatedGrads[n].variable;ve(()=>{const t=Ie(i,xs(r));i.assign(t);const e=Ie(Ee(Ae(r,yr(Ie(t,dt.backend.epsilon()))),-this.learningRate),s);s.assign(e)})}),this.incrementIterations()}dispose(){null!=this.accumulatedGrads&&ke(this.accumulatedGrads.map(t=>t.variable))}async getWeights(){return[await this.saveIterations()].concat(this.accumulatedGrads.map(t=>({name:t.originalName,tensor:t.variable})))}async setWeights(t){t=await this.extractIterations(t);this.accumulatedGrads=t.map(t=>({originalName:t.name,variable:t.tensor.variable(!1)}))}getConfig(){return{learningRate:this.learningRate,initialAccumulatorValue:this.initialAccumulatorValue}}static fromConfig(t,e){return new t(e.learningRate,e.initialAccumulatorValue)}}Gr.className="Adagrad",be(Gr);class Jr extends Vr{constructor(t,e,n,s=null){super(),this.learningRate=t,this.beta1=e,this.beta2=n,this.epsilon=s,this.accumulatedFirstMoment=[],this.accumulatedSecondMoment=[],ve(()=>{this.accBeta1=er(e).variable(),this.accBeta2=er(n).variable()}),null==s&&(this.epsilon=dt.backend.epsilon())}applyGradients(t){const e=Array.isArray(t)?t.map(t=>t.name):Object.keys(t);ve(()=>{const n=rs(1,this.accBeta1),s=rs(1,this.accBeta2);e.forEach((e,r)=>{const i=dt.registeredVariables[e];null==this.accumulatedFirstMoment[r]&&(this.accumulatedFirstMoment[r]={originalName:e+"/m",variable:ve(()=>Tn(i).variable(!1))}),null==this.accumulatedSecondMoment[r]&&(this.accumulatedSecondMoment[r]={originalName:e+"/v",variable:ve(()=>Tn(i).variable(!1))});const a=Array.isArray(t)?t[r].tensor:t[e];if(null==a)return;const o=this.accumulatedFirstMoment[r].variable,l=this.accumulatedSecondMoment[r].variable,u=Ie(Ee(o,this.beta1),Ee(a,1-this.beta1)),h=Ie(Ee(l,this.beta2),Ee(xs(a),1-this.beta2)),c=Ae(u,n),p=Ae(h,s);o.assign(u),l.assign(h);const d=Ie(Ee(Ae(c,Ie(yr(p),this.epsilon)),-this.learningRate),i);i.assign(d)}),this.accBeta1.assign(Ee(this.accBeta1,this.beta1)),this.accBeta2.assign(Ee(this.accBeta2,this.beta2))}),this.incrementIterations()}dispose(){this.accBeta1.dispose(),this.accBeta2.dispose(),null!=this.accumulatedFirstMoment&&ke(this.accumulatedFirstMoment.map(t=>t.variable)),null!=this.accumulatedSecondMoment&&ke(this.accumulatedSecondMoment.map(t=>t.variable))}async getWeights(){const t=[...this.accumulatedFirstMoment,...this.accumulatedSecondMoment];return[await this.saveIterations()].concat(t.map(t=>({name:t.originalName,tensor:t.variable})))}async setWeights(t){t=await this.extractIterations(t),ve(()=>{this.accBeta1.assign(Cs(this.beta1,this.iterations_+1)),this.accBeta2.assign(Cs(this.beta2,this.iterations_+1))});const e=t.length/2;this.accumulatedFirstMoment=t.slice(0,e).map(t=>({originalName:t.name,variable:t.tensor.variable(!1)})),this.accumulatedSecondMoment=t.slice(e,2*e).map(t=>({originalName:t.name,variable:t.tensor.variable(!1)}))}getConfig(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon}}static fromConfig(t,e){return new t(e.learningRate,e.beta1,e.beta2,e.epsilon)}}Jr.className="Adam",be(Jr);class Zr extends Vr{constructor(t,e,n,s=null,r=0){super(),this.learningRate=t,this.beta1=e,this.beta2=n,this.epsilon=s,this.decay=r,this.accumulatedFirstMoment=[],this.accumulatedWeightedInfNorm=[],ve(()=>{this.iteration=er(0).variable(),this.accBeta1=er(e).variable()}),null==s&&(this.epsilon=dt.backend.epsilon())}applyGradients(t){const e=Array.isArray(t)?t.map(t=>t.name):Object.keys(t);ve(()=>{const n=rs(1,this.accBeta1),s=Ae(-this.learningRate,Ie(Ee(this.iteration,this.decay),1));e.forEach((e,r)=>{const i=dt.registeredVariables[e];null==this.accumulatedFirstMoment[r]&&(this.accumulatedFirstMoment[r]={originalName:e+"/m",variable:Tn(i).variable(!1)}),null==this.accumulatedWeightedInfNorm[r]&&(this.accumulatedWeightedInfNorm[r]={originalName:e+"/v",variable:Tn(i).variable(!1)});const a=Array.isArray(t)?t[r].tensor:t[e];if(null==a)return;const o=this.accumulatedFirstMoment[r].variable,l=this.accumulatedWeightedInfNorm[r].variable,u=Ie(Ee(o,this.beta1),Ee(a,1-this.beta1)),h=Ee(l,this.beta2),c=Te(a),p=gs(h,c);o.assign(u),l.assign(p);const d=Ie(Ee(Ae(s,n),Ae(u,Ie(p,this.epsilon))),i);i.assign(d)}),this.iteration.assign(Ie(this.iteration,1)),this.accBeta1.assign(Ee(this.accBeta1,this.beta1))}),this.incrementIterations()}dispose(){this.accBeta1.dispose(),this.iteration.dispose(),null!=this.accumulatedFirstMoment&&ke(this.accumulatedFirstMoment.map(t=>t.variable)),null!=this.accumulatedWeightedInfNorm&&ke(this.accumulatedWeightedInfNorm.map(t=>t.variable))}async getWeights(){throw new Error("getWeights() is not implemented for Adamax yet.")}async setWeights(t){throw new Error("setWeights() is not implemented for Adamax yet.")}getConfig(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon,decay:this.decay}}static fromConfig(t,e){return new t(e.learningRate,e.beta1,e.beta2,e.epsilon,e.decay)}}Zr.className="Adamax",be(Zr);class Xr extends Vr{constructor(t){super(),this.learningRate=t,this.setLearningRate(t)}applyGradients(t){(Array.isArray(t)?t.map(t=>t.name):Object.keys(t)).forEach((e,n)=>{const s=Array.isArray(t)?t[n].tensor:t[e];if(null==s)return;const r=dt.registeredVariables[e];ve(()=>{const t=Ie(Ee(this.c,s),r);r.assign(t)})}),this.incrementIterations()}setLearningRate(t){this.learningRate=t,null!=this.c&&this.c.dispose(),this.c=xe(er(-t))}dispose(){this.c.dispose()}async getWeights(){return[await this.saveIterations()]}async setWeights(t){if(0!==(t=await this.extractIterations(t)).length)throw new Error("SGD optimizer does not have settable weights.")}getConfig(){return{learningRate:this.learningRate}}static fromConfig(t,e){return new t(e.learningRate)}}Xr.className="SGD",be(Xr);class Yr extends Xr{constructor(t,e,n=!1){super(t),this.learningRate=t,this.momentum=e,this.useNesterov=n,this.accumulations=[],this.m=er(this.momentum)}applyGradients(t){(Array.isArray(t)?t.map(t=>t.name):Object.keys(t)).forEach((e,n)=>{const s=dt.registeredVariables[e];if(null==this.accumulations[n]){const t=!1;this.accumulations[n]={originalName:e+"/momentum",variable:ve(()=>Tn(s).variable(t))}}const r=this.accumulations[n].variable,i=Array.isArray(t)?t[n].tensor:t[e];null!=i&&ve(()=>{let t;const e=Ie(Ee(this.m,r),i);t=this.useNesterov?Ie(Ee(this.c,Ie(i,Ee(e,this.m))),s):Ie(Ee(this.c,e),s),r.assign(e),s.assign(t)})}),this.incrementIterations()}dispose(){this.m.dispose(),null!=this.accumulations&&ke(this.accumulations.map(t=>t.variable))}setMomentum(t){this.momentum=t}async getWeights(){return[await this.saveIterations()].concat(this.accumulations.map(t=>({name:t.originalName,tensor:t.variable})))}async setWeights(t){t=await this.extractIterations(t);this.accumulations=t.map(t=>({originalName:t.name,variable:t.tensor.variable(!1)}))}getConfig(){return{learningRate:this.learningRate,momentum:this.momentum,useNesterov:this.useNesterov}}static fromConfig(t,e){return new t(e.learningRate,e.momentum,e.useNesterov)}}Yr.className="Momentum",be(Yr);class Qr extends Vr{constructor(t,e=.9,n=0,s=null,r=!1){if(super(),this.learningRate=t,this.decay=e,this.momentum=n,this.epsilon=s,this.accumulatedMeanSquares=[],this.accumulatedMoments=[],this.accumulatedMeanGrads=[],this.centered=r,null==s&&(this.epsilon=dt.backend.epsilon()),null==t)throw new Error("learningRate for RMSPropOptimizer must be defined.")}applyGradients(t){(Array.isArray(t)?t.map(t=>t.name):Object.keys(t)).forEach((e,n)=>{const s=dt.registeredVariables[e];null==this.accumulatedMeanSquares[n]&&(this.accumulatedMeanSquares[n]={originalName:e+"/rms",variable:ve(()=>Tn(s).variable(!1))}),null==this.accumulatedMoments[n]&&(this.accumulatedMoments[n]={originalName:e+"/momentum",variable:ve(()=>Tn(s).variable(!1))}),null==this.accumulatedMeanGrads[n]&&this.centered&&(this.accumulatedMeanGrads[n]={originalName:e+"/mg",variable:ve(()=>Tn(s).variable(!1))});const r=Array.isArray(t)?t[n].tensor:t[e];if(null==r)return;const i=this.accumulatedMeanSquares[n].variable,a=this.accumulatedMoments[n].variable;ve(()=>{const t=Ie(Ee(i,this.decay),Ee(xs(r),1-this.decay));if(this.centered){const e=this.accumulatedMeanGrads[n].variable,o=Ie(Ee(e,this.decay),Ee(r,1-this.decay)),l=Ae(Ee(r,this.learningRate),yr(rs(t,Ie(xs(o),this.epsilon)))),u=Ie(Ee(a,this.momentum),l);i.assign(t),e.assign(o),a.assign(u);const h=rs(s,u);s.assign(h)}else{const t=Ie(Ee(i,this.decay),Ee(xs(r),1-this.decay)),e=Ie(Ee(a,this.momentum),Ae(Ee(r,this.learningRate),yr(Ie(t,this.epsilon))));i.assign(t),a.assign(e);const n=rs(s,e);s.assign(n)}})}),this.incrementIterations()}dispose(){null!=this.accumulatedMeanSquares&&ke(this.accumulatedMeanSquares.map(t=>t.variable)),null!=this.accumulatedMeanGrads&&this.centered&&ke(this.accumulatedMeanGrads.map(t=>t.variable)),null!=this.accumulatedMoments&&ke(this.accumulatedMoments.map(t=>t.variable))}async getWeights(){const t=[...this.accumulatedMeanSquares,...this.accumulatedMoments];return this.centered&&t.push(...this.accumulatedMeanGrads),[await this.saveIterations()].concat(t.map(t=>({name:t.originalName,tensor:t.variable})))}async setWeights(t){t=await this.extractIterations(t);const e=this.centered?t.length/3:t.length/2;this.accumulatedMeanSquares=t.slice(0,e).map(t=>({originalName:t.name,variable:t.tensor.variable(!1)})),this.accumulatedMoments=t.slice(e,2*e).map(t=>({originalName:t.name,variable:t.tensor.variable(!1)})),this.centered&&(this.accumulatedMeanGrads=t.slice(2*e,3*e).map(t=>({originalName:t.name,variable:t.tensor.variable(!1)})))}getConfig(){return{learningRate:this.learningRate,decay:this.decay,momentum:this.momentum,epsilon:this.epsilon,centered:this.centered}}static fromConfig(t,e){return new t(e.learningRate,e.decay,e.momentum,e.epsilon,e.centered)}}Qr.className="RMSProp",be(Qr);class ti{static sgd(t){return new Xr(t)}static momentum(t,e,n=!1){return new Yr(t,e,n)}static rmsprop(t,e=.9,n=0,s=null,r=!1){return new Qr(t,e,n,s,r)}static adam(t=.001,e=.9,n=.999,s=null){return new Jr(t,e,n,s)}static adadelta(t=.001,e=.95,n=null){return new Hr(t,e,n)}static adamax(t=.002,e=.9,n=.999,s=null,r=0){return new Zr(t,e,n,s,r)}static adagrad(t,e=.1){return new Gr(t,e)}}const ei={sgd:ti.sgd,momentum:ti.momentum,adadelta:ti.adadelta,adagrad:ti.adagrad,rmsprop:ti.rmsprop,adamax:ti.adamax,adam:ti.adam},ni="undefined"!=typeof requestAnimationFrame?requestAnimationFrame:"undefined"!=typeof setImmediate?setImmediate:t=>t();function si(){return new Promise(t=>ni(()=>t()))}var ri=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n])};var ii=Object.assign||function(t){for(var e,n=1,s=arguments.length;n<s;n++)for(var r in e=arguments[n])Object.prototype.hasOwnProperty.call(e,r)&&(t[r]=e[r]);return t};function ai(t,e,n,s){return new(n||(n=Promise))((function(r,i){function a(t){try{l(s.next(t))}catch(t){i(t)}}function o(t){try{l(s.throw(t))}catch(t){i(t)}}function l(t){t.done?r(t.value):new n((function(e){e(t.value)})).then(a,o)}l((s=s.apply(t,e||[])).next())}))}function oi(t,e){var n,s,r,i,a={label:0,sent:function(){if(1&r[0])throw r[1];return r[1]},trys:[],ops:[]};return i={next:o(0),throw:o(1),return:o(2)},"function"==typeof Symbol&&(i[Symbol.iterator]=function(){return this}),i;function o(i){return function(o){return function(i){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,s&&(r=s[2&i[0]?"return":i[0]?"throw":"next"])&&!(r=r.call(s,i[1])).done)return r;switch(s=0,r&&(i=[0,r.value]),i[0]){case 0:case 1:r=i;break;case 4:return a.label++,{value:i[1],done:!1};case 5:a.label++,s=i[1],i=[0];continue;case 7:i=a.ops.pop(),a.trys.pop();continue;default:if(!(r=a.trys,(r=r.length>0&&r[r.length-1])||6!==i[0]&&2!==i[0])){a=0;continue}if(3===i[0]&&(!r||i[1]>r[0]&&i[1]<r[3])){a.label=i[1];break}if(6===i[0]&&a.label<r[1]){a.label=r[1],r=i;break}if(r&&a.label<r[2]){a.label=r[2],a.ops.push(i);break}r[2]&&a.ops.pop(),a.trys.pop();continue}i=e.call(t,a)}catch(t){i=[6,t],s=0}finally{n=r=0}if(5&i[0])throw i[1];return{value:i[0]?i[1]:void 0,done:!0}}([i,o])}}}function li(t){var e="function"==typeof Symbol&&t[Symbol.iterator],n=0;return e?e.call(t):{next:function(){return t&&n>=t.length&&(t=void 0),{value:t&&t[n++],done:!t}}}}function ui(t,e){var n="function"==typeof Symbol&&t[Symbol.iterator];if(!n)return t;var s,r,i=n.call(t),a=[];try{for(;(void 0===e||e-- >0)&&!(s=i.next()).done;)a.push(s.value)}catch(t){r={error:t}}finally{try{s&&!s.done&&(n=i.return)&&n.call(i)}finally{if(r)throw r.error}}return a}function hi(){for(var t=[],e=0;e<arguments.length;e++)t=t.concat(ui(arguments[e]));return t}Y().prototype.abs=function(){return this.throwIfDisposed(),Te(this)},Y().prototype.acos=function(){return this.throwIfDisposed(),De(this)},Y().prototype.acosh=function(){return this.throwIfDisposed(),ze(this)},Y().prototype.add=function(t){return this.throwIfDisposed(),Ie(this,t)},Y().prototype.all=function(t,e){return this.throwIfDisposed(),Ce(this,t,e)},Y().prototype.any=function(t,e){return this.throwIfDisposed(),Fe(this,t,e)},Y().prototype.argMax=function(t){return this.throwIfDisposed(),Re(this,t)},Y().prototype.argMin=function(t){return this.throwIfDisposed(),Me(this,t)},Y().prototype.asScalar=function(){return this.throwIfDisposed(),a(1===this.size,()=>"The array must have only 1 element."),Ve(this,[])},Y().prototype.asType=function(t){return this.throwIfDisposed(),se(this,t)},Y().prototype.as1D=function(){return this.throwIfDisposed(),Ve(this,[this.size])},Y().prototype.as2D=function(t,e){return this.throwIfDisposed(),Ve(this,[t,e])},Y().prototype.as3D=function(t,e,n){return this.throwIfDisposed(),Ve(this,[t,e,n])},Y().prototype.as4D=function(t,e,n,s){return this.throwIfDisposed(),Ve(this,[t,e,n,s])},Y().prototype.as5D=function(t,e,n,s,r){return this.throwIfDisposed(),Ve(this,[t,e,n,s,r])},Y().prototype.asin=function(){return this.throwIfDisposed(),Le(this)},Y().prototype.asinh=function(){return this.throwIfDisposed(),_e(this)},Y().prototype.atan=function(){return this.throwIfDisposed(),$e(this)},Y().prototype.atan2=function(t){return this.throwIfDisposed(),Oe(this,t)},Y().prototype.atanh=function(){return this.throwIfDisposed(),Be(this)},Y().prototype.avgPool=function(t,e,n,s){return this.throwIfDisposed(),He(this,t,e,n,s)},Y().prototype.batchToSpaceND=function(t,e){return this.throwIfDisposed(),Qe(this,t,e)},Y().prototype.batchNorm=function(t,e,n,s,r){return this.throwIfDisposed(),tn(this,t,e,n,s,r)},Y().prototype.broadcastTo=function(t){return this.throwIfDisposed(),rn(this,t)},Y().prototype.cast=function(t){return this.throwIfDisposed(),se(this,t)},Y().prototype.ceil=function(){return this.throwIfDisposed(),an(this)},Y().prototype.clipByValue=function(t,e){return this.throwIfDisposed(),on(this,t,e)},Y().prototype.concat=function(t,e){return this.throwIfDisposed(),t instanceof X&&(t=[t]),Je([this,...t],e)},Y().prototype.conv1d=function(t,e,n,s,r,i){return this.throwIfDisposed(),dn(this,t,e,n,s,r,i)},Y().prototype.conv2dTranspose=function(t,e,n,s,r){return this.throwIfDisposed(),mn(this,t,e,n,s,r)},Y().prototype.conv2d=function(t,e,n,s,r,i){return this.throwIfDisposed(),pn(this,t,e,n,s,r,i)},Y().prototype.cos=function(){return this.throwIfDisposed(),bn(this)},Y().prototype.cosh=function(){return this.throwIfDisposed(),wn(this)},Y().prototype.cumsum=function(t,e,n){return this.throwIfDisposed(),vn(this,t,e,n)},Y().prototype.depthToSpace=function(t,e){return this.throwIfDisposed(),kn(this,t,e)},Y().prototype.depthwiseConv2d=function(t,e,n,s,r,i){return this.throwIfDisposed(),xn(this,t,e,n,s,r,i)},Y().prototype.dilation2d=function(t,e,n,s,r){return this.throwIfDisposed(),Sn(this,t,e,n,s,r)},Y().prototype.divNoNan=function(t){return this.throwIfDisposed(),Dn(this,t)},Y().prototype.div=function(t){return this.throwIfDisposed(),Ae(this,t)},Y().prototype.dot=function(t){return this.throwIfDisposed(),zn(this,t)},Y().prototype.elu=function(){return this.throwIfDisposed(),Cn(this)},Y().prototype.equal=function(t){return this.throwIfDisposed(),An(this,t)},Y().prototype.erf=function(){return this.throwIfDisposed(),Fn(this)},Y().prototype.exp=function(){return this.throwIfDisposed(),Rn(this)},Y().prototype.expandDims=function(t){return this.throwIfDisposed(),Mn(this,t)},Y().prototype.expm1=function(){return this.throwIfDisposed(),Ln(this)},Y().prototype.fft=function(){return this.throwIfDisposed(),pr(this)},Y().prototype.flatten=function(){return this.throwIfDisposed(),Ve(this,[this.size])},Y().prototype.floor=function(){return this.throwIfDisposed(),Bn(this)},Y().prototype.floorDiv=function(t){return this.throwIfDisposed(),Ne(this,t)},Y().prototype.gather=function(t,e){return this.throwIfDisposed(),Pn(this,t,e)},Y().prototype.greaterEqual=function(t){return this.throwIfDisposed(),Wn(this,t)},Y().prototype.greater=function(t){return this.throwIfDisposed(),Un(this,t)},Y().prototype.ifft=function(){return this.throwIfDisposed(),dr(this)},Y().prototype.irfft=function(){return this.throwIfDisposed(),fr(this)},Y().prototype.isFinite=function(){return this.throwIfDisposed(),qn(this)},Y().prototype.isInf=function(){return this.throwIfDisposed(),Kn(this)},Y().prototype.isNaN=function(){return this.throwIfDisposed(),Vn(this)},Y().prototype.leakyRelu=function(t){return this.throwIfDisposed(),Hn(this,t)},Y().prototype.lessEqual=function(t){return this.throwIfDisposed(),Jn(this,t)},Y().prototype.less=function(t){return this.throwIfDisposed(),Gn(this,t)},Y().prototype.localResponseNormalization=function(t,e,n,s){return this.throwIfDisposed(),Zn(this,t,e,n,s)},Y().prototype.logSigmoid=function(){return this.throwIfDisposed(),ns(this)},Y().prototype.logSoftmax=function(t){return this.throwIfDisposed(),as(this,t)},Y().prototype.logSumExp=function(t,e){return this.throwIfDisposed(),us(this,t,e)},Y().prototype.log=function(){return this.throwIfDisposed(),Xn(this)},Y().prototype.log1p=function(){return this.throwIfDisposed(),Yn(this)},Y().prototype.logicalAnd=function(t){return this.throwIfDisposed(),hs(this,t)},Y().prototype.logicalNot=function(){return this.throwIfDisposed(),cs(this)},Y().prototype.logicalOr=function(t){return this.throwIfDisposed(),ps(this,t)},Y().prototype.logicalXor=function(t){return this.throwIfDisposed(),ds(this,t)},Y().prototype.matMul=function(t,e,n){return this.throwIfDisposed(),pe(this,t,e,n)},Y().prototype.maxPool=function(t,e,n,s){return this.throwIfDisposed(),fs(this,t,e,n,s)},Y().prototype.max=function(t,e){return this.throwIfDisposed(),ss(this,t,e)},Y().prototype.maximum=function(t){return this.throwIfDisposed(),gs(this,t)},Y().prototype.mean=function(t,e){return this.throwIfDisposed(),ys(this,t,e)},Y().prototype.min=function(t,e){return this.throwIfDisposed(),bs(this,t,e)},Y().prototype.minimum=function(t){return this.throwIfDisposed(),ws(this,t)},Y().prototype.mirrorPad=function(t,e){return this.throwIfDisposed(),vs(this,t,e)},Y().prototype.mod=function(t){return this.throwIfDisposed(),ks(this,t)},Y().prototype.mul=function(t){return this.throwIfDisposed(),Ee(this,t)},Y().prototype.neg=function(){return this.throwIfDisposed(),ts(this)},Y().prototype.norm=function(t,e,n){return this.throwIfDisposed(),Cr(this,t,e,n)},Y().prototype.notEqual=function(t){return this.throwIfDisposed(),Is(this,t)},Y().prototype.oneHot=function(t,e=1,n=0){return this.throwIfDisposed(),de(this,t,e,n)},Y().prototype.onesLike=function(){return this.throwIfDisposed(),Es(this)},Y().prototype.pad=function(t,e){return this.throwIfDisposed(),Ts(this,t,e)},Y().prototype.pool=function(t,e,n,s,r){return this.throwIfDisposed(),zs(this,t,e,n,s,r)},Y().prototype.pow=function(t){return this.throwIfDisposed(),Cs(this,t)},Y().prototype.prelu=function(t){return this.throwIfDisposed(),Fs(this,t)},Y().prototype.prod=function(t,e){return this.throwIfDisposed(),Rs(this,t,e)},Y().prototype.reciprocal=function(){return this.throwIfDisposed(),Js(this)},Y().prototype.relu=function(){return this.throwIfDisposed(),Zs(this)},Y().prototype.relu6=function(){return this.throwIfDisposed(),Xs(this)},Y().prototype.reshapeAs=function(t){return this.throwIfDisposed(),Ve(this,t.shape)},Y().prototype.reshape=function(t){return this.throwIfDisposed(),Ve(this,t)},Y().prototype.resizeBilinear=function(t,e,n){return this.throwIfDisposed(),Wr(this,t,e,n)},Y().prototype.resizeNearestNeighbor=function(t,e,n){return this.throwIfDisposed(),jr(this,t,e,n)},Y().prototype.reverse=function(t){return this.throwIfDisposed(),Ys(this,t)},Y().prototype.rfft=function(){return this.throwIfDisposed(),gr(this)},Y().prototype.round=function(){return this.throwIfDisposed(),Qs(this)},Y().prototype.rsqrt=function(){return this.throwIfDisposed(),tr(this)},Y().prototype.selu=function(){return this.throwIfDisposed(),nr(this)},Y().prototype.separableConv2d=function(t,e,n,s,r,i){return this.throwIfDisposed(),sr(this,t,e,n,s,r,i)},Y().prototype.sigmoid=function(){return this.throwIfDisposed(),Ze(this)},Y().prototype.sign=function(){return this.throwIfDisposed(),rr(this)},Y().prototype.sin=function(){return this.throwIfDisposed(),ir(this)},Y().prototype.sinh=function(){return this.throwIfDisposed(),ar(this)},Y().prototype.slice=function(t,e){return this.throwIfDisposed(),Xe(this,t,e)},Y().prototype.softmax=function(t){return this.throwIfDisposed(),cr(this,t)},Y().prototype.softplus=function(){return this.throwIfDisposed(),es(this)},Y().prototype.spaceToBatchND=function(t,e){return this.throwIfDisposed(),Ds(this,t,e)},Y().prototype.split=function(t,e){return this.throwIfDisposed(),mr(this,t,e)},Y().prototype.sqrt=function(){return this.throwIfDisposed(),yr(this)},Y().prototype.square=function(){return this.throwIfDisposed(),xs(this)},Y().prototype.squaredDifference=function(t){return this.throwIfDisposed(),br(this,t)},Y().prototype.squeeze=function(t){return this.throwIfDisposed(),wr(this,t)},Y().prototype.stack=function(t,e){this.throwIfDisposed();const n=t instanceof X?[this,t]:[this,...t];return vr(n,e)},Y().prototype.step=function(t){return this.throwIfDisposed(),kr(this,t)},Y().prototype.stridedSlice=function(t,e,n,s,r,i,a,o){return this.throwIfDisposed(),xr(this,t,e,n,s,r,i,a,o)},Y().prototype.sub=function(t){return this.throwIfDisposed(),rs(this,t)},Y().prototype.sum=function(t,e){return this.throwIfDisposed(),is(this,t,e)},Y().prototype.tan=function(){return this.throwIfDisposed(),Sr(this)},Y().prototype.tanh=function(){return this.throwIfDisposed(),Ye(this)},Y().prototype.tile=function(t){return this.throwIfDisposed(),_n(this,t)},Y().prototype.toBool=function(){return this.throwIfDisposed(),se(this,"bool")},Y().prototype.toFloat=function(){return this.throwIfDisposed(),se(this,"float32")},Y().prototype.toInt=function(){return this.throwIfDisposed(),se(this,"int32")},Y().prototype.topk=function(t,e){return this.throwIfDisposed(),Ar(this,t,e)},Y().prototype.transpose=function(t){return this.throwIfDisposed(),fe(this,t)},Y().prototype.unique=function(t){return this.throwIfDisposed(),Tr(this,t)},Y().prototype.unsortedSegmentSum=function(t,e){return this.throwIfDisposed(),Dr(this,t,e)},Y().prototype.unstack=function(t){return this.throwIfDisposed(),zr(this,t)},Y().prototype.where=function(t,e){return this.throwIfDisposed(),En(t,this,e)},Y().prototype.zerosLike=function(){return this.throwIfDisposed(),Tn(this)};const ci={kernelName:"Abs",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ee(t,kr(se(n,"float32"),-1))}}},pi={kernelName:"Acos",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>{const e=xs(se(n,"float32")),s=yr(rs(er(1),e));return ts(Ae(t,s))}}}},di={kernelName:"Acosh",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>{const e=yr(rs(xs(se(n,"float32")),1));return Ae(t,e)}}}},fi={kernelName:"Add",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e,r=Nn(n.shape,s.shape);return{a:()=>{let e=t;const s=In(n.shape,r);return s.length>0&&(e=is(e,s)),Ve(e,n.shape)},b:()=>{let e=t;const n=In(s.shape,r);return n.length>0&&(e=is(e,n)),Ve(e,s.shape)}}}},mi={kernelName:"AddN",saveAllInputs:!0,gradFunc:(t,e)=>{const n={};return e.forEach((e,s)=>{n[s]=()=>t.clone()}),n}},gi={kernelName:"ArgMax",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Tn(n)}}},yi={kernelName:"ArgMin",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Tn(n)}}},bi={kernelName:"Asin",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ae(t,yr(rs(er(1),xs(se(n,"float32")))))}}},wi={kernelName:"Asinh",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>{const e=yr(Ie(er(1),xs(se(n,"float32"))));return Ae(t,e)}}}},vi={kernelName:"Atan2",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e,r=Nn(n.shape,s.shape);return{a:()=>{const e=Ie(xs(n),xs(s));let i=Ee(t,Ae(s,e));const a=In(n.shape,r);return a.length>0&&(i=is(i,a)),Ve(i,n.shape)},b:()=>{const e=Ie(xs(n),xs(s));let i=ts(Ee(t,Ae(n,e)));const a=In(s.shape,r);return a.length>0&&(i=is(i,a)),Ve(i,s.shape)}}}},ki={kernelName:"Atan",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ae(t,Ie(xs(se(n,"float32")),1))}}},xi={kernelName:"Atanh",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ae(t,rs(er(1),xs(se(n,"float32"))))}}};const Si=vt({avgPool3dGrad_:function(t,e,n,s,r,i){const o=bt(t,"dy","avgPool3dGrad"),l=bt(e,"input","avgPool3dGrad");let u=o,h=l,c=!1;4===l.rank&&(c=!0,u=Ve(o,[1,o.shape[0],o.shape[1],o.shape[2],o.shape[3]]),h=Ve(l,[1,l.shape[0],l.shape[1],l.shape[2],l.shape[3]])),a(5===u.rank,()=>"Error in avgPool3dGrad: dy must be rank 5 but got rank "+u.rank+"."),a(5===h.rank,()=>"Error in avgPool3dGrad: input must be rank 5 but got rank "+h.rank+"."),null!=i&&a(p(r),()=>`Error in avgPool3dGrad: pad must be an integer when using, dimRoundingMode ${i} but got pad ${r}.`);const d={dy:u,input:h},f={filterSize:n,strides:s,pad:r,dimRoundingMode:i},m=dt.runKernel("AvgPool3DGrad",d,f);return c?Ve(m,[m.shape[1],m.shape[2],m.shape[3],m.shape[4]]):m}}),Ii={kernelName:"AvgPool3D",inputsToSave:["x"],gradFunc:(t,e,n)=>{const[s]=e,{filterSize:r,strides:i,pad:a,dimRoundingMode:o}=n;return{x:()=>Si(t,s,r,i,a,o)}}};const Ni=vt({avgPoolGrad_:function(t,e,n,s,r){const i=bt(t,"dy","avgPoolGrad"),o=bt(e,"input","avgPoolGrad");a(o.rank===i.rank,()=>`Rank of input (${o.rank}) does not match rank of dy (${i.rank})`);let l=o,u=i,h=!1;3===o.rank&&(h=!0,l=Ve(o,[1,o.shape[0],o.shape[1],o.shape[2]]),u=Ve(i,[1,i.shape[0],i.shape[1],i.shape[2]])),a(4===u.rank,()=>"Error in avgPoolGrad: dy must be rank 4 but got rank "+u.rank+"."),a(4===l.rank,()=>"Error in avgPoolGrad: input must be rank 4 but got rank "+l.rank+".");const c={dy:u,input:l},p={filterSize:n,strides:s,pad:r},d=dt.runKernel("AvgPoolGrad",c,p);return h?Ve(d,[d.shape[1],d.shape[2],d.shape[3]]):d}}),Ai={kernelName:"AvgPool",inputsToSave:["x"],gradFunc:(t,e,n)=>{const[s]=e,{filterSize:r,strides:i,pad:a}=n;return{x:()=>Ni(t,s,r,i,a)}}},Ei={kernelName:"BatchMatMul",inputsToSave:["a","b"],gradFunc:(t,e,n)=>{const[s,r]=e,{transposeA:i,transposeB:a}=n;return i||a?!i&&a?{a:()=>pe(t,r,!1,!1),b:()=>pe(t,s,!0,!1)}:i&&!a?{a:()=>pe(r,t,!1,!0),b:()=>pe(s,t,!1,!1)}:{a:()=>pe(r,t,!0,!0),b:()=>pe(t,s,!0,!0)}:{a:()=>pe(t,r,!1,!0),b:()=>pe(s,t,!0,!1)}}},Ti={kernelName:"BatchToSpaceND",gradFunc:(t,e,n)=>{const{blockShape:s,crops:r}=n;return{x:()=>Ds(t,s,r)}}},Di={kernelName:"BroadcastTo",gradFunc:(t,e,n)=>{const s=n,r=s.inputShape,i=s.shape,a=Array.from(i);for(let t=r.length-1;t>=0;t--)if(r[t]===i[t])a[t]=1;else if(1!==r[t])throw new Error(`broadcastTo(): [${r}] cannot be broadcast to [${i}].`);const o=[];for(let t=0;t<a.length;t++)a[t]>1&&o.push(t);return{x:()=>is(t,o,!0)}}},zi={kernelName:"Cast",gradFunc:t=>({x:()=>t.clone()})},Ci={kernelName:"Ceil",gradFunc:t=>({x:()=>Tn(t)})},Fi={kernelName:"ClipByValue",inputsToSave:["x"],gradFunc:(t,e,n)=>{const[s]=e,{clipValueMin:r,clipValueMax:i}=n;return{x:()=>En(hs(Wn(s,r),Jn(s,i)),t,Tn(t))}}},Ri={kernelName:"ComplexAbs",inputsToSave:["x"],gradFunc:ci.gradFunc},Mi={kernelName:"Concat",saveAllInputs:!0,gradFunc:(t,e,n)=>{const s=e.map(t=>t.shape),{axis:r}=n,i=f(r,e[0].shape)[0],a=s.map(t=>t[i]);return mr(t,a,i).map(t=>()=>t)}},Li={kernelName:"Conv2D",inputsToSave:["x","filter"],gradFunc:(t,e,n)=>{const[s,r]=e,{dilations:i,strides:o,pad:l,dataFormat:u}=n;return a(qe(i),()=>`Error in gradient of conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '${i}'`),{x:()=>fn(s.shape,t,r,o,l,u),filter:()=>Rr(s,t,r.shape,o,l,u)}}},_i={kernelName:"Conv2DBackpropInput",inputsToSave:["dy","filter"],gradFunc:(t,e,n)=>{const[s,r]=e,{strides:i,pad:a,dataFormat:o,dimRoundingMode:l}=n;return{dy:()=>pn(t,r,i,a,o,1,l),filter:()=>Rr(t,s,r.shape,i,a,o,l)}}};const $i=vt({conv3DBackpropFilter_:function(t,e,n,s,r){let i=t;4===t.rank&&(i=Ve(t,[1,t.shape[0],t.shape[1],t.shape[2],t.shape[3]]));let o=e;4===o.rank&&(o=Ve(e,[1,e.shape[0],e.shape[1],e.shape[2],e.shape[3]])),a(5===i.rank,()=>"Error in conv3dDerFilter: input must be rank 5, but got shape "+i.shape+"."),a(5===o.rank,()=>"Error in conv3dDerFilter: dy must be rank 5, but got shape "+o.shape+"."),a(5===n.length,()=>"Error in conv3dDerFilter: filterShape must be length 5, but got "+n+"."),a(i.shape[4]===n[3],()=>`Error in conv3dDerFilter: depth of input ${i.shape[4]}) must match input depth in filter (${n[3]}.`),a(o.shape[4]===n[4],()=>`Error in conv3dDerFilter: depth of dy (${o.shape[4]}) must match output depth for filter (${n[4]}).`);const l={x:i,dy:o},u={strides:s,pad:r,filterShape:n};return dt.runKernel("Conv3DBackpropFilterV2",l,u)}}),Oi={kernelName:"Conv3D",inputsToSave:["x","filter"],gradFunc:(t,e,n)=>{const{dilations:s,strides:r,pad:i}=n;a(qe(s),()=>`Error in gradient of conv3D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '${s}'`);const[o,l]=e;return{x:()=>yn(o.shape,t,l,r,i),filter:()=>$i(o,t,l.shape,r,i)}}},Bi={kernelName:"Cos",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ee(ts(ir(se(n,"float32"))),t)}}},Pi={kernelName:"Cosh",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ee(ar(se(n,"float32")),t)}}},Ui={kernelName:"Cumsum",inputsToSave:["x"],gradFunc:(t,e,n)=>{const[s]=e,{axis:r,exclusive:i,reverse:a}=n;return{x:()=>{const e=function(t,e){if(function(t,e){for(let n=0;n<t.length;++n)if(t[t.length-n-1]!==e-1-n)return!1;return!0}(t,e))return null;const n=[];for(let s=0;s<e;++s)-1===t.indexOf(s)&&n.push(s);return t.forEach(t=>n.push(t)),n}([r],s.rank);let n=vn(t,r,i,!a);return null!=e&&(n=fe(n,e)),n}}}},Wi={kernelName:"DepthwiseConv2dNative",inputsToSave:["x","filter"],gradFunc:(t,e,n)=>{const{dilations:s,strides:r,pad:i,dimRoundingMode:o}=n,l=null==s?[1,1]:s;a(qe(l),()=>`Error in gradient of depthwiseConv2dNative: dilation rates greater than 1 are not yet supported. Got dilations '${l}'`);const[u,h]=e;return a(4===u.rank,()=>`Error in gradient of depthwiseConv2dNative: input must be rank 4, but got rank ${u.rank}.`),a(4===h.rank,()=>`Error in gradient of depthwiseConv2dNative: filter must be rank 4, but got rank ${h.rank}.`),a(u.shape[3]===h.shape[2],()=>`Error in gradient of depthwiseConv2d: number of input channels (${u.shape[3]}) must match the inChannels dimension in filter ${h.shape[2]}.`),a(Ke(r,l),()=>`Error in gradient of depthwiseConv2d: Either strides or dilations must be  1. Got strides ${r} and dilations '${l}'.`),null!=o&&a(p(i),()=>`Error in depthwiseConv2d: pad must be an integer when using, dimRoundingMode ${o} but got pad ${i}.`),{x:()=>Pr(u.shape,t,h,r,i,s,o),filter:()=>Br(u,t,h.shape,r,i,s,o)}}},ji={kernelName:"Dilation2D",inputsToSave:["x","filter"],gradFunc:(t,e,n)=>{const[s,r]=e,i={x:s,filter:r,dy:t},a={x:s,filter:r,dy:t};return{x:()=>dt.runKernel("Dilation2DBackpropInput",i,n),filter:()=>dt.runKernel("Dilation2DBackpropFilter",a,n)}}},qi={kernelName:"Elu",outputsToSave:[!0],gradFunc:(t,e)=>{const[n]=e,s={dy:t,y:n};return{x:()=>dt.runKernel("EluGrad",s)}}},Ki={kernelName:"Erf",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e,s=Ee(Rn(ts(xs(n))),2/Math.sqrt(Math.PI));return{x:()=>Ee(t,s)}}},Vi={kernelName:"Exp",outputsToSave:[!0],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ee(t,n)}}},Hi={kernelName:"ExpandDims",inputsToSave:["input"],gradFunc:(t,e)=>{const[n]=e;return{input:()=>Ve(t,n.shape)}}},Gi={kernelName:"Expm1",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ee(t,Rn(n))}}},Ji={kernelName:"Floor",gradFunc:t=>({x:()=>Tn(t)})},Zi={kernelName:"FloorDiv",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e,r=Nn(n.shape,s.shape);return{a:()=>{const e=Ae(t,se(s,"float32")),i=In(n.shape,r);return i.length>0?Ve(is(e,i),n.shape):e},b:()=>{let e=Ee(t,se(n,"float32"));const i=In(s.shape,r);i.length>0&&(e=Ve(is(e,i),s.shape));const a=xs(s);return ts(Ae(e,se(a,"float32")))}}}},Xi={kernelName:"FusedBatchNorm",inputsToSave:["x","mean","variance","scale"],gradFunc:(t,e,n)=>{const{varianceEpsilon:s}=n,[r,i,a,o]=e,l=null==o?er(1):o,u=In(i.shape,r.shape),h=[];if(1===i.rank){for(let t=0;t<r.shape.length-1;++t)h.push(r.shape[t]);h.push(1)}const c=rs(r,i),p=Ee(t,l),d=tr(Ie(a,er(s))),f=Ee(Ee(Ee(d,d),d),er(-.5));return{x:()=>1===i.rank?Ve(Ee(Ee(t,_n(Ve(d,[1,1,1,i.shape[0]]),h)),l),r.shape):Ve(Ee(Ee(t,d),l),r.shape),mean:()=>{let t=Ee(Ee(d,er(-1)),p);return 1===i.rank&&(t=is(t,u)),Ve(t,i.shape)},variance:()=>{let t=Ee(Ee(f,c),p);return 1===i.rank&&(t=is(t,u)),Ve(t,i.shape)},scale:()=>{const e=Ee(c,d);let n=Ee(t,e);return 1===i.rank&&(n=is(n,u)),Ve(n,i.shape)},offset:()=>{let e=t;return 1===i.rank&&(e=is(e,u)),Ve(e,i.shape)}}}},Yi={kernelName:"GatherV2",inputsToSave:["x","indices"],gradFunc:(t,e,n)=>{const[s,r]=e,{axis:i}=n,a=f(i,s.shape)[0];return{x:()=>{const e=s.shape,n=r.size,o=e.slice(0,a),l=o.length,u=e.slice(i,e.length).slice(1),h=u.length,c=Qi(0,l),p=Qi(l+1,l+1+h),d=ta([o,[n],u]),f=Ve(t,d),m=Ve(r,[n]),g=ta([[l],c,p]),y=fe(f,g);let b=Dr(y,m,s.shape[a]);const w=ls(g);return b=fe(b,w),b},indices:()=>r}}};function Qi(t,e){const n=[];for(let s=t;s<e;++s)n.push(s);return n}function ta(t){const e=[];for(let n=0;n<t.length;++n)for(let s=0;s<t[n].length;++s)e.push(t[n][s]);return e}const ea={kernelName:"GreaterEqual",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e;return{a:()=>Tn(n),b:()=>Tn(s)}}},na={kernelName:"Identity",gradFunc:t=>({x:()=>se(t,"float32")})},sa={kernelName:"IsFinite",gradFunc:t=>({x:()=>Tn(t)})},ra={kernelName:"IsInf",gradFunc:t=>({x:()=>Tn(t)})},ia={kernelName:"IsNan",gradFunc:t=>({x:()=>Tn(t)})},aa={kernelName:"LeakyRelu",inputsToSave:["x"],gradFunc:(t,e,n)=>{const[s]=e,{alpha:r}=n,i=Un(s,0);return{x:()=>En(i,t,Ee(t,r))}}},oa={kernelName:"Log1p",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ae(t,Ie(n,1))}}},la={kernelName:"Log",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ae(t,se(n,"float32"))}}},ua={kernelName:"LogSoftmax",inputsToSave:[],outputsToSave:[!0],gradFunc:(t,e,n)=>{const[s]=e,{axis:r}=n;return{logits:()=>{const e=Rn(s);return rs(t,Ee(is(t,r,!0),e))}}}};const ha=vt({localResponseNormalizationBackprop_:function(t,e,n,s=5,r=1,i=1,a=.5){const o={x:t,y:e,dy:n},l={depthRadius:s,bias:r,alpha:i,beta:a};return dt.runKernel("LRNGrad",o,l)}}),ca={kernelName:"LRN",inputsToSave:["x"],outputsToSave:[!0],gradFunc:(t,e,n)=>{const[s,r]=e,{depthRadius:i,bias:a,alpha:o,beta:l}=n;return{x:()=>ha(s,r,t,i,a,o,l)}}};function pa(t,e,n,s){return e.rank<n.rank&&(e=Ve(e,os(e.shape,s))),t.rank<n.rank&&(t=Ve(t,os(t.shape,s))),{x:()=>Ee(t,se(An(n,e),t.dtype))}}const da={kernelName:"Max",inputsToSave:["x"],outputsToSave:[!0],gradFunc:(t,e,n)=>{const s=n,{reductionIndices:r}=s,i=e[0],a=pa(t,e[1],i,f(r,i.shape));return{x:()=>a.x()}}},fa={kernelName:"Maximum",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e;return{a:()=>Ee(t,se(Wn(n,s),"float32")),b:()=>Ee(t,se(Gn(n,s),"float32"))}}};const ma=vt({maxPool3dGrad_:function(t,e,n,s,r,i,o){const l=bt(t,"dy","maxPool3dGrad"),u=bt(e,"input","maxPool3dGrad"),h=bt(n,"output","maxPool3dGrad");let c=l,d=u,f=h,m=!1;4===u.rank&&(m=!0,c=Ve(l,[1,l.shape[0],l.shape[1],l.shape[2],l.shape[3]]),d=Ve(u,[1,u.shape[0],u.shape[1],u.shape[2],u.shape[3]]),f=Ve(h,[1,h.shape[0],h.shape[1],h.shape[2],h.shape[3]])),a(5===c.rank,()=>"Error in maxPool3dGrad: dy must be rank 5 but got rank "+c.rank+"."),a(5===d.rank,()=>"Error in maxPool3dGrad: input must be rank 5 but got rank "+d.rank+"."),a(5===f.rank,()=>"Error in maxPool3dGrad: output must be rank 5 but got rank "+f.rank+"."),null!=o&&a(p(i),()=>`Error in maxPool3dGrad: pad must be an integer when using, dimRoundingMode ${o} but got pad ${i}.`);const g={dy:c,input:d,output:f},y={filterSize:s,strides:r,pad:i,dimRoundingMode:o},b=dt.runKernel("MaxPool3DGrad",g,y);return m?Ve(b,[b.shape[1],b.shape[2],b.shape[3],b.shape[4]]):b}}),ga={kernelName:"MaxPool3D",inputsToSave:["x"],outputsToSave:[!0],gradFunc:(t,e,n)=>{const[s,r]=e,{filterSize:i,strides:a,pad:o,dimRoundingMode:l}=n;return{x:()=>ma(t,s,r,i,a,o,l)}}};const ya=vt({maxPoolGrad_:function(t,e,n,s,r,i,o){const l=bt(t,"dy","maxPoolGrad"),u=bt(e,"input","maxPoolGrad"),h=bt(n,"output","maxPoolGrad");a(u.rank===l.rank,()=>`Rank of input (${u.rank}) does not match rank of dy (${l.rank})`),a(4===l.rank,()=>"Error in maxPoolGrad: dy must be rank 4 but got rank "+l.rank+"."),a(4===u.rank,()=>"Error in maxPoolGrad: input must be rank 4 but got rank "+u.rank+"."),null!=o&&a(p(i),()=>`Error in maxPoolGrad: pad must be an integer when using, dimRoundingMode ${o} but got pad ${i}.`);const c={dy:l,input:u,output:h},d={filterSize:s,strides:r,pad:i,dimRoundingMode:o};return dt.runKernel("MaxPoolGrad",c,d)}}),ba={kernelName:"PadV2",inputsToSave:["x"],gradFunc:(t,e,n)=>{const s=e[0],{paddings:r}=n,i=r.map(t=>t[0]);return{x:()=>Xe(t,i,s.shape)}}},wa={kernelName:"SpaceToBatchND",gradFunc:(t,e,n)=>{const{blockShape:s,paddings:r}=n;return{x:()=>Qe(t,s,r)}}},va={kernelName:"SplitV",gradFunc:(t,e,n)=>{const{axis:s}=n;return{x:()=>Je(t,s)}}};const ka=[ci,pi,di,fi,mi,gi,yi,bi,wi,vi,ki,xi,Ii,Ai,Ei,Ti,Di,zi,Ci,Fi,Ri,Mi,_i,Li,Oi,Bi,Pi,Ui,Wi,ji,{kernelName:"RealDiv",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e,r=Nn(n.shape,s.shape);return{a:()=>{const e=Ae(t,se(s,"float32")),i=In(n.shape,r);return i.length>0?Ve(is(e,i),n.shape):e},b:()=>{let e=Ee(t,se(n,"float32"));const i=In(s.shape,r);i.length>0&&(e=Ve(is(e,i),s.shape));const a=xs(s);return ts(Ae(e,se(a,"float32")))}}}},qi,Ki,Vi,Hi,Gi,Zi,Ji,Xi,Yi,ea,na,sa,ra,ia,aa,oa,la,ua,ca,da,da,fa,ga,{kernelName:"MaxPool",inputsToSave:["x"],outputsToSave:[!0],gradFunc:(t,e,n)=>{const[s,r]=e,{filterSize:i,strides:a,pad:o}=n;return{x:()=>ya(t,s,r,i,a,o)}}},{kernelName:"Mean",inputsToSave:["x"],gradFunc:(t,e,n)=>{const[s]=e,{axis:r}=n,i=f(r,s.shape),a=h(function(t,e){const n=[],s=t.length;for(let r=0;r<s;r++)-1===e.indexOf(r)&&n.push(t[r]);return[n,e.map(e=>t[e])]}(s.shape,i)[1]);return{x:()=>{const e=s.shape.slice();i.forEach(t=>{e[t]=1});const n=Ve(t,e);return Ae(Ee(n,As(s.shape,"float32")),a)}}}},{kernelName:"Min",inputsToSave:["x"],outputsToSave:[!0],gradFunc:(t,e,n)=>{const s=n,{axis:r}=s,[i,a]=e,o=pa(t,a,i,f(r,i.shape));return{x:()=>o.x()}}},{kernelName:"Minimum",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e;return{a:()=>Ee(t,se(Jn(n,s),"float32")),b:()=>Ee(t,se(Un(n,s),"float32"))}}},{kernelName:"MirrorPad",inputsToSave:["x"],gradFunc:(t,e,n)=>{const s=e[0],{paddings:r}=n,i=r.map(t=>t[0]);return{x:()=>Xe(t,i,s.shape)}}},{kernelName:"Mod",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e,r=Nn(n.shape,s.shape);return{a:()=>{const e=In(n.shape,r);return e.length>0?Ve(is(t,e),n.shape):t},b:()=>{const e=Ee(t,ts(Bn(Ae(n,s)))),i=In(s.shape,r);return i.length>0?Ve(is(e,i),s.shape):e}}}},{kernelName:"Multiply",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e,r=Nn(n.shape,s.shape);return{a:()=>{const e=Ee(t,se(s,"float32")),i=In(n.shape,r);return i.length>0?Ve(is(e,i),n.shape):e},b:()=>{const e=Ee(t,se(n,"float32")),i=In(s.shape,r);return i.length>0?Ve(is(e,i),s.shape):e}}}},{kernelName:"Neg",gradFunc:t=>({x:()=>ts(t)})},{kernelName:"OneHot",inputsToSave:["indices"],gradFunc:(t,e)=>{const n=e[0];return{indices:()=>Ns(n.shape,"float32")}}},{kernelName:"OnesLike",gradFunc:t=>({x:()=>Tn(t)})},{kernelName:"Pack",saveAllInputs:!0,gradFunc:(t,e,n)=>{const{axis:s}=n;return zr(t,s).map(t=>()=>t)}},ba,ba,{kernelName:"Pow",inputsToSave:["a","b"],outputsToSave:[!0],gradFunc:(t,e)=>{const[n,s,r]=e,i=n,a=s,o=Nn(i.shape,a.shape);return{a:()=>{const e=se(a,"float32");let n=Ee(t,Ee(e,Cs(i,rs(e,er(1)))));const s=In(i.shape,o);return s.length>0&&(n=is(n,s)),Ve(n,i.shape)},b:()=>{const e=Un(i,0),n=En(e,Xn(i),Tn(i));let s=Ee(t,Ee(r,n));const l=In(a.shape,o);return l.length>0&&(s=is(s,l)),Ve(s,a.shape)}}}},{kernelName:"Prelu",inputsToSave:["x","alpha"],gradFunc:(t,e)=>{const[n,s]=e,r=Un(n,0);return{x:()=>En(r,t,Ee(t,s)),alpha:()=>{let e=En(r,Tn(t),Ee(t,n));const i=In(s.shape,t.shape);return i.length>0&&(e=is(e,i)),Ve(e,s.shape)}}}},{kernelName:"Reciprocal",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ae(t,ts(xs(n)))}}},{kernelName:"Relu6",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e,s=Ee(Jn(n,6),kr(n));return{x:()=>Ee(t,se(s,"float32"))}}},{kernelName:"Relu",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ee(t,se(kr(n),"float32"))}}},{kernelName:"Reshape",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ve(t,n.shape)}}},{kernelName:"ResizeBilinear",inputsToSave:["images"],gradFunc:(t,e,n)=>{const[s]=e,r={dy:t,images:s};return{images:()=>dt.runKernel("ResizeBilinearGrad",r,n)}}},{kernelName:"ResizeNearestNeighbor",inputsToSave:["images"],gradFunc:(t,e,n)=>{const[s]=e,r={dy:t,images:s};return{images:()=>dt.runKernel("ResizeNearestNeighborGrad",r,n)}}},{kernelName:"Reverse",gradFunc:(t,e,n)=>{const{dims:s}=n,r=f(s,t.shape);return{x:()=>Ys(t,r)}}},{kernelName:"Round",gradFunc:t=>({x:()=>Tn(t)})},{kernelName:"Rsqrt",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>ts(Ae(t,Ee(Cs(n,1.5),2)))}}},{kernelName:"Select",inputsToSave:["condition"],gradFunc:(t,e)=>{const[n]=e;return{condition:()=>se(Tn(n),"float32"),t:()=>Ee(t,se(n,t.dtype)),e:()=>Ee(t,se(cs(n),t.dtype))}}},{kernelName:"Selu",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>{const e=Un(n,er(0)),s=er(1.7580993408473768),r=er(1.0507009873554805),i=Ee(t,r),a=Ee(Ee(t,s),Rn(se(n,"float32")));return En(e,i,a)}}}},{kernelName:"Sigmoid",outputsToSave:[!0],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ee(t,Ee(n,rs(er(1),n)))}}},{kernelName:"Sign",gradFunc:t=>({x:()=>Tn(t)})},{kernelName:"Sin",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ee(bn(se(n,"float32")),t)}}},{kernelName:"Sinh",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ee(wn(se(n,"float32")),t)}}},{kernelName:"Slice",inputsToSave:["x"],gradFunc:(t,e,n)=>{const[s]=e,{begin:r,size:i}=n,o=s.shape,[l,u]=function(t,e,n){let s;const r=t.shape.length;let i;return s="number"==typeof e?[e,...new Array(r-1).fill(0)]:e.length<r?e.concat(new Array(r-e.length).fill(0)):e.slice(),s.forEach(t=>{a(-1!==t,()=>"slice() does not support negative begin indexing.")}),i=null==n?new Array(r).fill(-1):"number"==typeof n?[n,...new Array(r-1).fill(-1)]:n.length<r?n.concat(new Array(r-n.length).fill(-1)):n,i=i.map((e,n)=>e>=0?e:(a(-1===e,()=>`Negative size values should be exactly -1 but got ${e} for the slice() size at index ${n}.`),t.shape[n]-s[n])),[s,i]}(s,r,i),h=[];for(let e=0;e<t.rank;e++)h.push([l[e],o[e]-l[e]-u[e]]);return{x:()=>Ts(t,h)}}},{kernelName:"Softmax",outputsToSave:[!0],gradFunc:(t,e,n)=>{const[s]=e,{dim:r}=n,i=Ee(t,s);return{logits:()=>rs(i,Ee(is(i,[r],!0),s))}}},{kernelName:"Softplus",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ee(t,Ze(n))}}},wa,wa,va,va,{kernelName:"Sqrt",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ae(t,Ee(yr(se(n,"float32")),2))}}},{kernelName:"SquaredDifference",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e,r=er(2);return{a:()=>Ee(t,Ee(r,rs(n,s))),b:()=>Ee(t,Ee(r,rs(s,n)))}}},{kernelName:"Square",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ee(t,Ee(se(n,"float32"),2))}}},{kernelName:"Step",gradFunc:t=>({x:()=>Tn(t)})},{kernelName:"Sub",inputsToSave:["a","b"],gradFunc:(t,e)=>{const[n,s]=e,r=Nn(n.shape,s.shape);return{a:()=>{let e=t;const s=In(n.shape,r);return s.length>0&&(e=is(e,s)),Ve(e,n.shape)},b:()=>{let e=t;const n=In(s.shape,r);return n.length>0&&(e=is(e,n)),Ve(ts(e),s.shape)}}}},{kernelName:"Sum",inputsToSave:["x"],gradFunc:(t,e,n)=>{const[s]=e,r=s.shape.slice(),{axis:i}=n;f(i,s.shape).forEach(t=>{r[t]=1});const a=Ve(t,r),o=Ee(a,As(s.shape,"float32"));return{x:()=>o}}},{kernelName:"Tan",inputsToSave:["x"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ae(t,xs(bn(n)))}}},{kernelName:"Tanh",outputsToSave:[!0],gradFunc:(t,e)=>{const[n]=e;return{x:()=>Ee(rs(er(1),xs(n)),t)}}},{kernelName:"Tile",inputsToSave:["x"],gradFunc:(t,e,n)=>{const[s]=e,{reps:r}=n;return{x:()=>{let e=Tn(s);if(1===s.rank)for(let n=0;n<r[0];++n)e=Ie(e,Xe(t,[n*s.shape[0]],[s.shape[0]]));else if(2===s.rank)for(let n=0;n<r[0];++n)for(let i=0;i<r[1];++i)e=Ie(e,Xe(t,[n*s.shape[0],i*s.shape[1]],[s.shape[0],s.shape[1]]));else if(3===s.rank)for(let n=0;n<r[0];++n)for(let i=0;i<r[1];++i)for(let a=0;a<r[2];++a)e=Ie(e,Xe(t,[n*s.shape[0],i*s.shape[1],a*s.shape[2]],[s.shape[0],s.shape[1],s.shape[2]]));else{if(4!==s.rank)throw new Error("Gradient for tile operation is not implemented for rank-"+s.rank+" tensors yet.");for(let n=0;n<r[0];++n)for(let i=0;i<r[1];++i)for(let a=0;a<r[2];++a)for(let o=0;o<r[3];++o)e=Ie(e,Xe(t,[n*s.shape[0],i*s.shape[1],a*s.shape[2],o*s.shape[3]],[s.shape[0],s.shape[1],s.shape[2],s.shape[3]]))}return e}}}},{kernelName:"Transpose",gradFunc:(t,e,n)=>{const s=n,{perm:r}=s,i=ls(r);return{x:()=>fe(t,i)}}},{kernelName:"Unpack",gradFunc:(t,e,n)=>{const s=n,{axis:r}=s;return{value:()=>vr(t,r)}}},{kernelName:"UnsortedSegmentSum",inputsToSave:["segmentIds"],gradFunc:(t,e)=>{const[n]=e;return{x:()=>function(t,e){const n=gs(e,Tn(e)),s=Pn(t,n);let r=Wn(e,er(0,"int32"));const i=s.rank-r.rank;for(let t=0;t<i;++t)r=Mn(r,t+1);r=hs(r,As(s.shape,"bool"));const a=Tn(s);return En(r,s,a)}(t,n)}}},{kernelName:"ZerosLike",gradFunc:t=>({x:()=>Tn(t)})}];for(const t of ka)$(t);let xa;function Sa(){return null==xa&&(xa=Se().epsilon()),xa}class Ia extends Error{constructor(t){super(t),Object.setPrototypeOf(this,Ia.prototype)}}class Na extends Error{constructor(t){super(t),Object.setPrototypeOf(this,Na.prototype)}}class Aa extends Error{constructor(t){super(t),Object.setPrototypeOf(this,Aa.prototype)}}class Ea extends Error{constructor(t){super(t),Object.setPrototypeOf(this,Ea.prototype)}}class Ta extends Error{constructor(t){super(t),Object.setPrototypeOf(this,Ta.prototype)}}function Da(t,e){if(Array.isArray(t)){let n=[];for(let s=0;s<e;s++)n=n.concat(t);return n}{const n=new Array(e);return n.fill(t),n}}function za(t,e){if(!t)throw new Ta(e)}function Ca(t,e){let n=0;for(const s of t)s===e&&n++;return n}function Fa(t){return 1===t.length?t[0]:t}function Ra(t){return Array.isArray(t)?t:[t]}function Ma(t){const e=t.replace(/(.)([A-Z][a-z0-9]+)/g,"$1_$2").replace(/([a-z])([A-Z])/g,"$1_$2").toLowerCase();return"_"!==e[0]?e:"private"+e}function La(t){return t.length<=1||-1===t.indexOf("_")?t:t.replace(/[_]+(\w|$)/g,(t,e)=>e.toUpperCase())}let _a={};function $a(t){if(null==t)return null;const e={};return e.className=t.getClassName(),e.config=t.getConfig(),e}function Oa(t,e={},n={},s="object",r=!1){if("string"==typeof t){const r=t;let i;if(r in n)i=n[r];else if(r in _a)i=_a[r];else if(i=e[r],null==i)throw new Aa(`Unknown ${s}: ${t}. This may be due to one of the following reasons:\n1. The ${s} is defined in Python, in which case it needs to be ported to TensorFlow.js or your JavaScript code.\n2. The custom ${s} is defined in JavaScript, but is not registered properly with tf.serialization.registerClass().`);return i}{const i=t;if(null==i.className||null==i.config)throw new Aa(s+": Improper config format: "+JSON.stringify(i)+".\n'className' and 'config' must set.");const a=i.className;let o,l;if(a in n?[o,l]=n[a]:a in _a?[o,l]=_a.className:a in e&&([o,l]=e[a]),null==o)throw new Aa(`Unknown ${s}: ${a}. This may be due to one of the following reasons:\n1. The ${s} is defined in Python, in which case it needs to be ported to TensorFlow.js or your JavaScript code.\n2. The custom ${s} is defined in JavaScript, but is not registered properly with tf.serialization.registerClass().`);if(null!=l){const t={};for(const e of Object.keys(_a))t[e]=_a[e];for(const e of Object.keys(n))t[e]=n[e];i.config.customObjects=t;const e=Object.assign({},_a);for(const t of Object.keys(n))_a[t]=n[t];!function t(e){if(null!=e&&"object"==typeof e)if(Array.isArray(e))e.forEach(e=>t(e));else{const n=Object.keys(e);for(const s of n){const n=e[s];null!=n&&"object"==typeof n&&(Array.isArray(n)||"ndarray"!==n.type||"number"!=typeof n.value?t(n):e[s]=n.value)}}}(i.config);const s=l(o,i.config,n,r);return _a=Object.assign({},e),s}{const t=Object.assign({},_a);for(const t of Object.keys(n))_a[t]=n[t];const e=new o(i.config);return _a=Object.assign({},t),e}}}function Ba(t,e){return-1*function(t,e){return t<e?-1:t>e?1:0}(t,e)}function Pa(t){if(null==t)return t;const e=[];for(const n of t)-1===e.indexOf(n)&&e.push(n);return e}function Ua(t){if(null==t)throw new Aa("Invalid value in obj: "+JSON.stringify(t));for(const e in t)if(t.hasOwnProperty(e))return!1;return!0}function Wa(t,e,n){if(null!=n&&t.indexOf(n)<0)throw new Aa(`${n} is not a valid ${e}.  Valid values are ${t} or null/undefined.`)}function ja(t,e,n=0,s=1/0){return za(n>=0),za(s>=n),Array.isArray(t)&&t.length>=n&&t.length<=s&&t.every(t=>typeof t===e)}function qa(t,e){Array.isArray(t)?(a(t.length>0,()=>e+" is unexpectedly an empty array."),t.forEach((t,n)=>qa(t,`element ${n+1} of ${e}`))):a(Number.isInteger(t)&&t>0,()=>`Expected ${e} to be a positive integer, but got `+function t(e){return null===e?"null":Array.isArray(e)?"["+e.map(e=>t(e)).join(",")+"]":"string"==typeof e?`"${e}"`:""+e}(t)+".")}function Ka(t){return"relu"===t?"relu":"linear"===t?"linear":"elu"===t?"elu":null}function Va(t,e){return ve(()=>yr(is(Ee(t,t),e,!0)))}class Ha extends ge{getConfig(){return{}}}class Ga extends Ha{constructor(t){super(),this.defaultMaxValue=2,this.defaultAxis=0,this.maxValue=null!=t.maxValue?t.maxValue:this.defaultMaxValue,this.axis=null!=t.axis?t.axis:this.defaultAxis}apply(t){return ve(()=>{const e=Va(t,this.axis),n=on(e,0,this.maxValue);return Ee(t,Ae(n,Ie(Sa(),e)))})}getConfig(){return{maxValue:this.maxValue,axis:this.axis}}}Ga.className="MaxNorm",be(Ga);class Ja extends Ha{constructor(t){super(),this.defaultAxis=0,this.axis=null!=t.axis?t.axis:this.defaultAxis}apply(t){return ve(()=>Ae(t,Ie(Sa(),Va(t,this.axis))))}getConfig(){return{axis:this.axis}}}Ja.className="UnitNorm",be(Ja);class Za extends Ha{apply(t){return Zs(t)}}Za.className="NonNeg",be(Za);class Xa extends Ha{constructor(t){super(),this.defaultMinValue=0,this.defaultMaxValue=1,this.defaultRate=1,this.defaultAxis=0,this.minValue=null!=t.minValue?t.minValue:this.defaultMinValue,this.maxValue=null!=t.maxValue?t.maxValue:this.defaultMaxValue,this.rate=null!=t.rate?t.rate:this.defaultRate,this.axis=null!=t.axis?t.axis:this.defaultAxis}apply(t){return ve(()=>{const e=Va(t,this.axis),n=Ie(Ee(this.rate,on(e,this.minValue,this.maxValue)),Ee(1-this.rate,e));return Ee(t,Ae(n,Ie(Sa(),e)))})}getConfig(){return{minValue:this.minValue,maxValue:this.maxValue,rate:this.rate,axis:this.axis}}}Xa.className="MinMaxNorm",be(Xa);const Ya={maxNorm:"MaxNorm",minMaxNorm:"MinMaxNorm",nonNeg:"NonNeg",unitNorm:"UnitNorm"};function Qa(t){return $a(t)}function to(t,e={}){return Oa(t,ye.getMap().classNameMap,e,"constraint")}function eo(t){if(null==t)return null;if("string"==typeof t){return to({className:t in Ya?Ya[t]:t,config:{}})}return t instanceof Ha?t:to(t)}const no=["channelsFirst","channelsLast"],so=["nearest","bilinear"],ro=["valid","same","causal"],io=["max","avg"],ao=["sum","mul","concat","ave"],oo=new Map;function lo(t){Wa(no,"DataFormat",t)}function uo(t){Wa(ro,"PaddingMode",t)}function ho(t){Wa(io,"PoolMode",t)}const co=[];function po(t,e){co.push(t);try{const t=e();return co.pop(),t}catch(t){throw co.pop(),t}}function fo(t){if(!yo(t))throw new Error("Not a valid tensor name: '"+t+"'");return(0===co.length?"":co.join("/")+"/")+t}function mo(t){if(!yo(t))throw new Error("Not a valid tensor name: '"+t+"'");oo.has(t)||oo.set(t,0);const e=oo.get(t);if(oo.set(t,oo.get(t)+1),e>0){const n=`${t}_${e}`;return oo.set(n,1),n}return t}const go=new RegExp(/^[A-Za-z0-9][-A-Za-z0-9\._\/]*$/);function yo(t){return!!t.match(go)}function bo(t,e,n){null==e&&(e=0),null==n&&(n=t.length);let s=1;for(let r=e;r<n;++r)s*=t[r];return s}function wo(t){return Ir(t=Array.isArray(t)?new Float32Array(t):t)}function vo(t){return bs(wo(t)).dataSync()[0]}function ko(t){return ss(wo(t)).dataSync()[0]}function xo(t,e){if(e<t)throw new Aa(`end (${e}) < begin (${t}) is forbidden.`);const n=[];for(let s=t;s<e;++s)n.push(s);return n}function So(t,e){return t.asType(e)}function Io(t,e=-1){const n=t.shape.slice();return e<0&&(e=n.length+e+1),n.splice(e,0,1),t.reshape(n)}function No(t,e,n){return ve(()=>{switch(t.rank){case 1:return or(t,e,n);case 2:return lr(t,[e,0],[n,t.shape[1]]);case 3:return ur(t,[e,0,0],[n,t.shape[1],t.shape[2]]);case 4:return hr(t,[e,0,0,0],[n,t.shape[1],t.shape[2],t.shape[3]]);case 5:return Xe(t,[e,0,0,0,0],[n,t.shape[1],t.shape[2],t.shape[3],t.shape[4]]);case 6:return Xe(t,[e,0,0,0,0,0],[n,t.shape[1],t.shape[2],t.shape[3],t.shape[4],t.shape[5]]);default:throw new Aa("sliceAlongFirstAxis() received an unsupported tensor rank: "+t.rank)}})}function Ao(t,e,n){return ve(()=>{switch(t.rank){case 1:return or(t,e,n);case 2:return lr(t,[0,e],[t.shape[0],n]);case 3:return ur(t,[0,0,e],[t.shape[0],t.shape[1],n]);case 4:return hr(t,[0,0,0,e],[t.shape[0],t.shape[1],t.shape[2],n]);default:throw new Aa("sliceAlongLastAxis() received an unsupported tensor rank: "+t.rank)}})}function Eo(t,e,n,s){return ve(()=>{switch(t.rank){case 1:return or(t,e,n);case 2:switch(s){case 1:return No(t,e,n);case 2:return Ao(t,e,n);default:throw new Aa("The axis is not within the rank of the tensor "+s)}case 3:switch(s){case 1:return No(t,e,n);case 2:return ur(t,[0,e,0],[t.shape[0],n,t.shape[2]]);case 3:return Ao(t,e,n);default:throw new Aa("The axis is not within the rank of the tensor "+s)}case 4:switch(s){case 1:return No(t,e,n);case 2:return hr(t,[0,e,0,0],[t.shape[0],n,t.shape[2],t.shape[3]]);case 3:return hr(t,[0,0,e,0],[t.shape[0],t.shape[1],n,t.shape[3]]);case 4:return Ao(t,e,n);default:throw new Aa("The axis is not within the rank of the tensor "+s)}default:throw new Aa("sliceAlongLastAxis() received an unsupported tensor rank: "+t.rank)}})}function To(t,e=-1){let n;return e<0&&(n=t[0].rank,e=0!==n?n:0),e===t[0].rank&&(e=-1),Je(t,e)}function Do(t,e){switch(t.rank){case 1:return ln([t,e]);case 2:return un([t,e],0);case 3:return hn([t,e],0);case 4:return cn([t,e],0);default:throw new Aa("concatAlongFirstAxis() received an unsupported tensor rank: "+t.rank)}}function zo(t,e){if(Array.isArray(e)||(e=[e]),t.rank!==e.length)throw new Aa(`The length of input n (${e.length}) does not match the number of dimensions in input x (${t.rank})`);return _n(t,e)}function Co(t,e=0,n=1,s,r){return Ks(t,e,n,s,r)}function Fo(t,e,n,s){if(t.rank<2||e.rank<2)throw new Ea(`dot requires both inputs to be rank >= 2 but got x shape = ${t.shape} and y shape = ${e.shape}`);if(e.rank>=3){if(t.shape.slice(-1)[0]!==e.shape.slice(-2)[0])throw new Ea(`If rank y >= 3, then the second last dim of y must equal the last dim of x but got x shape = ${t.shape} and  y shape = `+e.shape)}if(2===t.rank&&2===e.rank){return Ur({a:t,b:e,transposeA:!1,transposeB:!1,bias:s?Lo(t.rank,s,"channelsLast"):null,activation:n})}{const r=t.shape.slice(),i=r.pop();t=t.reshape([-1,i]);const a=e.shape.slice(),o=a.pop(),l=a.pop(),u=[...a,o],h=Array.from({length:e.rank},(t,n)=>0===n?e.rank-2:n<=e.rank-2?n-1:n);e=e.transpose(h).reshape([l,-1]);const c=[...r,...u];return Ur({a:t,b:e,transposeA:!1,transposeB:!1,bias:s?Lo(t.rank,s,"channelsLast"):null,activation:n}).reshape(c)}}function Ro(t,e,n){return ve(()=>(e=Array.isArray(e)?Ir(e,"int32"):e.toInt(),Pn(t,e,n)))}function Mo(t){return Ee(t,t)}function Lo(t,e,n){const s=e.shape;if(1!==e.rank&&e.rank!==t)throw new Aa("Unexpected bias dimensions: "+e.rank+"; expected it to be 1 or "+t);if(5===t){if("channelsFirst"===n)return 1===s.length?e.reshape([1,s[0],1,1,1]):e.reshape([1,s[3],s[0],s[1],s[2]]);if("channelsLast"===n)return 1===s.length?e.reshape([1,1,1,1,s[0]]):e.reshape([1].concat(s))}else if(4===t){if("channelsFirst"===n)return 1===s.length?e.reshape([1,s[0],1,1]):e.reshape([1,s[2],s[0],s[1]]);if("channelsLast"===n)return 1===s.length?e.reshape([1,1,1,s[0]]):e.reshape([1].concat(s))}else if(3===t){if("channelsFirst"===n)return 1===s.length?e.reshape([1,s[0],1]):e.reshape([1,s[1],s[0]]);if("channelsLast"===n)return 1===s.length?e.reshape([1,1,s[0]]):e.reshape([1].concat(s))}else if(t<3)return e;throw new Aa("Unsupported input rank by biasAdd: "+e.rank)}function _o(t,e,n){return ve(()=>(null==n&&(n="channelsLast"),lo(n),t.add(Lo(t.rank,e,n))))}function $o(t,e,n,s){return ve(()=>Fr(t,e,n,s))}function Oo(t,e,n=!1){return n?t():e()}const Bo=["fanIn","fanOut","fanAvg"],Po=["normal","uniform","truncatedNormal"];class Uo extends ge{fromConfigUsesCustomObjects(){return!1}getConfig(){return{}}}class Wo extends Uo{apply(t,e){return Ns(t,e)}}Wo.className="Zeros",be(Wo);class jo extends Uo{apply(t,e){return As(t,e)}}jo.className="Ones",be(jo);class qo extends Uo{constructor(t){if(super(),"object"!=typeof t)throw new Aa("Expected argument of type ConstantConfig but got "+t);if(void 0===t.value)throw new Aa("config must have value set but got "+t);this.value=t.value}apply(t,e){return ve(()=>Ee(er(this.value),As(t,e)))}getConfig(){return{value:this.value}}}qo.className="Constant",be(qo);class Ko extends Uo{constructor(t){super(),this.DEFAULT_MINVAL=-.05,this.DEFAULT_MAXVAL=.05,this.minval=t.minval||this.DEFAULT_MINVAL,this.maxval=t.maxval||this.DEFAULT_MAXVAL,this.seed=t.seed}apply(t,e){return Vs(t,this.minval,this.maxval,e)}getConfig(){return{minval:this.minval,maxval:this.maxval,seed:this.seed}}}Ko.className="RandomUniform",be(Ko);class Vo extends Uo{constructor(t){super(),this.DEFAULT_MEAN=0,this.DEFAULT_STDDEV=.05,this.mean=t.mean||this.DEFAULT_MEAN,this.stddev=t.stddev||this.DEFAULT_STDDEV,this.seed=t.seed}apply(t,e){if("float32"!==(e=e||"float32")&&"int32"!==e)throw new Ea(`randomNormal does not support dType ${e}.`);return Co(t,this.mean,this.stddev,e,this.seed)}getConfig(){return{mean:this.mean,stddev:this.stddev,seed:this.seed}}}Vo.className="RandomNormal",be(Vo);class Ho extends Uo{constructor(t){super(),this.DEFAULT_MEAN=0,this.DEFAULT_STDDEV=.05,this.mean=t.mean||this.DEFAULT_MEAN,this.stddev=t.stddev||this.DEFAULT_STDDEV,this.seed=t.seed}apply(t,e){if("float32"!==(e=e||"float32")&&"int32"!==e)throw new Ea(`truncatedNormal does not support dType ${e}.`);return Er(t,this.mean,this.stddev,e,this.seed)}getConfig(){return{mean:this.mean,stddev:this.stddev,seed:this.seed}}}Ho.className="TruncatedNormal",be(Ho);class Go extends Uo{constructor(t){super(),this.gain=null!=t.gain?t.gain:1}apply(t,e){return ve(()=>{if(2!==t.length||t[0]!==t[1])throw new Aa("Identity matrix initializer can only be used for 2D square matrices.");return Ee(this.gain,$n(t[0]))})}getConfig(){return{gain:this.gain}}}Go.className="Identity",be(Go);class Jo extends Uo{constructor(t){if(super(),t.scale<0)throw new Aa("scale must be a positive float. Got: "+t.scale);var e;this.scale=null==t.scale?1:t.scale,this.mode=null==t.mode?"fanIn":t.mode,e=this.mode,Wa(Bo,"FanMode",e),this.distribution=null==t.distribution?"normal":t.distribution,function(t){Wa(Po,"Distribution",t)}(this.distribution),this.seed=t.seed}apply(t,e){const n=function(t,e="channelsLast"){let n,s;if(lo(e),2===t.length)n=t[0],s=t[1];else if(-1!==[3,4,5].indexOf(t.length)){if("channelsFirst"===e){const e=bo(t,2);n=t[1]*e,s=t[0]*e}else if("channelsLast"===e){const e=bo(t,0,t.length-2);n=t[t.length-2]*e,s=t[t.length-1]*e}}else{const e=bo(t);n=Math.sqrt(e),s=Math.sqrt(e)}return[n,s]}(t),s=n[0],r=n[1];let i=this.scale;if("fanIn"===this.mode?i/=Math.max(1,s):"fanOut"===this.mode?i/=Math.max(1,r):i/=Math.max(1,(s+r)/2),"normal"===this.distribution){const n=Math.sqrt(i);if("float32"!==(e=e||"float32")&&"int32"!==e)throw new Ea(`${this.getClassName()} does not support dType ${e}.`);return Er(t,0,n,e,this.seed)}{const n=Math.sqrt(3*i);return Vs(t,-n,n,e)}}getConfig(){return{scale:this.scale,mode:this.mode,distribution:this.distribution,seed:this.seed}}}Jo.className="VarianceScaling",be(Jo);class Zo extends Jo{constructor(t){super({scale:1,mode:"fanAvg",distribution:"uniform",seed:null==t?null:t.seed})}getClassName(){return Jo.className}}Zo.className="GlorotUniform",be(Zo);class Xo extends Jo{constructor(t){super({scale:1,mode:"fanAvg",distribution:"normal",seed:null==t?null:t.seed})}getClassName(){return Jo.className}}Xo.className="GlorotNormal",be(Xo);class Yo extends Jo{constructor(t){super({scale:2,mode:"fanIn",distribution:"normal",seed:null==t?null:t.seed})}getClassName(){return Jo.className}}Yo.className="HeNormal",be(Yo);class Qo extends Jo{constructor(t){super({scale:2,mode:"fanIn",distribution:"uniform",seed:null==t?null:t.seed})}getClassName(){return Jo.className}}Qo.className="HeUniform",be(Qo);class tl extends Jo{constructor(t){super({scale:1,mode:"fanIn",distribution:"normal",seed:null==t?null:t.seed})}getClassName(){return Jo.className}}tl.className="LeCunNormal",be(tl);class el extends Jo{constructor(t){super({scale:1,mode:"fanIn",distribution:"uniform",seed:null==t?null:t.seed})}getClassName(){return Jo.className}}el.className="LeCunNormal",be(el);class nl extends Uo{constructor(t){if(super(),this.DEFAULT_GAIN=1,this.gain=null==t.gain?this.DEFAULT_GAIN:t.gain,this.seed=t.seed,null!=this.seed)throw new Ea("Random seed is not implemented for Orthogonal Initializer yet.")}apply(t,e){return ve(()=>{if(t.length<2)throw new Ea("Shape must be at least 2D.");t[0]*t[1]>2e3&&console.warn(`Orthogonal initializer is being called on a matrix with more than 2000 (${t[0]*t[1]}) elements: Slowness may result.`);const e=Co(t[0]>t[1]?[t[1],t[0]]:t,0,1,"float32");let n=Kr.gramSchmidt(e);return t[0]>t[1]&&(n=n.transpose()),Ee(this.gain,n)})}getConfig(){return{gain:this.gain,seed:this.seed}}}nl.className="Orthogonal",be(nl);const sl={constant:"Constant",glorotNormal:"GlorotNormal",glorotUniform:"GlorotUniform",heNormal:"HeNormal",heUniform:"HeUniform",identity:"Identity",leCunNormal:"LeCunNormal",leCunUniform:"LeCunUniform",ones:"Ones",orthogonal:"Orthogonal",randomNormal:"RandomNormal",randomUniform:"RandomUniform",truncatedNormal:"TruncatedNormal",varianceScaling:"VarianceScaling",zeros:"Zeros"};function rl(t,e={}){return Oa(t,ye.getMap().classNameMap,e,"initializer")}function il(t){return $a(t)}function al(t){if("string"==typeof t){const e=t in sl?sl[t]:t;if("GlorotNormal"===e)return new Xo;if("GlorotUniform"===e)return new Zo;if("HeNormal"===e)return new Yo;if("HeUniform"===e)return new Qo;if("LeCunNormal"===e)return new tl;if("LeCunUniform"===e)return new el;{const t={};return t.className=e,t.config={},rl(t)}}return t instanceof Uo?t:rl(t)}let ol=0;function ll(){return ol++}const ul={};function hl(t=""){return t in ul||(ul[t]=0),ul[t]+=1,t+ul[t].toString()}function cl(t){return Array.isArray(t)&&Array.isArray(t[0])}function pl(t){return 0===t.length?[]:Array.isArray(t[0])?t:[t]}function dl(t){let e;if(Array.isArray(t)){if(1!==t.length)throw new Aa("Expected Tensor length to be 1; got "+t.length);e=t[0]}else e=t;return e}function fl(t){if(Array.isArray(t)&&Array.isArray(t[0])){if(1===t.length)return(t=t)[0];throw new Aa("Expected exactly 1 Shape; got "+t.length)}return t}function ml(t){let e=0;for(const n of t)0===n.shape.length?e+=1:e+=n.shape.reduce((t,e)=>t*e);return e}class gl{constructor(t,e="float32",n="Variable",s=!0,r=null){this.dtype=null==e?"float32":e,this.shape=t.shape,this.id=ll(),n=null==n?"Variable":n,this.originalName=fo(n),this.name=mo(this.originalName),this.trainable_=s,this.constraint=r,this.val=function(t,e=!0,n,s){return dt.makeVariable(t,e,n,s)}(t,this.trainable_,this.name,this.dtype)}read(){return this.assertNotDisposed(),this.val}write(t){return this.assertNotDisposed(),function(t,e){if(t.shape.toString()!==e.shape.toString())throw new Error("Shape mismatch: "+JSON.stringify(t.shape)+" vs. "+JSON.stringify(e.shape))}(this.val,t),this.val.id!==t.id&&(this.val.assign(t),null!=this.constraint&&this.val.assign(this.constraint.apply(this.val))),this}dispose(){this.assertNotDisposed(),this.val.dispose()}assertNotDisposed(){if(this.val.isDisposed)throw new Error(`LayersVariable ${this.name} is already disposed.`)}get trainable(){return this.trainable_}set trainable(t){this.trainable_=t,this.val.trainable=t}}function yl(t){return t.map(t=>t.read())}function bl(t){t.forEach(t=>{t[0].write(t[1])})}class wl{constructor(t){this.dtype=t.dtype,this.shape=t.shape,null!=t.shape?this.ndim=t.shape.length:this.ndim=t.ndim,this.maxNDim=t.maxNDim,this.minNDim=t.minNDim,this.axes=t.axes||{}}}class vl{constructor(t,e,n,s,r,i,a){this.dtype=t,this.shape=e,this.sourceLayer=n,this.inputs=s,this.callArgs=r,this.outputTensorIndex=a,this.id=ll(),null!=i&&(this.originalName=fo(i),this.name=mo(this.originalName)),this.rank=e.length}}let kl=0;class xl{constructor(t,e){this.callArgs=e,this.id=kl++,this.outboundLayer=t.outboundLayer,this.inboundLayers=t.inboundLayers,this.nodeIndices=t.nodeIndices,this.tensorIndices=t.tensorIndices,this.inputTensors=t.inputTensors,this.outputTensors=t.outputTensors,this.inputMasks=t.inputMasks,this.outputMasks=t.outputMasks,this.inputShapes=t.inputShapes,this.outputShapes=t.outputShapes;for(const e of t.inboundLayers)null!=e&&e.outboundNodes.push(this);t.outboundLayer.inboundNodes.push(this)}getConfig(){const t=[];for(const e of this.inboundLayers)null!=e?t.push(e.name):t.push(null);return{outboundLayer:this.outboundLayer?this.outboundLayer.name:null,inboundLayers:t,nodeIndices:this.nodeIndices,tensorIndices:this.tensorIndices}}}let Sl=0;class Il extends ge{constructor(t={}){super(),this._callHook=null,this._addedWeightNames=[],this._stateful=!1,this.id=Sl++,this.activityRegularizer=null,this.inputSpec=null,this.supportsMasking=!1,this._trainableWeights=[],this._nonTrainableWeights=[],this._losses=[],this._updates=[],this._built=!1,this.inboundNodes=[],this.outboundNodes=[];let e=t.name;if(!e){const t=this.getClassName();e=Ma(t)+"_"+hl(t)}if(this.name=e,this.trainable_=null==t.trainable||t.trainable,null!=t.inputShape||null!=t.batchInputShape){let e;if(null!=t.batchInputShape)e=t.batchInputShape;else if(null!=t.inputShape){let n=null;null!=t.batchSize&&(n=t.batchSize),e=[n].concat(t.inputShape)}this.batchInputShape=e;let n=t.dtype;null==n&&(n=t.inputDType),null==n&&(n="float32"),this.dtype=n}null!=t.weights?this.initialWeights=t.weights:this.initialWeights=null,this._refCount=null,this.fastWeightInitDuringBuild=!1}static nodeKey(t,e){return t.name+"_ib-"+e.toString()}getNodeAtIndex(t,e){if(0===this.inboundNodes.length)throw new Na(`The layer has never been called and thus has no defined ${e}.`);if(this.inboundNodes.length<=t)throw new Aa(`Asked to get ${e} at node ${t}, but the layer has only ${this.inboundNodes.length} inbound nodes.`);return this.inboundNodes[t]}getInputAt(t){return Fa(this.getNodeAtIndex(t,"input").inputTensors)}getOutputAt(t){return Fa(this.getNodeAtIndex(t,"output").outputTensors)}get input(){if(this.inboundNodes.length>1)throw new Ia("Layer "+this.name+' has multiple inbound nodes, hence the notion of "layer input" is ill-defined. Use `getInputAt(nodeIndex)` instead.');if(0===this.inboundNodes.length)throw new Ia("Layer "+this.name+" is not connected, no input to return.");return Fa(this.getNodeAtIndex(0,"input").inputTensors)}get output(){if(0===this.inboundNodes.length)throw new Ia("Layer "+this.name+" has no inbound nodes.");if(this.inboundNodes.length>1)throw new Ia("Layer "+this.name+' has multiple inbound nodes, hence the notion of "layer output" is ill-defined. Use `getOutputAt(nodeIndex)` instead.');return Fa(this.getNodeAtIndex(0,"output").outputTensors)}get losses(){return this._losses}calculateLosses(){return this.losses.map(t=>t())}get updates(){return this._updates}get built(){return this._built}set built(t){this._built=t}get trainable(){return this.trainable_}set trainable(t){this._trainableWeights.forEach(e=>e.trainable=t),this.trainable_=t}get trainableWeights(){return this.trainable_?this._trainableWeights.filter(t=>t.trainable):[]}set trainableWeights(t){this._trainableWeights=t}get nonTrainableWeights(){return this.trainable?this._trainableWeights.filter(t=>!t.trainable).concat(this._nonTrainableWeights):this._trainableWeights.concat(this._nonTrainableWeights)}set nonTrainableWeights(t){this._nonTrainableWeights=t}get weights(){return this.trainableWeights.concat(this.nonTrainableWeights)}get stateful(){return this._stateful}resetStates(){if(!this.stateful)throw new Error("Cannot call the resetStates() method of a non-stateful Layer object.")}assertInputCompatibility(t){if(t=Ra(t),null==this.inputSpec||0===this.inputSpec.length)return;const e=Ra(this.inputSpec);if(t.length!==e.length)throw new Aa(`Layer ${this.name} expects ${e.length} inputs, but it received ${t.length} input tensors. Input received: `+t);for(let n=0;n<t.length;n++){const s=t[n],r=e[n];if(null==r)continue;const i=s.rank;if(null!=r.ndim&&i!==r.ndim)throw new Aa(`Input ${n} is incompatible with layer ${this.name}: expected ndim=${r.ndim}, found ndim=${i}`);if(null!=r.maxNDim&&i>r.maxNDim)throw new Aa(`Input ${n} is incompatible with layer ${this.name}: expected max_ndim=${r.maxNDim}, found ndim=${i}`);if(null!=r.minNDim&&i<r.minNDim)throw new Aa(`Input ${n} is incompatible with layer ${this.name}: expected min_ndim=${r.minNDim}, found ndim=${i}.`);if(null!=r.dtype&&s.dtype!==r.dtype)throw new Aa(`Input ${n} is incompatible with layer ${this.name} : expected dtype=${r.dtype}, found dtype=${s.dtype}.`);if(r.axes){const t=s.shape;for(const e in r.axes){const s=Number(e),i=r.axes[e],a=s>=0?t[s]:t[t.length+s];if(null!=i&&-1===[i,null].indexOf(a))throw new Aa(`Input ${n} is incompatible with layer ${this.name}: expected axis ${s} of input shape to have value ${i} but got shape ${t}.`)}}if(null!=r.shape)for(let t=0;t<r.shape.length;++t){const e=r.shape[t],i=s.shape[t];if(null!=e&&null!=i&&e!==i)throw new Aa(`Input ${n} is incompatible with layer ${this.name}: expected shape=${r.shape}, found shape=${s.shape}.`)}}}call(t,e){return t}invokeCallHook(t,e){null!=this._callHook&&this._callHook(t,e)}setCallHook(t){this._callHook=t}clearCallHook(){this._callHook=null}apply(t,e){e=e||{},this.assertNotDisposed();const n=Ra(t);let s=!0;for(const t of n)if(!(t instanceof vl)){s=!1;break}let r=!0;for(const t of n)if(t instanceof vl){r=!1;break}if(s===r)throw new Aa("Arguments to apply() must be all SymbolicTensors or all Tensors");return po(this.name,()=>{if(!this.built){this.assertInputCompatibility(t);const e=[];for(const n of Ra(t))e.push(n.shape);this.build(Fa(e)),this.built=!0,this.initialWeights&&this.setWeights(this.initialWeights),null===this._refCount&&r&&(this._refCount=1)}if(this.assertInputCompatibility(t),r){let s=this.call(t,e);const r=Ra(s),i=[];for(let t of r)-1!==n.indexOf(t)&&(t=t.clone()),i.push(t);if(s=Fa(i),null!=this.activityRegularizer)throw new Ea("Layer invocation in the presence of activity regularizer(s) is not supported yet.");return s}{const n=function(t){t=Ra(t);const e=[];for(const n of t)e.push(n.shape);return Fa(e)}(t),s=this.computeOutputShape(n);let r;const i="float32";if(this.warnOnIncompatibleInputShape(Array.isArray(t)?n[0]:n),r=null!=s&&s.length>0&&Array.isArray(s[0])?s.map((n,s)=>new vl(i,n,this,Ra(t),e,this.name,s)):new vl(i,s,this,Ra(t),e,this.name),this.addInboundNode(t,r,null,null,n,s,e),this._refCount++,null!=this.activityRegularizer)throw new Ea("Layer invocation in the presence of activity regularizer(s) is not supported yet.");return r}})}warnOnIncompatibleInputShape(t){if(null!=this.batchInputShape)if(t.length!==this.batchInputShape.length)console.warn("The rank of the input tensor provided (shape: "+JSON.stringify(t)+") does not match that of the "+`batchInputShape (${JSON.stringify(this.batchInputShape)}) of the layer `+this.name);else{let e=!1;this.batchInputShape.forEach((n,s)=>{null!=n&&null!=t[s]&&t[s]!==n&&(e=!0)}),e&&console.warn(`The shape of the input tensor (${JSON.stringify(t)}) does not match the expectation of layer ${this.name}: `+JSON.stringify(this.batchInputShape))}}get outputShape(){if(null==this.inboundNodes||0===this.inboundNodes.length)throw new Ia(`The layer ${this.name} has never been called and thus has no defined output shape.`);const t=[];for(const e of this.inboundNodes){const n=JSON.stringify(e.outputShapes);-1===t.indexOf(n)&&t.push(n)}if(1===t.length){const t=this.inboundNodes[0].outputShapes;return Array.isArray(t)&&Array.isArray(t[0])&&1===t.length?t[0]:t}throw new Ia(`The layer ${this.name} has multiple inbound nodes with different output shapes. Hence the notion of "output shape" is ill-defined for the layer.`)}countParams(){if(!this.built)throw new Na(`You tried to call countParams() on ${this.name}, but the layer is not built yet. Build it first by calling build(batchInputShape).`);return ml(this.weights)}build(t){this.built=!0}getWeights(t=!1){return yl(t?this.trainableWeights:this.weights)}setWeights(t){ve(()=>{const e=this.weights;if(e.length!==t.length)throw new Aa(`You called setWeights(weights) on layer "${this.name}" with a weight list of length ${t.length}, but the layer was expecting ${e.length} weights. Provided weights: ${t}...`);if(0===e.length)return;const n=[],s=yl(e);for(let r=0;r<s.length;++r){const i=s[r],a=e[r],o=t[r];if(!c(i.shape,o.shape))throw new Aa(`Layer weight shape ${i.shape} not compatible with provided weight shape `+o.shape);n.push([a,o])}bl(n)})}addWeight(t,e,n,s,r,i,a){if(-1!==this._addedWeightNames.indexOf(t))throw new Aa(`Duplicate weight name ${t} for layer ${this.name}`);this._addedWeightNames.push(t),null==n&&(n="float32"),this.fastWeightInitDuringBuild&&(s=al("zeros"));const o=s.apply(e,n),l=new gl(o,n,t,i,a);return o.dispose(),null!=r&&this.addLoss(()=>r.apply(l.read())),null==i&&(i=!0),i?this._trainableWeights.push(l):this._nonTrainableWeights.push(l),l}setFastWeightInitDuringBuild(t){this.fastWeightInitDuringBuild=t}addLoss(t){null==t||Array.isArray(t)&&0===t.length||(t=Ra(t),void 0!==this._losses&&null!==this._losses&&this.losses.push(...t))}computeOutputShape(t){return t}computeMask(t,e){if(!this.supportsMasking){if(null!=e){if(!Array.isArray(e))throw new TypeError(`Layer ${this.name} does not support masking, but was passed an inputMask.`);e.forEach(t=>{if(null!=t)throw new TypeError(`Layer ${this.name} does not support masking, but was passed an inputMask.`)})}return null}return e}addInboundNode(t,e,n,s,r,i,a=null){const o=Ra(t);e=Ra(e),n=Ra(n),s=Ra(s),r=pl(r),i=pl(i);const l=[],u=[],h=[];for(const t of o)l.push(t.sourceLayer),u.push(t.nodeIndex),h.push(t.tensorIndex);new xl({outboundLayer:this,inboundLayers:l,nodeIndices:u,tensorIndices:h,inputTensors:o,outputTensors:e,inputMasks:n,outputMasks:s,inputShapes:r,outputShapes:i},a);for(let t=0;t<e.length;t++)e[t].sourceLayer=this,e[t].nodeIndex=this.inboundNodes.length-1,e[t].tensorIndex=t}getConfig(){const t={name:this.name,trainable:this.trainable};return null!=this.batchInputShape&&(t.batchInputShape=this.batchInputShape),null!=this.dtype&&(t.dtype=this.dtype),t}disposeWeights(){return this.weights.forEach(t=>t.dispose()),this.weights.length}assertNotDisposed(){if(0===this._refCount)throw new Error(`Layer '${this.name}' is already disposed.`)}dispose(){if(!this.built)throw new Error(`Cannot dispose Layer ${this.name} because it has not been built yet.`);if(null===this._refCount)throw new Error(`Cannot dispose Layer ${this.name} because it has not been used yet.`);this.assertNotDisposed();let t=0;return 0==--this._refCount&&(t=this.disposeWeights()),{refCountAfterDispose:this._refCount,numDisposedVariables:t}}}class Nl extends Il{constructor(t){if(super({dtype:t.dtype,name:null!=t.name?t.name:hl("input").toString()}),null==t.batchSize&&(t.batchSize=null),null==t.sparse&&(t.sparse=!1),this.trainable=!1,this.built=!0,this.sparse=t.sparse,null!=t.inputShape&&null!=t.batchInputShape)throw new Aa("Only provide the inputShape OR batchInputShape argument to inputLayer, not both at the same time.");let e=t.batchInputShape;if(null==e){if(null==t.inputShape)throw new Aa("An InputLayer should be passed either a `batchInputShape` or an `inputShape`.");e=[t.batchSize].concat(t.inputShape)}else if(null!=t.batchSize)throw new Aa("Cannot specify batchSize if batchInputShape is specified when creating an InputLayer.");const n=t.dtype||"float32";this.batchInputShape=e,this.dtype=n,this.inputSpec=[{shape:e}];const s=new vl(this.dtype,this.batchInputShape,this,[],{},this.name);s.nodeIndex=0,s.tensorIndex=0,new xl({outboundLayer:this,inboundLayers:[],nodeIndices:[],tensorIndices:[],inputTensors:[s],outputTensors:[s],inputMasks:[null],outputMasks:[null],inputShapes:[e],outputShapes:[e]})}apply(t,e){throw new Aa("Cannot pass any input to an InputLayer's apply() method. InputLayer name: "+this.name)}dispose(){return{refCountAfterDispose:this._refCount,numDisposedVariables:0}}getConfig(){return{batchInputShape:this.batchInputShape,dtype:this.dtype,sparse:this.sparse,name:this.name}}}async function Al(t){if(null==t)return;const e=[],n=[],s=[];for(const r in t){const i=t[r];if("number"!=typeof i){const t=i;e.push(t.data()),n.push(r),s.push(t)}}if(e.length>0){const r=await Promise.all(e);for(let e=0;e<r.length;++e)t[n[e]]=r[e][0];ke(s)}}function El(t){if(null!=t)for(const e in t){const n=t[e];"number"!=typeof n&&n.dispose()}}var Tl;Nl.className="InputLayer",be(Nl),function(t){t[t.SILENT=0]="SILENT",t[t.VERBOSE=1]="VERBOSE"}(Tl||(Tl={}));class Dl{constructor(){this.validationData=null}setParams(t){this.params=t}async onEpochBegin(t,e){}async onEpochEnd(t,e){}async onBatchBegin(t,e){}async onBatchEnd(t,e){}async onTrainBegin(t){}async onTrainEnd(t){}setModel(t){}}class zl{constructor(t,e=10){null==t&&(t=[]),this.callbacks=t,this.queueLength=e}append(t){this.callbacks.push(t)}setParams(t){for(const e of this.callbacks)e.setParams(t)}setModel(t){for(const e of this.callbacks)e.setModel(t)}async onEpochBegin(t,e){null==e&&(e={});for(const n of this.callbacks)await n.onEpochBegin(t,e)}async onEpochEnd(t,e){null==e&&(e={});for(const n of this.callbacks)await n.onEpochEnd(t,e)}async onBatchBegin(t,e){null==e&&(e={});for(const n of this.callbacks)await n.onBatchBegin(t,e)}async onBatchEnd(t,e){null==e&&(e={});for(const n of this.callbacks)await n.onBatchEnd(t,e)}async onTrainBegin(t){null==t&&(t={});for(const e of this.callbacks)await e.onTrainBegin(t)}async onTrainEnd(t){null==t&&(t={});for(const e of this.callbacks)await e.onTrainEnd(t)}}class Cl extends Dl{constructor(){super()}async onEpochBegin(t){this.seen=0,this.totals={}}async onBatchEnd(t,e){null==e&&(e={});const n=null==e.size?0:e.size;this.seen+=n;for(const t in e){const s=e[t];if("number"==typeof s)this.totals.hasOwnProperty(t)||(this.totals[t]=0),this.totals[t]=this.totals[t]+s*n;else{let e;t in this.totals?e=this.totals[t]:this.totals[t]=0;const r=ve(()=>Ie(this.totals[t],Ee(s,n)));this.totals[t]=r,null!=e&&e.dispose()}}}async onEpochEnd(t,e){if(null!=e)for(const t of this.params.metrics)null!=this.totals[t]&&("number"==typeof this.totals[t]?e[t]=this.totals[t]/this.seen:ve(()=>{const n=Ee(Ae(1,this.seen),this.totals[t]);e[t]=n,this.totals[t].dispose(),xe(e[t])}))}}class Fl extends Dl{async onTrainBegin(t){this.epoch=[],this.history={}}async onEpochEnd(t,e){null==e&&(e={}),this.epoch.push(t);for(const t in e)null==this.history[t]&&(this.history[t]=[]),this.history[t].push(e[t])}async syncData(){const t=[],e=[],n=[];for(const s in this.history){const r=this.history[s];for(let i=0;i<r.length;++i)if("number"!=typeof r[i]){const a=r[i];t.push(a.data()),e.push(s),n.push(i)}}const s=await Promise.all(t);for(let t=0;t<s.length;++t){this.history[e[t]][n[t]].dispose(),this.history[e[t]][n[t]]=s[t][0]}}}class Rl extends Dl{constructor(t,e){if(super(),this.currentEpoch=0,this.yieldEvery=e||"auto","auto"===this.yieldEvery&&(this.yieldEvery=125),"never"===this.yieldEvery&&null!=t.onYield)throw new Error("yieldEvery is `never` but you provided an `onYield` callback. Either change `yieldEvery` or remove the callback");y(this.yieldEvery)&&(this.maybeWait=function(t,e){let n,s=B();return(...r)=>{const i=B();return i-s<e||(s=i,n=t(...r)),n}}(this.maybeWait.bind(this),this.yieldEvery)),this.trainBegin=t.onTrainBegin,this.trainEnd=t.onTrainEnd,this.epochBegin=t.onEpochBegin,this.epochEnd=t.onEpochEnd,this.batchBegin=t.onBatchBegin,this.batchEnd=t.onBatchEnd,this.yield=t.onYield}async maybeWait(t,e,n){const s=[];null!=this.yield&&(await Al(n),s.push(this.yield(t,e,n))),s.push(si()),await Promise.all(s)}async onEpochBegin(t,e){this.currentEpoch=t,null!=this.epochBegin&&(await Al(e),await this.epochBegin(t,e))}async onEpochEnd(t,e){const n=[];null!=this.epochEnd&&(await Al(e),n.push(this.epochEnd(t,e))),"epoch"===this.yieldEvery&&n.push(si()),await Promise.all(n)}async onBatchBegin(t,e){null!=this.batchBegin&&(await Al(e),await this.batchBegin(t,e))}async onBatchEnd(t,e){const n=[];null!=this.batchEnd&&(await Al(e),n.push(this.batchEnd(t,e))),"batch"===this.yieldEvery?n.push(si()):y(this.yieldEvery)&&n.push(this.maybeWait(this.currentEpoch,t,e)),await Promise.all(n)}async onTrainBegin(t){null!=this.trainBegin&&(await Al(t),await this.trainBegin(t))}async onTrainEnd(t){null!=this.trainEnd&&(await Al(t),await this.trainEnd(t))}}function Ml(t,e){if(null==t&&(t={}),t instanceof Dl)return[t];if(Array.isArray(t)&&t[0]instanceof Dl)return t;return Ra(t).map(t=>new Rl(t,e))}class Ll{constructor(){}static registerCallbackConstructor(t,e){a(t>=0&&Number.isInteger(t),()=>"Verbosity level is expected to be an integer >= 0, but got "+t),Ll.checkForDuplicate(e),null==Ll.constructors[t]&&(Ll.constructors[t]=[]),Ll.constructors[t].push(e)}static checkForDuplicate(t){for(const e in Ll.constructors){Ll.constructors[+e].forEach(e=>{if(e===t)throw new Aa("Duplicate callback constructor.")})}}static clear(){Ll.constructors={}}static createCallbacks(t){const e=[];for(const n in Ll.constructors){const s=+n;t>=s&&e.push(...Ll.constructors[s])}return e.map(t=>new t)}}function _l(t,e,n,s,r,i,a,o,l){const u=new Fl,h=[new Cl,...Ll.createCallbacks(e)];null!=t&&h.push(...t),h.push(u);const c=new zl(h);return c.setParams({epochs:n,initialEpoch:s,samples:r,steps:i,batchSize:a,verbose:e,doValidation:o,metrics:l}),{callbackList:c,history:u}}function $l(t,e={},n=!1){return Oa(t,ye.getMap().classNameMap,e,"layer",n)}function Ol(t,e){return ve(()=>{"float32"!==t.dtype&&(t=t.asType("float32"));const n=is(Mo(t),e,!0),s=On(n.shape,Sa()),r=yr(gs(n,s));return Ae(t,r)})}function Bl(t,e){return ve(()=>ys(Mo(rs(e,t)),-1))}function Pl(t,e){return ve(()=>ys(Te(rs(e,t)),-1))}function Ul(t,e){return ve(()=>{const n=rs(t,e),s=on(Te(t),Sa(),Number.MAX_VALUE),r=Te(Ae(n,s));return Ee(100,ys(r,-1))})}function Wl(t,e,n=!1){return ve(()=>{if(n)e=cr(e);else{const t=is(e,e.shape.length-1,!0);e=Ae(e,t)}return e=on(e,Sa(),1-Sa()),ts(is(Ee(t.toFloat(),Xn(e)),e.shape.length-1))})}function jl(t,e,n=!1){return ve(()=>{const s=Bn(function(t){const e=[bo(t.shape)];return t.reshape(e)}(t)).toInt(),r=(e=on(e,Sa(),1-Sa())).shape;return Wl(de(s,r[r.length-1]).reshape(r),e,n)})}function ql(t,e){return ve(()=>{let n;return n=on(e,Sa(),1-Sa()),n=Xn(Ae(n,rs(1,n))),ys(function(t,e){if(!c(t.shape,e.shape))throw new Aa(`logits and labels must have the same shape, but got shapes ${JSON.stringify(t.shape)} and ${JSON.stringify(e.shape)}`);return ve(()=>{const n=e.relu(),s=e.abs().neg();return n.sub(e.mul(t)).add(s.exp().log1p())})}(t,n),-1)})}function Kl(t,e){return ve(()=>{const n=Ol(t,-1),s=Ol(e,-1),r=Ee(n,s);return ts(is(r,-1))})}Ll.constructors={};const Vl={meanSquaredError:Bl,meanAbsoluteError:Pl,meanAbsolutePercentageError:Ul,meanSquaredLogarithmicError:function(t,e){return ve(()=>{const n=on(e,Sa(),Number.MAX_VALUE),s=Xn(Ie(1,n)),r=on(t,Sa(),Number.MAX_VALUE),i=Xn(Ie(1,r));return ys(Mo(rs(s,i)),-1)})},squaredHinge:function(t,e){return ve(()=>{const n=gs(0,rs(1,Ee(t,e)));return ys(Mo(n),-1)})},hinge:function(t,e){return ve(()=>{const n=gs(0,rs(1,Ee(t,e)));return ys(n,-1)})},categoricalHinge:function(t,e){return ve(()=>{const n=is(Ee(t,e),-1),s=ss(Ee(rs(1,t),e),-1);return gs(0,Ie(1,rs(s,n)))})},logcosh:function(t,e){return ve(()=>{const n=Math.log(2),s=rs(e,t),r=rs(Ie(s,es(Ee(-2,s))),n);return ys(r,-1)})},categoricalCrossentropy:Wl,sparseCategoricalCrossentropy:jl,binaryCrossentropy:ql,kullbackLeiblerDivergence:function(t,e){return ve(()=>{const n=on(t,Sa(),1),s=on(e,Sa(),1);return is(Ee(t,Xn(Ae(n,s))),-1)})},poisson:function(t,e){return ve(()=>{const n=Xn(Ie(Sa(),e));return ys(rs(e,Ee(t,n)),-1)})},cosineProximity:Kl};function Hl(t){if("string"==typeof t){if(t in Vl)return Vl[t];let e="Unknown loss "+t;throw t.toLowerCase().includes("softmaxcrossentropy")&&(e=`Unknown loss ${t}. Use "categoricalCrossentropy" as the string name for tf.losses.softmaxCrossEntropy`),new Aa(e)}return t}function Gl(t,e){return ve(()=>{const n=Ee(.5,Es(e)),s=So(Un(e,n),t.dtype);return ys(An(t,s),-1)})}function Jl(t,e){return ve(()=>So(An(Re(t,-1),Re(e,-1)),"float32"))}function Zl(t,e){return ql(t,e)}function Xl(t,e){return t.rank===e.rank&&(t=t.squeeze([t.rank-1])),(e=e.argMax(-1)).dtype!==t.dtype&&(e=e.asType(t.dtype)),An(t,e).asType("float32")}const Yl=Wl,Ql=jl,tu={binaryAccuracy:Gl,categoricalAccuracy:Jl,precision:function(t,e){return ve(()=>{const n=function(t,e){return ve(()=>hs(t.equal(1),e.equal(1)).sum().cast("float32"))}(t,e),s=function(t,e){return ve(()=>hs(t.equal(0),e.equal(1)).sum().cast("float32"))}(t,e),r=n.add(s);return En(Un(r,0),n.div(r),0).cast("float32")})},categoricalCrossentropy:Yl,sparseCategoricalCrossentropy:Ql,mse:Bl,MSE:Bl,mae:Pl,MAE:Pl,mape:Ul,MAPE:Ul,cosine:Kl};function eu(t){if("string"==typeof t&&t in tu)return tu[t];if("string"!=typeof t&&null!=t)return t;throw new Aa("Unknown metric "+t)}function nu(t){if(za(null!==t,"Unknown LossOrMetricFn "+t),"string"==typeof t)return t;{let e;for(const n of Object.keys(Vl))if(Vl[n]===t){e=n;break}if(void 0!==e)return e;for(const n of Object.keys(tu))if(tu[n]===t){e=n;break}return void 0!==e?e:t.name}}function su(t,e,n=!1){if(null==t||"object"!=typeof t||Object.getPrototypeOf(t)!==Object.prototype||!function t(e){if(null===e)return!0;if("object"==typeof e){if(Object.getPrototypeOf(e)===Object.prototype){const n=Object.keys(e);for(const s of n){if("string"!=typeof s)return!1;if(!t(e[s]))return!1}return!0}if(Array.isArray(e)){for(const n of e)if(!t(n))return!1;return!0}return!1}{const t=typeof e;return"string"===t||"number"===t||"boolean"===t}}(t))throw new Error("User-defined metadata is expected to be a JSON object, but is not.");if(n){const n=JSON.stringify(t);n.length>1048576&&console.warn(`User-defined metadata of model "${e}" is too large in size (length=${n.length} when serialized). It is not recommended to store such large objects in user-defined metadata. Please make sure its serialized length is <= 1048576.`)}}function ru(t,e,n,s=console.log){const r=function(t){let e=!0;const n=[],s=[];for(const e in t.nodesByDepth)n.push(t.nodesByDepth[e]);for(const t of n){if(t.length>1||1===t.length&&t[0].inboundLayers.length>1){e=!1;break}s.push(...t)}if(e)for(const n of t.layers){let t=!1;for(const r of n.inboundNodes)if(-1!==s.indexOf(r)){if(t){e=!1;break}t=!0}if(!e)break}return e}(t),i=["Layer (type)","Output shape","Param #"];let a;if(r?(e=e||65,n=n||[.45,.85,1]):(e=e||98,n=n||[.33,.55,.67,1]),n[n.length-1]<=1&&(n=n.map(t=>Math.floor(e*t))),!r){i.push("Receives inputs"),a=[];for(const e in t.nodesByDepth)a.push(...t.nodesByDepth[e])}s("_".repeat(e)),iu(i,n,s),s("=".repeat(e));const o=t.layers;for(let t=0;t<o.length;++t)r?au(o[t],n,s):ou(o[t],n,a,s),s((t===o.length-1?"=":"_").repeat(e));t.checkTrainableWeightsConsistency();const l=function(t){let e;e=null!=t.collectedTrainableWeights?ml(t.collectedTrainableWeights):ml(t.trainableWeights);return e}(t),u=ml(t.nonTrainableWeights);s("Total params: "+(l+u)),s("Trainable params: "+l),s("Non-trainable params: "+u),s("_".repeat(e))}function iu(t,e,n=console.log){let s="";for(let n=0;n<t.length;++n)n>0&&(s=s.slice(0,s.length-1)+" "),s+=t[n],s=s.slice(0,e[n]),s+=" ".repeat(e[n]-s.length);n(s)}function au(t,e,n){let s;try{s=JSON.stringify(t.outputShape)}catch(t){s="multiple"}iu([`${t.name} (${t.getClassName()})`,s,t.countParams().toString()],e,n)}function ou(t,e,n,s){let r;try{r=JSON.stringify(t.outputShape)}catch(t){r="multiple"}const i=[];for(const e of t.inboundNodes)if(!(null!=n&&n.length>0&&-1===n.indexOf(e)))for(let t=0;t<e.inboundLayers.length;++t){const n=e.inboundLayers[t].name,s=e.nodeIndices[t],r=e.tensorIndices[t];i.push(`${n}[${s}][${r}]`)}const a=t.name,o=t.getClassName(),l=0===i.length?"":i[0];iu([`${a} (${o})`,r,t.countParams().toString(),l],e,s);for(let t=1;t<i.length;++t)iu(["","","",i[t]],e,s)}function lu(t,e,n){return("inboundNodes"===t||"outputLayers"===t||"inputLayers"===t)&&0===e&&"string"==typeof n}function uu(t,e){if(null===t)return null;if("string"==typeof t)return La(t);if("number"==typeof t||"boolean"==typeof t)return t;if(t instanceof Array){const n=[],s=t.length;for(let r=0;r<s;++r){const s=t[r];lu(e,r,s)?n.push(s):n.push(uu(s,e))}return n}{const e={};for(const n of Object.keys(t)){const s=t[n];if("name"===n&&"string"==typeof s)e[n]=s;else{const t=La(n);e[t]=uu(s,t)}}return e}}class hu{constructor(t){if(this.id2Value={},this.id2Mask={},this.name2Id={},t instanceof hu)for(const e in t.id2Value)this.id2Value[e]=t.id2Value[e],e in t.id2Mask&&(this.id2Mask[e]=t.id2Mask[e]);else{if(null==t)return;for(const e of t)this.add(e.key,e.value)}}add(t,e,n){if(null!=this.id2Value[t.id])throw new Aa(`Duplicate key: name=${t.name}, id=${t.id}`);return this.id2Value[t.id]=function(t,e){if(null==t.dtype||t.dtype===e.dtype)return e;try{return se(e,t.dtype)}catch(n){throw new Aa(`The dtype of the feed (${e.dtype}) can not be cast to the dtype of the key '${t.name}' (${t.dtype}).`)}}(t,e),this.name2Id[t.name]=t.id,null!=n&&(this.id2Mask[t.id]=n),this}addFeed(t){this.add(t.key,t.value)}hasKey(t){return null!=this.id2Value[t.id]}names(){return Object.keys(this.name2Id)}getValue(t){if(t instanceof vl){if(null==this.id2Value[t.id])throw new Aa("Nonexistent key: "+t.name);return this.id2Value[t.id]}{const e=this.name2Id[t];if(null==e)throw new Aa("Feed dict has no SymbolicTensor name: "+t);return this.id2Value[e]}}getMask(t){if(t instanceof vl){if(null==this.id2Value[t.id])throw new Aa("Nonexistent key: "+t.name);return this.id2Mask[t.id]}{const e=this.name2Id[t];if(null==e)throw new Aa("Feed dict has no SymbolicTensor name: "+t);return this.id2Mask[e]}}disposeMasks(){null!=this.id2Mask&&ke(this.id2Mask)}}const cu={},pu={};function du(t,e,n,s){const r=null!=n&&n.training,i=Array.isArray(t),o=i?t:[t],l=o.map(t=>t.name),u=[],h=e.names();for(const t of l)-1!==h.indexOf(t)?u.push(e.getValue(t)):u.push(null);null!=s&&(s.maxNumTensors=-1/0,s.minNumTensors=1/0);const c=l.join(",")+"|"+e.names().join(",");let p,d;if(null==cu[c]){const t=function(t,e){a(null!=t&&t.length>0,()=>"Expected at least one fetch, got none");let n=[],s={};if(1===t.length){const r=mu(t[0],e);n=r.sorted,s=r.recipientMap}else{const r=new Set;for(const i of t){const{sorted:t,recipientMap:a}=mu(i,e);for(const e of t)r.has(e.name)||(n.push(e),r.add(e.name));for(const t in a)null==s[t]&&(s[t]=new Set),a[t].forEach(e=>s[t].add(e))}}return{sorted:n,recipientCounts:fu(s)}}(o,e);p=t.sorted,d=t.recipientCounts,cu[c]=p,pu[c]=d}p=cu[c],d={},r||Object.assign(d,pu[c]);const f=new hu(e);for(let t=0;t<p.length;++t){if(null!=s){const t=we().numTensors;t>s.maxNumTensors&&(s.maxNumTensors=t),t<s.minNumTensors&&(s.minNumTensors=t)}const i=p[t],a=i.sourceLayer;if(a instanceof Nl)continue;const o=[],h=[],c=[];let m=!1;for(const t of i.inputs){const n=f.getValue(t),s=f.getMask(t);o.push(n),h.push(s),null!=s&&(m=!0),r||(d[t.name]--,0!==d[t.name]||e.hasKey(t)||-1!==l.indexOf(t.name)||n.isDisposed||!0===t.sourceLayer.stateful||c.push(n))}m&&((n=n||{}).mask=h[0]);const g=Ra(a.apply(o,n));let y=null;a.supportsMasking&&(y=a.computeMask(o,h));const b=gu(i),w=Array.isArray(b)?b:[b];for(let t=0;t<w.length;++t){f.hasKey(w[t])||f.add(w[t],g[t],Array.isArray(y)?y[0]:y);const e=l.indexOf(w[t].name);-1!==e&&(u[e]=g[t])}r||ke(c)}return f.disposeMasks(),i?u:u[0]}function fu(t){const e={};for(const n in t)e[n]=t[n].size;return e}function mu(t,e){const n=new Set,s=[],r={};for(const t of e.names())n.add(t);const i=[],a=[];for(i.push(t);i.length>0;){const t=i[i.length-1];if(n.has(t.name)){i.pop();continue}const e=a[a.length-1]===i.length-1;if(0===t.inputs.length||e)i.pop(),s.push(t),n.add(t.name),e&&a.pop();else{a.push(i.length-1);for(const e of t.inputs)null==r[e.name]&&(r[e.name]=new Set),r[e.name].add(t.name),n.has(e.name)||i.push(e)}}return{sorted:s,recipientMap:r}}function gu(t){let e;if(1===t.sourceLayer.inboundNodes.length)e=t.sourceLayer.output;else{let n=null;for(let e=0;e<t.sourceLayer.inboundNodes.length;++e)for(const s of t.sourceLayer.inboundNodes[e].outputTensors)if(s.id===t.id){n=e;break}e=t.sourceLayer.getOutputAt(n)}return e}class yu extends Il{constructor(t){if(super({}),this.containerNodes=new Set,this.name=t.name,null==this.name){const t=this.getClassName().toLowerCase();this.name=hl(t)}if(this.supportsMasking=!1,this.trainable_=!0,Array.isArray(t.inputs)?this.inputs=t.inputs.slice():this.inputs=[t.inputs],Array.isArray(t.outputs)?this.outputs=t.outputs.slice():this.outputs=[t.outputs],Pa(this.inputs).length!==this.inputs.length)throw new Aa("The list of inputs passed to the model is redundant. All inputs should only appear once. Found: "+this.inputs.map(t=>t.name));Pa(this.outputs).length!==this.outputs.length&&console.warn("The list of outputs passed to the model is redundant. All outputs should only appear once. Found: "+this.outputs.map(t=>t.name)),this.inputLayers=[],this.inputLayersNodeIndices=[],this.inputLayersTensorIndices=[],this.outputLayers=[],this.outputLayersNodeIndices=[],this.outputLayersTensorIndices=[],this.layers=[],this.internalContainerRefs=[];for(const t of this.outputs){const e=t.sourceLayer,n=t.nodeIndex,s=t.tensorIndex;this.outputLayers.push(e),this.outputLayersNodeIndices.push(n),this.outputLayersTensorIndices.push(s)}for(const t of this.inputs){const e=t.sourceLayer,n=t.nodeIndex,s=t.tensorIndex;za(0===n,"input layer has >1 nodes"),za(0===s,"input layer has >1 tensors"),this.inputLayers.push(e),this.inputLayersNodeIndices.push(n),this.inputLayersTensorIndices.push(s)}this.inputNames=[],this.outputNames=[],this.feedInputShapes=[],this.feedInputNames=[],this.feedOutputNames=[];for(let e=0;e<this.inputLayers.length;e++){const n=this.inputLayers[e];if(!(n instanceof Nl))throw new TypeError(`Input layers to a LayersModel must be InputLayer objects. Received inputs: ${t.inputs}. Input ${e} (0-based) originates from layer type ${n.getClassName()}.`);this.inputNames.push(n.name),this.feedInputShapes.push(n.batchInputShape),this.feedInputNames.push(n.name)}for(const t of this.outputLayers)this.outputNames.push(t.name);this.internalInputShapes=this.inputs.map(t=>t.shape),this.internalOutputShapes=this.outputs.map(t=>t.shape);const e={},n={},s={},r={},i={},a=[],o=(t,e,n,s,r,l)=>{null!=s&&null!=r&&null!=l||(s=t.sourceLayer,r=t.nodeIndex,l=t.tensorIndex);const u=s.inboundNodes[r];if(-1!==n.indexOf(u))throw new Na(`The tensor ${t.name} at layer "${s.name}" is part of a cycle.`);if(-1!==e.indexOf(u))return;this.containerNodes.add(yu.nodeKey(s,r)),s.id in i||(i[s.id]=Object.keys(i).length),-1===n.indexOf(u)&&n.push(u);const h=u.inboundLayers.length;for(let t=0;t<h;t++){const s=u.inputTensors[t],r=u.inboundLayers[t],i=u.nodeIndices[t],a=u.tensorIndices[t];o(s,e,n,r,i,a)}for(e.push(u);n.indexOf(u)>=0;)n.splice(n.indexOf(u),1);a.push(u)},l=[],u=[];for(const t of this.outputs)o(t,l,u);const h=a.slice().reverse();for(const t of h){n[t.id]=t,t.id in e||(e[t.id]=0);let i=e[t.id];const a=null==s[t.outboundLayer.id]?0:s[t.outboundLayer.id];i=Math.max(i,a),s[t.outboundLayer.id]=i,r[t.outboundLayer.id]=t.outboundLayer,e[t.id]=i;for(let s=0;s<t.inboundLayers.length;s++){const r=t.inboundLayers[s],a=t.nodeIndices[s],o=r.inboundNodes[a],l=null==e[o.id]?0:e[o.id];e[o.id]=Math.max(i+1,l),n[o.id]=o}}const c={};for(const t in e){const s=e[t];s in c||(c[s]=[]),c[s].push(n[t])}const p={};for(const t in s){const e=s[t];e in p||(p[e]=[]),p[e].push(r[t])}let d=Object.keys(p).map(t=>parseInt(t,10)).sort(Ba);this.layers=[];for(const t of d){const e=p[t];e.sort((t,e)=>{const n=i[t.id],s=i[e.id];return n<s?-1:n>s?1:0});for(const t of e)t instanceof yu&&this.internalContainerRefs.push(t),this.layers.push(t)}this.layersByDepth=p,d=Object.keys(c).map(t=>parseInt(t,10)).sort(Ba);const f=this.inputs.slice(),m=[];for(const t of d)for(const e of c[t]){const t=e.outboundLayer;if(null!=t){for(const n of e.inputTensors)if(-1===f.indexOf(n))throw new Na("Graph disconnected: cannot obtain value for tensor "+n+` at layer "${t.name}". The following previous layers were accessed without issue: `+m);for(const t of e.outputTensors)f.push(t);m.push(t.name)}}this.nodesByDepth=c;const g=this.layers.map(t=>t.name);for(const t of g){const e=g.filter(e=>e===t).length;if(1!==e)throw new Na(`The name "${t}" is used ${e} times in the model. All layer names should be unique. Layer names: `+JSON.stringify(g))}this.outboundNodes=[],this.inboundNodes=[],new xl({outboundLayer:this,inboundLayers:[],nodeIndices:[],tensorIndices:[],inputTensors:this.inputs,outputTensors:this.outputs,inputMasks:this.inputs.map(t=>null),outputMasks:this.outputs.map(t=>null),inputShapes:this.inputs.map(t=>t.shape),outputShapes:this.outputs.map(t=>t.shape)}),this.built=!0,this._refCount=1}assertNotDisposed(){if(0===this._refCount)throw new Error(`Container '${this.name}' is already disposed.`)}dispose(){this.assertNotDisposed();const t={refCountAfterDispose:null,numDisposedVariables:0};if(0==--this._refCount){for(const e of this.layers)t.numDisposedVariables+=e.dispose().numDisposedVariables;for(const e of this.internalContainerRefs)t.numDisposedVariables+=e.dispose().numDisposedVariables}return t.refCountAfterDispose=this._refCount,t}get trainable(){return this.trainable_}set trainable(t){this.layers.forEach(e=>{e._trainableWeights.forEach(e=>e.trainable=t)}),this.trainable_=t}get trainableWeights(){if(this._trainableWeights.length>0)throw new Aa("Container instance unexpectedly contains _trainableWeights.The trainable weights of a Container are a union of the trainable weights of its consituent Layers. Its own _trainableWeights must remain an empty Array.");if(!this.trainable)return[];let t=[];for(const e of this.layers)t=t.concat(e.trainableWeights);return t}get nonTrainableWeights(){const t=[];for(const e of this.layers)t.push(...e.nonTrainableWeights);if(!this.trainable){const e=[];for(const t of this.layers)e.push(...t.trainableWeights);return e.concat(t)}return t}get weights(){return this.trainableWeights.concat(this.nonTrainableWeights)}loadWeights(t,e=!0){const n={};let s=0;for(const t of this.layers)for(const e of t.weights){if(null!=n[e.originalName])throw new Aa("Duplicate weight name: "+e.originalName);n[e.originalName]=e,s++}const r=[];for(const s in t){let i=s;if(null==n[s]){const t=s.split("/");i=t.slice(0,-2).concat([t[t.length-1]]).join("/")}if(null!=n[i])r.push([n[i],t[s]]);else if(e)throw new Aa("Provided weight data has no target variable: "+s);delete n[i]}if(e){const t=[];for(const e in n)t.push(e);if(t.length>0)throw new Aa(`${t.length} of ${s} weights are not set: `+t)}bl(r)}updatedConfig(){const t=this.getConfig(),e={};return e.className=this.getClassName(),e.config=t,e.kerasVersion="tfjs-layers 3.0.0",e.backend="TensorFlow.js",e}toJSON(t,e=!0){const n=function t(e,n){if(null==e)return null;if("string"==typeof e)return Ma(e);if("number"==typeof e||"boolean"==typeof e)return e;if(e instanceof Array){const s=[],r=e.length;for(let i=0;i<r;++i){const r=e[i];lu(n,i,r)?s.push(r):s.push(t(r,n))}return s}{const n={};for(const s of Object.keys(e)){const r=e[s],i=Ma(s);n[i]="name"!==s&&"className"!==s||"string"!=typeof r?t(r,s):r}return n}}(this.updatedConfig());return e?JSON.stringify(n):n}call(t,e){return ve(()=>{t=Ra(t);const n=new hu;for(let e=0;e<this.inputs.length;++e)n.add(this.inputs[e],t[e]);return du(this.outputs,n,e)})}computeMask(t,e){return ve(()=>{let n;return t=Ra(t),n=null==e?Da(null,t.length):Ra(e),this.runInternalGraph(t,n)[1]})}computeOutputShape(t){const e=pl(t);if(e.length!==this.inputLayers.length)throw new Aa(`Invalid inputShape argument ${t}: model has ${this.inputLayers.length} tensor inputs.`);const n={};for(let t=0;t<e.length;t++){const s=this.inputLayers[t],r=e[t];n[s.name+"_0_0"]=r}const s=Object.keys(this.nodesByDepth).map(t=>parseInt(t,10)).sort(Ba);if(s.length>1)for(const t of s){const e=this.nodesByDepth[t];for(const t of e){const e=t.outboundLayer;if(-1!==this.inputLayers.map(t=>t.id).indexOf(e.id))continue;const s=[];for(let e=0;e<t.inboundLayers.length;e++){const r=t.inboundLayers[e],i=t.nodeIndices[e],a=t.tensorIndices[e],o=n[`${r.name}_${i}_${a}`];s.push(o)}const r=pl(e.computeOutputShape(Fa(s))),i=e.inboundNodes.indexOf(t);for(let t=0;t<r.length;t++){n[`${e.name}_${i}_${t}`]=r[t]}}}const r=[],i=[];for(let t=0;t<this.outputLayers.length;t++){const e=this.outputLayers[t],n=this.outputLayersNodeIndices[t],s=this.outputLayersTensorIndices[t],r=`${e.name}_${n}_${s}`;i.push(r)}for(let t=0;t<i.length;t++){const e=i[t];za(e in n),r.push(n[e])}return Fa(r)}runInternalGraph(t,e){null==e&&(e=Da(null,t.length));const n={};for(let s=0;s<this.inputs.length;++s){const r=this.inputs[s],i=t[s],a=e[s];n[r.id]=[i,a]}const s=Object.keys(this.nodesByDepth).map(t=>parseInt(t,10)).sort(Ba);for(const t of s){const e=this.nodesByDepth[t];for(const t of e){const e=t.outboundLayer,s=t.inputTensors,r=t.outputTensors,i=new Array;for(const t of s)t.id in n&&i.push(n[t.id]);if(i.length===s.length){let s,a,o,l,u={};if(null!=t.callArgs&&(u=t.callArgs),1===i.length){const[t,n]=i[0];null==u.mask&&(u.mask=n),o=Ra(e.call(t,u)),l=Ra(e.computeMask(t,n)),s=[t],a=[n]}else s=i.map(t=>t[0]),a=i.map(t=>t[1]),null==u.mask&&(u.mask=a),o=Ra(e.call(s,u)),l=Ra(e.computeMask(s,a));if(e.activityRegularizer)throw new Ea("LayersModel invocation with concrete Tensor value(s) in the presence of activity regularizer(s) is not supported yet.");for(let t=0;t<r.length;++t){const e=r[t],s=o[t],i=l[t];n[e.id]=[s,i]}}}}const r=[],i=[],a=[];for(const t of this.outputs){za(t.id in n,`Could not compute output ${t.name} : ${t.id}`);const[e,s]=n[t.id];a.push(e.shape),r.push(e),i.push(s)}return[r,i,a]}buildNodeConversionMap(t){const e={};let n;for(const t of this.layers){n=t instanceof yu?1:0;for(let s=0;s<t.inboundNodes.length;s++){const r=yu.nodeKey(t,s);this.containerNodes.has(r)&&(e[r]=n,n+=1)}}return e}getLayer(t,e){if(null!=e){if(this.layers.length<=e)throw new Aa(`Was asked to retrieve layer at index ${e}, but model only has ${this.layers.length} layer(s).`);return this.layers[e]}if(null==t)throw new Aa("Provide either a layer name or layer index");for(const e of this.layers)if(e.name===t)return e;throw new Aa("No such layer: "+t)}calculateLosses(){return ve(()=>{const t=[];for(const e of this.layers)for(let n=0;n<e.inboundNodes.length;++n){const s=yu.nodeKey(e,n);this.containerNodes.has(s)&&t.push(...e.calculateLosses())}return t})}getConfig(){const t={name:this.name},e=this.buildNodeConversionMap(this.layers),n=[];for(const t of this.layers){const s=t.getClassName(),r=t.getConfig(),i=[];for(let n=0;n<t.inboundNodes.length;n++){const s=t.inboundNodes[n],r=yu.nodeKey(t,n);let a={};if(this.containerNodes.has(r)){if(s.callArgs)try{JSON.stringify(s.callArgs),a=s.callArgs}catch(e){console.warn(`Layer ${t.name} was passed non-serializable keyword arguments: `+s.callArgs+". They will not be included in the serialized model (and thus will be missing at deserialization time)."),a={}}if(s.inboundLayers.length>0){const t=[];for(let n=0;n<s.inboundLayers.length;n++){const r=s.inboundLayers[n],i=s.nodeIndices[n],o=s.tensorIndices[n];let l=e[yu.nodeKey(r,i)];null==l&&(l=0),t.push([r.name,l,o,a])}i.push(t)}}}const a={};a.name=t.name,a.className=s,a.config=r,a.inboundNodes=i,n.push(a)}t.layers=n;const s=[];for(let t=0;t<this.inputLayers.length;t++){const n=this.inputLayers[t],r=this.inputLayersNodeIndices[t],i=yu.nodeKey(n,r);if(!this.containerNodes.has(i))continue;let a=e[i];null==a&&(a=0);const o=this.inputLayersTensorIndices[t];s.push([n.name,a,o])}t.inputLayers=s;const r=[];for(let t=0;t<this.outputLayers.length;t++){const n=this.outputLayers[t],s=this.outputLayersNodeIndices[t],i=yu.nodeKey(n,s);if(!this.containerNodes.has(i))continue;let a=e[i];null==a&&(a=0);const o=this.outputLayersTensorIndices[t];r.push([n.name,a,o])}return t.outputLayers=r,t}static fromConfig(t,e,n={},s=!1){const r={},i={};function a(t,e){t.name in i?i[t.name].push(e):i[t.name]=[e]}function o(t,e){const n=[];let s;for(const i of e){const o=i[0],l=i[1],u=i[2];if(s=null==i[3]?{}:i[3],!(o in r))return void a(t,e);const h=r[o];if(h.inboundNodes.length<=l)return void a(t,e);const c=h.inboundNodes[l];n.push(c.outputTensors[u])}n.length>0&&t.apply(Fa(n),s)}function l(t){const n=t.name,i=$l(t,null!=e.customObjects?e.customObjects:{});i.setFastWeightInitDuringBuild(s),r[n]=i;t.inboundNodes.forEach(t=>{if(!(t instanceof Array))throw new Aa("Corrupted configuration, expected array for nodeData: "+t);a(i,t)})}const u=e.name,h=e.layers;for(const t of h)l(t);for(;!Ua(i);)for(const t of h){const e=r[t.name];if(e.name in i){const t=i[e.name];delete i[e.name];for(const n of t)o(e,n)}}const c=[],p=[],d=e.inputLayers;for(const t of d){const e=t[0],n=t[1],s=t[2];za(e in r);const i=r[e].inboundNodes[n].outputTensors;c.push(i[s])}const f=e.outputLayers;for(const t of f){const e=t[0],n=t[1],s=t[2];za(e in r);const i=r[e].inboundNodes[n].outputTensors;p.push(i[s])}return new t({inputs:c,outputs:p,name:u})}get stateful(){if(this._stateful)throw new Aa("Container instance unexpectedly has _stateful = true. The statefulness of a Container is determined by the Layers it contains. Its _stateful property must remain the default false.");for(const t of this.layers)if(t.stateful)return!0;return!1}resetStates(){ve(()=>{this.layers.forEach(t=>{t.stateful&&t.resetStates()})})}}function bu(t,e){return function(t,e,n){const s=e.length;if(null==t||Array.isArray(t)&&0===t.length)return e.map(t=>null);if(1===s)return Array.isArray(t)&&1===t.length?t:"object"==typeof t&&e[0]in t?[t[e[0]]]:[t];if(Array.isArray(t)){if(t.length!==s)throw new Error(`Provided ${n} is an array of ${t.length} element(s), but the model has ${s} outputs. Make sure a set of weights is provided for each model output.`);return t}if("object"==typeof t&&Object.keys(t).length>0&&"object"==typeof t[Object.keys(t)[0]]){const n=[];return e.forEach(e=>{e in t?n.push(t[e]):n.push(null)}),n}throw new Error(`The model has multiple (${s}) outputs, so ${n} must be either an array with ${s} elements or an object with ${e} keys. Provided ${n} not understood: ${JSON.stringify(t)}`)}(t,e,"classWeight")}async function wu(t,e,n,s){if(null!=e||null!=s)throw new Error("Support sampleWeight is not implemented yet");if(null!=n){const e=ve(()=>{if(1===t.shape.length)return t.clone();if(2===t.shape.length){if(t.shape[1]>1){const e=1;return t.argMax(e)}if(1===t.shape[1])return t.reshape([t.shape[0]]);throw new Error(`Encountered unexpected last-dimension size (${t.shape[1]}) during handling of class weights. The size is expected to be >= 1.`)}throw new Error(`Unexpected rank of target (y) tensor (${t.rank}) during handling of class weights. The rank is expected to be 1 or 2.`)}),s=Array.from(await e.data());ke(e);const r=[];return s.forEach(t=>{if(null==n[t])throw new Error(`classWeight must contain all classes in the training data. The class ${t} exists in the data but not in classWeight`);r.push(n[t])}),Ir(r,"float32")}return null}function vu(t,e){return Ee(t,e)}function ku(t,e){let n,s;const r=e;n=r.xs,s=r.ys,a(null!=n&&null!=s,()=>"A Dataset iterator for fitDataset() is expected to generate objects of the form `{xs: xVal, ys: yVal}`, where the two values may be `tf.Tensor`, an array of Tensors, or a map of string to Tensor.  The provided Dataset instead generates "+e);const i=xu("input",t.inputNames,n),o=xu("output",t.outputNames,s),l=i[0].shape[0];a(i.length===t.inputs.length,()=>`LayersModel has ${t.inputs.length} inputs, but the dataset provides ${i.length} inputs.  (Expected input keys: `+JSON.stringify(t.inputNames)+")"),a(o.length===t.outputs.length,()=>`LayersModel has ${t.outputs.length} outputs, but the dataset provides ${o.length} outputs.  (Expected output keys: `+JSON.stringify(t.outputNames)+")");for(let e=0;e<i.length;e++)a(i[e].shape[0]===l,()=>`Batch size mismatch: input ${t.inputNames[e]} has ${i[e].shape[0]}; expected  ${l} based on input ${t.inputNames[0]}.`);for(let e=0;e<o.length;e++)a(o[e].shape[0]===l,()=>`Batch size mismatch: output ${t.outputNames[e]} has ${o[e].shape[0]}; expected  ${l} based on input ${t.inputNames[0]}.`);return{xs:i,ys:o}}function xu(t,e,n){if(n instanceof X)return[n];if(Array.isArray(n))return a(n.length===e.length,()=>`Received an array of ${n.length} Tensors, but expected ${e.length} to match the ${t} keys ${e}.`),n;{const s=[];for(const r of e){if(null==n[r])throw new Aa(`The feature data generated by the dataset lacks the required ${t} key '${r}'.`);s.push(n[r])}return s}}async function Su(t,e,n){const s=null!=n.batchesPerEpoch;if(a(null!=t.optimizer,()=>"You must compile a model before training/testing. Use LayersModel.compile(modelCompileConfig)."),a(null!=n,()=>"For fitDataset(), the 2nd argument (config) is required, but it is not provided in this call."),a(null!=n.epochs&&n.epochs>0&&Number.isInteger(n.epochs),()=>"For fitDataset(), config.epochs is expected to be a positive integer, but got "+n.epochs),a(!s||n.batchesPerEpoch>0&&Number.isInteger(n.batchesPerEpoch),()=>"For fitDataset(), config.batchesPerEpoch is expected to be a positive integer if specified, but got "+n.batchesPerEpoch),a(null==n.validationSplit,()=>"`validationSplit` is not supported by `fitDataset()`. Use validationData instead."),t.isTraining)throw new Error("Cannot start training because another fit() call is ongoing.");t.isTraining=!0;try{const r=null!=n.validationData;let i,o;if(r)if(Iu(n.validationData))a(null==n.validationBatches||n.validationBatches>0&&Number.isInteger(n.validationBatches),()=>"For fitDataset() with dataset-based validation, config.validationBatches is expected not to be provided, or to be a positive integer, but got "+n.validationBatches);else{const t=function(t){if(3===t.length)throw new Ea("Validation with sample weights is not implemented yet.");return{xs:t[0],ys:t[1]}}(n.validationData);i=t.xs,o=t.ys}const l=t.makeTrainFunction(),u=t.getDedupedMetricsNames();let h;h=r?u.slice().concat(u.map(t=>"val_"+t)):u.slice();const c=Ml(n.callbacks,n.yieldEvery),p=null==n.verbose?1:n.verbose,{callbackList:d,history:f}=_l(c,p,n.epochs,null,null,function(t,e){let n=null;null!=e.batchesPerEpoch?n=e.batchesPerEpoch:Number.isFinite(t.size)&&(n=t.size);return n}(e,n),null,r,h);d.setModel(t),t.history=f,await d.onTrainBegin(),t.stopTraining_=!1;let m=null==n.initialEpoch?0:n.initialEpoch,g=await e.iterator();for(;m<n.epochs;){const a={};await d.onEpochBegin(m);let h=0,c=0;for(s||(g=await e.iterator());!s||h<n.batchesPerEpoch;){const e=await g.next();if(s&&e.done){console.warn("You provided `batchesPerEpoch` as "+n.batchesPerEpoch+", but your dataset iterator ran out of data after "+h+" batches; interrupting training. Make sure that your dataset can generate at least `batchesPerEpoch * epochs` batches (in this case, "+n.batchesPerEpoch*n.epochs+" batches). You may need to use the repeat() function when building your dataset.");break}if(null!=e.value){const{xs:s,ys:r}=ku(t,e.value),i={};i.batch=c,i.size=s[0].shape[0],await d.onBatchBegin(c,i);const a=[];if(null!=n.classWeight){const e=bu(n.classWeight,t.outputNames);for(let t=0;t<e.length;++t)a.push(await wu(r[t],null,e[t]))}const o=s.concat(r).concat(a),p=l(o);ke(o);for(let t=0;t<u.length;++t){const e=u[t],n=p[t];i[e]=n,xe(n)}await d.onBatchEnd(c,i),El(i),c++,h++}if(s?h>=n.batchesPerEpoch:e.done){if(r){let e;e=Iu(n.validationData)?Ra(await t.evaluateDataset(n.validationData,{batches:n.validationBatches})):Ra(t.evaluate(i,o,{batchSize:null==n.validationBatchSize?32:n.validationBatchSize,verbose:0}));for(let n=0;n<t.metricsNames.length;++n)a["val_"+t.metricsNames[n]]=e[n]}break}if(t.stopTraining_)break}if(await d.onEpochEnd(m,a),m++,t.stopTraining_)break}return await d.onTrainEnd(),await t.history.syncData(),t.history}finally{t.isTraining=!1}}function Iu(t){return"function"==typeof t.iterator}function Nu(t){a(t>0&&Number.isInteger(t),()=>"batchSize is required to be a positive integer, but got "+t)}function Au(t,e,n){return null==t?[null]:Array.isArray(t)?t.map(t=>No(t,e,n-e)):No(t,e,n-e)}function Eu(t,e){return ve(()=>null==t?null:Array.isArray(t)?t.map(t=>Eu(t,e)):Ro(t,"int32"===e.dtype?e:e.toInt()))}function Tu(t,e){const n=[];let s=0,r=null;for(;s<t;)r=s+e,r>=t&&(r=t),n.push([s,r]),s=r;return n}async function Du(t,e,n,s={}){if(t.isTraining)throw new Error("Cannot start training because another fit() call is ongoing.");let r,a,o,l,u,h,c;t.isTraining=!0;try{const p=null==s.batchSize?32:s.batchSize;Nu(p);const d=!1,f=await t.standardizeUserData(e,n,s.sampleWeight,s.classWeight,d,p);r=f[0],a=f[1],c=f[2];let m,g=!1;if(null!=s.validationData&&s.validationData.length>0){if(g=!0,2!==s.validationData.length)throw 3===s.validationData.length?new Ea("validationData including sample weights is not supported yet."):new Aa("When passing validation data, it must contain 2 (valX, valY) or 3 (valX, valY, valSampleWeight) items; "+s.validationData+" is invalid.");o=s.validationData[0],l=s.validationData[1];const e=!0,n=await t.standardizeUserData(o,l,null,null,e,p);u=n[0],h=n[1],m=u.concat(h)}else if(null!=s.validationSplit&&s.validationSplit>0&&s.validationSplit<1){g=!0;const t=Math.floor(r[0].shape[0]*(1-s.validationSplit)),e=r[0].shape[0];u=Au(r,t,e),r=Au(r,0,t),h=Au(a,t,e),a=Au(a,0,t),m=u.concat(h)}else null!=s.validationSteps&&(g=!0);const y=r.concat(a).concat(c);t.checkTrainableWeightsConsistency();const b=t.makeTrainFunction(),w=t.getDedupedMetricsNames();let v,k;g?(t.makeTestFunction(),v=t.testFunction,k=w.slice().concat(w.map(t=>"val_"+t))):(v=null,m=[],k=w.slice());const x=Ml(s.callbacks,s.yieldEvery);return await async function(t,e,n,s,r,a,o,l,u,h,c,p,d,f,m){null==r&&(r=32),null==a&&(a=1),null==c&&(c=!0),null==d&&(d=0);let g=!1;if(null!=u&&null!=h&&(g=!0),null!=m&&(g=!0,null==f))throw new Aa("Can only use `validationSteps` when doing step-wise training, i.e., `stepsPerEpoch` must be set.");const y=t.checkNumSamples(n,r,f,"steps_per_epoch");let b;null!=y&&(b=xo(0,y)),null==o&&(o=1);const{callbackList:w,history:v}=_l(l,o,a,d,y,f,r,g,p);w.setModel(t),t.history=v,await w.onTrainBegin(),t.stopTraining_=!1;for(let o=d;o<a;++o){await w.onEpochBegin(o);const a={};if(null!=f)throw new Ea("stepsPerEpoch mode is not implemented yet.");{if("batch"===c)throw new Ea("batch shuffling is not implemneted yet");c&&i(b);const o=Ir(b),l=Tu(y,r);for(let i=0;i<l.length;++i){const c={};if(await w.onBatchBegin(i,c),ve(()=>{const p=l[i][0],d=l[i][1],f=No(o,p,d-p);c.batch=i,c.size=d-p;const m=Eu(n,f),y=e(m);for(let t=0;t<s.length;++t){const e=s[t],n=y[t];c[e]=n,xe(n)}if(i===l.length-1&&g){const e=t.testLoop(u,h,r);for(let t=0;t<s.length;++t){const n=s[t],r=e[t];xe(r),a["val_"+n]=r}}}),await w.onBatchEnd(i,c),El(c),t.stopTraining_)break}o.dispose()}if(await w.onEpochEnd(o,a),t.stopTraining_)break}return await w.onTrainEnd(),await t.history.syncData(),t.history}(t,b,y,w,p,s.epochs,s.verbose,x,v,m,s.shuffle,k,s.initialEpoch,null,null)}finally{t.isTraining=!1,Cu(r,e),Cu(a,n),Cu(u,o),Cu(h,l),null!=c&&ke(c)}}function zu(t){const e=[];t instanceof X&&(t=[t]);for(let n=0;n<t.length;++n){const s=t[n];if(1===s.rank)e.push(Io(s,1));else{if(0===s.rank)throw new Error("Expected tensor to be at least 1D, but received a 0D tensor (scalar).");e.push(s)}}return e}function Cu(t,e){if(null==t)return;const n=[];if(e instanceof X)n.push(e.id);else if(Array.isArray(e))e.forEach(t=>n.push(t.id));else if(null!=e)for(const t in e){const s=e[t];n.push(s.id)}const s=[];if(t instanceof X)-1===n.indexOf(t.id)&&s.push(t);else if(Array.isArray(t))t.forEach(t=>{-1===n.indexOf(t.id)&&s.push(t)});else if(null!=t)for(const e in t){const r=t[e];-1===n.indexOf(r.id)&&s.push(r)}s.forEach(t=>{t.isDisposed||t.dispose()})}function Fu(t){return Array.isArray(t)}function Ru(t){return!function(t){return t instanceof X}(t)&&!Fu(t)}function Mu(t,e,n,s=!0,r=""){if(null==e||0===e.length){if(null!=t){let e=!1;if(Fu(t)&&t.length>0)e=!0;else if(Ru(t)){for(const n in t)if(t.hasOwnProperty(n)){e=!0;break}}else e=!0;if(e)throw new Aa(`Error when checking model ${r} expected no data, but got `+t)}return[]}if(null==t)return e.map(t=>null);let i;if(Ru(t)){t=t,i=[];for(const n of e){if(null==t[n])throw new Aa(`No data provided for "${n}". Need data for each key in: `+e);i.push(t[n])}}else if(Fu(t)){if((t=t).length!==e.length)throw new Aa(`Error when checking model ${r}: the Array of Tensors that you are passing to your model is not the size the model expected. Expected to see ${e.length} Tensor(s), but instead got the following list of Tensor(s): `+t);i=t}else{if(t=t,e.length>1)throw new Aa(`The model ${r} expects ${e.length} Tensor(s), but only received one Tensor. Found: Tensor with shape `+t.shape);i=[t]}if(i=zu(i),null!=n)for(let t=0;t<e.length;++t){if(null==n[t])continue;const a=i[t];if(a.shape.length!==n[t].length)throw new Aa(`Error when checking ${r}: expected ${e[t]} to have ${n[t].length} dimension(s). but got array with shape `+a.shape);for(let i=0;i<n[t].length;++i){if(0===i&&!s)continue;const o=a.shape[i],l=n[t][i];if(null!=l&&l>=0&&o!==l)throw new Aa(`Error when checking ${r}: expected ${e[t]} to have shape [${n[t]}], but got array with shape [${a.shape}].`)}}return i}function Lu(t,e,n,s=!0,r=""){let i;if(Array.isArray(t)){if(t.length!==e.length)throw new Aa(`Error when checking model ${r}: the Array of Tensors that you are passing to your model is not the size the the model expected. Expected to see ${e.length} Tensor(s), but instead got ${t.length} Tensors(s).`);i=t}else{if(e.length>1)throw new Aa(`The model expects ${e.length} ${r} Tensors, but only received one Tensor. Found: array with shape `+JSON.stringify(t.shape)+".");i=[t]}if(null!=n)for(let t=0;t<e.length;++t){if(null==n[t])continue;const a=i[t];if(a.shape.length!==n[t].length)throw new Aa(`Error when checking ${r}: expected ${e[t]} to have ${n[t].length} dimension(s), but got array with shape `+JSON.stringify(a.shape));for(let i=0;i<n[t].length;++i){if(0===i&&!s)continue;const o=a.shape[i],l=n[t][i];if(null!=l&&l!==o)throw new Aa(`Error when checking ${r}: expected ${e[t]} to have shape ${JSON.stringify(n[t])} but got array with shape ${JSON.stringify(a.shape)}.`)}}}class _u extends yu{constructor(t){super(t),this.isTraining=!1}summary(t,e,n=console.log){if(!this.built)throw new Aa("This model has never been called, thus its weights have not been created yet. So no summary can be displayed. Build the model first (e.g., by calling it on some test data).");ru(this,t,e,n)}compile(t){if(null==t.loss&&(t.loss=[]),this.loss=t.loss,"string"==typeof t.optimizer)this.optimizer_=function(t){const e={Adagrad:()=>ei.adagrad(.01),Adadelta:()=>ei.adadelta(1,.95,Sa()),Adam:()=>ei.adam(.001,.9,.999,Sa()),Adamax:()=>ei.adamax(.002,.9,.999,Sa(),0),RMSProp:()=>ei.rmsprop(.001,.9,0,Sa()),SGD:()=>ei.sgd(.01)};if(e.adagrad=e.Adagrad,e.adadelta=e.Adadelta,e.adam=e.Adam,e.adamax=e.Adamax,e.rmsprop=e.RMSProp,e.sgd=e.SGD,t in e)return e[t]();throw new Aa("Unknown Optimizer "+t)}(t.optimizer),this.isOptimizerOwned=!0;else{if(!(t.optimizer instanceof Vr))throw new Aa("User-defined optimizer must be an instance of tf.Optimizer.");this.optimizer_=t.optimizer,this.isOptimizerOwned=!1}let e=[];if(Array.isArray(t.loss)||"string"==typeof t.loss||"function"==typeof t.loss)if(Array.isArray(t.loss)){if(t.loss.length!==this.outputs.length)throw new Aa(`When passing an Array as loss, it should have one entry per model output. The model has ${this.outputs.length} output(s), but you passed loss=${t.loss}.`);const n=t.loss;e=n.map(t=>Hl(t))}else{const n=Hl(t.loss);this.outputs.forEach(t=>{e.push(n)})}else{t.loss=t.loss;for(const e in t.loss)if(-1===this.outputNames.indexOf(e))throw new Aa(`Unknown entry in loss dictionary: "${e}". Only expected the following keys: `+this.outputNames);for(const n of this.outputNames)null==t.loss[n]&&console.warn(`Output "${n}" is missing from loss dictionary. We assume this was done on purpose, and we will not be expecting data to be passed to ${n} during training`),e.push(Hl(t.loss[n]))}this.lossFunctions=e,this.feedOutputNames=[],this.feedOutputShapes=[],this.feedLossFns=[];for(let t=0;t<this.outputs.length;++t){const e=this.internalOutputShapes[t],n=this.outputNames[t];this.feedOutputNames.push(n),this.feedOutputShapes.push(e),this.feedLossFns.push(this.lossFunctions[t])}const n=[];this.metrics=t.metrics,this.metricsNames=["loss"],this.metricsTensors=[],po("loss",()=>{for(let t=0;t<this.outputs.length;++t){if(-1!==n.indexOf(t))continue;const e=this.lossFunctions[t];this.outputs.length>1&&(this.metricsTensors.push([e,t]),this.metricsNames.push(this.outputNames[t]+"_loss"))}});const s=function(t,e){if(null==t||Array.isArray(t)&&0===t.length)return e.map(t=>[]);let n;if("string"==typeof t||"function"==typeof t)n=[t];else{if(!Array.isArray(t)&&"object"!=typeof t)throw new TypeError("Type of metrics argument not understood. Expected an string,function, Array, or Object, found: "+t);n=t}if(Array.isArray(n))return e.map(t=>n);{const t=[];for(const s of e){let e=n.hasOwnProperty(s)?n[s]:[];Array.isArray(e)||(e=[e]),t.push(e)}return t}}(t.metrics,this.outputNames),r=(t,e,n)=>{this.outputNames.length>1&&(e=this.outputNames[t]+"_"+e),this.metricsNames.push(e),this.metricsTensors.push([n,t])};po("metric",()=>{for(let t=0;t<this.outputs.length;++t){if(-1!==n.indexOf(t))continue;(e=>{let n,s,i;for(const a of e){if("string"==typeof a&&-1!==["accuracy","acc","crossentropy","ce"].indexOf(a)){const e=this.internalOutputShapes[t];let r;1===e[e.length-1]||this.lossFunctions[t]===ql?-1!==["accuracy","acc"].indexOf(a)?s=Gl:-1!==["crossentropy","ce"].indexOf(a)&&(s=Zl):this.lossFunctions[t]===jl?-1!==["accuracy","acc"].indexOf(a)?s=Xl:-1!==["crossentropy","ce"].indexOf(a)&&(s=Ql):-1!==["accuracy","acc"].indexOf(a)?s=Jl:-1!==["crossentropy","ce"].indexOf(a)&&(s=Yl),-1!==["accuracy","acc"].indexOf(a)?r="acc":-1!==["crossentropy","ce"].indexOf(a)&&(r="ce"),i=s,n=""+r}else{const t=eu(a);i=t,n=""+nu(a)}let e;po(n,()=>{e=i}),r(t,n,e)}})(s[t])}}),this.collectedTrainableWeights=this.trainableWeights}checkTrainableWeightsConsistency(){null!=this.collectedTrainableWeights&&this.trainableWeights.length!==this.collectedTrainableWeights.length&&console.warn("Discrepancy between trainableweights and collected trainable weights. Did you set `model.trainable` without calling `model.compile()` afterwards?")}evaluate(t,e,n={}){const s=null==n.batchSize?32:n.batchSize;Nu(s);const r=this.standardizeUserDataXY(t,e,!0,s);try{const i=r[0].concat(r[1]);this.makeTestFunction();const a=this.testFunction;return Fa(this.testLoop(a,i,s,n.verbose,n.steps))}finally{Cu(r[0],t),Cu(r[1],e)}}async evaluateDataset(t,e){return this.makeTestFunction(),async function(t,e,n){const s=null!=(n=n||{}).batches,r=t.testFunction;let i=[];if(n.verbose>0)throw new Ea("Verbose mode is not implemented yet.");a(!s||n.batches>0&&Number.isInteger(n.batches),()=>"Test loop expects `batches` to be a positive integer, but received "+JSON.stringify(n.batches));const o="function"==typeof e.next?e:await e.iterator();let l=0,u=0;for(;!s||u<n.batches;){const e=await o.next();if(i=ve(()=>{if(e.value){const{xs:n,ys:s}=ku(t,e.value),a=n.concat(s),o=ve(()=>r(a));if(ke(a),0===u)for(let t=0;t<o.length;++t)i.push(er(0));const h=a[0].shape[0];for(let t=0;t<o.length;++t){const e=o[t],n=i[t];i[t]=ve(()=>Ie(i[t],Ee(h,e))),u>0&&ke(n)}ke(o),l+=h,++u}return i}),e.done){s&&console.warn(`Your dataset iterator ran out of data during evaluateDataset(). Interrupting evalution. Make sure that your dataset can generate at least \`batches\` batches (in this case, ${n.batches} batches). You may need to use the repeat() function when building your dataset.`);break}}for(let t=0;t<i.length;++t){const e=i[t];i[t]=Ae(i[t],l),ke(e)}return Fa(i)}(this,t,e)}checkNumSamples(t,e,n,s="steps"){let r;if(null!=n){if(r=null,null!=e)throw new Aa(`If ${s} is set, batchSize must be null or undefined.Got batchSize = `+e)}else{if(null==t)throw new Aa("Either the input data should have a defined shape, or "+s+" shoud be specified.");r=Array.isArray(t)?t[0].shape[0]:t.shape[0]}return r}execute(t,e){if(Array.isArray(e)&&0===e.length)throw new Aa("`outputs` is an empty Array, which is not allowed.");const n=Array.isArray(e),s=n?e:[e],r=this.retrieveSymbolicTensors(s),i=new hu;if(t instanceof X&&(t=[t]),Array.isArray(t)){if(t.length!==this.inputs.length)throw new Aa(`The number of inputs provided (${t.length}) does not match the number of inputs of this model (${this.inputs.length}).`);for(let e=0;e<this.inputs.length;++e)i.add(this.inputs[e],t[e])}else for(const e of this.inputs){const n=t[e.name];if(null==n)throw new Aa("No value is provided for the model's input "+e.name);i.add(e,n)}const a=du(r,i);return n?a:a[0]}retrieveSymbolicTensors(t){const e=Da(null,t.length);let n=t.length;for(const s of this.layers){const r=Array.isArray(s.output)?s.output:[s.output],i=r.map(t=>t.name);for(let s=0;s<t.length;++s){const a=i.indexOf(t[s]);if(-1!==a&&(e[s]=r[a],n--),0===n)break}if(0===n)break}if(n>0){const n=[];throw e.forEach((e,s)=>{null==e&&n.push(t[s])}),new Aa("Cannot find SymbolicTensors for output name(s): "+JSON.stringify(n))}return e}predictLoop(t,e=32,n=!1){return ve(()=>{const s=this.checkNumSamples(t);if(n)throw new Ea("Verbose predictLoop() is not implemented yet.");const r=Tu(s,e),i=this.outputs.map(t=>[]);for(let e=0;e<r.length;++e){ve(()=>{const n=r[e][0],s=r[e][1],i=Au(t,n,s),a=[];if(Array.isArray(i))for(let t=0;t<i.length;++t)a.push({key:this.inputs[t],value:i[t]});else a.push({key:this.inputs[0],value:i});const o=new hu(a);return du(this.outputs,o)}).forEach((t,e)=>i[e].push(t))}return Fa(i.map(t=>Je(t,0)))})}predict(t,e={}){const n=zu(t);Lu(n,this.inputNames,this.feedInputShapes,!1);try{const s=null==e.batchSize?32:e.batchSize;return Nu(s),this.predictLoop(n,s)}finally{Cu(n,t)}}predictOnBatch(t){Lu(t,this.inputNames,this.feedInputShapes,!0);const e=(Array.isArray(t)?t[0]:t).shape[0];return this.predictLoop(t,e)}standardizeUserDataXY(t,e,n=!0,s){if(null==this.optimizer_)throw new Na("You must compile a model before training/testing. Use LayersModel.compile(modelCompileArgs).");const r=[];for(let t=0;t<this.feedOutputShapes.length;++t){const e=this.feedOutputShapes[t];this.feedLossFns[t]===jl?r.push(e.slice(0,e.length-1).concat([1])):r.push(e)}if(function(t,e,n){const s=Pa(t.map(t=>t.shape[0]));s.sort();const r=Pa(e.map(t=>t.shape[0]));if(r.sort(),s.length>1)throw new Aa("All input Tensors (x) should have the same number of samples. Got array shapes: "+JSON.stringify(t.map(t=>t.shape)));if(r.length>1)throw new Aa("All target Tensors (y) should have the same number of samples. Got array shapes: "+JSON.stringify(e.map(t=>t.shape)));if(s.length>0&&r.length>0&&!c(s,r))throw new Aa(`Input Tensors should have the same number of samples as target Tensors. Found ${s[0]} input sample(s) and ${r[0]} target sample(s).`)}(t=Mu(t,this.feedInputNames,this.feedInputShapes,!1,"input"),e=Mu(e,this.feedOutputNames,r,!1,"target")),function(t,e,n){const s=[Bl,ql,Wl];for(let r=0;r<t.length;++r){const i=t[r],a=e[r],o=n[r];if(null!=a){if(a===Wl&&1===i.shape[i.shape.length-1])throw new Aa(`You are passing a target array of shape ${i.shape} while using a loss 'categorical_crossentropy'. 'categorical_crossentropy'expects targets to be binary matrices (1s and 0s) of shape [samples, classes].`);if(-1!==s.indexOf(a)){const t=i.shape.slice(1),e=o.slice(1);for(let n=0;n<t.length;++n){const s=t[n],r=e[n];if(null!=r&&s!==r)throw new Aa(`A target Tensor with shape ${i.shape} was passed for an output of shape ${o}, while using a loss function that expects targets to have the same shape as the output.`)}}}}}(e,this.feedLossFns,this.feedOutputShapes),this.stateful&&null!=s&&s>0&&t[0].shape[0]%s!=0)throw new Aa(`In a stateful network, you should only pass inputs with a number of samples that is divisible by the batch size ${s}. Found: ${t[0].shape[0]} sample(s).`);return[t,e]}async standardizeUserData(t,e,n,s,r=!0,i){const[a,o]=this.standardizeUserDataXY(t,e,r,i);if(null!=n)throw new Error("sample weight is not supported yet.");let l=null;if(null!=s){const t=bu(s,this.outputNames);l=[];for(let e=0;e<t.length;++e)l.push(await wu(o[e],null,t[e]))}return[a,o,l]}testLoop(t,e,n,s=0,r){return ve(()=>{const i=this.checkNumSamples(e,n,r,"steps"),a=[];if(s>0)throw new Ea("Verbose mode is not implemented yet.");if(null!=r)throw new Ea("steps mode in testLoop() is not implemented yet");{const s=Tu(i,n),r=Ir(xo(0,i));for(let n=0;n<s.length;++n){const i=s[n][0],o=s[n][1],l=No(r,i,o-i),u=Eu(e,l),h=t(u);if(0===n)for(let t=0;t<h.length;++t)a.push(er(0));for(let t=0;t<h.length;++t){const e=h[t];a[t]=Ie(a[t],Ee(o-i,e))}}for(let t=0;t<a.length;++t)a[t]=Ae(a[t],i)}return a})}getDedupedMetricsNames(){const t=this.metricsNames,e=[];for(let n=0;n<t.length;++n){const s=t[n];let r=s;if(Ca(t,s)>1){r+="_"+Ca(t.slice(0,n),s)}e.push(r)}return e}makeTrainFunction(){return t=>{const e=[],n=t.slice(0,this.inputs.length),s=t.slice(this.inputs.length,this.inputs.length+this.outputs.length),r=t.slice(this.inputs.length+this.outputs.length,this.inputs.length+2*this.outputs.length),i=[],a=this.collectedTrainableWeights.map(t=>t.read());return[this.optimizer_.minimize(()=>{const t=[];for(let e=0;e<this.inputs.length;++e)t.push({key:this.inputs[e],value:n[e]});const a=new hu(t),o=du(this.outputs,a,{training:!0});let l;for(let t=0;t<this.lossFunctions.length;++t){let n=(0,this.lossFunctions[t])(s[t],o[t]);null!=r[t]&&(n=vu(n,r[t]));const i=ys(n);e.push(i),l=0===t?n:Ie(l,n)}for(let t=0;t<this.metricsTensors.length;++t){let n;if(this.outputs.length>1&&t<this.outputs.length)n=e[t];else{const e=this.metricsTensors[t][0],r=this.metricsTensors[t][1];n=ys(e(s[r],o[r]))}xe(n),i.push(n)}return l=ys(l),this.calculateLosses().forEach(t=>{l=Ie(l,t)}),l},!0,a)].concat(i)}}makeTestFunction(){this.testFunction=t=>ve(()=>{const e=[];let n;const s=t.slice(0,this.inputs.length),r=t.slice(this.inputs.length,this.inputs.length+this.outputs.length),i=[];for(let t=0;t<this.inputs.length;++t)i.push({key:this.inputs[t],value:s[t]});const a=new hu(i),o=du(this.outputs,a);for(let t=0;t<this.lossFunctions.length;++t){const s=this.lossFunctions[t],i=ys(s(r[t],o[t]));n=0===t?i:Ie(n,i),e.push(n)}for(let t=0;t<this.metricsTensors.length;++t){const n=this.metricsTensors[t][0],s=this.metricsTensors[t][1],i=ys(n(r[s],o[s]));e.push(i)}return e})}async fit(t,e,n={}){return Du(this,t,e,n)}async fitDataset(t,e){return Su(this,t,e)}async trainOnBatch(t,e){const n=await this.standardizeUserData(t,e),s=n[0],r=n[1],i=this.makeTrainFunction()(s.concat(r)),a=[];for(const t of i){const e=await t.data();a.push(e[0])}return ke(i),Fa(a)}getNamedWeights(t){const e=[],n=null!=t&&t.trainableOnly,s=n?this.trainableWeights:this.weights,r=this.getWeights(n);for(let t=0;t<s.length;++t)n&&!s[t].trainable||e.push({name:s[t].originalName,tensor:r[t]});return e}set stopTraining(t){this.stopTraining_=t}get stopTraining(){return this.stopTraining_}get optimizer(){return this.optimizer_}set optimizer(t){this.optimizer_!==t&&(this.optimizer_=t,this.isOptimizerOwned=!1)}dispose(){const t=super.dispose();if(0===t.refCountAfterDispose&&null!=this.optimizer&&this.isOptimizerOwned){const e=we().numTensors;this.optimizer_.dispose(),t.numDisposedVariables+=e-we().numTensors}return t}getLossIdentifiers(){let t;if("string"==typeof this.loss)t=Ma(this.loss);else if(Array.isArray(this.loss)){for(const t of this.loss)if("string"!=typeof t)throw new Error("Serialization of non-string loss is not supported.");t=this.loss.map(t=>Ma(t))}else{const e=Object.keys(this.loss);t={};const n=this.loss;for(const s of e){if("string"!=typeof n[s])throw new Error("Serialization of non-string loss is not supported.");t[s]=Ma(n[s])}}return t}getMetricIdentifiers(){if("string"==typeof this.metrics||"function"==typeof this.metrics)return[Ma(nu(this.metrics))];if(Array.isArray(this.metrics))return this.metrics.map(t=>Ma(nu(t)));{const t={};for(const e in this.metrics)t[e]=Ma(nu(this.metrics[e]));return t}}getTrainingConfig(){return{loss:this.getLossIdentifiers(),metrics:this.getMetricIdentifiers(),optimizer_config:{class_name:this.optimizer.getClassName(),config:this.optimizer.getConfig()}}}loadTrainingConfig(t){if(null!=t.weighted_metrics)throw new Error("Loading weight_metrics is not supported yet.");if(null!=t.loss_weights)throw new Error("Loading loss_weights is not supported yet.");if(null!=t.sample_weight_mode)throw new Error("Loading sample_weight_mode is not supported yet.");const e=$l(uu(t.optimizer_config));let n,s;if("string"==typeof t.loss)n=La(t.loss);else if(Array.isArray(t.loss))n=t.loss.map(t=>La(t));else if(null!=t.loss){n={};for(const e in t.loss)n[e]=La(t.loss[e])}if(Array.isArray(t.metrics))s=t.metrics.map(t=>La(t));else if(null!=t.metrics){s={};for(const e in t.metrics)s[e]=La(t.metrics[e])}this.compile({loss:n,metrics:s,optimizer:e})}async save(t,e){if("string"==typeof t){const e=(n=t,Ft.getSaveHandlers(n));if(0===e.length)throw new Aa(`Cannot find any save handlers for URL '${t}'`);if(e.length>1)throw new Aa(`Found more than one (${e.length}) save handlers for URL '${t}'`);t=e[0]}var n;if(null==t.save)throw new Aa("LayersModel.save() cannot proceed because the IOHandler provided does not have the `save` attribute defined.");const s=await Nt(this.getNamedWeights(e)),r={modelTopology:this.toJSON(null,!1),format:"layers-model",generatedBy:"TensorFlow.js tfjs-layers v3.0.0",convertedBy:null};if(null!=e&&e.includeOptimizer&&null!=this.optimizer){r.trainingConfig=this.getTrainingConfig();const t="optimizer",{data:e,specs:n}=await Nt(await this.optimizer.getWeights(),t);s.specs.push(...n),s.data=Dt([s.data,e])}if(null!=this.userDefinedMetadata){const t=!0;su(this.userDefinedMetadata,this.name,t),r.userDefinedMetadata=this.userDefinedMetadata}return r.weightData=s.data,r.weightSpecs=s.specs,t.save(r)}setUserDefinedMetadata(t){su(t,this.name),this.userDefinedMetadata=t}getUserDefinedMetadata(){return this.userDefinedMetadata}}_u.className="Model",be(_u);class $u extends _u{}async function Ou(t,e){if(null==e&&(e={}),"string"==typeof t){const r=(n=t,s=e,Ft.getLoadHandlers(n,s));if(0===r.length)r.push(function(t,e){return ue(t,e)}(t,e));else if(r.length>1)throw new Aa(`Found more than one (${r.length}) load handlers for URL '${t}'`);t=r[0]}var n,s;return async function(t,e,n){null==n&&(n={});if(null==t.load)throw new Aa("Cannot proceed with model loading because the IOHandler provided does not have the `load` method implemented.");const s=await t.load();let r=s.modelTopology;null!=r.model_config&&(r=r.model_config);const i=null==n.strict||n.strict,a=null!=s.weightData&&null!=s.weightSpecs&&i,o=$l(uu(r),e,a),l=s.trainingConfig;null!=l&&o.loadTrainingConfig(l);null!=s.userDefinedMetadata&&o.setUserDefinedMetadata(s.userDefinedMetadata);if(null!=s.weightData){if(null==s.weightSpecs)throw new Aa("LayersModel artifacts contains weight data, but not weight specs. Therefore loading of weights cannot proceed.");const{modelWeights:t,optimizerWeights:e}=function(t,e){const n=function(t,e){const n={};let s,r=0;for(const i of e){const e=i.name,a=i.dtype,o=i.shape,l=h(o);let u;if("quantization"in i){const n=i.quantization;if("uint8"===n.dtype||"uint16"===n.dtype){if(!("min"in n)||!("scale"in n))throw new Error(`Weight ${i.name} with quantization ${n.dtype} doesn't have corresponding metadata min and scale.`)}else{if("float16"!==n.dtype)throw new Error(`Weight ${i.name} has unknown quantization dtype ${n.dtype}. Supported quantization dtypes are: 'uint8', 'uint16', and 'float16'.`);if("float32"!==a)throw new Error(`Weight ${i.name} is quantized with ${n.dtype} which only supports weights of type float32 not ${a}.`)}const o=It[n.dtype],h=t.slice(r,r+l*o),c="uint8"===n.dtype?new Uint8Array(h):new Uint16Array(h);if("float32"===a)if("uint8"===n.dtype||"uint16"===n.dtype){u=new Float32Array(c.length);for(let t=0;t<c.length;t++){const e=c[t];u[t]=e*n.scale+n.min}}else{if("float16"!==n.dtype)throw new Error(`Unsupported quantization type ${n.dtype} for weight type float32.`);void 0===s&&(s=Ct()),u=s(c)}else{if("int32"!==a)throw new Error(`Unsupported dtype in weight '${e}': ${a}`);if("uint8"!==n.dtype&&"uint16"!==n.dtype)throw new Error(`Unsupported quantization type ${n.dtype} for weight type int32.`);u=new Int32Array(c.length);for(let t=0;t<c.length;t++){const e=c[t];u[t]=Math.round(e*n.scale+n.min)}}r+=l*o}else if("string"===a){const e=h(i.shape);u=[];for(let n=0;n<e;n++){const e=new Uint32Array(t.slice(r,r+4))[0];r+=4;const n=new Uint8Array(t.slice(r,r+e));u.push(n),r+=e}}else{const s=It[a],i=t.slice(r,r+l*s);if("float32"===a)u=new Float32Array(i);else if("int32"===a)u=new Int32Array(i);else if("bool"===a)u=new Uint8Array(i);else{if("complex64"!==a)throw new Error(`Unsupported dtype in weight '${e}': ${a}`);{u=new Float32Array(i);const t=new Float32Array(u.length/2),s=new Float32Array(u.length/2);for(let e=0;e<t.length;e++)t[e]=u[2*e],s[e]=u[2*e+1];const r=St(t,o,"float32"),a=St(s,o,"float32");n[e]=kt(r,a),r.dispose(),a.dispose()}}r+=l*s}"complex64"!==a&&(n[e]=St(u,o,a))}return n}(t,e),s={},r=[];return e.forEach(t=>{"optimizer"===t.group?r.push({name:t.name,tensor:n[t.name]}):s[t.name]=n[t.name]}),{modelWeights:s,optimizerWeights:r}}(s.weightData,s.weightSpecs);o.loadWeights(t,i),null!=o.optimizer&&e.length>0&&await o.optimizer.setWeights(e),ke(t),ke(e.map(t=>t.tensor))}return o}(t,void 0,e)}$u.className="Functional",be($u);class Bu extends _u{constructor(t){if(super({inputs:[],outputs:[]}),t=t||{},this.trainable=!0,this.built=!1,this.name=null!=t.name?t.name:hl("sequential_"),null!=t.layers)for(const e of t.layers)this.add(e)}checkShape(t){if(t.inboundNodes[0].outputTensors[0].shape.some(t=>t<0))throw new Aa("Negative dimension size caused by adding layer "+t.name+" with input shape ["+t.inboundNodes[0].inputTensors[0].shape+"]")}add(t){const e=t instanceof Bu||t instanceof _u;let n;if(e){if(n=t,1!==n.outputs.length)throw new Aa("All layers in a Sequential model should have a single output tensor. For multi-output layers, use the functional API.");if(1!==n.inputs.length)throw new Aa("All layers in a Sequential model should have a single input tensor. For multi-input layers, use the functional API.")}if(0===this.outputs.length){if(0===t.inboundNodes.length){if(null==t.batchInputShape)throw new Aa("The first layer in a Sequential model must get an `inputShape` or `batchInputShape` argument.");const e=function(t){if(null==t.batchShape&&null==t.shape)throw new Error("Please provide to Input either a `shape` or a `batchShape` argument. Note that `shape` does not include the batch dimension.");if(null!=t.batchShape&&null!=t.shape)throw new Aa("Please provide either a `shape` or `batchShape` argument to Input, but not both.");let e=t.batchShape;null!=t.shape&&null==e&&(e=[null].concat(t.shape));let n=t.dtype;return null==n&&(n="float32"),new Nl({batchInputShape:e,name:t.name,dtype:n,sparse:t.sparse}).inboundNodes[0].outputTensors[0]}({batchShape:t.batchInputShape,dtype:t.dtype,name:t.name+"_input"});t.apply(e)}if(e)this.outputs=n.outputs,this.inputs=n.inputs;else{if(1!==t.inboundNodes.length)throw new Aa(`A layer added to a Sequential model must not already be connected somewhere else. LayersModel received layer ${t.name} which has ${t.inboundNodes.length} pre-existing inbound connections.`);if(1!==t.inboundNodes[0].outputTensors.length)throw new Aa("All layers in a Sequential model should have a single output tensor. For multi-output layers, use the functional API.");this.checkShape(t),this.outputs=[t.inboundNodes[0].outputTensors[0]],this.inputs=function t(e,n,s){if((null==n||null!=s&&s>0)&&(n=e.sourceLayer,s=e.nodeIndex),0===n.inboundNodes.length)return[e];{const e=n.inboundNodes[s];if(0===e.inboundLayers.length)return e.inputTensors;{const n=[];for(let s=0;s<e.inboundLayers.length;s++){const r=t(e.inputTensors[s],e.inboundLayers[s],e.nodeIndices[s]);for(const t of r)-1===n.indexOf(t)&&n.push(t)}return n}}}(this.outputs[0])}this.inboundNodes=[],new xl({outboundLayer:this,inboundLayers:[],nodeIndices:[],tensorIndices:[],inputTensors:this.inputs,outputTensors:this.outputs,inputMasks:Da(null,this.inputs.length),outputMasks:[null],inputShapes:this.inputs.map(t=>t.shape),outputShapes:this.outputs[0].shape})}else{const e=t.apply(this.outputs[0]);if(Array.isArray(e))throw new TypeError("All layers in a Sequential model should have a single output tensor. For multi-output layers, use the functional API.");this.checkShape(t),this.outputs=[e],this.inboundNodes[0].outputTensors=this.outputs,this.inboundNodes[0].outputShapes=[this.outputs[0].shape]}this.layers.push(t),this.built=!1}pop(){if(0===this.layers.length)throw new TypeError("There are no layers in the model.");if(this.layers.pop(),0===this.layers.length)this.outputs=[],this.inboundNodes=[],this.outboundNodes=[];else{const t=this.layers.length-1;this.layers[t].outboundNodes=[],this.outputs=[this.layers[t].output],this.inboundNodes[0].outputTensors=this.outputs,this.inboundNodes[0].outputShapes=[this.outputs[0].shape]}}call(t,e){return null==this.model&&this.build(),this.model.call(t,e)}build(t){if(fl(t),0===this.inputs.length||0===this.outputs.length)throw new TypeError("Sequential model cannot be built: model is empty. Add some layers first.");this.model=new _u({inputs:this.inputs,outputs:this.outputs[0],name:this.name+"_model"}),this.model.trainable=this.trainable,this.supportsMasking=this.model.supportsMasking,this.inputLayers=this.model.inputLayers,this.inputLayersNodeIndices=this.model.inputLayersNodeIndices,this.inputLayersTensorIndices=this.model.inputLayersTensorIndices,this.outputLayers=this.model.outputLayers,this.outputLayersNodeIndices=this.model.outputLayersNodeIndices,this.outputLayersTensorIndices=this.model.outputLayersTensorIndices,this.nodesByDepth=this.model.nodesByDepth,this.containerNodes=this.model.containerNodes,this.outputNames=this.model.outputNames,this.inputNames=this.model.inputNames,this.built=!0}countParams(){return this.built||this.build(),super.countParams()}summary(t,e,n=console.log){this.built||this.build(),super.summary(t,e,n)}setWeights(t){null==this.model&&this.build(),this.model.setWeights(t)}evaluate(t,e,n={}){if(!this.built)throw new Na("The model needs to be compiled before being used.");return this.model.evaluate(t,e,n)}async evaluateDataset(t,e){if(!this.built)throw new Na("The model needs to be compiled before being used.");return this.model.evaluateDataset(t,e)}predict(t,e={}){return null==this.model&&this.build(),this.model.predict(t,e)}predictOnBatch(t){return null==this.model&&this.build(),this.model.predictOnBatch(t)}compile(t){this.build(),this.model.compile(t),this.optimizer_=this.model.optimizer,this.isOptimizerOwned=this.model.isOptimizerOwned,this.loss=this.model.loss,this.metrics=this.model.metrics,this.metricsTensors=this.model.metricsTensors,this.metricsNames=this.model.metricsNames}get optimizer(){return null==this.model?void 0:this.model.optimizer}set optimizer(t){this.model.optimizer=t}async fit(t,e,n={}){if(!this.built)throw new Na("The model needs to be compiled before being used.");return this.model.fit(t,e,n)}async fitDataset(t,e){if(!this.built)throw new Na("The model needs to be compiled before being used.");return this.model.fitDataset(t,e)}async trainOnBatch(t,e){return this.model.trainOnBatch(t,e)}static fromConfig(t,e,n={},s=!1){let r,i={};if(e instanceof Array){if(null==e[0].className||"Merge"===e[0].className)throw new Aa("Legacy serialization format not supported yet.");r=e}else a(null!=e.layers,()=>"When the config data for a Sequential model is not an Array, it must be an Object that contains the 'layers' field."),r=e.layers,delete e.layers,i=e;const o=new t(i);if(!(o instanceof Bu))throw new Ea("Sequential.fromConfig called on non-Sequential input: "+o);for(const t of r){const e=$l(t,void 0,s);s&&e.setFastWeightInitDuringBuild(!0),o.add(e)}return o}set stopTraining(t){if(null==this.model)throw new Aa("Cannot set the stopTraining property of a sequential model before it is compiled.");this.model.stopTraining=t}get stopTraining(){if(null==this.model)throw new Aa("Cannot get the stopTraining property of a sequential model before it is compiled.");return this.model.stopTraining}getConfig(){const t=[];for(const e of this.layers){const n={};n.className=e.getClassName(),n.config=e.getConfig(),t.push(n)}return{name:this.name,layers:t}}}function Pu(t){return new _u(t)}function Uu(t,e){return null==e&&(e={}),Ou(t,e)}Bu.className="Sequential",be(Bu);class Wu extends ge{getConfig(){return{}}}class ju extends Wu{apply(t,e=1){return function(t,e=1){if(1!==e)throw new Ea(`Support for alpha values other than 1 (${e}) is not implemented yet.`);return Cn(t)}(t,e)}}ju.className="elu",be(ju);class qu extends Wu{apply(t){return nr(t)}}qu.className="selu",be(qu);class Ku extends Wu{apply(t){return Zs(t)}}Ku.className="relu",be(Ku);class Vu extends Wu{apply(t){return ve(()=>ws(6,Zs(t)))}}Vu.className="relu6",be(Vu);class Hu extends Wu{apply(t){return t}}Hu.className="linear",be(Hu);class Gu extends Wu{apply(t){return Ze(t)}}Gu.className="sigmoid",be(Gu);class Ju extends Wu{apply(t){return function(t){return ve(()=>{const e=Ie(.5,Ee(.2,t));return on(e,0,1)})}(t)}}Ju.className="hardSigmoid",be(Ju);class Zu extends Wu{apply(t){return es(t)}}Zu.className="softplus",be(Zu);class Xu extends Wu{apply(t){return function(t){return ve(()=>Ae(t,Te(t).add(1)))}(t)}}Xu.className="softsign",be(Xu);class Yu extends Wu{apply(t){return Ye(t)}}Yu.className="tanh",be(Yu);class Qu extends Wu{apply(t,e=-1){return cr(t,e)}}Qu.className="softmax",be(Qu);class th extends Wu{apply(t,e=-1){return as(t,e)}}th.className="logSoftmax",be(th);class eh extends Wu{apply(t,e=1){return ve(()=>Ze(t.mul(e)).mul(t))}}function nh(t){return t.getClassName()}function sh(t,e={}){return Oa(t,ye.getMap().classNameMap,e,"activation")}function rh(t){if(null==t){const t={className:"linear",config:{}};return sh(t)}if("string"==typeof t){const e={};return e.className=t,e.config={},sh(e)}return t instanceof Wu?t:sh(t)}eh.className="swish",be(eh);class ih extends ge{}class ah extends ih{constructor(t){super(),function(t){if(null!=t&&"object"!=typeof t)throw new Error("Argument to L1L2 regularizer's constructor is expected to be an object, but received: "+t)}(t),this.l1=null==t||null==t.l1?.01:t.l1,this.l2=null==t||null==t.l2?.01:t.l2,this.hasL1=0!==this.l1,this.hasL2=0!==this.l2}apply(t){return ve(()=>{let e=Ns([1]);return this.hasL1&&(e=Ie(e,is(Ee(this.l1,Te(t))))),this.hasL2&&(e=Ie(e,is(Ee(this.l2,Mo(t))))),e.asScalar()})}getConfig(){return{l1:this.l1,l2:this.l2}}static fromConfig(t,e){return new t({l1:e.l1,l2:e.l2})}}ah.className="L1L2",be(ah);const oh={l1l2:"L1L2"};function lh(t){return $a(t)}function uh(t,e={}){return Oa(t,ye.getMap().classNameMap,e,"regularizer")}function hh(t){if(null==t)return null;if("string"==typeof t){return uh({className:t in oh?oh[t]:t,config:{}})}return t instanceof ih?t:uh(t)}class ch extends Il{constructor(t){super(null==t?{}:t),this.supportsMasking=!0,null!=t&&(this.maxValue=t.maxValue)}call(t,e){t=dl(t);let n=Zs(t);return null!=this.maxValue&&(n=on(n,0,this.maxValue)),n}computeOutputShape(t){return t}getConfig(){const t={maxValue:this.maxValue},e=super.getConfig();return Object.assign(t,e),t}}ch.className="ReLU",be(ch);class ph extends Il{constructor(t){super(null==t?{}:t),this.DEFAULT_ALPHA=.3,null==t&&(t={}),this.alpha=null==t.alpha?this.DEFAULT_ALPHA:t.alpha}call(t,e){const n=dl(t);return Hn(n,this.alpha)}computeOutputShape(t){return t}getConfig(){const t={alpha:this.alpha},e=super.getConfig();return Object.assign(t,e),t}}ph.className="LeakyReLU",be(ph);class dh extends Il{constructor(t){if(super(null==t?{}:t),this.DEFAULT_ALPHA_INITIALIZER="zeros",null==t&&(t={}),this.supportsMasking=!0,this.alphaInitializer=al(t.alphaInitializer||this.DEFAULT_ALPHA_INITIALIZER),this.alphaRegularizer=hh(t.alphaRegularizer),this.alphaConstraint=eo(t.alphaConstraint),null==t.sharedAxes)this.sharedAxes=null;else if(Array.isArray(t.sharedAxes))this.sharedAxes=t.sharedAxes;else{if("number"!=typeof t.sharedAxes)throw new Aa("Expected sharedAxes to be a number or an array of numbers, but got "+t.sharedAxes);this.sharedAxes=[t.sharedAxes]}}build(t){const e=(t=fl(t)).slice(1);if(null!=this.sharedAxes)for(const t of this.sharedAxes)e[t-1]=1;this.alpha=this.addWeight("alpha",e,"float32",this.alphaInitializer,this.alphaRegularizer,!0,this.alphaConstraint);const n={};if(null!=this.sharedAxes)for(let e=1;e<t.length;++e)n[e]=t[e];this.inputSpec=[new wl({ndim:t.length,axes:n})],this.built=!0}call(t,e){return t=dl(t),Fs(t,this.alpha.read())}getConfig(){const t={alphaInitializer:il(this.alphaInitializer),alphaRegularizer:lh(this.alphaRegularizer),alphaConstraint:Qa(this.alphaConstraint),sharedAxes:this.sharedAxes},e=super.getConfig();return Object.assign(t,e),t}}dh.className="PReLU",be(dh);class fh extends Il{constructor(t){if(super(null==t?{}:t),this.DEFAULT_ALPHA=1,null==t&&(t={}),null!=t.alpha&&t.alpha!==this.DEFAULT_ALPHA)throw new Ea(`Non-default alpha value (${t.alpha}) is not supported by the ELU layer yet.`);this.alpha=null==t.alpha?this.DEFAULT_ALPHA:t.alpha}call(t,e){const n=dl(t);return Cn(n)}computeOutputShape(t){return t}getConfig(){const t={alpha:this.alpha},e=super.getConfig();return Object.assign(t,e),t}}fh.className="ELU",be(fh);class mh extends Il{constructor(t){super(null==t?{}:t),this.DEFAULT_THETA=1,null==t&&(t={}),this.theta=null==t.theta?this.DEFAULT_THETA:t.theta}call(t,e){const n=dl(t);return n.mul(So(n.greater(this.theta),"float32"))}computeOutputShape(t){return t}getConfig(){const t={theta:this.theta},e=super.getConfig();return Object.assign(t,e),t}}mh.className="ThresholdedReLU",be(mh);class gh extends Il{constructor(t){super(null==t?{}:t),this.DEFAULT_AXIS=1,null==t&&(t={}),this.softmax=(new Qu).apply,this.axis=null==t.axis?this.DEFAULT_AXIS:t.axis}call(t,e){const n=dl(t);return this.softmax(n,this.axis)}computeOutputShape(t){return t}getConfig(){const t={axis:this.axis},e=super.getConfig();return Object.assign(t,e),t}}function yh(t,e,n){if("number"==typeof t)return Da(t,e);if(t.length!==e)throw new Aa(`The ${n} argument must be an integer or tuple of ${e} integers. Received: ${t.length} elements.`);for(let r=0;r<e;++r){const i=t[r];if((s=i)!==parseInt(s.toString(),10))throw new Aa(`The ${n} argument must be an integer or tuple of ${e} integers. Received: ${JSON.stringify(t)} including a non-integer number `+i)}return t;var s}function bh(t,e,n,s,r=1){if(null==t)return t;let i;return i="same"===n?t:t-(e+(e-1)*(r-1))+1,Math.floor((i+s-1)/s)}function wh(t,e,n,s){if(null==t)return null;if("valid"===s)t=t*e+ko([n-e,0]);else{if("same"!==s)throw new Aa(`Unsupport padding mode: ${s}.`);t*=e}return t}function vh(t,e){return ve(()=>(lo(e),"channelsFirst"===e?fe(t,[0,2,3,1]):t))}function kh(t,e){return ve(()=>(lo(e),"channelsFirst"===e?fe(t,[0,2,3,4,1]):t))}function xh(t,e,n,s=[1,1],r="valid",i,a,o=null){return ve(()=>{if(null==i&&(i="channelsLast"),lo(i),3!==t.rank&&4!==t.rank)throw new Aa(`conv2dWithBiasActivation expects input to be of rank 3 or 4, but received ${t.rank}.`);if(3!==e.rank&&4!==e.rank)throw new Aa(`conv2dWithBiasActivation expects kernel to be of rank 3 or 4, but received ${t.rank}.`);let l=vh(t,i);if("causal"===r)throw new Ea("The support for CAUSAL padding mode in conv1dWithBias is not implemented yet.");return l=Or({x:l,filter:e,strides:s,pad:"same"===r?"same":"valid",dilations:a,dataFormat:"NHWC",bias:n,activation:o}),"channelsFirst"===i&&(l=fe(l,[0,3,1,2])),l})}gh.className="Softmax",be(gh);class Sh extends Il{constructor(t,e){if(super(e),this.bias=null,this.DEFAULT_KERNEL_INITIALIZER="glorotNormal",this.DEFAULT_BIAS_INITIALIZER="zeros",Sh.verifyArgs(e),this.rank=t,qa(this.rank,"rank"),1!==this.rank&&2!==this.rank&&3!==this.rank)throw new Ea(`Convolution layer for rank other than 1, 2, or 3 (${this.rank}) is not implemented yet.`);if(this.kernelSize=yh(e.kernelSize,t,"kernelSize"),this.strides=yh(null==e.strides?1:e.strides,t,"strides"),this.padding=null==e.padding?"valid":e.padding,uo(this.padding),this.dataFormat=null==e.dataFormat?"channelsLast":e.dataFormat,lo(this.dataFormat),this.activation=rh(e.activation),this.useBias=null==e.useBias||e.useBias,this.biasInitializer=al(e.biasInitializer||this.DEFAULT_BIAS_INITIALIZER),this.biasConstraint=eo(e.biasConstraint),this.biasRegularizer=hh(e.biasRegularizer),this.activityRegularizer=hh(e.activityRegularizer),this.dilationRate=yh(null==e.dilationRate?1:e.dilationRate,t,"dilationRate"),1===this.rank&&Array.isArray(this.dilationRate)&&1!==this.dilationRate.length)throw new Aa("dilationRate must be a number or an array of a single number for 1D convolution, but received "+JSON.stringify(this.dilationRate));if(2===this.rank){if("number"==typeof this.dilationRate)this.dilationRate=[this.dilationRate,this.dilationRate];else if(2!==this.dilationRate.length)throw new Aa("dilationRate must be a number or array of two numbers for 2D convolution, but received "+JSON.stringify(this.dilationRate))}else if(3===this.rank)if("number"==typeof this.dilationRate)this.dilationRate=[this.dilationRate,this.dilationRate,this.dilationRate];else if(3!==this.dilationRate.length)throw new Aa("dilationRate must be a number or array of three numbers for 3D convolution, but received "+JSON.stringify(this.dilationRate))}static verifyArgs(t){if(za("kernelSize"in t,"required key 'kernelSize' not in config"),"number"!=typeof t.kernelSize&&!ja(t.kernelSize,"number",1,3))throw new Aa(`BaseConv expects config.kernelSize to be number or number[] with length 1, 2, or 3, but received ${JSON.stringify(t.kernelSize)}.`)}getConfig(){const t={kernelSize:this.kernelSize,strides:this.strides,padding:this.padding,dataFormat:this.dataFormat,dilationRate:this.dilationRate,activation:nh(this.activation),useBias:this.useBias,biasInitializer:il(this.biasInitializer),biasRegularizer:lh(this.biasRegularizer),activityRegularizer:lh(this.activityRegularizer),biasConstraint:Qa(this.biasConstraint)},e=super.getConfig();return Object.assign(t,e),t}}class Ih extends Sh{constructor(t,e){super(t,e),this.kernel=null,Ih.verifyArgs(e),this.filters=e.filters,qa(this.filters,"filters"),this.kernelInitializer=al(e.kernelInitializer||this.DEFAULT_KERNEL_INITIALIZER),this.kernelConstraint=eo(e.kernelConstraint),this.kernelRegularizer=hh(e.kernelRegularizer)}build(t){t=fl(t);const e="channelsFirst"===this.dataFormat?1:t.length-1;if(null==t[e])throw new Aa("The channel dimension of the input should be defined. Found "+t[e]);const n=t[e],s=this.kernelSize.concat([n,this.filters]);this.kernel=this.addWeight("kernel",s,null,this.kernelInitializer,this.kernelRegularizer,!0,this.kernelConstraint),this.useBias&&(this.bias=this.addWeight("bias",[this.filters],null,this.biasInitializer,this.biasRegularizer,!0,this.biasConstraint)),this.inputSpec=[{ndim:this.rank+2,axes:{[e]:n}}],this.built=!0}call(t,e){return ve(()=>{let e;t=dl(t);const n=null==this.bias?null:this.bias.read(),s=Ka(this.activation.getClassName());if(null!=s&&2===this.rank)e=xh(t,this.kernel.read(),n,this.strides,this.padding,this.dataFormat,this.dilationRate,s);else{if(1===this.rank)e=function(t,e,n,s=1,r="valid",i,a=1){return ve(()=>{if(null==i&&(i="channelsLast"),lo(i),3!==t.shape.length)throw new Aa("The input of a conv1dWithBias operation should be 3, but is "+t.shape.length+" instead.");if(3!==e.shape.length)throw new Aa("The kernel for a conv1dWithBias operation should be 3, but is "+e.shape.length+" instead");if(null!=n&&1!==n.shape.length)throw new Aa("The bias for a conv1dWithBias operation should be 1, but is "+e.shape.length+" instead");if("channelsFirst"===i&&(t=fe(t,[0,2,1])),"causal"===r)throw new Ea("The support for CAUSAL padding mode in conv1dWithBias is not implemented yet.");let o=dn(t,e,s,"same"===r?"same":"valid","NWC",a);return null!=n&&(o=_o(o,n)),o})}(t,this.kernel.read(),n,this.strides[0],this.padding,this.dataFormat,this.dilationRate[0]);else if(2===this.rank)e=xh(t,this.kernel.read(),n,this.strides,this.padding,this.dataFormat,this.dilationRate);else{if(3!==this.rank)throw new Ea("convolutions greater than 3D are not implemented yet.");e=function(t,e,n,s=[1,1,1],r="valid",i,a){return ve(()=>{if(null==i&&(i="channelsLast"),lo(i),4!==t.rank&&5!==t.rank)throw new Aa("conv3dWithBias expects input to be of rank 4 or 5, but received "+t.rank+".");if(4!==e.rank&&5!==e.rank)throw new Aa("conv3dWithBias expects kernel to be of rank 4 or 5, but received "+t.rank+".");let o=kh(t,i);if("causal"===r)throw new Ea("The support for CAUSAL padding mode in conv3dWithBias is not implemented yet.");return o=gn(o,e,s,"same"===r?"same":"valid","NDHWC",a),null!=n&&(o=_o(o,n)),"channelsFirst"===i&&(o=fe(o,[0,4,1,2,3])),o})}(t,this.kernel.read(),n,this.strides,this.padding,this.dataFormat,this.dilationRate)}null!=this.activation&&(e=this.activation.apply(e))}return e})}computeOutputShape(t){t=fl(t);const e=[],n="channelsLast"===this.dataFormat?t.slice(1,t.length-1):t.slice(2);for(let t=0;t<n.length;++t){const s=bh(n[t],this.kernelSize[t],this.padding,this.strides[t],"number"==typeof this.dilationRate?this.dilationRate:this.dilationRate[t]);e.push(s)}let s=[t[0]];return"channelsLast"===this.dataFormat?(s=s.concat(e),s.push(this.filters)):(s.push(this.filters),s=s.concat(e)),s}getConfig(){const t={filters:this.filters,kernelInitializer:il(this.kernelInitializer),kernelRegularizer:lh(this.kernelRegularizer),kernelConstraint:Qa(this.kernelConstraint)},e=super.getConfig();return Object.assign(t,e),t}static verifyArgs(t){if(!("filters"in t)||"number"!=typeof t.filters||t.filters<1)throw new Aa("Convolution layer expected config.filters to be a 'number' > 0 but got "+JSON.stringify(t.filters))}}class Nh extends Ih{constructor(t){super(2,t),Nh.verifyArgs(t)}getConfig(){const t=super.getConfig();return delete t.rank,t}static verifyArgs(t){if("number"!=typeof t.kernelSize&&!ja(t.kernelSize,"number",1,2))throw new Aa(`Conv2D expects config.kernelSize to be number or number[] with length 1 or 2, but received ${JSON.stringify(t.kernelSize)}.`)}}Nh.className="Conv2D",be(Nh);class Ah extends Ih{constructor(t){super(3,t),Ah.verifyArgs(t)}getConfig(){const t=super.getConfig();return delete t.rank,t}static verifyArgs(t){if("number"!=typeof t.kernelSize&&(!Array.isArray(t.kernelSize)||1!==t.kernelSize.length&&3!==t.kernelSize.length))throw new Aa(`Conv3D expects config.kernelSize to be number or [number, number, number], but received ${JSON.stringify(t.kernelSize)}.`)}}Ah.className="Conv3D",be(Ah);class Eh extends Nh{constructor(t){if(super(t),this.inputSpec=[new wl({ndim:4})],"same"!==this.padding&&"valid"!==this.padding)throw new Aa("Conv2DTranspose currently supports only padding modes 'same' and 'valid', but received padding mode "+this.padding)}build(t){if(4!==(t=fl(t)).length)throw new Aa("Input should have rank 4; Received input shape: "+JSON.stringify(t));const e="channelsFirst"===this.dataFormat?1:t.length-1;if(null==t[e])throw new Aa("The channel dimension of the inputs should be defined. Found `None`.");const n=t[e],s=this.kernelSize.concat([this.filters,n]);this.kernel=this.addWeight("kernel",s,"float32",this.kernelInitializer,this.kernelRegularizer,!0,this.kernelConstraint),this.useBias&&(this.bias=this.addWeight("bias",[this.filters],"float32",this.biasInitializer,this.biasRegularizer,!0,this.biasConstraint)),this.inputSpec=[new wl({ndim:4,axes:{[e]:n}})],this.built=!0}call(t,e){return ve(()=>{let e=dl(t);if(4!==e.shape.length)throw new Aa("Conv2DTranspose.call() expects input tensor to be rank-4, but received a tensor of rank-"+e.shape.length);const n=e.shape,s=n[0];let r,i;"channelsFirst"===this.dataFormat?(r=2,i=3):(r=1,i=2);const a=n[r],o=n[i],l=this.kernelSize[0],u=this.kernelSize[1],h=this.strides[0],c=this.strides[1],p=[s,wh(a,h,l,this.padding),wh(o,c,u,this.padding),this.filters];"channelsLast"!==this.dataFormat&&(e=fe(e,[0,2,3,1]));let d=mn(e,this.kernel.read(),p,this.strides,this.padding);return"channelsLast"!==this.dataFormat&&(d=fe(d,[0,3,1,2])),null!=this.bias&&(d=_o(d,this.bias.read(),this.dataFormat)),null!=this.activation&&(d=this.activation.apply(d)),d})}computeOutputShape(t){const e=(t=fl(t)).slice();let n,s,r;"channelsFirst"===this.dataFormat?(n=1,s=2,r=3):(n=3,s=1,r=2);const i=this.kernelSize[0],a=this.kernelSize[1],o=this.strides[0],l=this.strides[1];return e[n]=this.filters,e[s]=wh(e[s],o,i,this.padding),e[r]=wh(e[r],l,a,this.padding),e}getConfig(){const t=super.getConfig();return delete t.dilationRate,t}}Eh.className="Conv2DTranspose",be(Eh);class Th extends Ih{constructor(t,e){if(super(t,e),this.DEFAULT_DEPTHWISE_INITIALIZER="glorotUniform",this.DEFAULT_POINTWISE_INITIALIZER="glorotUniform",this.depthwiseKernel=null,this.pointwiseKernel=null,null==e.filters)throw new Aa("The `filters` configuration field is required by SeparableConv, but is unspecified.");if(null!=e.kernelInitializer||null!=e.kernelRegularizer||null!=e.kernelConstraint)throw new Aa("Fields kernelInitializer, kernelRegularizer and kernelConstraint are invalid for SeparableConv2D. Use depthwiseInitializer, depthwiseRegularizer, depthwiseConstraint, pointwiseInitializer, pointwiseRegularizer and pointwiseConstraint instead.");if(null!=e.padding&&"same"!==e.padding&&"valid"!==e.padding)throw new Aa(`SeparableConv${this.rank}D supports only padding modes: 'same' and 'valid', but received `+JSON.stringify(e.padding));this.depthMultiplier=null==e.depthMultiplier?1:e.depthMultiplier,this.depthwiseInitializer=al(e.depthwiseInitializer||this.DEFAULT_DEPTHWISE_INITIALIZER),this.depthwiseRegularizer=hh(e.depthwiseRegularizer),this.depthwiseConstraint=eo(e.depthwiseConstraint),this.pointwiseInitializer=al(e.depthwiseInitializer||this.DEFAULT_POINTWISE_INITIALIZER),this.pointwiseRegularizer=hh(e.pointwiseRegularizer),this.pointwiseConstraint=eo(e.pointwiseConstraint)}build(t){if((t=fl(t)).length<this.rank+2)throw new Aa(`Inputs to SeparableConv${this.rank}D should have rank `+(this.rank+2)+", but received input shape: "+JSON.stringify(t));const e="channelsFirst"===this.dataFormat?1:t.length-1;if(null==t[e]||t[e]<0)throw new Aa("The channel dimension of the inputs should be defined, but found "+JSON.stringify(t[e]));const n=t[e],s=this.kernelSize.concat([n,this.depthMultiplier]),r=[];for(let t=0;t<this.rank;++t)r.push(1);r.push(n*this.depthMultiplier,this.filters);this.depthwiseKernel=this.addWeight("depthwise_kernel",s,"float32",this.depthwiseInitializer,this.depthwiseRegularizer,!0,this.depthwiseConstraint),this.pointwiseKernel=this.addWeight("pointwise_kernel",r,"float32",this.pointwiseInitializer,this.pointwiseRegularizer,!0,this.pointwiseConstraint),this.useBias?this.bias=this.addWeight("bias",[this.filters],"float32",this.biasInitializer,this.biasRegularizer,!0,this.biasConstraint):this.bias=null,this.inputSpec=[new wl({ndim:this.rank+2,axes:{[e]:n}})],this.built=!0}call(t,e){return ve(()=>{let e;if(t=dl(t),1===this.rank)throw new Ea("1D separable convolution is not implemented yet.");return 2===this.rank&&("channelsFirst"===this.dataFormat&&(t=fe(t,[0,2,3,1])),e=sr(t,this.depthwiseKernel.read(),this.pointwiseKernel.read(),this.strides,this.padding,this.dilationRate,"NHWC")),this.useBias&&(e=_o(e,this.bias.read(),this.dataFormat)),null!=this.activation&&(e=this.activation.apply(e)),"channelsFirst"===this.dataFormat&&(e=fe(e,[0,3,1,2])),e})}getConfig(){const t=super.getConfig();return delete t.rank,delete t.kernelInitializer,delete t.kernelRegularizer,delete t.kernelConstraint,t.depthwiseInitializer=il(this.depthwiseInitializer),t.pointwiseInitializer=il(this.pointwiseInitializer),t.depthwiseRegularizer=lh(this.depthwiseRegularizer),t.pointwiseRegularizer=lh(this.pointwiseRegularizer),t.depthwiseConstraint=Qa(this.depthwiseConstraint),t.pointwiseConstraint=Qa(this.pointwiseConstraint),t}}Th.className="SeparableConv";class Dh extends Th{constructor(t){super(2,t)}}Dh.className="SeparableConv2D",be(Dh);class zh extends Ih{constructor(t){super(1,t),zh.verifyArgs(t),this.inputSpec=[{ndim:3}]}getConfig(){const t=super.getConfig();return delete t.rank,delete t.dataFormat,t}static verifyArgs(t){if("number"!=typeof t.kernelSize&&!ja(t.kernelSize,"number",1,1))throw new Aa(`Conv1D expects config.kernelSize to be number or number[] with length 1, but received ${JSON.stringify(t.kernelSize)}.`)}}zh.className="Conv1D",be(zh);class Ch extends Il{constructor(t){super(t),"number"==typeof t.cropping?this.cropping=[[t.cropping,t.cropping],[t.cropping,t.cropping]]:"number"==typeof t.cropping[0]?this.cropping=[[t.cropping[0],t.cropping[0]],[t.cropping[1],t.cropping[1]]]:this.cropping=t.cropping,this.dataFormat=void 0===t.dataFormat?"channelsLast":t.dataFormat,this.inputSpec=[{ndim:4}]}computeOutputShape(t){return"channelsFirst"===this.dataFormat?[t[0],t[1],t[2]-this.cropping[0][0]-this.cropping[0][1],t[3]-this.cropping[1][0]-this.cropping[1][1]]:[t[0],t[1]-this.cropping[0][0]-this.cropping[0][1],t[2]-this.cropping[1][0]-this.cropping[1][1],t[3]]}call(t,e){return ve(()=>{if(t=dl(t),"channelsLast"===this.dataFormat){const e=Eo(t,this.cropping[0][0],t.shape[1]-this.cropping[0][0]-this.cropping[0][1],2);return Eo(e,this.cropping[1][0],t.shape[2]-this.cropping[1][1]-this.cropping[1][0],3)}{const e=Eo(t,this.cropping[0][0],t.shape[2]-this.cropping[0][0]-this.cropping[0][1],3);return Eo(e,this.cropping[1][0],t.shape[3]-this.cropping[1][1]-this.cropping[1][0],4)}})}getConfig(){const t={cropping:this.cropping,dataFormat:this.dataFormat},e=super.getConfig();return Object.assign(t,e),t}}Ch.className="Cropping2D",be(Ch);class Fh extends Il{constructor(t){var e;super(t),this.DEFAULT_SIZE=[2,2],this.inputSpec=[{ndim:4}],this.size=null==t.size?this.DEFAULT_SIZE:t.size,this.dataFormat=null==t.dataFormat?"channelsLast":t.dataFormat,lo(this.dataFormat),this.interpolation=null==t.interpolation?"nearest":t.interpolation,e=this.interpolation,Wa(so,"InterpolationFormat",e)}computeOutputShape(t){if("channelsFirst"===this.dataFormat){const e=null==t[2]?null:this.size[0]*t[2],n=null==t[3]?null:this.size[1]*t[3];return[t[0],t[1],e,n]}{const e=null==t[1]?null:this.size[0]*t[1],n=null==t[2]?null:this.size[1]*t[2];return[t[0],e,n,t[3]]}}call(t,e){return ve(()=>{let e=dl(t);const n=e.shape;if("channelsFirst"===this.dataFormat){e=fe(e,[0,2,3,1]);const t=this.size[0]*n[2],s=this.size[1]*n[3],r="nearest"===this.interpolation?e.resizeNearestNeighbor([t,s]):e.resizeBilinear([t,s]);return fe(r,[0,3,1,2])}{const t=this.size[0]*n[1],s=this.size[1]*n[2];return"nearest"===this.interpolation?e.resizeNearestNeighbor([t,s]):e.resizeBilinear([t,s])}})}getConfig(){const t={size:this.size,dataFormat:this.dataFormat},e=super.getConfig();return Object.assign(t,e),t}}Fh.className="UpSampling2D",be(Fh);class Rh extends Sh{constructor(t){super(2,t),this.depthwiseKernel=null,this.depthMultiplier=null==t.depthMultiplier?1:t.depthMultiplier,this.depthwiseInitializer=al(t.depthwiseInitializer||this.DEFAULT_KERNEL_INITIALIZER),this.depthwiseConstraint=eo(t.depthwiseConstraint),this.depthwiseRegularizer=hh(t.depthwiseRegularizer)}build(t){if((t=fl(t)).length<4)throw new Aa(`Inputs to DepthwiseConv2D should have rank 4. Received input shape: ${JSON.stringify(t)}.`);const e="channelsFirst"===this.dataFormat?1:3;if(null==t[e]||t[e]<0)throw new Aa(`The channel dimension of the inputs to DepthwiseConv2D should be defined, but is not (${t[e]}).`);const n=t[e],s=[this.kernelSize[0],this.kernelSize[1],n,this.depthMultiplier];this.depthwiseKernel=this.addWeight("depthwise_kernel",s,null,this.depthwiseInitializer,this.depthwiseRegularizer,!0,this.depthwiseConstraint),this.useBias?this.bias=this.addWeight("bias",[n*this.depthMultiplier],null,this.biasInitializer,this.biasRegularizer,!0,this.biasConstraint):this.bias=null,this.built=!0}call(t,e){return ve(()=>{let e=function(t,e,n=[1,1],s="valid",r,i){return ve(()=>{null==r&&(r="channelsLast"),lo(r);let a=vh(t,r);if(4!==t.rank)throw new Aa("Input for depthwiseConv2d is required to be 4-D, but is instead "+t.rank+"-D");if(4!==e.rank)throw new Aa("depthwiseKernel is required to be 4-D, but is instead "+e.rank+"-D");return a=xn(a,e,n,"same"===s?"same":"valid","NHWC",i),"channelsFirst"===r&&(a=fe(a,[0,3,1,2])),a})}(t=dl(t),this.depthwiseKernel.read(),this.strides,this.padding,this.dataFormat,null);return this.useBias&&(e=_o(e,this.bias.read(),this.dataFormat)),null!=this.activation&&(e=this.activation.apply(e)),e})}computeOutputShape(t){t=fl(t);const e="channelsFirst"===this.dataFormat?t[2]:t[1],n="channelsFirst"===this.dataFormat?t[3]:t[2],s="channelsFirst"===this.dataFormat?t[1]*this.depthMultiplier:t[3]*this.depthMultiplier,r=bh(e,this.kernelSize[0],this.padding,this.strides[0]),i=bh(n,this.kernelSize[1],this.padding,this.strides[1]);return"channelsFirst"===this.dataFormat?[t[0],s,r,i]:[t[0],r,i,s]}getConfig(){const t=super.getConfig();return t.depthMultiplier=this.depthMultiplier,t.depthwiseInitializer=il(this.depthwiseInitializer),t.depthwiseRegularizer=lh(this.depthwiseRegularizer),t.depthwiseConstraint=Qa(this.depthwiseRegularizer),t}}function Mh(t,e,n,s){if(Array.isArray(t)){if(null!=e||null!=n)throw new Aa("When inputs is an array, neither initialState or constants should be provided");null!=s&&(n=t.slice(t.length-s,t.length),t=t.slice(0,t.length-s)),t.length>1&&(e=t.slice(1,t.length)),t=t[0]}function r(t){return null==t||Array.isArray(t)?t:[t]}return{inputs:t,initialState:e=r(e),constants:n=r(n)}}function Lh(t,e,n,s=!1,r,i,a=!1,o=!1){return ve(()=>{const l=e.shape.length;if(l<3)throw new Aa(`Input should be at least 3D, but is ${l}D.`);const u=[1,0].concat(xo(2,l));if(e=fe(e,u),null!=i)throw new Ea("The rnn() functoin of the deeplearn.js backend does not support constants yet.");a&&console.warn("Backend rnn(): the unroll = true option is not applicable to the imperative deeplearn.js backend."),null!=r&&((r=r.asType("bool").asType("float32")).rank===l-1&&(r=Mn(r,-1)),r=fe(r,u)),s&&(e=Ys(e,0),null!=r&&(r=Ys(r,0)));const h=[];let c,p=n;const d=e.shape[0],f=zr(e);let m,g;null!=r&&(m=zr(r));for(let e=0;e<d;++e){const n=f[e],s=ve(()=>t(n,p));if(null==r)c=s[0],p=s[1];else{const t=ve(()=>{const t=m[e],n=Es(t).sub(t);return{output:s[0].mul(t).add(p[0].mul(n)),newStates:p.map((e,r)=>s[1][r].mul(t).add(e.mul(n)))}});c=t.output,p=t.newStates}o&&h.push(c)}if(o){g=vr(h,1)}return[c,g,p]})}Rh.className="DepthwiseConv2D",be(Rh);class _h extends Il{constructor(t){let e;if(super(t),null==t.cell)throw new Aa("cell property is missing for the constructor of RNN.");if(e=Array.isArray(t.cell)?new qh({cells:t.cell}):t.cell,null==e.stateSize)throw new Aa("The RNN cell should have an attribute `stateSize` (tuple of integers, one integer per RNN state).");this.cell=e,this.returnSequences=null!=t.returnSequences&&t.returnSequences,this.returnState=null!=t.returnState&&t.returnState,this.goBackwards=null!=t.goBackwards&&t.goBackwards,this._stateful=null!=t.stateful&&t.stateful,this.unroll=null!=t.unroll&&t.unroll,this.supportsMasking=!0,this.inputSpec=[new wl({ndim:3})],this.stateSpec=null,this.states_=null,this.numConstants=null,this.keptStates=[]}getStates(){if(null==this.states_){return xo(0,Array.isArray(this.cell.stateSize)?this.cell.stateSize.length:1).map(t=>null)}return this.states_}setStates(t){this.states_=t}computeOutputShape(t){cl(t)&&(t=t[0]),t=t;let e=this.cell.stateSize;Array.isArray(e)||(e=[e]);const n=e[0];let s;if(s=this.returnSequences?[t[0],t[1],n]:[t[0],n],this.returnState){const n=[];for(const s of e)n.push([t[0],s]);return[s].concat(n)}return s}computeMask(t,e){return ve(()=>{Array.isArray(e)&&(e=e[0]);const t=this.returnSequences?e:null;if(this.returnState){const e=this.states.map(t=>null);return[t].concat(e)}return t})}get states(){if(null==this.states_){const t=Array.isArray(this.cell.stateSize)?this.cell.stateSize.length:1,e=[];for(let n=0;n<t;++n)e.push(null);return e}return this.states_}set states(t){this.states_=t}build(t){if(null!=this.numConstants)throw new Ea("Constants support is not implemented in RNN yet.");cl(t)&&(t=t[0]),t=t;const e=this.stateful?t[0]:null,n=t.slice(2);this.inputSpec[0]=new wl({shape:[e,null,...n]});const s=[t[0]].concat(t.slice(2));let r;if(this.cell.build(s),r=Array.isArray(this.cell.stateSize)?this.cell.stateSize:[this.cell.stateSize],null!=this.stateSpec){if(!c(this.stateSpec.map(t=>t.shape[t.shape.length-1]),r))throw new Aa(`An initialState was passed that is not compatible with cell.stateSize. Received stateSpec=${this.stateSpec}; However cell.stateSize is `+this.cell.stateSize)}else this.stateSpec=r.map(t=>new wl({shape:[null,t]}));this.stateful&&this.resetStates()}resetStates(t,e=!1){ve(()=>{if(!this.stateful)throw new Ia("Cannot call resetStates() on an RNN Layer that is not stateful.");const n=this.inputSpec[0].shape[0];if(null==n)throw new Aa("If an RNN is stateful, it needs to know its batch size. Specify the batch size of your input tensors: \n- If using a Sequential model, specify the batch size by passing a `batchInputShape` option to your first layer.\n- If using the functional API, specify the batch size by passing a `batchShape` option to your Input layer.");if(null==this.states_)Array.isArray(this.cell.stateSize)?this.states_=this.cell.stateSize.map(t=>Ns([n,t])):this.states_=[Ns([n,this.cell.stateSize])];else if(null==t)ke(this.states_),null!=this.keptStates&&(ke(this.keptStates),this.keptStates=[]),Array.isArray(this.cell.stateSize)?this.states_=this.cell.stateSize.map(t=>Ns([n,t])):this.states_[0]=Ns([n,this.cell.stateSize]);else{if(Array.isArray(t)||(t=[t]),t.length!==this.states_.length)throw new Aa(`Layer ${this.name} expects ${this.states_.length} state(s), but it received ${t.length} state value(s). Input received: `+t);!0===e?this.keptStates.push(this.states_.slice()):ke(this.states_);for(let e=0;e<this.states_.length;++e){const s=t[e],r=Array.isArray(this.cell.stateSize)?this.cell.stateSize[e]:this.cell.stateSize,i=[n,r];if(!c(s.shape,i))throw new Aa(`State ${e} is incompatible with layer ${this.name}: expected shape=${i}, received shape=${s.shape}`);this.states_[e]=s}}this.states_=this.states_.map(t=>xe(t.clone()))})}apply(t,e){let n=null==e?null:e.initialState,s=null==e?null:e.constants;null==e&&(e={});const r=Mh(t,n,s,this.numConstants);t=r.inputs,n=r.initialState,s=r.constants;let i=[],a=[];if(null!=n){e.initialState=n,i=i.concat(n),this.stateSpec=[];for(const t of n)this.stateSpec.push(new wl({shape:t.shape}));a=a.concat(this.stateSpec)}null!=s&&(e.constants=s,i=i.concat(s),this.numConstants=s.length);if(i[0]instanceof vl){const n=[t].concat(i),s=this.inputSpec.concat(a),r=this.inputSpec;this.inputSpec=s;const o=super.apply(n,e);return this.inputSpec=r,o}return super.apply(t,e)}call(t,e){return ve(()=>{const n=null==e?null:e.mask,s=null==e?null:e.training;let r=null==e?null:e.initialState;t=dl(t),null==r&&(r=this.stateful?this.states_:this.getInitialState(t));const i=Array.isArray(this.cell.stateSize)?this.cell.stateSize.length:1;if(r.length!==i)throw new Aa(`RNN Layer has ${i} state(s) but was passed `+r.length+" initial state(s).");this.unroll&&console.warn("Ignoring unroll = true for RNN layer, due to imperative backend.");const a={training:s},o=Lh((t,e)=>{const n=this.cell.call([t].concat(e),a);return[n[0],n.slice(1)]},t,r,this.goBackwards,n,null,this.unroll,this.returnSequences),l=o[0],u=o[1],h=o[2];this.stateful&&this.resetStates(h,s);const c=this.returnSequences?u:l;return this.returnState?[c].concat(h):c})}getInitialState(t){return ve(()=>{let e=Ns(t.shape);return e=is(e,[1,2]),e=Io(e),Array.isArray(this.cell.stateSize)?this.cell.stateSize.map(t=>t>1?zo(e,[1,t]):e):this.cell.stateSize>1?[zo(e,[1,this.cell.stateSize])]:[e]})}get trainableWeights(){return this.trainable?this.cell.trainableWeights:[]}get nonTrainableWeights(){return this.trainable?this.cell.nonTrainableWeights:this.cell.weights}setFastWeightInitDuringBuild(t){super.setFastWeightInitDuringBuild(t),null!=this.cell&&this.cell.setFastWeightInitDuringBuild(t)}getConfig(){const t=super.getConfig(),e={returnSequences:this.returnSequences,returnState:this.returnState,goBackwards:this.goBackwards,stateful:this.stateful,unroll:this.unroll};null!=this.numConstants&&(e.numConstants=this.numConstants);const n=this.cell.getConfig();return this.getClassName()===_h.className&&(e.cell={className:this.cell.getClassName(),config:n}),Object.assign({},n,t,e)}static fromConfig(t,e,n={}){const s=$l(e.cell,n);return new t(Object.assign(e,{cell:s}))}}_h.className="RNN",be(_h);class $h extends Il{}class Oh extends $h{constructor(t){super(t),this.DEFAULT_ACTIVATION="tanh",this.DEFAULT_KERNEL_INITIALIZER="glorotNormal",this.DEFAULT_RECURRENT_INITIALIZER="orthogonal",this.DEFAULT_BIAS_INITIALIZER="zeros",this.units=t.units,qa(this.units,"units"),this.activation=rh(null==t.activation?this.DEFAULT_ACTIVATION:t.activation),this.useBias=null==t.useBias||t.useBias,this.kernelInitializer=al(t.kernelInitializer||this.DEFAULT_KERNEL_INITIALIZER),this.recurrentInitializer=al(t.recurrentInitializer||this.DEFAULT_RECURRENT_INITIALIZER),this.biasInitializer=al(t.biasInitializer||this.DEFAULT_BIAS_INITIALIZER),this.kernelRegularizer=hh(t.kernelRegularizer),this.recurrentRegularizer=hh(t.recurrentRegularizer),this.biasRegularizer=hh(t.biasRegularizer),this.kernelConstraint=eo(t.kernelConstraint),this.recurrentConstraint=eo(t.recurrentConstraint),this.biasConstraint=eo(t.biasConstraint),this.dropout=vo([1,ko([0,null==t.dropout?0:t.dropout])]),this.recurrentDropout=vo([1,ko([0,null==t.recurrentDropout?0:t.recurrentDropout])]),this.stateSize=this.units,this.dropoutMask=null,this.recurrentDropoutMask=null}build(t){t=fl(t),this.kernel=this.addWeight("kernel",[t[t.length-1],this.units],null,this.kernelInitializer,this.kernelRegularizer,!0,this.kernelConstraint),this.recurrentKernel=this.addWeight("recurrent_kernel",[this.units,this.units],null,this.recurrentInitializer,this.recurrentRegularizer,!0,this.recurrentConstraint),this.useBias?this.bias=this.addWeight("bias",[this.units],null,this.biasInitializer,this.biasRegularizer,!0,this.biasConstraint):this.bias=null,this.built=!0}call(t,e){return ve(()=>{if(2!==(t=t).length)throw new Aa(`SimpleRNNCell expects 2 input Tensors, got ${t.length}.`);let n=t[1];t=t[0];const s=null!=e.training&&e.training;let r;0<this.dropout&&this.dropout<1&&null==this.dropoutMask&&(this.dropoutMask=Kh({ones:()=>Es(t),rate:this.dropout,training:s})),0<this.recurrentDropout&&this.recurrentDropout<1&&null==this.recurrentDropoutMask&&(this.recurrentDropoutMask=Kh({ones:()=>Es(n),rate:this.recurrentDropout,training:s}));const i=this.dropoutMask,a=this.recurrentDropoutMask;r=Fo(null!=i?Ee(t,i):t,this.kernel.read()),null!=this.bias&&(r=_o(r,this.bias.read())),null!=a&&(n=Ee(n,a));let o=Ie(r,Fo(n,this.recurrentKernel.read()));return null!=this.activation&&(o=this.activation.apply(o)),[o,o]})}getConfig(){const t=super.getConfig(),e={units:this.units,activation:nh(this.activation),useBias:this.useBias,kernelInitializer:il(this.kernelInitializer),recurrentInitializer:il(this.recurrentInitializer),biasInitializer:il(this.biasInitializer),kernelRegularizer:lh(this.kernelRegularizer),recurrentRegularizer:lh(this.recurrentRegularizer),biasRegularizer:lh(this.biasRegularizer),activityRegularizer:lh(this.activityRegularizer),kernelConstraint:Qa(this.kernelConstraint),recurrentConstraint:Qa(this.recurrentConstraint),biasConstraint:Qa(this.biasConstraint),dropout:this.dropout,recurrentDropout:this.recurrentDropout};return Object.assign({},t,e)}}Oh.className="SimpleRNNCell",be(Oh);class Bh extends _h{constructor(t){t.cell=new Oh(t),super(t)}call(t,e){return ve(()=>{null!=this.cell.dropoutMask&&(ke(this.cell.dropoutMask),this.cell.dropoutMask=null),null!=this.cell.recurrentDropoutMask&&(ke(this.cell.recurrentDropoutMask),this.cell.recurrentDropoutMask=null);const n=null==e?null:e.mask,s=null==e?null:e.training,r=null==e?null:e.initialState;return super.call(t,{mask:n,training:s,initialState:r})})}static fromConfig(t,e){return new t(e)}}Bh.className="SimpleRNN",be(Bh);class Ph extends $h{constructor(t){if(super(t),this.DEFAULT_ACTIVATION="tanh",this.DEFAULT_RECURRENT_ACTIVATION="hardSigmoid",this.DEFAULT_KERNEL_INITIALIZER="glorotNormal",this.DEFAULT_RECURRENT_INITIALIZER="orthogonal",this.DEFAULT_BIAS_INITIALIZER="zeros",t.resetAfter)throw new Aa("GRUCell does not support reset_after parameter set to true.");this.units=t.units,qa(this.units,"units"),this.activation=rh(void 0===t.activation?this.DEFAULT_ACTIVATION:t.activation),this.recurrentActivation=rh(void 0===t.recurrentActivation?this.DEFAULT_RECURRENT_ACTIVATION:t.recurrentActivation),this.useBias=null==t.useBias||t.useBias,this.kernelInitializer=al(t.kernelInitializer||this.DEFAULT_KERNEL_INITIALIZER),this.recurrentInitializer=al(t.recurrentInitializer||this.DEFAULT_RECURRENT_INITIALIZER),this.biasInitializer=al(t.biasInitializer||this.DEFAULT_BIAS_INITIALIZER),this.kernelRegularizer=hh(t.kernelRegularizer),this.recurrentRegularizer=hh(t.recurrentRegularizer),this.biasRegularizer=hh(t.biasRegularizer),this.kernelConstraint=eo(t.kernelConstraint),this.recurrentConstraint=eo(t.recurrentConstraint),this.biasConstraint=eo(t.biasConstraint),this.dropout=vo([1,ko([0,null==t.dropout?0:t.dropout])]),this.recurrentDropout=vo([1,ko([0,null==t.recurrentDropout?0:t.recurrentDropout])]),this.implementation=t.implementation,this.stateSize=this.units,this.dropoutMask=null,this.recurrentDropoutMask=null}build(t){const e=(t=fl(t))[t.length-1];this.kernel=this.addWeight("kernel",[e,3*this.units],null,this.kernelInitializer,this.kernelRegularizer,!0,this.kernelConstraint),this.recurrentKernel=this.addWeight("recurrent_kernel",[this.units,3*this.units],null,this.recurrentInitializer,this.recurrentRegularizer,!0,this.recurrentConstraint),this.useBias?this.bias=this.addWeight("bias",[3*this.units],null,this.biasInitializer,this.biasRegularizer,!0,this.biasConstraint):this.bias=null,this.built=!0}call(t,e){return ve(()=>{if(2!==(t=t).length)throw new Aa("GRUCell expects 2 input Tensors (inputs, h, c), got "+t.length+".");const n=null!=e.training&&e.training;let s=t[1];t=t[0],0<this.dropout&&this.dropout<1&&null==this.dropoutMask&&(this.dropoutMask=Kh({ones:()=>Es(t),rate:this.dropout,training:n,count:3})),0<this.recurrentDropout&&this.recurrentDropout<1&&null==this.recurrentDropoutMask&&(this.recurrentDropoutMask=Kh({ones:()=>Es(s),rate:this.recurrentDropout,training:n,count:3}));const r=this.dropoutMask,i=this.recurrentDropoutMask;let a,o,l;0<this.dropout&&this.dropout<1&&(t=Ee(t,r[0]));let u=Fo(t,this.kernel.read());this.useBias&&(u=_o(u,this.bias.read())),0<this.recurrentDropout&&this.recurrentDropout<1&&(s=Ee(s,i[0]));const h=this.recurrentKernel.read(),[c,p]=mr(h,[2*this.units,this.units],h.rank-1),d=Fo(s,c),[f,m,g]=mr(u,3,u.rank-1),[y,b]=mr(d,2,d.rank-1);a=this.recurrentActivation.apply(Ie(f,y)),o=this.recurrentActivation.apply(Ie(m,b));const w=Fo(Ee(o,s),p);l=this.activation.apply(Ie(g,w));const v=Ie(Ee(a,s),Ee(Ie(1,ts(a)),l));return[v,v]})}getConfig(){const t=super.getConfig(),e={units:this.units,activation:nh(this.activation),recurrentActivation:nh(this.recurrentActivation),useBias:this.useBias,kernelInitializer:il(this.kernelInitializer),recurrentInitializer:il(this.recurrentInitializer),biasInitializer:il(this.biasInitializer),kernelRegularizer:lh(this.kernelRegularizer),recurrentRegularizer:lh(this.recurrentRegularizer),biasRegularizer:lh(this.biasRegularizer),activityRegularizer:lh(this.activityRegularizer),kernelConstraint:Qa(this.kernelConstraint),recurrentConstraint:Qa(this.recurrentConstraint),biasConstraint:Qa(this.biasConstraint),dropout:this.dropout,recurrentDropout:this.recurrentDropout,implementation:this.implementation,resetAfter:!1};return Object.assign({},t,e)}}Ph.className="GRUCell",be(Ph);class Uh extends _h{constructor(t){0===t.implementation&&console.warn("`implementation=0` has been deprecated, and now defaults to `implementation=1`. Please update your layer call."),t.cell=new Ph(t),super(t)}call(t,e){return ve(()=>{null!=this.cell.dropoutMask&&(ke(this.cell.dropoutMask),this.cell.dropoutMask=null),null!=this.cell.recurrentDropoutMask&&(ke(this.cell.recurrentDropoutMask),this.cell.recurrentDropoutMask=null);const n=null==e?null:e.mask,s=null==e?null:e.training,r=null==e?null:e.initialState;return super.call(t,{mask:n,training:s,initialState:r})})}static fromConfig(t,e){return 0===e.implmentation&&(e.implementation=1),new t(e)}}Uh.className="GRU",be(Uh);class Wh extends $h{constructor(t){super(t),this.DEFAULT_ACTIVATION="tanh",this.DEFAULT_RECURRENT_ACTIVATION="hardSigmoid",this.DEFAULT_KERNEL_INITIALIZER="glorotNormal",this.DEFAULT_RECURRENT_INITIALIZER="orthogonal",this.DEFAULT_BIAS_INITIALIZER="zeros",this.units=t.units,qa(this.units,"units"),this.activation=rh(void 0===t.activation?this.DEFAULT_ACTIVATION:t.activation),this.recurrentActivation=rh(void 0===t.recurrentActivation?this.DEFAULT_RECURRENT_ACTIVATION:t.recurrentActivation),this.useBias=null==t.useBias||t.useBias,this.kernelInitializer=al(t.kernelInitializer||this.DEFAULT_KERNEL_INITIALIZER),this.recurrentInitializer=al(t.recurrentInitializer||this.DEFAULT_RECURRENT_INITIALIZER),this.biasInitializer=al(t.biasInitializer||this.DEFAULT_BIAS_INITIALIZER),this.unitForgetBias=t.unitForgetBias,this.kernelRegularizer=hh(t.kernelRegularizer),this.recurrentRegularizer=hh(t.recurrentRegularizer),this.biasRegularizer=hh(t.biasRegularizer),this.kernelConstraint=eo(t.kernelConstraint),this.recurrentConstraint=eo(t.recurrentConstraint),this.biasConstraint=eo(t.biasConstraint),this.dropout=vo([1,ko([0,null==t.dropout?0:t.dropout])]),this.recurrentDropout=vo([1,ko([0,null==t.recurrentDropout?0:t.recurrentDropout])]),this.implementation=t.implementation,this.stateSize=[this.units,this.units],this.dropoutMask=null,this.recurrentDropoutMask=null}build(t){var e;const n=(t=fl(t))[t.length-1];let s;if(this.kernel=this.addWeight("kernel",[n,4*this.units],null,this.kernelInitializer,this.kernelRegularizer,!0,this.kernelConstraint),this.recurrentKernel=this.addWeight("recurrent_kernel",[this.units,4*this.units],null,this.recurrentInitializer,this.recurrentRegularizer,!0,this.recurrentConstraint),this.useBias){if(this.unitForgetBias){const t=this.biasInitializer,n=this.units;s=new((e=class extends Uo{apply(e,s){const r=t.apply([n]),i=(new jo).apply([n]),a=t.apply([2*n]);return Do(Do(r,i),a)}}).className="CustomInit",e)}else s=this.biasInitializer;this.bias=this.addWeight("bias",[4*this.units],null,s,this.biasRegularizer,!0,this.biasConstraint)}else this.bias=null;this.built=!0}call(t,e){return ve(()=>{const n=null!=e.training&&e.training;if(3!==(t=t).length)throw new Aa("LSTMCell expects 3 input Tensors (inputs, h, c), got "+t.length+".");let s=t[1];const r=t[2];t=t[0],0<this.dropout&&this.dropout<1&&null==this.dropoutMask&&(this.dropoutMask=Kh({ones:()=>Es(t),rate:this.dropout,training:n,count:4})),0<this.recurrentDropout&&this.recurrentDropout<1&&null==this.recurrentDropoutMask&&(this.recurrentDropoutMask=Kh({ones:()=>Es(s),rate:this.recurrentDropout,training:n,count:4}));const i=this.dropoutMask,a=this.recurrentDropoutMask;let o,l,u,h;0<this.dropout&&this.dropout<1&&(t=Ee(t,i[0]));let c=Fo(t,this.kernel.read());0<this.recurrentDropout&&this.recurrentDropout<1&&(s=Ee(s,a[0])),c=Ie(c,Fo(s,this.recurrentKernel.read())),this.useBias&&(c=_o(c,this.bias.read()));const[p,d,f,m]=mr(c,4,c.rank-1);o=this.recurrentActivation.apply(p),l=this.recurrentActivation.apply(d),u=Ie(Ee(l,r),Ee(o,this.activation.apply(f))),h=this.recurrentActivation.apply(m);const g=Ee(h,this.activation.apply(u));return[g,g,u]})}getConfig(){const t=super.getConfig(),e={units:this.units,activation:nh(this.activation),recurrentActivation:nh(this.recurrentActivation),useBias:this.useBias,kernelInitializer:il(this.kernelInitializer),recurrentInitializer:il(this.recurrentInitializer),biasInitializer:il(this.biasInitializer),unitForgetBias:this.unitForgetBias,kernelRegularizer:lh(this.kernelRegularizer),recurrentRegularizer:lh(this.recurrentRegularizer),biasRegularizer:lh(this.biasRegularizer),activityRegularizer:lh(this.activityRegularizer),kernelConstraint:Qa(this.kernelConstraint),recurrentConstraint:Qa(this.recurrentConstraint),biasConstraint:Qa(this.biasConstraint),dropout:this.dropout,recurrentDropout:this.recurrentDropout,implementation:this.implementation};return Object.assign({},t,e)}}Wh.className="LSTMCell",be(Wh);class jh extends _h{constructor(t){0===t.implementation&&console.warn("`implementation=0` has been deprecated, and now defaults to `implementation=1`. Please update your layer call."),t.cell=new Wh(t),super(t)}call(t,e){return ve(()=>{null!=this.cell.dropoutMask&&(ke(this.cell.dropoutMask),this.cell.dropoutMask=null),null!=this.cell.recurrentDropoutMask&&(ke(this.cell.recurrentDropoutMask),this.cell.recurrentDropoutMask=null);const n=null==e?null:e.mask,s=null==e?null:e.training,r=null==e?null:e.initialState;return super.call(t,{mask:n,training:s,initialState:r})})}static fromConfig(t,e){return 0===e.implmentation&&(e.implementation=1),new t(e)}}jh.className="LSTM",be(jh);class qh extends $h{constructor(t){super(t),this.cells=t.cells}get stateSize(){const t=[];for(const e of this.cells.slice().reverse())Array.isArray(e.stateSize)?t.push(...e.stateSize):t.push(e.stateSize);return t}call(t,e){return ve(()=>{let n=(t=t).slice(1);const s=[];for(const t of this.cells.slice().reverse())Array.isArray(t.stateSize)?s.push(n.splice(0,t.stateSize.length)):s.push(n.splice(0,1));s.reverse();const r=[];let i;for(let a=0;a<this.cells.length;++a){const o=this.cells[a];n=s[a],i=0===a?[t[0]].concat(n):[i[0]].concat(n),i=o.call(i,e),r.push(i.slice(1))}n=[];for(const t of r.slice().reverse())n.push(...t);return[i[0]].concat(n)})}build(t){let e;cl(t)&&(t=t[0]),t=t,this.cells.forEach((n,s)=>{po("RNNCell_"+s,()=>{n.build(t),e=Array.isArray(n.stateSize)?n.stateSize[0]:n.stateSize,t=[t[0],e]})}),this.built=!0}getConfig(){const t=super.getConfig(),e={cells:this.cells.map(t=>({className:t.getClassName(),config:t.getConfig()}))};return Object.assign({},t,e)}static fromConfig(t,e,n={}){const s=[];for(const t of e.cells)s.push($l(t,n));return new t({cells:s})}get trainableWeights(){if(!this.trainable)return[];const t=[];for(const e of this.cells)t.push(...e.trainableWeights);return t}get nonTrainableWeights(){const t=[];for(const e of this.cells)t.push(...e.nonTrainableWeights);if(!this.trainable){const e=[];for(const t of this.cells)e.push(...t.trainableWeights);return e.concat(t)}return t}getWeights(){const t=[];for(const e of this.cells)t.push(...e.weights);return yl(t)}setWeights(t){const e=[];for(const n of this.cells){const s=n.weights.length,r=t.splice(s);for(let t=0;t<n.weights.length;++t)e.push([n.weights[t],r[t]])}bl(e)}}function Kh(t){const{ones:e,rate:n,training:s=!1,count:r=1}=t,i=()=>$o(e(),n),a=()=>Oo(i,e,s);if(!r||r<=1)return xe(a().clone());return Array(r).fill(void 0).map(a).map(t=>xe(t.clone()))}qh.className="StackedRNNCells",be(qh);var Vh=function(t,e){var n={};for(var s in t)Object.prototype.hasOwnProperty.call(t,s)&&e.indexOf(s)<0&&(n[s]=t[s]);if(null!=t&&"function"==typeof Object.getOwnPropertySymbols){var r=0;for(s=Object.getOwnPropertySymbols(t);r<s.length;r++)e.indexOf(s[r])<0&&Object.prototype.propertyIsEnumerable.call(t,s[r])&&(n[s[r]]=t[s[r]])}return n};class Hh extends _h{constructor(t){if(t.unroll)throw new Ea("Unrolling is not possible with convolutional RNNs.");if(Array.isArray(t.cell))throw new Ea("It is not possible at the moment to stack convolutional cells.");super(t),this.inputSpec=[new wl({ndim:5})]}call(t,e){return ve(()=>{if(null!=this.cell.dropoutMask&&(ke(this.cell.dropoutMask),this.cell.dropoutMask=null),null!=this.cell.recurrentDropoutMask&&(ke(this.cell.recurrentDropoutMask),this.cell.recurrentDropoutMask=null),e&&e.constants)throw new Aa("ConvRNN2D cell does not support constants");const n=null==e?null:e.mask,s=null==e?null:e.training,r=null==e?null:e.initialState;return super.call(t,{mask:n,training:s,initialState:r})})}computeOutputShape(t){let e=this.computeSingleOutputShape(t);return this.returnSequences||(e=[e[0],...e.slice(2)]),this.returnState&&(e=[e,...Array(2).fill([t[0],...e.slice(-3)])]),e}getInitialState(t){return ve(()=>{const{stateSize:e}=this.cell,n=t.shape,s=this.computeSingleOutputShape(n),r=Ns([s[0],...s.slice(2)]);return Array.isArray(e)?Array(e.length).fill(r):[r]})}resetStates(t,e=!1){ve(()=>{if(!this.stateful)throw new Ia("Cannot call resetStates() on an RNN Layer that is not stateful.");const n=this.inputSpec[0].shape,s=this.computeSingleOutputShape(n),r=[s[0],...s.slice(2)];if(null==n[0])throw new Aa("If an RNN is stateful, it needs to know its batch size. Specify the batch size of your input tensors: \n- If using a Sequential model, specify the batch size by passing a `batchInputShape` option to your first layer.\n- If using the functional API, specify the batch size by passing a `batchShape` option to your Input layer.");if(null==this.getStates())Array.isArray(this.cell.stateSize)?this.states_=this.cell.stateSize.map(()=>Ns(r)):this.states_=[Ns(r)];else if(null==t)ke(this.states_),null!=this.keptStates&&(ke(this.keptStates),this.keptStates=[]),Array.isArray(this.cell.stateSize)?this.states_=this.cell.stateSize.map(()=>Ns(r)):this.states_[0]=Ns(r);else{if(Array.isArray(t)||(t=[t]),t.length!==this.states_.length)throw new Aa(`Layer ${this.name} expects ${this.states_.length} state(s), but it received ${t.length} state value(s). Input received: `+t);e?this.keptStates.push(this.states_.slice()):ke(this.states_);for(let e=0;e<this.states_.length;++e){const n=t[e],s=r;if(!c(n.shape,s))throw new Aa(`State ${e} is incompatible with layer ${this.name}: expected shape=${s}, received shape=${n.shape}`);this.states_[e]=n}}this.states_=this.states_.map(t=>xe(t.clone()))})}computeSingleOutputShape(t){const{dataFormat:e,filters:n,kernelSize:s,padding:r,strides:i,dilationRate:a}=this.cell,o="channelsFirst"===e,l=t[o?3:2],u=t[o?4:3],h=bh(l,s[0],r,i[0],a[0]),c=bh(u,s[1],r,i[1],a[1]);return[...t.slice(0,2),...o?[n,h,c]:[h,c,n]]}}Hh.className="ConvRNN2D";class Gh extends Wh{constructor(t){const{filters:e,kernelSize:n,strides:s,padding:r,dataFormat:i,dilationRate:a}=t;super(Object.assign({},t,{units:e})),this.filters=e,qa(this.filters,"filters"),this.kernelSize=yh(n,2,"kernelSize"),this.kernelSize.forEach(t=>qa(t,"kernelSize")),this.strides=yh(s||1,2,"strides"),this.strides.forEach(t=>qa(t,"strides")),this.padding=r||"valid",uo(this.padding),this.dataFormat=i||"channelsLast",lo(this.dataFormat),this.dilationRate=yh(a||1,2,"dilationRate"),this.dilationRate.forEach(t=>qa(t,"dilationRate"))}build(t){var e;t=fl(t);const n="channelsFirst"===this.dataFormat?1:t.length-1;if(null==t[n])throw new Aa("The channel dimension of the input should be defined. Found "+t[n]);const s=t[n],r=this.kernelSize.concat([s,4*this.filters]);this.kernel=this.addWeight("kernel",r,null,this.kernelInitializer,this.kernelRegularizer,!0,this.kernelConstraint);const i=this.kernelSize.concat([this.filters,4*this.filters]);if(this.recurrentKernel=this.addWeight("recurrent_kernel",i,null,this.recurrentInitializer,this.recurrentRegularizer,!0,this.recurrentConstraint),this.useBias){let t;if(this.unitForgetBias){const n=this.biasInitializer,s=this.filters;t=new((e=class extends Uo{apply(t,e){return To([n.apply([s]),As([s]),n.apply([2*s])])}}).className="CustomInit",e)}else t=this.biasInitializer;this.bias=this.addWeight("bias",[4*this.filters],null,t,this.biasRegularizer,!0,this.biasConstraint)}this.built=!0}call(t,e){return ve(()=>{if(3!==t.length)throw new Aa("ConvLSTM2DCell expects 3 input Tensors (inputs, h, c), got "+t.length+".");const n=e.training||!1,s=t[0],r=t[1],i=t[2];0<this.dropout&&this.dropout<1&&null==this.dropoutMask&&(this.dropoutMask=Kh({ones:()=>Es(s),rate:this.dropout,training:n,count:4}));const a=this.dropoutMask,o=(t,e,n)=>e&&e[n]?Ee(e[n],t):t;let l=o(s,a,0),u=o(s,a,1),h=o(s,a,2),c=o(s,a,3);0<this.recurrentDropout&&this.recurrentDropout<1&&null==this.recurrentDropoutMask&&(this.recurrentDropoutMask=Kh({ones:()=>Es(r),rate:this.recurrentDropout,training:n,count:4}));const p=this.recurrentDropoutMask;let d=o(r,p,0),f=o(r,p,1),m=o(r,p,2),g=o(r,p,3);const[y,b,w,v]=mr(this.kernel.read(),4,3),[k,x,S,I]=this.useBias?mr(this.bias.read(),4):[null,null,null,null];l=this.inputConv(l,y,k,this.padding),u=this.inputConv(u,b,x,this.padding),h=this.inputConv(h,w,S,this.padding),c=this.inputConv(c,v,I,this.padding);const[N,A,E,T]=mr(this.recurrentKernel.read(),4,3);d=this.recurrentConv(d,N),f=this.recurrentConv(f,A),m=this.recurrentConv(m,E),g=this.recurrentConv(g,T);const D=this.recurrentActivation.apply(Ie(l,d)),z=this.recurrentActivation.apply(Ie(u,f)),C=Ie(Ee(z,i),Ee(D,this.activation.apply(Ie(h,m)))),F=Ee(this.recurrentActivation.apply(Ie(c,g)),this.activation.apply(C));return[F,F,C]})}getConfig(){const t=super.getConfig(),e=Vh(t,["units"]),n={filters:this.filters,kernelSize:this.kernelSize,padding:this.padding,dataFormat:this.dataFormat,dilationRate:this.dilationRate,strides:this.strides};return Object.assign({},e,n)}inputConv(t,e,n,s){const r=pn(t,e,this.strides,s||"valid","channelsFirst"===this.dataFormat?"NCHW":"NHWC",this.dilationRate);return n?_o(r,n,this.dataFormat):r}recurrentConv(t,e){return pn(t,e,1,"same","channelsFirst"===this.dataFormat?"NCHW":"NHWC")}}Gh.className="ConvLSTM2DCell",be(Gh);class Jh extends Hh{constructor(t){const e=new Gh(t);super(Object.assign({},t,{cell:e}))}static fromConfig(t,e){return new t(e)}}Jh.className="ConvLSTM2D",be(Jh);class Zh extends Il{constructor(t){super(t),this.rate=Math.max(Math.min(t.rate,1),0),this.noiseShape=t.noiseShape,this.seed=t.seed,this.supportsMasking=!0}getNoiseShape(t){if(null==this.noiseShape)return this.noiseShape;const e=t.shape,n=[];for(let t=0;t<this.noiseShape.length;++t)n.push(null==this.noiseShape[t]?e[t]:this.noiseShape[t]);return n}call(t,e){return ve(()=>{this.invokeCallHook(t,e);const n=dl(t);if(0<this.rate&&this.rate<1){const t=null!=e.training&&e.training,s=this.getNoiseShape(n);return Oo(()=>$o(n,this.rate,s,this.seed),()=>n,t)}return t})}getConfig(){const t={rate:this.rate,noiseShape:this.noiseShape,seed:this.seed},e=super.getConfig();return Object.assign(t,e),t}dispose(){return super.dispose()}}Zh.className="Dropout",be(Zh);class Xh extends Zh{constructor(t){super(t),this.inputSpec=[{ndim:3}]}getNoiseShape(t){const e=t.shape;return[e[0],1,e[2]]}}Xh.className="SpatialDropout1D",be(Xh);class Yh extends Il{constructor(t){if(super(t),this.activation=null,this.useBias=!0,this.kernel=null,this.bias=null,this.DEFAULT_KERNEL_INITIALIZER="glorotNormal",this.DEFAULT_BIAS_INITIALIZER="zeros",null==t.batchInputShape&&null==t.inputShape&&null!=t.inputDim){let e=null;null!=t.batchSize&&(e=t.batchSize),this.batchInputShape=[e,t.inputDim]}this.units=t.units,qa(this.units,"units"),this.activation=rh(t.activation),null!=t.useBias&&(this.useBias=t.useBias),this.kernelInitializer=al(t.kernelInitializer||this.DEFAULT_KERNEL_INITIALIZER),this.biasInitializer=al(t.biasInitializer||this.DEFAULT_BIAS_INITIALIZER),this.kernelConstraint=eo(t.kernelConstraint),this.biasConstraint=eo(t.biasConstraint),this.kernelRegularizer=hh(t.kernelRegularizer),this.biasRegularizer=hh(t.biasRegularizer),this.activityRegularizer=hh(t.activityRegularizer),this.supportsMasking=!0,this.inputSpec=[{minNDim:2}]}build(t){const e=(t=fl(t))[t.length-1];null==this.kernel&&(this.kernel=this.addWeight("kernel",[e,this.units],null,this.kernelInitializer,this.kernelRegularizer,!0,this.kernelConstraint),this.useBias&&(this.bias=this.addWeight("bias",[this.units],null,this.biasInitializer,this.biasRegularizer,!0,this.biasConstraint))),this.inputSpec=[{minNDim:2,axes:{[-1]:e}}],this.built=!0}computeOutputShape(t){const e=(t=fl(t)).slice();return e[e.length-1]=this.units,e}call(t,e){return ve(()=>{this.invokeCallHook(t,e);const n=dl(t),s=Ka(this.activation.getClassName());let r;return null!=s?r=Fo(n,this.kernel.read(),s,this.bias?this.bias.read():null):(r=Fo(n,this.kernel.read()),null!=this.bias&&(r=_o(r,this.bias.read())),null!=this.activation&&(r=this.activation.apply(r))),r})}getConfig(){const t={units:this.units,activation:nh(this.activation),useBias:this.useBias,kernelInitializer:il(this.kernelInitializer),biasInitializer:il(this.biasInitializer),kernelRegularizer:lh(this.kernelRegularizer),biasRegularizer:lh(this.biasRegularizer),activityRegularizer:lh(this.activityRegularizer),kernelConstraint:Qa(this.kernelConstraint),biasConstraint:Qa(this.biasConstraint)},e=super.getConfig();return Object.assign(t,e),t}}Yh.className="Dense",be(Yh);class Qh extends Il{constructor(t){super(t=t||{}),this.inputSpec=[{minNDim:3}],this.dataFormat=t.dataFormat}computeOutputShape(t){t=fl(t);for(const e of t.slice(1))if(null==e)throw new Aa(`The shape of the input to "Flatten" is not fully defined (got ${t.slice(1)}). Make sure to pass a complete "input_shape" or "batch_input_shape" argument to the first layer in your model.`);return[t[0],bo(t,1)]}call(t,e){return ve(()=>{this.invokeCallHook(t,e);let n=dl(t);if("channelsFirst"===this.dataFormat&&n.rank>1){const t=[0];for(let e=2;e<n.rank;++e)t.push(e);t.push(1),n=n.transpose(t)}return function(t){if(t.rank<=1)throw new Aa(`batchFlatten requires a minimum rank of 2. Got rank: ${t.rank}.`);const e=[t.shape[0],bo(t.shape,1)];return t.reshape(e)}(n)})}getConfig(){const t={};null!=this.dataFormat&&(t.dataFormat=this.dataFormat);const e=super.getConfig();return Object.assign(t,e),t}}Qh.className="Flatten",be(Qh);class tc extends Il{constructor(t){super(t),this.supportsMasking=!0,this.activation=rh(t.activation)}call(t,e){return ve(()=>{this.invokeCallHook(t,e);const n=dl(t);return this.activation.apply(n)})}getConfig(){const t={activation:nh(this.activation)},e=super.getConfig();return Object.assign(t,e),t}}tc.className="Activation",be(tc);class ec extends Il{constructor(t){super(t),this.n=t.n,this.inputSpec=[{ndim:2}]}computeOutputShape(t){return[t[0],this.n,t[1]]}call(t,e){return ve(()=>{return t=dl(t),e=t,n=this.n,ve(()=>{if(2!==e.shape.length)throw new Aa(`repeat() expects a rank-2 tensor, but received a rank-${e.shape.length} tensor.`);return zo(Io(e,1),[1,n,1])});var e,n})}getConfig(){const t={n:this.n},e=super.getConfig();return Object.assign(t,e),t}}ec.className="RepeatVector",be(ec);class nc extends Il{constructor(t){super(t),this.targetShape=t.targetShape;for(let t=0;t<this.targetShape.length;++t)this.isUnknown(this.targetShape[t])&&(this.targetShape[t]=null)}isUnknown(t){return t<0||null==t}fixUnknownDimension(t,e){const n="Total size of new array must be unchanged.",s=e.slice();let r=1,i=null;for(let t=0;t<s.length;++t){const e=s[t];if(this.isUnknown(e)){if(null!==i)throw new Aa("Can only specifiy one unknown dimension.");i=t}else r*=e}const a=bo(t);if(null!==i){if(0===r||a%r!=0)throw new Aa(n);s[i]=a/r}else if(a!==r)throw new Aa(n);return s}computeOutputShape(t){let e=!1;for(let n=0;n<t.length;++n)if(this.isUnknown(t[n])){e=!0;break}return e?t.slice(0,1).concat(this.targetShape):t.slice(0,1).concat(this.fixUnknownDimension(t.slice(1),this.targetShape))}call(t,e){return ve(()=>{this.invokeCallHook(t,e);const n=dl(t),s=n.shape,r=s.slice(0,1).concat(this.fixUnknownDimension(s.slice(1),this.targetShape));return n.reshape(r)})}getConfig(){const t={targetShape:this.targetShape},e=super.getConfig();return Object.assign(t,e),t}}nc.className="Reshape",be(nc);class sc extends Il{constructor(t){if(super(t),null==t.dims)throw new Error("Required configuration field `dims` is missing during Permute constructor call.");if(!Array.isArray(t.dims))throw new Error("Permute constructor requires `dims` to be an Array, but received "+t.dims+" instead.");const e=xo(1,t.dims.length+1);if(!c(t.dims.slice().sort(),e))throw new Error("Invalid permutation `dims`: "+JSON.stringify(t.dims)+" `dims` must contain consecutive integers starting from 1.");this.dims=t.dims,this.dimsIncludingBatch=[0].concat(this.dims),this.inputSpec=[new wl({ndim:this.dims.length+1})]}computeOutputShape(t){const e=(t=fl(t)).slice();return this.dims.forEach((n,s)=>{e[s+1]=t[n]}),e}call(t,e){return fe(dl(t),this.dimsIncludingBatch)}getConfig(){const t={dims:this.dims},e=super.getConfig();return Object.assign(t,e),t}}sc.className="Permute",be(sc);class rc extends Il{constructor(t){super(null==t?{}:t),this.supportsMasking=!0,this.maskValue=null!=t?null==t.maskValue?0:t.maskValue:0}computeOutputShape(t){return t}getConfig(){const t=super.getConfig(),e={maskValue:this.maskValue};return Object.assign(e,t),e}computeMask(t,e){const n=dl(t);return Fe(Is(n,this.maskValue),-1)}call(t,e){return ve(()=>{this.invokeCallHook(t,e);const n=dl(t),s=Fe(Is(n,this.maskValue),-1,!0);return n.mul(s.asType(n.dtype))})}}rc.className="Masking",be(rc);class ic extends Il{constructor(t){if(super(t),this.embeddings=null,this.DEFAULT_EMBEDDINGS_INITIALIZER="randomUniform",null==t.batchInputShape&&null==t.inputShape){let e=null;null!=t.batchSize&&(e=t.batchSize),null==t.inputLength?this.batchInputShape=[e,null]:this.batchInputShape=[e].concat(Ra(t.inputLength))}this.inputDim=t.inputDim,qa(this.inputDim,"inputDim"),this.outputDim=t.outputDim,qa(this.outputDim,"outputDim"),this.embeddingsInitializer=al(t.embeddingsInitializer||this.DEFAULT_EMBEDDINGS_INITIALIZER),this.embeddingsRegularizer=hh(t.embeddingsRegularizer),this.activityRegularizer=hh(t.activityRegularizer),this.embeddingsConstraint=eo(t.embeddingsConstraint),this.maskZero=t.maskZero,this.supportsMasking=t.maskZero,this.inputLength=t.inputLength}build(t){this.embeddings=this.addWeight("embeddings",[this.inputDim,this.outputDim],this.dtype,this.embeddingsInitializer,this.embeddingsRegularizer,!0,this.embeddingsConstraint),this.built=!0}warnOnIncompatibleInputShape(t){}computeMask(t,e){return ve(()=>this.maskZero?(t=dl(t),Is(t,Tn(t))):null)}computeOutputShape(t){if(t=fl(t),null==this.inputLength)return[...t,this.outputDim];const e=Ra(this.inputLength);if(e.length!==t.length-1)throw new Aa(`"inputLength" is ${this.inputLength}, but received input shape has shape `+t);{let n=0;for(let s=0;s<e.length;++s){const r=e[s],i=t[s+1];if(null!=r&&null!=i&&r!==i)throw new Aa(`"inputLength" is ${this.inputLength}, but received input shape has shape `+t);null==r&&(e[n]=i),n++}}return[t[0],...e,this.outputDim]}call(t,e){return ve(()=>{this.invokeCallHook(t,e);let n=dl(t);"int32"!==n.dtype&&(n=So(n,"int32"));return Ro(this.embeddings.read(),n.as1D()).reshape(fl(this.computeOutputShape(n.shape)))})}getConfig(){const t={inputDim:this.inputDim,outputDim:this.outputDim,embeddingsInitializer:il(this.embeddingsInitializer),embeddingsRegularizer:lh(this.embeddingsRegularizer),activityRegularizer:lh(this.activityRegularizer),embeddingsConstraint:Qa(this.embeddingsConstraint),maskZero:this.maskZero,inputLength:this.inputLength},e=super.getConfig();return Object.assign(t,e),t}}ic.className="Embedding",be(ic);class ac extends Il{constructor(t){super(t||{}),this.supportsMasking=!0}mergeFunction(t){throw new Ea}computeElementwiseOpOutputShape(t,e){if(null==t||null==e)return null;if(t.length<e.length)return this.computeElementwiseOpOutputShape(e,t);if(0===e.length)return t;const n=t.slice(0,t.length-e.length);for(let s=0;s<e.length;++s){const r=t[t.length-e.length+s],i=e[s];if(null==r||null==i||r<0||i<0)n.push(null);else if(1===r)n.push(i);else if(1===i)n.push(r);else{if(r!==i)throw new Aa("Operands could not be broadcast together with shapes "+JSON.stringify(t)+" "+JSON.stringify(e));n.push(r)}}return n}build(t){if(Array.isArray(t)&&!Array.isArray(t[0])&&(t=[fl(t)]),(t=t).length<2)throw new Aa(`A merge layer should be called on an Array of at least 2 inputs. Got ${t.length} input(s).`);let e=[];for(const n of t)null!=n&&null!==n[0]&&e.push(n[0]);if(e=Pa(e),e.length>1)throw new Aa(`Can not merge tensors with different batch sizes. Got tensors with shapes: ${JSON.stringify(t)}.`);let n=null==t[0]?null:t[0].slice(1);for(let e=1;e<t.length;++e){const s=null==t[e]?null:t[e].slice(1);n=this.computeElementwiseOpOutputShape(n,s)}const s=t.map(t=>t.length);-1===t.indexOf(null)&&1===Pa(s).length?this.reshapeRequired=!1:this.reshapeRequired=!0}call(t,e){return ve(()=>{if(t=t,this.reshapeRequired){const e=[],n=t.map(t=>t.rank);if(-1===n.indexOf(null)){const s=ko(n);for(let n of t){const t=n.rank;for(let e=0;e<s-t;++e)n=Io(n,1);e.push(n)}return this.mergeFunction(e)}{let n=!1;for(const s of t){const t=s.rank;if(null==t){const t=s.shape,r=t[0],i=t.slice(1).concat([r]);let a=s.reshape([r].concat(bo(t.slice(1))));a=fe(a,[1,0]),a=a.reshape(i),e.push(a),n=!0}else if(t>1){const r=xo(1,t).concat([0]);e.push(fe(s,r)),n=!0}else e.push(s)}let s=this.mergeFunction(e);const r=s.rank;if(n)if(null==r){const t=s.shape,e=t[t.length-1],n=[e].concat(t.slice(0,t.length-1));s=fe(s.reshape([-1,e]),[1,0]).reshape(n)}else if(r>1){const t=[r-1].concat(xo(0,r-1));s=fe(s,t)}return s}}return this.mergeFunction(t)})}computeOutputShape(t){let e;e=null==(t=t)[0]?null:t[0].slice(1);for(let n=1;n<t.length;++n){const s=null==t[n]?null:t[n].slice(1);e=this.computeElementwiseOpOutputShape(e,s)}let n=[];for(const e of t)null!=e&&null!==e[0]&&n.push(e[0]);return n=Pa(n),e=1===n.length?n.concat(e):[null].concat(e),e}computeMask(t,e){return ve(()=>{if(null==e)return null;if(!Array.isArray(e))throw new Aa("`mask` should be an Array");if(!Array.isArray(t))throw new Aa("`inputs` should be an Array");if(e.length!==t.length)throw new Aa(`The Array 'inputs' and 'mask' are expected to have the same length, but have different lengths (${t.length} vs ${e.length})`);if(e.every(t=>null==t))return null;let n=(e=e.map(t=>null==t?t:Mn(t,0)))[0];for(let t=1;t<e.length-1;++t)n=hs(n,e[t]);return n})}}class oc extends ac{constructor(t){super(t)}mergeFunction(t){return ve(()=>{let e=t[0].clone();for(let n=1;n<t.length;++n)e=Ie(e,t[n]);return e})}}oc.className="Add",be(oc);class lc extends ac{constructor(t){super(t)}mergeFunction(t){return ve(()=>{let e=t[0].clone();for(let n=1;n<t.length;++n)e=Ee(e,t[n]);return e})}}lc.className="Multiply",be(lc);class uc extends ac{constructor(t){super(t)}mergeFunction(t){return ve(()=>{let e=t[0].clone();for(let n=1;n<t.length;++n)e=Ie(e,t[n]);return Ee(1/t.length,e)})}}uc.className="Average",be(uc);class hc extends ac{constructor(t){super(t)}mergeFunction(t){return ve(()=>{let e=t[0];for(let n=1;n<t.length;++n)e=gs(e,t[n]);return e})}}hc.className="Maximum",be(hc);class cc extends ac{constructor(t){super(t)}mergeFunction(t){return ve(()=>{let e=t[0];for(let n=1;n<t.length;++n)e=ws(e,t[n]);return e})}}cc.className="Minimum",be(cc);class pc extends ac{constructor(t){super(t),this.DEFAULT_AXIS=-1,null==t&&(t={}),this.axis=null==t.axis?this.DEFAULT_AXIS:t.axis,this.supportsMasking=!0,this.reshapeRequired=!1}build(t){if(!Array.isArray(t)||!Array.isArray(t[0])||1===t.length)throw new Aa("A `Concatenate` layer should be called on a list of at least 2 inputs");t=t;let e=!0;for(const n of t)if(null!=n){e=!1;break}if(e)return;const n=[];for(let e=0;e<t.length;++e){const s=t[e].slice();s.splice(this.axis,1);let r=!1;for(const t of n)if(c(t,s)){r=!0;break}r||n.push(s)}if(n.length>1)throw new Aa("A `Concatenate` layer requires inputs with matching shapes except for the concat axis. Got input shapes: "+JSON.stringify(t))}mergeFunction(t){return ve(()=>To(t,this.axis))}computeOutputShape(t){if(!Array.isArray(t)||!Array.isArray(t[0]))throw new Aa("A `Concatenate` layer should be called on a list of inputs.");const e=t,n=e[0].slice(),s=this.axis<0?n.length+this.axis:this.axis;for(const t of e.slice(1)){if(null==n[s]||null==t[s]){n[s]=null;break}n[s]+=t[s]}return n}computeMask(t,e){if(null==e)return null;if(!Array.isArray(e))throw new Aa("`mask` should be an array for Concatenate");if(!Array.isArray(t))throw new Aa("`inputs` should be an array for Concatenate");if(e.length!==t.length)throw new Aa(`Mismatch in the length of mask (${e.length}) and the legnth of inputs (${t.length})`);return ve(()=>{let n=!0;if(e.forEach(t=>{null==t||(n=!1)}),n)return null;const s=[];for(let n=0;n<t.length;++n)null==e[n]?s.push(Es(t[n]).asType("bool")):e[n].rank<t[n].rank?s.push(Mn(e[n],-1)):s.push(e[n]);const r=Je(s,this.axis);return Ce(r,-1,!1)})}getConfig(){const t={axis:this.axis},e=super.getConfig();return Object.assign(t,e),t}}function dc(t,e){for(;t<0;)t+=e;return t}pc.className="Concatenate",be(pc);class fc extends ac{constructor(t){super(t),this.axes=t.axes,this.normalize=null!=t.normalize&&t.normalize,this.supportsMasking=!0,this.reshapeRequired=!1}build(t){a(Array.isArray(t)&&2===t.length&&Array.isArray(t[0])&&Array.isArray(t[1]),()=>"A `Dot` layer should be called on a list of exactly 2 inputs.");const e=t[0],n=t[1];if(e.length>3||n.length>3)throw new Ea("Dot layer does not support tensors of 4D or higher rank yet.");const s=this.interpretAxes(e,n);if(e[s[0]]!==n[s[1]])throw new Aa(`Dimension incompatibility: ${e[s[0]]} !== ${n[s[1]]}`)}mergeFunction(t){if(2!==t.length)throw new Aa(`A \`Dot\` layer must be called on exactly 2 inputs, but received ${t.length} input(s).`);let e,n=t[0],s=t[1];return e=Array.isArray(this.axes)?this.axes.map((e,n)=>dc(e,t[n].shape.length)):[dc(this.axes,n.shape.length),dc(this.axes,s.shape.length)],this.normalize&&(n=Ol(n,e[0]),s=Ol(s,e[1])),function(t,e,n){if(t.shape.length>3||e.shape.length>3)throw new Ea("batchDot is not implemented for tensors of 4D or higher rank yet");if(a(t.shape.length>=2,()=>"batchDot requires the rank of x to be >= 2, but got "+t.shape.length),a(t.shape.length>=2,()=>"batchDot requires the rank of y to be >= 2, but got "+e.shape.length),"number"==typeof n&&(n=[n,n]),"complex64"===t.dtype||"complex64"===e.dtype)throw new Ea("batchDot is not implemented for complex64-type Tensors yet.");const s=t.shape.length,r=e.shape.length;null==n&&(n=[s-1,r-2]);const i=n;return ve(()=>{let n,a;if(s>r){n=s-r;const t=[];for(let e=0;e<n;++e)t.push(1);e=e.reshape(e.shape.concat(t))}else if(r>s){n=r-s;const e=[];for(let t=0;t<n;++t)e.push(1);t=t.reshape(t.shape.concat(e))}else n=0;if(2===t.shape.length&&2===e.shape.length)a=i[0]===i[1]?t.mul(e).sum(i[0]):t.transpose([1,0]).mul(e).sum(i[1]);else{const n=i[0]!==t.shape.length-1,s=i[1]===e.shape.length-1;a=t.matMul(e,n,s)}if(n>0){let t;t=s>r?s+r-3:s-1;const e=[];for(let s=t;s<t+n;++s)e.push(s);a=a.squeeze(e)}return 1===a.shape.length&&(a=a.expandDims(1)),a})}(n,s,e)}interpretAxes(t,e){let n;return n=Array.isArray(this.axes)?this.axes:[dc(this.axes,t.length),dc(this.axes,e.length)],n}computeOutputShape(t){a(Array.isArray(t)&&2===t.length&&Array.isArray(t[0])&&Array.isArray(t[1]),()=>"A `Dot` layer should be called on a list of exactly 2 inputs.");const e=t[0].slice(),n=t[1].slice();if(e.length>3||n.length>3)throw new Ea("Dot layer does not support tensors of 4D or higher rank yet.");const s=this.interpretAxes(e,n);e.splice(s[0],1),n.splice(s[1],1),n.splice(0,1);const r=e.concat(n);return 1===r.length&&r.push(1),r}computeMask(t,e){return null}getConfig(){const t={axes:this.axes,normalize:this.normalize},e=super.getConfig();return Object.assign(t,e),t}}fc.className="Dot",be(fc);class mc extends Il{constructor(t){super(t),this.supportsMasking=!0,this.stddev=t.stddev}computeOutputShape(t){return t}getConfig(){const t=super.getConfig(),e={stddev:this.stddev};return Object.assign(e,t),e}call(t,e){return ve(()=>{this.invokeCallHook(t,e);const n=dl(t);return Oo(()=>Co(n.shape,0,this.stddev).add(n),()=>n,e.training||!1)})}}mc.className="GaussianNoise",be(mc);class gc extends Il{constructor(t){super(t),this.supportsMasking=!0,this.rate=t.rate}computeOutputShape(t){return t}getConfig(){const t=super.getConfig(),e={rate:this.rate};return Object.assign(e,t),e}call(t,e){return ve(()=>{this.invokeCallHook(t,e);const n=dl(t);if(this.rate>0&&this.rate<1){return Oo(()=>{const t=Math.sqrt(this.rate/(1-this.rate));return n.mul(Co(n.shape,1,t))},()=>n,e.training||!1)}return n})}}gc.className="GaussianDropout",be(gc);class yc extends Il{constructor(t){super(t),this.supportsMasking=!0,this.rate=t.rate,this.noiseShape=t.noiseShape}_getNoiseShape(t){return this.noiseShape||dl(t).shape}computeOutputShape(t){return t}getConfig(){const t=super.getConfig(),e={rate:this.rate};return Object.assign(e,t),e}call(t,e){return ve(()=>{if(this.rate<1&&this.rate>0){const n=this._getNoiseShape(t);return Oo(()=>{const e=dl(t),s=-1.7580993408473766;let r=Wn(Vs(n),this.rate);r=So(r,"float32");const i=((1-this.rate)*(1+this.rate*s**2))**-.5,a=-i*s*this.rate;return e.mul(r).add(r.add(-1).mul(s)).mul(i).add(a)},()=>dl(t),e.training||!1)}return t})}}function bc(t,e,n,s,r,i=.001){let a;if(2===t.rank)a=en(t,e,n,s,r,i);else if(3===t.rank)a=nn(t,e,n,s,r,i);else{if(4!==t.rank)throw new Ea(`batchNormalization is not implemented for array of rank ${t.rank} yet`);a=sn(t,e,n,s,r,i)}return a}function wc(t,e,n,s,r=.001){return c(s.slice().sort(),xo(0,t.rank-1))?function(t,e,n,s,r=.001){return ve(()=>{const i=Ss(t,s),a=i.mean,o=i.variance;return[bc(t,a,o,n,e,r),a,o]})}(t,e,n,s,r):function(t,e,n,s,r=.001){return ve(()=>{const i=Ss(t,s),a=i.mean,o=i.variance,l=[];for(const e of xo(0,t.rank))-1!==s.indexOf(e)?l.push(1):l.push(t.shape[e]);const u=a.reshape(l),h=o.reshape(l),c=null==e?null:e.reshape(l),p=null==n?null:n.reshape(l);return[bc(t,u,h,p,c,r),a,o]})}(t,e,n,s,r)}yc.className="AlphaDropout",be(yc);class vc extends Il{constructor(t){null==t&&(t={}),super(t),this.supportsMasking=!0,this.axis=null==t.axis?-1:t.axis,this.momentum=null==t.momentum?.99:t.momentum,this.epsilon=null==t.epsilon?.001:t.epsilon,this.center=null==t.center||t.center,this.scale=null==t.scale||t.scale,this.betaInitializer=al(t.betaInitializer||"zeros"),this.gammaInitializer=al(t.gammaInitializer||"ones"),this.movingMeanInitializer=al(t.movingMeanInitializer||"zeros"),this.movingVarianceInitializer=al(t.movingVarianceInitializer||"ones"),this.betaConstraint=eo(t.betaConstraint),this.gammaConstraint=eo(t.gammaConstraint),this.betaRegularizer=hh(t.betaRegularizer),this.gammaRegularizer=hh(t.gammaRegularizer)}build(t){t=fl(t);const e=this.axis>=0?this.axis:this.axis+t.length,n=t[e];if(null==n)throw new Aa(`Axis ${e} of input tensor should have a defined dimension but the layer received an input with shape `+JSON.stringify(t)+".");this.inputSpec=[new wl({ndim:t.length,axes:{[e]:n}})];const s=[n];this.scale&&(this.gamma=this.addWeight("gamma",s,null,this.gammaInitializer,this.gammaRegularizer,!0,this.gammaConstraint)),this.center&&(this.beta=this.addWeight("beta",s,null,this.betaInitializer,this.betaRegularizer,!0,this.betaConstraint)),this.movingMean=this.addWeight("moving_mean",s,null,this.movingMeanInitializer,null,!1),this.movingVariance=this.addWeight("moving_variance",s,null,this.movingVarianceInitializer,null,!1),this.built=!0}call(t,e){return ve(()=>{const n=null!=e.training&&e.training,s=dl(t),r=s.shape,i=r.length,a=xo(0,i),o=this.axis>=0?this.axis:this.axis+i;a.splice(o,1);const l=Da(1,i);l[o]=r[o];const u=a.slice();u.sort();const h=!c(u,xo(0,i).slice(0,i-1));if(!n)return(()=>{if(h){const t=this.movingMean.read().reshape(l),e=this.movingVariance.read().reshape(l),n=this.center?this.beta.read().reshape(l):null,r=this.scale?this.gamma.read().reshape(l):null;return bc(s,t,e,n,r,this.epsilon)}return bc(s,this.movingMean.read(),this.movingVariance.read(),null==this.beta?null:this.beta.read(),null==this.gamma?null:this.gamma.read(),this.epsilon)})();const[p,d,f]=wc(s,this.gamma.read(),this.beta.read(),a,this.epsilon),m=(t,e,n)=>{ve(()=>{const s=1-n,r=t.read(),i=r.sub(e).mul(s);t.write(r.sub(i))})};return(()=>{m(this.movingMean,d,this.momentum),m(this.movingVariance,f,this.momentum)})(),p})}getConfig(){const t={axis:this.axis,momentum:this.momentum,epsilon:this.epsilon,center:this.center,scale:this.scale,betaInitializer:il(this.betaInitializer),gammaInitializer:il(this.gammaInitializer),movingMeanInitializer:il(this.movingMeanInitializer),movingVarianceInitializer:il(this.movingVarianceInitializer),betaRegularizer:lh(this.betaRegularizer),gammaRegularizer:lh(this.gammaRegularizer),betaConstraint:Qa(this.betaConstraint),gammaConstraint:Qa(this.gammaConstraint)},e=super.getConfig();return Object.assign(t,e),t}}vc.className="BatchNormalization",be(vc);class kc extends Il{constructor(t){if(null==t&&(t={}),super(t),this.axis=null==t.axis?-1:t.axis,"number"==typeof this.axis){if(!Number.isInteger(this.axis))throw new Error("Expected axis to be an integer, but received "+this.axis)}else{if(!Array.isArray(this.axis))throw new Error("Expected axis to be an integer or an array of integers, but received "+JSON.stringify(this.axis));for(const t of this.axis)if(!Number.isInteger(t))throw new Error("Expected axis to be an array of integers, but received "+JSON.stringify(this.axis))}this.epsilon=null==t.epsilon?.001:t.epsilon,this.center=null==t.center||t.center,this.scale=null==t.scale||t.scale,this.betaInitializer=al(t.betaInitializer||"zeros"),this.gammaInitializer=al(t.gammaInitializer||"ones"),this.betaRegularizer=hh(t.betaRegularizer),this.gammaRegularizer=hh(t.gammaRegularizer),this.supportsMasking=!0}build(t){const e=(t=fl(t)).length;"number"==typeof this.axis&&(this.axis=[this.axis]);for(let t=0;t<this.axis.length;++t)this.axis[t]<0&&(this.axis[t]+=e);for(const t of this.axis)if(t<0||t>=e)throw new Error("Invalid axis: "+t);if(this.axis.length!==Pa(this.axis).length)throw new Error("Found duplicate axes in: "+this.axis);const n=this.axis.map(e=>t[e]);this.scale?this.gamma=this.addWeight("gamma",n,"float32",this.gammaInitializer,this.gammaRegularizer,!0):this.gamma=null,this.center?this.beta=this.addWeight("beta",n,"float32",this.betaInitializer,this.betaRegularizer,!0):this.beta=null,this.built=!0}call(t,e){const n=dl(t),s=n.shape,r=s.length;return ve(()=>{let{mean:t,variance:e}=Ss(n,this.axis,!0);const i=Da(1,r);for(const t of this.axis)i[t]=s[t];const a=t=>null!=t&&t.shape.length!==r&&this.axis!==[r-1]?t.reshape(i):t;let o=a(this.gamma.read()),l=a(this.beta.read());const u=[],h=[];for(let t=0;t<r;++t)-1!==this.axis.indexOf(t)?(u.push(s[t]),h.push(1)):(u.push(1),h.push(s[t]));return t=t.tile(u),e=e.tile(u),o=o.tile(h),l=l.tile(h),bc(n,t,e,l,o,this.epsilon)})}getConfig(){const t={axis:this.axis,epsilon:this.epsilon,center:this.center,scale:this.scale,betaInitializer:il(this.betaInitializer),gammaInitializer:il(this.gammaInitializer),betaRegularizer:lh(this.betaRegularizer),gammaRegularizer:lh(this.gammaRegularizer)},e=super.getConfig();return Object.assign(t,e),t}}kc.className="LayerNormalization",be(kc);class xc extends Il{constructor(t){if(null==t&&(t={}),super(t),this.dataFormat=null==t.dataFormat?"channelsLast":t.dataFormat,null==t.padding)this.padding=[[1,1],[1,1]];else if("number"==typeof t.padding)this.padding=[[t.padding,t.padding],[t.padding,t.padding]];else{if(t.padding=t.padding,2!==t.padding.length)throw new Aa(`ZeroPadding2D expects padding to be a length-2 array, but received a length-${t.padding.length} array.`);let e,n;if("number"==typeof t.padding[0])e=[t.padding[0],t.padding[0]],n=[t.padding[1],t.padding[1]];else{if(t.padding=t.padding,2!==t.padding[0].length)throw new Aa(`ZeroPadding2D expects height padding to be a length-2 array, but received a length-${t.padding[0].length} array.`);if(e=t.padding[0],2!==t.padding[1].length)throw new Aa(`ZeroPadding2D expects width padding to be a length-2 array, but received a length-${t.padding[1].length} array.`);n=t.padding[1]}this.padding=[e,n]}this.inputSpec=[new wl({ndim:4})]}computeOutputShape(t){let e,n;return t=fl(t),"channelsFirst"===this.dataFormat?(e=null!=t[2]&&t[2]>=0?t[2]+this.padding[0][0]+this.padding[0][1]:null,n=null!=t[3]&&t[3]>=0?t[3]+this.padding[1][0]+this.padding[1][1]:null,[t[0],t[1],e,n]):(e=null!=t[1]&&t[1]>=0?t[1]+this.padding[0][0]+this.padding[0][1]:null,n=null!=t[2]&&t[2]>=0?t[2]+this.padding[1][0]+this.padding[1][1]:null,[t[0],e,n,t[3]])}call(t,e){return ve(()=>{return e=dl(t),n=this.padding,s=this.dataFormat,ve(()=>{if(4!==e.rank)throw new Aa("temporalPadding expects input tensor to be 4-D, but received a "+e.rank+"-D tensor.");if(null==n&&(n=[[1,1],[1,1]]),2!==n.length||2!==n[0].length||2!==n[1].length)throw new Aa("spatial2dPadding expects `padding` to be an Array of two Arrays, each of which is an Array of two integers.");if(null==s&&(s="channelsLast"),"channelsLast"!==s&&"channelsFirst"!==s)throw new Aa(`Unknown data format: ${s}. Supported data formats are 'channelsLast' and 'channelsFirst.`);let t;return t="channelsFirst"===s?[[0,0],[0,0],n[0],n[1]]:[[0,0],n[0],n[1],[0,0]],Ts(e,t)});var e,n,s})}getConfig(){const t={padding:this.padding,dataFormat:this.dataFormat},e=super.getConfig();return Object.assign(t,e),t}}function Sc(t,e,n,s,r,i){return ve(()=>{let a;lo(r),ho(i),uo(s),null==n&&(n=[1,1]),null==s&&(s="valid"),null==r&&(r="channelsLast"),null==i&&(i="max"),t=vh(t,r);const o="same"===s?"same":"valid";return a="max"===i?fs(t,e,n,o):He(t,e,n,o),"channelsFirst"===r&&(a=fe(a,[0,3,1,2])),a})}function Ic(t,e,n,s,r,i){return ve(()=>{let a;lo(r),ho(i),uo(s),null==n&&(n=[1,1,1]),null==s&&(s="valid"),null==r&&(r="channelsLast"),null==i&&(i="max"),t=kh(t,r);const o="same"===s?"same":"valid";return a="max"===i?ms(t,e,n,o):Ge(t,e,n,o),"channelsFirst"===r&&(a=fe(a,[0,4,1,2,3])),a})}xc.className="ZeroPadding2D",be(xc);class Nc extends Il{constructor(t){if(null==t.poolSize&&(t.poolSize=2),super(t),"number"==typeof t.poolSize)this.poolSize=[t.poolSize];else{if(!Array.isArray(t.poolSize)||1!==t.poolSize.length||"number"!=typeof t.poolSize[0])throw new Aa("poolSize for 1D convolutional layer must be a number or an Array of a single number, but received "+JSON.stringify(t.poolSize));this.poolSize=t.poolSize}if(qa(this.poolSize,"poolSize"),null==t.strides)this.strides=this.poolSize;else if("number"==typeof t.strides)this.strides=[t.strides];else{if(!Array.isArray(t.strides)||1!==t.strides.length||"number"!=typeof t.strides[0])throw new Aa("strides for 1D convolutional layer must be a number or an Array of a single number, but received "+JSON.stringify(t.strides));this.strides=t.strides}qa(this.strides,"strides"),this.padding=null==t.padding?"valid":t.padding,uo(this.padding),this.inputSpec=[new wl({ndim:3})]}computeOutputShape(t){const e=bh((t=fl(t))[1],this.poolSize[0],this.padding,this.strides[0]);return[t[0],e,t[2]]}call(t,e){return ve(()=>{this.invokeCallHook(t,e),t=Io(dl(t),2);const n=this.poolingFunction(dl(t),[this.poolSize[0],1],[this.strides[0],1],this.padding,"channelsLast");return wr(n,[2])})}getConfig(){const t={poolSize:this.poolSize,padding:this.padding,strides:this.strides},e=super.getConfig();return Object.assign(t,e),t}}class Ac extends Nc{constructor(t){super(t)}poolingFunction(t,e,n,s,r){return lo(r),uo(s),Sc(t,e,n,s,r,"max")}}Ac.className="MaxPooling1D",be(Ac);class Ec extends Nc{constructor(t){super(t)}poolingFunction(t,e,n,s,r){return lo(r),uo(s),Sc(t,e,n,s,r,"avg")}}Ec.className="AveragePooling1D",be(Ec);class Tc extends Il{constructor(t){if(null==t.poolSize&&(t.poolSize=[2,2]),super(t),this.poolSize=Array.isArray(t.poolSize)?t.poolSize:[t.poolSize,t.poolSize],null==t.strides)this.strides=this.poolSize;else if(Array.isArray(t.strides)){if(2!==t.strides.length)throw new Aa("If the strides property of a 2D pooling layer is an Array, it is expected to have a length of 2, but received length "+t.strides.length+".");this.strides=t.strides}else this.strides=[t.strides,t.strides];qa(this.poolSize,"poolSize"),qa(this.strides,"strides"),this.padding=null==t.padding?"valid":t.padding,this.dataFormat=null==t.dataFormat?"channelsLast":t.dataFormat,lo(this.dataFormat),uo(this.padding),this.inputSpec=[new wl({ndim:4})]}computeOutputShape(t){t=fl(t);let e="channelsFirst"===this.dataFormat?t[2]:t[1],n="channelsFirst"===this.dataFormat?t[3]:t[2];return e=bh(e,this.poolSize[0],this.padding,this.strides[0]),n=bh(n,this.poolSize[1],this.padding,this.strides[1]),"channelsFirst"===this.dataFormat?[t[0],t[1],e,n]:[t[0],e,n,t[3]]}call(t,e){return ve(()=>(this.invokeCallHook(t,e),this.poolingFunction(dl(t),this.poolSize,this.strides,this.padding,this.dataFormat)))}getConfig(){const t={poolSize:this.poolSize,padding:this.padding,strides:this.strides,dataFormat:this.dataFormat},e=super.getConfig();return Object.assign(t,e),t}}class Dc extends Tc{constructor(t){super(t)}poolingFunction(t,e,n,s,r){return lo(r),uo(s),Sc(t,e,n,s,r,"max")}}Dc.className="MaxPooling2D",be(Dc);class zc extends Tc{constructor(t){super(t)}poolingFunction(t,e,n,s,r){return lo(r),uo(s),Sc(t,e,n,s,r,"avg")}}zc.className="AveragePooling2D",be(zc);class Cc extends Il{constructor(t){if(null==t.poolSize&&(t.poolSize=[2,2,2]),super(t),this.poolSize=Array.isArray(t.poolSize)?t.poolSize:[t.poolSize,t.poolSize,t.poolSize],null==t.strides)this.strides=this.poolSize;else if(Array.isArray(t.strides)){if(3!==t.strides.length)throw new Aa("If the strides property of a 3D pooling layer is an Array, it is expected to have a length of 3, but received length "+t.strides.length+".");this.strides=t.strides}else this.strides=[t.strides,t.strides,t.strides];qa(this.poolSize,"poolSize"),qa(this.strides,"strides"),this.padding=null==t.padding?"valid":t.padding,this.dataFormat=null==t.dataFormat?"channelsLast":t.dataFormat,lo(this.dataFormat),uo(this.padding),this.inputSpec=[new wl({ndim:5})]}computeOutputShape(t){t=fl(t);let e="channelsFirst"===this.dataFormat?t[2]:t[1],n="channelsFirst"===this.dataFormat?t[3]:t[2],s="channelsFirst"===this.dataFormat?t[4]:t[3];return e=bh(e,this.poolSize[0],this.padding,this.strides[0]),n=bh(n,this.poolSize[1],this.padding,this.strides[1]),s=bh(s,this.poolSize[2],this.padding,this.strides[2]),"channelsFirst"===this.dataFormat?[t[0],t[1],e,n,s]:[t[0],e,n,s,t[4]]}call(t,e){return ve(()=>(this.invokeCallHook(t,e),this.poolingFunction(dl(t),this.poolSize,this.strides,this.padding,this.dataFormat)))}getConfig(){const t={poolSize:this.poolSize,padding:this.padding,strides:this.strides,dataFormat:this.dataFormat},e=super.getConfig();return Object.assign(t,e),t}}class Fc extends Cc{constructor(t){super(t)}poolingFunction(t,e,n,s,r){return lo(r),uo(s),Ic(t,e,n,s,r,"max")}}Fc.className="MaxPooling3D",be(Fc);class Rc extends Cc{constructor(t){super(t)}poolingFunction(t,e,n,s,r){return lo(r),uo(s),Ic(t,e,n,s,r,"avg")}}Rc.className="AveragePooling3D",be(Rc);class Mc extends Il{constructor(t){super(t),this.inputSpec=[new wl({ndim:3})]}computeOutputShape(t){return[t[0],t[2]]}call(t,e){throw new Ea}}class Lc extends Mc{constructor(t){super(t||{})}call(t,e){return ve(()=>{const e=dl(t);return ys(e,1)})}}Lc.className="GlobalAveragePooling1D",be(Lc);class _c extends Mc{constructor(t){super(t||{})}call(t,e){return ve(()=>{const e=dl(t);return ss(e,1)})}}_c.className="GlobalMaxPooling1D",be(_c);class $c extends Il{constructor(t){super(t),this.dataFormat=null==t.dataFormat?"channelsLast":t.dataFormat,lo(this.dataFormat),this.inputSpec=[new wl({ndim:4})]}computeOutputShape(t){return t=t,"channelsLast"===this.dataFormat?[t[0],t[3]]:[t[0],t[1]]}call(t,e){throw new Ea}getConfig(){const t={dataFormat:this.dataFormat},e=super.getConfig();return Object.assign(t,e),t}}class Oc extends $c{call(t,e){return ve(()=>{const e=dl(t);return"channelsLast"===this.dataFormat?ys(e,[1,2]):ys(e,[2,3])})}}Oc.className="GlobalAveragePooling2D",be(Oc);class Bc extends $c{call(t,e){return ve(()=>{const e=dl(t);return"channelsLast"===this.dataFormat?ss(e,[1,2]):ss(e,[2,3])})}}Bc.className="GlobalMaxPooling2D",be(Bc);class Pc extends Il{constructor(t){super(t),this.layer=t.layer}build(t){this.built=!0}get trainable(){return null!=this.layer&&this.layer.trainable}set trainable(t){null!=this.layer&&(this.layer.trainable=t)}get trainableWeights(){return this.layer.trainableWeights}get nonTrainableWeights(){return this.layer.nonTrainableWeights}get updates(){return this.layer._updates}get losses(){return this.layer.losses}getWeights(){return this.layer.getWeights()}setWeights(t){this.layer.setWeights(t)}getConfig(){const t={layer:{className:this.layer.getClassName(),config:this.layer.getConfig()}},e=super.getConfig();return Object.assign(t,e),t}setFastWeightInitDuringBuild(t){super.setFastWeightInitDuringBuild(t),null!=this.layer&&this.layer.setFastWeightInitDuringBuild(t)}static fromConfig(t,e,n={}){const s=$l(e.layer,n);delete e.layer;const r={layer:s};return Object.assign(r,e),new t(r)}}class Uc extends Pc{constructor(t){super(t),this.supportsMasking=!0}build(t){if((t=fl(t)).length<3)throw new Aa("TimeDistributed layer expects an input shape >= 3D, but received input shape "+JSON.stringify(t));this.inputSpec=[{shape:t}];const e=[t[0]].concat(t.slice(2));this.layer.built||(this.layer.build(e),this.layer.built=!0),super.build(t)}computeOutputShape(t){const e=[(t=fl(t))[0]].concat(t.slice(2)),n=this.layer.computeOutputShape(e),s=t[1];return[n[0],s].concat(n.slice(1))}call(t,e){return ve(()=>Lh((t,n)=>[dl(this.layer.call(t,e)),[]],t=dl(t),[],!1,null,null,!1,!0)[1])}}Uc.className="TimeDistributed",be(Uc);class Wc extends Pc{constructor(t){super(t);const e=t.layer.getConfig(),n={};n.className=t.layer.getClassName(),n.config=e,this.forwardLayer=$l(n),e.goBackwards=!0!==e.goBackwards;const s={};var r;if(s.className=t.layer.getClassName(),s.config=e,this.backwardLayer=$l(s),this.forwardLayer.name="forward_"+this.forwardLayer.name,this.backwardLayer.name="backward_"+this.backwardLayer.name,this.mergeMode=void 0===t.mergeMode?"concat":t.mergeMode,r=this.mergeMode,Wa(ao,"BidirectionalMergeMode",r),t.weights)throw new Ea("weights support is not implemented for Bidirectional layer yet.");this._stateful=t.layer.stateful,this.returnSequences=t.layer.returnSequences,this.returnState=t.layer.returnState,this.supportsMasking=!0,this._trainable=!0,this.inputSpec=t.layer.inputSpec,this.numConstants=null}get trainable(){return this._trainable}set trainable(t){this._trainable=t,null!=this.forwardLayer&&(this.forwardLayer.trainable=t),null!=this.backwardLayer&&(this.backwardLayer.trainable=t)}getWeights(){return this.forwardLayer.getWeights().concat(this.backwardLayer.getWeights())}setWeights(t){const e=t.length,n=Math.floor(e/2);this.forwardLayer.setWeights(t.slice(0,n)),this.backwardLayer.setWeights(t.slice(n))}computeOutputShape(t){let e,n,s,r=this.forwardLayer.computeOutputShape(t);return Array.isArray(r)&&Array.isArray(r[0])||(r=[r]),r=r,this.returnState?(s=r.slice(1),e=r[0]):e=r[0],e=e,"concat"===this.mergeMode?(e[e.length-1]*=2,n=[e]):n=null==this.mergeMode?[e,e.slice()]:[e],this.returnState?null==this.mergeMode?n.concat(s).concat(s.slice()):[e].concat(s).concat(s.slice()):Fa(n)}apply(t,e){let n=null==e?null:e.initialState,s=null==e?null:e.constants;null==e&&(e={});const r=Mh(t,n,s,this.numConstants);if(t=r.inputs,n=r.initialState,s=r.constants,Array.isArray(t)&&(n=t.slice(1),t=t[0]),(null==n||0===n.length)&&null==s)return super.apply(t,e);const i=[],a=[];if(null!=n){const t=n.length;if(t%2>0)throw new Aa("When passing `initialState` to a Bidrectional RNN, the state should be an Array containing the states of the underlying RNNs.");e.initialState=n,i.push(...n);const s=n.map(t=>new wl({shape:t.shape}));this.forwardLayer.stateSpec=s.slice(0,t/2),this.backwardLayer.stateSpec=s.slice(t/2),a.push(...s)}if(null!=s)throw new Ea("Support for constants in Bidirectional layers is not implemented yet.");const o=i[0]instanceof vl;for(const t of i)if(t instanceof vl!==o)throw new Aa("The initial state of a Bidirectional layer cannot be specified as a mix of symbolic and non-symbolic tensors");if(o){const n=[t].concat(i),s=this.inputSpec.concat(a),r=this.inputSpec;this.inputSpec=s;const o=super.apply(n,e);return this.inputSpec=r,o}return super.apply(t,e)}call(t,e){return ve(()=>{const n=e.initialState;let s,r,i,a;if(null==n)s=this.forwardLayer.call(t,e),r=this.backwardLayer.call(t,e);else{const i=n.slice(0,n.length/2),a=n.slice(n.length/2);s=this.forwardLayer.call(t,Object.assign(e,{initialState:i})),r=this.backwardLayer.call(t,Object.assign(e,{initialState:a}))}return this.returnState&&(Array.isArray(s)&&(i=s.slice(1).concat(r.slice(1))),s=s[0],r=r[0]),this.returnSequences&&(r=Ys(r,1)),"concat"===this.mergeMode?a=To([s,r]):"sum"===this.mergeMode?a=Ie(s,r):"ave"===this.mergeMode?a=Ee(.5,Ie(s,r)):"mul"===this.mergeMode?a=Ee(s,r):null==this.mergeMode&&(a=[s,r]),this.returnState?null==this.mergeMode?a.concat(i):[a].concat(i):a})}resetStates(t){this.forwardLayer.resetStates(),this.backwardLayer.resetStates()}build(t){po(this.forwardLayer.name,()=>{this.forwardLayer.build(t)}),po(this.backwardLayer.name,()=>{this.backwardLayer.build(t)}),this.built=!0}computeMask(t,e){let n;if(Array.isArray(e)&&(e=e[0]),n=this.returnSequences?null==this.mergeMode?[e,e]:e:null==this.mergeMode?[null,null]:null,this.returnState){const t=this.forwardLayer.states.map(t=>null);return Array.isArray(n)?n.concat(t).concat(t):[n].concat(t).concat(t)}return n}get trainableWeights(){return this.forwardLayer.trainableWeights.concat(this.backwardLayer.trainableWeights)}get nonTrainableWeights(){return this.forwardLayer.nonTrainableWeights.concat(this.backwardLayer.nonTrainableWeights)}setFastWeightInitDuringBuild(t){super.setFastWeightInitDuringBuild(t),null!=this.forwardLayer&&this.forwardLayer.setFastWeightInitDuringBuild(t),null!=this.backwardLayer&&this.backwardLayer.setFastWeightInitDuringBuild(t)}getConfig(){const t={mergeMode:this.mergeMode},e=super.getConfig();return Object.assign(t,e),t}static fromConfig(t,e){const n=$l(e.layer);if(delete e.layer,null!=e.numConstants)throw new Ea("Deserialization of a Bidirectional layer with numConstants present is not supported yet.");const s=e;return s.layer=n,new t(s)}}function jc(t){return ai(this,void 0,void 0,(function(){var n,s,r,i,a;return oi(this,(function(o){switch(o.label){case 0:return"http://","https://",n="file://",0!==t.indexOf("http://")&&0!==t.indexOf("https://")?[3,3]:[4,fetch(t)];case 1:return[4,o.sent().json()];case 2:return[2,o.sent()];case 3:return 0!==t.indexOf(n)?[3,5]:(s=require("fs"),r=e.promisify(s.readFile),a=(i=JSON).parse,[4,r(t.slice(n.length),{encoding:"utf-8"})]);case 4:return[2,a.apply(i,[o.sent()])];case 5:throw new Error("Unsupported URL scheme in metadata URL: "+t+". Supported schemes are: http://, https://, and (node.js-only) file://")}}))}))}Wc.className="Bidirectional",be(Wc);var qc=null;function Kc(t){return null==qc&&(qc=Se().epsilon()),ve((function(){var e=Ss(t),n=e.mean,s=e.variance;return Ae(rs(t,n),Ie(yr(s),qc))}))}function Vc(t){if(t.length<2)throw new Error("Cannot normalize a Float32Array with fewer than 2 elements.");return null==qc&&(qc=Se().epsilon()),ve((function(){var e=Ss(Ir(t)),n=e.mean,s=e.variance,r=n.arraySync(),i=Math.sqrt(s.arraySync()),a=Array.from(t).map((function(t){return(t-r)/(i+qc)}));return new Float32Array(a)}))}function Hc(t){return ai(this,void 0,void 0,(function(){return oi(this,(function(e){return[2,navigator.mediaDevices.getUserMedia({audio:null==t||t,video:!1})]}))}))}var Gc=function(){function t(t){var e=this;if(null==t)throw new Error("Required configuration object is missing for BrowserFftFeatureExtractor constructor");if(null==t.spectrogramCallback)throw new Error("spectrogramCallback cannot be null or undefined");if(!(t.numFramesPerSpectrogram>0))throw new Error("Invalid value in numFramesPerSpectrogram: "+t.numFramesPerSpectrogram);if(t.suppressionTimeMillis<0)throw new Error("Expected suppressionTimeMillis to be >= 0, but got "+t.suppressionTimeMillis);if(this.suppressionTimeMillis=t.suppressionTimeMillis,this.spectrogramCallback=t.spectrogramCallback,this.numFrames=t.numFramesPerSpectrogram,this.sampleRateHz=t.sampleRateHz||44100,this.fftSize=t.fftSize||1024,this.frameDurationMillis=this.fftSize/this.sampleRateHz*1e3,this.columnTruncateLength=t.columnTruncateLength||this.fftSize,this.overlapFactor=t.overlapFactor,this.includeRawAudio=t.includeRawAudio,a(this.overlapFactor>=0&&this.overlapFactor<1,(function(){return"Expected overlapFactor to be >= 0 and < 1, but got "+e.overlapFactor})),this.columnTruncateLength>this.fftSize)throw new Error("columnTruncateLength "+this.columnTruncateLength+" exceeds fftSize ("+this.fftSize+").");this.audioContextConstructor=window.AudioContext||window.webkitAudioContext}return t.prototype.start=function(t){return ai(this,void 0,void 0,(function(){var e,n,s;return oi(this,(function(r){switch(r.label){case 0:if(null!=this.frameIntervalTask)throw new Error("Cannot start already-started BrowserFftFeatureExtractor");return e=this,[4,Hc(t)];case 1:return e.stream=r.sent(),this.audioContext=new this.audioContextConstructor,this.audioContext.sampleRate!==this.sampleRateHz&&console.warn("Mismatch in sampling rate: Expected: "+this.sampleRateHz+"; Actual: "+this.audioContext.sampleRate),n=this.audioContext.createMediaStreamSource(this.stream),this.analyser=this.audioContext.createAnalyser(),this.analyser.fftSize=2*this.fftSize,this.analyser.smoothingTimeConstant=0,n.connect(this.analyser),this.freqDataQueue=[],this.freqData=new Float32Array(this.fftSize),this.includeRawAudio&&(this.timeDataQueue=[],this.timeData=new Float32Array(this.fftSize)),s=Math.max(1,Math.round(this.numFrames*(1-this.overlapFactor))),this.tracker=new Yc(s,Math.round(this.suppressionTimeMillis/this.frameDurationMillis)),this.frameIntervalTask=setInterval(this.onAudioFrame.bind(this),this.fftSize/this.sampleRateHz*1e3),[2]}}))}))},t.prototype.onAudioFrame=function(){return ai(this,void 0,void 0,(function(){var t,e,n,s;return oi(this,(function(r){switch(r.label){case 0:return this.analyser.getFloatFrequencyData(this.freqData),this.freqData[0]===-1/0?[2]:(this.freqDataQueue.push(this.freqData.slice(0,this.columnTruncateLength)),this.includeRawAudio&&(this.analyser.getFloatTimeDomainData(this.timeData),this.timeDataQueue.push(this.timeData.slice())),this.freqDataQueue.length>this.numFrames&&this.freqDataQueue.shift(),this.tracker.tick()?(t=Jc(this.freqDataQueue),e=Zc(t,[1,this.numFrames,this.columnTruncateLength,1]),n=void 0,this.includeRawAudio&&(s=Jc(this.timeDataQueue),n=Zc(s,[1,this.numFrames*this.fftSize])),[4,this.spectrogramCallback(e,n)]):[3,2]);case 1:r.sent()&&this.tracker.suppress(),ke([e,n]),r.label=2;case 2:return[2]}}))}))},t.prototype.stop=function(){return ai(this,void 0,void 0,(function(){return oi(this,(function(t){if(null==this.frameIntervalTask)throw new Error("Cannot stop because there is no ongoing streaming activity.");return clearInterval(this.frameIntervalTask),this.frameIntervalTask=null,this.analyser.disconnect(),this.audioContext.close(),null!=this.stream&&this.stream.getTracks().length>0&&this.stream.getTracks()[0].stop(),[2]}))}))},t.prototype.setConfig=function(t){throw new Error("setConfig() is not implemented for BrowserFftFeatureExtractor.")},t.prototype.getFeatures=function(){throw new Error("getFeatures() is not implemented for BrowserFftFeatureExtractor. Use the spectrogramCallback field of the constructor config instead.")},t}();function Jc(t){var e=t[0].length,n=new Float32Array(t.length*e);return t.forEach((function(t,s){return n.set(t,s*e)})),n}function Zc(t,e){var n=new Float32Array(h(e));return n.set(t,n.length-t.length),St(n,e)}var Xc,Yc=function(){function t(t,e){var n=this;this.period=t,this.suppressionTime=null==e?0:e,this.counter=0,a(this.period>0,(function(){return"Expected period to be positive, but got "+n.period}))}return t.prototype.tick=function(){return this.counter++,this.counter%this.period==0&&(null==this.suppressionOnset||this.counter-this.suppressionOnset>this.suppressionTime)},t.prototype.suppress=function(){this.suppressionOnset=this.counter},t}();function Qc(t,e,n=new Map,s=new Set){if(null==t)return null;if(s.has(t))throw new Error("Circular references are not supported.");if(n.has(t))return n.get(t);const r=e(t);if(r.recurse&&null!==r.value)throw new Error("A deep map function may not return both a value and recurse=true.");if(r.recurse){if(sp(t)){const r=Array.isArray(t)?[]:{};s.add(t);for(const i in t){const a=Qc(t[i],e,n,s);r[i]=a}return s.delete(t),r}throw new Error("Can't recurse into non-iterable type: "+t)}return n.set(t,r.value),r.value}function tp(t,e=ep){return function t(e,n,s=new Set){const r=e[0];if(s.has(r))throw new Error("Circular references are not supported.");const i=n(e);if(i.recurse&&null!==i.value)throw new Error("A deep zip function may not return both a value and recurse=true.");if(i.recurse){if(sp(r)){const i=Array.isArray(r)?[]:{};s.add(r);for(const a in r){const r=e.map(t=>t[a]),o=t(r,n,s);i[a]=o}return s.delete(r),i}throw new Error("Can't recurse into non-iterable type: "+r)}return i.value}(t,e)}function ep(t){return null===t?null:sp(t[0])?{value:null,recurse:!0}:{value:t,recurse:!1}}async function np(t,e){const n=new Map;Qc(t,e,n);for(const t of Array.from(n.keys())){const e=n.get(t);if(N(e)){const s=await e;n.set(t,s)}}return Qc(t,e,n)}function sp(t){return null!=t&&!ArrayBuffer.isView(t)&&(Array.isArray(t)||"object"==typeof t&&!(t instanceof X))}function rp(t){return Qc(t,ip)}function ip(t){return t instanceof X?{value:t.clone(),recurse:!1}:sp(t)?{value:null,recurse:!0}:{value:t,recurse:!1}}class ap{constructor(t){if(this.capacity=t,this.begin=0,this.end=0,null==t)throw new RangeError("Can't create a ring buffer of unknown capacity.");if(t<1)throw new RangeError("Can't create ring buffer of capacity < 1.");this.data=new Array(t),this.doubledCapacity=2*t}wrap(t){for(;t<0;)t+=this.doubledCapacity;return t%this.doubledCapacity}get(t){if(t<0)throw new RangeError("Can't get item at a negative index.");return this.data[t%this.capacity]}set(t,e){if(t<0)throw new RangeError("Can't set item at a negative index.");this.data[t%this.capacity]=e}length(){let t=this.end-this.begin;return t<0&&(t=this.doubledCapacity+t),t}isFull(){return this.length()===this.capacity}isEmpty(){return 0===this.length()}push(t){if(this.isFull())throw new RangeError("Ring buffer is full.");this.set(this.end,t),this.end=this.wrap(this.end+1)}pushAll(t){for(const e of t)this.push(e)}pop(){if(this.isEmpty())throw new RangeError("Ring buffer is empty.");this.end=this.wrap(this.end-1);const t=this.get(this.end);return this.set(this.end,void 0),t}unshift(t){if(this.isFull())throw new RangeError("Ring buffer is full.");this.begin=this.wrap(this.begin-1),this.set(this.begin,t)}shift(){if(this.isEmpty())throw new RangeError("Ring buffer is empty.");const t=this.get(this.begin);return this.set(this.begin,void 0),this.begin=this.wrap(this.begin+1),t}shuffleExcise(t){if(this.isEmpty())throw new RangeError("Ring buffer is empty.");const e=this.wrap(this.begin+t),n=this.get(e);return this.set(e,this.pop()),n}}class op extends ap{constructor(){super(op.INITIAL_CAPACITY)}isFull(){return!1}push(t){super.isFull()&&this.expand(),super.push(t)}unshift(t){super.isFull()&&this.expand(),super.unshift(t)}expand(){const t=2*this.capacity,e=new Array(t),n=this.length();for(let t=0;t<n;t++)e[t]=this.get(this.wrap(this.begin+t));this.data=e,this.capacity=t,this.doubledCapacity=2*this.capacity,this.begin=0,this.end=n}}function lp(t){return new hp(t)}op.INITIAL_CAPACITY=32;class up{async toArray(){const t=[];let e=await this.next();for(;!e.done;)t.push(e.value),e=await this.next();return t}async toArrayForTest(){const t=this.prefetch(100),e=[];let n=await t.next();for(;!n.done;)e.push(n.value),n=await t.next();return e}async resolveFully(){let t=await this.next();for(;!t.done;)t=await this.next()}async resolveWhile(t){let e=await this.next(),n=t(e.value);for(;!e.done&&n;)e=await this.next(),n=t(e.value)}handleErrors(t){return new bp(this,t)}filter(t){return new gp(this,t)}map(t){return new yp(this,t)}mapAsync(t){return new wp(this,t)}serialMapAsync(t){return new wp(this,t).serial()}flatmap(t){return new kp(this,t)}async forEachAsync(t){return this.map(t).resolveFully()}async serialForEach(t){return this.serialMapAsync(t).resolveWhile(t=>!0===t)}rowMajorBatch(t,e=!0){return new mp(this,t,e)}columnMajorBatch(t,e=!0,n=ep){return this.rowMajorBatch(t,e).map(t=>tp(t,n))}concatenate(t,e){return new xp(lp([this,t]),e)}take(t){return t<0||null==t?this:new fp(this,t)}skip(t){return t<0||null==t?this:new dp(this,t)}prefetch(t){return new Ip(this,t)}shuffle(t,e){return new Np(this,t,e)}serial(){return new pp(this)}}class hp extends up{constructor(t){super(),this.items=t,this.trav=0}summary(){return`Array of ${this.items.length} items`}async next(){if(this.trav>=this.items.length)return{value:null,done:!0};const t=this.items[this.trav];return this.trav++,{value:rp(t),done:!1}}}class cp extends up{constructor(t){super(),this.nextFn=t}summary(){return"Function call"}async next(){try{return this.nextFn()}catch(t){throw t.message="Error thrown while iterating through a dataset: "+t.message,t}}}class pp extends up{constructor(t){super(),this.upstream=t,this.lastRead=Promise.resolve({value:null,done:!1})}summary(){return this.upstream.summary()+" -> Serial"}async next(){return this.lastRead=this.lastRead.then(()=>this.serialNext()),this.lastRead}async serialNext(){return this.upstream.next()}}class dp extends up{constructor(t,e){super(),this.upstream=t,this.maxCount=e,this.count=0,this.lastRead=Promise.resolve({value:null,done:!1})}summary(){return this.upstream.summary()+" -> Skip"}async next(){return this.lastRead=this.lastRead.then(()=>this.serialNext()),this.lastRead}async serialNext(){for(;this.count++<this.maxCount;){const t=await this.upstream.next();if(t.done)return t;ke(t.value)}return this.upstream.next()}}class fp extends up{constructor(t,e){super(),this.upstream=t,this.maxCount=e,this.count=0}summary(){return this.upstream.summary()+" -> Take"}async next(){return this.count++>=this.maxCount?{value:null,done:!0}:this.upstream.next()}}class mp extends up{constructor(t,e,n=!0){super(),this.upstream=t,this.batchSize=e,this.enableSmallLastBatch=n,this.lastRead=Promise.resolve({value:null,done:!1})}summary(){return this.upstream.summary()+" -> RowMajorBatch"}async next(){return this.lastRead=this.lastRead.then(()=>this.serialNext()),this.lastRead}async serialNext(){const t=[];for(;t.length<this.batchSize;){const e=await this.upstream.next();if(e.done)return this.enableSmallLastBatch&&t.length>0?{value:t,done:!1}:{value:null,done:!0};t.push(e.value)}return{value:t,done:!1}}}class gp extends up{constructor(t,e){super(),this.upstream=t,this.predicate=e,this.lastRead=Promise.resolve({value:null,done:!1})}summary(){return this.upstream.summary()+" -> Filter"}async next(){return this.lastRead=this.lastRead.then(()=>this.serialNext()),this.lastRead}async serialNext(){for(;;){const t=await this.upstream.next();if(t.done||this.predicate(t.value))return t;ke(t.value)}}}class yp extends up{constructor(t,e){super(),this.upstream=t,this.transform=e}summary(){return this.upstream.summary()+" -> Map"}async next(){const t=await this.upstream.next();if(t.done)return{value:null,done:!0};const e=lt(t.value),n=this.transform(t.value),s=lt(n);for(const t of e)ot(t,s)||t.dispose();return{value:n,done:!1}}}class bp extends up{constructor(t,e){super(),this.upstream=t,this.handler=e,this.count=0,this.lastRead=Promise.resolve({value:null,done:!1})}summary(){return this.upstream.summary()+" -> handleErrors"}async next(){return this.lastRead=this.lastRead.then(()=>this.serialNext()),this.lastRead}async serialNext(){for(;;)try{return await this.upstream.next()}catch(t){if(!this.handler(t))return{value:null,done:!0}}}}class wp extends up{constructor(t,e){super(),this.upstream=t,this.transform=e}summary(){return this.upstream.summary()+" -> AsyncMap"}async next(){const t=await this.upstream.next();if(t.done)return{value:null,done:!0};const e=lt(t.value),n=await this.transform(t.value),s=lt(n);for(const t of e)ot(t,s)||t.dispose();return{value:n,done:!1}}}class vp extends up{constructor(){super(),this.outputQueue=new op,this.lastRead=Promise.resolve({value:null,done:!1})}async next(){return this.lastRead=this.lastRead.then(()=>this.serialNext()),this.lastRead}async serialNext(){for(;0===this.outputQueue.length();)if(!await this.pump())return{value:null,done:!0};return{value:this.outputQueue.shift(),done:!1}}}class kp extends vp{constructor(t,e){super(),this.upstream=t,this.transform=e}summary(){return this.upstream.summary()+" -> Flatmap"}async pump(){const t=await this.upstream.next();if(t.done)return!1;const e=lt(t.value),n=this.transform(t.value),s=lt(n);this.outputQueue.pushAll(n);for(const t of e)ot(t,s)||t.dispose();return!0}}class xp extends up{constructor(t,e){super(),this.baseErrorHandler=e,this.lastRead=null,this.iterator=null,this.moreIterators=t}summary(){return"TODO: fill in upstream of chained summaries -> Chained"}async next(){return this.lastRead=this.readFromChain(this.lastRead),this.lastRead}async readFromChain(t){if(await t,null==this.iterator){const t=await this.moreIterators.next();if(t.done)return{value:null,done:!0};this.iterator=t.value,null!=this.baseErrorHandler&&(this.iterator=this.iterator.handleErrors(this.baseErrorHandler))}const e=await this.iterator.next();return e.done?(this.iterator=null,this.readFromChain(t)):e}}!function(t){t[t.FAIL=0]="FAIL",t[t.SHORTEST=1]="SHORTEST",t[t.LONGEST=2]="LONGEST"}(Xc||(Xc={}));class Sp extends up{constructor(t,e=Xc.FAIL){super(),this.iterators=t,this.mismatchMode=e,this.count=0,this.currentPromise=null}summary(){return"{TODO: fill in upstream of zip summaries} -> Zip"}async nextState(t){await t;let e=0,n=0;const s=await np(this.iterators,(function(t){if(t instanceof up){return{value:t.next().then(t=>(e++,t.done&&n++,t.value)),recurse:!1}}return{value:null,recurse:!0}}));if(e===n)return{value:null,done:!0};if(n>0)switch(this.mismatchMode){case Xc.FAIL:throw new Error(`Zipped streams should have the same length. Mismatched at element ${this.count}.`);case Xc.SHORTEST:return{value:null,done:!0};case Xc.LONGEST:}return this.count++,{value:s,done:!1}}async next(){return this.currentPromise=this.nextState(this.currentPromise),this.currentPromise}}class Ip extends up{constructor(t,e){super(),this.upstream=t,this.bufferSize=e,this.buffer=new ap(e)}summary(){return this.upstream.summary()+" -> Prefetch"}refill(){for(;!this.buffer.isFull();){const t=this.upstream.next();this.buffer.push(t)}}next(){return this.refill(),this.buffer.shift()}}class Np extends Ip{constructor(t,e,n){super(t,e),this.upstream=t,this.windowSize=e,this.upstreamExhausted=!1,this.random=Ws(n||B().toString()),this.lastRead=Promise.resolve({value:null,done:!1})}async next(){return this.lastRead=this.lastRead.then(()=>this.serialNext()),this.lastRead}randomInt(t){return Math.floor(this.random()*t)}chooseIndex(){return this.randomInt(this.buffer.length())}async serialNext(){for(this.upstreamExhausted||this.refill();!this.buffer.isEmpty();){const t=this.chooseIndex(),e=await this.buffer.shuffleExcise(t);if(!e.done)return this.refill(),e;this.upstreamExhausted=!0}return{value:null,done:!0}}}class Ap{constructor(){this.size=null}batch(t,e=!0){const n=this;let s;return a(t>0,()=>"batchSize needs to be positive, but it is\n      "+t),s=this.size===1/0||null==this.size?this.size:e?Math.ceil(this.size/t):Math.floor(this.size/t),Ep(async()=>(await n.iterator()).columnMajorBatch(t,e,zp),s)}concatenate(t){const e=this;let n;return n=this.size===1/0||t.size===1/0?1/0:null!=this.size&&null!=t.size?this.size+t.size:null,Ep(async()=>(await e.iterator()).concatenate(await t.iterator()),n)}filter(t){const e=this;let n;return n=this.size===1/0?1/0:null,Ep(async()=>(await e.iterator()).filter(e=>ve(()=>t(e))),n)}async forEachAsync(t){return(await this.iterator()).forEachAsync(t)}map(t){const e=this;return Ep(async()=>(await e.iterator()).map(e=>ve(()=>t(e))),this.size)}mapAsync(t){const e=this;return Ep(async()=>(await e.iterator()).mapAsync(t),this.size)}prefetch(t){if(null==t)throw new RangeError("`Dataset.prefetch()` requires bufferSize to be specified.");const e=this;return Ep(async()=>(await e.iterator()).prefetch(t),this.size)}repeat(t){const e=this;let n;return n=null!=this.size&&t>0?this.size*t:0===t?0:null!=this.size&&(void 0===t||t<0)?1/0:null,Ep(async()=>{const n=new cp(async()=>({value:await e.iterator(),done:!1}));var s,r;return s=n.take(t),new xp(s,r)},n)}skip(t){const e=this;let n;return n=null!=this.size&&t>=0&&this.size>=t?this.size-t:null!=this.size&&(this.size<t||void 0===t||t<0)?0:null,Ep(async()=>(await e.iterator()).skip(t),n)}shuffle(t,e,n=!0){if(null==t||t<0)throw null==this.size?new RangeError("`Dataset.shuffle()` requires bufferSize to be specified."):new RangeError(`\`Dataset.shuffle()\` requires bufferSize to be specified.  If your data fits in main memory (for regular JS objects), and/or GPU memory (for \`tf.Tensor\`s), consider setting bufferSize to the dataset size (${this.size} elements)`);const s=this,r=Ws(e||B().toString());return Ep(async()=>{let e=r.int32();return n&&(e+=r.int32()),(await s.iterator()).shuffle(t,e.toString())},this.size)}take(t){const e=this;let n;return n=null!=this.size&&this.size>t?t:null!=this.size&&this.size<=t?this.size:null,Ep(async()=>(await e.iterator()).take(t),n)}async toArray(){if(this.size===1/0)throw new Error("Can not convert infinite data stream to array.");return(await this.iterator()).toArray()}async toArrayForTest(){if(this.size===1/0)throw new Error("Can not convert infinite data stream to array.");return(await this.iterator()).toArrayForTest()}}function Ep(t,e=null){return new class extends Ap{constructor(){super(...arguments),this.size=e}async iterator(){return t()}}}function Tp(t){return Ep(async()=>lp(t),t.length)}function Dp(t){if(!sp(t))throw new Error("The argument to zip() must be an object or array.");let e;if(Array.isArray(t))for(let n=0;n<t.length;n++)e=null==e?t[n].size:Math.min(e,t[n].size);else if(t instanceof Object)for(const n in t)e=null==e?t[n].size:Math.min(e,t[n].size);return Ep(async()=>function(t,e=Xc.FAIL){return new Sp(t,e)}(await np(t,t=>{if(t instanceof Ap)return{value:t.iterator(),recurse:!1};if(sp(t))return{value:null,recurse:!0};throw new Error("Leaves of the structure passed to zip() must be Datasets, not primitives.")}),Xc.SHORTEST),e)}function zp(t){if(null===t)return null;const e=t[0];if(null==(n=e)||null===(s=n)||"object"!=typeof s&&"function"!=typeof s||Array.isArray(n)||"object"==typeof n&&n instanceof X||m(n)){return{value:function(t){if(0===t.length)throw new Error("Can't make a batch of zero elements.");return t[0]instanceof X?vr(t):St(t)}(t),recurse:!1}}var n,s;return{value:null,recurse:!0}}Ap.MAX_BUFFER_SIZE=1e4;var Cp=Ms((function(t,e){var s=n.Buffer;function r(t,e){for(var n in t)e[n]=t[n]}function i(t,e,n){return s(t,e,n)}s.from&&s.alloc&&s.allocUnsafe&&s.allocUnsafeSlow?t.exports=n:(r(n,e),e.Buffer=i),r(s,i),i.from=function(t,e,n){if("number"==typeof t)throw new TypeError("Argument must not be a number");return s(t,e,n)},i.alloc=function(t,e,n){if("number"!=typeof t)throw new TypeError("Argument must be a number");var r=s(t);return void 0!==e?"string"==typeof n?r.fill(e,n):r.fill(e):r.fill(0),r},i.allocUnsafe=function(t){if("number"!=typeof t)throw new TypeError("Argument must be a number");return s(t)},i.allocUnsafeSlow=function(t){if("number"!=typeof t)throw new TypeError("Argument must be a number");return n.SlowBuffer(t)}})),Fp=(Cp.Buffer,Cp.Buffer),Rp=Fp.isEncoding||function(t){switch((t=""+t)&&t.toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":case"raw":return!0;default:return!1}};function Mp(t){var e;switch(this.encoding=function(t){var e=function(t){if(!t)return"utf8";for(var e;;)switch(t){case"utf8":case"utf-8":return"utf8";case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return"utf16le";case"latin1":case"binary":return"latin1";case"base64":case"ascii":case"hex":return t;default:if(e)return;t=(""+t).toLowerCase(),e=!0}}(t);if("string"!=typeof e&&(Fp.isEncoding===Rp||!Rp(t)))throw new Error("Unknown encoding: "+t);return e||t}(t),this.encoding){case"utf16le":this.text=$p,this.end=Op,e=4;break;case"utf8":this.fillLast=_p,e=4;break;case"base64":this.text=Bp,this.end=Pp,e=3;break;default:return this.write=Up,void(this.end=Wp)}this.lastNeed=0,this.lastTotal=0,this.lastChar=Fp.allocUnsafe(e)}function Lp(t){return t<=127?0:t>>5==6?2:t>>4==14?3:t>>3==30?4:t>>6==2?-1:-2}function _p(t){var e=this.lastTotal-this.lastNeed,n=function(t,e,n){if(128!=(192&e[0]))return t.lastNeed=0,"�";if(t.lastNeed>1&&e.length>1){if(128!=(192&e[1]))return t.lastNeed=1,"�";if(t.lastNeed>2&&e.length>2&&128!=(192&e[2]))return t.lastNeed=2,"�"}}(this,t);return void 0!==n?n:this.lastNeed<=t.length?(t.copy(this.lastChar,e,0,this.lastNeed),this.lastChar.toString(this.encoding,0,this.lastTotal)):(t.copy(this.lastChar,e,0,t.length),void(this.lastNeed-=t.length))}function $p(t,e){if((t.length-e)%2==0){var n=t.toString("utf16le",e);if(n){var s=n.charCodeAt(n.length-1);if(s>=55296&&s<=56319)return this.lastNeed=2,this.lastTotal=4,this.lastChar[0]=t[t.length-2],this.lastChar[1]=t[t.length-1],n.slice(0,-1)}return n}return this.lastNeed=1,this.lastTotal=2,this.lastChar[0]=t[t.length-1],t.toString("utf16le",e,t.length-1)}function Op(t){var e=t&&t.length?this.write(t):"";if(this.lastNeed){var n=this.lastTotal-this.lastNeed;return e+this.lastChar.toString("utf16le",0,n)}return e}function Bp(t,e){var n=(t.length-e)%3;return 0===n?t.toString("base64",e):(this.lastNeed=3-n,this.lastTotal=3,1===n?this.lastChar[0]=t[t.length-1]:(this.lastChar[0]=t[t.length-2],this.lastChar[1]=t[t.length-1]),t.toString("base64",e,t.length-n))}function Pp(t){var e=t&&t.length?this.write(t):"";return this.lastNeed?e+this.lastChar.toString("base64",0,3-this.lastNeed):e}function Up(t){return t.toString(this.encoding)}function Wp(t){return t&&t.length?this.write(t):""}function jp(t){var e=0;t.forEach((function(t){e+=t.byteLength}));var n=new Uint8Array(e),s=0;return t.forEach((function(t){n.set(new Uint8Array(t),s),s+=t.byteLength})),n.buffer}function qp(t){var e=0;t.forEach((function(t){return e+=t.length}));var n=new Float32Array(e),s=0;return t.forEach((function(t){n.set(t,s),s+=t.length})),n}function Kp(t){if(null==t)throw new Error("Received null or undefind string");for(var e=unescape(encodeURIComponent(t)),n=new Uint8Array(e.length),s=0;s<e.length;++s)n[s]=e.charCodeAt(s);return n.buffer}function Vp(t){if(null==t)throw new Error("Received null or undefind buffer");var e=new Uint8Array(t);return decodeURIComponent(escape(String.fromCharCode.apply(String,hi(e))))}Mp.prototype.write=function(t){if(0===t.length)return"";var e,n;if(this.lastNeed){if(void 0===(e=this.fillLast(t)))return"";n=this.lastNeed,this.lastNeed=0}else n=0;return n<t.length?e?e+this.text(t,n):this.text(t,n):e||""},Mp.prototype.end=function(t){var e=t&&t.length?this.write(t):"";return this.lastNeed?e+"�":e},Mp.prototype.text=function(t,e){var n=function(t,e,n){var s=e.length-1;if(s<n)return 0;var r=Lp(e[s]);if(r>=0)return r>0&&(t.lastNeed=r-1),r;if(--s<n||-2===r)return 0;if((r=Lp(e[s]))>=0)return r>0&&(t.lastNeed=r-2),r;if(--s<n||-2===r)return 0;if((r=Lp(e[s]))>=0)return r>0&&(2===r?r=0:t.lastNeed=r-3),r;return 0}(this,t,e);if(!this.lastNeed)return t.toString("utf8",e);this.lastTotal=n;var s=t.length-(n-this.lastNeed);return t.copy(this.lastChar,0,s),t.toString("utf8",e,s)},Mp.prototype.fillLast=function(t){if(this.lastNeed<=t.length)return t.copy(this.lastChar,this.lastTotal-this.lastNeed,0,this.lastNeed),this.lastChar.toString(this.encoding,0,this.lastTotal);t.copy(this.lastChar,this.lastTotal-this.lastNeed,0,t.length),this.lastNeed-=t.length};var Hp=function(){function t(t){if(this.examples={},this.label2Ids={},null!=t)for(var e=function(t){a(null!=t,(function(){return"Received null or undefined buffer"}));var e=0;a("TFJSSCDS"===Vp(t.slice(e,"TFJSSCDS".length)),(function(){return"Deserialization error: Invalid descriptor"})),e+="TFJSSCDS".length,e+=4;var n=new Uint32Array(t,e,1),s=e+=4;e=s+n[0];var r=Vp(t.slice(s,e)),i=JSON.parse(r),o=t.slice(e);return{manifest:i,data:o}}(t),n=0,s=0;s<e.manifest.length;++s){var r=e.manifest[s],i=r.spectrogramNumFrames*r.spectrogramFrameSize;null!=r.rawAudioNumSamples&&(i+=r.rawAudioNumSamples),i*=4,this.addExample(Jp({spec:r,data:e.data.slice(n,n+i)})),n+=i}}return t.prototype.addExample=function(t){a(null!=t,(function(){return"Got null or undefined example"})),a(null!=t.label&&t.label.length>0,(function(){return"Expected label to be a non-empty string, but got "+JSON.stringify(t.label)}));var e=function(){function t(){return Math.floor(65536*(1+Math.random())).toString(16).substring(1)}return t()+t()+"-"+t()+"-"+t()+"-"+t()+"-"+t()+t()+t()}();return this.examples[e]=t,t.label in this.label2Ids||(this.label2Ids[t.label]=[]),this.label2Ids[t.label].push(e),e},t.prototype.merge=function(t){var e,n,s,r;a(t!==this,(function(){return"Cannot merge a dataset into itself"}));var i=t.getVocabulary();try{for(var o=li(i),l=o.next();!l.done;l=o.next()){var u=l.value,h=t.getExamples(u);try{for(var c=(s=void 0,li(h)),p=c.next();!p.done;p=c.next()){var d=p.value;this.addExample(d.example)}}catch(t){s={error:t}}finally{try{p&&!p.done&&(r=c.return)&&r.call(c)}finally{if(s)throw s.error}}}}catch(t){e={error:t}}finally{try{l&&!l.done&&(n=o.return)&&n.call(o)}finally{if(e)throw e.error}}},t.prototype.getExampleCounts=function(){var t={};for(var e in this.examples){var n=this.examples[e];n.label in t||(t[n.label]=0),t[n.label]++}return t},t.prototype.getExamples=function(t){var e=this;a(null!=t,(function(){return"Expected label to be a string, but got "+JSON.stringify(t)})),a(t in this.label2Ids,(function(){return'No example of label "'+t+'" exists in dataset'}));var n=[];return this.label2Ids[t].forEach((function(t){n.push({uid:t,example:e.examples[t]})})),n},t.prototype.getData=function(t,e){var n=this;a(this.size()>0,(function(){return"Cannot get spectrograms as tensors because the dataset is empty"}));var s=this.getVocabulary();null!=t?a(-1!==s.indexOf(t),(function(){return"Label "+t+" is not in the vocabulary ("+JSON.stringify(s)+")"})):a(s.length>1,(function(){return"One-hot encoding of labels requires the vocabulary to have at least two words, but it has only "+s.length+" word."})),null==e&&(e={});var r,o,l=this.getSortedUniqueNumFrames();1===l.length?(r=null==e.numFrames?l[0]:e.numFrames,o=null==e.hopFrames?1:e.hopFrames):(a(null!=(r=e.numFrames)&&Number.isInteger(r)&&r>0,(function(){return"There are "+l.length+" unique lengths among the "+n.size()+" examples of this Dataset, hence numFrames is required. But it is not provided."})),a(r<=l[0],(function(){return"numFrames ("+r+") exceeds the minimum numFrames ("+l[0]+") among the examples of the Dataset."})),a(null!=(o=e.hopFrames)&&Number.isInteger(o)&&o>0,(function(){return"There are "+l.length+" unique lengths among the "+n.size()+" examples of this Dataset, hence hopFrames is required. But it is not provided."})));var u=null==e.normalize||e.normalize;return ve((function(){for(var l,h,c,p=[],d=[],f=[],m=0;m<s.length;++m){var g=s[m];if(null==t||g===t){var y=n.label2Ids[g],b=function(s){var i,l,h=n.examples[s].spectrogram,y=h.frameSize;null==c?c=y:a(y===c,(function(){return"Mismatch in frameSize  ("+y+" vs "+c+")"}));var b=h.data.length/y,w=null;"_background_noise_"!==g&&(w=null==h.keyFrameIndex?Yp(h).dataSync()[0]:h.keyFrameIndex);var v=me(h.data,[b,y,1]),k=Zp(b,w,r,o),x=function(n){var s=ve((function(){var t=Xe(v,[n[0],0,0],[n[1]-n[0],-1,-1]);return u?Kc(t):t}));e.getDataset?d.push(s.dataSync()):p.push(s),null==t&&f.push(m)};try{for(var S=(i=void 0,li(k)),I=S.next();!I.done;I=S.next()){x(I.value)}}catch(t){i={error:t}}finally{try{I&&!I.done&&(l=S.return)&&l.call(S)}finally{if(i)throw i.error}}ke(v)};try{for(var w=(l=void 0,li(y)),v=w.next();!v.done;v=w.next()){b(v.value)}}catch(t){l={error:t}}finally{try{v&&!v.done&&(h=w.return)&&h.call(w)}finally{if(l)throw l.error}}}}null!=e.augmentByMixingNoiseRatio&&n.augmentByMixingNoise(e.getDataset?d:p,f,e.augmentByMixingNoiseRatio);var k=null==e.shuffle||e.shuffle;if(e.getDataset){var x=null==e.datasetBatchSize?32:e.datasetBatchSize,S=null==e.datasetValidationSplit?.15:e.datasetValidationSplit;a(S>0&&S<1,(function(){return"Invalid dataset validation split: "+S}));var I=d.map((function(t,e){return[t,f[e]]}));i(I),d=I.map((function(t){return t[0]}));var N=I.map((function(t){return t[1]})),A=function(t,e,n){var s,r,o,l,u,h,c,p;a(n>0&&n<1,(function(){return"validationSplit is expected to be >0 and <1, but got "+n}));for(var d=!Array.isArray(t[0]),f=e,m=[],g=0;g<f.length;++g){var y=f[g];null==m[y]&&(m[y]=[]),m[y].push(g)}var b=m.length,w=[],v=[];for(m.map((function(t){return i(t)})),g=0;g<b;++g)for(var k=m[g],x=Math.round(k.length*(1-n)),S=0;S<k.length;++S)S<x?w.push(k[S]):v.push(k[S]);if(d){var I=[],N=[],A=[],E=[];try{for(var T=li(w),D=T.next();!D.done;D=T.next()){var z=D.value;I.push(t[z]),N.push(e[z])}}catch(t){s={error:t}}finally{try{D&&!D.done&&(r=T.return)&&r.call(T)}finally{if(s)throw s.error}}try{for(var C=li(v),F=C.next();!F.done;F=C.next()){z=F.value;A.push(t[z]),E.push(e[z])}}catch(t){o={error:t}}finally{try{F&&!F.done&&(l=C.return)&&l.call(C)}finally{if(o)throw o.error}}return{trainXs:I,trainYs:N,valXs:A,valYs:E}}I=[],N=[],A=[],E=[];try{for(var R=li(w),M=R.next();!M.done;M=R.next()){z=M.value;I.push(t[z]),N.push(e[z])}}catch(t){u={error:t}}finally{try{M&&!M.done&&(h=R.return)&&h.call(R)}finally{if(u)throw u.error}}try{for(var L=li(v),_=L.next();!_.done;_=L.next()){z=_.value;A.push(t[z]),E.push(e[z])}}catch(t){c={error:t}}finally{try{_&&!_.done&&(p=L.return)&&p.call(L)}finally{if(c)throw c.error}}return{trainXs:I,trainYs:N,valXs:A,valYs:E}}(d,N,S),E=A.trainXs,T=A.trainYs,D=A.valXs,z=A.valYs,C=Dp({xs:Tp(E).map((function(t){return me(t,[r,c,1])})),ys:Tp(T).map((function(t){return wr(de([t],s.length),[0])}))});k&&(C=C.shuffle(d.length)),C=C.batch(x).prefetch(4);var F=Dp({xs:Tp(D).map((function(t){return me(t,[r,c,1])})),ys:Tp(z).map((function(t){return wr(de([t],s.length),[0])}))});return[C,F=F.batch(x).prefetch(4)]}if(k){var R=[];p.forEach((function(t,e){R.push({x:t,y:f[e]})})),i(R),p=R.map((function(t){return t.x})),f=R.map((function(t){return t.y}))}var M=null==t?se(de(Ir(f,"int32"),s.length),"float32"):void 0;return{xs:vr(p),ys:M}}))},t.prototype.augmentByMixingNoise=function(t,e,n){var s,r;if(null==t||0===t.length)throw new Error("Cannot perform augmentation because data is null or empty");for(var i=t[0]instanceof Float32Array,a=this.getVocabulary(),o=[],l=[],u=0;u<e.length;++u)"_background_noise_"===a[e[u]]?o.push(u):l.push(u);if(0===o.length)throw new Error("Cannot perform augmentation by mixing with noise when there is no example with label _background_noise_");var h=[],c=[],p=function(s){var r=o[function(t,e){return Math.floor((e-t)*Math.random())+t}(0,o.length)],a=i?Ir(t[s]):t[s],l=i?Ir(t[r]):t[r],u=ve((function(){return Kc(Ie(a,Ee(l,n)))}));i?h.push(u.dataSync()):h.push(u),c.push(e[s])};try{for(var d=li(l),f=d.next();!f.done;f=d.next()){p(f.value)}}catch(t){s={error:t}}finally{try{f&&!f.done&&(r=d.return)&&r.call(d)}finally{if(s)throw s.error}}console.log("Data augmentation: mixing noise: added "+h.length+" examples"),h.forEach((function(e){return t.push(e)})),e.push.apply(e,hi(c))},t.prototype.getSortedUniqueNumFrames=function(){for(var t,e,n=new Set,s=this.getVocabulary(),r=0;r<s.length;++r){var i=s[r],a=this.label2Ids[i];try{for(var o=(t=void 0,li(a)),l=o.next();!l.done;l=o.next()){var u=l.value,h=this.examples[u].spectrogram,c=h.data.length/h.frameSize;n.add(c)}}catch(e){t={error:e}}finally{try{l&&!l.done&&(e=o.return)&&e.call(o)}finally{if(t)throw t.error}}}var p=hi(n);return p.sort(),p},t.prototype.removeExample=function(t){if(!(t in this.examples))throw new Error("Nonexistent example UID: "+t);var e=this.examples[t].label;delete this.examples[t];var n=this.label2Ids[e].indexOf(t);this.label2Ids[e].splice(n,1),0===this.label2Ids[e].length&&delete this.label2Ids[e]},t.prototype.setExampleKeyFrameIndex=function(t,e){if(!(t in this.examples))throw new Error("Nonexistent example UID: "+t);var n=this.examples[t].spectrogram,s=n.data.length/n.frameSize;a(e>=0&&e<s&&Number.isInteger(e),(function(){return"Invalid keyFrameIndex: "+e+". Must be >= 0, < "+s+", and an integer."})),n.keyFrameIndex=e},t.prototype.size=function(){return Object.keys(this.examples).length},t.prototype.durationMillis=function(){var t=0;for(var e in this.examples){var n=this.examples[e].spectrogram,s=23.22|n.frameDurationMillis;t+=n.data.length/n.frameSize*s}return t},t.prototype.empty=function(){return 0===this.size()},t.prototype.clear=function(){this.examples={}},t.prototype.getVocabulary=function(){var t=new Set;for(var e in this.examples){var n=this.examples[e];t.add(n.label)}var s=hi(t);return s.sort(),s},t.prototype.serialize=function(t){var e,n,s,r,i=this.getVocabulary();a(!this.empty(),(function(){return"Cannot serialize empty Dataset"})),null!=t&&(Array.isArray(t)||(t=[t]),t.forEach((function(t){if(-1===i.indexOf(t))throw new Error('Word label "'+t+'" does not exist in the vocabulary of this dataset. The vocabulary is: '+JSON.stringify(i)+".")})));var o=[],l=[];try{for(var u=li(i),h=u.next();!h.done;h=u.next()){var c=h.value;if(null==t||-1!==t.indexOf(c)){var p=this.label2Ids[c];try{for(var d=(s=void 0,li(p)),f=d.next();!f.done;f=d.next()){var m=f.value,g=Gp(this.examples[m]);o.push(g.spec),l.push(g.data)}}catch(t){s={error:t}}finally{try{f&&!f.done&&(r=d.return)&&r.call(d)}finally{if(s)throw s.error}}}}}catch(t){e={error:t}}finally{try{h&&!h.done&&(n=u.return)&&n.call(u)}finally{if(e)throw e.error}}return function(t){var e=Kp(JSON.stringify(t.manifest)),n=Kp("TFJSSCDS"),s=new Uint32Array([1]),r=new Uint32Array([e.byteLength]),i=jp([n,s.buffer,r.buffer]);return jp([i,e,t.data])}({manifest:o,data:jp(l)})},t}();function Gp(t){var e=null!=t.rawAudio,n={label:t.label,spectrogramNumFrames:t.spectrogram.data.length/t.spectrogram.frameSize,spectrogramFrameSize:t.spectrogram.frameSize};null!=t.spectrogram.keyFrameIndex&&(n.spectrogramKeyFrameIndex=t.spectrogram.keyFrameIndex);var s=t.spectrogram.data.buffer.slice(0);return e&&(n.rawAudioNumSamples=t.rawAudio.data.length,n.rawAudioSampleRateHz=t.rawAudio.sampleRateHz,s=jp([s,t.rawAudio.data.buffer])),{spec:n,data:s}}function Jp(t){var e={frameSize:t.spec.spectrogramFrameSize,data:new Float32Array(t.data.slice(0,4*t.spec.spectrogramFrameSize*t.spec.spectrogramNumFrames))};null!=t.spec.spectrogramKeyFrameIndex&&(e.keyFrameIndex=t.spec.spectrogramKeyFrameIndex);var n={label:t.spec.label,spectrogram:e};return null!=t.spec.rawAudioNumSamples&&(n.rawAudio={sampleRateHz:t.spec.rawAudioSampleRateHz,data:new Float32Array(t.data.slice(4*t.spec.spectrogramFrameSize*t.spec.spectrogramNumFrames))}),n}function Zp(t,e,n,s){if(a(Number.isInteger(t)&&t>0,(function(){return"snippetLength must be a positive integer, but got "+t})),null!=e&&a(Number.isInteger(e)&&e>=0,(function(){return"focusIndex must be a non-negative integer, but got "+e})),a(Number.isInteger(n)&&n>0,(function(){return"windowLength must be a positive integer, but got "+n})),a(Number.isInteger(s)&&s>0,(function(){return"windowHop must be a positive integer, but got "+s})),a(n<=t,(function(){return"windowLength ("+n+") exceeds snippetLength ("+t+")"})),a(e<t,(function(){return"focusIndex ("+e+") equals or exceeds snippetLength ("+t+")"})),n===t)return[[0,t]];var r=[];if(null==e){for(var i=0;i+n<=t;)r.push([i,i+n]),i+=s;return r}var o=Math.floor(n/2),l=e-o;for(l<0?l=0:l+n>t&&(l=t-n);!(l-s<0||e>=l-s+n);)l-=s;for(;l+n<=t&&!(e<l);)r.push([l,l+n]),l+=s;return r}function Xp(t){return ve((function(){var e=t.data.length/t.frameSize,n=Nr(t.data,[e,t.frameSize]);return ys(n,-1)}))}function Yp(t){return ve((function(){return Re(Xp(t))}))}var Qp="tfjs-speech-commands-saved-model-metadata",td="indexeddb://tfjs-speech-commands-model/",ed={localStorage:"undefined"==typeof window?null:window.localStorage};var nd=function(){function t(e,n,s){this.MODEL_URL_PREFIX="https://storage.googleapis.com/tfjs-models/tfjs/speech-commands/v"+function(t){return t.split(".").slice(0,2).join(".")}("0.5.1")+"/browser_fft",this.SAMPLE_RATE_HZ=44100,this.FFT_SIZE=1024,this.DEFAULT_SUPPRESSION_TIME_MILLIS=0,this.streaming=!1,this.transferRecognizers={},a(null==n&&null==s||null!=n&&null!=s,(function(){return"modelURL and metadataURL must be both provided or both not provided."})),null==n?(null==e?e=t.DEFAULT_VOCABULARY_NAME:a(-1!==t.VALID_VOCABULARY_NAMES.indexOf(e),(function(){return"Invalid vocabulary name: '"+e+"'"})),this.vocabulary=e,this.modelArtifactsOrURL=this.MODEL_URL_PREFIX+"/"+this.vocabulary+"/model.json",this.metadataOrURL=this.MODEL_URL_PREFIX+"/"+this.vocabulary+"/metadata.json"):(a(null==e,(function(){return"vocabulary name must be null or undefined when modelURL is provided"})),this.modelArtifactsOrURL=n,this.metadataOrURL=s),this.parameters={sampleRateHz:this.SAMPLE_RATE_HZ,fftSize:this.FFT_SIZE}}return t.prototype.listen=function(t,e){return ai(this,void 0,void 0,(function(){var n,s,r,i,o,l=this;return oi(this,(function(u){switch(u.label){case 0:if(this.streaming)throw new Error("Cannot start streaming again when streaming is ongoing.");return[4,this.ensureModelLoaded()];case 1:if(u.sent(),null==e&&(e={}),n=null==e.probabilityThreshold?0:e.probabilityThreshold,e.includeEmbedding&&(n=0),a(n>=0&&n<=1,(function(){return"Invalid probabilityThreshold value: "+n})),s=null!=e.invokeCallbackOnNoiseAndUnknown&&e.invokeCallbackOnNoiseAndUnknown,e.includeEmbedding&&(s=!0),e.suppressionTimeMillis<0)throw new Error("suppressionTimeMillis is expected to be >= 0, but got "+e.suppressionTimeMillis);return a((r=null==e.overlapFactor?.5:e.overlapFactor)>=0&&r<1,(function(){return"Expected overlapFactor to be >= 0 and < 1, but got "+r})),i=function(r,i){return ai(l,void 0,void 0,(function(){var i,a,o,l,u,h,c,p,d,f,m;return oi(this,(function(g){switch(g.label){case 0:return i=Kc(r),e.includeEmbedding?[4,this.ensureModelWithEmbeddingOutputCreated()]:[3,2];case 1:return g.sent(),m=ui(this.modelWithEmbeddingOutput.predict(i),2),a=m[0],o=m[1],[3,3];case 2:a=this.model.predict(i),g.label=3;case 3:return[4,a.data()];case 4:return l=g.sent(),[4,(u=a.argMax(-1)).data()];case 5:return h=g.sent()[0],c=Math.max.apply(Math,hi(l)),ke([a,u,i]),c<n?[2,!1]:[3,6];case 6:return p=void 0,e.includeSpectrogram?(d={},[4,r.data()]):[3,8];case 7:d.data=g.sent(),d.frameSize=this.nonBatchInputShape[1],p=d,g.label=8;case 8:return f=!0,s||"_background_noise_"!==this.words[h]&&"_unknown_"!==this.words[h]||(f=!1),f&&t({scores:l,spectrogram:p,embedding:o}),[2,f]}}))}))},o=null==e.suppressionTimeMillis?this.DEFAULT_SUPPRESSION_TIME_MILLIS:e.suppressionTimeMillis,this.audioDataExtractor=new Gc({sampleRateHz:this.parameters.sampleRateHz,numFramesPerSpectrogram:this.nonBatchInputShape[0],columnTruncateLength:this.nonBatchInputShape[1],suppressionTimeMillis:o,spectrogramCallback:i,overlapFactor:r}),[4,this.audioDataExtractor.start(e.audioTrackConstraints)];case 2:return u.sent(),this.streaming=!0,[2]}}))}))},t.prototype.ensureModelLoaded=function(){return ai(this,void 0,void 0,(function(){var t,e,n,s,r=this;return oi(this,(function(i){switch(i.label){case 0:return null!=this.model?[2]:[4,this.ensureMetadataLoaded()];case 1:return i.sent(),"string"!=typeof this.modelArtifactsOrURL?[3,3]:[4,Uu(this.modelArtifactsOrURL)];case 2:return t=i.sent(),[3,5];case 3:return[4,Uu(ce(this.modelArtifactsOrURL.modelTopology,this.modelArtifactsOrURL.weightSpecs,this.modelArtifactsOrURL.weightData))];case 4:t=i.sent(),i.label=5;case 5:if(1!==t.inputs.length)throw new Error("Expected model to have 1 input, but got a model with "+t.inputs.length+" inputs");if(4!==t.inputs[0].shape.length)throw new Error("Expected model to have an input shape of rank 4, but got an input shape of rank "+t.inputs[0].shape.length);if(1!==t.inputs[0].shape[3])throw new Error("Expected model to have an input shape with 1 as the last dimension, but got input shape"+JSON.stringify(t.inputs[0].shape[3])+"}");if(2!==(e=t.outputShape).length)throw new Error("Expected loaded model to have an output shape of rank 2,but received shape "+JSON.stringify(e));if(e[1]!==this.words.length)throw new Error("Mismatch between the last dimension of model's output shape ("+e[1]+") and number of words ("+this.words.length+").");return this.model=t,this.freezeModel(),this.nonBatchInputShape=t.inputs[0].shape.slice(1),this.elementsPerExample=1,t.inputs[0].shape.slice(1).forEach((function(t){return r.elementsPerExample*=t})),this.warmUpModel(),n=this.parameters.fftSize/this.parameters.sampleRateHz*1e3,s=t.inputs[0].shape[1],this.parameters.spectrogramDurationMillis=s*n,[2]}}))}))},t.prototype.ensureModelWithEmbeddingOutputCreated=function(){return ai(this,void 0,void 0,(function(){var t,e;return oi(this,(function(n){switch(n.label){case 0:return null!=this.modelWithEmbeddingOutput?[2]:[4,this.ensureModelLoaded()];case 1:for(n.sent(),e=this.model.layers.length-2;e>=0;--e)if("Dense"===this.model.layers[e].getClassName()){t=this.model.layers[e];break}if(null==t)throw new Error("Failed to find second last dense layer in the original model.");return this.modelWithEmbeddingOutput=Pu({inputs:this.model.inputs,outputs:[this.model.outputs[0],t.output]}),[2]}}))}))},t.prototype.warmUpModel=function(){var t=this;ve((function(){for(var e=Ns([1].concat(t.nonBatchInputShape)),n=0;n<3;++n)t.model.predict(e)}))},t.prototype.ensureMetadataLoaded=function(){return ai(this,void 0,void 0,(function(){var t,e,n;return oi(this,(function(s){switch(s.label){case 0:return null!=this.words?[2]:"string"!=typeof this.metadataOrURL?[3,2]:[4,jc(this.metadataOrURL)];case 1:return e=s.sent(),[3,3];case 2:e=this.metadataOrURL,s.label=3;case 3:if(null==(t=e).wordLabels){if(null==(n=t.words))throw new Error('Cannot find field "words" or "wordLabels" in metadata JSON file');this.words=n}else this.words=t.wordLabels;return[2]}}))}))},t.prototype.stopListening=function(){return ai(this,void 0,void 0,(function(){return oi(this,(function(t){switch(t.label){case 0:if(!this.streaming)throw new Error("Cannot stop streaming when streaming is not ongoing.");return[4,this.audioDataExtractor.stop()];case 1:return t.sent(),this.streaming=!1,[2]}}))}))},t.prototype.isListening=function(){return this.streaming},t.prototype.wordLabels=function(){return this.words},t.prototype.params=function(){return this.parameters},t.prototype.modelInputShape=function(){if(null==this.model)throw new Error("Model has not been loaded yet. Load model by calling ensureModelLoaded(), recognize(), or listen().");return this.model.inputs[0].shape},t.prototype.recognize=function(t,e){return ai(this,void 0,void 0,(function(){var n,s,r,i,a,o,u,h,c,p,d,f,m;return oi(this,(function(g){switch(g.label){case 0:return null==e&&(e={}),[4,this.ensureModelLoaded()];case 1:return g.sent(),null!=t?[3,3]:[4,this.recognizeOnline()];case 2:n=g.sent(),t=n.data,g.label=3;case 3:if(t instanceof X)this.checkInputTensorShape(t),r=t,s=t.shape[0];else{if(t.length%this.elementsPerExample)throw new Error("The length of the input Float32Array "+t.length+" is not divisible by the number of tensor elements per per example expected by the model "+this.elementsPerExample+".");s=t.length/this.elementsPerExample,r=function(t,e,n){if(l(t),null!=e&&4!==e.length)throw new Error("tensor4d() requires shape to have four numbers");const s=gt(t,n);if(4!==s.length&&1!==s.length)throw new Error("tensor4d() requires values to be number[][][][] or flat/TypedArray");if(1===s.length&&null==e)throw new Error("tensor4d() requires shape to be provided when `values` are a flat array");return xt(t,e,s,n)}(t,[s].concat(this.nonBatchInputShape))}return a={scores:null},e.includeEmbedding?[4,this.ensureModelWithEmbeddingOutputCreated()]:[3,5];case 4:return g.sent(),o=this.modelWithEmbeddingOutput.predict(r),i=o[0],a.embedding=o[1],[3,6];case 5:i=this.model.predict(r),g.label=6;case 6:return 1!==s?[3,8]:(u=a,[4,i.data()]);case 7:return u.scores=g.sent(),[3,10];case 8:return h=zr(i),c=h.map((function(t){return t.data()})),p=a,[4,Promise.all(c)];case 9:p.scores=g.sent(),ke(h),g.label=10;case 10:return e.includeSpectrogram?(d=a,f={},t instanceof X?[4,t.data()]:[3,12]):[3,14];case 11:return m=g.sent(),[3,13];case 12:m=t,g.label=13;case 13:d.spectrogram=(f.data=m,f.frameSize=this.nonBatchInputShape[1],f),g.label=14;case 14:return ke(i),[2,a]}}))}))},t.prototype.recognizeOnline=function(){return ai(this,void 0,void 0,(function(){var t=this;return oi(this,(function(e){return[2,new Promise((function(e,n){t.audioDataExtractor=new Gc({sampleRateHz:t.parameters.sampleRateHz,numFramesPerSpectrogram:t.nonBatchInputShape[0],columnTruncateLength:t.nonBatchInputShape[1],suppressionTimeMillis:0,spectrogramCallback:function(n){return ai(t,void 0,void 0,(function(){var t,s,r;return oi(this,(function(i){switch(i.label){case 0:return t=Kc(n),[4,this.audioDataExtractor.stop()];case 1:return i.sent(),s=e,r={},[4,t.data()];case 2:return s.apply(void 0,[(r.data=i.sent(),r.frameSize=this.nonBatchInputShape[1],r)]),t.dispose(),[2,!1]}}))}))},overlapFactor:0}),t.audioDataExtractor.start()}))]}))}))},t.prototype.createTransfer=function(t){if(null==this.model)throw new Error("Model has not been loaded yet. Load model by calling ensureModelLoaded(), recognizer(), or listen().");a(null!=t&&"string"==typeof t&&t.length>1,(function(){return"Expected the name for a transfer-learning recognized to be a non-empty string, but got "+JSON.stringify(t)})),a(null==this.transferRecognizers[t],(function(){return"There is already a transfer-learning model named '"+t+"'"}));var e=new sd(t,this.parameters,this.model);return this.transferRecognizers[t]=e,e},t.prototype.freezeModel=function(){var t,e;try{for(var n=li(this.model.layers),s=n.next();!s.done;s=n.next()){s.value.trainable=!1}}catch(e){t={error:e}}finally{try{s&&!s.done&&(e=n.return)&&e.call(n)}finally{if(t)throw t.error}}},t.prototype.checkInputTensorShape=function(t){var e=this.model.inputs[0].shape.length;if(t.shape.length!==e)throw new Error("Expected input Tensor to have rank "+e+", but got rank "+t.shape.length+" that differs ");var n=t.shape.slice(1),s=this.model.inputs[0].shape.slice(1);if(!c(n,s))throw new Error("Expected input to have shape [null,"+s+"], but got shape [null,"+n+"]")},t.VALID_VOCABULARY_NAMES=["18w","directional4w"],t.DEFAULT_VOCABULARY_NAME="18w",t}(),sd=function(t){function e(e,n,s){var r=t.call(this)||this;return r.name=e,r.parameters=n,r.baseModel=s,a(null!=e&&"string"==typeof e&&e.length>0,(function(){return"The name of a transfer model must be a non-empty string, but got "+JSON.stringify(e)})),r.nonBatchInputShape=r.baseModel.inputs[0].shape.slice(1),r.words=null,r.dataset=new Hp,r}return function(t,e){function n(){this.constructor=t}ri(t,e),t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)}(e,t),e.prototype.collectExample=function(t,e){return ai(this,void 0,void 0,(function(){var n,s,r,i,o=this;return oi(this,(function(l){if(a(!this.streaming,(function(){return"Cannot start collection of transfer-learning example because a streaming recognition or transfer-learning example collection is ongoing"})),a(null!=t&&"string"==typeof t&&t.length>0,(function(){return"Must provide a non-empty string when collecting transfer-learning example"})),null==e&&(e={}),null!=e.durationMultiplier&&null!=e.durationSec)throw new Error("durationMultiplier and durationSec are mutually exclusive, but are both specified.");return null!=e.durationSec?(a(e.durationSec>0,(function(){return"Expected durationSec to be > 0, but got "+e.durationSec})),s=this.parameters.fftSize/this.parameters.sampleRateHz,n=Math.ceil(e.durationSec/s)):null!=e.durationMultiplier?(a(e.durationMultiplier>=1,(function(){return"Expected duration multiplier to be >= 1, but got "+e.durationMultiplier})),n=Math.round(this.nonBatchInputShape[0]*e.durationMultiplier)):n=this.nonBatchInputShape[0],null!=e.snippetDurationSec&&(a(e.snippetDurationSec>0,(function(){return"snippetDurationSec is expected to be > 0, but got "+e.snippetDurationSec})),a(null!=e.onSnippet,(function(){return"onSnippet must be provided if snippetDurationSec is provided."}))),null!=e.onSnippet&&a(null!=e.snippetDurationSec,(function(){return"snippetDurationSec must be provided if onSnippet is provided."})),r=this.parameters.fftSize/this.parameters.sampleRateHz,i=r*n,this.streaming=!0,[2,new Promise((function(s){var r=null==e.snippetDurationSec?1:e.snippetDurationSec/i,a=1-r,l=Math.round(1/r),u=0,h=-1,c=[];o.audioDataExtractor=new Gc({sampleRateHz:o.parameters.sampleRateHz,numFramesPerSpectrogram:n,columnTruncateLength:o.nonBatchInputShape[1],suppressionTimeMillis:0,spectrogramCallback:function(n,r){return ai(o,void 0,void 0,(function(){var i,a,o,p,d,f,m,g,y,b,w,v,k,x,S,I,N,A,E,T;return oi(this,(function(D){switch(D.label){case 0:return null!=e.onSnippet?[3,7]:(i=Kc(n),o=(a=this.dataset).addExample,p={label:t},d={},[4,i.data()]);case 1:return p.spectrogram=(d.data=D.sent(),d.frameSize=this.nonBatchInputShape[1],d),e.includeRawAudio?(m={},[4,r.data()]):[3,3];case 2:return m.data=D.sent(),m.sampleRateHz=this.audioDataExtractor.sampleRateHz,f=m,[3,4];case 3:f=void 0,D.label=4;case 4:return o.apply(a,[(p.rawAudio=f,p)]),i.dispose(),[4,this.audioDataExtractor.stop()];case 5:return D.sent(),this.streaming=!1,this.collateTransferWords(),g=s,y={},[4,n.data()];case 6:return g.apply(void 0,[(y.data=D.sent(),y.frameSize=this.nonBatchInputShape[1],y)]),[3,13];case 7:return[4,n.data()];case 8:for(b=D.sent(),-1===h&&(h=b.length),w=h-1;0!==b[w]&&w>=0;)w--;return v=h-w-1,h=w+1,k=b.slice(b.length-v,b.length),c.push(k),null!=e.onSnippet&&e.onSnippet({data:k,frameSize:this.nonBatchInputShape[1]}),u++!==l?[3,13]:[4,this.audioDataExtractor.stop()];case 9:return D.sent(),this.streaming=!1,this.collateTransferWords(),x=Vc(qp(c)),S={data:x,frameSize:this.nonBatchInputShape[1]},N=(I=this.dataset).addExample,A={label:t,spectrogram:S},e.includeRawAudio?(T={},[4,r.data()]):[3,11];case 10:return T.data=D.sent(),T.sampleRateHz=this.audioDataExtractor.sampleRateHz,E=T,[3,12];case 11:E=void 0,D.label=12;case 12:N.apply(I,[(A.rawAudio=E,A)]),s(S),D.label=13;case 13:return[2,!1]}}))}))},overlapFactor:a,includeRawAudio:e.includeRawAudio}),o.audioDataExtractor.start(e.audioTrackConstraints)}))]}))}))},e.prototype.clearExamples=function(){var t=this;a(null!=this.words&&this.words.length>0&&!this.dataset.empty(),(function(){return"No transfer learning examples exist for model name "+t.name})),this.dataset.clear(),this.words=null},e.prototype.countExamples=function(){if(this.dataset.empty())throw new Error("No examples have been collected for transfer-learning model named '"+this.name+"' yet.");return this.dataset.getExampleCounts()},e.prototype.getExamples=function(t){return this.dataset.getExamples(t)},e.prototype.setExampleKeyFrameIndex=function(t,e){this.dataset.setExampleKeyFrameIndex(t,e)},e.prototype.removeExample=function(t){this.dataset.removeExample(t),this.collateTransferWords()},e.prototype.isDatasetEmpty=function(){return this.dataset.empty()},e.prototype.loadExamples=function(t,e){var n,s,r,i;void 0===e&&(e=!1);var a=new Hp(t);e&&this.clearExamples();var o=a.getVocabulary();try{for(var l=li(o),u=l.next();!u.done;u=l.next()){var h=u.value,c=a.getExamples(h);try{for(var p=(r=void 0,li(c)),d=p.next();!d.done;d=p.next()){var f=d.value;this.dataset.addExample(f.example)}}catch(t){r={error:t}}finally{try{d&&!d.done&&(i=p.return)&&i.call(p)}finally{if(r)throw r.error}}}}catch(t){n={error:t}}finally{try{u&&!u.done&&(s=l.return)&&s.call(l)}finally{if(n)throw n.error}}this.collateTransferWords()},e.prototype.serializeExamples=function(t){return this.dataset.serialize(t)},e.prototype.collateTransferWords=function(){this.words=this.dataset.getVocabulary()},e.prototype.collectTransferDataAsTensors=function(t,e){var n=this.nonBatchInputShape[0];t=t||.25;var s=Math.round(t*n),r=this.dataset.getData(null,ii({numFrames:n,hopFrames:s},e));return{xs:r.xs,ys:r.ys}},e.prototype.collectTransferDataAsTfDataset=function(t,e,n,s){void 0===e&&(e=.15),void 0===n&&(n=32);var r=this.nonBatchInputShape[0];t=t||.25;var i=Math.round(t*r);return this.dataset.getData(null,ii({numFrames:r,hopFrames:i,getDataset:!0,datasetBatchSize:n,datasetValidationSplit:e},s))},e.prototype.train=function(t){return ai(this,void 0,void 0,(function(){var e,n=this;return oi(this,(function(s){return a(null!=this.words&&this.words.length>0,(function(){return"Cannot train transfer-learning model '"+n.name+"' because no transfer learning example has been collected."})),a(this.words.length>1,(function(){return"Cannot train transfer-learning model '"+n.name+"' because only 1 word label ('"+JSON.stringify(n.words)+"') has been collected for transfer learning. Requires at least 2."})),null!=t.fineTuningEpochs&&a(t.fineTuningEpochs>=0&&Number.isInteger(t.fineTuningEpochs),(function(){return"If specified, fineTuningEpochs must be a non-negative integer, but received "+t.fineTuningEpochs})),null==t&&(t={}),null==this.model&&this.createTransferModelFromBaseModel(),this.secondLastBaseDenseLayer.trainable=!1,this.model.compile({loss:"categoricalCrossentropy",optimizer:t.optimizer||"sgd",metrics:["acc"]}),e=null==t.fitDatasetDurationMillisThreshold?6e4:t.fitDatasetDurationMillisThreshold,this.dataset.durationMillis()>e?(console.log("Detected large dataset: total duration = "+this.dataset.durationMillis()+" ms > "+e+" ms. Training transfer model using fitDataset() instead of fit()"),[2,this.trainOnDataset(t)]):[2,this.trainOnTensors(t)]}))}))},e.prototype.trainOnDataset=function(t){return ai(this,void 0,void 0,(function(){var e,n,s,r,i,o,l,u,h;return oi(this,(function(c){switch(c.label){case 0:return a(t.epochs>0,(function(){return"Invalid config.epochs"})),e=null==t.batchSize?32:t.batchSize,n=t.windowHopRatio||.25,s=ui(this.collectTransferDataAsTfDataset(n,t.validationSplit,e,{augmentByMixingNoiseRatio:t.augmentByMixingNoiseRatio}),2),r=s[0],i=s[1],o=B(),[4,this.model.fitDataset(r,{epochs:t.epochs,validationData:t.validationSplit>0?i:null,callbacks:null==t.callback?null:[t.callback]})];case 1:return l=c.sent(),console.log("fitDataset() took "+(B()-o).toFixed(2)+" ms"),null!=t.fineTuningEpochs&&t.fineTuningEpochs>0?(u=B(),[4,this.fineTuningUsingTfDatasets(t,r,i)]):[3,3];case 2:return h=c.sent(),console.log("fitDataset() (fine-tuning) took "+(B()-u).toFixed(2)+" ms"),[2,[l,h]];case 3:return[2,l]}}))}))},e.prototype.trainOnTensors=function(t){return ai(this,void 0,void 0,(function(){var e,n,s,r,o,l,u,h,c,p;return oi(this,(function(d){switch(d.label){case 0:e=t.windowHopRatio||.25,n=this.collectTransferDataAsTensors(e,{augmentByMixingNoiseRatio:t.augmentByMixingNoiseRatio}),s=n.xs,r=n.ys,console.log("Training data: xs.shape = "+s.shape+", ys.shape = "+r.shape),d.label=1;case 1:return d.trys.push([1,,6,7]),null!=t.validationSplit?(h=function(t,e,n){return a(n>0&&n<1,(function(){return"validationSplit is expected to be >0 and <1, but got "+n})),ve((function(){for(var s=Re(e,-1).dataSync(),r=[],a=0;a<s.length;++a){var o=s[a];null==r[o]&&(r[o]=[]),r[o].push(a)}var l=r.length,u=[],h=[];r.map((function(t){return i(t)}));for(a=0;a<l;++a)for(var c=r[a],p=Math.round(c.length*(1-n)),d=0;d<c.length;++d)d<p?u.push(c[d]):h.push(c[d]);return{trainXs:Pn(t,u),trainYs:Pn(e,u),valXs:Pn(t,h),valYs:Pn(e,h)}}))}(s,r,t.validationSplit),o=h.trainXs,l=h.trainYs,u=[h.valXs,h.valYs]):(o=s,l=r),[4,this.model.fit(o,l,{epochs:null==t.epochs?20:t.epochs,validationData:u,batchSize:t.batchSize,callbacks:null==t.callback?null:[t.callback]})];case 2:return c=d.sent(),null!=t.fineTuningEpochs&&t.fineTuningEpochs>0?[4,this.fineTuningUsingTensors(t,o,l,u)]:[3,4];case 3:return p=d.sent(),[2,[c,p]];case 4:return[2,c];case 5:return[3,7];case 6:return ke([s,r,o,l,u]),[7];case 7:return[2]}}))}))},e.prototype.fineTuningUsingTfDatasets=function(t,e,n){return ai(this,void 0,void 0,(function(){var s,r,i;return oi(this,(function(a){switch(a.label){case 0:return s=this.secondLastBaseDenseLayer.trainable,this.secondLastBaseDenseLayer.trainable=!0,r=null==t.fineTuningOptimizer?"sgd":t.fineTuningOptimizer,this.model.compile({loss:"categoricalCrossentropy",optimizer:r,metrics:["acc"]}),[4,this.model.fitDataset(e,{epochs:t.fineTuningEpochs,validationData:n,callbacks:null==t.callback?null:[t.callback]})];case 1:return i=a.sent(),this.secondLastBaseDenseLayer.trainable=s,[2,i]}}))}))},e.prototype.fineTuningUsingTensors=function(t,e,n,s){return ai(this,void 0,void 0,(function(){var r,i,a;return oi(this,(function(o){switch(o.label){case 0:return r=this.secondLastBaseDenseLayer.trainable,this.secondLastBaseDenseLayer.trainable=!0,i=null==t.fineTuningOptimizer?"sgd":t.fineTuningOptimizer,this.model.compile({loss:"categoricalCrossentropy",optimizer:i,metrics:["acc"]}),[4,this.model.fit(e,n,{epochs:t.fineTuningEpochs,validationData:s,batchSize:t.batchSize,callbacks:null==t.fineTuningCallback?null:[t.fineTuningCallback]})];case 1:return a=o.sent(),this.secondLastBaseDenseLayer.trainable=r,[2,a]}}))}))},e.prototype.evaluate=function(t){return ai(this,void 0,void 0,(function(){var e=this;return oi(this,(function(n){return a(null!=t.wordProbThresholds&&t.wordProbThresholds.length>0,(function(){return"Received null or empty wordProbThresholds"})),0,a("_background_noise_"===this.words[0],(function(){return"Cannot perform evaluation when the first tag is not _background_noise_"})),[2,ve((function(){for(var n=[],s=0,r=e.collectTransferDataAsTensors(t.windowHopRatio),i=r.xs,a=r.ys.argMax(-1).dataSync(),o=e.model.predict(i),l=ss(Xe(o,[0,1],[o.shape[0],o.shape[1]-1]),-1),u=o.shape[0],h=0;h<t.wordProbThresholds.length;++h){for(var c=t.wordProbThresholds[h],p=l.greater(er(c)).dataSync(),d=0,f=0,m=0,g=0,y=0;y<u;++y)0===a[y]?(d++,p[y]&&m++):(f++,p[y]&&g++);var b=m/d,w=g/f;n.push({probThreshold:c,fpr:b,tpr:w}),console.log("ROC thresh="+c+": fpr="+b.toFixed(4)+", tpr="+w.toFixed(4)),h>0&&(s+=Math.abs(n[h-1].fpr-n[h].fpr)*(n[h-1].tpr+n[h].tpr)/2)}return{rocCurve:n,auc:s}}))]}))}))},e.prototype.createTransferModelFromBaseModel=function(){var t=this;a(null!=this.words,(function(){return"No word example is available for tranfer-learning model of name "+t.name}));for(var e=this.baseModel.layers,n=e.length-2;n>=0&&"dense"!==e[n].getClassName().toLowerCase();)n--;if(n<0)throw new Error("Cannot find a hidden dense layer in the base model.");this.secondLastBaseDenseLayer=e[n];var s,r,i=this.secondLastBaseDenseLayer.output;this.transferHead=new Bu(s),this.transferHead.add((r={units:this.words.length,activation:"softmax",inputShape:i.shape.slice(1),name:"NewHeadDense"},new Yh(r)));var o=this.transferHead.apply(i);this.model=Pu({inputs:this.baseModel.inputs,outputs:o})},e.prototype.modelInputShape=function(){return this.baseModel.inputs[0].shape},e.prototype.getMetadata=function(){return{tfjsSpeechCommandsVersion:"0.5.1",modelName:this.name,timeStamp:(new Date).toISOString(),wordLabels:this.wordLabels()}},e.prototype.save=function(t){return ai(this,void 0,void 0,(function(){var e,n,s;return oi(this,(function(r){return e=null!=t,t=t||rd(this.name),e||(n=ed.localStorage.getItem(Qp),(s=null==n?{}:JSON.parse(n))[this.name]=this.getMetadata(),ed.localStorage.setItem(Qp,JSON.stringify(s))),console.log("Saving model to "+t),[2,this.model.save(t)]}))}))},e.prototype.load=function(t){return ai(this,void 0,void 0,(function(){var e,n,s;return oi(this,(function(r){switch(r.label){case 0:if(e=null!=t,t=t||rd(this.name),!e){if(null==(n=JSON.parse(ed.localStorage.getItem(Qp)))||null==n[this.name])throw new Error("Cannot find metadata for transfer model named "+this.name+'"');this.words=n[this.name].wordLabels,console.log("Loaded word list for model named "+this.name+": "+this.words)}return s=this,[4,Uu(t)];case 1:return s.model=r.sent(),console.log("Loaded model from "+t+":"),this.model.summary(),[2]}}))}))},e.prototype.createTransfer=function(t){throw new Error("Creating transfer-learned recognizer from a transfer-learned recognizer is not supported.")},e}(nd);function rd(t){return""+td+t}var id={concatenateFloat32Arrays:qp,normalizeFloat32Array:Vc,normalize:Kc,playRawAudio:function(t,e){var n=new(window.AudioContext||window.webkitAudioContext),s=n.createBuffer(1,t.data.length,t.sampleRateHz);s.getChannelData(0).set(t.data);var r=n.createBufferSource();r.buffer=s,r.connect(n.destination),r.start(),r.onended=function(){null!=e&&e()}}};t.BACKGROUND_NOISE_TAG="_background_noise_",t.Dataset=Hp,t.UNKNOWN_TAG="_unknown_",t.create=function(t,e,n,s){if(a(null==n&&null==s||null!=n&&null!=s,(function(){return"customModelURL and customMetadataURL must be both provided or both not provided."})),null!=n&&a(null==e,(function(){return"vocabulary name must be null or undefined when modelURL is provided."})),"BROWSER_FFT"===t)return new nd(e,n,s);throw"SOFT_FFT"===t?new Error("SOFT_FFT SpeechCommandRecognizer has not been implemented yet."):new Error("Invalid fftType: '"+t+"'")},t.deleteSavedTransferModel=function(t){return ai(this,void 0,void 0,(function(){var e;return oi(this,(function(n){switch(n.label){case 0:return null==(e=JSON.parse(ed.localStorage.getItem(Qp)))&&(e={}),null!=e[t]&&delete e[t],ed.localStorage.setItem(Qp,JSON.stringify(e)),[4,Xt(rd(t))];case 1:return n.sent(),[2]}}))}))},t.getMaxIntensityFrameIndex=Yp,t.listSavedTransferModels=function(){return ai(this,void 0,void 0,(function(){var t,e,n;return oi(this,(function(s){switch(s.label){case 0:return[4,Zt()];case 1:for(n in t=s.sent(),e=[],t)n.startsWith(td)&&e.push(n.slice(td.length));return[2,e]}}))}))},t.spectrogram2IntensityCurve=Xp,t.utils=id,t.version="0.5.1",Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=speech-commands.min.js.map
